<?php
/*
**** COPYRIGHT & LICENSE NOTICE *** DO NOT REMOVE ****
* 
* WaWision (c) embedded projects GmbH, Holzbachstrasse 4, D-86154 Augsburg, * Germany 2015 
*
* This file is licensed under the Embedded Projects General Public License *Version 3.1. 
*
* You should have received a copy of this license from your vendor and/or *along with this file; If not, please visit www.wawision.de/Lizenzhinweis 
* to obtain the text of the corresponding license version.  
*
**** END OF COPYRIGHT & LICENSE NOTICE *** DO NOT REMOVE ****
*/
?>
<?php
include_once "class.superfpdf.php";

class Briefpapier extends SuperFPDF {
  public $doctype;
  public $doctypeOrig;

  public $logofile;
  public $sender;
  public $recipient;
  public $corrDetails;
  public $boldCorrDetails;
  public $textDetails;
  public $items;

  public $ust_befreit;

  public $barcode;
  public $firmendatenid;
  public $absender;
  public $knickfalz;
  public $projekt;

  public $id;
  public $table;


  /***********************************
   *     data aggregation functions
   ***********************************/  
  function __construct(&$app,$projekt="") {

    //$orientation='P';$unit='mm';$format='A4';
    //parent::PDF_EPS($orientation,$unit,$format);
    $this->projekt = $projekt;

    $this->app=&$app;
    $this->absender = "";
    $this->firmendatenid = $this->app->DB->Select("SELECT MAX(id) FROM firmendaten LIMIT 1");


    $viernachkommastellen_belege = $this->app->erp->Firmendaten("viernachkommastellen_belege");
    if($viernachkommastellen_belege=="1")
    { 
      $this->anzahlkomma=4;
    } else {
      $this->anzahlkomma=2;
    }

    if($this->app->erp->Firmendaten("kleinunternehmer")=="1")
      $this->ust_befreit=1;

    $hintergrund = $this->app->erp->Firmendaten("hintergrund");


    if($this->app->erp->BriefpapierHintergrunddisable)
    {
    } 
    else if($hintergrund=="logo")
    {
      $logo = $this->app->DB->Select("SELECT logo FROM firmendaten WHERE id='".$this->firmendatenid."' LIMIT 1"); 
      $filename = $this->app->erp->GetTMP().'/'.$this->app->Conf->WFdbname.'_logo.jpg';
      if ($handle = fopen($filename, "w")) {
        fwrite($handle, base64_decode($logo));
        fclose($handle);
      }
      $this->logofile = $this->app->erp->GetTMP()."/".$this->app->Conf->WFdbname."_logo.jpg";
      $this->briefpapier="";
    }
    else if($hintergrund=="briefpapier")
    {
      $briefpapier = $this->app->DB->Select("SELECT briefpapier FROM firmendaten WHERE id='".$this->firmendatenid."' LIMIT 1"); 
      $filename = $this->app->erp->GetTMP().'/'.$this->app->Conf->WFdbname.'_briefpapier.pdf';
      if ($handle = fopen($filename, "w")) {
        fwrite($handle, base64_decode($briefpapier));
        fclose($handle);
      }

      $this->briefpapier=$this->app->erp->GetTMP()."/".$this->app->Conf->WFdbname."_briefpapier.pdf";
      $this->logofile = ""; 

      $briefpapier2vorhanden = $this->app->erp->Firmendaten('briefpapier2vorhanden');
      $this->briefpapier2vorhanden = $briefpapier2vorhanden;
      if($briefpapier2vorhanden > 0)
      {
        $briefpapier2 = $this->app->DB->Select("SELECT briefpapier2 FROM firmendaten WHERE id='".$this->firmendatenid."' LIMIT 1"); 
        $filename = $this->app->erp->GetTMP().'/'.$this->app->Conf->WFdbname.'_briefpapier2.pdf';
        if ($handle = fopen($filename, "w")) {
          fwrite($handle, base64_decode($briefpapier2));
          fclose($handle);
        }

        $this->briefpapier2=$this->app->erp->GetTMP()."/".$this->app->Conf->WFdbname."_briefpapier2.pdf";
      }
    }
    else {
      $this->logofile = ""; 
      $this->briefpapier="";
    }  

    if($this->app->Conf->WFtestmode==true)
    {
      $this->briefpapier="./lib/dokumente/briefpapier_testmodus.pdf";
      $this->briefpapier2="./lib/dokumente/briefpapier_testmodus.pdf";
    }

    $this->knickfalz = $this->app->erp->Firmendaten('knickfalz');
    $this->abseite2y = $this->app->erp->Firmendaten('abseite2y');

    $footersichtbar = $this->app->erp->Firmendaten('footersichtbar');
    if($footersichtbar==1) $this->nichtsichtbar_footer = false; else $this->nichtsichtbar_footer = true;

    $seite_von_sichtbar = $this->app->erp->Firmendaten('seite_von_sichtbar');
    if($seite_von_sichtbar==1) $this->seite_von_sichtbar = false; else $this->seite_von_sichtbar = true;

    $this->seite_von_ausrichtung = $this->app->erp->Firmendaten('seite_von_ausrichtung');


    $this->abstand_adresszeileoben = $this->app->erp->Firmendaten('abstand_adresszeileoben');
    $this->abstand_boxrechtsoben = $this->app->erp->Firmendaten('abstand_boxrechtsoben');
    $this->abstand_boxrechtsoben_lr = $this->app->erp->Firmendaten('abstand_boxrechtsoben_lr');
    $this->abstand_betreffzeileoben = $this->app->erp->Firmendaten('abstand_betreffzeileoben');
    $this->abstand_artikeltabelleoben = $this->app->erp->Firmendaten('abstand_artikeltabelleoben');

    $this->boxausrichtung = $this->app->erp->Firmendaten('boxausrichtung');

    $sichtbar = $this->app->erp->Firmendaten('sichtbar');
    if($sichtbar==1) $this->nichtsichtbar_zeileabsender = false; else $this->nichtsichtbar_zeileabsender =true;


    $this->barcode_sichtbar = $this->app->erp->Firmendaten('barcode');
    $this->barcode_x = $this->app->erp->Firmendaten('barcode_x');
    $this->barcode_y = $this->app->erp->Firmendaten('barcode_y');
    $this->barcode_x_header = $this->app->erp->Firmendaten('barcode_x_header');
    $this->barcode_y_header = $this->app->erp->Firmendaten('barcode_y_header');

    $projekt = $this->projekt; 


    $this->waehrung=$this->app->erp->Firmendaten('waehrung');



    // kann man herausfinden was fuer ein projekt angegeben ist???
    $speziallieferschein = $this->app->DB->Select("SELECT speziallieferschein FROM projekt WHERE id='$projekt' LIMIT 1");
    $speziallieferscheinbeschriftung = $this->app->DB->Select("SELECT speziallieferscheinbeschriftung FROM projekt WHERE id='$projekt' LIMIT 1");
    $eigenesteuer = $this->app->DB->Select("SELECT eigenesteuer FROM projekt WHERE id='$projekt' LIMIT 1");
    if($eigenesteuer=="1")
      $this->waehrung=$this->app->DB->Select("SELECT waehrung FROM projekt WHERE id='$projekt' LIMIT 1");
    if($speziallieferschein>0)
    {
      $seite1 = $this->app->DB->Select("SELECT datei FROM datei_stichwoerter WHERE subjekt='Briefpapier1' AND objekt='Projekt' AND parameter='$projekt' LIMIT 1");	
      $seite2 = $this->app->DB->Select("SELECT datei FROM datei_stichwoerter WHERE subjekt='Briefpapier2' AND objekt='Projekt' AND parameter='$projekt' LIMIT 1");	


      $this->briefpapier=$this->app->erp->GetDateiPfad($seite1);
      $this->briefpapier2=$this->app->erp->GetDateiPfad($seite2);

      if($seite2>0)
        $this->briefpapier2vorhanden = 1;

      $this->logofile = "";

      if($speziallieferscheinbeschriftung!=1){
        $this->nichtsichtbar_zeileabsender = true;
        $this->nichtsichtbar_footer = true;
        $this->nichtsichtbar_rechtsoben = true;
      }
    }    

    $this->nichtsichtbar_rechtsoben = true;
    $this->nichtsichtbar_summe = false;
    $this->nichtsichtbar_box=false;
    $this->nichtsichtbar_empfaenger=false;

  }

  function GetChargeMHDSNString($type,$doctype,$doctypeid,$posid)
  {
    if($type == 'sn' && ($doctype == 'lieferschein' || $doctype == 'rechnung' || $doctype == 'gutschrift'))
    {
      if($doctype == 'lieferschein')$lieferschein_posid = $posid;
      if($doctype == 'rechnung')$auftrag_position_id = $this->app->DB->Select("SELECT auftrag_position_id FROM rechnung_position WHERE id='$posid'");
      if($doctype == 'gutschrift')$auftrag_position_id = $this->app->DB->Select("SELECT gutschrift_position_id FROM rechnung_position WHERE id='$posid'");
      if(!empty($auftrag_position_id))$lieferschein_posid = $this->app->DB->Select("SELECT id FROM lieferschein_position WHERE auftrag_position_id='$auftrag_position_id' LIMIT 1");
      if($tmp)
      {
        for($i=0;$i<count($tmp);$i++)
        {
          $tmp_string[]=$tmp[$i]['seriennummer'];
        }
      }
      
    }
    
    $tmp = $this->app->DB->SelectArr("SELECT SUM(menge) as menge,wert FROM beleg_chargesnmhd WHERE type='$type' AND doctype='$doctype' AND doctypeid='$doctypeid' AND pos='$posid' GROUP by wert");
    for($i=0;$i<count($tmp);$i++)
    {
      if($type=="mhd" && $tmp[$i]['wert']!="") $tmp[$i]['wert'] = date('d.m.Y',strtotime($tmp[$i]['wert']));
      if($tmp[$i]['menge'] > 1) $tmp[$i]['menge']  = " (".floatval($tmp[$i]['menge']).")"; else $tmp[$i]['menge']="";
      $tmp_string[]=$tmp[$i]['wert'].$tmp[$i]['menge'];
    }

    if(count($tmp_string)<=0 && $doctype=="rechnung")
    {
      $auftrag_position_id = $this->app->DB->Select("SELECT auftrag_position_id FROM rechnung_position WHERE id='$posid'");
      $lieferschein_posid = $this->app->DB->Select("SELECT id FROM lieferschein_position WHERE auftrag_position_id='$auftrag_position_id' LIMIT 1");
      $tmp = $this->app->DB->SelectArr("SELECT SUM(menge) as menge,wert FROM beleg_chargesnmhd WHERE type='$type' AND doctype='lieferschein' AND pos='$lieferschein_posid' AND pos <> '0' GROUP by wert");
      for($i=0;$i<count($tmp);$i++)
      {
        if($type=="mhd" && $tmp[$i]['wert']!="") $tmp[$i]['wert'] = date('d.m.Y',strtotime($tmp[$i]['wert']));
        if($tmp[$i]['menge'] > 1) $tmp[$i]['menge']  = " (".floatval($tmp[$i]['menge']).")"; else $tmp[$i]['menge']="";
        $tmp_string[]=$tmp[$i]['wert'].$tmp[$i]['menge'];
      }  
    }

    /* oft gibt man nur einen Teil zurueck und primaer geht es darum damit man weiss was der Kunde hat daher eher nicht GS
    if(count($tmp_string)<=0 && $doctype=="gutschrift")
    {
      $auftrag_position_id = $this->app->DB->Select("SELECT auftrag_position_id FROM gutschrift_position WHERE id='$posid'");
      $lieferschein_posid = $this->app->DB->Select("SELECT id FROM lieferschein_position WHERE auftrag_position_id='$auftrag_position_id' LIMIT 1");
      $tmp = $this->app->DB->SelectArr("SELECT SUM(menge) as menge,wert FROM beleg_chargesnmhd WHERE type='$type' AND doctype='lieferschein' AND pos='$lieferschein_posid' GROUP by wert");
      for($i=0;$i<count($tmp);$i++)
      {
        if($type=="mhd" && $tmp[$i]['wert']!="") $tmp[$i]['wert'] = date('d.m.Y',strtotime($tmp[$i]['wert']));
        if($tmp[$i]['menge'] > 1) $tmp[$i]['menge']  = " (".floatval($tmp[$i]['menge']).")"; else $tmp[$i]['menge']="";
        $tmp_string[]=$tmp[$i]['wert'].$tmp[$i]['menge'];
      }  
    }*/

    if(isset($tmp_string))return implode(", ",$tmp_string);
    return "";
  }

  function CheckPosition($value,$doctype,$doctypeid,$posid)
  {
    // ean
    if($this->app->erp->Firmendaten("beleg_pos_ean")=="1")
    {
      $tmpvalue['ean'] = $this->app->DB->Select("SELECT ean FROM artikel WHERE id='".$value['artikel']."' LIMIT 1"); 
      if($tmpvalue['ean']!="") $tmpvalue['ean'] = $this->app->erp->Beschriftung("dokument_ean").": ".$tmpvalue['ean'];
    }

    // zolltarif
    if($this->app->erp->Firmendaten("beleg_pos_zolltarifnummer")=="1")
    {
      $value['zolltarifnummer'] = $this->app->DB->Select("SELECT zolltarifnummer FROM artikel WHERE id='".$value['artikel']."' LIMIT 1"); 
      $value['herkunftsland'] = $this->app->DB->Select("SELECT herkunftsland FROM artikel WHERE id='".$value['artikel']."' LIMIT 1"); 
    }

    // charge
    if($this->app->erp->Firmendaten("beleg_pos_charge")=="1")
    {
      $tmpvalue['charge']=$this->GetChargeMHDSNString("charge",$doctype,$doctypeid,$posid);
      if($tmpvalue['charge']!="") $tmpvalue['charge'] = $this->app->erp->Beschriftung("dokument_charge").": ".$tmpvalue['charge'];
    }


    // mhd
    if($this->app->erp->Firmendaten("beleg_pos_mhd")=="1")
    {
      $tmpvalue['mhd']=$this->GetChargeMHDSNString("mhd",$doctype,$doctypeid,$posid);
      if($tmpvalue['mhd']!="") $tmpvalue['mhd'] = $this->app->erp->Beschriftung("dokument_mhd").": ".$tmpvalue['mhd'];
    }

    // sn
    if($this->app->erp->Firmendaten("beleg_pos_sn")=="1")
    {
      $tmpvalue['sn']=$this->GetChargeMHDSNString("sn",$doctype,$doctypeid,$posid);
      if($tmpvalue['sn']!="") {
        $tmpvalue['sn'] = $this->app->erp->Beschriftung("dokument_seriennummer").": ".$tmpvalue['sn'];
        $value['seriennummer']="";
      }
    }

    if(isset($tmpvalue))
    {
      if($value['beschreibung']!="")
            $value['beschreibung']=$value['beschreibung']."\r\n".implode("\r\n",$tmpvalue);
      else
            $value['beschreibung']=implode("\r\n",$tmpvalue);
    }
    return $value;
  }




  public function addItem($rdata){
    // add rabatt
    if($rdata['price']!="-")
      $rdata['tprice'] = $rdata['amount']*($rdata['price']-($rdata['price']/100*$rdata['rabatt'])    );
    else $rdata['tprice']='-';
    $this->items[]=$rdata;
  }

  public function setSender($rdata){


    $this->sender['enterprise']   = $this->app->erp->ReadyForPDF($rdata[0]);
    $this->sender['firstname']     = $this->app->erp->ReadyForPDF($rdata[1]);
    $this->sender['familyname']   = $this->app->erp->ReadyForPDF($rdata[2]);
    $this->sender['address1']     = $this->app->erp->ReadyForPDF($rdata[3]);
    $this->sender['areacode']     = $this->app->erp->ReadyForPDF($rdata[4]);
    $this->sender['city']         = $this->app->erp->ReadyForPDF($rdata[5]);
    if(isset($rdata[6]))$this->sender['country'] = $this->app->erp->ReadyForPDF($rdata[6]);
  }

  function setRecipientRechnung($id)
  {


  }


  function setRecipientLieferadresse($id,$table)
  {
    $this->id = $id;
    $this->table = $table;

    $tmp = $this->app->DB->SelectArr("SELECT * FROM $table WHERE id='$id' LIMIT 1");

    $titelansprechpartner="";
    $titelname="";
    
    if($tmp[0]['ansprechpartner']!="" && $tmp[0]['titel']!="") $titelansprechpartner = $tmp[0]['titel']." "; 
    else if ($tmp[0]['titel']!="")  $titelname = $tmp[0]['titel']." ";

    if($tmp[0]['typ']!="person")
    {
      $this->recipient['enterprise'] = $this->app->erp->ReadyForPDF($titelname.$tmp[0]['name']);

      if($tmp[0]['abteilung']!="" && strlen($tmp[0]['abteilung']) >1)
        $this->recipient['address2']   =  $this->app->erp->ReadyForPDF($tmp[0]['abteilung']);

      if($tmp[0]['ansprechpartner']!="" && strlen($tmp[0][ansprechpartner])>1)
        $this->recipient['firstname']   = $this->app->erp->ReadyForPDF($titelansprechpartner.$tmp[0]['ansprechpartner']);

      if($this->app->erp->Firmendaten("rechnung_gutschrift_ansprechpartner")!="1" && ($table=="rechnung" || $table=="gutschrift"))
        $this->recipient['firstname']   = "";

      if($tmp[0]['unterabteilung']!="")
        $this->recipient['address3'] = $this->app->erp->ReadyForPDF($tmp[0]['unterabteilung']);

      if($tmp[0]['adresszusatz']!="")
        $this->recipient['address4'] = $this->app->erp->ReadyForPDF($tmp[0]['adresszusatz']);

    }

    else {
      $vorname = '';
      if(isset($tmp[0]['vorname']) && $tmp[0]['vorname']!='' && strlen(trim($tmp[0]['vorname']))>0)	
        $vorname = $tmp[0]['vorname']." ";	

      $this->recipient['enterprise'] = $this->app->erp->ReadyForPDF($vorname.$tmp[0]['name']);
      $this->recipient['address2']   = $this->app->erp->ReadyForPDF($tmp[0]['adresszusatz']);
    }


    $this->recipient['address1']     = $this->app->erp->ReadyForPDF($tmp[0]['strasse']);
    $this->recipient['areacode']     = $this->app->erp->ReadyForPDF($tmp[0]['plz']);
    $this->recipient['city']         = $this->app->erp->ReadyForPDF($tmp[0]['ort']);
    //if($this->recipient['city']!="")
    $this->recipient['country']      = $this->app->erp->ReadyForPDF($tmp[0]['land']);
  }


  function setRecipientDB($adresse)
  {
    $tmp = $this->app->DB->SelectArr("SELECT * FROM adresse WHERE id='$adresse' LIMIT 1");
    if($tmp[0]['typ']!="person")
    {
      $this->recipient['enterprise'] = $this->app->erp->ReadyForPDF($tmp[0]['name']);

      if($tmp[0]['abteilung']!="" && strlen($tmp[0]['abteilung'])>1)
        $this->recipient['address2']   = $this->app->erp->ReadyForPDF($tmp[0]['abteilung']);


      if($this->app->erp->Firmendaten("rechnung_gutschrift_ansprechpartner")=="1")
      {
        if($tmp[0]['ansprechpartner']!="")
          $this->recipient['firstname']   = $this->app->erp->ReadyForPDF($tmp[0]['ansprechpartner']);
      }

      if($tmp[0]['unterabteilung']!="")
        $this->recipient['address3'] = $this->app->erp->ReadyForPDF($tmp[0]['unterabteilung']);

      if($tmp[0]['adresszusatz']!="")
        $this->recipient['address4'] = $this->app->erp->ReadyForPDF($tmp[0]['adresszusatz']);

    }

    else {
      $this->recipient['enterprise'] = $this->app->erp->ReadyForPDF($tmp[0]['name']);
      $this->recipient['address2']   = $this->app->erp->ReadyForPDF($tmp[0]['adresszusatz']);
    }


    $this->recipient['address1']     = $this->app->erp->ReadyForPDF($tmp[0]['strasse']);
    $this->recipient['areacode']     = $this->app->erp->ReadyForPDF($tmp[0]['plz']);
    $this->recipient['city']         = $this->app->erp->ReadyForPDF($tmp[0]['ort']);
    //if($this->recipient['city']!="")
    $this->recipient['country']      = $this->app->erp->ReadyForPDF($tmp[0]['land']);
  }


  public function setRecipient($rdata){
    $this->recipient['enterprise']   = $this->app->erp->ReadyForPDF($rdata[0]);
    $this->recipient['firstname']   = $this->app->erp->ReadyForPDF($rdata[1]);
    $this->recipient['familyname']   = $this->app->erp->ReadyForPDF($rdata[2]);
    $this->recipient['address1']     = $this->app->erp->ReadyForPDF($rdata[3]);
    $this->recipient['areacode']     = $this->app->erp->ReadyForPDF($rdata[4]);
    $this->recipient['city']         = $this->app->erp->ReadyForPDF($rdata[5]);
    if(isset($rdata[3]))$this->recipient['country'] = $this->app->erp->ReadyForPDF($rdata[6]);
  }

  public function setCorrDetails($rdata){
    if($this->app->erp->Firmendaten("projektnummerimdokument")=="1")
      $rdata[$this->app->erp->Beschriftung("dokument_projekt")]=$this->app->DB->Select("SELECT abkuerzung FROM projekt WHERE id='".$this->projekt."' LIMIT 1");

    if($this->app->erp->Firmendaten("internetnummerimbeleg")=="1")
    {
      switch($this->doctype)
      {
        case "rechnung":
        case "lieferschein":
          $internetnummer = $this->app->DB->Select("SELECT a.internet FROM auftrag a LEFT JOIN ".$this->doctype." b ON b.auftragid=a.id WHERE b.id='".$this->doctypeid."' LIMIT 1");    
        break;
        case "gutschrift":
          $internetnummer = $this->app->DB->Select("SELECT a.internet FROM gutschrift g LEFT JOIN rechnung r ON r.id=g.rechnungid LEFT JOIN auftrag a ON a.id=r.auftragid WHERE g.id='".$this->doctypeid."' LIMIT 1");    
        break;
        case "auftrag":
          $internetnummer = $this->app->DB->Select("SELECT internet FROM auftrag WHERE id='".$this->doctypeid."' LIMIT 1");
        break;
        default:
          $internetnummer = "";

      }
      $rdata[$this->app->erp->Firmendaten("beschriftunginternetnummer")]=$internetnummer;
    } 
    if($this->doctype=="rechnung"||$this->doctype=="lieferschein"||$this->doctype=="gutschrift"||$this->doctype=="auftrag"||$this->doctype=="angebot"||$this->doctype=="lieferschein")
    {
        if($this->doctype=="lieferschein")$tabelle="lieferschein";else $tabelle=$this->doctype;
//      $bearbeiteremail = $this->app->DB->Select("SELECT b.email FROM ".$this->doctype." a LEFT JOIN adresse adr ON a.adresse=adr.id LEFT JOIN adresse b ON b.id=adr.innendienst WHERE a.id='".$this->doctypeid."' LIMIT 1");
 //     $bearbeitertelefon = $this->app->DB->Select("SELECT b.telefon FROM ".$this->doctype." a LEFT JOIN adresse adr ON a.adresse=adr.id LEFT JOIN adresse b ON b.id=adr.innendienst WHERE a.id='".$this->doctypeid."' LIMIT 1");

      $bearbeiteremail = $this->app->DB->Select("SELECT b.email FROM ".$tabelle." a  LEFT JOIN adresse b ON b.id=a.bearbeiterid WHERE a.id='".$this->doctypeid."' LIMIT 1");
      $bearbeitertelefon = $this->app->DB->Select("SELECT b.telefon FROM ".$tabelle." a  LEFT JOIN adresse b ON b.id=a.bearbeiterid WHERE a.id='".$this->doctypeid."' LIMIT 1");
    }

    if($this->app->erp->Firmendaten("bearbeiteremailimdokument")=="1")
      $rdata["E-Mail"]=$bearbeiteremail;
    if($this->app->erp->Firmendaten("bearbeitertelefonimdokument")=="1")
      $rdata["Telefon"]=$bearbeitertelefon;

    
    //$rdata[$this->app->erp->Firmendaten("beschriftungbearbeiteremail")]=$internetnummer;
    //$rdata[$this->app->erp->Firmendaten("beschriftungbearbeitertelefonnummer")]=$internetnummer;

    $this->corrDetails = $rdata;
  }
  public function setBoldCorrDetails($rdata){
    $this->boldCorrDetails = $rdata;
  }
  public function setTextDetails($rdata){
    $this->textDetails = $rdata;
  }


  public function setTotals($rdata){
    $this->totals   = $rdata;
  }

  // Briefpapier festlegen
  public function setStationery($stationeryfile) {
    $this->setSourceFile($stationeryfile);
    $tplidx = $this->ImportPage(1);
    $this->useTemplate($tplidx);    
  }
  /* 
     public function setLogo($logofile) {
     $this->logofile = "./lib/pdf/images/".$logofile;
     }
   */ 

  // label settings
  public function setBarcode($barcode) {
    if($this->barcode_sichtbar)
      $this->barcode = $barcode;
    else $this->barcode="";

  }  


  public function Header() {
    if($this->knickfalz!="1"){
      $this->Line(0,105,5,105);
      $this->Line(0,148,7,148);
      $this->Line(0,210,5,210);
    }
    if($this->logofile!="") 
      $this->Image($this->logofile,15,10,110);

    if($this->barcode!="" && $this->briefpapier==""){
      //$this->Rotate(90);
      $this->Code39($this->barcode_x, $this->barcode_y, $this->barcode, 1, 3);
      //$this->Rotate(0);
    }

    if($this->briefpapier!="" && $this->PageNo()<=1)
      $this->setStationery($this->briefpapier);

    // wenn 
    if($this->PageNo() > 1 && $this->briefpapier2!="" && $this->briefpapier2vorhanden=="1")
      $this->setStationery($this->briefpapier2);
    else if ( $this->PageNo() > 1 && $this->briefpapier!="")
      $this->setStationery($this->briefpapier);


    if($this->PageNo() > 1)
    {
      $this->SetY($this->abseite2y);                                                                                                 
    }
  }  

  public function Footer() {
    $differenz=12;
    $this->SetXY(12,$this->app->erp->Firmendaten("abstand_seiten_unten")*-1);
    $this->SetFont($this->GetFont(),'',8);


    if($this->seite_von_sichtbar!="1")	
    {
      if($this->app->erp->Firmendaten("seite_von_ausrichtung_relativ")=="1")// && $this->seite_von_ausrichtung=="C")
      {
        $this->SetX($this->app->erp->Firmendaten("abstand_seitenrandlinks"));
        $differenz = $this->app->erp->Firmendaten("abstand_seitenrandlinks");
      }

    $tmp = $this->rMargin;
    if($this->app->erp->Firmendaten("abstand_seitenrandrechts")>0)
      $this->rMargin=$this->app->erp->Firmendaten("abstand_seitenrandrechts");
    else
      $this->rMargin=$this->app->erp->Firmendaten("abstand_seitenrandlinks");
      
      $tmpc = $this->cMargin;
      if($this->seite_von_ausrichtung=="R")
        $this->cMargin=-3;

      if($this->app->erp->Firmendaten("seite_belegnr"))
        $this->Cell(0,8,$this->app->erp->Beschriftung("dokument_seite").' '.$this->PageNo().' '.$this->app->erp->Beschriftung("dokument_seitevon").' {nb} '.$this->zusatzfooter,0,0,$this->seite_von_ausrichtung);
      else
        $this->Cell(0,8,$this->app->erp->Beschriftung("dokument_seite").' '.$this->PageNo().' '.$this->app->erp->Beschriftung("dokument_seitevon").' {nb}',0,0,$this->seite_von_ausrichtung);
      
      $this->cMargin = $tmpc;

      $this->rMargin=$tmp;
    }

    if($this->nichtsichtbar_footer!=true)
    { 

      $footerarr = $this->app->DB->SelectArr("SELECT * FROM firmendaten WHERE id='".$this->firmendatenid."' LIMIT 1");
      $firmendaten_extra = $this->app->DB->SelectArr("SELECT * FROM firmendaten_werte");
      if($firmendaten_extra)
      {
        foreach($firmendaten_extra as $v)
        {
          if(!isset($footerarr[0][$v['name']]))$footerarr[0][$v['name']] = $v['wert'];
        }
      }
      $footerarr = $footerarr[0];

      foreach($footerarr as $key=>$value)
        $footerarr[$key] = utf8_decode($value);

      $this->SetXY(10,-26);
      $this->SetDrawColor($this->app->erp->Firmendaten("footer_farbe"));
      $this->SetTextColor($this->app->erp->Firmendaten("footer_farbe"));

      $this->SetFont($this->GetFont(),'',7);


      if($this->app->erp->Firmendaten("footer_zentriert")!=1)
      {
      $this->MultiCell($footerarr['footer_breite1'],3,utf8_encode("  ".$footerarr['footer_0_0']."\n  ".$footerarr['footer_0_1']."\n  ".$footerarr['footer_0_2']."\n  ".$footerarr['footer_0_3']."\n  ".$footerarr['footer_0_4']."\n  ".$footerarr['footer_0_5'].""),'','L');
      $this->SetXY($footerarr['footer_breite1'] + 10,-26); // Breite 1 + 10
      $this->MultiCell($footerarr['footer_breite2'],3,utf8_encode("  ".$footerarr['footer_1_0']."\n  ".$footerarr['footer_1_1']."\n  ".$footerarr['footer_1_2']."\n  ".$footerarr['footer_1_3']."\n  ".$footerarr['footer_1_4']."\n  ".$footerarr['footer_1_5'].""),'','L');
      $this->SetXY($footerarr['footer_breite1'] + $footerarr['footer_breite2'] + 10,-26); //breite 1 + breite 2 + 10
      $this->MultiCell($footerarr['footer_breite3'],3,utf8_encode("  ".$footerarr['footer_2_0']."\n  ".$footerarr['footer_2_1']."\n  ".$footerarr['footer_2_2']."\n  ".$footerarr['footer_2_3']."\n  ".$footerarr['footer_2_4']."\n  ".$footerarr['footer_2_5'].""),'','L');
      $this->SetXY($footerarr['footer_breite1'] + $footerarr['footer_breite2'] + $footerarr['footer_breite3'] + 10,-26); //breite 1 + breite 2 + breite 3 + 10
      $this->MultiCell($footerarr['footer_breite4'],3,utf8_encode("  ".$footerarr['footer_3_0']."\n  ".$footerarr['footer_3_1']."\n  ".$footerarr['footer_3_2']."\n  ".$footerarr['footer_3_3']."\n  ".$footerarr['footer_3_4']."\n  ".$footerarr['footer_3_5'].""),'','L');
      } else {
        $this->MultiCell(0,3,utf8_encode("  ".$footerarr['footer_0_0']."\n  ".$footerarr['footer_0_1']."\n  ".$footerarr['footer_0_2']."\n  ".$footerarr['footer_0_3']."\n  ".$footerarr['footer_0_4']."\n  ".$footerarr['footer_0_5'].""),'','C');


      }
    }
  }
  
  public function ArchiviereDocument($schreibschutz = false)
  {
    $dir = $this->app->Conf->WFuserdata."/pdfarchiv/".$this->app->Conf->WFdbname;
    if(!is_dir($dir)){
      if(!mkdir($dir, 0700,true))$this->app->erp->LogFile('Fehler beim erstellen von '.$dir);
      //				echo "fehlt";
    }
    if(!is_dir($dir))return false;
    if(!is_dir($dir."/".$this->table))
      if(!mkdir ($dir."/".$this->table,0700,true))$this->app->erp->LogFile('Fehler beim erstellen von '.$dir."/".$this->table);
    if(!is_dir($dir."/".$this->table))return;
    $md5alt = false;
    $altesdokument = $this->app->DB->SelectArr("SELECT * from pdfarchiv where table_id = '".$this->id."'  and table_name = '".$this->table."' AND doctype = '".$this->app->DB->real_escape_string($this->doctype)."' AND doctypeorig = '".$this->app->DB->real_escape_string($this->doctypeOrig)."' ORDER BY zeitstempel DESC LIMIT 1");
    if($altesdokument)
    {
      $altesdokument = reset($altesdokument);
      $md5alt = $altesdokument['checksum'];
      if(!is_file($dir."/".$this->table."/".$md5alt."_".$this->id."_".$this->filename))
      {
        if(file_exists($dir."/".$this->table."/".$this->id."_".$this->filename))
        {
          rename($dir."/".$this->table."/".$this->id."_".$this->filename,$dir."/".$this->table."/".$md5alt."_".$this->id."_".$this->filename);
          if(file_exists($dir."/".$this->table."/".$md5alt."_".$this->id."_".$this->filename))
          {
            $md5sum_tmp = md5_file($dir."/".$this->table."/".$md5alt."_".$this->id."_".$this->filename);
            if($md5sum_tmp !== $md5alt)
            {
              $this->app->DB->Update("UPDATE pdfarchiv set checksum = '$md5sum_tmp' WHERE id = '".$altesdokument['id']."'");
              $md5alt = $md5sum_tmp;
            }
          }
        }
      }
    }


    $this->Output($dir."/".$this->table."/".$this->id."_".$this->filename,'F');
    
    if($this->table)$this->app->DB->Update("UPDATE ".$this->table." SET zuarchivieren = 0 WHERE id = '".$this->id."'");
		// neue sicherung
		$md5sum_tmp = md5_file($dir."/".$this->table."/".$this->id."_".$this->filename);
    
    if($md5sum_tmp !== $md5alt || empty($altesdokument) || empty($altesdokument['dateiname']))
    {
      
      $belegnummer = str_ireplace('.pdf','', substr($this->filename,strrpos($this->filename,'_')+1));
      
      $this->app->DB->Insert("INSERT INTO pdfarchiv (zeitstempel, checksum, table_id, table_name, bearbeiter,erstesoriginal,doctype,doctypeorig,dateiname,belegnummer ) values (NOW(),'$md5sum_tmp','".$this->id."','".$this->table."','".$this->app->User->GetName()."',".($md5alt?0:0).",'".$this->app->DB->real_escape_string($this->doctype)."','".$this->app->DB->real_escape_string($this->doctypeOrig)."','".$this->app->DB->real_escape_string($md5sum_tmp."_".$this->id."_".$this->filename)."','".$this->app->DB->real_escape_string($belegnummer)."')");
      $newid = $this->app->DB->GetInsertID();
      if($schreibschutz || $this->app->DB->Select("SELECT schreibschutz FROM ".$this->table." WHERE id = '".$this->id."' LIMIT 1"))$this->app->DB->Update("UPDATE pdfarchiv SET schreibschutz = 1 WHERE id = '$newid' LIMIT 1");
      if(!file_exists($dir."/".$this->table."/".$md5sum_tmp."_".$this->id."_".$this->filename))
      {
        rename($dir."/".$this->table."/".$this->id."_".$this->filename, $dir."/".$this->table."/".$md5sum_tmp."_".$this->id."_".$this->filename);
      }
    }elseif($md5alt && isset($altesdokument['id']) && $altesdokument['id'])
    {
      if($schreibschutz || $this->app->DB->Select("SELECT schreibschutz FROM ".$this->table." WHERE id = '".$this->id."' LIMIT 1"))$this->app->DB->Update("UPDATE pdfarchiv SET schreibschutz = 1 WHERE id = '".$altesdokument['id']."' LIMIT 1");
    }
  }
  
  public function DocumentArchiviert()
  {
    $dir = $this->app->Conf->WFuserdata."/pdfarchiv/".$this->app->Conf->WFdbname;
    if(!is_dir($dir)){
      return false;
    }	
    if(!is_dir($dir."/".$this->table))
      return false;
    
    $md5alt = false;
    $altesdokument = $this->app->DB->SelectArr("SELECT * from pdfarchiv where table_id = '".$this->id."'  and table_name = '".$this->table."' AND doctype = '".$this->app->DB->real_escape_string($this->doctype)."' AND doctypeorig = '".$this->app->DB->real_escape_string($this->doctypeOrig)."' ORDER BY zeitstempel DESC LIMIT 1");
    if(!$altesdokument)return false;
    $altesdokument = reset($altesdokument);
    $md5alt = $altesdokument['checksum'];
    if(!file_exists($dir."/".$this->table."/".$md5alt."_".$this->id."_".$this->filename))return false;
    
    $this->Output($dir."/".$this->table."/TEMP_".$this->id."_".$this->filename,'F');
    $md5sum_tmp = md5_file($dir."/".$this->table."/TEMP_".$this->id."_".$this->filename);
    unlink($dir."/".$this->table."/TEMP_".$this->id."_".$this->filename);
    if($md5sum_tmp == $md5alt)return true;
    return false;
  }
  

  public function archiveDocument()
  {

    $dir = $this->app->Conf->WFuserdata."/pdfmirror/".$this->app->Conf->WFdbname;
    if(!is_dir($dir)){
      if(!mkdir($dir, 0700,true))$this->app->erp->LogFile('Fehler beim erstellen von '.$dir);
      //				echo "fehlt";
    }	
    if(!is_dir($dir."/".$this->table))
      mkdir ($dir."/".$this->table,0700,true);

		// alte sicherung
    $md5sum_tmp = '';
		if(file_exists($dir."/".$this->table."/".$this->id."_".$this->filename))
    {
      $md5sum_tmp = md5_file($dir."/".$this->table."/".$this->id."_".$this->filename);
      if(!is_file($dir."/".$this->table."/".$md5sum_tmp."_".$this->id."_".$this->filename))
      {
        $this->app->erp->LogFile("PDF Copy Checksum $md5sum_tmp (".$this->table."/".$this->id.")");
        $this->app->DB->Insert("INSERT INTO pdfmirror_md5pool (id,zeitstempel,checksum,table_id,table_name,bearbeiter,erstesoriginal) VALUES 
          ('',NOW(),'$md5sum_tmp','".$this->id."','".$this->table."','".$this->app->User->GetName()."',1)");
        
        copy($dir."/".$this->table."/".$this->id."_".$this->filename,$dir."/".$this->table."/".$md5sum_tmp."_".$this->id."_".$this->filename);
      }
    }
    $this->Output($dir."/".$this->table."/".$this->id."_".$this->filename,'F');
		// neue sicherung
		$md5sum_tmp = md5_file($dir."/".$this->table."/".$this->id."_".$this->filename);
		if(!is_file($dir."/".$this->table."/".$md5sum_tmp."_".$this->id."_".$this->filename))
		{
			$this->app->erp->LogFile("PDF Create Checksum $md5sum_tmp (".$this->table."/".$this->id.")");
			$this->app->DB->Insert("INSERT INTO pdfmirror_md5pool (id,zeitstempel,checksum,table_id,table_name,bearbeiter) VALUES 
				('',NOW(),'$md5sum_tmp','".$this->id."','".$this->table."','".$this->app->User->GetName()."')");
			$this->Output($dir."/".$this->table."/".$md5sum_tmp."_".$this->id."_".$this->filename,'F');
		}
    
  }

  public function inlineDocument($from_archiv = false) {
    //$from_archiv=false;
    if($from_archiv)
    {
      $dir = $this->app->Conf->WFuserdata."/pdfarchiv/".$this->app->Conf->WFdbname.'/'.$this->table;
      if(is_dir($dir) && $this->table && $this->id)
      {
        $mirror = $this->app->DB->Select("SELECT dateiname FROM pdfarchiv WHERE table_name = '".$this->table."' AND table_id = '".$this->id."' AND schreibschutz = 1 ORDER by zeitstempel DESC LIMIT 1");
        if($mirror)
        {
          if(is_file($dir.'/'.$mirror))
          {
            $content = file_get_contents($dir.'/'.$mirror);
          }
        }
        /*
        //$mirrors = $this->app->DB->SelectArr("SELECT checksum from pdfmirror_md5pool where table_id = '".$this->id."' and table_name = '".$this->table."' ORDER BY zeitstempel DESC");
        $mirrors = $this->getArchivedFiles_alt($this->id, $this->table);
        if($mirrors)
        {
          foreach($mirrors as $mirror)
          {
            //if(file_exists($dir."/".$this->table."/".$mirror['checksum']."_".$this->id."_".$this->filename))
            if(file_exists($dir."/".$this->table."/".$mirror['file']))
            {
              //$content = file_get_contents($dir."/".$this->table."/".$mirror['checksum']."_".$this->id."_".$this->filename);
              $content = file_get_contents($dir."/".$this->table."/".$mirror['file']);
              break;
            }
          }
        }*/
      }
    }
    if(isset($content) && $content)
    {
      header('Content-type: application/pdf');
      echo $content;
    } else {
      $this->renderDocument();
      $this->archiveDocument();
      header('Content-type: application/pdf');
      $this->Output();
    }
    exit;
  }
  
  public function zuArchivieren($tableid, $tablename)
  {
    if($tablename)$check = $this->app->DB->Select("SELECT zuArchivieren FROM $tablename WHERE id = '$tableid'");
    if($check)return true;
    $mirrors = $this->app->DB->SelectArr("SELECT * from pdfarchiv where table_id = '".$tableid."' and table_name = '".$tablename."' and erstesoriginal = 0 ORDER BY zeitstempel DESC");
    if(!$mirrors)return true;
    $dir = $this->app->Conf->WFuserdata."/pdfarchiv/".$this->app->Conf->WFdbname.'/'.$tablename;
    if(!is_dir($dir))return true;
    foreach($mirrors as $k => $mirror)
    {
      if(!$mirror['dateiname'] || !file_exists($dir.'/'.$mirror['dateiname']))
      {
      }else{
        return false;
      }
    }
    return true;
  }

  public function getArchivedFiles($tableid, $tablename)
  {
    $mirrors = $this->app->DB->SelectArr("SELECT * from pdfarchiv where table_id = '".$tableid."' and table_name = '".$tablename."' ORDER BY zeitstempel DESC");
    if(!$mirrors)return false;
    
    $dir = $this->app->Conf->WFuserdata."/pdfarchiv/".$this->app->Conf->WFdbname.'/'.$tablename;
    if(is_dir($dir))
    {
      /*$files = glob($dir.'/*.pdf');
      if(!$files)return false;
      
      foreach($files as $file)
      {
        $path_parts = pathinfo($file);
        foreach($mirrors as $k => $mirror)
        {
          if($mirror['checksum'])
          {
            
            if(strpos($path_parts['basename'],$mirror['checksum'])=== 0)
            {
              $this->app->erp->LogFile('checksum');
              $mirrors[$k]['file'] = $path_parts['basename'];
            }
            
          } else {
            if(strpos($path_parts['filename'], $tableid.'_') === 0){
              $this->app->erp->LogFile('o checksum');
              $mirrors[$k]['file'] = $path_parts['basename'];
            }
            
          }
          
        }
      }*/
      foreach($mirrors as $k => $mirror)
      {
        if(!$mirror['dateiname'] || !file_exists($dir.'/'.$mirror['dateiname']))
        {
          unset($mirrors[$k]);
        }else{
          $mirror['file'] = $mirror['dateiname'];
        }
      }
      
      if(!isset($mirrors) || count($mirrors) < 1)return false;
      return $mirrors;
    }
    return false;
  }
  
  public function getArchivedFiles_alt($tableid, $tablename)
  {
    
    $mirrors = $this->app->DB->SelectArr("SELECT * from pdfmirror_md5pool where table_id = '".$tableid."' and table_name = '".$tablename."' ORDER BY zeitstempel DESC");
    
    if(!$mirrors)return false;
    
    $dir = $this->app->Conf->WFuserdata."/pdfmirror/".$this->app->Conf->WFdbname.'/'.$tablename;
    if(is_dir($dir))
    {
      
      
      $files = glob($dir.'/*.pdf');
      if(!$files)return false;
      
      foreach($files as $file)
      {
        $path_parts = pathinfo($file);
        foreach($mirrors as $k => $mirror)
        {
          if($mirror['checksum'])
          {
            
            if(strpos($path_parts['basename'],$mirror['checksum'])=== 0)
            {
              $mirrors[$k]['file'] = $path_parts['basename'];
            }
            
          } else {
            if(strpos($path_parts['filename'], $tableid.'_') === 0){
              $mirrors[$k]['file'] = $path_parts['basename'];
            }
            
          }
          
        }
      }
      foreach($mirrors as $k => $mirror)
      {
        if(!isset($mirror['file']))unset($mirrors[$k]);
      }
      
      if(!isset($mirrors) || count($mirrors) < 1)return false;
      
      return $mirrors;
    }
    return false;
  }
  
  public function getArchivByID($id)
  {
    $id = (int)$id;
    if(!$id)return false;
    $dir = $this->app->Conf->WFuserdata."/pdfarchiv/".$this->app->Conf->WFdbname;
    if(!is_dir($dir))return false;
    $mirror = $this->app->DB->SelectArr("SELECT * from pdfarchiv where id = '$id' LIMIT 1");
    if(!$mirror)return false;
    $mirror = reset($mirror);
    if(!$mirror['dateiname'])return false;
    if(file_exists($dir.'/'.$mirror['table_name'].'/'.$mirror['dateiname']))
    {
      $tmpr['belegnr'] = $mirror['belegnummer'];
      $tmpr['file'] = file_get_contents($dir.'/'.$mirror['table_name'].'/'.$mirror['dateiname']);
      return $tmpr; 
    }
    return false;
  }

  public function getArchivByID_alt($id)
  {
    $id = (int)$id;
    if(!$id)return false;
    $dir = $this->app->Conf->WFuserdata."/pdfmirror/".$this->app->Conf->WFdbname;
    if(!is_dir($dir))return false;
    $mirror = $this->app->DB->SelectArr("SELECT * from pdfmirror_md5pool where id = '$id' LIMIT 1");
    if(!$mirror)return false;
    $mirror = reset($mirror);
    $mirrors = $this->getArchivedFiles_alt($mirror['table_id'], $mirror['table_name']);
    if(!$mirrors)return false;
    foreach($mirrors as $mirror)
    {
      //echo ".";
      if($mirror['id'] == $id)
      {
        //echo ":";
        if(file_exists($dir."/".$mirror['table_name']."/".$mirror['file']))
        {
          //echo ";";
          $tmpr['belegnr'] = str_replace('.pdf','',$mirror['file']);
          $tmpr['belegnr'] = substr($tmpr['belegnr'],strrpos($tmpr['belegnr'],'_')+1);
          $tmpr['file'] = file_get_contents($dir."/".$mirror['table_name']."/".$mirror['file']);
          return $tmpr; 
        }
        return false;
      }
    }
    return false;
  }
  
  public function displayDocument($from_archiv = false) {
    //$from_archiv=false;
    if($from_archiv)
    {
      
      $dir = $this->app->Conf->WFuserdata."/pdfarchiv/".$this->app->Conf->WFdbname.'/'.$this->table;
      if(is_dir($dir) && $this->table && $this->id)
      {
        $mirror = $this->app->DB->Select("SELECT dateiname FROM pdfarchiv WHERE table_name = '".$this->table."' AND table_id = '".$this->id."' AND schreibschutz = 1 ORDER by zeitstempel DESC LIMIT 1");
        if($mirror)
        {
          if(is_file($dir.'/'.$mirror))
          {
            $content = file_get_contents($dir.'/'.$mirror);
          }
        }
      }
      /*
      $dir = $this->app->Conf->WFuserdata."/pdfmirror/".$this->app->Conf->WFdbname;
      if(is_dir($dir))
      {
        //$mirrors = $this->app->DB->SelectArr("SELECT checksum from pdfmirror_md5pool where table_id = '".$this->id."' and table_name = '".$this->table."' ORDER BY zeitstempel DESC");
        $mirrors = $this->getArchivedFiles_alt($this->id, $this->table);
        if($mirrors)
        {
          foreach($mirrors as $mirror)
          {
            //if(file_exists($dir."/".$this->table."/".$mirror['checksum']."_".$this->id."_".$this->filename))
            if(file_exists($dir."/".$this->table."/".$mirror['file']))
            {
              //$content = file_get_contents($dir."/".$this->table."/".$mirror['checksum']."_".$this->id."_".$this->filename);
              $content = file_get_contents($dir."/".$this->table."/".$mirror['file']);
              break;
            }
          }
        }
      }*/
    }
    if(isset($content) && $content)
    {
      header('Content-type: application/pdf');
      header('Content-Disposition: attachment; filename="'.$this->filename.'"');
      echo $content;
    } else {
      $this->renderDocument();
      $this->archiveDocument();
      $this->Output($this->filename,'D');
    }
    exit;
  }

  public function displayTMP($from_archiv = false) {
    $this->renderDocument();
    $this->archiveDocument();
    $this->Output($this->app->erp->GetTMP()."/".$this->filename,'F');
    return $this->app->erp->GetTMP()."/".$this->filename;
  }

  public function sendDocument($from_archiv = false) { 
    $this->renderDocument();
    $this->archiveDocument();
    $this->Output($this->filename,'S'); 
    exit;
  }  

  /***********************************
   *       public functions
   ***********************************/  
  // setup relevant data for a invoice
  public function setupTax() {
    // full taxrate
    //   define("USTV",0.19);
    // reduced taxrate
    //    define("USTR",0.07);
  }  


  public function calcTotals() {
    $total=$totalFullTax=$totalReducedTax=0;
    for($i=0;$i<count($this->items);$i++) {
      $total += $this->items[$i]['tprice'];
      if($this->items[$i]['tax']=="USTV") $totalFullTax+= $this->items[$i]['tprice']*USTV;
      else                                $totalReducedTax+= $this->items[$i]['tprice']*USTR;
    }
    return array($total,$totalFullTax,$totalReducedTax);
  }

  function GetFont()
  {
    if($this->app->erp->Firmendaten("schriftart")!="")
      return $this->app->erp->Firmendaten("schriftart");
    else
      return 'Arial';
  }

  public function renderDocument() {
    // prepare page details
    parent::__construct('P','mm','A4');

    //		if($this->app->erp->Firmendaten("schriftart")!="")
    //			$this->SetFont($this->app->erp->Firmendaten("schriftart"));  

    if($this->app->erp->Firmendaten("schriftart")!="" && $this->app->erp->Firmendaten("schriftart")!="Arial" &&
        $this->app->erp->Firmendaten("schriftart")!="Courier" && $this->app->erp->Firmendaten("schriftart")!="Helvetica"
        && $this->app->erp->Firmendaten("schriftart")!="Times" && $this->app->erp->Firmendaten("schriftart")!="Arial"){
      $this->AddFont($this->app->erp->Firmendaten("schriftart"),'',strtolower($this->app->erp->Firmendaten("schriftart")).'.php');

      if(is_file("lib/pdf/font/".strtolower($this->app->erp->Firmendaten("schriftart")).'i.php'))
        $this->AddFont($this->app->erp->Firmendaten("schriftart"),'I',strtolower($this->app->erp->Firmendaten("schriftart")).'i.php');
      else
        $this->AddFont($this->app->erp->Firmendaten("schriftart"),'I',strtolower($this->app->erp->Firmendaten("schriftart")).'.php');

      if(is_file("lib/pdf/font/".strtolower($this->app->erp->Firmendaten("schriftart")).'b.php'))
        $this->AddFont($this->app->erp->Firmendaten("schriftart"),'B',strtolower($this->app->erp->Firmendaten("schriftart")).'b.php');
      else
        $this->AddFont($this->app->erp->Firmendaten("schriftart"),'B',strtolower($this->app->erp->Firmendaten("schriftart")).'.php');
    }

    // invoke Header() and Footer() by adding a new page
    $this->AddPage();
    //$this->setStationery("/home/eproo/eproo-master/app/main/www/lib/dokumente/demo.pdf");
    $this->SetDisplayMode("real","single");

    if($this->app->erp->Firmendaten("abstand_seitenrandrechts")=="")
      $this->app->erp->FirmendatenSet("abstand_seitenrandrechts",$this->app->erp->Firmendaten("abstand_seitenrandlinks"));

    $this->SetMargins($this->app->erp->Firmendaten("abstand_seitenrandlinks"),50,$this->app->erp->Firmendaten("abstand_seitenrandrecht"));
    $this->SetAutoPageBreak(true,$this->app->erp->Firmendaten("abstand_umbruchunten")); 
    $this->AliasNbPages('{nb}');

    // render document top to bottom
    if(!$this->nichtsichtbar_empfaenger)
    {
      if(!empty($this->recipient)) 
        $this->renderRecipient();
    }

    if($this->doctype=="lieferschein" && !empty($this->barcode))
    {
      if($this->barcode_y_header!=0)
        $y = $this->barcode_y_header;
      else
        $y = $this->GetY();
      $this->Code39($this->barcode_x_header, $y+1, $this->barcode, 1, 5);
    } 

    if($this->barcode!="" && $this->briefpapier!=""){
      $this->Code39($this->barcode_x, $this->barcode_y, $this->barcode, 1, 3);
    }

    //if(!empty($this->sender)) 
    $this->renderSender();

    if(!$this->nichtsichtbar_box)
    { 
      if(!empty($this->corrDetails) || !empty($this->boldCorrDetails)) 
        $this->renderCorrDetails();
    }

    $this->renderDoctype();
    if($this->doctype=="brief")
    {
      $this->SetY(95);                                                                                                 
      $this->textDetails['body']=$this->letterDetails['body'];
    }

    $this->renderText();
    if(!empty($this->items)) {
      $this->renderItems();
      if($this->doctype!="lieferschein" && $this->doctype!="preisanfrage") {
        if($this->GetY()>215) $this->AddPage();
        if(!$this->nichtsichtbar_summe)
          $this->renderTotals();
      }
    }
    $this->renderFooter();
    
    if($this->addpdf)
    {
      foreach($this->addpdf as $addpdf)
      {
        $filename = $addpdf;
        $this->AddPage();
        $this->SetXY(0,0);
        $anz = $this->setSourceFile($filename);
        for($i = 1; $i <= $anz; $i++)
        {
          if($i > 1)
          {
            $this->AddPage();
            $this->SetXY(0,0);
          }
          $tplidx = $this->ImportPage($i);
          $this->useTemplate($tplidx); 
        }
      }
    }
    
  }


  public function renderRecipient(){
    //    $this->SetY(50);
    $this->SetY(50+$this->abstand_adresszeileoben);
    $this->SetFont($this->GetFont(),'',10);

    $schriftgroesse  = $this->app->erp->Firmendaten('schriftgroesse');
    if($schriftgroesse>0)
      $this->SetFont($this->GetFont(),'',$schriftgroesse);

    $this->SetMargins($this->app->erp->Firmendaten("abstand_adresszeilelinks"),50);
    if($this->recipient['enterprise']) {
      $this->SetX($this->app->erp->Firmendaten("abstand_adresszeilelinks"));
      $charlimit=40;
      if(strlen($this->recipient['enterprise'])>$charlimit + 15)
      {
        $array = explode( "\n", wordwrap($this->recipient['enterprise'], $charlimit));
        foreach($array as $row)
        {
          $this->Cell(80,5,$this->app->erp->ReadyForPDF($row),0,1);
        }
      } else {
        $this->Cell(80,5,$this->app->erp->ReadyForPDF($this->recipient['enterprise']),0,1);
      }

    }


    if($this->recipient['firstname']!="")
    {
      $this->SetX($this->app->erp->Firmendaten("abstand_adresszeilelinks"));
      $this->Cell(80,5,$this->recipient['firstname'],0,1);
    }

    if($this->recipient['address2']!="") {
      $this->SetX($this->app->erp->Firmendaten("abstand_adresszeilelinks"));
      $this->Cell(80,5,$this->recipient['address2'],0,1);
    }

    if($this->recipient['address3']!="")
    {
      $this->SetX($this->app->erp->Firmendaten("abstand_adresszeilelinks"));
      $this->Cell(80,5,$this->recipient['address3'],0,1);
    }

    if($this->recipient['address4']!="")
    {
      $this->SetX($this->app->erp->Firmendaten("abstand_adresszeilelinks"));
      $this->Cell(80,5,$this->recipient['address4'],0,1);
    }


    //$this->Cell(80,5,$this->recipient['firstname']." ".$this->recipient['familyname'],0,1);
    $this->SetX($this->app->erp->Firmendaten("abstand_adresszeilelinks"));
    $this->Cell(80,5,$this->recipient['address1'],0,1);


    $this->SetFont($this->GetFont(),'',10);
    if($schriftgroesse>0)
      $this->SetFont($this->GetFont(),'',$schriftgroesse);


    $this->SetX($this->app->erp->Firmendaten("abstand_adresszeilelinks"));
    $inland = $this->app->erp->Firmendaten("land");
    if($this->recipient['country']!=$inland)
    {
      //$this->Cell(80,5,$this->recipient['country']."-".$this->recipient['areacode']." ".$this->recipient['city'],0,1);
      
      if(function_exists('mb_strtoupper'))
        $this->Cell(80,5,mb_strtoupper($this->recipient['areacode']." ".$this->recipient['city'],"UTF-8"),0,1);
      else
        $this->Cell(80,5,strtoupper($this->recipient['areacode']." ".$this->recipient['city']),0,1);

      $this->SetX($this->app->erp->Firmendaten("abstand_adresszeilelinks"));
      $this->Cell(80,5,strtoupper($this->app->erp->UmlauteEntfernen($this->app->GetLandLang($this->recipient['country'],$this->sprache))),0,1);
 
    }
    else {
      $this->Cell(80,5,$this->recipient['areacode']." ".$this->recipient['city'],0,1);
    }
    //$this->SetFont($this->GetFont(),'',9);
    //if(isset($this->recipient['country'])) $this->Cell(80,5,$this->recipient['country'],0,1);
    $this->SetMargins($this->app->erp->Firmendaten("abstand_seitenrandlinks"),50,$this->app->erp->Firmendaten("abstand_seitenrandrechts"));
  }

  public function setAbsender($sender)
  {
    $this->absender = $sender;

  }

  public function renderSender() {
    $monthlu = array("", "Januar", "Februar", "M�rz", "April", "Mai", "Juni", "Juli", "August", "September", "Oktober", "November", "Dezember");
    $monthnom = date("n");
    $month = $monthlu[$monthnom];
    $date = date("j").". ".$month." ".date("Y");


    if($this->nichtsichtbar_zeileabsender!=true)
    {

      //abstand_adresszeileoben
      // line above address field
      $absender = (($this->absender!='') ? $this->absender : $this->app->erp->Firmendaten('absender'));
      $schriftgroesse  = $this->app->erp->Firmendaten('schriftgroesseabsender');
      $this->SetY(43+$this->abstand_adresszeileoben);
      $this->SetFont($this->GetFont(),'',$schriftgroesse);
      //$cellStr = $this->sender['enterprise']." � ".$this->sender['address1']." � ".$this->sender['areacode']." ".$this->sender['city'];
      $cellStr = $this->app->erp->ReadyForPDF($absender);

      $this->SetX($this->app->erp->Firmendaten("abstand_adresszeilelinks"));

      if($this->app->erp->Firmendaten("absenderunterstrichen")=="1")
        $this->Cell($this->GetStringWidth($cellStr)+2,5,$cellStr,'B');
      else
        $this->Cell($this->GetStringWidth($cellStr)+2,5,$cellStr,'');
    }

    if($this->nichtsichtbar_rechtsoben!=true)
    {
      // detailed sender data
      $lineHeight = 4;
      $xOffset = 131;
      $absatz = 3;

      $this->SetXY($xOffset,10);
      $this->SetFont($this->GetFont(),'',9);
      $this->Cell(30,$lineHeight,"Name der Gesellschaft: ",0,0,'R');
      $this->SetFont($this->GetFont(),'B',9);
      $this->Cell(60,$lineHeight,$this->sender['enterprise'],0,2);
      if(isset($this->sender['enterprise2']))
        $this->Cell(60,$lineHeight,$this->sender['enterprise2'],0,2);

      $this->SetXY($xOffset,$this->GetY());
      $this->SetFont($this->GetFont(),'',9);
      $this->Cell(30,$lineHeight,"Sitz der Gesellschaft: ",0,0,'R');
      $this->SetFont($this->GetFont(),'B',9);
      $this->Cell(60,$lineHeight,$this->sender['address1'],0,2);
      if(isset($this->sender['address2']))
        $this->Cell(60,$lineHeight,$this->sender['address2'],0,2);
      $this->Cell(60,$lineHeight,$this->sender['areacode']." ".$this->sender['city'],0,2);

      $this->SetXY($xOffset,$this->GetY()+$absatz); //abstand
      $this->SetFont($this->GetFont(),'',9);
      if(isset($this->sender['phone1'])) {
        $this->Cell(30,$lineHeight,"Fon: ",0,0,'R');
        $this->Cell(60,$lineHeight,$this->sender['phone1'],0,2);
      }

      if(isset($this->sender['fax'])) {
        $this->SetXY($xOffset,$this->GetY());
        $this->Cell(30,$lineHeight,"Fax: ",0,0,'R');
        $this->Cell(60,$lineHeight,$this->sender['fax'],0,2);
      }


      $this->SetXY($xOffset, $this->GetY()+$absatz); //abstand
      if(isset($this->sender['email'])) {
        $this->Cell(30,$lineHeight,"Mail: ",0,0,'R');
        $this->Cell(60,$lineHeight,$this->sender['email'],0,2);  
      }

      if(isset($this->sender['web'])) {
        $this->SetXY($xOffset,$this->GetY());
        $this->Cell(30,$lineHeight,"Web: ",0,0,'R');
        $this->Cell(60,$lineHeight,$this->sender['web'],0,2);  
      }

      $this->SetXY($xOffset, $this->GetY()+$absatz); //abstand
      if(isset($this->sender['ustid'])) {
        $this->Cell(30,$lineHeight,"UST-ID: ",0,0,'R');
        $this->Cell(60,$lineHeight,$this->sender['ustid'],0,2);
      }
      if(isset($this->sender['taxnr'])) {
        $this->SetXY($xOffset,$this->GetY());
        $this->Cell(30,$lineHeight,"Steuer-Nr.: ",0,0,'R');
        $this->Cell(60,$lineHeight,$this->sender['taxnr'],0,2);
      }
      if(isset($this->sender['hreg'])) {
        $this->SetXY($xOffset,$this->GetY());
        $this->Cell(30,$lineHeight,"Handelsregister: ",0,0,'R');
        $this->Cell(60,$lineHeight,$this->sender['hreg'],0,2);
      }

      $this->SetXY($xOffset,$this->GetY());
      $this->Cell(30,$lineHeight,utf8_encode("Gesch�ftsf�hrung: "),0,0,'R');
      $this->Cell(60,$lineHeight,$this->sender['firstname'].' '.$this->sender['familyname'],0,2);

      //$this->SetXY($xOffset, $this->GetY()+$absatz+2); //abstand
      //$this->Cell(30,$lineHeight,"Datum: ",0,0,'R');
      //$this->Cell(60,$lineHeight,utf8_encode($date),0,2);
    } 
  }


  // kundennummer rechnungsnummer und datum
  public function renderCorrDetails() {

    $breite_spalte_rechts = 30;

    $recht_links_verschieben = $this->abstand_boxrechtsoben_lr;

    $startpos_links_rechts = -83 + $recht_links_verschieben;

    $boldTitleStr = $boldValueStr = $titleStr = $valueStr = "";
    if(isset($this->boldCorrDetails)){
      foreach($this->boldCorrDetails as $title => $value) {
        $boldTitleStr .= $this->app->erp->ReadyForPDF($title).": \n";
        $boldValueStr .= $this->app->erp->ReadyForPDF($value)."\n";
      }
    }
    if(isset($this->corrDetails)){
      foreach($this->corrDetails as $title => $value) {
        if($value!="")
        {
          $titleStr .= $this->app->erp->ReadyForPDF($title).": \n";
          $valueStr .= $this->app->erp->ReadyForPDF($value)."\n";	
        }
      }
    }

    if($this->boxausrichtung=="") $this->boxausrichtung="R";

    $pos = strpos($this->boxausrichtung, ';');	
    if($pos > 0)
    {
      $tmp_box = explode(";",$this->boxausrichtung);
      $this->boxausrichtung = $tmp_box[0];
      $this->box_breite1 = $tmp_box[1];
      $this->box_breite2 = $tmp_box[2];
    }
    if($this->box_breite1=="") $this->box_breite1=34;
    if($this->box_breite2=="") $this->box_breite2=38;


    $fontinfobox = $this->app->erp->Firmendaten("infobox");

    if($boldTitleStr!="")
    {
      $this->SetFont($this->GetFont(),'B',$fontinfobox);
      $this->SetXY($startpos_links_rechts,80);
      $this->MultiCell($this->box_breite1,4,$boldTitleStr,"",$this->boxausrichtung); //TL
      $this->SetXY($startpos_links_rechts+$breite_spalte_rechts,80);
      $this->MultiCell($this->box_breite2,4,$boldValueStr,"",$this->boxausrichtung);   //TR
    } else {
      $this->SetXY($startpos_links_rechts,80+$this->abstand_boxrechtsoben);
      $this->MultiCell($this->box_breite1,0,"","",$this->boxausrichtung); //TL
      $this->SetXY($startpos_links_rechts+$breite_spalte_rechts,80+$this->abstand_boxrechtsoben);
      $this->MultiCell($this->box_breite2,0,"","",$this->boxausrichtung);   //TR
    }

    $this->SetY(80);
    $this->SetY($this->GetY()+$this->abstand_boxrechtsoben);

    $this->SetFont($this->GetFont(),'',$fontinfobox);
    $tempY = $this->GetY();
    $this->SetX($startpos_links_rechts);
    $this->MultiCell($this->box_breite1,4,$titleStr,"",$this->boxausrichtung); //BL
    $this->SetXY($startpos_links_rechts+$breite_spalte_rechts,$tempY);
    $this->MultiCell($this->box_breitexi21,4,$valueStr,"",$this->boxausrichtung); //BR

    $this->SetY(80+$this->abstand_artikeltabelleoben); //Hoehe Box
    //$this->SetY(60);//+$this->abstand_artikeltabelleoben); //Hoehe Box
  }  


  public function renderDoctype() {
    //$this->Ln(1);

    if($this->doctype=="brief")
      $betreffszeile  = $this->app->erp->Firmendaten('betreffszeile');
    else
      $betreffszeile  = $this->app->erp->Firmendaten('betreffszeile');

    $this->SetY(80);//+$this->abstand_artikeltabelleoben); //Hoehe Box
    //$this->SetY(80+$this->abstand_artikeltabelleoben); //Hoehe Box

    $this->SetFont($this->GetFont(),'B',$betreffszeile);
    $this->SetY($this->GetY()+$this->abstand_betreffzeileoben);
    $this->Cell(85,6,$this->doctypeOrig);
    $this->SetY($this->GetY()-$this->abstand_betreffzeileoben);

    //$this->SetY($this->GetY()+$this->abstand_betreffzeileoben);
    $this->SetY($this->GetY()+$this->abstand_artikeltabelleoben); //Hoehe Box
  }

  public function renderText() {

    if(isset($this->textDetails['body'])) {
      if($this->doctype=="brief")
        $dokumententext  = $this->app->erp->Firmendaten('dokumententext');
      else
        $dokumententext  = $this->app->erp->Firmendaten('dokumententext');
      $this->SetFont($this->GetFont(),'',$dokumententext);
      //if($this->doctype!="brief")
      $this->Ln(11);

      $this->textDetails['body'] = $this->app->erp->ParseUserVars($this->table,$this->id,$this->textDetails['body']);

      if($this->app->erp->Firmendaten("briefhtml")=="1")
      {
        $html = $this->app->erp->ReadyForPDF($this->app->erp->RemoveNewlineAfterBreaks($this->textDetails['body']));
        $this->MultiCell(180,4,$this->WriteHTML($html));
      } else {
        $this->MultiCell(180,4,$this->app->erp->ReadyForPDF($this->textDetails['body']));
      }


    }
  }  

  public function renderFooter() {
    if(isset($this->textDetails['footer'])) {
      $freitext  = $this->app->erp->Firmendaten('freitext');
      
      if($this->app->erp->Firmendaten("kleinunternehmer"))
      {
        if($this->textDetails['footer']=="") $this->textDetails['footer'] ="Als Kleinunternehmer im Sinne von §19 Abs.1 UStG wird Umsatzsteuer nicht berechnet!";
        else $this->textDetails['footer'] .="\r\nAls Kleinunternehmer im Sinne von § 19 Abs. 1 UStG wird Umsatzsteuer nicht berechnet!";
      }

      $this->textDetails['footer'] = $this->app->erp->ParseUserVars($this->table,$this->id,$this->textDetails['footer']);

      $this->SetFont($this->GetFont(),'',$freitext);
      //      $this->Ln();
      $y = $this->GetY();

      //			if($this->doctype!="lieferschein")
      //				$this->SetY($y-5);
      //$parsed = $this->app->erp->ReadyForPDF($this->textDetails['footer']);
      if($this->app->erp->Firmendaten("briefhtml")=="1")
      {
        $html = $this->app->erp->ReadyForPDF($this->app->erp->RemoveNewlineAfterBreaks($this->textDetails['footer']));
        $this->MultiCell(180,4,$this->WriteHTML($html));
      } else {
        $this->MultiCell(180,4,$this->app->erp->ReadyForPDF($this->textDetails['footer']));
      }
    }
  }

  public function renderItems() {

    //		if($this->bestellungohnepreis) $this->doctype="lieferschein";
    $posWidth     = $this->app->erp->Firmendaten("breite_position");
    $amWidth     = $this->app->erp->Firmendaten("breite_menge");
    $itemNoWidth = $this->app->erp->Firmendaten("breite_nummer");
    $einheitWidth    = $this->app->erp->Firmendaten("breite_einheit");
    $descWidth    = $this->app->erp->Firmendaten("breite_artikel");
    $taxWidth    = $this->app->erp->Firmendaten("breite_steuer");
    $belege_subpositionen = $this->app->erp->Firmendaten("belege_subpositionen");


    if($this->doctype=="arbeitsnachweis")
    {
      $itemNoWidth = 20;
      $taxWidth = 40;
      $descWidth   = 95;
    }
    else if($this->doctype!="lieferschein" && $this->doctype!="produktion" && $this->doctype!="preisanfrage") {
      if($descWidth <=0)
        $descWidth   = 76;

      if($taxWidth <=0)
        $taxWidth   = 15;
    }
    else
    {
      $itemNoWidth = 30;
      $descWidth   = 91;
      if($taxWidth <=0)
        $taxWidth   = 15;
    }

    if($this->rabatt=="1") $descWidth = $descWidth - 15;
    $priceWidth = 20;
    $sumWidth   = 20;
    $rabattWidth   = 15;
    // $lineLength = $amWidth + $itemNoWidth + $descWidth + $taxWidth + $priceWidth + $sumWidth;

    $cellhoehe   = 5;

    // render table header
    if(isset($this->textDetails['body'])) $this->Ln();
    else $this->Ln(8);
    $tabellenbeschriftung  = $this->app->erp->Firmendaten('tabellenbeschriftung');

    $this->SetX($this->app->erp->Firmendaten("abstand_seitenrandlinks")+1); // eventuell einstellbar per GUI

    $this->SetFont($this->GetFont(),'B',$tabellenbeschriftung);
    $this->Cell($posWidth,6,$this->app->erp->Beschriftung("dokument_position"),0,0,'C');
    if($this->doctype!="arbeitsnachweis") 
    {
      if($this->doctype=="zahlungsavis")
      {
        $this->Cell($itemNoWidth,6,'Nummer');
        $this->Cell($descWidth-$einheitWidth+$taxWidth+$priceWidth+$rabattWidth,6,'Beleg');

        $this->Cell($amWidth,6,'',0,0,'R');
      }
      else {
        $this->Cell($itemNoWidth,6,$this->app->erp->Beschriftung("dokument_artikelnummer"));
        if($this->app->erp->Firmendaten("artikeleinheit")=="1")
          $this->Cell($descWidth-$einheitWidth,6,$this->app->erp->Beschriftung("dokument_artikel"));
        else
          $this->Cell($descWidth,6,$this->app->erp->Beschriftung("dokument_artikel"));
        $this->Cell($amWidth,6,$this->app->erp->Beschriftung("dokument_menge"),0,0,'R');
      }
    } else {
      $this->Cell($taxWidth,6,'Mitarbeiter');
      $this->Cell($itemNoWidth,6,'Ort');
      $this->Cell($descWidth,6,'Tätigkeit');
      $this->Cell($amWidth,6,'Stunden',0,0,'R');
    }

    if($this->doctype!="lieferschein" && $this->doctype!="arbeitsnachweis" && $this->doctype!="produktion" && $this->doctype!="zahlungsavis" && $this->doctype!="preisanfrage"){
      if($this->app->erp->Firmendaten("artikeleinheit")=="1")
        $this->Cell($einheitWidth,6,$this->app->erp->Beschriftung("dokument_einheit"),0,0,'R');

      if($this->app->erp->Firmendaten("kleinunternehmer"))
        $this->Cell($taxWidth,6,'',0,0,'R');
      else
        $this->Cell($taxWidth,6,$this->app->erp->Beschriftung("dokument_mwst"),0,0,'R');

      if($this->app->erp->Firmendaten("artikeleinheit")=="1")
        $this->Cell($priceWidth,6,utf8_encode($this->app->erp->Beschriftung("dokument_einzel")),0,0,'R');
      else
        $this->Cell($priceWidth,6,utf8_encode($this->app->erp->Beschriftung("dokument_stueck")),0,0,'R');

      if($this->rabatt=="1") {
        $this->Cell($rabattWidth,6,$this->app->erp->Beschriftung("dokument_rabatt"),0,0,'R');
        $this->Cell($sumWidth,6,$this->app->erp->Beschriftung("dokument_gesamt"),0,0,'R');
      } else {
        $this->Cell($sumWidth,6,$this->app->erp->Beschriftung("dokument_gesamt"),0,0,'R');
      }
    }
    else if ($this->doctype=="lieferschein" || $this->doctype=="preisanfrage")
    {
      if($this->app->erp->Firmendaten("artikeleinheit")=="1")
        $this->Cell($einheitWidth,6,$this->app->erp->Beschriftung("dokument_einheit"),0,0,'R');
    } 
    else if ($this->doctype=="zahlungsavis")
    {
      $this->Cell($sumWidth,6,$this->app->erp->Beschriftung("dokument_gesamt"),0,0,'R');
    }	

    $this->Ln();
    $this->Line($this->app->erp->Firmendaten("abstand_seitenrandlinks")+1, $this->GetY(), 210-$this->app->erp->Firmendaten("abstand_seitenrandrechts"), $this->GetY()); 
    $this->Ln(2);

    // render table body
    $tabelleninhalt  = $this->app->erp->Firmendaten('tabelleninhalt');

    $this->SetFont($this->GetFont(),'',$tabelleninhalt);
    $topos = 0;
    if(is_array($this->items))$topos = count($this->items);
    $zwischenpositionen = $this->app->DB->Select("SELECT count(distinct pos) FROM beleg_zwischenpositionen WHERE doctype='".$this->doctype."' AND doctypeid='".$this->doctypeid."' AND pos > 0 AND pos <'$topos' AND (postype = 'gruppe'  OR postype = 'zwischensumme' OR postype = 'gruppensumme') ORDER by sort");
    if($zwischenpositionen < 1)$belege_subpositionen = false;
    $hauptnummer = 0;
    $posoffset = 0;
    if($belege_subpositionen)$hauptnummer = 1;
    $langeartikelnummern = $this->app->erp->Firmendaten('langeartikelnummern');
    $pos=0; 
    foreach($this->items as $item){
      $iszwichenpos = $this->DrawZwischenpositionen($pos);
      $item['name'] = ($langeartikelnummern?"\r\n":'').$this->app->erp->ReadyForPDF($item['name']);
      $item['desc'] = $this->app->erp->ReadyForPDF($item['desc']);
      $item['itemno'] = $this->app->erp->ReadyForPDF($item['itemno']);
      $item['herstellernummer'] = $this->app->erp->ReadyForPDF($item['herstellernummer']);
      $item['artikelnummerkunde'] = $this->app->erp->ReadyForPDF($item['artikelnummerkunde']);
      $item['lieferdatum'] = $this->app->erp->ReadyForPDF($item['lieferdatum']);
      $item['hersteller'] = $this->app->erp->ReadyForPDF($item['hersteller']);

      //TODO Soll einstellbar werden: Zeilenabstand in Tabelle normal mittel 
      $cellhoehe  = 3;
      //position
      
      if($iszwichenpos && $belege_subpositionen && $pos > $posoffset)
      {
        $hauptnummer++;
        $posoffset = $pos;
      }
      
      $pos++;
      $posstr = $pos;
      if($belege_subpositionen && $hauptnummer)
      {
        $posstr = $hauptnummer.'.'.($pos-$posoffset);
      }
      $this->Cell($posWidth,$cellhoehe,$posstr,0,0,'C');
      //artikelnummer
      if($this->doctype=="arbeitsnachweis")
      {
        $this->Cell($taxWidth,$cellhoehe,trim($item['person']),0);

        $zeilenuntertext  = $this->app->erp->Firmendaten('zeilenuntertext');
        $this->SetFont($this->GetFont(),'',$zeilenuntertext);

        // ort
        $tmpy = $this->GetY();
        $tmpx = $this->GetX();
        $this->MultiCell($itemNoWidth,($zeilenuntertext/2),trim($item['itemno']),0); // 4 = abstand
        $tmpy2 = $this->GetY();
        $this->SetXY($tmpx+$itemNoWidth,$tmpy);
        $this->SetFont($this->GetFont(),'',$tabelleninhalt);
      }
      else {
        //TODO BENE
        if($this->doctype=="lieferschein" && $this->app->erp->Firmendaten("modul_verband")=="1")
          $this->SetFont($this->GetFont(),'',$tabelleninhalt+3);
        else
          $this->SetFont($this->GetFont(),'',$tabelleninhalt);
        if(isset($item['itemno'])) $this->Cell($itemNoWidth,$cellhoehe,$item['itemno'],0);
        else $this->Cell($itemNoWidth);
        $this->SetFont($this->GetFont(),'',$tabelleninhalt);
      }

      $position_x   = $this->GetX();
      $position_y   = $this->GetY();

// start am Ende der Zeile Zeichnen
    $this->SetAutoPageBreak(false,$this->app->erp->Firmendaten("abstand_umbruchunten")); //2306BS
      // Artikel Name
      if($item['tax']!=="hidden")		
        $this->SetFont($this->GetFont(),'B',$tabelleninhalt);

      if($this->app->erp->Firmendaten("artikeleinheit")=="1")
        $this->MultiCell($descWidth-$einheitWidth,$cellhoehe,$item['name'],0,Alignment.LEFT, false);
      else
        $this->MultiCell($descWidth,$cellhoehe,$item['name'],0,Alignment.LEFT, false);

      $this->SetFont($this->GetFont(),'',$tabelleninhalt);
    $this->SetAutoPageBreak(true,$this->app->erp->Firmendaten("abstand_umbruchunten")); //2306BS

      $position_y_end_name   = $this->GetY();
//

      // wenn vorhanden Artikel Einheit


      if($this->app->erp->Firmendaten("artikeleinheit")=="1")
        $this->SetXY(($position_x + $descWidth-$einheitWidth), $position_y);
      else
        $this->SetXY(($position_x + $descWidth), $position_y); 


      if($this->doctype=="arbeitsnachweis")
        $this->SetXY(($position_x + $descWidth), $position_y); 


      // Menge

      if($this->doctype=="zahlungsavis")
        $this->Cell($amWidth,$cellhoehe,"",0,0,'R');
      else
        $this->Cell($amWidth,$cellhoehe,$item['amount'],0,0,'R');

      if($this->doctype!="lieferschein" && $this->doctype!="arbeitsnachweis" && $this->doctype!="produktion" && $this->doctype!="preisanfrage") {
        if($this->app->erp->Firmendaten("artikeleinheit")=="1")
        {
          if($item['unit']!="")
            $einheit = $item['unit'];
          else {
            $einheit = $this->app->DB->Select("SELECT einheit FROM artikel WHERE 
                nummer='".$item['itemno']."' LIMIT 1");
            if($einheit=="") $einheit = $this->app->erp->Firmendaten("artikeleinheit_standard");
          }
          $this->Cell($einheitWidth,$cellhoehe,$this->app->erp->ReadyForPDF($einheit),0,0,'R');
        }

        //			if($item['tax']=="hidden") $item['tax']=="hidden";
        if($item['tax']!=="hidden")
        {          
          if($this->ust_befreit>0) { 
            $item['tax'] = 0;
          } else {
            if($item['tax'] == "normal") $item['tax'] = $this->app->erp->GetSteuersatzNormal(true,$this->id,$this->table)-1; 
            else $item['tax'] = $this->app->erp->GetSteuersatzErmaessigt(true,$this->id,$this->table)-1;
          }
          if(isset($item['steuersatz']))$item['tax'] = $item['steuersatz'] / 100;
        }


        // wenn steuerfrei komplett immer 0 steuer anzeigen
        $item['tmptax'] = $item['tax'] + 1;

        // standard anzeige mit steuer
        if($this->app->erp->Firmendaten("kleinunternehmer")!="1"){
          if($item['tax']==="hidden"){
            $this->Cell($taxWidth,$cellhoehe,"",0,0,'R');
          } else {
            $tax = $item['tax']; //= $tax; //="USTV"?0.19:0.07;
            $tax *= 100; $tax = $tax."%";

            if($this->doctype=="zahlungsavis")
              $this->Cell($taxWidth,$cellhoehe,"",0,0,'R');
            else
              $this->Cell($taxWidth,$cellhoehe,$item['ohnepreis']?'':$tax,0,0,'R');
          } 
        } else {
          //kleinunternehmer
          $this->Cell($taxWidth,$cellhoehe,"",0,0,'R');
        }


        if($this->doctype!="lieferschein" && $this->doctype!="produktion" && $this->doctype!="preisanfrage") {
          // preis pro Artikel

          if($this->doctype!="zahlungsavis")
          {
            if($item['tax']!=="hidden"){
              if(($this->anrede=="firma" || $this->app->erp->AnzeigeBelegNetto($this->anrede,$projekt) || $this->doctype=="bestellung" || $this->app->erp->Firmendaten("immernettorechnungen",$projekt)=="1") 
                 && $this->app->erp->Firmendaten("immerbruttorechnungen",$projekt)!="1")
                $this->Cell($priceWidth,$cellhoehe,$item['ohnepreis']?'':number_format((double)$item['price'], $this->anzahlkomma, ',', '.'),0,0,'R');
              else
                $this->Cell($priceWidth,$cellhoehe,$item['ohnepreis']?'':number_format((double)$item['price']*$item['tmptax'], $this->anzahlkomma, ',', '.'),0,0,'R');
            } else
              $this->Cell($priceWidth,$cellhoehe,$item['ohnepreis']?'':number_format((double)$item['price'], $this->anzahlkomma, ',', '.'),0,0,'R');
          } else {
            $this->Cell($priceWidth,$cellhoehe,"",0,0,'R');
          }

          // zentale rabatt spalte
          if($this->rabatt=="1") {
            $rabatt_string="";

            //rabatt	
            if($item['grundrabatt'] > 0 || $item['rabatt1'] > 0 || $item['rabatt2'] > 0)
            {
              if($item['grundrabatt']>0) $rabatt_string .= $item['grundrabatt']."%\r\n";
              if($item['rabatt1']>0) $rabatt_string .= $item['rabatt1']."%\r\n";
              if($item['rabatt2']>0) $rabatt_string .= $item['rabatt2']."%\r\n";
              if($item['rabatt3']>0) $rabatt_string .= $item['rabatt3']."%\r\n";
              if($item['rabatt4']>0) $rabatt_string .= $item['rabatt4']."%\r\n";
              if($item['rabatt5']>0) $rabatt_string .= $item['rabatt5']."%\r\n";


              $tmpy = $this->GetY();
              $tmpx = $this->GetX();

              $this->SetFont($this->GetFont(),'',6);
              if($item['keinrabatterlaubt']=="1" || $item['rabatt']<=0 || $item['rabatt']==="") {
                $rabatt_or_porto = $this->app->DB->Select("SELECT id FROM artikel WHERE 
                    nummer='".$item['itemno']."' AND (porto='1' OR rabatt='1') LIMIT 1");
                if($rabatt_or_porto)
                  $rabatt_string="";
                else {
                  if($this->app->erp->Firmendaten("modul_verband")=="1") $rabatt_string="SNP";
                  else $rabatt_string="";
                }
              }

              if($item['tax']!=="hidden")
                $this->MultiCell($rabattWidth,$cellhoehe-1,$rabatt_string,0,0,'L');
              else
                $this->MultiCell($rabattWidth,$cellhoehe-1,"",0,0,'L');


              $this->SetXY($tmpx+$rabattWidth,$tmpy);
              $this->SetFont($this->GetFont(),'',$tabelleninhalt);
            } else {
              if($item['rabatt']>0)// && $item['keinrabatterlaubt']!="1")
                $this->Cell($rabattWidth,$cellhoehe,$item['ohnepreis']?'':$item['rabatt']." %",0,0,'R');
              else
              {
                if($this->app->erp->Firmendaten("modul_verband")=="1")
                {
                  $rabatt_or_porto = $this->app->DB->Select("SELECT id FROM artikel WHERE 
                      nummer='".$item['itemno']."' AND (porto='1' OR rabatt='1') LIMIT 1");
                  if($rabatt_or_porto)
                    $this->Cell($rabattWidth,$cellhoehe,"",0,0,'R');
                  else
                    $this->Cell($rabattWidth,$cellhoehe,"SNP",0,0,'R');
                } else {
                  $this->Cell($rabattWidth,$cellhoehe,"",0,0,'R');
                }
              }
            }
          } 
          else {
            // anzeige ohne zentrale rabatt spalte
            if ($item['tax']==="hidden"){
              $this->Cell($priceWidth,$cellhoehe,"",0,0,'R');
            }
            else {
              if(($this->anrede=="firma" || $this->app->erp->AnzeigeBelegNetto($this->anrede,$projekt) || $this->doctype=="bestellung" || $this->app->erp->Firmendaten("immernettorechnungen",$projekt)=="1") 
                 && $this->app->erp->Firmendaten("immerbruttorechnungen",$projekt)!="1")
              {
                $this->Cell($priceWidth,$cellhoehe,$item['ohnepreis']?'':number_format((double)$item['tprice'], $this->anzahlkomma, ',', '.'),0,0,'R');
              }
              else
                $this->Cell($priceWidth,$cellhoehe,$item['ohnepreis']?'':number_format((double)$item['tprice']*$item['tmptax'], $this->anzahlkomma, ',', '.'),0,0,'R');

              $this->Cell($rabattWidth,$cellhoehe,"",0,0,'R');
            }
          }
        } 
        else {
 
           if(($this->anrede=="firma" || $this->app->erp->AnzeigeBelegNetto($this->anrede,$projekt) || $this->doctype=="bestellung" || $this->app->erp->Firmendaten("immernettorechnungen",$projekt)=="1") 
                 && $this->app->erp->Firmendaten("immerbruttorechnungen",$projekt)!="1")
            $this->Cell($priceWidth,$cellhoehe,$item['ohnepreis']?'':number_format((double)$item['price'], $this->anzahlkomma, ',', '.'),0,0,'R');
          else
            $this->Cell($priceWidth,$cellhoehe,$item['ohnepreis']?'':number_format((double)$item['price']*$item['tmptax'], $this->anzahlkomma, ',', '.'),0,0,'R');
        }
        //$this->Cell($sumWidth,$cellhoehe,number_format($item['tprice'], 2, ',', '').' '.$item['currency'],0,0,'R');
        if($this->rabatt=="1")
        {
          //gesamt preis
          if ($item['tax']==="hidden"){
            $this->Cell($priceWidth,$cellhoehe,"",0,0,'R');
          }
          else {
            if($this->rabatt=="1"){
              if(($this->anrede=="firma" || $this->app->erp->AnzeigeBelegNetto($this->anrede,$projekt) || $this->doctype=="bestellung" || $this->app->erp->Firmendaten("immernettorechnungen",$projekt)=="1") 
                 && $this->app->erp->Firmendaten("immerbruttorechnungen",$projekt)!="1")

                $this->Cell($sumWidth,$cellhoehe,$item['ohnepreis']?'':number_format((double)$item['tprice'], $this->anzahlkomma, ',', '.'),0,0,'R');
              else
                $this->Cell($sumWidth,$cellhoehe,$item['ohnepreis']?'':number_format((double)$item['tprice']*$item['tmptax'], $this->anzahlkomma, ',', '.'),0,0,'R');
            }
            else {
               if(($this->anrede=="firma" || $this->app->erp->AnzeigeBelegNetto($this->anrede,$projekt) || $this->doctype=="bestellung" || $this->app->erp->Firmendaten("immernettorechnungen",$projekt)=="1") 
                 && $this->app->erp->Firmendaten("immerbruttorechnungen",$projekt)!="1")
                $this->Cell($sumWidth,$cellhoehe,$item['ohnepreis']?'':number_format((double)$item['tprice'], $this->anzahlkomma, ',', '.'),0,0,'R');
              else
                $this->Cell($sumWidth,$cellhoehe,$item['ohnepreis']?'':number_format((double)$item['tprice']*$item['tmptax'], $this->anzahlkomma, ',', '.'),0,0,'R');
            }
          }
        }

      }
      else if($this->app->erp->Firmendaten("artikeleinheit")=="1" && ($this->doctype=="lieferschein" || $this->doctype=="preisanfrage"))
        {
          if($item['unit']!="")
            $einheit = $item['unit'];
          else {
            $einheit = $this->app->DB->Select("SELECT einheit FROM artikel WHERE
                nummer='".$item['itemno']."' LIMIT 1");
            if($einheit=="") $einheit = $this->app->erp->Firmendaten("artikeleinheit_standard");
          }
          $this->Cell($einheitWidth,$cellhoehe,$this->app->erp->ReadyForPDF($einheit),0,0,'R');
        }

      $this->Ln();
      if($this->app->erp->Firmendaten("herstellernummerimdokument")=="1" && $item['herstellernummer']!="")
      {
        if($item['desc']!="")
          $item['desc']=$item['desc']."\r\nPN: ".$item['herstellernummer'];
        else
          $item['desc']="PN: ".$item['herstellernummer'];
      }


      if($item['lieferdatum']!="" && $item['lieferdatum']!="0000-00-00" && $item['lieferdatum']!="00.00.0000")
      {

        if(strpos($item['lieferdatum'],"-")!==false)
          $item['lieferdatum'] = $this->app->erp->ReadyForPDF($this->app->String->Convert($item['lieferdatum'],"%1-%2-%3","%3.%2.%1"));

        if($item['lieferdatumkw']==1)
        {
          $ddate = $this->app->String->Convert($item['lieferdatum'],"%3.%2.%1","%1-%2-%3");
          $duedt = explode("-", $ddate);
          $date  = mktime(0, 0, 0, $duedt[1], $duedt[2], $duedt[0]);
          $week  = date('W/Y', $date);
          $item['lieferdatum'] = $this->app->erp->Beschriftung("dokument_lieferdatumkw")." ".$week;
        }

        if($item['desc']!="")
          $item['desc']=$item['desc']."\r\n".$this->app->erp->Beschriftung("dokument_lieferdatum").": ".$item['lieferdatum'];
        else
          $item['desc']=$this->app->erp->Beschriftung("dokument_lieferdatum").": ".$item['lieferdatum'];
      }


      if($this->app->erp->Firmendaten("freifelderimdokument")=="1")
      {
        for($ifreifeld=1;$ifreifeld<=20;$ifreifeld++)
        {
          if($item['freifeld'.$ifreifeld]!="")
          {
            if($item['desc']!="")
              $item['desc']=$item['desc']."\r\n".$this->app->erp->Beschriftung("artikel_freifeld".$ifreifeld).": ".$item['freifeld'.$ifreifeld];
            else
              $item['desc']=$this->app->erp->Beschriftung("artikel_freifeld".$ifreifeld).": ".$item['freifeld'.$ifreifeld];
          }
        }
      }

      if($item['artikelnummerkunde']!="" && $item['artikelnummerkunde']!="0")
      {
        if($item['desc']!="")
          $item['desc']=$item['desc']."\r\n".$this->app->erp->Beschriftung("dokument_artikelnummerkunde").": ".$item['artikelnummerkunde'];
        else
          $item['desc']=$this->app->erp->Beschriftung("dokument_artikelnummerkunde").": ".$item['artikelnummerkunde'];
      }

      if($item['zolltarifnummer']!="" && $item['zolltarifnummer']!="0")
      {
        if($item['desc']!="")
          $item['desc']=$item['desc']."\r\n".$this->app->erp->Beschriftung("dokument_zolltarifnummer").": ".$item['zolltarifnummer']." ".$this->app->erp->Beschriftung("dokument_herkunftsland").": ".$item['herkunftsland'];
        else
          $item['desc']=$this->app->erp->Beschriftung("dokument_zolltarifnummer").": ".$item['zolltarifnummer']." ".$this->app->erp->Beschriftung("dokument_herkunftsland").": ".$item['herkunftsland'];
      }

      if($item['ean']!="" && $item['ean']!="0")
      {
        if($item['desc']!="")
          $item['desc']=$item['desc']."\r\n".$this->app->erp->Beschriftung("dokument_ean").": ".$item['ean'];
        else
          $item['desc']=$this->app->erp->Beschriftung("dokument_ean").": ".$item['ean'];
      }




      if($item['desc']!="") {
        //Herstellernummer einblenden wenn vorhanden und aktiviert

        $zeilenuntertext  = $this->app->erp->Firmendaten('zeilenuntertext');
        $this->SetY($position_y_end_name+$this->app->erp->Firmendaten("abstand_name_beschreibung"));
        $this->SetFont($this->GetFont(),'',$zeilenuntertext);
        $this->Cell($posWidth);
        $this->Cell($itemNoWidth);
        if($this->doctype=="arbeitsnachweis") $this->Cell($taxWidth);

        if($this->doctype=="lieferschein" && $this->app->erp->Firmendaten("modul_verband")=="1")
          $this->SetFont($this->GetFont(),'',$tabelleninhalt+1);

        if($this->app->erp->Firmendaten("briefhtml")=="1")
        {
          $html = $this->app->erp->ReadyForPDF($this->app->erp->RemoveNewlineAfterBreaks($item['desc']));
          if($this->app->erp->Firmendaten("artikeleinheit")=="1")
          {
            if($this->app->erp->Firmendaten("breite_artikelbeschreibung"))
            {
              $this->MultiCell($descWidth-$einheitWidth+$taxWidth + $sumWidth + $rabattWidth,($zeilenuntertext/2),$this->WriteHTML($html),0,'L'); // 4 = abstand
              if(!empty($item['steuertext']))$this->MultiCell($descWidth-$einheitWidth+$taxWidth + $sumWidth + $rabattWidth,($zeilenuntertext/2),$item['steuertext'],0,'L');
            }
            else
            {
              $this->MultiCell($descWidth-$einheitWidth,($zeilenuntertext/2),$this->WriteHTMLCell($descWidth-$einheitWidth,$html),0,'L'); // 4 = abstand //ALT
              if(!empty($item['steuertext']))$this->MultiCell($descWidth-$einheitWidth+$taxWidth + $sumWidth + $rabattWidth,($zeilenuntertext/2),$item['steuertext'],0,'L');
            }
          }
          else
          {
            if($this->app->erp->Firmendaten("breite_artikelbeschreibung")=="1")
            {
              $this->MultiCell($descWidth+$taxWidth + $sumWidth + $rabattWidth,($zeilenuntertext/2),$this->WriteHTML($html),0,'L'); // 4 = abstand
              if(!empty($item['steuertext']))$this->MultiCell($descWidth-$einheitWidth+$taxWidth + $sumWidth + $rabattWidth,($zeilenuntertext/2),$item['steuertext'],0,'L');
            }
            else
            {
              $this->MultiCell($descWidth,($zeilenuntertext/2),$this->WriteHTMLCell($descWidth,$html),0,'L'); // 4 = abstand //ALT
              if(!empty($item['steuertext']))$this->MultiCell($descWidth-$einheitWidth+$taxWidth + $sumWidth + $rabattWidth,($zeilenuntertext/2),$item['steuertext'],0,'L');
            }
          } 
        } else {
          if($this->app->erp->Firmendaten("artikeleinheit")=="1")
          {
            if($this->app->erp->Firmendaten("breite_artikelbeschreibung"))
            {
              $this->MultiCell($descWidth-$einheitWidth+$taxWidth + $sumWidth + $rabattWidth,($zeilenuntertext/2),trim($item['desc']),0,'L'); // 4 = abstand
              if(!empty($item['steuertext']))$this->MultiCell($descWidth-$einheitWidth+$taxWidth + $sumWidth + $rabattWidth,($zeilenuntertext/2),$item['steuertext'],0,'L');
            }
            else
            {
              $this->MultiCell($descWidth-$einheitWidth,($zeilenuntertext/2),trim($item['desc']),0,'L'); // 4 = abstand //ALT
              if(!empty($item['steuertext']))$this->MultiCell($descWidth-$einheitWidth+$taxWidth + $sumWidth + $rabattWidth,($zeilenuntertext/2),$item['steuertext'],0,'L');
            }
          }
          else
          {
            if($this->app->erp->Firmendaten("breite_artikelbeschreibung")=="1")
            {
              $this->MultiCell($descWidth+$taxWidth + $sumWidth + $rabattWidth,($zeilenuntertext/2),trim($item['desc']),0,'L'); // 4 = abstand
              if(!empty($item['steuertext']))$this->MultiCell($descWidth-$einheitWidth+$taxWidth + $sumWidth + $rabattWidth,($zeilenuntertext/2),$item['steuertext'],0,'L');
            }
            else
            {
              $this->MultiCell($descWidth,($zeilenuntertext/2),trim($item['desc']),0,'L'); // 4 = abstand //ALT
              if(!empty($item['steuertext']))$this->MultiCell($descWidth-$einheitWidth+$taxWidth + $sumWidth + $rabattWidth,($zeilenuntertext/2),$item['steuertext'],0,'L');
            }
          } 

        }
        $this->Cell($taxWidth);
        $this->Cell($amWidth);
        $this->Ln();
        $this->SetFont($this->GetFont(),'',$tabelleninhalt);

        $zeilenuntertext  = $this->app->erp->Firmendaten('zeilenuntertext');
        $this->SetFont($this->GetFont(),'',$zeilenuntertext);
        $this->Cell($posWidth);
        $this->Cell($itemNoWidth);
        if($this->doctype=="arbeitsnachweis") $this->Cell($taxWidth);
        if($this->app->erp->Firmendaten("artikeleinheit")=="1")
          $this->MultiCell($descWidth-$einheitWidth,4,"",0); // 4 = abstand zwischen Artikeln
        else
          $this->MultiCell($descWidth,4,"",0); // 4 = abstand zwischen Artikeln
        $this->Cell($taxWidth);
        $this->Cell($amWidth);
        $this->Ln();
        $this->SetFont($this->GetFont(),'',$tabelleninhalt);
      } else {

        $zeilenuntertext  = $this->app->erp->Firmendaten('zeilenuntertext');
        $this->SetY($position_y_end_name);
        $this->SetFont($this->GetFont(),'',$zeilenuntertext);
        $this->Cell($posWidth);
        $this->Cell($itemNoWidth);
        if($this->doctype=="arbeitsnachweis") $this->Cell($taxWidth);

        if($this->app->erp->Firmendaten("artikeleinheit")=="1")
        {
          $this->MultiCell($descWidth-$einheitWidth,3,trim($item['desc']),0); // 4 = abstand
          if(!empty($item['steuertext']))$this->MultiCell($descWidth-$einheitWidth+$taxWidth + $sumWidth + $rabattWidth,($zeilenuntertext/2),$item['steuertext'],0,'L');
        }
        else
        {
          $this->MultiCell($descWidth,3,trim($item['desc']),0); // 4 = abstand
          if(!empty($item['steuertext']))$this->MultiCell($descWidth-$einheitWidth+$taxWidth + $sumWidth + $rabattWidth,($zeilenuntertext/2),$item['steuertext'],0,'L');
          
        }

        $this->Cell($taxWidth);
        $this->Cell($amWidth);
        $this->Ln();
        $this->SetFont($this->GetFont(),'',$tabelleninhalt);

      }
      

      
    }
    $this->DrawZwischenpositionen($pos);

    //$this->Line($this->GetX(), $this->GetY(), $this->app->erp->Firmendaten("abstand_seitenrandlinks")+195-$this->app->erp->Firmendaten("abstand_seitenrandrechts"), $this->GetY()); 

    $this->Line($this->app->erp->Firmendaten("abstand_seitenrandlinks")+1, $this->GetY(), 210-$this->app->erp->Firmendaten("abstand_seitenrandrechts"), $this->GetY()); 
  }  

  function DrawZwischenpositionen($pos) {
    $ret = false;
    $zwischenpositionen = $this->app->DB->SelectArr("SELECT * FROM beleg_zwischenpositionen WHERE doctype='".$this->table."' AND doctypeid='".$this->doctypeid."' AND pos='$pos' ORDER by sort");

    for($i=0;$i<count($zwischenpositionen);$i++)
    {
      $data = json_decode($zwischenpositionen[$i]['wert'], true);
      switch($zwischenpositionen[$i]['postype'])
      {
        case "gruppe":
          $ret = true;
          $schriftgroesse = $this->FontSizePt;
          $schriftgroesse_alt = $schriftgroesse;
          if($schriftgroesse == 0)$schriftgroesse = 7;
          if(!empty($data['Schriftgroesse']))
          {
            $schriftgroesse = $data['Schriftgroesse'];
            if($schriftgroesse == 0)$schriftgroesse = 7;
            $this->SetFontSize($schriftgroesse);
          }
          $fett = true;
          if(isset($data['Fett']))
          {
            if($data['Fett'] === false || $data['Fett'] === 'false')$fett = false;
            if($data['Fett'] === true || $data['Fett'] === 'true')$fett = true;
          }
          $unterstrichen = false;
          if(isset($data['Unterstrichen']))
          {
            $unterstrichen = $data['Unterstrichen'];
          }
          $this->underline = $unterstrichen;
          $html = ($fett?"<b>":"").$data['name'].($fett?"</b>":"");
          if(!empty($data['Abstand_Oben']))
          {
            $this->Ln((int)$data['Abstand_Oben']);
          }else{
            $this->Ln(5);
          }
          $schriftgroesse = 7;
          if(!empty($data['Schriftgroesse']))
          {
            $schriftgroesse = $data['Schriftgroesse'];
          }
          $this->SetFontSize($schriftgroesse_alt);
          $x = $this->GetX();
          $abstand_links = 0;
          if(isset($data['Abstand_Links']))
          {
            $abstand_links = (int)$data['Abstand_Links'];
            $this->SetX($x+$abstand_links);
          }
          
          $this->MultiCell(0,4,$this->WriteHTML($html));
          $this->SetX($x);
          $this->Ln();
          $this->underline = false;
          if($data['kurztext']!="")
          {
            
            if(isset($data['Kurztext_Unterstrichen']))
            {
              $this->underline = $data['Kurztext_Unterstrichen'];
            }
            $x = $this->GetX();
            $abstand_links = 0;
            if(isset($data['Kurztext_Abstand_Links'])){
              $abstand_links = (int)$data['Kurztext_Abstand_Links'];
              $this->SetX($x+$abstand_links);
            }
            elseif(isset($data['Abstand_Links']))
            {
              $abstand_links = (int)$data['Abstand_Links'];
              $this->SetX($x+$abstand_links);
            }
            $this->MultiCell(0,4,$this->WriteHTML($data['kurztext']));
            $this->SetX($x);
            if(!empty($data['Abstand_Unten']))
            {
              $this->Ln((int)$data['Abstand_Unten']);
            }else{
              $this->Ln(10);
            }
          }
          $this->SetFontSize($schriftgroesse_alt);
          $this->underline = false;
        break;

        case "seitenumbruch":
          $this->AddPage();
        break;

        case "gruppensumme":
        case "zwischensumme":
          $ret = true;
          $posWidth     = $this->app->erp->Firmendaten("breite_position");
          $amWidth     = $this->app->erp->Firmendaten("breite_menge");
          $itemNoWidth = $this->app->erp->Firmendaten("breite_nummer");
          $einheitWidth    = $this->app->erp->Firmendaten("breite_einheit");
          $descWidth    = $this->app->erp->Firmendaten("breite_artikel");
          $taxWidth    = $this->app->erp->Firmendaten("breite_steuer");

          if($this->doctype=="arbeitsnachweis")
          {
            $itemNoWidth = 20;
            $taxWidth = 40;
            $descWidth   = 95;
          }
          else if($this->doctype!="lieferschein" && $this->doctype!="produktion" && $this->doctype!="preisanfrage") {
            if($descWidth <=0)
              $descWidth   = 76;

            if($taxWidth <=0)
              $taxWidth   = 15;
          }
          else
          {
            $itemNoWidth = 30;
            $descWidth   = 91;
            if($taxWidth <=0)
              $taxWidth   = 15;
          }
          $priceWidth = 20;
          $sumWidth   = 20;
          $rabattWidth   = 15;
          
        
          $schriftgroesse = $this->FontSizePt;
          $schriftgroesse_alt = $schriftgroesse;
          if($schriftgroesse == 0)$schriftgroesse = 4;
          if(!empty($data['Schriftgroesse']))
          {
            $schriftgroesse = $data['Schriftgroesse'];
            if($schriftgroesse == 0)$schriftgroesse = 4;
            $this->SetFontSize($schriftgroesse);
          }
          $fett = true;
          if(isset($data['Fett']))
          {
            if($data['Fett'] === false || $data['Fett'] === 'false')$fett = false;
            if($data['Fett'] === true || $data['Fett'] === 'true')$fett = true;
          }
          $unterstrichen = false;
          if(isset($data['Unterstrichen']))
          {
            $unterstrichen = $data['Unterstrichen'];
          }
          $this->underline = $unterstrichen;

          switch($zwischenpositionen[$i]['postype'])
          {
            case "gruppensumme":
              $maxpos_untergruppedrueber = $this->app->DB->Select("SELECT pos FROM beleg_zwischenpositionen WHERE doctype='".$this->doctype."' AND doctypeid='".$this->doctypeid."' AND pos < '$pos' AND postype='gruppe' ORDER by pos DESC LIMIT 1");

              if($this->doctype=="angebot")
              {
                $subwhere = " AND optional!=1";
              }
              $summe = number_format($this->app->DB->Select("SELECT SUM((preis-(preis/100*rabatt))*menge) FROM ".$this->doctype."_position WHERE ".$this->doctype."='".$this->doctypeid."' AND sort <='$pos' AND sort >'$maxpos_untergruppedrueber' $subwhere"),$this->anzahlkomma,',','.');
            break;
            default:
              //zwischensumme
              if($this->doctype=="angebot")
              {
                $subwhere = " AND optional!=1";
              }
              $summe = number_format($this->app->DB->Select("SELECT SUM((preis-(preis/100*rabatt))*menge) FROM ".$this->doctype."_position WHERE ".$this->doctype."='".$this->doctypeid."' AND sort <='$pos' $subwhere"),$this->anzahlkomma,',','.');
          }

          $beschriftung_zeile = ucfirst($zwischenpositionen[$i]['postype']);

          if($data['name']=="")
            $html = ($fett?"<b>":"").$beschriftung_zeile.($fett?"</b>":"");
          else
            $html = ($fett?"<b>":"").$data['name'].($fett?"</b>":"");
          if(!empty($data['Abstand_Oben']))
          {
            $this->Ln((int)$data['Abstand_Oben']);
          }else{
            $this->Ln(10);
          }
          $x = $this->GetX();
          
          if(isset($data['Abstand_Links']) && $data['Abstand_Links'] > 0)
          {
            $abstand_links = (int)$data['Abstand_Links'];
            $this->SetX($x+$abstand_links);
          }else{
            $abstand_links = $posWidth +$itemNoWidth;
          }
          
          $this->SetX($x+$abstand_links);
          $this->Cell($descWidth,4,$this->WriteHTML($html));
          $this->SetX($x+$abstand_links+$descWidth);
          //$this->SetX($x);
          
          $rahmen_links = false;
          $rahmen_rechts = false;
          $rahmen_oben = false;
          $rahmen_unten = false;
          if(isset($data['Rahmen_Links']))
          {
            $rahmen_links = $data['Rahmen_Links'];
          }
          if(isset($data['Rahmen_Rechts']))
          {
            $rahmen_rechts = $data['Rahmen_Rechts'];
          }
          if(isset($data['Rahmen_Oben']))
          {
            $rahmen_oben = $data['Rahmen_Oben'];
          }
          if(isset($data['Rahmen_Unten']))
          {
            $rahmen_unten = $data['Rahmen_Unten'];
          }
          $rahmen = '';
          if($rahmen_links)$rahmen .= 'L';
          if($rahmen_rechts)$rahmen .= 'R';
          if($rahmen_oben)$rahmen .= 'T';
          if($rahmen_unten)$rahmen .= 'B';
          $ausrichtung = 'R';
          if(isset($data['Text_Ausrichtung']))
          {
            $ausrichtung = $data['Text_Ausrichtung'];
          }
          $this->Cell($priceWidth+$amWidth+$taxWidth+$priceWidth,4,$summe,$rahmen,0,$ausrichtung);
          if(!empty($data['Abstand_Unten']))
          {
            $this->Ln((int)$data['Abstand_Unten']);
          }else{
            $this->Ln(10);
          }
          $this->SetFontSize($schriftgroesse_alt);
          $this->underline = false;
        break;
      }
    }
    return $ret;
  }


  /*
     totals (
     totalArticles   - Summe aller Artikelpreise
     modeOfDispatch   - Versandart
     priceOfDispatch  - Versandkosten
     modeOfPayment    - Zahlungsweise
     priceOfPayment  - Kosten der Zahlungsweise
     total           = totalArticles + priceOfDispatch + priceOfPayment
     totalTaxV      - Summe voller Steuersatz
     totalTaxR      - Summe reduzierter Steuersatz
     )
   */
  public function renderTotals() {

    $this->SetY($this->GetY()+1);

    $differenz_wegen_abstand = $this->app->erp->Firmendaten("abstand_gesamtsumme_lr");

    if($this->doctype!="lieferschein" && $this->doctype!="arbeitsnachweis" && $this->doctype!="preisanfrage") {
      //$this->Line(110, $this->GetY(), 190, $this->GetY());
      $this->Ln(1);
      $this->SetFont($this->GetFont(),'',$this->app->erp->Firmendaten("schriftgroesse_gesamt"));
      $this->Cell($differenz_wegen_abstand,2,'',0);
      if($this->app->erp->Firmendaten("kleinunternehmer")!="1" && $this->doctype!="zahlungsavis"){
        $this->Cell(30,5,$this->app->erp->Beschriftung("dokument_gesamtnetto"),0,0,'L');
        $this->Cell(40,5,number_format((double)$this->totals['totalArticles'], 2, ',', '.').' '.$this->waehrung,0,'L','R');
      } else {
        //kleinunzernehmer
        $this->Cell(30,5,'',0,0,'L');
        $this->Cell(40,5,'',0,'L','R');
      }
      $this->Ln();

      if(isset($this->totals['modeOfDispatch'])) $versand = 'Versand: '.$this->totals['modeOfDispatch'];
      else $versand = 'Versandkosten: ';
      if(isset($this->totals['priceOfDispatch'])) {
        $this->Cell($differenz_wegen_abstand,2,'',0);
        $this->Cell(30,5,$versand,0,'L','L');
        $this->Cell(40,5,number_format((double)$this->totals['priceOfDispatch'], 2, ',', '.').' '.$this->waehrung,0,'L','R');
      }
      //$this->Ln();

      if(isset($this->totals['priceOfPayment']) && $this->totals['priceOfPayment']!='0.00'){
        $this->Cell($differenz_wegen_abstand,2,'',0);
        $this->Cell(30,5,$this->totals['modeOfPayment'],0,'L','L');
        $this->Cell(40,5,number_format((double)$this->totals['priceOfPayment'], 2, ',', '.').' '.$this->waehrung,0,'L','R');
        $this->Ln();    
      }

      $this->SetY($this->GetY());
      $this->SetFont($this->GetFont(),'',$this->app->erp->Firmendaten("schriftgroesse_gesamt_steuer"));


      if(isset($this->totals['totalTaxV']) && $this->totals['totalTaxV']!="0.00"){
        $this->Cell($differenz_wegen_abstand,1,'',0);

        if($this->app->erp->Firmendaten("kleinunternehmer")!="1"){
          if(($this->anrede=="firma" || $this->app->erp->AnzeigeBelegNetto($this->anrede,$projekt) || $this->doctype=="bestellung" || $this->app->erp->Firmendaten("immernettorechnungen",$projekt)=="1") 
                 && $this->app->erp->Firmendaten("immerbruttorechnungen",$projekt)!="1")
          {
            $this->Cell(30,3,$this->app->erp->Beschriftung("dokument_zzglmwst").' '.$this->app->erp->GetSteuersatzNormal(false,$this->id,$this->table).' %',0,'L','L');
          }
          else {
            $this->Cell(30,3,$this->app->erp->Beschriftung("dokument_inklmwst").' '.$this->app->erp->GetSteuersatzNormal(false,$this->id,$this->table).' %',0,'L','L');
          }
          $this->Cell(40,3,number_format((double)$this->totals['totalTaxV'], 2, ',', '.').' '.$this->waehrung,0,'L','R');
        } else {
          //kleinunternehmer
          $this->Cell(30,3,'',0,'L','L');
          $this->Cell(40,3,'',0,'L','R');
        }
        $this->Ln();
      }

      if(isset($this->totals['totalTaxR']) && $this->totals['totalTaxR']!="0.00"){
        $this->Cell($differenz_wegen_abstand,1,'',0);

        if($this->app->erp->Firmendaten("kleinunternehmer")!="1"){
          if(($this->anrede=="firma" || $this->app->erp->AnzeigeBelegNetto($this->anrede,$projekt) || $this->doctype=="bestellung" || $this->app->erp->Firmendaten("immernettorechnungen",$projekt)=="1") 
                 && $this->app->erp->Firmendaten("immerbruttorechnungen",$projekt)!="1")
            {
              $this->Cell(30,3,$this->app->erp->Beschriftung("dokument_zzglmwst").' '.$this->app->erp->GetSteuersatzErmaessigt(false,$this->id,$this->table).' %',0,'L','L');
            }
          else {
            $this->Cell(30,3,$this->app->erp->Beschriftung("dokument_inklmwst").' '.$this->app->erp->GetSteuersatzErmaessigt(false,$this->id,$this->table).' %',0,'L','L');
            }

          $this->Cell(40,3,number_format((double)$this->totals['totalTaxR'], 2, ',', '.').' '.$this->waehrung,0,'L','R');
        } else {
          //kleinunternehmer
          $this->Cell(30,3,'',0,'L','L');
          $this->Cell(40,3,"",0,'L','R');
        }

        $this->Ln();
      }
      
      if(isset($this->totals['summen']))
      {
        ksort($this->totals['summen'], SORT_NUMERIC);
        foreach($this->totals['summen'] as $k => $value)
        {
          $this->Cell($differenz_wegen_abstand,1,'',0);

          if($this->app->erp->Firmendaten("kleinunternehmer")!="1"){
            if(($this->anrede=="firma" || $this->app->erp->AnzeigeBelegNetto($this->anrede,$projekt) || $this->doctype=="bestellung" || $this->app->erp->Firmendaten("immernettorechnungen",$projekt)=="1") 
                   && $this->app->erp->Firmendaten("immerbruttorechnungen",$projekt)!="1")
            {
              $this->Cell(30,3,$this->app->erp->Beschriftung("dokument_zzglmwst").' '.$k.' %',0,'L','L');
            }else {
              $this->Cell(30,3,$this->app->erp->Beschriftung("dokument_inklmwst").' '.$k.' %',0,'L','L');
            }

            $this->Cell(40,3,number_format($value, 2, ',', '.').' '.$this->waehrung,0,'L','R');
          } else {
            //kleinunternehmer
            $this->Cell(30,3,'',0,'L','L');
            $this->Cell(40,3,"",0,'L','R');
          }

          $this->Ln();
          
        }
        
      }

      if(!isset($this->totals['totalTaxR']) && !isset($this->totals['totalTaxV']) && !isset($this->totals['summen']) && $this->doctype!="zahlungsavis")
      {
        $this->Cell($differenz_wegen_abstand,3,'',0);

        if($this->app->erp->Firmendaten("kleinunternehmer")!="1")
        {
          if(($this->anrede=="firma" || $this->app->erp->AnzeigeBelegNetto($this->anrede,$projekt) || $this->doctype=="bestellung" || $this->app->erp->Firmendaten("immernettorechnungen",$projekt)=="1") 
                 && $this->app->erp->Firmendaten("immerbruttorechnungen",$projekt)!="1")
            {
              $this->Cell(30,3,$this->app->erp->Beschriftung("dokument_zzglmwst").' 0.00 %',0,'L','L');
            }
          else {
            $this->Cell(30,3,$this->app->erp->Beschriftung("dokument_inklmwst").' 0.00 %',0,'L','L');
          }

          $this->Cell(40,3,'0,00 '.$this->waehrung,0,'L','R');
        } else {
          //kleinunternehmer
          $this->Cell(30,3,'',0,'L','L');
          $this->Cell(40,3,'',0,'L','R');
        }
        $this->Ln();
      }
      $this->SetY($this->GetY()+2);
      //$this->Line(110, $this->GetY(), 190,$this->GetY());
    } 

    $this->SetFont($this->GetFont(),'B',$this->app->erp->Firmendaten("schriftgroesse_gesamt"));
    $this->Cell($differenz_wegen_abstand,5,'',0);
    if($this->doctype=="offer")
      $this->Cell(30,5,$this->app->erp->Beschriftung("dokument_gesamt_total"),0,'L','L');
    elseif($this->doctype=="creditnote")
      $this->Cell(30,5,$this->app->erp->Beschriftung("dokument_gesamt_total"),0,'L','L');
    else if($this->doctype=="arbeitsnachweis")
      $this->Cell(30,5,$this->app->erp->Beschriftung("dokument_gesamt_total"),0,'L','L');
    else if($this->doctype=="zahlungsavis")
      $this->Cell(30,5,$this->app->erp->Beschriftung("dokument_gesamt_total"),0,'L','L');
    else 
      $this->Cell(30,5,$this->app->erp->Beschriftung("dokument_gesamt_total"),0,'L','L');

    if($this->doctype=="arbeitsnachweis")
      $this->Cell(40,5,$this->totals['total'].' ',0,'L','R');
    else {
      if($this->app->erp->Firmendaten("kleinunternehmer")!="1")
        $this->Cell(40,5,number_format((double)$this->totals['total'], 2, ',', '.').' '.$this->waehrung,0,'L','R');
      else
        $this->Cell(40,5,number_format((double)$this->totals['totalArticles'], 2, ',', '.').' '.$this->waehrung,0,'L','R');
    }

    $this->Ln();
    if($this->app->erp->Firmendaten("briefpapier_ohnedoppelstrich")!="1")
    {
      $this->Line($differenz_wegen_abstand+5, $this->GetY(), 210-$this->app->erp->Firmendaten("abstand_seitenrandrechts"),$this->GetY());   
      $this->Line($differenz_wegen_abstand+5, $this->GetY()+1, 210-$this->app->erp->Firmendaten("abstand_seitenrandrechts"),$this->GetY()+1);
    }

    $this->SetY($this->GetY()+10);
  }

}
?>
