<?php
/*
**** COPYRIGHT & LICENSE NOTICE *** DO NOT REMOVE ****
* 
* WaWision (c) embedded projects GmbH, Holzbachstrasse 4, D-86154 Augsburg, * Germany 2015 
*
* This file is licensed under the Embedded Projects General Public License *Version 3.1. 
*
* You should have received a copy of this license from your vendor and/or *along with this file; If not, please visit www.wawision.de/Lizenzhinweis 
* to obtain the text of the corresponding license version.  
*
**** END OF COPYRIGHT & LICENSE NOTICE *** DO NOT REMOVE ****
*/
?>
<?php

include_once "class.superfpdf.php";

class EtikettenPDF extends SuperFPDF {

  function __construct(&$app,$projekt="") {
    $this->app=&$app;
    $this->page_definded=false;
  }

  function SetXML($xml)
  {
    if(empty($xml))return;
    $label = new SimpleXMLElement($xml);


    foreach($label as $key=>$items)
    {
      switch($key)
      {
        case "settings":
          if(!$this->page_definded)
          {
            parent::__construct('P','mm',array(trim($items->attributes()->width),trim($items->attributes()->height)));
            $this->page_definded = true;
          }

          $this->SetAutoPageBreak(false);
          $this->SetFont('Arial','B',4);
          $this->SetLeftMargin(0);
          $this->SetMargins(0,0,0);
          $this->AddPage();
          break;

        case "line":
          $this->SetXY(trim($items->attributes()->x),$items->attributes()->y,$items[0]); 
          $this->SetFont('Arial','',$items->attributes()->size*2);
          $this->MultiCell(0,$items->attributes()->size,$items[0],0,'L');
          break;
  
        case "image":
          $type = exif_imagetype ( trim($items[0]) );

          switch($type)
          {
            case IMAGETYPE_GIF: $type="gif"; break;
            case IMAGETYPE_JPEG: $type="jpg"; break;
            case IMAGETYPE_PNG: $type="png"; break;
            default: $type="";
          }
          if($type!="")
          {
            $this->Image(trim($items[0]),trim($items->attributes()->x),trim($items->attributes()->y),trim($items->attributes()->width),trim($items->attributes()->height),$type);
          } 
          break; 

        case "barcode":
          if((String)($items->attributes()->type)=="E30") {
            $this->EAN13($items->attributes()->x,$items->attributes()->y, $items[0],$items->attributes()->size);
          }
          else if((String)($items->attributes()->type)=="Code128" || (String)($items->attributes()->type)=="1") {
            $this->Code128($items->attributes()->x, $items->attributes()->y, $items[0], $items->attributes()->width, $items->attributes()->size);
          }
          else { // standard auf 2 bzw default
            $this->Code39($items->attributes()->x,$items->attributes()->y, $items[0], 0.5, $items->attributes()->size);//, $printText=false)
          }

          break;
        case "qrcode":
          if(file_exists(dirname(__FILE__).'/../barcode/barcode.php'))
          {
            include_once(dirname(__FILE__).'/../barcode/barcode.php');
            $generator = new barcode_generator();
            $type = 'jpg';
            $symbology = 'qrh';
            $options['sf'] = 4;
            $filename = rtrim($this->app->erp->GetTMP(),'/').'/'.md5(microtime(true).$items[0]).'.jpg';
            $image = $generator->render_image($symbology, isset($items->attributes()->base64)?base64_decode($items[0]):$items[0], $options);
            $imagetmp = imagejpeg($image, $filename,100);
            unset($generator);
            unset($image);
            $this->Image(trim($filename),trim($items->attributes()->x),trim($items->attributes()->y),trim(isset($items->attributes()->width)?$items->attributes()->width:$items->attributes()->size),trim(isset($items->attributes()->height)?$items->attributes()->height:$items->attributes()->size),$type);
            unlink($filename);
          }
        break;
      }
    }



  }


}
?>
