<?php
/*
**** COPYRIGHT & LICENSE NOTICE *** DO NOT REMOVE ****
* 
* WaWision (c) embedded projects GmbH, Holzbachstrasse 4, D-86154 Augsburg, * Germany 2015 
*
* This file is licensed under the Embedded Projects General Public License *Version 3.1. 
*
* You should have received a copy of this license from your vendor and/or *along with this file; If not, please visit www.wawision.de/Lizenzhinweis 
* to obtain the text of the corresponding license version.  
*
**** END OF COPYRIGHT & LICENSE NOTICE *** DO NOT REMOVE ****
*/
?>
<?php
if(!class_exists('BriefpapierCustom'))
{
  class BriefpapierCustom extends Briefpapier
  {
    
  }
}

class LieferscheinPDF extends BriefpapierCustom {
  public $doctype;

  function __construct($app,$projekt="")
  {
    $this->app=&$app;
    //parent::Briefpapier();
    $this->doctype="lieferschein";
    $this->doctypeOrig="Lieferschein";
    parent::__construct($this->app,$projekt);
  } 


  function GetLieferschein($id,$info="",$extrafreitext="")
  {
    $this->doctypeid = $id;
    if(method_exists($this->app->erp,'LieferscheinSeriennummernberechnen'))$this->app->erp->LieferscheinSeriennummernberechnen($id);
    $briefpapier_bearbeiter_ausblenden = $this->app->erp->Firmendaten('briefpapier_bearbeiter_ausblenden');
    $briefpapier_vertrieb_ausblenden = $this->app->erp->Firmendaten('briefpapier_vertrieb_ausblenden');
    $adresse = $this->app->DB->Select("SELECT adresse FROM lieferschein WHERE id='$id' LIMIT 1");

    // das muss vom lieferschein sein!!!!
    $this->setRecipientLieferadresse($id,"lieferschein");


    // OfferNo, customerId, OfferDate
    $kundennummer = $this->app->DB->Select("SELECT kundennummer FROM lieferschein WHERE id='$id' LIMIT 1");
    if(empty($kundennummer))$kundennummer = $this->app->DB->Select("SELECT kundennummer FROM adresse WHERE id='$adresse' LIMIT 1");
    $sprache = $this->app->DB->Select("SELECT sprache FROM lieferschein WHERE id='$id' LIMIT 1");
    if(empty($sprache))$sprache = $this->app->DB->Select("SELECT sprache FROM adresse WHERE id='$adresse' LIMIT 1");
    $this->sprache = $sprache;
    $this->app->erp->BeschriftungSprache($sprache);
    $auftrag = $this->app->DB->Select("SELECT auftragid FROM lieferschein WHERE id='$id' LIMIT 1");
    $auftrag = $this->app->DB->Select("SELECT belegnr FROM auftrag WHERE id='$auftrag' LIMIT 1");
    $bearbeiter = $this->app->DB->Select("SELECT bearbeiter FROM lieferschein WHERE id='$id' LIMIT 1");
    $bearbeiter = $this->app->erp->ReadyForPDF($bearbeiter);
    $vertrieb = $this->app->DB->Select("SELECT vertrieb FROM lieferschein WHERE id='$id' LIMIT 1");
    $vertrieb = $this->app->erp->ReadyForPDF($vertrieb);
    $bestellbestaetigung = $this->app->DB->Select("SELECT bestellbestaetigung FROM lieferschein WHERE id='$id' LIMIT 1");
    $datum = $this->app->DB->Select("SELECT DATE_FORMAT(datum,'%d.%m.%Y') FROM lieferschein WHERE id='$id' LIMIT 1");
    $belegnr = $this->app->DB->Select("SELECT belegnr FROM lieferschein WHERE id='$id' LIMIT 1");
    $land = $this->app->DB->Select("SELECT land FROM lieferschein WHERE id='$id' LIMIT 1");
    $versandart = $this->app->DB->Select("SELECT versandart FROM lieferschein WHERE id='$id' LIMIT 1");
    $freitext = $this->app->DB->Select("SELECT freitext FROM lieferschein WHERE id='$id' LIMIT 1");
    $this->projekt = $this->app->DB->Select("SELECT projekt FROM lieferschein WHERE id='$id' LIMIT 1");
    $bodyzusatz = $this->app->DB->Select("SELECT bodyzusatz FROM lieferschein WHERE id='$id' LIMIT 1");

    $ohne_briefpapier = $this->app->DB->Select("SELECT ohne_briefpapier FROM lieferschein WHERE id='$id' LIMIT 1");
    $ihrebestellnummer = $this->app->DB->Select("SELECT ihrebestellnummer FROM lieferschein WHERE id='$id' LIMIT 1");
    $ihrebestellnummer = $this->app->erp->ReadyForPDF($ihrebestellnummer);


    $trackingnummer = $this->app->DB->Select("SELECT tracking FROM versand WHERE lieferschein='$id' LIMIT 1");


    if($ohne_briefpapier=="1")
    {
      $this->logofile = "";
      $this->briefpapier="";
      $this->briefpapier2="";
    }

    //$this->doctype="deliveryreceipt";

    if($belegnr=="" || $belegnr=="0") $belegnr = "- ".$this->app->erp->Beschriftung("dokument_entwurf");

    $this->zusatzfooter = " (LS$belegnr)";

    if($info=="")
      $this->doctypeOrig=$this->app->erp->Beschriftung("dokument_lieferschein")." $belegnr";
    else if($info=="kommissionierschein")
      $this->doctypeOrig=$this->app->erp->Beschriftung("dokument_kommissionierschein")." $belegnr";
    else
      $this->doctypeOrig=$this->app->erp->Beschriftung("dokument_lieferschein").$info." $belegnr";

    if($lieferschein=="") $lieferschein = "-";
    if($kundennummer=="") $kundennummer= "-";

    if($bearbeiter==$vertrieb) $vertrieb="";

    //$this->setCorrDetails(array($this->app->erp->Beschriftung("dokument_auftrag")=>$auftrag,"Ihre Kunden-Nr."=>$kundennummer,"Versand"=>$datum,"Versand"=>$bearbeiter));
    if($briefpapier_bearbeiter_ausblenden || $briefpapier_vertrieb_ausblenden)
    {
      $sCD = array($this->app->erp->Beschriftung("dokument_auftrag")=>$auftrag,$this->app->erp->Beschriftung("bezeichnungkundennummer")=>$kundennummer,$this->app->erp->Beschriftung("auftrag_bezeichnung_bestellnummer")=>$ihrebestellnummer,$this->app->erp->Beschriftung("dokument_lieferdatum")=>$datum);
      if(!$briefpapier_bearbeiter_ausblenden)
      {
        if($bearbeiter)$sCD[$this->app->erp->Beschriftung("auftrag_bezeichnung_bearbeiter")] = $bearbeiter;
      }elseif(!$briefpapier_vertrieb_ausblenden)
      {
        if($vertrieb)$sCD[$this->app->erp->Beschriftung("auftrag_bezeichnung_vertrieb")] = $vertrieb;
      }
      $this->setCorrDetails($sCD);
      //$this->setCorrDetails(array($this->app->erp->Beschriftung("dokument_auftrag")=>$auftrag,$this->app->erp->Beschriftung("bezeichnungkundennummer")=>$kundennummer,$this->app->erp->Beschriftung("auftrag_bezeichnung_bestellnummer")=>$ihrebestellnummer,$this->app->erp->Beschriftung("dokument_lieferdatum")=>$datum));
    }else{
      $this->setCorrDetails(array($this->app->erp->Beschriftung("dokument_auftrag")=>$auftrag,$this->app->erp->Beschriftung("bezeichnungkundennummer")=>$kundennummer,$this->app->erp->Beschriftung("auftrag_bezeichnung_bestellnummer")=>$ihrebestellnummer,$this->app->erp->Beschriftung("dokument_lieferdatum")=>$datum,$this->app->erp->Beschriftung("auftrag_bezeichnung_bearbeiter")=>$bearbeiter,$this->app->erp->Beschriftung("auftrag_bezeichnung_vertrieb")=>$vertrieb));
    }


    $body=$this->app->erp->Beschriftung("lieferschein_header");
    if($bodyzusatz!="") $body=$body."\r\n".$bodyzusatz;
    $body = $this->app->erp->ParseUserVars("lieferschein",$id,$body);


    if ($versandart!="" && $trackingnummer!=""){
        $versandinfo = "$versandart: $trackingnummer\r\n";
    }else{ $versandinfo ="";}



     if($this->app->erp->Firmendaten("footer_reihenfolge_lieferschein_aktivieren")=="1")      {
        $footervorlage = $this->app->erp->Firmendaten("footer_reihenfolge_lieferschein");
        if($footervorlage=="")
          $footervorlage = "{FOOTERVERSANDINFO}{FOOTERFREITEXT}{FOOTEREXTRAFREITEXT}\r\n{FOOTERTEXTVORLAGELIEFERSCHEIN}";
        $footervorlage = str_replace('{FOOTERVERSANDINFO}',$versandinfo,$footervorlage);
        $footervorlage = str_replace('{FOOTERFREITEXT}',$freitext,$footervorlage);
        $footervorlage = str_replace('{FOOTEREXTRAFREITEXT}',$extrafreitext,$footervorlage);
        $footervorlage = str_replace('{FOOTERTEXTVORLAGELIEFERSCHEIN}',$this->app->erp->Beschriftung("lieferschein_footer"),$footervorlage);
        $footervorlage  = $this->app->erp->ParseUserVars("lieferschein",$id,$footervorlage);
        $footer = $footervorlage;
      } else {
        $footer = $versandinfo."$freitext\r\n$extrafreitext\r\n".$this->app->erp->ParseUserVars("lieferschein",$id,$this->app->erp->Beschriftung("lieferschein_footer"));
      }



    $this->setTextDetails(array(
          "body"=>$body,
          "footer"=>$footer));

    $artikel = $this->app->DB->SelectArr("SELECT * FROM lieferschein_position WHERE lieferschein='$id' ORDER By sort");

    //$waehrung = $this->app->DB->Select("SELECT waehrung FROM lieferschein_position WHERE lieferschein='$id' LIMIT 1");
    foreach($artikel as $key=>$value)
    {
      $snummer = '';
      $seriennummernliste="";
 /* 
      if($value['seriennummer']!="")
      {
        //if( $value['beschreibung']!="")  $value['beschreibung'] =  $value['beschreibung']."\n";
        //$value['beschreibung'] = $this->app->erp->Beschriftung("dokument_seriennummer").": ".$value['seriennummer']."\n\n";
        $snummer = $value['seriennummer'];
      }
      
      if(!empty($seriennummern) && count($seriennummern) > 0)
      {
        $tmpseriennummer = null;
        if(!empty($value['seriennummer']))
        {
          $_tmpseriennummer = explode(' ',$value['seriennummer']);
          foreach($_tmpseriennummer as $ks => $vs)
          {
            if(trim($vs,',;'))$tmpseriennummer[] = trim($vs,',;');
          }
        }
        foreach($seriennummern as $seriennummern=>$seriennummer)
        {
          if($seriennummer['artikel'] == $value['artikel'])
          {
            if(!$tmpseriennummer || !in_array(trim($seriennummer['seriennummer']),$tmpseriennummer))$seriennummernliste = $seriennummernliste.$seriennummer['seriennummer'].";";
          }
        }

        $seriennummernliste=substr($seriennummernliste, 0, -1);

        $value['seriennummern'] = $this->app->DB->Select("SELECT seriennummern FROM artikel WHERE id='".$value['artikel']."' LIMIT 1");

        if ($value['seriennummern']=="keine"){
          $value['beschreibung'] = $value['beschreibung'];
        }elseif ($value['seriennummern']==""){
          $value['beschreibung'] = $value['beschreibung'];
        }else{
          if(!empty($seriennummernliste))
          {
            //$value['beschreibung'] = $value['beschreibung']."\r\n".$this->app->erp->Beschriftung("dokument_seriennummer").": ". $seriennummernliste;
            if($snummer != '')$snummer .= ' ';
            $snummer .= $seriennummernliste;
          }
        }
      }
      
      if($snummer)
      {
        $value['beschreibung'] = $value['beschreibung']."\r\n".$this->app->erp->Beschriftung("dokument_seriennummer").": ".$snummer;
      }
*/
      $value['herstellernummer'] = $this->app->DB->Select("SELECT herstellernummer FROM artikel WHERE id='".$value['artikel']."' LIMIT 1");
      $value['hersteller'] = $this->app->DB->Select("SELECT hersteller FROM artikel WHERE id='".$value['artikel']."' LIMIT 1");

      if($value['explodiert_parent_artikel'] > 0)
      {
        $check_ausblenden = $this->app->DB->Select("SELECT keineeinzelartikelanzeigen FROM artikel WHERE id='".$value['explodiert_parent_artikel']."' LIMIT 1");
      } else $check_ausblenden=0;
/*
      if($ust_befreit==2 && $value['zolltarifnummer']!="")
      {
        $value[beschreibung] = $value[beschreibung]."\r\nCustoms tariff number: ".$value['zolltarifnummer'];
      }
*/


/*
      if(!empty($chargen))
      {
        foreach($chargen as $chargen=>$charge)
        {
          $chargenliste = $chargenliste.$charge['charge'].";";
        }

        $chargenliste=substr($chargenliste, 0, -1);

        $value['chargen'] = $this->app->DB->Select("SELECT chargenverwaltung FROM artikel WHERE id='".$value[artikel]."' LIMIT 1");

        if ($value['chargen']=="0"){
          $value['beschreibung'] = $value['beschreibung'];
        }else{
          $value['beschreibung'] = $value['beschreibung']."\r\n".$this->app->erp->Beschriftung("dokument_charge").": ". $chargenliste;
        }
      }
*/



      if(!$this->app->erp->Export($land))
      {
        $value['zolltarifnummer']="";
        $value['herkunftsland']="";
      }


      $value['menge'] = floatval($value['menge']);

      if($check_ausblenden!=1)
      {
        $this->addItem(array('amount'=>$value['menge'],
              'itemno'=>$value['nummer'],
              'artikel'=>$value['artikel'],
              'desc'=>ltrim($value['beschreibung']),
              'unit'=>$value['einheit'],
              'hersteller'=>$value['hersteller'],
              'artikelnummerkunde'=>$value['artikelnummerkunde'],
              'lieferdatum'=>$value['lieferdatum'],
              'lieferdatumkw'=>$value['lieferdatumkw'],
              'zolltarifnummer'=>$value['zolltarifnummer'],
              'herkunftsland'=>$value['herkunftsland'],
              'herstellernummer'=>trim($value['herstellernummer']),
              'freifeld1'=>$value['freifeld1'],
              'freifeld2'=>$value['freifeld2'],
              'freifeld3'=>$value['freifeld3'],
              'freifeld4'=>$value['freifeld4'],
              'freifeld5'=>$value['freifeld5'],
              'freifeld6'=>$value['freifeld6'],
              'freifeld7'=>$value['freifeld7'],
              'freifeld8'=>$value['freifeld8'],
              'freifeld9'=>$value['freifeld9'],
              'freifeld10'=>$value['freifeld10'],
              'freifeld11'=>$value['freifeld11'],
              'freifeld12'=>$value['freifeld12'],
              'freifeld13'=>$value['freifeld13'],
              'freifeld14'=>$value['freifeld14'],
              'freifeld15'=>$value['freifeld15'],
              'freifeld16'=>$value['freifeld16'],
              'freifeld17'=>$value['freifeld17'],
              'freifeld18'=>$value['freifeld18'],
              'freifeld19'=>$value['freifeld19'],
              'freifeld20'=>$value['freifeld20'],
              "name"=>$value['bezeichnung']));
      }
    }


    /* Dateiname */
    $datum = $this->app->DB->Select("SELECT DATE_FORMAT(datum,'%Y%m%d') FROM lieferschein WHERE id='$id' LIMIT 1");
    $belegnr= $this->app->DB->Select("SELECT belegnr FROM lieferschein WHERE id='$id' LIMIT 1");
    $tmp_name = str_replace(' ','',trim($this->recipient['enterprise']));
    $tmp_name = str_replace('.','',$tmp_name);

    $this->filename = $datum."_LS".$belegnr.".pdf";
    $this->setBarcode($belegnr);
  }


}
?>
