<?php
/*
**** COPYRIGHT & LICENSE NOTICE *** DO NOT REMOVE ****
* 
* WaWision (c) embedded projects GmbH, Holzbachstrasse 4, D-86154 Augsburg, * Germany 2015 
*
* This file is licensed under the Embedded Projects General Public License *Version 3.1. 
*
* You should have received a copy of this license from your vendor and/or *along with this file; If not, please visit www.wawision.de/Lizenzhinweis 
* to obtain the text of the corresponding license version.  
*
**** END OF COPYRIGHT & LICENSE NOTICE *** DO NOT REMOVE ****
*/
?>
<?php


class PreisanfragePDF extends Briefpapier {
  public $doctype;

  function __construct($app,$projekt="")
  {
    $this->app=&$app;
    //parent::Briefpapier();
    $this->doctype="preisanfrage";
    $this->doctypeOrig="Preisanfrage";
    parent::__construct($this->app,$projekt);
  } 


  function GetPreisanfrage($id,$info="",$extrafreitext="")
  {
    $adresse = $this->app->DB->Select("SELECT adresse FROM preisanfrage WHERE id='$id' LIMIT 1");

    // das muss vom preisanfrage sein!!!!
    $this->setRecipientLieferadresse($id,"preisanfrage");


    // OfferNo, customerId, OfferDate
    $lieferantennummer = $this->app->DB->Select("SELECT lieferantennummer FROM adresse WHERE id='$adresse' LIMIT 1");
    $bearbeiter = $this->app->DB->Select("SELECT bearbeiter FROM preisanfrage WHERE id='$id' LIMIT 1");
    $bestellbestaetigung = $this->app->DB->Select("SELECT bestellbestaetigung FROM preisanfrage WHERE id='$id' LIMIT 1");
    $datum = $this->app->DB->Select("SELECT DATE_FORMAT(datum,'%d.%m.%Y') FROM preisanfrage WHERE id='$id' LIMIT 1");
    $belegnr = $this->app->DB->Select("SELECT belegnr FROM preisanfrage WHERE id='$id' LIMIT 1");
    $freitext = $this->app->DB->Select("SELECT freitext FROM preisanfrage WHERE id='$id' LIMIT 1");
    $this->projekt = $this->app->DB->Select("SELECT projekt FROM preisanfrage WHERE id='$id' LIMIT 1");
    $bodyzusatz = $this->app->DB->Select("SELECT bodyzusatz FROM preisanfrage WHERE id='$id' LIMIT 1");

    //$ohne_briefpapier = $this->app->DB->Select("SELECT ohne_briefpapier FROM preisanfrage WHERE id='$id' LIMIT 1");
    $ihrebestellnummer = $this->app->DB->Select("SELECT ihrebestellnummer FROM preisanfrage WHERE id='$id' LIMIT 1");
    $ihrebestellnummer = $this->app->erp->ReadyForPDF($ihrebestellnummer);


    if($ohne_briefpapier=="1")
    {
      $this->logofile = "";
      $this->briefpapier="";
    }

    $this->doctype="preisanfrage";

    if($belegnr<=0) $belegnr = "- Entwurf";


    if($info=="")
      $this->doctypeOrig="Preisanfrage $belegnr";
    else
      $this->doctypeOrig="Preisanfrage$info $belegnr";

    if($preisanfrage=="") $preisanfrage = "-";
    if($lieferantennummer=="") $lieferantennummer= "-";

    if(empty($kundennummer))$kundennummer = $this->app->DB->Select("SELECT kundennummerlieferant FROM adresse WHERE id='$adresse' LIMIT 1");
    $kundennummer = $this->app->erp->ReadyForPDF($kundennummer);

    $this->setCorrDetails(array(
      $this->app->erp->Beschriftung("dokument_bestellung_unserekundennummer")=>$kundennummer,
      $this->app->erp->Beschriftung("dokument_datum")=>$datum));




    $body=$this->app->erp->Firmendaten("preisanfrage_header");
    if($bodyzusatz!="") $body=$body."\r\n".$bodyzusatz;
    $body = $this->app->erp->ParseUserVars("preisanfrage",$id,$body);

    $this->setTextDetails(array(
          "body"=>$body,
          "footer"=>"$freitext\r\n$extrafreitext\r\n".$this->app->erp->ParseUserVars("preisanfrage",$id,$this->app->erp->Firmendaten("preisanfrage_footer"))));

    $artikel = $this->app->DB->SelectArr("SELECT * FROM preisanfrage_position WHERE preisanfrage='$id' ORDER By sort");

    //$waehrung = $this->app->DB->Select("SELECT waehrung FROM preisanfrage_position WHERE preisanfrage='$id' LIMIT 1");
    foreach($artikel as $key=>$value)
    {

      if($value[seriennummer]!="")
      {
        if( $value[beschreibung]!="")  $value[beschreibung] =  $value[beschreibung]."\n";
        $value[beschreibung] = "SN: ".$value[seriennummer]."\n\n";
      }

      $value['herstellernummer'] = $this->app->DB->Select("SELECT herstellernummer FROM artikel WHERE id='".$value[artikel]."' LIMIT 1");
      $value['hersteller'] = $this->app->DB->Select("SELECT hersteller FROM artikel WHERE id='".$value[artikel]."' LIMIT 1");

      $value['menge'] = floatval($value['menge']);
      $this->addItem(array('amount'=>$value[menge],
            'itemno'=>$value[nummer],
            'artikel'=>$value['artikel'],
            'desc'=>ltrim($value[beschreibung]),
            'unit'=>$value[einheit],
            'hersteller'=>$value[hersteller],
            'herstellernummer'=>trim($value[herstellernummer]),
              'freifeld1'=>$value['freifeld1'],
              'freifeld2'=>$value['freifeld2'],
              'freifeld3'=>$value['freifeld3'],
              'freifeld4'=>$value['freifeld4'],
              'freifeld5'=>$value['freifeld5'],
              'freifeld6'=>$value['freifeld6'],
              'freifeld7'=>$value['freifeld7'],
              'freifeld8'=>$value['freifeld8'],
              'freifeld9'=>$value['freifeld9'],
              'freifeld10'=>$value['freifeld10'],
              'freifeld11'=>$value['freifeld11'],
              'freifeld12'=>$value['freifeld12'],
              'freifeld13'=>$value['freifeld13'],
              'freifeld14'=>$value['freifeld14'],
              'freifeld15'=>$value['freifeld15'],
              'freifeld16'=>$value['freifeld16'],
              'freifeld17'=>$value['freifeld17'],
              'freifeld18'=>$value['freifeld18'],
              'freifeld19'=>$value['freifeld19'],
              'freifeld20'=>$value['freifeld20'],
            "name"=>$value[bezeichnung]));
    }


    /* Dateiname */
    $datum = $this->app->DB->Select("SELECT DATE_FORMAT(datum,'%Y%m%d') FROM preisanfrage WHERE id='$id' LIMIT 1");
    $belegnr= $this->app->DB->Select("SELECT belegnr FROM preisanfrage WHERE id='$id' LIMIT 1");
    $tmp_name = str_replace(' ','',trim($this->recipient['enterprise']));
    $tmp_name = str_replace('.','',$tmp_name);

    $this->filename = $datum."_AF".$belegnr.".pdf";
    $this->setBarcode($belegnr);
  }


}
?>
