<?php
require_once(dirname(__FILE__).'/../class.versanddienstleister.php');

//require 'shipcloudapi/shipcloud-php/vendor/autoload.php';

class Versandart_shipcloud extends Versanddienstleister{

  private $einstellungen;

  private $info;


  private $credentials;

  public $paketmarke_drucker;
  public $export_drucker;

  public $errors;

  /**
   * Constructor for Shipment SDK
   * 
   * @param type $api_einstellungen
   * @param type $customer_info
   */

  function __construct(&$app, $id) {
    $this->id = $id;
    $this->app = &$app;

    $einstellungen_json = $this->app->DB->Select("SELECT einstellungen_json FROM versandarten WHERE id = '$id' LIMIT 1");
    $this->paketmarke_drucker = $this->app->DB->Select("SELECT paketmarke_drucker FROM versandarten WHERE id = '$id' LIMIT 1");
    $this->export_drucker = $this->app->DB->Select("SELECT export_drucker FROM versandarten WHERE id = '$id' LIMIT 1");
    if($einstellungen_json)
    {
      $this->einstellungen = json_decode($einstellungen_json,true);
    }else{
      $this->einstellungen = array();
    } 

    $this->credentials = $this->einstellungen;
    $this->errors = array();
    $data = $this->einstellungen;
    $this->info = $this->einstellungen;

    $this->apiKey = $this->einstellungen['apikey'];
  }

  public function VersandartMindestgewicht()
  {
    if(empty($this->einstellungen['mindestgewicht']))return 2;
    if($this->einstellungen['mindestgewicht'] === '')return 2;
    return str_replace(',','.',$this->einstellungen['mindestgewicht']);
  }
  
  function ShowUserdata()
  {
    if(isset($this->app->Conf->WFuserdata))return 'Userdata-Ordner: '.$this->app->Conf->WFuserdata;
    return;
  }

  public function Einstellungen($target = 'return')
  {

    parent::Einstellungen($target);
  }

  //TODO ....

  function Trackinglink($tracking, &$notsend, &$link, &$rawlink){
    $shipment = $this->shipcloud->shipments()->find($tracking);
    $link = json_decode($shipment);
    $link = $link['tracking_url'];
    return $shipment; 
  }

  public function GetBezeichnung()
  {
    return 'Shipcloud';
  }

  function EinstellungenStruktur()
  {
    return array(

        'apikey' => array('typ' => 'text', 'bezeichnung' => 'API Key'),
        'stdheight' => array('typ' => 'text', 'bezeichnung' => 'Standardhöhe (in cm)'),
        'stdwidth' => array('typ' => 'text', 'bezeichnung' => 'Standardbreite (in cm)'),
        'stdlength' => array('typ' => 'text', 'bezeichnung' => 'Standardlänge (in cm)'),
        'versandfirma' => array('typ' => 'text', 'bezeichnung' => 'Versandfirma','info'=>'DHL,DPD,Hermes,Fedex,UPS,GLS (Eine Option kann man als Vorauswahl hier eingeben)'),
        'mindestgewicht'=>array('typ'=>'text','bezeichnung'=>'Mindestgewicht:')
        );

  }


  public function Paketmarke($doctyp, $docid, $target = '', $error = false)
  {
    $id = $docid;
    $drucken = $this->app->Secure->GetPOST("drucken");
    $anders = $this->app->Secure->GetPOST("anders");
    $tracking_again = $this->app->Secure->GetGET("tracking_again");

   if($anders!="")
    {

    }
    else  if(($drucken!="" || $tracking_again=="1") && !$error )
    {

    //if($drucken != "" || $tracking_again == "1"){

      if($tracking_again != "1"){

        $module = $this->app->Secure->GetGET("module");
        //TODO Workarrond fuer lieferschein
        if($module=="lieferschein")
        {
          $lieferschein = $id;
        }
        else {
          $lieferschein = $this->app->DB->Select("SELECT lieferschein FROM versand WHERE id='$id' LIMIT 1");
          if($lieferschein <=0) $lieferschein=$id;
        }


        $Query = $this->app->DB->SelectArr("SELECT * FROM lieferschein where id='$lieferschein'");
        if($Query)$Query = reset($Query);
        $projekt = $Query['projekt'];
        $Adresse = $this->app->DB->SelectArr("SELECT * FROM adresse WHERE id='" . $Query['adresse'] . "' LIMIT 1");
        if($Adresse)$Adresse = reset($Adresse);
        $auftragbelegnr = $this->app->DB->Select("SELECT belegnr FROM auftrag WHERE id = '".$Query["auftragid"]."' LIMIT 1");
        if($auftragbelegnr=="") $auftragbelegnr = $Query["belegnr"];
        $lieferscheinbelegnr = $this->app->DB->Select("SELECT belegnr FROM lieferschein where id='$lieferschein'");


        $Country = $this->app->Secure->GetPOST('land');
        $versandmit= $this->app->Secure->GetPOST("versandmit");
        $trackingsubmit= $this->app->Secure->GetPOST("trackingsubmit");
        $versandmitbutton = $this->app->Secure->GetPOST("versandmitbutton");
        $tracking= $this->app->Secure->GetPOST("tracking");
        $trackingsubmitcancel= $this->app->Secure->GetPOST("trackingsubmitcancel");
        $retourenlabel = $this->app->Secure->GetPOST("retourenlabel"); 

        $Weight= $this->app->Secure->GetPOST("kg1");
        $Name= $this->app->Secure->GetPOST("name");
        $Name2= $this->app->Secure->GetPOST("name2");
        $Name3= $this->app->Secure->GetPOST("name3");
        $Street = $this->app->Secure->GetPOST("strasse");
        $HouseNo = $this->app->Secure->GetPOST("hausnummer");
        $ZipCode = $this->app->Secure->GetPOST("plz");
        $City = $this->app->Secure->GetPOST("ort");
        $Mail = $this->app->Secure->GetPOST("email");
        $Phone= $this->app->Secure->GetPOST("phone");

        //$this->createDPD(

        //$name2= $this->app->Secure->GetPOST("name2");
        //$name3= $this->app->Secure->GetPOST("name3");
        $StreetArray = explode(" ", $Adresse['strasse']);

        $nummeraufbeleg= $this->app->Secure->GetPOST("nummeraufbeleg");

          $array = array(
              "to" => array(
              //"company" => "",
              //"first_name" => "",
              "last_name" => $Name,
              "street" => $Street,
              "street_no" => $HouseNo,
              "city" => $City,
              "zip_code" => $ZipCode,
              "country" => $Country
              ),
              "package" => array(
              "weight" => $Weight,
              "length" => $this->app->Secure->GetPOST("length"),
              "width" => $this->app->Secure->GetPOST("width"),
              "height" => $this->app->Secure->GetPOST("height"),
              //"declared_value" => [
              //"amount" => 555.45,
              //"currency" => "EUR"
              // ]
              ),
              "carrier" => $this->einstellungen['versandfirma'],
              "service" => "standard",
              "reference_number" => $lieferscheinbelegnr,
              "notification_email" => $Mail,
              "create_shipping_label" => true
                );


          $session = curl_init();
          curl_setopt($session, CURLOPT_POST, TRUE);
          curl_setopt($session, CURLOPT_URL, 'https://api.shipcloud.io/v1/shipments');
          curl_setopt($session, CURLOPT_RETURNTRANSFER, 1);
          curl_setopt($session, CURLOPT_POSTFIELDS, json_encode($array));
          curl_setopt($session, CURLOPT_USERPWD, $this->apiKey);
          curl_setopt($session, CURLOPT_HTTPHEADER, array(
                'Content-Type: application/json',
                'Affiliate-ID: integration.wawision.mUxNFb7b'
                ));

          $ship = json_decode(curl_exec($session), TRUE);


          $data['drucker'] = $this->paketmarke_drucker;
          $data['druckerlogistikstufe2'] = $this->export_drucker;

          if($this->app->erp->GetStandardPaketmarkendrucker()>0)
            $data['drucker'] = $this->app->erp->GetStandardPaketmarkendrucker();
          

          if($this->app->erp->GetStandardVersanddrucker($projekt)>0)
            $data['druckerlogistikstufe2'] = $this->app->erp->GetStandardVersanddrucker($projekt);
          

          if(in_array('errors', array_keys($ship))){
            $this->errors[] = $ship['errors'][0];
            return $this->errors;
          }

          if(!$ship) {
            $this->errors[] = "Allgemeiner Fehler! (Eventuell fehlender API Key und Konfiguration)";
            return $this->errors;
          }

          $datei = $this->app->erp->GetTMP().'ShipcloudLabel'. $ship["carrier_tracking_no"] .".pdf";

          file_put_contents($datei, fopen($ship['label_url'], 'r'));

          $this->app->printer->Drucken($data['drucker'],$datei);
          unlink($datei);

      }

    }


    if($target){
      //$versandfirma = $this->einstellungen['versandfirma'];
      //$key = "DEFAULT" . strtoupper($versandfirma);
      //$this->app->Tpl->Add($key, "selected");
      //$this->app->Tpl->Add("VERSANDFIRMA", $this->einstellungen['versandfirma']);
      $this->app->Tpl->Add("HEIGHT", $this->einstellungen['stdheight']);
      $this->app->Tpl->Add("WIDTH", $this->einstellungen['stdwidth']);
      $this->app->Tpl->Add("LENGTH", $this->einstellungen['stdlength']);

      $this->app->Tpl->Parse($target,'versandarten_shipcloud.tpl');
    }
  }


  public function Export($daten)
  {

  }


  private function log($message) {

    if (isset($this->einstellungen['log'])) {

      if (is_array($message) || is_object($message)) {

        error_log(print_r($message, true));

      } else {

        error_log($message);

      }

    }

  }

}

?>
