<?php
/*
**** COPYRIGHT & LICENSE NOTICE *** DO NOT REMOVE ****
* 
* WaWision (c) embedded projects GmbH, Holzbachstrasse 4, D-86154 Augsburg, * Germany 2015 
*
* This file is licensed under the Embedded Projects General Public License *Version 3.1. 
*
* You should have received a copy of this license from your vendor and/or *along with this file; If not, please visit www.wawision.de/Lizenzhinweis 
* to obtain the text of the corresponding license version.  
*
**** END OF COPYRIGHT & LICENSE NOTICE *** DO NOT REMOVE ****
*/
?>
<?php
class Ajax {
  var $app;

  function __construct(&$app) {
    $this->app=&$app;

    $this->app->ActionHandlerInit($this);

    $this->app->ActionHandler("filter","AjaxFilter");
    $this->app->ActionHandler("table","AjaxTable");
    $this->app->ActionHandler("validator","AjaxValidator");
    $this->app->ActionHandler("ansprechpartner","AjaxAnsprechpartner");
    $this->app->ActionHandler("lieferadresse","AjaxLieferadresse");
    $this->app->ActionHandler("adressestammdaten","AjaxAdresseStammdaten");
    $this->app->ActionHandler("tooltipsuche","AjaxTooltipSuche");
    $this->app->ActionHandler("tableposition","AjaxTablePosition");
    $this->app->ActionHandler("tablefilter", "AjaxTableFilter");
    $this->app->ActionHandler("moduleunlock", "AjaxModuleUnlock");
    $this->app->ActionHandler("thumbnail", "AjaxThumbnail");
    $this->app->ActionHandler("autosavekonfiguration", "AjaxAutoSaveKonfiguration");
    $this->app->ActionHandler("autosaveuserparameter", "AjaxAutoSaveUserParameter");
    $this->app->ActionHandler("getuserparameter","AjaxGetUserParameter");
    $this->app->ActionHandler("getdateititel","AjaxGetDateiTitel");
    $this->app->ActionHandler("editdateititel","AjaxEditDateiTitel");
    $this->app->ActionHandler("profilbild","AjaxProfilbild");
    $this->app->ActionHandler("getgewicht","AjaxGetGewicht");
    $this->app->ActionHandlerListen($app);
  }

  function AjaxGetGewicht()
  {
    $seriennummer = $this->app->Secure->GetPOST('seriennummer');
    $mindestgewicht = (float)$this->app->Secure->GetPOST('mindestgewicht');
    $gewicht = str_replace(',','.',$this->app->erp->GetAdapterboxAPIWaage($seriennummer));
    if(!is_numeric($gewicht))$gewicht = 0;
    if($gewicht < $mindestgewicht)$gewicht = $mindestgewicht;
    echo json_encode(array('gewicht'=>number_format($gewicht ,1,'.','')));
    exit;
  }
  
  function AjaxValidator()
  {
    $rule = $this->app->Secure->GetPOST("rule");
    $value = $this->app->Secure->GetPOST("value");
    $data['error']=1;

    $tmp = explode(' ',$value); 

    switch($rule)
    {
      case "kunde":
        $adresse = $this->app->DB->Select("SELECT id FROM adresse WHERE kundennummer='".$tmp[0]."' AND kundennummer!='' AND geloescht!='1'"); 
        if($adresse <= 0)
          $data['message']="Kunde nicht gültig.";
        else 
          $data['error']=0;
      break;
      case "mitarbeiter":
        $adresse = $this->app->DB->Select("SELECT id FROM adresse WHERE mitarbeiternummer='".$tmp[0]."' AND mitarbeiternummer!='' AND geloescht!='1'"); 
        if($adresse <= 0)
          $data['message']="Mitarbeiter nicht gültig.";
        else 
          $data['error']=0;
      break;
      case "artikel":
        $artikel = $this->app->DB->Select("SELECT id FROM artikel WHERE nummer='".$tmp[0]."' AND nummer!='' AND geloescht!='1'"); 
        if($artikel <= 0)
          $data['message']="Artikel-Nr. nicht gültig.";
        else 
          $data['error']=0;
      break;
      case "rechnung":
        $rechnung = $this->app->DB->Select("SELECT id FROM rechnung WHERE belegnr='".$tmp[0]."'");
        if($rechnung <= 0)
          $data['message']="Rechnungs-Nr. nicht gültig.";
        else
          $data['error']=0;
      break;
      case "auftrag":
        $auftrag = $this->app->DB->Select("SELECT id FROM auftrag WHERE belegnr='".$tmp[0]."'");
        if($auftrag <= 0)
          $data['message']="Auftrags-Nr. nicht gültig.";
        else
          $data['error']=0;
      break;
      default:
       $data['message']="Validatorregel nicht gültig.";
    }
     
    echo json_encode($data);
    exit;
  }

  function AjaxGetDateiTitel()
  {
    $status = 0;
    $cmds = $this->CmdList();
    $cmd = $this->app->Secure->GetPOST('typ');
    $data = null;
    if(in_array($cmd, $cmds))
    {
      if($this->app->erp->RechteVorhanden($cmd, 'dateien'))
      {
        $id = $this->app->Secure->GetPOST('id');
        $objekt = $this->app->Secure->GetPOST('typ');
        $parameter = $this->app->Secure->GetPOST('parameter');
        if($objekt == 'adresse')$objekt = 'Adressen';
        
        $datei = $this->app->DB->SelectArr("SELECT d.*, s.subjekt FROM datei d LEFT JOIN datei_stichwoerter s ON d.id=s.datei LEFT JOIN datei_version v ON v.datei=d.id WHERE s.objekt LIKE '$objekt' AND s.parameter='$parameter' AND d.geloescht=0 AND d.id = '$id' LIMIT 1");
        if($datei)$data = reset($datei);
        $module = strtolower($objekt);
        if($module == 'adressen')$module = 'adresse';
        $subjekthtml = '<option value="Sonstige">Sonstige Datei</option><option value="anhang">Anhang</option><option value="Shopbild">Standard Artikelbild</option><option value="Gruppenbild">Standard Gruppenbild</option><option value="Etikettenbild">Etikettenbild</option><option value="Bild">Sonstiges Bild</option><option value="Briefpapier1">Briefpapier Seite 1</option><option value="Briefpapier2">Briefpapier Seite 2</option><option value="Datenblatt">Datenblatt</option><option value="Druckbild">Druckbild (300dpi)</option><option value="Zertifikat">Zertifikat Anhang (PDF)</option>';
        if($module=='adresse')
        { 
          $subjekthtml .= '<option value="Profilbild">Profilbild</option>';
        }

        if($module!="")
        {
          $tmp = $this->app->DB->SelectArr("SELECT * FROM datei_stichwortvorlagen WHERE modul='$module' ORDER by beschriftung");
          for($i=0;$i<count($tmp);$i++)
            $subjekthtml .= '<option value="'.$tmp[$i]['beschriftung'].'">'.$tmp[$i]['beschriftung'].'</option>';
        }

        $tmp = $this->app->DB->SelectArr("SELECT * FROM datei_stichwortvorlagen WHERE modul='' ORDER by beschriftung");
        for($i=0;$i<count($tmp);$i++)
          $subjekthtml .= '<option value="'.$tmp[$i]['beschriftung'].'">'.$tmp[$i]['beschriftung'].'</option>';


        if($data)$data['subjekthtml'] = $subjekthtml;
        
        
      }
    }
    
    echo json_encode($data);
    exit;
  }

  function AjaxEditDateiTitel()
  {
    $status = 0;
    $cmds = $this->CmdList();
    $cmd = $this->app->Secure->GetPOST('typ');
    $data = null;
    if(in_array($cmd, $cmds))
    {
      if($this->app->erp->RechteVorhanden($cmd, 'dateien'))
      {
        $id = $this->app->Secure->GetPOST('id');
        $objekt = $this->app->Secure->GetPOST('typ');
        $parameter = $this->app->Secure->GetPOST('parameter');
        $titel = $this->app->Secure->GetPOST('titel');
        $beschreibung = $this->app->Secure->GetPOST('beschreibung');
        $subjekt = $this->app->Secure->GetPOST('subjekt');
        if($objekt == 'adresse')$objekt = 'Adressen';
        $datei = $this->app->DB->SelectArr("SELECT d.id, s.id as sid FROM datei d LEFT JOIN datei_stichwoerter s ON d.id=s.datei LEFT JOIN datei_version v ON v.datei=d.id WHERE s.objekt LIKE '$objekt' AND s.parameter='$parameter' AND d.geloescht=0 AND d.id = '$id' LIMIT 1");
        if($datei)
        {
          $sid = $datei[0]['sid'];
          if($subjekt && $sid)$this->app->DB->Update("UPDATE datei_stichwoerter SET subjekt = '".$this->app->DB->real_escape_string($subjekt)."' WHERE id = '$sid' LIMIT 1");
          $this->app->DB->Update("UPDATE datei SET titel = '$titel', beschreibung = '$beschreibung' WHERE id = '$id' LIMIT 1");
          $status = 1;
        }
      }
    }
    echo json_encode(array('status'=>$status));
    exit;
  }
  
  function CmdList()
  {
    return array('artikel','adresse','angebot','auftrag','rechnung','gutschrift','lieferschein','bestellung','projekt','produktion','anfrage','reisekosten','kalkulation');
  }
  
  function AjaxProfilbild()
  {
    $adresse = 0;
    $dateiversion = 0;
    $user = (int)$this->app->Secure->GetGET('id');
    
    if($user)
    {
      $adresse = $this->app->DB->Select("SELECT a.id FROM user u LEFT JOIN adresse a ON a.id=u.adresse LEFT JOIN useronline uo ON uo.user_id=u.id AND uo.login=1
        LEFT JOIN adresse_rolle ar ON ar.adresse=a.id 
        WHERE u.activ=1 AND u.kalender_ausblenden!=1 AND ar.subjekt='Mitarbeiter' AND (ar.bis='0000-00-00' OR ar.bis <= NOW())
        AND u.id='".$user."' AND ((u.hwtoken <> 4 ) OR u.hwtoken IS NULL) LIMIT 1");
      if($adresse)
      {
        $dateiversion = (int)$this->app->DB->Select("SELECT dv.id FROM datei_stichwoerter ds INNER JOIN datei d ON ds.datei = d.id INNER JOIN datei_version dv ON dv.datei = d.id WHERE d.geloescht = 0 AND objekt like 'Adressen' AND parameter = '".$adresse."' AND subjekt like 'Profilbild' ORDER by dv.id DESC LIMIT 1");
        if($dateiversion)
        {
          $userdata = isset($this->app->Conf->WFuserdata)?$this->app->Conf->WFuserdata:str_replace("index.php", "", $_SERVER['SCRIPT_FILENAME'])."../userdata";
          $path = $userdata."/dms/".$this->app->Conf->WFdbname;
          $cachefolder = $path.'/cache';
          if(!file_exists($cachefolder.'/'.$dateiversion.'_100_100'))
          {
            if(file_exists($path.'/'.$dateiversion))
            {
              $type = mime_content_type($path.'/'.$dateiversion);
              switch($type)
              {
                case 'image/jpg':
                case 'image/jpeg':
                  $img = new image($this->app);
                  $str = $img->scaledPicByFileId($dateiversion, 100, 100);
                  header('Content-type: image/jpg');
                  echo $str;
                  exit;
                break;
                case 'image/png':
                  $img = new image($this->app);
                  $str = $img->scaledPicByFileId($dateiversion, 100, 100);
                  header('Content-type: image/png');
                  echo $str;
                  exit;
                break;
                case 'image/gif':
                  $img = new image($this->app);
                  $str = $img->scaledPicByFileId($dateiversion, 100, 100);
                  header('Content-type: image/gif');
                  echo $str;
                  exit;
                break;
                case 'application/pdf':
                  $str = file_get_contents(dirname(__FILE__) . '/../themes/new/images/pdf.png');
                  header('Content-type: image/png');
                  echo $str;
                  exit;
                break;
              }
            }
          }
      
          if(file_exists($cachefolder.'/'.$dateiversion.'_100_100'))
          {
            $type = mime_content_type($cachefolder.'/'.$dateiversion.'_100_100');
            if(strpos($type, 'image') !== false)
            {
              $str = file_get_contents($cachefolder.'/'.$dateiversion.'_100_100');
              header('Content-type: '.$type.'');
              echo $str;
              exit;
            }
          }
        }
      }
    }
    $str = file_get_contents(dirname(__FILE__) . '/../themes/new/images/checkabgeschlossen.png');
    header('Content-type: image/png');
    echo $str;
    exit;
  }
  
  function AjaxThumbnail()
  {
    $cmds = $this->CmdList();
    $cmd = trim($this->app->Secure->GetGET("cmd"));
    $id = (int)$this->app->Secure->GetGET("id");
    if($cmd && in_array($cmd, $cmds) && $this->app->erp->RechteVorhanden($cmd,"dateien") && $id)
    {
      $datei = $this->app->DB->SelectArr("SELECT dv.id, ds.parameter, dv.dateiname FROM datei_version dv INNER JOIN datei_stichwoerter ds ON ds.datei = dv.datei WHERE dv.datei = '$id' AND (ds.objekt like '$cmd'".($cmd == 'adresse'?" OR ds.objekt like 'Adressen' ":"").") ORDER BY  dv.datei DESC, dv.version DESC LIMIT 1");
      if(!$datei)
      {
        if ($this->app->erp->Firmendaten('iconset_dunkel')) {
          $str = file_get_contents(dirname(__FILE__) . '/../themes/new/images/keinbild_dunkel.png');
        } else {
          $str = file_get_contents(dirname(__FILE__) . '/../themes/new/images/keinbild_hell.png');
        }
        header('Content-type: image/png');
        echo $str;
        exit;
      }
      if($datei[0]['parameter'])
      {
        if($cmd == 'projekt')
        {
          if(!$this->app->erp->UserProjektRecht($datei[0]['parameter']))
          {
            if ($this->app->erp->Firmendaten('iconset_dunkel')) {
              $str = file_get_contents(dirname(__FILE__) . '/../themes/new/images/keinbild_dunkel.png');
            } else {
              $str = file_get_contents(dirname(__FILE__) . '/../themes/new/images/keinbild_hell.png');
            }
            header('Content-type: image/png');
            echo $str;
            exit;
          }
        }else{
          $projekt = $this->app->DB->Select("SELECT projekt FROM $cmd WHERE id = '".$datei[0]['parameter']."' LIMIT 1");
          if(!$this->app->erp->UserProjektRecht($projekt))
          {
            if ($this->app->erp->Firmendaten('iconset_dunkel')) {
              $str = file_get_contents(dirname(__FILE__) . '/../themes/new/images/keinbild_dunkel.png');
            } else {
              $str = file_get_contents(dirname(__FILE__) . '/../themes/new/images/keinbild_hell.png');
            }
            header('Content-type: image/png');
            echo $str;
            exit;
          }
        }
      }
      //Rechte prüfen
      
      $userdata = isset($this->app->Conf->WFuserdata)?$this->app->Conf->WFuserdata:str_replace("index.php", "", $_SERVER['SCRIPT_FILENAME'])."../userdata";
      $path = $userdata."/dms/".$this->app->Conf->WFdbname;
      $cachefolder = $path.'/cache';
      if(!file_exists($cachefolder.'/'.$datei[0]['id'].'_100_100'))
      {
        if(file_exists($path.'/'.$datei[0]['id']))
        {
          $type = mime_content_type($path.'/'.$datei[0]['id']);
          switch($type)
          {
            case 'image/jpg':
            case 'image/jpeg':
              $img = new image($this->app);
              $str = $img->scaledPicByFileId($datei[0]['id'], 100, 100);
              header('Content-type: image/jpg');
              echo $str;
              exit;
            break;
            case 'image/png':
              $img = new image($this->app);
              $str = $img->scaledPicByFileId($datei[0]['id'], 100, 100);
              header('Content-type: image/png');
              echo $str;
              exit;
            break;
            case 'image/gif':
              $img = new image($this->app);
              $str = $img->scaledPicByFileId($datei[0]['id'], 100, 100);
              header('Content-type: image/gif');
              echo $str;
              exit;
            break;
            case 'application/pdf':
              $str = file_get_contents(dirname(__FILE__) . '/../themes/new/images/pdf.png');
              header('Content-type: image/png');
              echo $str;
              exit;
            break;
            default:
              $str = file_get_contents(dirname(__FILE__) . '/../themes/new/images/pdf.png');
              if(substr(strtolower($datei[0]['dateiname']),-4) == '.gif')
              {
                header('Content-type: image/gif');
                echo $str;
                exit; 
              }elseif(substr(strtolower($datei[0]['dateiname']),-4) == '.png')
              {
                header('Content-type: image/png');
                echo $str;
                exit; 
              }elseif(substr(strtolower($datei[0]['dateiname']),-4) == '.jpg' || substr(strtolower($datei[0]['dateiname']),-4) == 'jpeg')
              {
                header('Content-type: image/jpg');
                echo $str;
                exit;                 
              }
            break;
          }
        }
      }
      
      if(file_exists($cachefolder.'/'.$datei[0]['id'].'_100_100'))
      {
        $type = mime_content_type($path.'/'.$datei[0]['id']);
        if(strpos($type,'image') !== false)
        {
          header('Content-type: '.$type);
          $str = file_get_contents($cachefolder.'/'.$datei[0]['id'].'_100_100');
          echo $str;
          exit;
        }else{
          $str = file_get_contents($cachefolder.'/'.$datei[0]['id'].'_100_100');
          if(substr(strtolower($datei[0]['dateiname']),-4) == '.gif')
          {
            header('Content-type: image/gif');
            echo $str;
            exit; 
          }elseif(substr(strtolower($datei[0]['dateiname']),-4) == '.png')
          {
            header('Content-type: image/png');
            echo $str;
            exit; 
          }elseif(substr(strtolower($datei[0]['dateiname']),-4) == '.jpg' || substr(strtolower($datei[0]['dateiname']),-4) == 'jpeg')
          {
            header('Content-type: image/jpg');
            echo $str;
            exit;                 
          }
        }
      }else{
        if ($this->app->erp->Firmendaten('iconset_dunkel')) {
          $str = file_get_contents(dirname(__FILE__) . '/../themes/new/images/keinbild_dunkel.png');
        } else {
          $str = file_get_contents(dirname(__FILE__) . '/../themes/new/images/keinbild_hell.png');
        }
        header('Content-type: image/png');
        echo $str;
        exit;
      }
    }else{
      if ($this->app->erp->Firmendaten('iconset_dunkel')) {
        $str = file_get_contents(dirname(__FILE__) . '/../themes/new/images/keinbild_dunkel.png');
      } else {
        $str = file_get_contents(dirname(__FILE__) . '/../themes/new/images/keinbild_hell.png');
      }
      header('Content-type: image/png');
      echo $str;
    }
    exit;
  }
  
  function AjaxModuleUnlock() {
    if($this->app->erp->RechteVorhanden("welcome","unlock"))
    {
      if($salt = $this->app->Secure->GetGET('salt'))
      {
        $this->app->DB->Delete("DELETE from module_lock where salt = '".$salt."'");
      }
    }
    $this->app->erp->ExitWawi();
  }

  function AjaxTableFilter() {

    /*header("Content-Type: text/html; charset=utf-8");*/

    $do = $this->app->Secure->GetGET("do");
    $filter = $this->app->Secure->GetGET("filter");

    switch ($do) {
      case 'getParameters':
        $params = $this->app->User->GetParameter('table_filter_' . $filter);
        echo base64_decode($params);
        break;
      case 'setParameters':
        $params = base64_encode(json_encode($_GET)); 
        $this->app->User->SetParameter('table_filter_' . $filter, $params);
        break;
      case 'clearParameters':
        $this->app->User->SetParameter('table_filter_' . $filter,'');
        break;
      default:
        return false;
        break;
    }

    $this->app->erp->ExitWawi();

  }


  function AjaxTooltipSuche()
  {
    $term = $this->app->Secure->GetGET("term");

    if(is_numeric($term))
    {
      $rechnung = $this->app->DB->SelectArr("SELECT id,belegnr,soll,ist FROM rechnung WHERE belegnr='$term'");
      $gutschrift = $this->app->DB->SelectArr("SELECT id,belegnr,soll,ist FROM gutschrift WHERE belegnr='$term'");
      $auftrag = $this->app->DB->SelectArr("SELECT id,belegnr FROM auftrag WHERE belegnr='$term'");
      $internet = $this->app->DB->SelectArr("SELECT id,belegnr FROM auftrag WHERE internet='$term'");
      $kunde = $this->app->DB->SelectArr("SELECT id,name FROM adresse WHERE kundennummer='$term'");
    }
    if(is_array($rechnung))
    {
      foreach($rechnung as $value){
        echo "<table width=\"500\"><tr><td>Rechnung ".$value[belegnr]." SOLL:".$value[soll]." IST:".$value[ist]."</td></tr></table>";
      }
    }




    if(is_array($auftrag))
    {
      foreach($auftrag as $value){
        echo "Auftrag ".$value[belegnr];
      }
    }



    if(is_array($internet))
    {
      foreach($internet as $value){
        echo "Internet Auftrag ".$value[belegnr];
      }
    }


    if($internetnummer)
      echo "Internetnummer";


    if(is_array($kunde))
    {
      foreach($kunde as $value){
        echo "Kunde ".$value[name];
      }
    }


    echo "ENDE ";

    $this->app->erp->ExitWawi();

  }

  function AjaxAdresseStammdaten()
  {
    $id = $this->app->Secure->GetGET("id");	


    //name	abteilung		unterabteilung	land	strasse		ort		plz

    $values = $this->app->DB->SelectArr("SELECT * FROM adresse WHERE id='$id' LIMIT 1");

    foreach($values[0] as $key=>$value)
    {
      $values[0][$key]=$this->app->erp->ReadyForPDF($value);
    }

    echo $this->app->erp->ClearDataBeforeOutput($values[0][name]."#*#".$values[0][abteilung]."#*#".$values[0][unterabteilung]."#*#".$values[0][land]."#*#".$values[0][strasse]."#*#".$values[0][ort]."#*#".$values[0][plz]."#*#".$values[0][adresszusatz]."#*#".$values[0][ansprechpartner]."#*#".$values[0]['titel']."#*#".$values[0][id]);
    $this->app->erp->ExitWawi();

  }


  function AjaxLieferadresse()
  {
    $id = $this->app->Secure->GetGET("id");	


    //name	abteilung		unterabteilung	land	strasse		ort		plz

    $values = $this->app->DB->SelectArr("SELECT * FROM lieferadressen WHERE id='$id' LIMIT 1");

    foreach($values[0] as $key=>$value)
    {
      $values[0][$key]=$this->app->erp->ReadyForPDF($value);
    }

    echo $this->app->erp->ClearDataBeforeOutput($values[0][name]."#*#".$values[0][abteilung]."#*#".$values[0][unterabteilung]."#*#".$values[0][land]."#*#".$values[0][strasse]."#*#".$values[0][ort]."#*#".$values[0][plz]."#*#".$values[0][adresszusatz]."#*#".$values[0][ansprechpartner]."#*#".$values[0][id]."#*#".$values[0][gln]."#*#".$values[0][ustid]."#*#".$values[0][ust_befreit]."#*#".$values[0][lieferbedingung]);
    $this->app->erp->ExitWawi();

  }



  function AjaxAnsprechpartner()
  {
    $id = $this->app->Secure->GetGET("id");	

    $values = $this->app->DB->SelectArr("SELECT * FROM ansprechpartner WHERE id='$id' LIMIT 1");

    foreach($values[0] as $key=>$value)
    {
      $values[0][$key]=$this->app->erp->ReadyForPDF($value);
    }

    echo $this->app->erp->ClearDataBeforeOutput($values[0]['name']."#*#".$values[0]['email']."#*#".$values[0]['telefon']."#*#".$values[0]['telefax']."#*#".$values[0]['abteilung']."#*#".$values[0]['unterabteilung'].
        "#*#".$values[0]['ansprechpartner_land']."#*#".$values[0]['strasse']."#*#".$values[0]['plz']."#*#".$values[0]['ort']."#*#".$values[0]['adresszusatz']."#*#".$values[0]['typ']."#*#".$values[0]['anschreiben']."#*#".$values[0]['titel']."#*#".$values[0]['id']);
    $this->app->erp->ExitWawi();

  }

  function AjaxAutoSaveKonfiguration()
  {
    $name = $this->app->Secure->GetPOST("name");
    $value = $this->app->Secure->GetPOST("value");
    $this->app->erp->SetKonfigurationValue($name,base64_decode($value));
    $this->app->erp->ExitWawi();
  }

  function AjaxAutoSaveUserParameter()
  {
    $name = $this->app->Secure->GetPOST("name");
    $value = $this->app->Secure->GetPOST("value");
    $this->app->User->SetParameter($name,base64_decode($value));
    $this->app->erp->ExitWawi();
  }


  function AjaxGetUserParameter()
  {
    $name = $this->app->Secure->GetPOST("name");
    echo json_encode(array('name'=>$name,'elem'=>$this->app->Secure->GetPOST("elem"),'value'=>$this->app->User->GetParameter($name)));
    $this->app->erp->ExitWawi();
  }


  function AjaxFilter()
  {
    //$term = $this->app->Secure->GetGET("term");
    $term = $this->app->Secure->GetGET("term");
    $rmodule = $this->app->Secure->GetGET("rmodule");
    $raction = $this->app->Secure->GetGET("raction");
    $rid = (int)$this->app->Secure->GetGET("rid");
    $pruefemodule = array('artikel','auftrag','angebot','rechnung','lieferschein','gutschrift','bestellung');
    $filter_projekt = 0;
    if($raction == 'edit' && $rid && in_array($rmodule, $pruefemodule))
    {
      $projekt = $this->app->DB->Select("SELECT projekt FROM $rmodule WHERE id = '$rid' LIMIT 1");
      if($projekt)
      {
        $eigenernummernkreis = $this->app->DB->Select("SELECT eigenernummernkreis FROM projekt WHERE id = '$projekt' LIMIT 1");
        //if($eigenernummernkreis)
        $filter_projekt = $projekt;
      }
    }    
    $term2 = $term;
    $term3 = $term;
    $term = $this->app->erp->ConvertForDBUTF8($term);
    $term2 = $this->app->erp->ConvertForDB($term2);
    if($term2=="") $term2 = $term;
    $term = str_replace(' ','%',$term);
    $term2 = str_replace(' ','%',$term2);
    $term3 = str_replace(' ','%',$term3);
    //$term = $this->app->erp->ConvertForDBUTF8($term);
    //		$term = str_replace(' ','%',$term);
    $filtername = $this->app->Secure->GetGET("filtername");

    $term = trim($term);
    $term2 = trim($term2);

    switch($filtername)
    {
      case "adressenamegruppe":
        $gruppe = $this->app->Secure->GetGET('gruppe');
        $gruppea = explode(',',$gruppe);
        $gruppenwhere = ' 0 ';
        foreach($gruppea as $v)
        {
          if($v)$gruppenw[] = " ar.parameter = '$v' ";
        }
        if(!empty($gruppenw))
        {
          $gruppenwhere = " (".implode(' OR ', $gruppenw).") ";
        }
        
        $arr = $this->app->DB->SelectArr("SELECT DISTINCT concat(a.id, ' ',a.name) as name2 FROM adresse a 
        INNER JOIN adresse_rolle ar ON a.id = ar.adresse AND $gruppenwhere AND ar.objekt LIKE 'Gruppe' AND (bis = '0000-00-00' OR bis >= curdate())
        WHERE (a.email LIKE '%$term%' OR a.name LIKE '%$term%') AND a.geloescht <> 1 ".$this->app->erp->ProjektRechte('a.projekt')."
        ORDER BY a.name LIMIT 20
        ");
        for($i=0;$i<count($arr);$i++)
          $newarr[] = "{$arr[$i]['name2']}";
      break;
      
      case "adressename":
        $arr = $this->app->DB->SelectArr("SELECT a.email, (SELECT name FROM adresse a2 WHERE a2.kundennummer = a.kundennummer ".$this->app->erp->ProjektRechte('a2.projekt')." order by ".($filter_projekt?" a2.projekt = '$filter_projekt' DESC, ":"")."  projekt LIMIT 1) as name2 FROM adresse a WHERE (a.email LIKE '%$term%' OR a.name LIKE '%$term%') ".$this->app->erp->ProjektRechte('a.projekt')." GROUP by email ORDER BY a.email, name2 LIMIT 20");
        for($i=0;$i<count($arr);$i++)
          $newarr[] = "{$arr[$i]['name2']}";
        break;
/*

select a.kundennummer, (SELECT name FROM adresse a2 WHERE a2.kundennummer = a.kundennummer order by a2.projekt = 13 DESC, a2.projekt = 0 DESC, projekt LIMIT 1) as name FROM adresse a WHERE a.kundennummer like '10500' group by a.kundennummer 
*/

      case "arbeitspaket":
         $checkprojekt = $this->app->User->GetParameter("teilprojekt_filter");
         if(is_numeric($checkprojekt) && $checkprojekt > 0)
          $projektid = $this->app->DB->Select("SELECT id FROM projekt WHERE id='".$checkprojekt."' LIMIT 1");
         if($projektid <=0)
         {
          $checkprojekt = explode(' ',$checkprojekt);
          $projektid = $this->app->DB->Select("SELECT id FROM projekt WHERE abkuerzung='".$checkprojekt[0]."' AND abkuerzung!='' LIMIT 1");
         }
         if($projektid > 0) $subwhere = " AND p.id='".$projektid."'"; else $subwhere="";
         $arr = $this->app->DB->SelectArr("SELECT CONCAT(ap.id,' ',p.abkuerzung,' ',ap.aufgabe) as name2 FROM arbeitspaket ap LEFT JOIN projekt p ON p.id=ap.projekt WHERE (p.abkuerzung LIKE '%$term%' OR p.abkuerzung LIKE '%$term2%' OR p.abkuerzung LIKE '%$term3%' OR ap.aufgabe LIKE '%$term%' OR ap.aufgabe LIKE '%$term2%' OR ap.aufgabe LIKE '%$term3%') AND ap.status!='abgeschlossen' AND ap.aufgabe!='' AND p.id > 0 $subwhere LIMIT 20");
        for($i=0;$i<count($arr);$i++)
          $newarr[] = "{$arr[$i]['name2']}";
        break;
      case "drucker":
        $arr = $this->app->DB->SelectArr("SELECT name FROM drucker WHERE name LIKE '%$term%' OR name LIKE '%$term2%' OR name LIKE '%$term3%' LIMIT 20");
        for($i=0;$i<count($arr);$i++)
          $newarr[] = "{$arr[$i]['name']}";
        break;

      case "laender":
        $laender = $this->app->erp->GetSelectLaenderliste();
        $_term = explode(',',$term);
        $_term = $_term[count($_term)-1];
        if($laender){
          foreach($laender as $key => $value)
          {
            if(stripos($key, $_term) !== false || stripos($value, $_term) !== false)
            {
              $newarr[] = $key.' '.$value;
            }
          }
        }
      break;
      case "artikelname":
        $artikel_freitext1_suche = $this->app->erp->Firmendaten('artikel_freitext1_suche');
        $arr = $this->app->DB->SelectArr("SELECT name_de FROM artikel WHERE geloescht=0 AND intern_gesperrt!=1 AND (name_de LIKE '%$term%' ".($artikel_freitext1_suche?" OR freifeld1 LIKE '%$term%' ":"")."  OR nummer LIKE '%$term%' OR CONCAT(nummer,' ',name_de) LIKE '%$term%') AND geloescht=0 ORDER by name_de LIMIT 20");
        for($i=0;$i<count($arr);$i++)
          $newarr[] = $arr[$i]['name_de'];
        break;

      case "artikelgruppe":
        $arr = $this->app->DB->SelectArr("SELECT DISTINCT typ FROM artikel WHERE geloescht=0 AND intern_gesperrt!=1 AND typ LIKE '%$term%' ORDER by typ");
        for($i=0;$i<count($arr);$i++)
          $newarr[] = $arr[$i]['typ'];
        break;

      
      case "artikelkategorien":
      
        $anz = $this->app->DB->Select("SELECT count(*) FROM artikelkategorien");
        $subwhere = $this->app->erp->ProjektRechte('ar.projekt');
        if($anz)
        {
          $arr = $this->app->DB->SelectArr("SELECT a.typ,ar.bezeichnung  FROM artikel a LEFT JOIN artikelkategorien ar ON a.typ = concat(ar.id,'_kat') WHERE a.geloescht=0 AND a.intern_gesperrt!=1 AND ar.bezeichnung LIKE '%$term%' ".$subwhere." GROUP BY a.typ ORDER by ar.bezeichnung ");
          if($arr)
          {
            $typen = false;
            foreach($arr as $k => $a)
            {
              if($a['bezeichnung'])$arr[$k]['typ'] = $a['bezeichnung'];
              $typen = $arr[$k]['typ'];
            }
            array_multisort($typen, $arr);
            $last = false;
            foreach($arr as $k => $a)
            {
              if($last == $a['typ'])
              {
                unset($arr[$k]);
              } else {
                $last = $a['typ'];
              }
            }
          }
          
          
        } else {
          $arr = $this->app->DB->SelectArr("SELECT DISTINCT typ FROM artikel WHERE geloescht=0 AND intern_gesperrt!=1 AND typ LIKE '%$term%' ORDER by typ");  
        }
        if($arr)
        {          
          for($i=0;$i<count($arr);$i++)
            $newarr[] = $arr[$i]['typ']; 
        }
      break;
      
      case 'alleartikelkategorien':
        $anz = $this->app->DB->Select("SELECT count(*) FROM artikelkategorien");
        $subwhere = $this->app->erp->ProjektRechte('ar.projekt');
        if($anz)
        {
          $arr = $this->app->DB->SelectArr("SELECT ar.bezeichnung as typ  FROM artikelkategorien ar  WHERE ar.bezeichnung LIKE '%$term%' ".$subwhere." AND ar.geloescht <> 1 ORDER by ar.bezeichnung ");
        } else {
          $arr = $this->app->DB->SelectArr("SELECT DISTINCT typ FROM artikel WHERE geloescht=0 AND intern_gesperrt!=1 AND typ LIKE '%$term%' ORDER by typ");  
        }
        if($arr)
        {          
          for($i=0;$i<count($arr);$i++)
            $newarr[] = $arr[$i]['typ']; 
        }
      break;
      case "artikeleinheit":
        //$arr = $this->app->DB->SelectArr("SELECT DISTINCT einheit_de FROM artikeleinheit WHERE firma='".$this->app->User->GetFirma()."' AND einheit_de LIKE '%$term%' ORDER by einheit_de");
        $arr = $this->app->DB->SelectArr("SELECT DISTINCT einheit_de FROM artikeleinheit WHERE einheit_de LIKE '%$term%' ORDER by einheit_de");
        for($i=0;$i<count($arr);$i++)
          $newarr[] = $arr[$i]['einheit_de'];
        break;



      case "ihrebestellnummer":
        $adresse = $this->app->Secure->GetGET("adresse");
        $arr = $this->app->DB->SelectArr("SELECT DISTINCT ihrebestellnummer FROM auftrag WHERE ihrebestellnummer LIKE '%$term%' AND adresse='$adresse' ORDER by ihrebestellnummer ");
        for($i=0;$i<count($arr);$i++)
          $newarr[] = $arr[$i]['ihrebestellnummer'];
      break;


      case "accountart":
        $arr = $this->app->DB->SelectArr("SELECT DISTINCT art FROM adresse_accounts WHERE art LIKE '%$term%' ORDER by art");
        for($i=0;$i<count($arr);$i++)
          $newarr[] = $arr[$i]['art'];
        break;

      case "ansprechpartner":
        $adresse = $this->app->Secure->GetGET("adresse");
        $arr = $this->app->DB->SelectArr("SELECT DISTINCT name FROM ansprechpartner WHERE adresse='$adresse' AND name LIKE '%$term%' AND geloescht <> 1 ORDER by name");
        for($i=0;$i<count($arr);$i++)
          $newarr[] = $arr[$i]['name'];
        break;
      case "hersteller":
        $arr = $this->app->DB->SelectArr("SELECT DISTINCT hersteller FROM artikel WHERE geloescht=0 AND intern_gesperrt!=1 AND hersteller LIKE '%$term%' ORDER by hersteller");
        for($i=0;$i<count($arr);$i++)
          $newarr[] = $arr[$i]['hersteller'];
        break;
  
      case "zeiterfassung_beschreibung":
        $arr = $this->app->DB->SelectArr("SELECT DISTINCT beschreibung FROM zeiterfassung_kosten WHERE beschreibung LIKE '%$term%' ORDER by beschreibung");
        for($i=0;$i<count($arr);$i++)
          $newarr[] = $arr[$i]['beschreibung'];
        break;

      case "eigenschaften_vorlagen":
        $arr = $this->app->DB->SelectArr("SELECT DISTINCT bezeichnung FROM eigenschaften_vorlagen WHERE bezeichnung LIKE '%$term%' AND aktiv = 1 ORDER BY bezeichnung");
        for($i=0;$i<count($arr);$i++)
          $newarr[] = $arr[$i]['bezeichnung'];
        break;

      case "artikelarbeitsanweisung_vorlagen":
        $arr = $this->app->DB->SelectArr("SELECT DISTINCT bezeichnung FROM artikelarbeitsanweisung_vorlagen WHERE bezeichnung LIKE '%$term%' AND aktiv = 1 ORDER BY bezeichnung");
        for($i=0;$i<count($arr);$i++)
          $newarr[] = $arr[$i]['bezeichnung'];
        break;   

   


 
      case "uservorlage":
        $arr = $this->app->DB->SelectArr("SELECT DISTINCT bezeichnung FROM uservorlage WHERE bezeichnung LIKE '%$term%' ORDER by bezeichnung");
        for($i=0;$i<count($arr);$i++)
          $newarr[] = $arr[$i]['bezeichnung'];
        break;


      case "lagergrund":
        $arr = $this->app->DB->SelectArr("SELECT DISTINCT TRIM(REPLACE(REPLACE(referenz,'Umlagern f&uuml; :',''),'Differenz:','')) as ergebnis FROM lager_bewegung WHERE REPLACE(referenz,'Differenz:','') LIKE '%$term%' AND referenz NOT LIKE '%Inventur%' AND referenz NOT LIKE '%Charge%' AND referenz NOT LIKE '%Lieferschein%'
            AND referenz NOT LIKE '%Manuell%' AND referenz NOT LIKE '%Wareneingang%' AND referenz NOT LIKE '%Lieferungen%' LIMIT 20");
        for($i=0;$i<count($arr);$i++)
          $newarr[] = $arr[$i]['ergebnis'];
        break;



      case "auftrag_zahlungseingang":
        if(strpos($term,',')!==false)
        {
          $term = substr($term,strripos($term,','));
          $term = str_replace(',','',$term);
        }

        $arr = $this->app->DB->SelectArr("SELECT CONCAT(r.belegnr,' ',a.name,' ',r.internet,' GESAMT: ',r.gesamtsumme,' (Kunde ',a.kundennummer,') vom ',DATE_FORMAT(r.datum,'%d.%m.%Y'),' Status: ',r.status) as name
            FROM auftrag r LEFT JOIN adresse a ON a.id=r.adresse WHERE r.belegnr!='' 
            AND (a.name LIKE '%$term%' OR r.belegnr LIKE '%$term%' OR a.kundennummer LIKE '%$term%' ) ORDER by r.belegnr  DESC LIMIT 20");
        for($i=0;$i<count($arr);$i++)
          $newarr[] = $arr[$i]['name'];
        break;


      case "rechnung_zahlungseingang":
        if(strpos($term,',')!==false)
        {
          $term = substr($term,strripos($term,','));
          $term = str_replace(',','',$term);
        }

        $arr = $this->app->DB->SelectArr("SELECT CONCAT(r.belegnr,' Soll:',r.soll,' Ist:',r.ist,' ',' Diff:',(r.soll-r.ist)*-1,' ',
          if(r.zahlungszielskonto > 0,CONCAT('SK:',r.zahlungszielskonto,'%(',FORMAT((r.soll/100)*r.zahlungszielskonto,2),') '),''),a.name,'(Kunde ',a.kundennummer,') vom ',DATE_FORMAT(r.datum,'%d.%m.%Y'),' Status: ',r.status) as name
            FROM rechnung r LEFT JOIN adresse a ON a.id=r.adresse WHERE r.belegnr!='' AND (a.name LIKE '%$term%' OR r.belegnr LIKE '%$term%' OR a.kundennummer LIKE '%$term%') AND r.zahlungsstatus!='bezahlt' ORDER by r.belegnr DESC LIMIT 20");
        for($i=0;$i<count($arr);$i++)
          $newarr[] = $arr[$i]['name'];
        break;

      case "gutschrift_zahlungseingang":
        if(strpos($term,',')!==false)
        {
          $term = substr($term,strripos($term,','));
          $term = str_replace(',','',$term);
        }


        $arr = $this->app->DB->SelectArr("SELECT CONCAT(r.belegnr,' SOLL: ',r.soll,' IST:',r.ist,' ',a.name,' (Kunde ',a.kundennummer,') vom ',DATE_FORMAT(r.datum,'%d.%m.%Y'),' Status: ',r.status) as name
            FROM gutschrift r LEFT JOIN adresse a ON a.id=r.adresse WHERE r.belegnr!='' AND (a.name LIKE '%$term%' OR r.belegnr LIKE '%$term%' OR a.kundennummer LIKE '%$term%') ORDER by r.belegnr DESC LIMIT 20");
        for($i=0;$i<count($arr);$i++)
          $newarr[] = $arr[$i]['name'];
        break;



      case "angebot":
        $arr = $this->app->DB->SelectArr("SELECT CONCAT(belegnr,' ',name,' ',DATE_FORMAT(datum,'%d.%m.%Y')) as name 
            FROM angebot WHERE belegnr!='' AND belegnr!='0' AND (name LIKE '%$term%' OR belegnr LIKE '%$term%' OR DATE_FORMAT(datum,'%Y-%m-%d') LIKE '%$term%')  ORDER by belegnr DESC LIMIT 20");
        for($i=0;$i<count($arr);$i++)
          $newarr[] = $arr[$i]['name'];
        break;

      case "bestellung":
        $arr = $this->app->DB->SelectArr("SELECT CONCAT(belegnr,' ',name,' ',DATE_FORMAT(datum,'%d.%m.%Y')) as name 
            FROM bestellung WHERE belegnr!='0' AND belegnr!='' AND (name LIKE '%$term%' OR belegnr LIKE '%$term%' OR DATE_FORMAT(datum,'%Y-%m-%d') LIKE '%$term%')  ORDER by belegnr DESC LIMIT 20");
        for($i=0;$i<count($arr);$i++)
          $newarr[] = $arr[$i]['name'];
        break;

      case "auftrag_position_dienstleistung":
        $arr = $this->app->DB->SelectArr("SELECT CONCAT(a.belegnr,'-',ap.sort,' ',a.name,' ',DATE_FORMAT(a.datum,'%d.%m.%Y'),' ',ap.bezeichnung) as name 
            FROM auftrag_position ap LEFT JOIN auftrag a ON a.id=ap.auftrag LEFT JOIN artikel art ON art.id=ap.artikel WHERE art.dienstleistung=1 AND  a.belegnr!='0' AND a.belegnr!='' AND (a.name LIKE '%$term%' OR ap.bezeichnung LIKE '%$term%' OR a.belegnr LIKE '%$term%' OR DATE_FORMAT(a.datum,'%Y-%m-%d') LIKE '%$term%') ORDER by a.belegnr DESC LIMIT 20");
        for($i=0;$i<count($arr);$i++)
          $newarr[] = $arr[$i]['name'];
        break;


      case "auftragihrebestellnummer":
        $arr = $this->app->DB->SelectArr("SELECT CONCAT(belegnr,' ',name,' ',DATE_FORMAT(datum,'%d.%m.%Y'),
            if(ihrebestellnummer!='',CONCAT(' ',ihrebestellnummer),''),if(internebezeichnung!='',CONCAT(' ',internebezeichnung),'')) as name 
            FROM auftrag WHERE belegnr!='0' AND belegnr!='' AND status!='angelegt' AND
            (name LIKE '%$term%' OR name LIKE '%$term2%' OR name LIKE '%$term3%' OR ihrebestellnummer LIKE '%$term%' OR internebezeichnung LIKE '%$term%' 
              OR belegnr LIKE '%$term%' OR DATE_FORMAT(datum,'%Y-%m-%d') LIKE '%$term%') ORDER by belegnr DESC LIMIT 20");
        for($i=0;$i<count($arr);$i++)
          $newarr[] = $arr[$i]['name'];
        break;



      case "auftrag":
        $arr = $this->app->DB->SelectArr("SELECT CONCAT(belegnr,' ',name,' ',DATE_FORMAT(datum,'%d.%m.%Y')) as name 
            FROM auftrag WHERE belegnr!='0' AND belegnr!='' AND (name LIKE '%$term%' OR belegnr LIKE '%$term%' OR DATE_FORMAT(datum,'%Y-%m-%d') LIKE '%$term%') ORDER by belegnr DESC LIMIT 20");
        for($i=0;$i<count($arr);$i++)
          $newarr[] = $arr[$i]['name'];
        break;

      case "auftrag_freigegeben":
        $arr = $this->app->DB->SelectArr("SELECT CONCAT(belegnr,' ',name,' ',DATE_FORMAT(datum,'%d.%m.%Y')) as name 
            FROM auftrag WHERE belegnr!='0' AND belegnr!='' AND status='freigegeben' AND (name LIKE '%$term%' OR belegnr LIKE '%$term%' OR DATE_FORMAT(datum,'%Y-%m-%d') LIKE '%$term%') ORDER by belegnr DESC LIMIT 20");
        for($i=0;$i<count($arr);$i++)
          $newarr[] = $arr[$i]['name'];
        break;


      case "rechnung_freigegeben":
        $arr = $this->app->DB->SelectArr("SELECT CONCAT(belegnr,' ',name,' ',DATE_FORMAT(datum,'%d.%m.%Y')) as name 
            FROM rechnung WHERE belegnr!='0' AND belegnr!='' AND status='freigegeben' AND (name LIKE '%$term%' OR belegnr LIKE '%$term%' OR DATE_FORMAT(datum,'%Y-%m-%d') LIKE '%$term%') ORDER by belegnr DESC LIMIT 20");
        for($i=0;$i<count($arr);$i++)
          $newarr[] = $arr[$i]['name'];
        break;

      case "produktion":
        $arr = $this->app->DB->SelectArr("SELECT CONCAT(belegnr,' ',name,' ',DATE_FORMAT(datum,'%d.%m.%Y')) as name 
            FROM produktion WHERE belegnr!='0' AND belegnr!='' AND (name LIKE '%$term%' OR belegnr LIKE '%$term%' OR DATE_FORMAT(datum,'%Y-%m-%d') LIKE '%$term%') ORDER by belegnr DESC LIMIT 20");
        for($i=0;$i<count($arr);$i++)
          $newarr[] = $arr[$i]['name'];
        break;



      case "arbeitsnachweis":
        $arr = $this->app->DB->SelectArr("SELECT CONCAT(belegnr,' ',name,' ',DATE_FORMAT(datum,'%d.%m.%Y')) as name 
            FROM arbeitsnachweis WHERE belegnr!='0' AND belegnr!='' AND (name LIKE '%$term%' OR belegnr LIKE '%$term%' OR DATE_FORMAT(datum,'%Y-%m-%d') LIKE '%$term%') ORDER by belegnr DESC LIMIT 20");
        for($i=0;$i<count($arr);$i++)
          $newarr[] = $arr[$i]['name'];
        break;

      case "lieferschein":
        $arr = $this->app->DB->SelectArr("SELECT CONCAT(belegnr,' ',name,' ',DATE_FORMAT(datum,'%d.%m.%Y')) as name 
            FROM lieferschein WHERE belegnr!='0' AND belegnr!='' AND  (name LIKE '%$term%' OR belegnr LIKE '%$term%' OR DATE_FORMAT(datum,'%Y-%m-%d') LIKE '%$term%') ORDER by belegnr DESC LIMIT 20");
        for($i=0;$i<count($arr);$i++)
          $newarr[] = $arr[$i]['name'];
        break;

      case "rechnung":
        $arr = $this->app->DB->SelectArr("SELECT CONCAT(belegnr,' ',name,' ',DATE_FORMAT(datum,'%d.%m.%Y')) as name 
            FROM rechnung WHERE belegnr!='0' AND belegnr!='' AND (name LIKE '%$term%' OR belegnr LIKE '%$term%' OR DATE_FORMAT(datum,'%Y-%m-%d') LIKE '%$term%') ORDER by belegnr DESC LIMIT 20");
        for($i=0;$i<count($arr);$i++)
          $newarr[] = $arr[$i]['name'];
        break;

      case "vpeartikel":
        $arr = $this->app->DB->SelectArr("SELECT DISTINCT vpe FROM verkaufspreise WHERE geloescht=0 AND vpe LIKE '%$term%' ORDER by vpe");
        for($i=0;$i<count($arr);$i++)
          $newarr[] = $arr[$i]['vpe'];
        break;

      case "herstellerlink":
        $arr = $this->app->DB->SelectArr("SELECT DISTINCT herstellerlink FROM artikel WHERE geloescht=0 AND intern_gesperrt!=1 AND herstellerlink LIKE '%$term%' ORDER by herstellerlink");
        for($i=0;$i<count($arr);$i++)
          $newarr[] = $arr[$i]['herstellerlink'];
        break;


      case "lagerplatz":
        $arr = $this->app->DB->SelectArr("SELECT kurzbezeichnung FROM lager_platz WHERE geloescht=0 AND kurzbezeichnung LIKE '%$term%' ORDER by kurzbezeichnung");
        for($i=0;$i<count($arr);$i++)
          $newarr[] = $arr[$i]['kurzbezeichnung'];
        break;
      case "lagerplatzartikel":
        $artikel = (int)$this->app->Secure->GetGET('artikel');
        $arr = $this->app->DB->SelectArr("SELECT kurzbezeichnung FROM lager_platz lp INNER JOIN lager_platz_inhalt lpi on lp.id = lpi.lager_platz WHERE lpi.artikel='$artikel' AND lp.geloescht=0 AND lp.kurzbezeichnung LIKE '%$term%' GROUP BY lp.kurzbezeichnung ORDER by lp.kurzbezeichnung");
        for($i=0;$i<count($arr);$i++)
          $newarr[] = $arr[$i]['kurzbezeichnung'];
        break;

      case "lager":
        $arr = $this->app->DB->SelectArr("SELECT bezeichnung FROM lager WHERE geloescht=0 AND bezeichnung LIKE '%$term%' ORDER by bezeichnung");
        for($i=0;$i<count($arr);$i++)
          $newarr[] = $arr[$i]['bezeichnung'];
        break;


      case "waehrung":
        $arr = $this->app->DB->SelectArr("(SELECT DISTINCT waehrung_nach as name FROM waehrung_umrechnung
            WHERE (waehrung_nach LIKE '%$term%') ORDER by waehrung_nach) UNION (SELECT DISTINCT waehrung_von as name FROM waehrung_umrechnung
            WHERE (waehrung_von LIKE '%$term%') ORDER by waehrung_von) ORDER by name");

        for($i=0;$i<count($arr);$i++)
          $newarr[] = $arr[$i]['name'];
        break;


      case "lieferbedingungen":
        $arr = $this->app->DB->SelectArr("SELECT CONCAT(lieferbedingungen) as name FROM lieferbedingungen
            WHERE (lieferbedingungen LIKE '%$term%' OR lieferbedingungen LIKE '%$term2%' OR lieferbedingungen LIKE '%$term3%') ORDER by lieferbedingungen");
        for($i=0;$i<count($arr);$i++)
          $newarr[] = $arr[$i]['name'];
        break;
 
      case "zeiterfassungvorlage":
        $arr = $this->app->DB->SelectArr("SELECT vorlage as name FROM zeiterfassungvorlage
            WHERE (vorlage LIKE '%$term%' OR vorlage LIKE '%$term2%' OR vorlage LIKE '%$term3%') AND ausblenden!=1 ORDER by vorlage");
        for($i=0;$i<count($arr);$i++)
          $newarr[] = $arr[$i]['name'];
        break;
  
      case "zolltarifnummer":
        $arr = $this->app->DB->SelectArr("SELECT CONCAT(nummer,' ',beschreibung) as name FROM zolltarifnummer WHERE beschreibung LIKE '%$term%' OR nummer LIKE '%$term%' ORDER by nummer");
        for($i=0;$i<count($arr);$i++)
          $newarr[] = $arr[$i]['name'];
        break;


      case "kostenstelle":
        $arr = $this->app->DB->SelectArr("SELECT CONCAT(nummer,' ',beschreibung) as name FROM kostenstellen WHERE beschreibung LIKE '%$term%' OR nummer LIKE '%$term%' ORDER by nummer");
        for($i=0;$i<count($arr);$i++)
          $newarr[] = $arr[$i]['name'];
        break;

      case "verrechnungsart":
        $arr = $this->app->DB->SelectArr("SELECT CONCAT(nummer,' ',beschreibung) as name FROM verrechnungsart WHERE beschreibung LIKE '%$term%' OR nummer LIKE '%$term%' ORDER by nummer");
        for($i=0;$i<count($arr);$i++)
          $newarr[] = $arr[$i]['name'];
        break;
      
      case "kundenrechnung":
      case "kundenauftrag":
      case "kundenlieferschein":
      case "kundenamgebot":
      case "kundenproformarechnung":
        $adresse = (int)$this->app->Secure->GetGET('adresse');
        if(!$adresse)
        {
          $kunde = explode(' ',$this->app->Secure->GetGET('kunde'));
          $adresse = $this->app->DB->Select("SELECT id FROM adresse WHERE kundennummer = '".$kunde[0]."' AND kundennummer <> '' LIMIT 1");
        }
        $beleg = str_replace('kunden','',$filtername);
        $arr = $this->app->DB->SelectArr("SELECT CONCAT(id,' ',if(belegnr <> '',belegnr,'ENTWURF'),' ',kundennummer,' ',name) as name FROM $beleg WHERE (belegnr LIKE '%$term%' OR name LIKE '%$term%' OR kundennummer LIKE '$%term%') AND (status = 'angelegt' OR status = 'freigegeben') 
        ".($adresse?" AND adresse = '$adresse' ":'')."   ".$this->app->erp->ProjektRechte('projekt')."
        ORDER by belegnr LIMIT 20");
        for($i=0;$i<count($arr);$i++)
          $newarr[] = $arr[$i]['name'];
      break;
      case "lieferantenpreisanfrage":
      case "lieferantenbestellung":
        $adresse = (int)$this->app->Secure->GetGET('adresse');
        if(!$adresse)
        {
          $lieferant = explode(' ',$this->app->Secure->GetGET('lieferant'));
          $adresse = $this->app->DB->Select("SELECT id FROM adresse WHERE lieferantennummer = '".$kunde[0]."' AND lieferantennummer <> '' LIMIT 1");
        }
        $beleg = str_replace('lieferanten','',$filtername);
        $arr = $this->app->DB->SelectArr("SELECT CONCAT(id,' ',if(belegnr <> '',belegnr,'ENTWURF'),' ',lieferantennummer,' ',name) as name FROM $beleg WHERE (belegnr LIKE '%$term%' OR name LIKE '%$term%' OR lieferantennummer LIKE '$%term%') AND (status = 'angelegt' OR status = 'freigegeben') 
        ".($adresse?" AND adresse = '$adresse' ":'')."  ".$this->app->erp->ProjektRechte('projekt')."
        ORDER by belegnr LIMIT 20" );
        for($i=0;$i<count($arr);$i++)
          $newarr[] = $arr[$i]['name'];
      break;      
      

      case "artikelnummer":
        $projekt = $this->app->Secure->GetGET("projekt");
        $artikel_freitext1_suche = $this->app->erp->Firmendaten('artikel_freitext1_suche');
        //$checkprojekt = $this->app->DB->Select("SELECT id FROM projekt WHERE id='$projekt' LIMIT 1");
        //$eigenernummernkreis = $this->app->DB->Select("SELECT eigenernummernkreis FROM projekt WHERE id='$projekt' LIMIT 1");

        //if($checkprojekt > 0 && $eigenernummernkreis=="1") $tmp_where = " AND projekt='$checkprojekt' ";
        //else $tmp_where = "";


        $arr = $this->app->DB->SelectArr("SELECT CONCAT(nummer,' ',name_de) as name FROM artikel WHERE geloescht=0 AND  (nummer LIKE '%$term%' OR name_de LIKE '%$term%' OR nummer LIKE '%$term2%' OR name_de LIKE '%$term2%' OR nummer LIKE '%$term3%' OR name_de LIKE '%$term3%' OR herstellernummer LIKE '%$term%' OR ean LIKE '%$term%' ".($artikel_freitext1_suche?" OR freifeld1 LIKE '%$term%' ":"").") AND geloescht=0 AND intern_gesperrt!=1 $tmp_where LIMIT 20");
        for($i=0;$i<count($arr);$i++)
          $newarr[] = $arr[$i]['name'];
        break;
        
      case "artikelnummertagespreise":
        $projekt = $this->app->Secure->GetGET("projekt");
        $artikel_freitext1_suche = $this->app->erp->Firmendaten('artikel_freitext1_suche');
        $checkprojekt = $this->app->DB->Select("SELECT id FROM projekt WHERE id='$projekt' LIMIT 1");
        $eigenernummernkreis = $this->app->DB->Select("SELECT eigenernummernkreis FROM projekt WHERE id='$projekt' LIMIT 1");

        if($checkprojekt > 0 && $eigenernummernkreis=="1") $tmp_where = " AND projekt='$checkprojekt' ";
        else $tmp_where = "";


        $arr = $this->app->DB->SelectArr("SELECT CONCAT(nummer,' ',name_de) as name FROM artikel WHERE geloescht=0 AND tagespreise = 1 AND  (nummer LIKE '%$term%' OR name_de LIKE '%$term%' OR nummer LIKE '%$term2%' OR name_de LIKE '%$term2%' OR nummer LIKE '%$term3%' OR name_de LIKE '%$term3%' OR herstellernummer LIKE '%$term%' OR ean LIKE '%$term%' ".($artikel_freitext1_suche?" OR freifeld1 LIKE '%$term%' ":"").") AND geloescht=0 AND intern_gesperrt!=1 $tmp_where LIMIT 20");
        for($i=0;$i<count($arr);$i++)
          $newarr[] = $arr[$i]['name'];
        break;

      case "keinelagerartikelnummer":
        $artikel_freitext1_suche = $this->app->erp->Firmendaten('artikel_freitext1_suche');
        $arr = $this->app->DB->SelectArr("SELECT CONCAT(nummer,' ',name_de) as name 
            FROM artikel WHERE (nummer LIKE '%$term%' OR name_de LIKE '%$term%' OR name_de LIKE '%$term2%' OR  name_de LIKE '%$term3%'  OR herstellernummer LIKE '%$term%' OR ean LIKE '%$term%'".($artikel_freitext1_suche?" OR freifeld1 LIKE '%$term%' ":"").") AND geloescht=0  AND intern_gesperrt!=1
            AND lagerartikel!='1' LIMIT 20");
        for($i=0;$i<count($arr);$i++)
          $newarr[] = $arr[$i]['name'];
        break;
 
      case "lagerartikelnummer":
        $artikel_freitext1_suche = $this->app->erp->Firmendaten('artikel_freitext1_suche');
        $arr = $this->app->DB->SelectArr("SELECT CONCAT(nummer,' ',name_de) as name 
            FROM artikel WHERE (nummer LIKE '%$term%' OR name_de LIKE '%$term%' OR name_de LIKE '%$term2%' OR  name_de LIKE '%$term3%'  OR herstellernummer LIKE '%$term%' OR ean LIKE '%$term%'".($artikel_freitext1_suche?" OR freifeld1 LIKE '%$term%' ":"").") AND geloescht=0  AND intern_gesperrt!=1
            AND lagerartikel='1' LIMIT 20");
        for($i=0;$i<count($arr);$i++)
          $newarr[] = $arr[$i]['name'];
        break;
        
      case "lagerartikelnummerohnechargemhdseriennummer":
        $artikel_freitext1_suche = $this->app->erp->Firmendaten('artikel_freitext1_suche');
        $arr = $this->app->DB->SelectArr("SELECT CONCAT(nummer,' ',name_de) as name 
            FROM artikel WHERE (nummer LIKE '%$term%' OR name_de LIKE '%$term%' OR name_de LIKE '%$term2%' OR  name_de LIKE '%$term3%'  OR herstellernummer LIKE '%$term%' OR ean LIKE '%$term%'".($artikel_freitext1_suche?" OR freifeld1 LIKE '%$term%' ":"").") AND geloescht=0  AND intern_gesperrt!=1
            AND lagerartikel='1' AND chargenverwaltung = 0 AND mindesthaltbarkeitsdatum <> 1 AND (seriennummern = '' OR seriennummern = 'keine') ".$this->app->erp->ProjektRechte('projekt')." LIMIT 20");
        for($i=0;$i<count($arr);$i++)
          $newarr[] = $arr[$i]['name'];
        break;
     
      
      case "chargenartikel":
        $artikel_freitext1_suche = $this->app->erp->Firmendaten('artikel_freitext1_suche');
        $arr = $this->app->DB->SelectArr("SELECT CONCAT(nummer,' ',name_de) as name 
            FROM artikel WHERE (nummer LIKE '%$term%' OR name_de LIKE '%$term%' OR name_de LIKE '%$term2%' OR  name_de LIKE '%$term3%'  OR herstellernummer LIKE '%$term%' OR ean LIKE '%$term%'".($artikel_freitext1_suche?" OR freifeld1 LIKE '%$term%' ":"").") AND geloescht=0  AND intern_gesperrt!=1
            AND chargenverwaltung > 0  ".$this->app->erp->ProjektRechte('projekt')." LIMIT 20");
        for($i=0;$i<count($arr);$i++)
          $newarr[] = $arr[$i]['name'];
        break;
        
      case "artikelnummerlager":
        $lager_platz = (int)$this->app->Secure->GetGET("lager_platz");
        $lwhere = '';
        if($lager_platz)$lwhere = " and lpi.lager_platz = '$lager_platz' ";
        $artikel_freitext1_suche = $this->app->erp->Firmendaten('artikel_freitext1_suche');
        $arr = $this->app->DB->SelectArr("SELECT CONCAT(ar.nummer,' ',ar.name_de) as name 
            FROM artikel ar INNER JOIN lager_platz_inhalt lpi ON ar.id=lpi.artikel WHERE (ar.nummer LIKE '%$term%' OR ar.name_de LIKE '%$term%' OR ar.name_de LIKE '%$term2%' OR  ar.name_de LIKE '%$term3%'  OR ar.herstellernummer LIKE '%$term%' OR ar.ean LIKE '%$term%'".($artikel_freitext1_suche?" OR ar.freifeld1 LIKE '%$term%' ":"").") AND ar.geloescht=0  AND ar.intern_gesperrt!=1
            AND ar.lagerartikel='1' $lwhere GROUP BY CONCAT(ar.nummer,' ',ar.name_de) ".$this->app->erp->ProjektRechte('ar.projekt')."  LIMIT 20");

        for($i=0;$i<count($arr);$i++)
          $newarr[] = $arr[$i]['name'];
        break;
        
  

      case "artikelnummerprojekt":
        $artikel_freitext1_suche = $this->app->erp->Firmendaten('artikel_freitext1_suche');
        $projekt = $this->app->Secure->GetGET("projekt");
        $checkprojekt = $this->app->DB->Select("SELECT id FROM projekt WHERE id='$projekt' LIMIT 1");
        $eigenernummernkreis = $this->app->DB->Select("SELECT eigenernummernkreis FROM projekt WHERE id='$projekt' LIMIT 1");
        $eanherstellerscan = $this->app->DB->Select("SELECT eanherstellerscan FROM projekt WHERE id='$projekt'");

        if($checkprojekt > 0 && $eigenernummernkreis=="1") $tmp_where = " AND a.projekt='$checkprojekt' ";
        else $tmp_where = "";

        // besser ist wenn man die immer scannt da es oberflächen gibt wo das projekt nicht angegeben werden kann
        if(0)//$eanherstellerscan)	
        {
          $arr = $this->app->DB->SelectArr("SELECT DISTINCT CONCAT(a.nummer,' ',a.name_de,if(a.herstellernummer IS NULL OR a.herstellernummer='','',CONCAT(' PN: ',a.herstellernummer))) as name FROM artikel a WHERE a.geloescht=0 AND a.intern_gesperrt!=1 AND (a.nummer LIKE '%$term%' OR a.name_de LIKE '%$term%' OR a.herstellernummer LIKE '%$term%' OR a.ean LIKE '%$term%'".($artikel_freitext1_suche?" OR freifeld1 LIKE '%$term%' ":"").") $tmp_where ORDER by a.id DESC LIMIT 20");
        }
        else {
          $arr = $this->app->DB->SelectArr("SELECT DISTINCT CONCAT(a.nummer,' ',a.name_de,if(a.herstellernummer IS NULL OR a.herstellernummer='','',CONCAT(' PN: ',a.herstellernummer))) as name FROM artikel a WHERE a.geloescht=0 AND a.intern_gesperrt!=1 AND (a.nummer LIKE '%$term%' OR a.name_de LIKE '%$term%' OR a.name_de LIKE '%$term2%' OR  a.name_de LIKE '%$term3%' OR a.herstellernummer LIKE '%$term%' OR a.ean LIKE '%$term%'".($artikel_freitext1_suche?" OR freifeld1 LIKE '%$term%' ":"").") $tmp_where ORDER by a.id DESC LIMIT 20");

        }
        for($i=0;$i<count($arr);$i++)
          $newarr[] = $arr[$i]['name'];
        break;


      case "lagerartikelnummerprojekt":
        $artikel_freitext1_suche = $this->app->erp->Firmendaten('artikel_freitext1_suche');
        $arr = $this->app->DB->SelectArr("SELECT CONCAT(a.nummer,' ',a.name_de,' (',p.abkuerzung,')') as name FROM artikel a LEFT JOIN projekt p ON p.id=a.projekt WHERE a.geloescht=0 AND a.porto=0 AND a.intern_gesperrt!=1  
          AND (a.nummer LIKE '%$term%' OR a.name_de LIKE '%$term%' OR a.herstellernummer LIKE '%$term%' OR a.ean LIKE '%$term%') LIMIT 20");
            for($i=0;$i<count($arr);$i++)
            $newarr[] = $arr[$i]['name'];
            break;


      case "verkaufartikelnummerprojekt":
        $artikel_freitext1_suche = $this->app->erp->Firmendaten('artikel_freitext1_suche');
        $projekt = $this->app->Secure->GetGET("projekt");
        $checkprojekt = $this->app->DB->Select("SELECT id FROM projekt WHERE id='$projekt' LIMIT 1");
        $eigenernummernkreis = $this->app->DB->Select("SELECT eigenernummernkreis FROM projekt WHERE id='$projekt' LIMIT 1");

        $smodule = $this->app->Secure->GetGET("smodule");	
        $sid = $this->app->Secure->GetGET("sid");	
        $adresse = $this->app->DB->Select("SELECT adresse FROM $smodule WHERE id='$sid' LIMIT 1");
        $tmp_where = $this->app->erp->ProjektRechte('p.id', true, '', array(0, $projekt));
        //if($checkprojekt > 0 && $eigenernummernkreis=="1") $tmp_where = $this->app->erp->ProjektRechte();
        //else $tmp_where = "";

        $arr = $this->app->DB->SelectArr("SELECT a.id as id, CONCAT(a.nummer,' ',a.name_de,' (',p.abkuerzung,if(a.lagerartikel=1,'',''),')',if(a.herstellernummer!='',CONCAT(' (PN: ',a.herstellernummer,')'),'')) as name FROM artikel a LEFT JOIN projekt p ON p.id=a.projekt WHERE a.geloescht=0 AND a.intern_gesperrt!=1  
          AND (a.nummer LIKE '%$term%' OR a.name_de LIKE '%$term%' OR a.herstellernummer LIKE '%$term%' OR a.nummer LIKE '%$term2%' OR a.name_de LIKE '%$term2%' ".($artikel_freitext1_suche?" OR freifeld1 LIKE '%$term2%' ":"")." OR a.herstellernummer LIKE '%$term2%' OR a.nummer LIKE '%$term3%' OR a.name_de LIKE '%$term3%' OR a.herstellernummer LIKE '%$term3%' OR a.ean LIKE '%$term%' OR CONCAT(a.nummer,' ',a.name_de) LIKE '%$term%') $tmp_where LIMIT 20");


        $rabatt = $this->app->DB->Select("SELECT realrabatt FROM $smodule WHERE id='$sid' LIMIT 1");
        

        for($i=0;$i<count($arr);$i++)
        {

          $arr[$i]['name'] = $this->app->DB->Select("SELECT CONCAT(nummer,' ',name_de,if(herstellernummer!='',CONCAT(' (PN: ',herstellernummer,')'),'') ) FROM artikel WHERE id='".$arr[$i]['id']."' LIMIT 1");
          $keinrabatterlaubt = $this->app->DB->Select("SELECT keinrabatterlaubt FROM artikel WHERE id='".$arr[$i]['id']."' LIMIT 1");
          $checkporto = $this->app->DB->Select("SELECT porto FROM artikel WHERE id='".$arr[$i]['id']."' LIMIT 1");
          $gruppenarray = $this->app->erp->GetGruppen($adresse);

          if(count($gruppenarray)>0) $sql_erweiterung = " OR ";
          for($gi=0;$gi<count($gruppenarray);$gi++)
          {
            $sql_erweiterung .= " gruppe='".$gruppenarray[$gi]."' ";

            if($gi<count($gruppenarray)-1)
              $sql_erweiterung .= " OR ";
          }

          $vkarr = $this->app->erp->GeneratePreisliste($arr[$i]['id'],$adresse,$rabatt);

          $check_lagerartikel = $this->app->DB->Select("SELECT lagerartikel FROM artikel WHERE id='".$arr[$i]['id']."' LIMIT 1");
          //$newarr[]=$arr[$i]['name']." ($label Inkl. Rabatt ".$rabatt."%: ".$this->app->erp->Rabatt($arr[$i]['preis'],$rabatt).")";
          if($this->app->erp->LagerFreieMenge($arr[$i]['id']) <= 0 && $check_lagerartikel) $lager=" (Aktuell kein Lagerbestand) "; else $lager="";

          for($vi=0;$vi<count($vkarr);$vi++)
          {
            $tmprabatt = $rabatt;
            if($vkarr[$vi]['art']=="Kunde" && ($vkarr[$vi]['adresse']<=0 || $vkarr[$vi]['adresse']==""))
              $vkarr[$vi]['art']="Standardpreis";

            $preis = 0;
            if($letzte_menge !=$vkarr[$vi]['ab_menge'])
            {
              if($keinrabatterlaubt=="1" || $checkporto=="1")
              {
                $preis = $vkarr[$vi]['preis']; //$this->app->erp->GetVerkaufspreis($arr[$i]['id'],$vkarr[$vi][ab_menge],$adresse);

                $newarr[]=$arr[$i]['name']." $lager ab Menge ".$vkarr[$vi]['ab_menge']." | Preis: ".$preis.
                  " (".$vkarr[$vi]['art']." - Kein Rabatt erlaubt) ";

              } else {
                if($this->app->erp->IsSpezialVerkaufspreis($arr[$i]['id'],$vkarr[$vi]['ab_menge'],$adresse))
                {
                  $tmprabatt=0;
                  $rabatt_string = " - Kein Rabatt auf Spezialpreis";
                  $uvp_string = "(UVP: ".$this->app->erp->GetVerkaufspreis($arr[$i]['id'],$vkarr[$vi]['ab_menge'],$adresse).") ";
                } else {
                  if($tmprabatt > 0) {
                    $rabatt_string = " Inkl. Rabatt ".$tmprabatt."%"; 
                    $uvp_string = "(UVP: ".$this->app->erp->GetVerkaufspreis($arr[$i]['id'],$vkarr[$vi]['ab_menge'],$adresse).") ";
                  } else {
                    $rabatt_string = "";
                    $uvp_string = "";
                  }
                }
                if($this->app->erp->Firmendaten("viernachkommastellen_belege"))
                  $preis = number_format(rtrim($vkarr[$vi]['preis'],0),4,',','.'); //$this->app->erp->GetVerkaufspreis($arr[$i]['id'],$vkarr[$vi][ab_menge],$adresse);
                else
                  $preis = number_format(rtrim($vkarr[$vi]['preis'],0),2,',','.'); //$this->app->erp->GetVerkaufspreis($arr[$i]['id'],$vkarr[$vi][ab_menge],$adresse);

                $newarr[]=$arr[$i]['name']." $lager ab Menge ".$vkarr[$vi]['ab_menge']." | Preis: ".$preis. 
                  " $uvp_string(".$vkarr[$vi]['art'].$rabatt_string.") ";
              }
            }
          }	

          if($vi==0)
          {
            $rabattartikel = $this->app->DB->Select("SELECT rabatt FROM artikel WHERE id='".$arr[$i]['id']."' LIMIT 1");
            $rabattartikel_prozent = $this->app->DB->Select("SELECT rabatt_prozent FROM artikel WHERE id='".$arr[$i]['id']."' LIMIT 1");
            $arr[$i]['name'] = $this->app->DB->Select("SELECT CONCAT(nummer,' ',name_de,if(herstellernummer!='',CONCAT(' (PN: ',herstellernummer,')'),'')) FROM artikel WHERE id='".$arr[$i]['id']."' LIMIT 1");

            if($rabattartikel=="1")
              $newarr[] = $arr[$i]['name']." $lager ab Menge 1 | Preis: $rabattartikel_prozent% Rabatt auf Gesamtsumme ohne Porto";
            else {
              $preis = $this->app->erp->GetVerkaufspreis($arr[$i]['id'],1,$adresse);
              if($preis > 0)
                $newarr[] = $arr[$i]['name']." $lager ab Menge 1 | Preis: $preis";
              else
                $newarr[] = $arr[$i]['name']." $lager ab Menge 1 | Preis: nicht vorhanden";
            }
          }
        }
        break;

            case "einkaufartikelnummerprojekt":
        $adresse = $this->app->Secure->GetGET("adresse");

        $arr = $this->app->DB->SelectArr("SELECT CONCAT(a.nummer,' ', a.name_de,' | Bezeichnung bei Lieferant ',IFNULL(e.bestellnummer,'nicht vorhanden'),' ',LEFT(IFNULL(e.bezeichnunglieferant,'nicht vorhanden'),50),' | ',' ab Menge ',IFNULL(e.ab_menge,1), ' | Preis ',IFNULL(e.preis,0)) as name FROM artikel a 
            LEFT JOIN projekt p ON p.id=a.projekt LEFT JOIN einkaufspreise e ON e.artikel=a.id WHERE a.tagespreise = 0 AND a.geloescht=0 AND a.intern_gesperrt!=1 AND (((e.gueltig_bis > NOW() OR e.gueltig_bis='0000-00-00') AND e.adresse='$adresse') OR a.allelieferanten=1)
            AND (a.nummer LIKE '%$term%' OR a.name_de LIKE '%$term%' OR a.name_de LIKE '%$term2%' OR a.name_de LIKE '%$term3%' OR e.bezeichnunglieferant LIKE '%$term%' OR e.bestellnummer LIKE '%$term%' OR e.bezeichnunglieferant LIKE '%$term2%' OR e.bestellnummer LIKE '%$term2%'OR e.bezeichnunglieferant LIKE '%$term3%' OR e.bestellnummer LIKE '%$term3%') GROUP by a.nummer, e.ab_menge LIMIT 20");
        for($i=0;$i<count($arr);$i++)
          $newarr[] = $arr[$i]['name'];
        break;

            case "lieferantname":
        $arr = $this->app->DB->SelectArr("SELECT name FROM adresse WHERE geloescht=0 AND a.lieferantennummer!='' AND a.lieferantennummer!='0' AND (name LIKE '%$term%' OR name LIKE '%$term2%' OR name LIKE '%$term3%') order by name LIMIT 20");
        for($i=0;$i<count($arr);$i++)
          $newarr[] = $arr[$i]['name'];
        break;

            case "lieferant":
        //$arr = $this->app->DB->SelectArr("SELECT CONCAT(a.lieferantennummer,' ',a.name) as name FROM adresse a LEFT JOIN projekt p ON p.id=a.projekt WHERE a.geloescht=0 AND a.lieferantennummer!='' AND lieferantennummer!='0' AND (a.name LIKE '%$term%' OR a.lieferantennummer LIKE '%$term%' OR a.name LIKE '%$term2%' OR a.name LIKE '%$term3%') ".$this->app->erp->ProjektRechte()." order by a.name LIMIT 20");
        /*
        $arr = $this->app->DB->SelectArr("SELECT a.lieferantennummer, 
          
          (SELECT 
              CONCAT(a2.lieferantennummer, ' ',a2.name)
                FROM adresse a2 WHERE a2.lieferantennummer = a.lieferantennummer ".$this->app->erp->ProjektRechte("a2.projekt")." ORDER BY  
              ".($filter_projekt?" a2.projekt = '$filter_projekt' DESC, ":"")." a2.projekt LIMIT 1
          )as name2
        FROM adresse a LEFT JOIN projekt p ON p.id=a.projekt WHERE a.geloescht=0 AND a.lieferantennummer!='' AND lieferantennummer!='0' AND (a.name LIKE '%$term%' OR a.lieferantennummer LIKE '%$term%' OR a.name LIKE '%$term2%' OR a.name LIKE '%$term3%') ".$this->app->erp->ProjektRechte()." group by a.lieferantennummer order by name2 LIMIT 20");
        */
        $arr = $this->app->DB->SelectArr("SELECT concat(a.lieferantennummer,' ',a.name) as name2
        FROM adresse a INNER JOIN   (SELECT a2.lieferantennummer,  ".($filter_projekt?"  min( if(a2.projekt = ".$filter_projekt.", -1,a2.projekt))":" min(a2.projekt) ")." as mprojekt FROM adresse a2 
              WHERE (a2.geloescht = 0 or isnull(a2.geloescht))  AND a2.lieferantennummer!='' AND a2.lieferantennummer!='0'  ".$this->app->erp->ProjektRechte("a2.projekt", true, 'a2.vertrieb')."
              group by a2.lieferantennummer) adr  
              ON a.lieferantennummer = adr.lieferantennummer AND ".($filter_projekt?"(a.projekt = adr.mprojekt OR a.projekt = $filter_projekt AND adr.mprojekt = -1)":"a.projekt = adr.mprojekt")." 
        
          WHERE a.geloescht=0 AND a.lieferantennummer!='' AND a.lieferantennummer!='0' AND (a.name LIKE '%$term%' OR a.lieferantennummer LIKE '%$term%' OR a.name LIKE '%$term2%' OR a.name LIKE '%$term3%') ".$this->app->erp->ProjektRechte("a.projekt")." group by a.lieferantennummer order by name2 LIMIT 20
        
        ");
        for($i=0;$i<count($arr);$i++)
          $newarr[] = $arr[$i]['name2'];
        break;

        case "lieferantartikel":
          $artikel = (int)$this->app->Secure->GetGET('artikel');
        $arr = $this->app->DB->SelectArr("SELECT concat(a.lieferantennummer,' ',a.name) as name2
        FROM adresse a INNER JOIN   (SELECT a2.lieferantennummer,  ".($filter_projekt?"  min( if(a2.projekt = ".$filter_projekt.", -1,a2.projekt))":" min(a2.projekt) ")." as mprojekt FROM adresse a2 
              WHERE (a2.geloescht = 0 or isnull(a2.geloescht))  AND a2.lieferantennummer!='' AND a2.lieferantennummer!='0'  ".$this->app->erp->ProjektRechte("a2.projekt", true, 'a2.vertrieb')."
              group by a2.lieferantennummer) adr  
              ON a.lieferantennummer = adr.lieferantennummer AND ".($filter_projekt?"(a.projekt = adr.mprojekt OR a.projekt = $filter_projekt AND adr.mprojekt = -1)":"a.projekt = adr.mprojekt")." 
          INNER JOIN einkaufspreise ep ON ep.adresse = a.id AND ep.artikel = '$artikel'
          WHERE a.geloescht=0 AND a.lieferantennummer!='' AND a.lieferantennummer!='0' AND (a.name LIKE '%$term%' OR a.lieferantennummer LIKE '%$term%' OR a.name LIKE '%$term2%' OR a.name LIKE '%$term3%') ".$this->app->erp->ProjektRechte("a.projekt")." group by a.lieferantennummer order by name2 LIMIT 20
        
        ");
        
        for($i=0;$i<count($arr);$i++)
          $newarr[] = $arr[$i]['name2'];
        break;

            case "adresse":
        $arr = $this->app->DB->SelectArr("SELECT if(a.lieferantennummer,CONCAT(a.id,' ',a.name,' (Kdr: ',a.kundennummer,' Liefr: ',a.lieferantennummer,')'),CONCAT(a.id,' ',a.name,' (Kdr: ',a.kundennummer,')')) as name FROM adresse a LEFT JOIN projekt p ON p.id=a.projekt WHERE a.geloescht=0 AND (a.name LIKE '%$term%' OR a.kundennummer LIKE '%$term%' OR a.lieferantennummer LIKE '%$term%' OR a.name LIKE '%$term2%' OR a.name LIKE '%$term3%') ".$this->app->erp->ProjektRechte()." order by a.name LIMIT 20");
        for($i=0;$i<count($arr);$i++)
          $newarr[] = $arr[$i]['name'];
        break;
       case "adressemitvertrieb":
        $arr = $this->app->DB->SelectArr("SELECT if(a.lieferantennummer,CONCAT(a.id,' ',a.name,' (Kdr: ',a.kundennummer,' Liefr: ',a.lieferantennummer,')'),CONCAT(a.id,' ',a.name,' (Kdr: ',a.kundennummer,')')) as name FROM adresse a LEFT JOIN projekt p ON p.id=a.projekt WHERE a.geloescht=0 AND (a.name LIKE '%$term%' OR a.kundennummer LIKE '%$term%' OR a.lieferantennummer LIKE '%$term%' OR a.name LIKE '%$term2%' OR a.name LIKE '%$term3%') AND ((1 ".$this->app->erp->ProjektRechte().") OR a.id = '".$this->app->User->GetAdresse()."') order by a.name LIMIT 20");
        for($i=0;$i<count($arr);$i++)
          $newarr[] = $arr[$i]['name'];
       break;
       case "kundepos":
        if($this->app->erp->Firmendaten("adresse_freitext1_suche"))
        {
          $arr = $this->app->DB->SelectArr("SELECT CONCAT(a.kundennummer,' ',a.name,if(a.projekt > 0,CONCAT(' (',p.abkuerzung,')'),''),if(a.freifeld1!='',CONCAT(' (',a.freifeld1,')'),'')) as name FROM adresse a LEFT JOIN projekt p ON p.id=a.projekt WHERE a.geloescht=0 AND a.kundennummer!='' AND a.kundennummer!='0' AND (a.name LIKE '%$term%' OR a.kundennummer LIKE '%$term%' OR a.freifeld1 LIKE '%$term%' OR a.plz LIKE '%$term%' OR a.name LIKE '%$term2%' OR a.name LIKE '%$term3%' OR a.ansprechpartner LIKE '%$term%' OR a.ansprechpartner LIKE '%$term2%' OR a.ansprechpartner LIKE '%$term3%') order by name LIMIT 20");
        } else {
          $arr = $this->app->DB->SelectArr("SELECT CONCAT(a.kundennummer,' ',a.name,if(a.projekt > 0,CONCAT(' (',p.abkuerzung,')'),'')) as name FROM adresse a LEFT JOIN projekt p ON p.id=a.projekt WHERE a.geloescht=0 AND a.kundennummer!='' AND a.kundennummer!='0'   AND (a.name LIKE '%$term%' OR a.kundennummer LIKE '%$term%' OR a.name LIKE '%$term2%' OR a.name LIKE '%$term3%' OR a.ansprechpartner LIKE '%$term%' OR a.ansprechpartner LIKE '%$term2%' OR a.ansprechpartner LIKE '%$term3%') order by name LIMIT 20");
        }
        for($i=0;$i<count($arr);$i++)
          $newarr[] = $arr[$i]['name'];
        break;



            case "kunde":
        if($this->app->erp->Firmendaten("adresse_freitext1_suche"))
        {
          
          //$arr = $this->app->DB->SelectArr("SELECT CONCAT(a.kundennummer,' ',a.name,if(a.freifeld1!='',CONCAT(' (',a.freifeld1,')'),'')) as name FROM adresse a LEFT JOIN projekt p ON p.id=a.projekt WHERE a.geloescht=0 AND a.kundennummer!='' AND a.kundennummer!='0' AND (a.name LIKE '%$term%' OR a.kundennummer LIKE '%$term%' OR a.freifeld1 LIKE '%$term%' OR a.plz LIKE '%$term%' OR a.name LIKE '%$term2%' OR a.name LIKE '%$term3%') ".$this->app->erp->ProjektRechte()." ".($filter_projekt?" AND (a.projekt = '$filter_projekt' or a.projekt = 0) ":"")." order by name LIMIT 20");
          
          $arr = $this->app->DB->SelectArr("
          SELECT CONCAT(a.kundennummer, ' ',a.name,if(a.freifeld1!='',CONCAT(' (',a.freifeld1,')'),'')) as name FROM adresse a INNER JOIN
              (SELECT a2.kundennummer,  ".($filter_projekt?"  min( if(a2.projekt = ".$filter_projekt.", -1,a2.projekt))":" min(a2.projekt) ")." as mprojekt FROM adresse a2 
              WHERE (a2.geloescht = 0 or isnull(a2.geloescht))  AND a2.kundennummer!='' AND a2.kundennummer!='0'  ".$this->app->erp->ProjektRechte("a2.projekt", true, 'a2.vertrieb')."
              group by a2.kundennummer) adr 
              ON a.kundennummer = adr.kundennummer AND ".($filter_projekt?"(a.projekt = adr.mprojekt OR a.projekt = $filter_projekt AND adr.mprojekt = -1)":"a.projekt = adr.mprojekt")." 
              WHERE (a.name LIKE '%$term%' OR a.kundennummer LIKE '%$term%' OR a.freifeld1 LIKE '%$term%' OR a.plz LIKE '%$term%' OR a.name LIKE '%$term2%' OR a.name LIKE '%$term3%') 
          ".$this->app->erp->ProjektRechte("a.projekt", true, 'a.vertrieb')."
              GROUP by a.kundennummer, a.name
              order by name LIMIT 20
          ");
          /*
          $arr = $this->app->DB->SelectArr("SELECT a.kundennummer, a.ort,
          
          (SELECT 
              CONCAT(a2.kundennummer, ' ',a2.name,if(a2.freifeld1!='',CONCAT(' (',a2.freifeld1,')'),''))
                FROM adresse a2 WHERE a2.kundennummer = a.kundennummer ".$this->app->erp->ProjektRechte("a2.projekt", true, 'a2.vertrieb')." ORDER BY  
              ".($filter_projekt?" a2.projekt = '$filter_projekt' DESC, ":"")." a2.projekt LIMIT 1
          )as name
          
          FROM adresse a LEFT JOIN projekt p ON p.id=a.projekt 
          WHERE a.geloescht=0 AND a.kundennummer!='' AND a.kundennummer!='0' 
          AND (a.name LIKE '%$term%' OR a.kundennummer LIKE '%$term%' OR a.freifeld1 LIKE '%$term%' OR a.plz LIKE '%$term%' OR a.name LIKE '%$term2%' OR a.name LIKE '%$term3%') 
          ".$this->app->erp->ProjektRechte("p.id", true, 'a.vertrieb')."  GROUP BY a.kundennummer
          order by name LIMIT 20");*/

          
          //$arr = $this->app->DB->SelectArr("SELECT CONCAT(a.kundennummer,' ',a.name,if(a.freifeld1!='',CONCAT(' (',a.freifeld1,')'),'')) as name2, (SELECT a.kundennummer FROM adresse a2 WHERE a2.kundennummer = a.kundennummer ".$this->app->erp->ProjektRechte('a2.projekt')." order by ".($filter_projekt?" a2.projekt = '$filter_projekt' DESC, ":"")." a2.projekt = 0 DESC, a2.projekt LIMIT 1)  FROM adresse a LEFT JOIN projekt p ON p.id=a.projekt WHERE a.geloescht=0 AND a.kundennummer!='' AND a.kundennummer!='0' AND (a.name LIKE '%$term%' OR a.kundennummer LIKE '%$term%' OR a.freifeld1 LIKE '%$term%' OR a.plz LIKE '%$term%' OR a.name LIKE '%$term2%' OR a.name LIKE '%$term3%') ".$this->app->erp->ProjektRechte()." group by a.kundennummer order by name2 LIMIT 20");
        } else {
          //$arr = $this->app->DB->SelectArr("SELECT CONCAT(a.kundennummer,' ',a.name) as name FROM adresse a LEFT JOIN projekt p ON p.id=a.projekt WHERE a.geloescht=0 AND a.kundennummer!='' AND a.kundennummer!='0'   AND (a.name LIKE '%$term%' OR a.kundennummer LIKE '%$term%' OR a.name LIKE '%$term2%' OR a.name LIKE '%$term3%') ".$this->app->erp->ProjektRechte()." ".($filter_projekt?" AND (a.projekt = '$filter_projekt' or a.projekt = 0) ":"")." order by name LIMIT 20");
          //$arr = $this->app->DB->SelectArr("SELECT CONCAT(a.kundennummer,' ',a.name) as name2, (SELECT a.kundennummer FROM adresse a2 WHERE a2.kundennummer = a.kundennummer ".$this->app->erp->ProjektRechte('a2.projekt')." order by ".($filter_projekt?" a2.projekt = '$filter_projekt' DESC, ":"")." a2.projekt = 0 DESC, a2.projekt LIMIT 1)  FROM adresse a LEFT JOIN projekt p ON p.id=a.projekt WHERE a.geloescht=0 AND a.kundennummer!='' AND a.kundennummer!='0' AND (a.name LIKE '%$term%' OR a.kundennummer LIKE '%$term%' OR a.plz LIKE '%$term%' OR a.name LIKE '%$term2%' OR a.name LIKE '%$term3%') ".$this->app->erp->ProjektRechte()." group by a.kundennummer order by name2 LIMIT 20");
/*
          $arr = $this->app->DB->SelectArr("SELECT a.kundennummer, a.ort,
          
          (SELECT 
              CONCAT(a2.kundennummer, ' ',a2.name)
                FROM adresse a2 WHERE a2.kundennummer = a.kundennummer ".$this->app->erp->ProjektRechte("a2.projekt",true, 'a2.vertrieb')." ORDER BY  
              ".($filter_projekt?" a2.projekt = '$filter_projekt' DESC, ":"")." a2.projekt LIMIT 1
          )as name
          
          FROM adresse a LEFT JOIN projekt p ON p.id=a.projekt 
          WHERE a.geloescht=0 AND a.kundennummer!='' AND a.kundennummer!='0' 
          AND (a.name LIKE '%$term%' OR a.kundennummer LIKE '%$term%'  OR a.plz LIKE '%$term%' OR a.name LIKE '%$term2%' OR a.name LIKE '%$term3%') 
          ".$this->app->erp->ProjektRechte("p.id", true, 'a.vertrieb')."  GROUP BY a.kundennummer
          order by name LIMIT 20");*/
          
          $arr = $this->app->DB->SelectArr("
          SELECT CONCAT(a.kundennummer, ' ',a.name) as name FROM adresse a INNER JOIN
              (SELECT a2.kundennummer,  ".($filter_projekt?"  min( if(a2.projekt = ".$filter_projekt.", -1,a2.projekt))":" min(a2.projekt) ")." as mprojekt FROM adresse a2 
              WHERE (a2.geloescht = 0 or isnull(a2.geloescht))  AND a2.kundennummer!='' AND a2.kundennummer!='0'  ".$this->app->erp->ProjektRechte("a2.projekt", true, 'a2.vertrieb')."
              group by a2.kundennummer) adr 
              ON a.kundennummer = adr.kundennummer AND ".($filter_projekt?"(a.projekt = adr.mprojekt OR a.projekt = $filter_projekt AND adr.mprojekt = -1)":"a.projekt = adr.mprojekt")." 
              WHERE (a.name LIKE '%$term%' OR a.kundennummer LIKE '%$term%' OR a.plz LIKE '%$term%' OR a.name LIKE '%$term2%' OR a.name LIKE '%$term3%') 
          ".$this->app->erp->ProjektRechte("a.projekt", true, 'a.vertrieb')."
              GROUP by a.kundennummer, a.name
              order by name LIMIT 20
          ");
        }
        for($i=0;$i<count($arr);$i++)
        {
          if($arr[$i]['ort']!="")
            $newarr[] = $arr[$i]['name']." (".$arr[$i]['ort'].")";
          else
            $newarr[] = $arr[$i]['name'];
        }
        break;

            case "mitarbeiter":
        $arr = $this->app->DB->SelectArr("SELECT CONCAT(mitarbeiternummer,' ',name) as name FROM adresse WHERE geloescht=0 AND mitarbeiternummer!='' AND mitarbeiternummer!='0' AND (name LIKE '%$term%' OR mitarbeiternummer LIKE '%$term%') order by name LIMIT 20");
        for($i=0;$i<count($arr);$i++)
          $newarr[] = $arr[$i]['name'];
        break;

            case "mitarbeitername":
        $arr = $this->app->DB->SelectArr("SELECT name FROM adresse WHERE geloescht=0 AND mitarbeiternummer!='' AND mitarbeiternummer!='0' AND (name LIKE '%$term%' OR mitarbeiternummer LIKE '%$term%') order by name LIMIT 20");
        for($i=0;$i<count($arr);$i++)
          $newarr[] = $arr[$i]['name'];
        break;
        
        case "emailadresse":
        if(strpos($term,',')!==false)
        {
          $term = substr($term,strripos($term,','));
          $term = str_replace(',','',$term);
        }
        
        $subwhere1 = '';
        $subwhere2 = '';
        if($this->app->Secure->GetGET('kundennummer'))
        {
          //$adresse = $this->app->DB->Select("SELECT id FROM adresse WHERE kundennummer like '".$this->app->Secure->GetGET('kundennummer')."' ".($filter_projekt?" AND (projekt = '$filter_projekt' or projekt = 0) ":"")." LIMIT 1");
          $adresse = $this->app->DB->Select("SELECT id FROM adresse WHERE kundennummer like '".$this->app->Secure->GetGET('kundennummer')."' AND geloescht <> 1 ORDER BY ".($filter_projekt?" projekt = '$filter_projekt' DESC,  ":"")." projekt LIMIT 1");
          if($adresse)
          {
            $subwhere1 .= " AND adresse = '$adresse' ";
            $subwhere2 .= " AND id = '$adresse' ";
          }
        }

        $arr = $this->app->DB->SelectArr("SELECT email FROM ansprechpartner WHERE (name LIKE '%$term%' OR email LIKE '%$term%') and email <> '' $subwhere1 AND geloescht <> 1 order by name LIMIT 20");
        for($i=0;$i<count($arr);$i++)
          $newarr[] = $arr[$i]['email'];
        $arr = $this->app->DB->SelectArr("SELECT email  FROM adresse WHERE (name LIKE '%$term%' OR email LIKE '%$term%') and email <> '' AND geloescht!='1' $subwhere2 order by name LIMIT 20");

        for($i=0;$i<count($arr);$i++)
          $newarr[] = $arr[$i]['email'];

        $newarr = array_unique($newarr); 
        sort($newarr);
        break;


            case "emailname":
        if(strpos($term,',')!==false)
        {
          $term = substr($term,strripos($term,','));
          $term = str_replace(',','',$term);
        }

        $arr = $this->app->DB->SelectArr("SELECT CONCAT(name,' <',email,'>') as name FROM ansprechpartner WHERE (name LIKE '%$term%' OR email LIKE '%$term%') AND geloescht <> 1 order by name LIMIT 20");
        for($i=0;$i<count($arr);$i++)
          $newarr[] = $arr[$i]['name'];


        $arr = $this->app->DB->SelectArr("SELECT CONCAT(name,' <',email,'>') as name FROM adresse WHERE (name LIKE '%$term%' OR email LIKE '%$term%') AND geloescht!='1' order by name LIMIT 20");
        for($i=0;$i<count($arr);$i++)
          $newarr[] = $arr[$i]['name'];

        $newarr = array_unique($newarr); 
        sort($newarr); 
        break;

            case "shopname":
        $arr = $this->app->DB->SelectArr("SELECT bezeichnung FROM shopexport WHERE bezeichnung LIKE '%$term%'");
        for($i=0;$i<count($arr);$i++)
          $newarr[] = $arr[$i]['bezeichnung'];
        break;

            case "gruppekennziffer":
        $arr = $this->app->DB->SelectArr("SELECT CONCAT(g.kennziffer,' ',g.name) as bezeichnung FROM gruppen g LEFT JOIN projekt p ON p.id=g.projekt  
          WHERE (g.name LIKE '%$term%' OR g.kennziffer LIKE '%$term%') AND g.aktiv=1 ".$this->app->erp->ProjektRechte());
        for($i=0;$i<count($arr);$i++)
          $newarr[] = $arr[$i]['bezeichnung'];
        break;

            case "gruppe":
        $arr = $this->app->DB->SelectArr("SELECT CONCAT(g.name,' ',g.kennziffer) as bezeichnung FROM gruppen g 
          LEFT JOIN projekt p ON p.id=g.projekt WHERE (g.name LIKE '%$term%' OR g.kennziffer LIKE '%$term%') AND g.aktiv=1 ".$this->app->erp->ProjektRechte());
        for($i=0;$i<count($arr);$i++)
          $newarr[] = $arr[$i]['bezeichnung'];
        break;

            case "verband":
        $arr = $this->app->DB->SelectArr("SELECT CONCAT(name,' ',kennziffer) as bezeichnung FROM gruppen WHERE (name LIKE '%$term%' OR kennziffer LIKE '%$term%') AND aktiv=1 AND art='verband'");
        for($i=0;$i<count($arr);$i++)
          $newarr[] = $arr[$i]['bezeichnung'];
        break;

            case "projektname":
        $arr = $this->app->DB->SelectArr("SELECT CONCAT(p.abkuerzung,' ',p.name) as name FROM projekt p WHERE p.geloescht=0 AND (p.name LIKE '%$term%' OR p.name LIKE '%$term2%' OR p.name LIKE '%$term3%' OR p.abkuerzung LIKE '%$term%' OR p.abkuerzung LIKE '%$term2%' OR p.abkuerzung LIKE '%$term3%') ".$this->app->erp->ProjektRechte());
        for($i=0;$i<count($arr);$i++)
          $newarr[] = $arr[$i]['name'];
        break;
        
      case "uebertragung_account":
        $arr = $this->app->DB->SelectArr("SELECT CONCAT(u.id,' ',u.bezeichnung) as name FROM uebertragungen_account u WHERE (u.bezeichnung LIKE '%$term%') ".$this->app->erp->ProjektRechte('u.projekt'));
        for($i=0;$i<count($arr);$i++)
          $newarr[] = $arr[$i]['name'];
        break;
      break;
      case "api_account":
        $arr = $this->app->DB->SelectArr("SELECT CONCAT(u.id,' ',u.bezeichnung) as name FROM api_account u WHERE (u.bezeichnung LIKE '%$term%') ".$this->app->erp->ProjektRechte('u.projekt'));
        for($i=0;$i<count($arr);$i++)
          $newarr[] = $arr[$i]['name'];
        break;
      break;
      case "gruppen_kategorien":
        $arr = $this->app->DB->SelectArr("SELECT CONCAT(g.id,' ',g.bezeichnung) as name FROM gruppen_kategorien g 
          LEFT JOIN projekt p ON p.id=g.projekt WHERE (g.bezeichnung LIKE '%$term%' ) ".$this->app->erp->ProjektRechte());
        for($i=0;$i<count($arr);$i++)
          $newarr[] = $arr[$i]['name'];
        break;
      case "gruppenkategoriegruppen":
        $kategorie = (int)$this->app->Secure->GetGET('gkid');
        $arr = $this->app->DB->SelectArr("SELECT CONCAT(g.kennziffer,' ',g.name) as bezeichnung FROM gruppen g 
          LEFT JOIN projekt p ON p.id=g.projekt WHERE kategorie = '$kategorie' AND (g.name LIKE '%$term%' OR g.kennziffer LIKE '%$term%') AND g.aktiv=1 ".$this->app->erp->ProjektRechte());
        for($i=0;$i<count($arr);$i++)
          $newarr[] = $arr[$i]['bezeichnung'];
        break;
      break;
      case "steuersatz":
        $newarr[] = $this->app->erp->Firmendaten('steuersatz_normal').' normal';
        $newarr[] = $this->app->erp->Firmendaten('steuersatz_ermaessigt').' ermaessigt';
        $arr = $this->app->DB->SelectArr("SELECT concat(satz,' ',bezeichnung) as name FROM steuersaetze WHERE aktiv = 1 ");
        if($arr)
        {
          for($i=0;$i<count($arr);$i++)
            $newarr[] = $arr[$i]['name'];
          break;          
        }
      
      break;

            default: ;
    }

    for($i=0;$i<count($newarr);$i++)
      $tmp[] = $this->app->erp->ClearDataBeforeOutput(html_entity_decode($newarr[$i], ENT_QUOTES, 'UTF-8'));


    echo json_encode($tmp);
    $this->app->erp->ExitWawi();
  }

  function AjaxTablePosition()
  {

    $iDisplayStart = $this->app->Secure->GetGET("iDisplayStart");
    $iDisplayLength = $this->app->Secure->GetGET("iDisplayLength");
    $iSortCol_0 = $this->app->Secure->GetGET("iSortCol_0");
    $iSortingCols = $this->app->Secure->GetGET("iSortingCols");
    $sSearch = $this->app->Secure->GetGET("sSearch");
    $sEcho = $this->app->Secure->GetGET("sEcho");
    $cmd = $this->app->Secure->GetGET("cmd");


    $sLimit = "";
    if ( isset($iDisplayStart) )
    {

      $sLimit = "LIMIT ".mysqli_real_escape_string($this->app->DB->connection, $iDisplayStart ).", ".
        mysqli_real_escape_string($this->app->DB->connection, $iDisplayLength );
    }

    /* Ordering */
    if ( isset( $iSortCol_0 ) )
    {
      $sOrder = "ORDER BY  ";
      for ( $i=0 ; $i<mysqli_real_escape_string($this->app->DB->connection, $iSortingCols ) ; $i++ )
      {
        $iSortingCols_tmp = $this->app->Secure->GetGET("iSortCol_".$i);
        $sSortDir_tmp = $this->app->Secure->GetGET("sSortDir_".$i);

        $sOrder .= $this->fnColumnToFieldPosition(mysqli_real_escape_string($this->app->DB->connection, $iSortingCols_tmp ))."
          ".mysqli_real_escape_string($this->app->DB->connection, $sSortDir_tmp ) .", ";
      }
      $sOrder = substr_replace( $sOrder, "", -2 );
    }

    /* Filtering - NOTE this does not match the built-in DataTables filtering which does it
     * word by word on any field. It's possible to do here, but concerned about efficiency
     * on very large tables, and MySQL's regex functionality is very limited
     */


    $sWhere = "";
    $where = $this->app->YUI->TablePositionSearch("",$cmd,"where");
    if ( $sSearch != "" )
    {
      $searchsql = $this->app->YUI->TablePositionSearch("",$cmd,"searchsql");

      if($where=="")
        $sWhere = " WHERE (";
      else
      {
        if(count($searchsql) >0)
          $sWhere = " WHERE $where AND (";
        else
          $sWhere = " WHERE $where ";
      }

      
      for($i=0;$i<count($searchsql)-1;$i++)
      {
        $sWhere .= $searchsql[$i]." LIKE '%".mysqli_real_escape_string($this->app->DB->connection, $sSearch )."%' OR ";	
      }
      $sWhere .= $searchsql[$i]." LIKE '%".mysqli_real_escape_string($this->app->DB->connection, $sSearch )."%')";	

    
    } else {
      if($where!="")
        $sWhere = " WHERE $where ";
    } 

   
    $searchfulltext = $this->app->YUI->TablePositionSearch("",$cmd,"searchfulltext");
    if($searchfulltext!="" && $sSearch!="")
    {
      $searchfulltext = " MATCH(".$searchfulltext.") AGAINST ('$sSearch') ";	
      if($sWhere=="")
        $sWhere = " WHERE $searchfulltext ";
      else 
        $sWhere .= "AND $searchfulltext ";
    }
    $tmp = $this->app->YUI->TablePositionSearch("",$cmd,"sql");


    $sQuery = "
      $tmp
      $sWhere 
      $sOrder
      $sLimit
      ";


    $rResult = mysqli_query($this->app->DB->connection, $sQuery);



    $sQuery = "
      SELECT FOUND_ROWS()
      ";
    $rResultFilterTotal = mysqli_query($this->app->DB->connection, $sQuery);
    $aResultFilterTotal = mysqli_fetch_array($this->app->DB->connection,$rResultFilterTotal);
    $iFilteredTotal = $aResultFilterTotal[0];

    /*    
          $sQuery = "
          SELECT COUNT(id)
          FROM   artikel
          ";
     */
    $sQuery = $this->app->YUI->TablePositionSearch("",$cmd,"count");
    $rResultTotal = mysqli_query($this->app->DB->connection,$sQuery);
    $aResultTotal = mysqli_fetch_array($this->app->DB->connection,$rResultTotal);
    $iTotal = $aResultTotal[0];


    $heading = count($this->app->YUI->TablePositionSearch("",$cmd,"heading"));
    $menu = $this->app->YUI->TablePositionSearch("",$cmd,"menu");

    $sOutput = '{';
    $sOutput .= '"sEcho": '.intval($sEcho).', ';
    $sOutput .= '"iTotalRecords": '.$iTotal.', ';
    $sOutput .= '"iTotalDisplayRecords": '.$iFilteredTotal.', ';
    $sOutput .= '"aaData": [ ';
    while ( $aRow = mysqli_fetch_array($this->app->DB->connection, $rResult ) )
    {
      $sOutput .= "[";
      for($i=1;$i<$heading;$i++) 
        $sOutput .= '"'.addslashes($aRow[$i]).'",';

      $sOutput .= '"'.addslashes(str_replace('%value%',$aRow[$i],$menu)).'"';

      $sOutput .= "],";

    }
    $sOutput = substr_replace( $sOutput, "", -1 );
    $sOutput .= '] }';

    $sOutput = str_replace("\t","",$sOutput); 

    echo json_encode(json_decode($this->app->erp->ClearDataBeforeOutput($sOutput)));
    $this->app->erp->ExitWawi();
  }

  function AjaxTable()
  {
    $iDisplayStart = $this->app->Secure->GetGET("iDisplayStart");
    $iDisplayLength = $this->app->Secure->GetGET("iDisplayLength");
    $iSortCol_0 = $this->app->Secure->GetGET("iSortCol_0");
    $sSortDir_0  = $this->app->Secure->GetGET("sSortDir_0");
    $iSortingCols = $this->app->Secure->GetGET("iSortingCols");
    $sSearch = $this->app->Secure->GetGET("sSearch");
    $sEcho = $this->app->Secure->GetGET("sEcho");
    $cmd = $this->app->Secure->GetGET("cmd");
    $frommodule = $this->app->Secure->GetGET("frommodule");
    $fromclass = $this->app->Secure->GetGET("fromclass");
    $sSearch = trim($sSearch);

    $sSearch = str_replace('%','\%',$sSearch);

    $sSearch2 = $sSearch;
    $sSearch3 = $this->app->erp->ConvertForDB($sSearch);
    $sSearch = $this->app->erp->ConvertForDBUTF8($sSearch);


    $limiert = false;
    if(method_exists($this->app->erp, 'BegrenzungLivetabelle'))$limiert = 2*$this->app->erp->BegrenzungLivetabelle($cmd, mysqli_real_escape_string($this->app->DB->connection, $iDisplayLength ));
    
    $sLimit = "";
    if($limiert)
    {
      $limiert += (int)mysqli_real_escape_string($this->app->DB->connection, $iDisplayStart );
      $iDisplayLength = mysqli_real_escape_string($this->app->DB->connection, $iDisplayLength );
        $sLimit = "LIMIT ".mysqli_real_escape_string($this->app->DB->connection, $iDisplayStart ).", ".
          (mysqli_real_escape_string($this->app->DB->connection, $limiert) );
    }else{
      if ( isset($iDisplayStart) )
      {
        $iDisplayLength = mysqli_real_escape_string($this->app->DB->connection, $iDisplayLength );
        $sLimit = "LIMIT ".mysqli_real_escape_string($this->app->DB->connection, $iDisplayStart ).", ".
          mysqli_real_escape_string($this->app->DB->connection, $iDisplayLength );
      }
    }
    /* Ordering */

    // check if is allowed
    if(!$this->app->erp->TableSearchAllowed($cmd)) 
    {
      $this->app->erp->Protokoll("Nicht erlaubter Zugriff auf $cmd von Benutzer ".$this->app->User->GetName());
      $this->app->erp->ExitWawi();
    }
  
    $YUIs = $this->app->YUI->TableSearch("",$cmd,"ALL","","",$frommodule, $fromclass);

    //$findcolstmp = $this->app->YUI->TableSearch("",$cmd,"findcols","","",$frommodule, $fromclass);
    $findcolstmp = $YUIs['findcols'];
    //$moreinfo = $this->app->YUI->TableSearch("",$cmd,"moreinfo","","",$frommodule, $fromclass);
    $moreinfo = $YUIs['moreinfo'];

    if (isset( $iSortCol_0 ) && $sEcho > 1)
    {
      $sOrder = "ORDER BY  ";
      //	if($iSortCol_0 <=1)

      if($moreinfo)
      {
        if($iSortCol_0 <1)
          goto default_sort;
        else
          $iSortCol_0 = $iSortCol_0 + 1;
      } else {
        $iSortCol_0 = $iSortCol_0 + 1;

      }
      $sOrder = "ORDER BY ".$findcolstmp[$iSortCol_0-1]." $sSortDir_0";
    }
    else
    {
  default_sort:
      //standard einstellung nach datum absteigend wenn datumsspalte vorhanden
      //$defaultorder = $this->app->YUI->TableSearch("",$cmd,"defaultorder","","",$frommodule, $fromclass);
      $defaultorder = $YUIs['defaultorder'];
      //$defaultorderdesc = $this->app->YUI->TableSearch("",$cmd,"defaultorderdesc","","",$frommodule, $fromclass);
      $defaultorderdesc = $YUIs['defaultorderdesc'];
      if($defaultorder<=0) { $defaultorder = count($findcolstmp); $defaultorderdesc = 1;}

      if($defaultorderdesc=="1") $defaultorderdesc = " DESC"; else $defaultorderdesc="";


      if($defaultorder >=0 && is_numeric($defaultorder))
      {
        $defaultorder = $defaultorder + 1;
        //$findcolstmp = $this->app->YUI->TableSearch("",$cmd,"findcols","","",$frommodule, $fromclass);
        $findcolstmp = $YUIs['findcols'];

        $sOrder = "ORDER BY ".$findcolstmp[$defaultorder-2]." $defaultorderdesc";
      }
    }




    /* Filtering - NOTE this does not match the built-in DataTables filtering which does it
     * word by word on any field. It's possible to do here, but concerned about efficiency
     * on very large tables, and MySQL's regex functionality is very limited
     */
    //echo "FUUUU";

    $sWhere = "";
    //$where = $this->app->YUI->TableSearch("",$cmd,"where","","",$frommodule, $fromclass);
    $where = $YUIs['where'];
    //echo $where;
    if ( $sSearch != "" )
    {
      /*
         $sWhere = "WHERE a.nummer LIKE '%".mysqli_real_escape_string($this->app->DB->connection, $sSearch )."%' OR ".
         "p.abkuerzung LIKE '%".mysqli_real_escape_string($this->app->DB->connection, $sSearch )."%' OR ".
         "a.name_de LIKE '%".mysqli_real_escape_string($this->app->DB->connection, $sSearch )."%'";
       */
      //$searchsql = $this->app->YUI->TableSearch("",$cmd,"searchsql","","",$frommodule, $fromclass);
      $searchsql = $YUIs['searchsql'];
      if($where=="")
        $sWhere = " WHERE (";
      else
      {
        if(count($searchsql) > 0)
          $sWhere = " WHERE $where AND (";
        else
          $sWhere = " WHERE $where ";
      }

      // Prozent austauschen da dies mysql wildcat ist
      $sSearch = str_replace('&#37;','%',$sSearch);
      $sSearch = str_replace(' ','%',$sSearch);
      $sSearch2 = str_replace('&#37;','%',$sSearch2);
      $sSearch2 = str_replace(' ','%',$sSearch2);
      //$sSearch3 = str_replace('&#37;','%',$sSearch3);
      //$sSearch3 = str_replace(' ','%',$sSearch3);

      for($i=0;$i<count($searchsql)-1;$i++)
      {
        if(mysqli_real_escape_string($this->app->DB->connection, $sSearch ) !== $this->app->erp->ConvertForTableSearch( $sSearch ))
        {
          $sWhere .= "({$searchsql[$i]} LIKE '%".mysqli_real_escape_string($this->app->DB->connection, $sSearch )."%' OR {$searchsql[$i]} LIKE '%".$this->app->erp->ConvertForTableSearch( $sSearch )."%' ) ";
        }else{
          $sWhere .= "({$searchsql[$i]} LIKE '%".mysqli_real_escape_string($this->app->DB->connection, $sSearch )."%') ";
        }

        
        if($sSearch2!="" && ($sSearch2 !== $sSearch))
        {
          if(mysqli_real_escape_string($this->app->DB->connection, $sSearch2 ) !== $this->app->erp->ConvertForTableSearch( $sSearch2 ))
          {
            $sWhere .=" OR ({$searchsql[$i]} LIKE '%".mysqli_real_escape_string($this->app->DB->connection, $sSearch2 )."%' OR {$searchsql[$i]} LIKE '%".$this->app->erp->ConvertForTableSearch( $sSearch2 )."%' ) ";
          }else{
            $sWhere .=" OR ({$searchsql[$i]} LIKE '%".mysqli_real_escape_string($this->app->DB->connection, $sSearch2 )."%') ";
          }
        }

        if($sSearch3!="" && ($sSearch3 !== $sSearch || $sSearch3 !== $sSearch2))
        {
          if(mysqli_real_escape_string($this->app->DB->connection, $sSearch3 ) !== $this->app->erp->ConvertForTableSearch( $sSearch3 ))
          {
            $sWhere .= "OR ({$searchsql[$i]} LIKE '%".mysqli_real_escape_string($this->app->DB->connection, $sSearch3 )."%' OR {$searchsql[$i]} LIKE '%".$this->app->erp->ConvertForTableSearch( $sSearch3 )."%' ) OR ";
          }else{
            $sWhere .= "OR ({$searchsql[$i]} LIKE '%".mysqli_real_escape_string($this->app->DB->connection, $sSearch3 )."%') OR ";
          }
        }
        else $sWhere .= " OR ";

      }

      //$searchfulltext = $this->app->YUI->TableSearch("",$cmd,"searchfulltext","","",$frommodule, $fromclass);
      $searchfulltext = $YUIs['searchfulltext'];
      if($searchfulltext!="" && $sSearch!="")
      {
        $sSearch = str_replace("&quot;",'"',$sSearch);
        $sSearch .= "*";
        $searchfulltext = ' MATCH(e.subject,e.sender,e.action,e.action_html) AGAINST (\''.$this->app->erp->ConvertForTableSearch($sSearch).'\' IN BOOLEAN MODE ) ';
      }
      if(count($searchsql) > 0){
        if($searchfulltext!="") $searchfulltext = " OR ".$searchfulltext;
        if(mysqli_real_escape_string($this->app->DB->connection, $sSearch ) !== $this->app->erp->ConvertForTableSearch( $sSearch ))
        {
          $sWhere .= "( {$searchsql[$i]} LIKE '%".mysqli_real_escape_string($this->app->DB->connection, $sSearch )."%' OR {$searchsql[$i]} LIKE '%".$this->app->erp->ConvertForTableSearch( $sSearch )."%')     $searchfulltext           )";
        }else{
          $sWhere .= "( {$searchsql[$i]} LIKE '%".mysqli_real_escape_string($this->app->DB->connection, $sSearch )."%')     $searchfulltext           )";
        }

      } else {
        $sWhere .= " AND $searchfulltext";

      }

    } else {
      if($where!="")
        $sWhere = " WHERE $where ";
    } 


    //$searchsql = $this->app->YUI->TableSearch("",$cmd,"searchsql","","",$frommodule, $fromclass);
    $searchsql = $YUIs['searchsql'];
    //$moreinfo = $this->app->YUI->TableSearch("",$cmd,"moreinfo","","",$frommodule, $fromclass);
    $moreinfo = $YUIs['moreinfo'];
    if($moreinfo) $offset = 1; else $offset=0;

    for($isearch=0;$isearch<count($searchsql);$isearch++)
    {
      $sSearch = $this->app->Secure->GetGET("sSearch_".$isearch);
      if($sSearch!="" && $sSearch!="A")
      { 
        if($sWhere=="")
				{
					if($searchsql[$isearch-$offset]!="")
        		$sWhere = "WHERE ".$searchsql[$isearch-$offset]." LIKE '%".mysqli_real_escape_string($this->app->DB->connection, $sSearch )."%'";
				}
        else
				{
					if($searchsql[$isearch-$offset]!="")
        		$sWhere = "$sWhere AND (".$searchsql[$isearch-$offset]." LIKE '%".mysqli_real_escape_string($this->app->DB->connection, $sSearch )."%')";
				}
      }
    }



    //$tmp = $this->app->YUI->TableSearch("",$cmd,"sql","","",$frommodule, $fromclass);
    $tmp = $YUIs['sql'];
    //$groupby = $this->app->YUI->TableSearch("",$cmd,"groupby","","",$frommodule, $fromclass);
    $groupby = $YUIs['groupby'];
    //$orderby = $this->app->YUI->TableSearch("",$cmd,"orderby","","",$frommodule, $fromclass);
    $orderby = $YUIs['orderby'];
    
    $fastcount = isset($YUIs['fastcount'])?$YUIs['fastcount']:'';
    if($orderby)$sOrder = $orderby;
    //$sQuery = $sWhere." ".$sOrder." ". $sLimit;

    //$rResult = $this->app->DB->Query( $sQuery);
    $sQuery = "
      $tmp
      $sWhere 
      $groupby
      $sOrder
      $sLimit
      ";
      
    if($fastcount || $limiert)$sQuery = str_replace('SQL_CALC_FOUND_ROWS','',$sQuery);
      
    //SELECT * FROM emailbackup_mails e WHERE  MATCH(e.subject,e.sender,e.action,e.action_html) AGAINST ("+vetter" IN BOOLEAN MODE)
    // TABLEOUT BENE
     //echo $sQuery;
     //exit;

    $rResult = $this->app->DB->Query( $sQuery);
    if(!$limiert){
      if($fastcount)
      {
        $sQuery = "$fastcount $sWhere 
        $groupby ";
        $rResultFilterTotal = $this->app->DB->Query( $sQuery);
        $aResultFilterTotal = $this->app->DB->Fetch_Array($rResultFilterTotal);
        $iFilteredTotal = $aResultFilterTotal[0];
      }else{
        $sQuery = "
          SELECT FOUND_ROWS()
          ";
        $rResultFilterTotal = $this->app->DB->Query( $sQuery);
        $aResultFilterTotal = $this->app->DB->Fetch_Array($rResultFilterTotal);
        $iFilteredTotal = $aResultFilterTotal[0];
      }
    }
    /*    
          $sQuery = "
          SELECT COUNT(id)
          FROM   artikel
          ";
     */
    //$sQuery = $this->app->YUI->TableSearch("",$cmd,"count","","",$frommodule, $fromclass);
    if(!$limiert){
      $sQuery = $YUIs['count'];

      $rResultTotal = $this->app->DB->Query( $sQuery);
      
      $aResultTotal = $this->app->DB->Fetch_Array($rResultTotal);
      $iTotal = (int)$aResultTotal[0];
    }

    //$heading = count($this->app->YUI->TableSearch("",$cmd,"heading","","",$frommodule, $fromclass));
    $heading = count($YUIs['heading']);
    //$menu = $this->app->YUI->TableSearch("",$cmd,"menu","","",$frommodule, $fromclass);
    $menu = $YUIs['menu'];
    $sOutput2 = '';
    $rowc = 0;
    while ( $aRow = $this->app->DB->Fetch_Array( $rResult ) )
    {
      $rowc++;
      if(!$limiert || ($rowc <= $iDisplayLength))
      {
        $sOutput2 .= "[";
        for($i=1;$i<$heading;$i++) 
        {
          $aRow[$i] = $this->EntferneSteuerzeichen(trim(str_replace("'","",$aRow[$i])));
          $aRow[$i] = str_replace("\r","",$aRow[$i]);
          $aRow[$i] = str_replace("\n","",$aRow[$i]);
          $sOutput2 .= '"'.addslashes($aRow[$i]).'",';
        }

        $sOutput2 .= '"'.addslashes(str_replace('%value%',$aRow[$i],$menu)).'"';

        $sOutput2 .= "],";
      }

    }
    if($limiert)
    {
      $sOutput = '{';
      $sOutput .= '"sEcho": '.intval($sEcho).', ';
      $sOutput .= '"iTotalRecords": '.($rowc+(int)$iDisplayStart).', ';
      $sOutput .= '"iTotalDisplayRecords": '.($rowc+(int)$iDisplayStart).', ';
      $sOutput .= '"aaData": [ ';
    }else{
      $sOutput = '{';
      $sOutput .= '"sEcho": '.intval($sEcho).', ';
      $sOutput .= '"iTotalRecords": '.$iTotal.', ';
      $sOutput .= '"iTotalDisplayRecords": '.$iFilteredTotal.', ';
      $sOutput .= '"aaData": [ ';

    }
    $sOutput .= $sOutput2;
    
    $sOutput = substr_replace( $sOutput, "", -1 );
    $sOutput .= '] }';

    $sOutput = str_replace("\t","",$sOutput); 

    // Eventuell deutsches Datumsformat in allen Tabellen und sortieren geht auch
    $repl =    preg_replace('~\"([1-2]{1}\d{3})-(\d{2})-(\d{2})\"~', '"<!--$1-%s-%3--> $3.$2.$1"', $sOutput);
    $repl =    preg_replace('~\"([1-2]{1}\d{3})-(\d{2})-(\d{2})\s+~', '"<!--$1-%s-%3--> $3.$2.$1 ', $repl);
    $repl =    preg_replace('~\s+([1-2]{1}\d{3})-(\d{2})-(\d{2})\s+~', ' <!--$1-%s-%3--> $3.$2.$1 ', $repl);
    //$repl = preg_replace('~\"(\d{4})-(\d{2})-(\d{2})\"~', '"<!--$1-%s-%3-->$3.$2.$1"', $sOutput);	
    $repl = $this->app->erp->ClearDataBeforeOutput($repl);
    $repl = json_encode(json_decode($repl));
    echo $repl;
    $this->app->erp->ExitWawi();

    }

  function EntferneSteuerzeichen($string)
  {
    $len = strlen($string);
    $out = '';
    for($i = 0; $i < $len; $i++)
    {
      $ord = ord($string{$i});
      if($ord != 127 && ($ord > 31 || $ord == 13 || $ord == 10 || $ord == 9))$out .= $string{$i};
    }
    return $out;
  }
    
  function fnColumnToFieldPosition( $i )
  {
    $cmd = $this->app->Secure->GetGET("cmd");
    $findcols = $this->app->YUI->TablePositionSearch("",$cmd,"findcols");

    return $findcols[$i];
  }

  function fnColumnToField( $i )
  {
    $cmd = $this->app->Secure->GetGET("cmd");
    $frommodule = $this->app->Secure->GetGET("frommodule");
    $fromclass = $this->app->Secure->GetGET("fromclass");
    $findcols = $this->app->YUI->TableSearch("",$cmd,"findcols","","",$frommodule, $fromclass);

    return $findcols[$i];

    if ( $i == 0 )
      return "nummer";
    else if ( $i == 1 )
      return "name_de";
    else if ( $i == 2 )
      return "projekt";
    else if ( $i == 3 )
      return "id";

  }




  }

?>
