<?php
/*
**** COPYRIGHT & LICENSE NOTICE *** DO NOT REMOVE ****
* 
* WaWision (c) embedded projects GmbH, Holzbachstrasse 4, D-86154 Augsburg, * Germany 2015 
*
* This file is licensed under the Embedded Projects General Public License *Version 3.1. 
*
* You should have received a copy of this license from your vendor and/or *along with this file; If not, please visit www.wawision.de/Lizenzhinweis 
* to obtain the text of the corresponding license version.  
*
**** END OF COPYRIGHT & LICENSE NOTICE *** DO NOT REMOVE ****
*/
?>
<?php

class Appstore {
  var $app;
  
  function __construct(&$app) {
    $this->app=&$app;
    $this->app->ActionHandlerInit($this);
    $this->app->ActionHandler("list","AppstoreList");
    $this->app->DefaultActionHandler("list");
    $this->app->ActionHandlerListen($app);
  }

  function match($haystack, $needle)
  {
    $needle = strtolower($this->app->erp->UmlauteEntfernen($needle));
    $haystack = strtolower($this->app->erp->UmlauteEntfernen($haystack));
    $needlaa = explode(' ',$needle);
    foreach($needlaa as $v)
    {
      if($v)
      {
        if(strpos($haystack, $v) === false)return false;
      }
    }
    return true;
  }
  
  function GetApps($val = '')
  {
    $val = (String)$val;
    $module = $this->app->erp->getApps();
    if($module)
    {
      if(isset($module['installiert']))
      {
        foreach($module['installiert'] as $k => $v)
        {
          $module['installiert'][$k]['match'] = $this->match($v['Bezeichnung'], $val);
          $module['installiert'][$k]['md5'] = md5($v['Bezeichnung']); 
        }
      }
      if(isset($module['kauf']))
      {
        foreach($module['kauf'] as $k => $v)
        {
          $module['kauf'][$k]['match'] = $this->match($v['Bezeichnung'], $val);
          $module['kauf'][$k]['md5'] = md5($v['Bezeichnung']);
        }
      }
    }
    return $module;
  }
  
  function AppstoreList()
  {
    $this->app->erp->MenuEintrag("index.php?module=appstore&action=list","&Uuml;bersicht");
    $module = $this->getApps($this->app->Secure->GetPOST('val'));
    
    if($this->app->Secure->GetGET('cmd') == 'suche')
    {
      $anzeigen = '';
      $ausblenden = '';
      if($module)
      {
        if(isset($module['installiert']))
        {
          foreach($module['installiert'] as $k => $v)
          {
            if($v['match'])
            {
              if($anzeigen != '')$anzeigen .= ';';
              $anzeigen .= 'm'.md5($v['Bezeichnung']);
            }else{
              if($ausblenden != '')$ausblenden .= ';';
              $ausblenden .= 'm'.md5($v['Bezeichnung']);
            }
          }
        }
        if(isset($module['kauf']))
        {
          foreach($module['kauf'] as $k => $v)
          {
            if($v['match'])
            {
              if($anzeigen != '')$anzeigen .= ';';
              $anzeigen .= 'm'.md5($v['Bezeichnung']);
            }else{
              if($ausblenden != '')$ausblenden .= ';';
              $ausblenden .= 'm'.md5($v['Bezeichnung']);
            }
          }
        }
      }
      echo json_encode(array('anzeigen'=>$anzeigen,'ausblenden'=>$ausblenden));
      exit;
    }

    if($module)
    {
      if(isset($module['installiert']))
      {
        $this->app->Tpl->Add('MODULEINSTALLIERT','<div class="modulediv">');
        for($l = 0; $l < count($module['installiert']); $l++)
        {
          $i = $l;
          $modul = $module['installiert'][$i];
          $this->app->Tpl->Add('MODULEINSTALLIERT','<div class="modulecol" id="m'.md5($modul['Bezeichnung']).'">');
              
          $this->app->Tpl->Add('MODULEINSTALLIERT','<div style="text-align:center;"><a href="'.$modul['Link'].'"><img src="./themes/'.$this->app->Conf->WFconf['defaulttheme'].'/images/einstellungen/'.$modul['Icon'].'" border="0" width="30%"></a></div>');
          $this->app->Tpl->Add('MODULEINSTALLIERT','<div style="text-align:center;"><a href="'.$modul['Link'].'">'.$modul['Bezeichnung'].'</a></div>');
          $this->app->Tpl->Add('MODULEINSTALLIERT','</div>');
        }
        
        $this->app->Tpl->Add('MODULEINSTALLIERT','<div style="clear:both;"></div></div>');
      }
      if(isset($module['kauf']))
      {
        $this->app->Tpl->Add('MODULEVERFUEGBAR','<div class="modulediv">');
        for($l = 0; $l < count($module['kauf']); $l++)
        {
          $i = $l;
          $modul = $module['kauf'][$i];
          $this->app->Tpl->Add('MODULEVERFUEGBAR','<div class="modulecol" id="m'.md5($modul['Bezeichnung']).'">');
              
          $this->app->Tpl->Add('MODULEVERFUEGBAR','<div style="text-align:center;"><a href="'.$modul['Link'].'"><img src="./themes/'.$this->app->Conf->WFconf['defaulttheme'].'/images/einstellungen/'.$modul['Icon'].'" border="0" width="30%"></a></div>');
              
          $this->app->Tpl->Add('MODULEVERFUEGBAR','<div style="text-align:center;"><a href="'.$modul['Link'].'">'.$modul['Bezeichnung'].'</a></div>');
          $this->app->Tpl->Add('MODULEVERFUEGBAR','</div>');
        }
        $this->app->Tpl->Add('MODULEVERFUEGBAR','<div style="clear:both;"></div></div>');

      } else {
        $this->app->Tpl->Add('VERFUEGBARVOR','<!--');
        $this->app->Tpl->Add('VERFUEGBARNACH','--!>');
      }
    }
    
    $this->app->Tpl->Parse('TAB1',"appstore.tpl");
    $this->app->Tpl->Parse('PAGE',"tabview.tpl");
  }
}

?>
