<?php
/*
**** COPYRIGHT & LICENSE NOTICE *** DO NOT REMOVE ****
* 
* WaWision (c) embedded projects GmbH, Holzbachstrasse 4, D-86154 Augsburg, * Germany 2015 
*
* This file is licensed under the Embedded Projects General Public License *Version 3.1. 
*
* You should have received a copy of this license from your vendor and/or *along with this file; If not, please visit www.wawision.de/Lizenzhinweis 
* to obtain the text of the corresponding license version.  
*
**** END OF COPYRIGHT & LICENSE NOTICE *** DO NOT REMOVE ****
*/
?>
<?php
class Artikelbaum
{
  static function TableSearch(&$app, $name, $erlaubtevars)
  {
    switch($name)
    {
      case "artikelbaum_artikel":
        //$allowed['denalunion'] = array('auftragsstatus');
        $heading = array('Nummer','Artikel','Projekt','');
        $width = array('10%','80%','10%');
        $findcols = array('a.nummer', 'a.name_de','p.abkuerzung','a.id');
        $searchsql = array('a.nummer', 'a.name_de','p.abkuerzung');
        
        $defaultorder = 1; //Optional wenn andere Reihenfolge gewuenscht

        $defaultorderdesc = 1;
        //$sumcol = 9;
        $id = (int)$app->Secure->GetGET('id');
        $menu = "<table cellpadding=0 cellspacing=0><tr><td nowrap><a href=\"index.php?module=artikel&action=edit&id=%value%\" target=\"_blank\"><img src=\"themes/{$app->Conf->WFconf['defaulttheme']}/images/edit.png\" border=\"0\"></a></td></tr></table>";
        
        //$menucol = 5;
        //$moreinfo = true;
        $sql = "SELECT SQL_CALC_FOUND_ROWS a.id, a.nummer, a.name_de,p.abkuerzung,a.id
        FROM artikel a LEFT JOIN projekt p ON p.id = a.projekt 
        LEFT JOIN artikelbaum_artikel aba ON aba.artikel = a.id AND aba.kategorie = '$id' AND aba.kategorie != '0'
        ";
        $where = " (a.typ = '".$id."_kat' OR not isnull(aba.id)) ".$app->erp->ProjektRechte();
        $groupby = "GROUP BY a.id";
        
        //$count = "select count(distinct ms.datum) FROM mitarbeiterzeiterfassung_sollstunden ms where ms.adresse = '$adresse' AND ms.datum >= '$von' AND ms.datum <= '$bis'";
        $count = "SELECT count(distinct a.id) FROM artikel a LEFT JOIN projekt p ON p.id = a.projekt LEFT JOIN artikelbaum_artikel aba ON aba.artikel = a.id AND aba.kategorie = '$id' AND aba.kategorie != '0' WHERE $where";
            
      break;
    }
    
    $erg = false;
    
    //$erlaubtevars = array('heading','width','sql','count','findcols','searchsql','defaultorder','defaultorderdesc','menu','menucol','where','groupby','allowed');
    
    
    foreach($erlaubtevars as $k => $v)
    {
      if(isset($$v))$erg[$v] = $$v;
    }
    return $erg; 
  }
  function __construct(&$app)
  {
    $this->app=&$app; 

    $this->app->ActionHandlerInit($this);
    $this->app->ActionHandler("list","ArtikelbaumList");
    $this->app->ActionHandler("change", "ArtikelbaumChange");
    $this->app->ActionHandler("baumajax", "ArtikelbaumBaumajax");
    $this->app->ActionHandler("detail", "ArtikelbaumDetail");
    $this->app->ActionHandler("loeschen", "ArtikelbaumLoeschen");

    $this->app->DefaultActionHandler("list");

    $this->app->ActionHandlerListen($app);
  }
  
  function ArtikelbaumLoeschen()
  {
    //Rechte
    exit;
  }
  
  function ArtikelbaumList()
  {
    $this->app->erp->MenuEintrag("index.php?module=artikelbaum&action=list","&Uuml;bersicht");
    $id = $this->app->Secure->GetGET("id");
    $url = 'index.php?module=artikelbaum&action=baumajax&id='.$id;
    $this->app->Tpl->Set('URL',$url);
    
    if($this->app->Secure->GetPOST("speichern"))
    {
      $katid = (int)$this->app->Secure->GetPOST('kat');
      $bezeichnung = $this->app->Secure->GetPOST('bezeichnung');
      if($bezeichnung && $this->app->erp->RechteVorhanden("artikelbaum","change"))
      {
        if($katid > 0)
        {
          $projekt = $this->app->DB->Select("SELECT projekt FROM artikelkategorien WHERE id = '$katid' LIMIT 1");
          if(!$projekt || $this->app->erp->UserProjektRecht($projekt))
          {
            $this->app->DB->Update("UPDATE artikelkategorien SET bezeichnung = '$bezeichnung' WHERE id = '$katid' LIMIT 1");
          }
        }else{
          $this->app->DB->Insert("INSERT INTO artikelkategorien (bezeichnung) VALUES ('$bezeichnung')");
        }
      }
    }
    if($this->app->Secure->GetPOST("loeschen"))
    {
      $katid = (int)$this->app->Secure->GetPOST('kat');
      if($katid > 0)
      {
        $projekt = $this->app->DB->Select("SELECT projekt FROM artikelkategorien WHERE id = '$katid' LIMIT 1");
        if(!$projekt || $this->app->erp->UserProjektRecht($projekt) && $this->app->erp->RechteVorhanden("artikelbaum","loeschen"))        
          $this->app->DB->Update("UPDATE artikelkategorien SET geloescht = 1 WHERE id = '$katid' LIMIT 1");
      }
    }
    if($this->app->Secure->GetPOST("speichernunter"))
    {
      $parent = (int)$this->app->Secure->GetPOST('kat');
      $bezeichnungunterkategorie = $this->app->Secure->GetPOST('bezeichnungunterkategorie');
      if(!empty($bezeichnungunterkategorie) && $parent > 0 && $this->app->erp->RechteVorhanden("artikelbaum","change"))
      {
        $projekt = $this->app->DB->Select("SELECT projekt FROM artikelkategorien WHERE id = '$parent' LIMIT 1");
        if(!$projekt || $this->app->erp->UserProjektRecht($projekt))
        {
          $this->app->DB->Insert("INSERT INTO artikelkategorien (bezeichnung, parent, projekt) VALUES ('$bezeichnungunterkategorie', '$parent','$projekt')");
        }
      }
    }
    
    $this->app->Tpl->Parse('PAGE','artikelbaum_list.tpl');
  }
  
  function ArtikelbaumDetail()
  {
    $id = (int)$this->app->Secure->GetGET("id");
    if($id)
    {
      $this->app->Tpl->Set('ID', $id);
      $bezeichnung = $this->app->DB->Select("SELECT bezeichnung FROM artikelkategorien WHERE id = '$id' LIMIT 1");
      $this->app->Tpl->Add('BEZEICHNUNG',$bezeichnung);
      $this->app->YUI->TableSearch('TABELLE', "artikelbaum_artikel", "show","","",basename(__FILE__), __CLASS__);
       
    }else{
      $this->app->Tpl->Add('VORLOESCHEN','<!--');
      $this->app->Tpl->Add('NACHLOESCHEN','-->');
      $this->app->Tpl->Add('VORUNTERKATEGORIE','<!--');
      $this->app->Tpl->Add('NACHUNTERKATEGORIE','-->');
    }
    
    echo $this->app->Tpl->Parse('return', 'artikelbaum_detail.tpl',true);
    exit;
  }
  
  function ArtikelbaumBaumajax()
  {
    $id = (int)$this->app->Secure->GetGET('id');
    //$kategorien = $this->app->DB->SelectArr("SELECT id, bezeichnung,parent FROM artikelkategorien WHERE geloescht != 1 ORDER by parent, bezeichnung");
    $kategorien = null;
    $this->getKategorien($kategorien, 0);
    $kategorie = $this->app->DB->Select("SELECT typ FROM artikel WHERE id = '$id' LIMIT 1");
    $kategorie = str_replace('_kat','',$kategorie);
    if($kategorien)
    {
      $maxlvl = 0;
      foreach($kategorien as $k => $v)
      {
        $ind[$v['id']] = $k;

        if($v['parent'] == 0)
        {
          $kategorien[$k]['lvl'] = 0;
          $name = 'node'.$k;
          $$name = new stdClass();
          $$name->id = $v['id'];
          $$name->label = $v['bezeichnung'];
          $$name->checkbox = false;
          $$name->inode = false;
          $$name->radio = false;
          //if($v['id'] == $kategorie)$$name->checked = true;
          $baum[] = $$name;
          $kategorien[$k]['node'] = $$name;
        }else{
          if(isset($ind[$v['parent']]))
          {
            $name = 'node'.$k;
            $$name = new stdClass();
            $$name->id = $v['id'];
            $$name->label = $v['bezeichnung'];
            $$name->checkbox = false;
            $$name->inode = false;
            $$name->radio = false;
            //if($v['id'] == $kategorie)$$name->checked = true;
            $kategorien[$k]['node'] = $$name;
            $kategorien[$k]['lvl'] = 1+$kategorien[$ind[$v['parent']]]['lvl'];
            if($kategorien[$k]['lvl'] > $maxlvl)$maxlvl = $kategorien[$k]['lvl'];
            $kategorien[$ind[$v['parent']]]['inode'] = true;
            //$kategorien[$ind[$v['parent']]]['node']->inode = true;
            $kategorien[$ind[$v['parent']]]['node']->open = true;
            $kategorien[$ind[$v['parent']]]['node']->branch[] = $$name;
          }
        }
      }
      echo json_encode($baum);
      exit;
    }
    echo '[]';  
    exit;
  }
  
  function getKategorien(&$kategorien, $parent)
  {
    $res = $this->app->DB->SelectArr("SELECT id, bezeichnung, parent FROM artikelkategorien WHERE geloescht != 1 AND parent = '$parent' ORDER by bezeichnung");
    if($res)
    {
      foreach($res as $k => $v)
      {
        $kategorien[] = $v;
        $this->getKategorien($kategorien, $v['id']);
      }
    }
    if($parent == 0)
    {
      $kategorien[] = array('id'=>0,'bezeichnung'=> 'Neue Kategorie anlegen', 'parent'=> 0);
    }
  }
  
  function ArtikelbaumChange()
  {
  
    
    exit;
  }
  
}
?>
