<?php
/*
**** COPYRIGHT & LICENSE NOTICE *** DO NOT REMOVE ****
* 
* WaWision (c) embedded projects GmbH, Holzbachstrasse 4, D-86154 Augsburg, * Germany 2015 
*
* This file is licensed under the Embedded Projects General Public License *Version 3.1. 
*
* You should have received a copy of this license from your vendor and/or *along with this file; If not, please visit www.wawision.de/Lizenzhinweis 
* to obtain the text of the corresponding license version.  
*
**** END OF COPYRIGHT & LICENSE NOTICE *** DO NOT REMOVE ****
*/
?>
<?php


class Ftpbackup {
  var $app;
  
  function __construct(&$app, $intern = false)
  {
    $this->app=&$app;
    if($intern)return;
    $this->app->ActionHandlerInit($this);

    $this->app->ActionHandler("list","FtpbackupList");

    $this->app->DefaultActionHandler("list");

    $this->app->ActionHandlerListen($app);
  }


  function FtpbackupList()
  {

    $this->app->YUI->AutoSaveKonfiguration("server","ftpbackup_list_server");
    $this->app->YUI->AutoSaveKonfiguration("benutzer","ftpbackup_list_benutzer");
    $this->app->YUI->AutoSaveKonfiguration("passwort","ftpbackup_list_passwort");


    $server = $this->app->erp->GetKonfiguration("ftpbackup_list_server");
    $benutzer = $this->app->erp->GetKonfiguration("ftpbackup_list_benutzer");
    $passwort = $this->app->erp->GetKonfiguration("ftpbackup_list_passwort");

    $this->app->Tpl->Set('BENUTZER',$benutzer);
    $this->app->Tpl->Set('SERVER',$server);
    $this->app->Tpl->Set('PASSWORT',$passwort);


    //$result = file_get_contents("https://app.ftpbackup.io/api/v1/backup/?api_key=$apikey&site_key=$webseitekey");

    $conn_id = ftp_connect($server);
    $login_result = ftp_login($conn_id, $benutzer, $passwort);
    $data = ftp_rawlist($conn_id,'/');

    $filetypes = array('-'=>'file', 'd'=>'directory', 'l'=>'link');
    $pos=1;

    if(is_array($data) && count($data) > 0)
    {
      foreach($data as $line)
      {
        preg_match('/'. str_repeat('([^\s]+)\s+', 7) .'([^\s]+) (.*)/', $line, $matches); # Here be Dragons
        list($permissions, $children, $owner, $group, $size, $month, $day, $time, $name) = array_slice($matches, 1);
        if (! in_array($permissions[0], array_keys($filetypes))) continue;
        $type = $filetypes[$permissions[0]];


        $date = date('d/m/y H:i', (strpos($time, ':') ? mktime(substr($time, 0, 2), substr($time, -2), 0, $month, $day) : mktime(0,0,0,$month, $day, $time) ) );

        $free = $size;
        $si_prefix = array( 'B', 'KB', 'MB', 'GB', 'TB', 'PB','EB', 'ZB', 'YB' );
        $base = 1024;
        $class_free = min((int)log($free , $base) , count($si_prefix) - 1);
        $free_format =  sprintf('%1.2f' , $free / pow($base,$class_free)) . ' ' . $si_prefix[$class_free];


        if(strpos($name,"userdata")!==false)
          $userdata[floatval(preg_replace('![^0-9]!', '', $name))] = array('name'=>$name,'type'=>$type, 'permissions'=>substr($permissions, 1), 'children'=>$children, 'owner'=>$owner, 'group'=>$group, 'size'=>$free_format, 'date'=>date('d.m.Y',strtotime($day." ".$month)));
        else
          $files[floatval(preg_replace('![^0-9]!', '', $name))] = array('name'=>$name,'type'=>$type, 'permissions'=>substr($permissions, 1), 'children'=>$children, 'owner'=>$owner, 'group'=>$group, 'size'=>$free_format, 'date'=>date('d.m.Y',strtotime($day." ".$month)));

      }
    }
    
    if(is_array($userdata) && count($userdata) > 0)
    {
      for($i=1;$i<=31;$i++)
      {

        if(isset($userdata[$i])){
          $datum = $userdata[$i]['date'];
          $name = $userdata[$i]['name'];
          $free_format = $userdata[$i]['size'];
        } else { 
          $datum ="-";
          $name ="-";
          $free_format ="-";
        }
       if(isset($files[$i])){
          $datum2 = $files[$i]['date'];
          $name2 = $files[$i]['name'];
          $free_format2 = $files[$i]['size'];
        } else { 
          $datum2 ="-";
          $name2 ="-";
          $free_format2 ="-";
        }


        $this->app->Tpl->Add('BACKUPROW',"<tr><td>".($pos++)."</td>
          <td>$datum</td><td>$name</td><td>".$free_format."</td>
          <td>$datum2</td><td>$name2</td><td>".$free_format2."</td>
          </tr>");
      }
    } else {
        $this->app->Tpl->Add('BACKUPROW',"<tr><td colspan=\"6\">Keine Backups gefunden! Entweder sind die Keys falsch, oder es existieren noch keine.</td></tr>");
    }



    //$this->app->YUI->HideDisableFormular("nameradioorchecked",array('input:bla','table:xx'));
	
    $this->app->erp->MenuEintrag("index.php?module=ftpbackup&action=list","&Uuml;bersicht");
    $this->app->Tpl->Parse('PAGE',"ftpbackup_list.tpl");
  }




}

?>
