<?php
/*
**** COPYRIGHT & LICENSE NOTICE *** DO NOT REMOVE ****
* 
* WaWision (c) embedded projects GmbH, Holzbachstrasse 4, D-86154 Augsburg, * Germany 2015 
*
* This file is licensed under the Embedded Projects General Public License *Version 3.1. 
*
* You should have received a copy of this license from your vendor and/or *along with this file; If not, please visit www.wawision.de/Lizenzhinweis 
* to obtain the text of the corresponding license version.  
*
**** END OF COPYRIGHT & LICENSE NOTICE *** DO NOT REMOVE ****
*/
?>
<?php
include ("_gen/importvorlage.php");

class Importvorlage extends GenImportvorlage {
  var $app;
  var $limit_datensaetze;

  function __construct(&$app, $intern = false) {
    //parent::GenImportvorlage($app);
    $this->app=&$app;
    if($intern)return;
    $this->limit_datensaetze=1;

    $this->app->ActionHandlerInit($this);

    $this->app->ActionHandler("create","ImportvorlageCreate");
    $this->app->ActionHandler("edit","ImportvorlageEdit");
    $this->app->ActionHandler("import","ImportvorlageImport");
    $this->app->ActionHandler("list","ImportvorlageList");
    $this->app->ActionHandler("delete","ImportvorlageDelete");
    $this->app->ActionHandler("uebersicht","ImportvorlageUebersicht");
    $this->app->ActionHandler("adressen","ImportvorlageAdressen");
    $this->app->ActionHandler("adresseedit","ImportvorlageAdresseEdit");
    $this->app->ActionHandler("rueckgaengig","ImportvorlageRueckgaengig");

    $this->app->ActionHandlerListen($app);

    $this->app->Tpl->Set('KURZUEBERSCHRIFT',"Daten Import");
  }

  function ImportvorlageAdresseEdit()
  {
    $this->app->Tpl->Parse('TAB1',"importvorlage_uebersicht.tpl");
    $this->app->Tpl->Set('TABTEXT',"Import");
    $this->app->Tpl->Parse('PAGE',"tabview.tpl");
  }

  function ImportvorlageUebersicht()
  {
    $this->app->Tpl->Parse('TAB1',"importvorlage_uebersicht.tpl");
    $this->app->Tpl->Set('TABTEXT',"Import");
    $this->app->Tpl->Parse('PAGE',"tabview.tpl");
  }

  function ImportvorlageAdressen()
  {
    //$this->app->Tpl->Parse('TAB1',"importvorlage_adressen.tpl");
    $this->app->YUI->TableSearch('TAB1',"adresse_import");
    $this->app->erp->MenuEintrag("index.php?module=importvorlage&action=uebersicht","Zur&uuml;ck zur &Uuml;bersicht");
    $this->app->Tpl->Set('TABTEXT',"Import");
    $this->app->Tpl->Parse('PAGE',"tabview.tpl");
  }

  function ImportvorlageRueckgaengig()
  {
    $sid = $this->app->Secure->GetGET("sid");

    if($sid > 0)
    {
      $tmp = $this->app->DB->SelectArr("SELECT *,DATE_FORMAT(zeitstempel,'%d.%m.%Y %H:%i') as zeit 
          FROM importvorlage_log WHERE ersterdatensatz='1' AND user='".$this->app->User->GetID()."' 
          ORDER by zeitstempel DESC LIMIT 1");  

        if($tmp[0]['id']==$sid)
        {
          $zeitstempel = $this->app->DB->Select("SELECT zeitstempel FROM importvorlage_log WHERE id='$sid' LIMIT 1");
          $this->app->erp->ImportvorlageLogDelete($zeitstempel);
          $msg=$this->app->erp->base64_url_encode("<div class=\"info\">Import r&uuml;ckg&auml;ngig gemacht.</div>");
          header("Location: index.php?module=importvorlage&action=list&msg=$msg");
          exit;
        }
    }
  } 

  function ImportvorlageCreate()
  {
    $this->ImportvorlageMenu();
    parent::ImportvorlageCreate();
  }

  function ImportvorlageDelete()
  {
    $id = $this->app->Secure->GetGET("id");
    if(is_numeric($id))
    {
      $this->app->DB->Delete("DELETE FROM importvorlage WHERE id='$id'");
       $this->app->DB->Delete("DELETE FROM importvorlage WHERE id='$id'");
       $msg=$this->app->erp->base64_url_encode("<div class=\"info\">Die Importvorlagen wurde gelöscht!</div>");
       header("Location: index.php?module=importvorlage&action=list&msg=$msg");
       exit;
    }
    $this->ImportvorlageList();
  }

  function ImportvorlageList()
  {
    $this->ImportvorlageMenu();
    if($this->app->DB->Select("SELECT COUNT(id) FROM importvorlage") <=0)
    {

   /* Erst ab 17.1 mit Wiedervorlagen und Notizen 
      $this->app->DB->Insert("INSERT INTO `importvorlage` (`id`, `bezeichnung`, `fields`, `internebemerkung`, `ziel`, `letzterimport`, `mitarbeiterletzterimport`, `importtrennzeichen`, `importerstezeilenummer`, `importdatenmaskierung`, `importzeichensatz`) VALUES
          ('', 'Wiedervorlagen', '1:datum_faellig;\r\n2:uhrzeit_faellig;\r\n3:kundennummer;\r\n4:mitarbeiternummer;\r\n5:betreff;\r\n6:text;\r\n7:abgeschlossen;', '', 'wiedervorlagen', '0000-00-00 00:00:00', '', 'semikolon', 2, 'gaensefuesschen', '');");

      $this->app->DB->Insert("INSERT INTO `importvorlage` (`id`, `bezeichnung`, `fields`, `internebemerkung`, `ziel`, `letzterimport`, `mitarbeiterletzterimport`, `importtrennzeichen`, `importerstezeilenummer`, `importdatenmaskierung`, `importzeichensatz`) VALUES
          ('', 'Notizen', '1:datum;\r\n2:uhrzeit;\r\n3:kundennummer;\r\n4:mitarbeiternummer;\r\n5:betreff;\r\n6:text;', '', 'notizen', '0000-00-00 00:00:00', '', 'semikolon', 2, 'gaensefuesschen', '');");
      */
      $this->app->DB->Insert("INSERT INTO `importvorlage` (`id`, `bezeichnung`, `fields`, `internebemerkung`, `ziel`, `letzterimport`, `mitarbeiterletzterimport`, `importtrennzeichen`, `importerstezeilenummer`, `importdatenmaskierung`, `importzeichensatz`) VALUES
          ('', 'Artikel Stücklisten erstellen (nach normalen Artikelimport)', '1:nummer;\r\n2:stuecklistevonartikel;\r\n3:stuecklistemenge;', '', 'artikel', '0000-00-00 00:00:00', '', 'semikolon', 2, 'gaensefuesschen', '');");

      $this->app->DB->Insert("INSERT INTO `importvorlage` (`id`, `bezeichnung`, `fields`, `internebemerkung`, `ziel`, `letzterimport`, `mitarbeiterletzterimport`, `importtrennzeichen`, `importerstezeilenummer`, `importdatenmaskierung`, `importzeichensatz`) VALUES
          ('', 'Artikel-Varianten verknüpfen (nach normalen Artikelimport)', '1:nummer;\r\n2:variante_von;', '', 'artikel', '0000-00-00 00:00:00', '', 'semikolon', 2, 'gaensefuesschen', '');");

      $this->app->DB->Insert("INSERT INTO `importvorlage` (`id`, `bezeichnung`, `fields`, `internebemerkung`, `ziel`, `letzterimport`, `mitarbeiterletzterimport`, `importtrennzeichen`, `importerstezeilenummer`, `importdatenmaskierung`, `importzeichensatz`) VALUES
          ('', 'Artikel', '1:nummer;\r\n2:name_de;\r\n3:artikelbeschreibung_de;\r\n4:kurztext_de;\r\n5:internerkommentar;\r\n6:hersteller;\r\n7:ean;\r\n8:gewicht;\r\n9:lieferantennummer;\r\n10:lieferantbestellnummer;\r\n11:lieferanteinkaufnetto;\r\n12:lieferanteinkaufmenge;\r\n13:verkaufspreis1netto;\r\n14:verkaufspreis1menge;\r\n15:lagerartikel;\r\n16:lager_platz;\r\n17:lager_menge_total;\r\n18:mindestlager;', '', 'artikel', '0000-00-00 00:00:00', '', 'semikolon', 2, 'gaensefuesschen', '');");

      $this->app->DB->Insert("INSERT INTO `importvorlage` (`id`, `bezeichnung`, `fields`, `internebemerkung`, `ziel`, `letzterimport`, `mitarbeiterletzterimport`, `importtrennzeichen`, `importerstezeilenummer`, `importdatenmaskierung`, `importzeichensatz`) VALUES
          ('', 'Ansprechpartner', '1:kundennummer;\r\n2:name;\r\n3:typ;\r\n4:email;\r\n5:telefon;\r\n6:telefax;\r\n7:mobil;\r\n8:strasse;\r\n9:plz;\r\n10:ort;\r\n11:abteilung;\r\n12:anschreiben;', '', 'adresse', '0000-00-00 00:00:00', '', 'semikolon', 2, 'gaensefuesschen', '');");

      $this->app->DB->Insert("INSERT INTO `importvorlage` (`id`, `bezeichnung`, `fields`, `internebemerkung`, `ziel`, `letzterimport`, `mitarbeiterletzterimport`, `importtrennzeichen`, `importerstezeilenummer`, `importdatenmaskierung`, `importzeichensatz`) VALUES
          ('', 'Lieferanten', '1:lieferantennummer;\r\n2:firma;\r\n3:typ;\r\n4:strasse;\r\n5:plz;\r\n6:ort;\r\n7:telefon;\r\n8:mobil;\r\n9:telefax;\r\n10:internetseite;\r\n11:ansprechpartner;\r\n12:anschreiben;\r\n13:email;\r\n14:land;\r\n15:sprache;\r\n16:kundennummerlieferant;\r\n17:zahlungsweiselieferant;\r\n18:zahlungszieltagelieferant;\r\n19:zahlungszieltageskontolieferant;\r\n20:zahlungszielskontolieferant;\r\n21:sonstiges;', '', 'adresse', '0000-00-00 00:00:00', '', 'semikolon', 2, 'gaensefuesschen', '');");

      $this->app->DB->Insert("INSERT INTO `importvorlage` (`id`, `bezeichnung`, `fields`, `internebemerkung`, `ziel`, `letzterimport`, `mitarbeiterletzterimport`, `importtrennzeichen`, `importerstezeilenummer`, `importdatenmaskierung`, `importzeichensatz`) VALUES
          ('', 'Geschäftskunden', '1:kundennummer;\r\n2:firma;\r\n3:typ;\r\n4:strasse;\r\n5:plz;\r\n6:ort;\r\n7:telefon;\r\n8:mobil;\r\n9:telefax;\r\n10:internetseite;\r\n11:ansprechpartner;\r\n12:anschreiben;\r\n13:email;\r\n14:land;\r\n15:sprache;\r\n16:ustid;\r\n17:steuernummer;\r\n18:zahlungsweise;\r\n19:zahlungszieltage;\r\n20:zahlungszieltageskonto;\r\n21:zahlungszielskonto;\r\n22:sonstiges;', '', 'adresse', '0000-00-00 00:00:00', '', 'semikolon', 2, 'gaensefuesschen', '');");

      $this->app->DB->Insert("INSERT INTO `importvorlage` (`id`, `bezeichnung`, `fields`, `internebemerkung`, `ziel`, `letzterimport`, `mitarbeiterletzterimport`, `importtrennzeichen`, `importerstezeilenummer`, `importdatenmaskierung`, `importzeichensatz`) VALUES
          ('', 'Privatkunden', '1:kundennummer;\r\n2:name;\r\n3:typ;\r\n4:strasse;\r\n5:plz;\r\n6:ort;\r\n7:telefon;\r\n8:mobil;\r\n9:telefax;\r\n10:email;\r\n11:anschreiben;\r\n12:land;\r\n13:sprache;\r\n14:sonstiges;', '', 'adresse', '0000-00-00 00:00:00', '', 'semikolon', 2, 'gaensefuesschen', '');");


    }

    $tmp = $this->app->DB->SelectArr("SELECT *,DATE_FORMAT(zeitstempel,'%d.%m.%Y %H:%i') as zeit FROM importvorlage_log WHERE ersterdatensatz='1' ORDER by zeitstempel DESC LIMIT 1");

    if($tmp[0]['id'] > 0 && $tmp[0]['tabelle']=="adresse")
    {
      $name_import = $this->app->DB->Select("SELECT bezeichnung FROM importvorlage WHERE id='".$tmp[0]['importvorlage']."' LIMIT 1"); 
      $user_name = $this->app->DB->Select("SELECT a.name FROM user u LEFT JOIN adresse a ON a.id=u.adresse WHERE u.id='".$tmp[0]['user']."' LIMIT 1"); 
      $this->app->Tpl->Set('MESSAGE',"<div class=\"info\">Letzter Import: $name_import am ".$tmp[0]['zeit']." Uhr von $user_name (<a href=\"#\" onclick=\"if(!confirm('Wirklich den Import r&uuml;ckg&auml;ngig machen?')) return false; else window.location.href='index.php?module=importvorlage&action=rueckgaengig&sid=".$tmp[0]['id']."';\">Import r&uuml;ckg&auml;ngig machen</a>).</div>");
    }
    parent::ImportvorlageList();
  }

  function ImportvorlageMenu()
  {
    $id = $this->app->Secure->GetGET("id");
    $bezeichnung = $this->app->DB->Select("SELECT bezeichnung FROM importvorlage WHERE id='$id' LIMIT 1");

    $this->app->Tpl->Set('KURZUEBERSCHRIFT2',$bezeichnung);

    if($this->app->Secure->GetGET("action")=="list")
    {
      $this->app->erp->MenuEintrag("index.php?module=importvorlage&action=create","Neue Importvorlage anlegen");
      $this->app->erp->MenuEintrag("index.php?module=importvorlage&action=uebersicht","Zur&uuml;ck zur &Uuml;bersicht");
    }
    else
    {
      $this->app->erp->MenuEintrag("index.php?module=importvorlage&action=edit&id=$id","Details");
      //if($this->app->Secure->GetGET("action")!="create")
      $this->app->erp->MenuEintrag("index.php?module=importvorlage&action=import&id=$id","Import starten: CSV Datei heraufladen");
      $this->app->erp->MenuEintrag("index.php?module=importvorlage&action=list","Zur&uuml;ck zur &Uuml;bersicht");
    }
  }

  function ImportvorlageEdit()
  {
    $this->ImportvorlageMenu();
    parent::ImportvorlageEdit();
  }

  function ImportvorlageGetFields($id)
  {
    $fields = $this->app->DB->Select("SELECT fields FROM importvorlage WHERE id='$id' LIMIT 1");

    $fieldsarray = explode(';',$fields);
    for($i=0;$i<count($fieldsarray);$i++)
    {
      $fieldsarray_items = explode(':',$fieldsarray[$i]);
      $fieldsarray_items[0] = str_replace('!','',$fieldsarray_items[0]);
      if($fieldsarray_items[1]!=""){
        if(strpos($fieldsarray_items[0],'"') === false)
        {
          $csv_fields[$fieldsarray_items[0]]= $fieldsarray_items[1];
          $csv_fields_keys[] = $fieldsarray_items[0];
        }
      }
    }           
    return $csv_fields;
  }

  function ImportvorlageGetFieldsNew($id, $parameter = null)
  {
    if(empty($parameter) || empty($parameter['fields']))$fields = $this->app->DB->Select("SELECT fields FROM importvorlage WHERE id='$id' LIMIT 1");
    $fieldsarray = explode(';',$fields);
    for($i=0;$i<count($fieldsarray);$i++)
    {
      $fieldsarray_items = explode(':',$fieldsarray[$i],3);
      $fieldsarray_items1 = trim(str_replace('!','',$fieldsarray_items[1]));
      if($fieldsarray_items[1]!=""){
        if(strpos($fieldsarray_items[0],'"') === false)
        {
          $erg[$i]['nr'] = trim($fieldsarray_items[0]);
          $erg[$i]['field'] = $fieldsarray_items1;
          if(strpos($fieldsarray_items[1],'!') !== false)
          {
            $erg[$i]['inv'] = true;
          }          
        } else {
          $erg[$i]['field'] = $fieldsarray_items1;
          $erg[$i]['vorlage'] = trim(trim($fieldsarray_items[0]),'"');
        }
        if(isset($fieldsarray_items[2]) && trim($fieldsarray_items[2]))$erg[$i]['bedingung'] = trim($fieldsarray_items[2]);
      }
    }
    if(isset($erg))return $erg;
    return false;
  }


  function ImportvorlageGetFieldsInverse($id)
  {
    $fields = $this->app->DB->Select("SELECT fields FROM importvorlage WHERE id='$id' LIMIT 1");

    $fieldsarray = explode(';',$fields);
    for($i=0;$i<count($fieldsarray);$i++)
    {
      $fieldsarray_items = explode(':',$fieldsarray[$i]);
      if($fieldsarray_items[1]!=""){
        if(strpos($fieldsarray_items[0],'"') === false)
        {
          if(strpos($fieldsarray_items[1],'!') !== false)
          {
            $csv_fields[$fieldsarray_items[0]] = true;
          } else {
            $csv_fields[$fieldsarray_items[0]] = false;
          }
        }
      }
    }
    return $csv_fields;
  }

  function ImportvorlageGetVorlage($id)
  {
    $fields = $this->app->DB->Select("SELECT fields FROM importvorlage WHERE id='$id' LIMIT 1");

    $fieldsarray = explode(';',$fields);
    for($i=0;$i<count($fieldsarray);$i++)
    {
      $fieldsarray_items = explode(':',$fieldsarray[$i]);
      if($fieldsarray_items[1]!=""){
        if(strpos($fieldsarray_items[0],'"') === false)
        {

        } else {

          $vorlage[trim($fieldsarray_items[1])] = trim(trim($fieldsarray_items[0]),'"');
        }
      }
    }           
    if(isset($vorlage))return $vorlage;
    return false;
  }

  function ImportvorlageImport($id = null)
  {
    $_id = $id;
    if(!$_id)$id = (int)$this->app->Secure->GetGET("id");
    if(!$_id)$this->app->erp->MenuEintrag("index.php?module=importvorlage&action=edit&id=$id","Details");
    if(!$_id)$this->app->erp->MenuEintrag("index.php?module=importvorlage&action=import&id=$id","Import starten: CSV Datei heraufladen");



    set_time_limit (0);
    $upload = $this->app->Secure->GetPOST("upload");
    $selcharsets = array('UTF8'=>'UTF-8','ISO-8859-1'=>'ISO-8859-1','CP850'=>'CP850');
    $sel = '<select id="selcharset">';
    $charset = '';
    $charset = $this->app->DB->Select("SELECT charset from importvorlage where id = '$id'");
    if($upload!="")
    {
      $charset = $this->app->Secure->GetPOST("charset");
    }
    $this->app->Tpl->Set('CHARSET',$charset);
    foreach($selcharsets as $k => $v)
    {
      $sel .= '<option value="'.$k.'"'.($charset == $k?' selected="selected" ':'').'>'.$v.'</option>';

    }
    $sel .= '</select>';
    $this->app->Tpl->Set('SELCHARSET',$sel);
    $this->app->Tpl->Add('JAVASCRIPT','
        $(document).ready(function() {
          $("#selcharset").on("change",function(){
              $("#charset").val($("#selcharset").val());
              });
          });

        ');

    $bezeichnung = $this->app->DB->Select("SELECT bezeichnung FROM importvorlage WHERE id='$id' LIMIT 1");
    $importtrennzeichen = $this->app->DB->Select("SELECT importtrennzeichen FROM importvorlage WHERE id='$id' LIMIT 1");
    $importerstezeilenummer = $this->app->DB->Select("SELECT importerstezeilenummer FROM importvorlage WHERE id='$id' LIMIT 1");
    $importdatenmaskierung = $this->app->DB->Select("SELECT importdatenmaskierung FROM importvorlage WHERE id='$id' LIMIT 1");
    $importzeichensatz = $this->app->DB->Select("SELECT importzeichensatz FROM importvorlage WHERE id='$id' LIMIT 1");
    $fields = $this->app->DB->Select("SELECT fields FROM importvorlage WHERE id='$id' LIMIT 1");
    $ziel = $this->app->DB->Select("SELECT ziel FROM importvorlage WHERE id='$id' LIMIT 1");
    $utf8decode = 0;//$this->app->DB->Select("SELECT utf8decode FROM importvorlage WHERE id='$id' LIMIT 1");

    $fieldset = $this->ImportvorlageGetFieldsNew($id);

    if($importtrennzeichen=="semikolon") $importtrennzeichen=';';
    if($importtrennzeichen=="komma") $importtrennzeichen=',';

    if($importdatenmaskierung=="gaensefuesschen") $importdatenmaskierung='"';
    $number_of_fields = count($csv_fields);



    if($upload!="")
    {

      //print_r($csv_fields);
      $stueckliste_csv = $this->app->erp->GetTMP()."importvorlage".$this->app->User->GetID();


      if (move_uploaded_file($_FILES['userfile']['tmp_name'], $stueckliste_csv)) {
        $importfilename = $_FILES['userfile']['name'];
      }
      ini_set("auto_detect_line_endings", true);
      if (($handle = fopen($stueckliste_csv, "r")) !== FALSE) 
      {
        $rowcounter = 0;
        $rowcounter_real = 0;

        $this->ImportPrepareHeader($ziel, $fieldset);
        while (($data = fgetcsv($handle, 0, $importtrennzeichen)) !== FALSE) {
          $rowcounter++;
          $num = count($data);
          if($rowcounter >= $importerstezeilenummer)
          {
            $rowcounter_real++;
            foreach($data as $key=>$value) {
              if($charset && strtoupper($charset) != 'UTF-8' && strtoupper($charset) != 'UTF8')$data[$key] = iconv($charset, 'UTF-8', $data[$key]."\0") ;
            }
            foreach($data as $key=>$value) {
              $data[$key] = trim( $data[$key] );
              $data[$key] = str_replace('""', '"', $data[$key]);
              $data[$key] = preg_replace("/^\"(.*)\"$/sim", "$1", $data[$key]);
              //                                                                $data[$key]= mb_convert_encoding($data[$key], "Windows-1252");
            }

            if($limit_erreicht!=true)
              $this->ImportPrepareRow($rowcounter_real,$ziel,$data,$fieldset);

            if($rowcounter_real >= 50){//$this->limit_datensaetze) {
              $limit_erreicht = true;
              //break;
            }

          }
        }
      }
      fclose($handle);

      if($rowcounter_real < $this->limit_datensaetze)
        unlink($stueckliste_csv);

      if($limit_erreicht)
        $this->app->Tpl->Add('IMPORTBUTTON','<input type="submit" name="import" value="importieren"> <i>Vorschau: Es werden aktuell nur 50 von <b>'.$rowcounter_real.'</b> Datens&auml;tze angezeigt. Importiert werden aber alle '.$rowcounter_real.' Datens&auml;tze!</i> <input type="hidden" name="importdateiname" value="'.$stueckliste_csv.'">');
      else
        $this->app->Tpl->Add('IMPORTBUTTON','<input type="submit" name="import" value="importieren">');

      //$this->app->Tpl->Add('IMPORTBUTTON','<input type="submit" name="import" value="importieren">');
    }


    $import = $this->app->Secure->GetPOST("import");
    if($import!="")
    {
      $this->ImportvorlageDo($charset);
      $this->app->erp->Tpl->Set('MESSAGE',"<div class=\"info\">Import durchgef&uuml;hrt.</div>");
    }



    if(!$_id)$this->app->Tpl->Set('KURZUEBERSCHRIFT2',$bezeichnung);
    if(!$_id)$this->app->Tpl->Parse('TAB1',"importvorlage_import.tpl");
    if(!$_id)$this->app->Tpl->Parse('PAGE',"tabview.tpl");
  }

  function ImportvorlageGetCSV($stueckliste_csv,$id, $charset = "", $parameter = null)
  {
    // einlesen von der CSV Datei
    if(empty($parameter) || empty($parameter['fields']))$fieldstmp = $this->app->DB->Select("SELECT fields FROM importvorlage WHERE id='$id' LIMIT 1");

    if(empty($parameter) || empty($parameter['importtrennzeichen']))$importtrennzeichen = $this->app->DB->Select("SELECT importtrennzeichen FROM importvorlage WHERE id='$id' LIMIT 1");
    if(empty($parameter) || empty($parameter['importerstezeilenummer']))$importerstezeilenummer = $this->app->DB->Select("SELECT importerstezeilenummer FROM importvorlage WHERE id='$id' LIMIT 1");
    if(empty($parameter) || empty($parameter['importdatenmaskierung']))$importdatenmaskierung = $this->app->DB->Select("SELECT importdatenmaskierung FROM importvorlage WHERE id='$id' LIMIT 1");
    if(empty($parameter) || empty($parameter['importzeichensatz']))$importzeichensatz = $this->app->DB->Select("SELECT importzeichensatz FROM importvorlage WHERE id='$id' LIMIT 1");
    $utf8decode = 0;

    $fieldsarray = explode(';',$fieldstmp);
    for($i=0;$i<count($fieldsarray);$i++)
    {
      $fieldsarray_items = explode(':',$fieldsarray[$i]);
      foreach($fieldsarray_items as $k => $v)$fieldsarray_items[$k] = trim($v);
      if($fieldsarray_items[1]!=""){
        if($fieldsarray_items[0] == (int)$fieldsarray_items[0])
        {
          $csv_fields[$fieldsarray_items[0]]= $fieldsarray_items[1];
          $csv_fields_keys[] = $fieldsarray_items[0];
        } else {
          $vorlage[$fieldsarray_items[1]] = trim($fieldsarray_items[0],'"');
        }
      }
    }

    if($importtrennzeichen=="semikolon") $importtrennzeichen=';';
    if($importtrennzeichen=="komma") $importtrennzeichen=',';

    if($importdatenmaskierung=="gaensefuesschen") $importdatenmaskierung='"';
    $number_of_fields = count($csv_fields);
    if (($handle = fopen($stueckliste_csv, "r")) !== FALSE)
    {
      $rowcounter = 0;
      $rowcounter_real = 0;

      while (($data = fgetcsv($handle, 0, $importtrennzeichen)) !== FALSE) {
        $rowcounter++;
        $num = count($data);
        if($rowcounter >= $importerstezeilenummer)
        {  
          $rowcounter_real++;
          foreach($data as $key=>$value) {
            if($charset && strtoupper($charset) != 'UTF-8' && strtoupper($charset) != "UTF8")$data[$key] = iconv($charset, 'UTF-8', $value."\0");
          }

          foreach($data as $key=>$value) {
            $data[$key] = trim( $data[$key] );
            $data[$key] = str_replace('""', '"', $data[$key]);
            $data[$key] = preg_replace("/^\"(.*)\"$/sim", "$1", $data[$key]);
          }

          for($j=0;$j<=$number_of_fields;$j++)
          {  
            $value = trim($data[($csv_fields_keys[$j]-1)]);
            $fieldname = $csv_fields[$csv_fields_keys[$j]];
            $tmp[$fieldname][$rowcounter+1] = $value;
            $tmp['cmd'][$rowcounter+1] = 'create';
            $tmp['checked'][$rowcounter+1] = 1;
            if(isset($vorlage))
            {
              foreach($vorlage as $k => $v)
              {
                $tmp[$v] = $k;
              }
            }
          }
        }
      }
      $number_of_rows = $rowcounter;
      fclose($handle);
      unlink($stueckliste_csv);
    }
    return $tmp;
  }


  function ImportvorlageDo($charset = "", $parameter = null, $return = false)
  {
    $id = $this->app->Secure->GetGET("id");
    if(empty($parameter) || empty($parameter['ziel']))$ziel = $this->app->DB->Select("SELECT ziel FROM importvorlage WHERE id='$id' LIMIT 1");

    $fieldset = $this->ImportvorlageGetFieldsNew($id, $parameter);

    $ekpreisaenderungen = 0;
    $vkpreisaenderungen = 0;

    $tmp = $this->app->Secure->GetPOST("row");


    if(is_null($stueckliste_csv))$stueckliste_csv = $this->app->Secure->GetPOST("importdateiname");
    if($stueckliste_csv !="")
    {
      $tmp = $this->ImportvorlageGetCSV($stueckliste_csv,$id,$charset, $parameter);
    }

    $ersterdatensatz = 1;
    $zeitstempel = time();

    $number_of_rows = count($tmp['cmd']);
    $number_of_rows = $number_of_rows + 2;

    for($i=1;$i<=$number_of_rows;$i++)
    {
      unset($felder);
      unset($lieferantid);
      unset($kundenid);
      unset($artikelid);
      unset($adressid);
      if(isset($tmp['nummer']) && isset($tmp['nummer'][$i]))$tmp['nummer'][$i] = trim($tmp['nummer'][$i]);
      if(isset($tmp['kundennummer']) && isset($tmp['kundennummer'][$i]))$tmp['kundennummer'][$i] = trim($tmp['kundennummer'][$i]);
      if(isset($tmp['lieferantennummer']) && isset($tmp['lieferantennummer'][$i]))$tmp['lieferantennummer'][$i] = trim($tmp['lieferantennummer'][$i]);
      if($tmp['lieferantennummer'][$i]!="" && ($tmp['kundennummer'][$i]!="NEW" || $tmp['kundennummer'][$i]!="NEU"))
      {
        $lieferantid = $this->app->DB->Select("SELECT id FROM adresse WHERE lieferantennummer='".$this->app->DB->real_escape_string($tmp['lieferantennummer'][$i])."' 
            AND lieferantennummer!='' LIMIT 1");

      }

      if($tmp['kundennummer'][$i]!="" && ($tmp['kundennummer'][$i]!="NEW" || $tmp['kundennummer'][$i]!="NEU"))
      {
        $kundenid = $this->app->DB->Select("SELECT id FROM adresse WHERE kundennummer='".$this->app->DB->real_escape_string($tmp['kundennummer'][$i])."' AND kundennummer!='' LIMIT 1");
      }

      if($kundenid<=0) $kundenid=0;
      if($lieferantid<=0) $lieferantid=0;

      if($lieferantid<=0 && $tmp['lieferantname'][$i]!="")
      {
        $lieferantid = $this->app->DB->Select("SELECT id FROM adresse WHERE name='".$this->app->DB->real_escape_string($tmp['lieferantname'][$i])."' LIMIT 1");
      }

      if($ziel!="adresse")
      {
        $artikelid = $this->app->DB->Select("SELECT id FROM artikel WHERE nummer='".$this->app->DB->real_escape_string($tmp['nummer'][$i])."' AND nummer!='' AND nummer != 'DEL' LIMIT 1");
      }

      if($ziel == "artikel")
      {
        foreach($fieldset as $k => $v)
        {
          $bedingung = "";
          $value = "";
          $fieldname = "";
          if(isset($fieldset[$k]['bedingung']))$bedingung = $fieldset[$k]['bedingung'];
          if(trim(strtolower($bedingung)) == 'unique')
          {
            if($v['field'] && isset($tmp[$v['field']]) && isset($tmp[$v['field']][$i]) && $tmp[$v['field']][$i])
            {
              if(!isset($artikelid) || !$artikelid)
                $artikelid = $this->app->DB->Select("SELECT id FROM artikel WHERE ".$v['field']."='".$this->app->DB->real_escape_string($tmp[$v['field']][$i])."' AND nummer!='' LIMIT 1");
            }
          }
        }
      }

      if($ziel == "adresse")
      {
        foreach($fieldset as $k => $v)
        {
          $bedingung = "";
          $value = "";
          $fieldname = "";
          if(isset($fieldset[$k]['bedingung']))$bedingung = $fieldset[$k]['bedingung'];
          if(trim(strtolower($bedingung)) == 'unique')
          {
            if($v['field'] && isset($tmp[$v['field']]) && isset($tmp[$v['field']][$i]) && $tmp[$v['field']][$i])
            {  
              $adressid = $this->app->DB->Select("SELECT id FROM adresse WHERE ".$v['field']."='".$this->app->DB->real_escape_string($tmp[$v['field']][$i])."' LIMIT 1");
              if($adressid)
              {
                if(isset($tmp['kundennummer'][$i]) && (strtoupper(trim($tmp['kundennummer'][$i])) == 'NEW' || strtoupper(trim($tmp['kundennummer'][$i])) == 'NEU'))
                {
                  $kundenid = $adressid;
                  $tmp['kundennummer'][$i] = $this->app->DB->Select("SELECT kundennummer FROM adresse WHERE id = '$adressid' LIMIT 1");
                }
                if(isset($tmp['lieferantennummer'][$i]) && (strtoupper(trim($tmp['lieferantennummer'][$i])) == 'NEW' || strtoupper(trim($tmp['lieferantennummer'][$i])) == 'NEU'))
                {
                  $lieferantid = $adressid;
                  $tmp['lieferantennummer'][$i] = $this->app->DB->Select("SELECT lieferantennummer FROM adresse WHERE id = '$adressid' LIMIT 1");
                }
              }
            }
          }
        }
      }
      if($ziel == "einkauf")
      {
        foreach($fieldset as $k => $v)
        {
          $bedingung = "";
          $value = "";
          $fieldname = "";
          if(isset($fieldset[$k]['bedingung']))$bedingung = $fieldset[$k]['bedingung'];
          if(trim(strtolower($bedingung)) == 'sonstiges' && $v['field'] == 'lieferantennummer' && $tmp[$v['field']][$i] != '')
          {
            $tmp['lieferantennummer'][$i] = $this->app->DB->Select("SELECT lieferantennummer FROM adresse WHERE sonstiges='".$this->app->DB->real_escape_string($tmp[$v['field']][$i])."' LIMIT 1");
            $lieferantid = $this->app->DB->Select("SELECT id FROM adresse WHERE lieferantennummer='".$this->app->DB->real_escape_string($tmp['lieferantennummer'][$i])."' LIMIT 1");

          }
        }
      }

      switch($ziel)
      {
        case "einkauf":
        case "artikel":

          // pruefe ob es artikelnummer schon gibt
          if($artikelid > 0)
            $tmp['cmd'][$i]="update";
          // wenn es artikel nicht gibt muss man diesen neu anlegen
          if($tmp['cmd'][$i]=="create")// && $tmp['checked'][$i]=="1")
          {
            if($tmp['name_de']!="")
            {
              foreach($fieldset as $k => $v)
              {
                $bedingung = "";
                $value = "";
                $fieldname = "";
                if(isset($v['bedingung']))$bedingung = $v['bedingung'];
                if(trim(strtolower($bedingung)) == 'unique')
                {


                }
                if(isset($v['nr']))
                {
                  $value = trim($tmp[$v['field']][$i]);
                  if(isset($v['inv']))
                  {
                    if($value != "1")
                    {
                      $value = 1;
                    }else{
                      $value = 0;
                    }
                  }
                } elseif(isset($v['vorlage']))
                {
                  $value = $v['vorlage'];
                }
                if(isset($v['bedingung']))$value = $this->ImportvorlageBedingung($value, $v['bedingung']);
                $fieldname = $v['field'];
                $felder[$fieldname] = $value;
                $tmp[$fieldname][$i] = $value;
              }
            }
            
            if(isset($tmp['vkmeldungunterdruecken'][$i]))
            {
              if($tmp['vkmeldungunterdruecken'][$i] == 1 || $tmp['vkmeldungunterdruecken'][$i] == 0)
              {
                $felder['vkmeldungunterdruecken'] = $tmp['vkmeldungunterdruecken'][$i];
              }
            }
            if(!is_int($tmp['projekt'][$i]))
            {
              $tmp['projekt'][$i] = $this->app->DB->Select("SELECT id FROM projekt WHERE abkuerzung='".$this->app->DB->real_escape_string($tmp['projekt'][$i])."' AND abkuerzung!='' LIMIT 1");
              $felder['projekt'] = $tmp['projekt'][$i];
            }
            if( strtoupper($tmp['nummer'][$i]) == 'NEW' ||  strtoupper($tmp['nummer'][$i]) == 'NEU' || $tmp['nummer'][$i] == '')
            {
              if(empty($tmp['projekt']) && !empty($this->projekt))$tmp['projekt'] = $this->projekt;
              if($tmp['typ'][$i] > 0)
                $felder['nummer']=$this->app->erp->GetNextArtikelnummer($tmp['typ'][$i], 1, empty($tmp['projekt'])?'':$tmp['projekt']);
              else if($tmp['artikelkategorie'][$i] > 0)
                $felder['nummer']=$this->app->erp->GetNextArtikelnummer($tmp['artikelkategorie'][$i], 1, empty($tmp['projekt'])?'':$tmp['projekt']);
              else if ($tmp['artikelkategorie_name'][$i] !="")
              {
                $tmp_katname = $this->app->DB->Select("SELECT id FROM artikelkategorien WHERE bezeichnung='".$this->app->DB->real_escape_string($tmp['artikelkategorie_name'][$i])."'  order by geloescht LIMIT 1");
                $felder['nummer']=$this->app->erp->GetNextArtikelnummer($tmp_katname, 1, empty($tmp['projekt'])?'':$tmp['projekt']);
              }else{
                $felder['nummer']=$this->app->erp->GetNextArtikelnummer('produkt', 1, empty($tmp['projekt'])?'':$tmp['projekt']);
              }
            }
            else
            {
              $felder['nummer']=$tmp['nummer'][$i];
            }

            if($tmp['artikelbeschreibung_de'][$i]!="") $felder['anabregs_text'] = $tmp['artikelbeschreibung_de'][$i];
            if($tmp['artikelbeschreibung_en'][$i]!="") $felder['anabregs_text_en'] = $tmp['artikelbeschreibung_en'][$i];



            // ek preis
            if($lieferantid <=0 && $tmp['lieferantname'][$i]!="")
            {
              $lieferantid = $this->app->erp->CreateAdresse($this->app->DB->real_escape_string($tmp['lieferantname'][$i]));
              $this->app->erp->AddRolleZuAdresse($lieferantid, "Lieferant", "von","Projekt",$tmp['projekt'][$i]);
            }

            if(isset($tmp['artikelkategorie_name'][$i]))
            {
              $check = $this->app->DB->Select("SELECT id FROM artikelkategorien WHERE bezeichnung like '".$this->app->DB->real_escape_string($tmp['artikelkategorie_name'][$i])."'  order by geloescht LIMIT 1");
              if(!$check)
              {
                $this->app->DB->Insert("INSERT INTO artikelkategorien (bezeichnung) values ('".$this->app->DB->real_escape_string($tmp['artikelkategorie_name'][$i])."')");
                $check = $this->app->DB->GetInsertID();
              }else $this->app->DB->Update("UPDATE artikelkategorien set geloescht = 0 WHERE id = '$check' LIMIT 1");
              if($check)$felder['typ'] = $check.'_kat';
            }

            if($lieferantid>0)
              $felder['adresse']=$lieferantid;
            // mit welcher Artikelgruppe?
            if($felder['nummer'] != '')
            {
              $artikelid = $this->app->erp->ImportCreateArtikel($felder,false);
            }

            if(isset($tmp['artikelunterkategorie_name'][$i]) && (!empty($tmp['artikelkategorie_name'][$i]) || !empty($tmp['artikelkategorie'][$i])))
            {
              if(!empty($tmp['artikelkategorie'][$i]))
              {
                $check = $this->app->DB->Select("SELECT id FROM artikelkategorien WHERE id = '".(int)$tmp['artikelkategorie'][$i]."' LIMIT 1");
              }else{
                $check = $this->app->DB->Select("SELECT id FROM artikelkategorien WHERE bezeichnung like '".$this->app->DB->real_escape_string($tmp['artikelkategorie_name'][$i])."' order by geloescht LIMIT 1");
                if(!$check)
                {
                  $this->app->DB->Insert("INSERT INTO artikelkategorien (bezeichnung) values ('".$this->app->DB->real_escape_string($tmp['artikelkategorie_name'][$i])."')");
                  $check = $this->app->DB->GetInsertID();
                }else $this->app->DB->Update("UPDATE artikelkategorien set geloescht = 0 WHERE id = '$check' LIMIT 1");
              }
              if($check)
              {
                $felder['typ'] = $check.'_kat';
                $this->app->DB->Update("UPDATE artikel SET typ='".$check."_kat' WHERE id='".$artikelid."' LIMIT 1");
              
                $check2 = $this->app->DB->Select("SELECT id FROM artikelkategorien WHERE bezeichnung like '".$this->app->DB->real_escape_string($tmp['artikelunterkategorie_name'][$i])."' order by geloescht, parent = '$check'  DESC LIMIT 1");
                if(!$check2)
                {
                  $this->app->DB->Insert("INSERT INTO artikelkategorien (bezeichnung,parent) values ('".$this->app->DB->real_escape_string($tmp['artikelunterkategorie_name'][$i])."', '$check')");
                  $check2 = $this->app->DB->GetInsertID();
                }else $this->app->DB->Update("UPDATE artikelkategorien set geloescht = 0 WHERE id = '$check2' LIMIT 1");
                if($check2)
                {
                  $check3 = $this->app->DB->Select("SELECT id FROM artikelbaum_artikel WHERE kategorie = '$check2' AND artikel = '$artikelid' LIMIT 1");
                  if(!mysqli_error($this->app->DB->connection) && !$check3)
                  {
                    $this->app->DB->Insert("INSERT INTO artikelbaum_artikel (kategorie, artikel) VALUES ('$check2','$artikelid')");
                  }
                }
              }
            }

            if(($tmp['lieferanteinkaufnetto'][$i]!="" || ($tmp['lieferanteinkaufvpepreis'][$i] > 0 && $tmp['lieferanteinkaufvpemenge'][$i])) && $lieferantid > 0){

              if($tmp['lieferantbestellnummer'][$i]!="") $nr = $tmp['lieferantbestellnummer'][$i];
              else if($tmp['herstellernummer'][$i]!="") $nr = $tmp['herstellernummer'][$i];
              else $nr = $tmp['name_de'][$i];

              if($tmp['lieferanteinkaufvpemenge'][$i] > 0 && $tmp['lieferanteinkaufvpepreis'][$i]  > 0)
              {
                $tmp['lieferanteinkaufnetto'][$i] = $tmp['lieferanteinkaufvpepreis'][$i] / $tmp['lieferanteinkaufvpemenge'][$i]*1.00;
                $tmp['lieferanteinkaufmenge'][$i] = $tmp['lieferanteinkaufvpemenge'][$i];
              }

              if($tmp['lieferanteinkaufmenge'][$i]<=0)
                $tmp['lieferanteinkaufmenge'][$i] = 1;

              if($artikelid && $lieferantid)
              {
                $aktlieferantid = $this->app->DB->Select("SELECT adresse FROM artikel WHERE id = '$artikelid'");
                if(!$aktlieferantid)$this->app->DB->Update("UPDATE artikel SET adresse = '$lieferantid' WHERE id = '$artikelid' LIMIT 1");

              }
              $lieferantartikelbezeichnung = "";
              if($tmp['lieferantartikelbezeichnung'][$i])
              {
                $lieferantartikelbezeichnung = $this->app->DB->real_escape_string($tmp['lieferantartikelbezeichnung'][$i]);
                if($tmp['lieferantartikelbezeichnung'][$i])$lieferantartikelbezeichnung .= " ".$this->app->DB->real_escape_string($tmp['lieferantartikelbezeichnung'][$i]);
              }

              $this->app->erp->AddEinkaufspreis($artikelid,$tmp['lieferanteinkaufmenge'][$i],
                  $lieferantid,$nr,$lieferantartikelbezeichnung,
                  str_replace(',','.',$tmp['lieferanteinkaufnetto'][$i]),$tmp['lieferanteinkaufwaehrung'][$i],$tmp['lieferanteinkaufvpemenge'][$i]);

            }

            if(($tmp['lieferanteinkaufnetto2'][$i]!="" || ($tmp['lieferanteinkaufvpepreis2'][$i] > 0 && $tmp['lieferanteinkaufvpemenge2'][$i])) && $lieferantid > 0){
              if(!isset($tmp['lieferanteinkaufwaehrung2'][$i]) && isset($tmp['lieferanteinkaufwaehrung'][$i]))$tmp['lieferanteinkaufwaehrung2'][$i] = $tmp['lieferanteinkaufwaehrung'][$i];
              if($tmp['lieferantbestellnummer2'][$i]!="") $nr = $tmp['lieferantbestellnummer2'][$i];
              else if($tmp['herstellernummer'][$i]!="") $nr = $tmp['herstellernummer'][$i];
              else $nr = $tmp['name_de'][$i];

              if($tmp['lieferanteinkaufvpemenge2'][$i] > 0 && $tmp['lieferanteinkaufvpepreis2'][$i]  > 0)
              {
                $tmp['lieferanteinkaufnetto2'][$i] = $tmp['lieferanteinkaufvpepreis2'][$i] / $tmp['lieferanteinkaufvpemenge2'][$i]*1.00;
                $tmp['lieferanteinkaufmenge2'][$i] = $tmp['lieferanteinkaufvpemenge2'][$i];
              }

              if($tmp['lieferanteinkaufmenge2'][$i]<=0)
                $tmp['lieferanteinkaufmenge2'][$i] = 1;
              $lieferantartikelbezeichnung = "";
              if($tmp['lieferantartikelbezeichnung2'][$i])
              {
                $lieferantartikelbezeichnung = $this->app->DB->real_escape_string($tmp['lieferantartikelbezeichnung2'][$i]);
                if($tmp['lieferantartikelbezeichnung2'][$i])$lieferantartikelbezeichnung .= " ".$this->app->DB->real_escape_string($tmp['lieferantartikelbezeichnung2'][$i]);
              }

              $this->app->erp->AddEinkaufspreis($artikelid,$tmp['lieferanteinkaufmenge2'][$i],
                  $lieferantid,$nr,$lieferantartikelbezeichnung,
                  str_replace(',','.',$tmp['lieferanteinkaufnetto2'][$i]),$tmp['lieferanteinkaufwaehrung2'][$i],$tmp['lieferanteinkaufvpemenge2'][$i]);

            }
            if(($tmp['lieferanteinkaufnetto3'][$i]!="" || ($tmp['lieferanteinkaufvpepreis3'][$i] > 0 && $tmp['lieferanteinkaufvpemenge3'][$i])) && $lieferantid > 0){
              if(!isset($tmp['lieferanteinkaufwaehrung3'][$i]) && isset($tmp['lieferanteinkaufwaehrung'][$i]))$tmp['lieferanteinkaufwaehrung3'][$i] = $tmp['lieferanteinkaufwaehrung'][$i];
              if($tmp['lieferantbestellnummer3'][$i]!="") $nr = $tmp['lieferantbestellnummer3'][$i];
              else if($tmp['herstellernummer'][$i]!="") $nr = $tmp['herstellernummer'][$i];
              else $nr = $tmp['name_de'][$i];

              if($tmp['lieferanteinkaufvpemenge3'][$i] > 0 && $tmp['lieferanteinkaufmenge3'][$i]<=0 && $tmp['lieferanteinkaufvpepreis3'][$i]  > 0)
              {
                $tmp['lieferanteinkaufnetto3'][$i] = $tmp['lieferanteinkaufvpepreis3'][$i] / $tmp['lieferanteinkaufvpemenge3'][$i]*1.00;
                $tmp['lieferanteinkaufmenge3'][$i] = $tmp['lieferanteinkaufvpemenge3'][$i];
              }

              if($tmp['lieferanteinkaufmenge3'][$i]<=0)
                $tmp['lieferanteinkaufmenge3'][$i] = 1;
              $lieferantartikelbezeichnung = "";
              if($tmp['lieferantartikelbezeichnung3'][$i])
              {
                $lieferantartikelbezeichnung = $this->app->DB->real_escape_string($tmp['lieferantartikelbezeichnung3'][$i]);
                if($tmp['lieferantartikelbezeichnung3'][$i])$lieferantartikelbezeichnung .= " ".$this->app->DB->real_escape_string($tmp['lieferantartikelbezeichnung3'][$i]);
              }

              $this->app->erp->AddEinkaufspreis($artikelid,$tmp['lieferanteinkaufmenge3'][$i],
                  $lieferantid,$nr,$lieferantartikelbezeichnung,
                  str_replace(',','.',$tmp['lieferanteinkaufnetto3'][$i]),$tmp['lieferanteinkaufwaehrung3'][$i],$tmp['lieferanteinkaufvpemenge3'][$i]);

            }
            // vk preis
            if($tmp['verkaufspreis1netto'][$i]!=""){
              $gruppe = "";
              if(isset($tmp['verkaufspreis1gruppe'][$i]))$gruppe = $this->app->DB->Select("SELECT id FROM gruppen where kennziffer = '".$tmp['verkaufspreis1gruppe'][$i]."' LIMIT 1");

              if(!is_numeric($tmp['verkaufspreis1menge'][$i])) $tmp['verkaufspreis1menge'][$i] = 1;

              if((float)str_replace(',','.',$tmp['verkaufspreis1netto'][$i]))
              {
                $_kundenid = 0;
                if(isset($tmp['verkaufspreis1kundennummer']) && $tmp['verkaufspreis1kundennummer'][$i])$_kundenid = $this->app->DB->Select("SELECT id FROM adresse WHERE geloescht = 0 AND kundennummer = '".$this->app->DB->real_escape_string($tmp['verkaufspreis1kundennummer'][$i])."' and kundennummer != '' LIMIT 1");
                if($gruppe)
                {
                  $this->app->erp->AddVerkaufspreisGruppe($artikelid,$tmp['verkaufspreis1menge'][$i],$gruppe,str_replace(',','.',$tmp['verkaufspreis1netto'][$i]),$tmp['verkaufspreis1waehrung'][$i],isset($tmp['verkaufspreis1artikelnummerbeikunde'])?$tmp['verkaufspreis1artikelnummerbeikunde'][$i]:'');
                }else{
                  $this->app->erp->AddVerkaufspreis($artikelid,$tmp['verkaufspreis1menge'][$i],
                      $_kundenid,str_replace(',','.',$tmp['verkaufspreis1netto'][$i]),$tmp['verkaufspreis1waehrung'][$i],isset($tmp['verkaufspreis1artikelnummerbeikunde'])?$tmp['verkaufspreis1artikelnummerbeikunde'][$i]:'',$gruppe);
                }
              }
            }
            if($tmp['verkaufspreis2netto'][$i]!=""){
              $gruppe = "";
              if(isset($tmp['verkaufspreis2gruppe'][$i]))$gruppe = $this->app->DB->Select("SELECT id FROM gruppen where kennziffer = '".$tmp['verkaufspreis2gruppe'][$i]."' LIMIT 1");
              if(!is_numeric($tmp['verkaufspreis2menge'][$i])) $tmp['verkaufspreis2menge'][$i] = 1;
              if((float)str_replace(',','.',$tmp['verkaufspreis2netto'][$i]))
              {
                $_kundenid = 0;
                if(isset($tmp['verkaufspreis2kundennummer']) && $tmp['verkaufspreis2kundennummer'][$i])$_kundenid = $this->app->DB->Select("SELECT id FROM adresse WHERE geloescht = 0 AND kundennummer = '".$this->app->DB->real_escape_string($tmp['verkaufspreis2kundennummer'][$i])."' and kundennummer != '' LIMIT 1");
                if($gruppe)
                {
                  $this->app->erp->AddVerkaufspreisGruppe($artikelid,$tmp['verkaufspreis2menge'][$i],$gruppe,str_replace(',','.',$tmp['verkaufspreis2netto'][$i]),$tmp['verkaufspreis2waehrung'][$i],isset($tmp['verkaufspreis2artikelnummerbeikunde'])?$tmp['verkaufspreis2artikelnummerbeikunde'][$i]:'');
                }else{
                  $this->app->erp->AddVerkaufspreis($artikelid,$tmp['verkaufspreis2menge'][$i],
                      $_kundenid,str_replace(',','.',$tmp['verkaufspreis2netto'][$i]),$tmp['verkaufspreiswaehrung'][$i],isset($tmp['verkaufspreis2artikelnummerbeikunde'])?$tmp['verkaufspreis2artikelnummerbeikunde'][$i]:'',$gruppe);
                }
              }
            }

            if($tmp['verkaufspreis3netto'][$i]!=""){
              $gruppe = "";
              if(isset($tmp['verkaufspreis3gruppe'][$i]))$gruppe = $this->app->DB->Select("SELECT id FROM gruppen where kennziffer = '".$tmp['verkaufspreis3gruppe'][$i]."' LIMIT 1");
              if(!is_numeric($tmp['verkaufspreis3menge'][$i])) $tmp['verkaufspreis3menge'][$i] = 1;
              if((float)str_replace(',','.',$tmp['verkaufspreis3netto'][$i]))
              {
                $_kundenid = 0;
                if(isset($tmp['verkaufspreis3kundennummer']) && $tmp['verkaufspreis3kundennummer'][$i])$_kundenid = $this->app->DB->Select("SELECT id FROM adresse WHERE geloescht = 0 AND kundennummer = '".$this->app->DB->real_escape_string($tmp['verkaufspreis3kundennummer'][$i])."' and kundennummer != '' LIMIT 1");
                if($gruppe)
                {
                  $this->app->erp->AddVerkaufspreisGruppe($artikelid,$tmp['verkaufspreis3menge'][$i],$gruppe,str_replace(',','.',$tmp['verkaufspreis3netto'][$i]),$tmp['verkaufspreis3waehrung'][$i],isset($tmp['verkaufspreis3artikelnummerbeikunde'])?$tmp['verkaufspreis3artikelnummerbeikunde'][$i]:'');
                }else{
                  $this->app->erp->AddVerkaufspreis($artikelid,$tmp['verkaufspreis3menge'][$i],
                      $_kundenid,str_replace(',','.',$tmp['verkaufspreis3netto'][$i]),$tmp['verkaufspreiswaehrung'][$i],isset($tmp['verkaufspreis3artikelnummerbeikunde'])?$tmp['verkaufspreis3artikelnummerbeikunde'][$i]:'',$gruppe);
                }
              }
            }
            if($tmp['verkaufspreis4netto'][$i]!=""){
              $gruppe = "";
              if(isset($tmp['verkaufspreis4gruppe'][$i]))$gruppe = $this->app->DB->Select("SELECT id FROM gruppen where kennziffer = '".$tmp['verkaufspreis4gruppe'][$i]."' LIMIT 1");
              if(!is_numeric($tmp['verkaufspreis4menge'][$i])) $tmp['verkaufspreis4menge'][$i] = 1;
              if((float)str_replace(',','.',$tmp['verkaufspreis4netto'][$i]))
              {
                $_kundenid = 0;
                if(isset($tmp['verkaufspreis4kundennummer']) && $tmp['verkaufspreis4kundennummer'][$i])$_kundenid = $this->app->DB->Select("SELECT id FROM adresse WHERE geloescht = 0 AND kundennummer = '".$this->app->DB->real_escape_string($tmp['verkaufspreis4kundennummer'][$i])."' and kundennummer != '' LIMIT 1");
                if($gruppe)
                {
                  $this->app->erp->AddVerkaufspreisGruppe($artikelid,$tmp['verkaufspreis4menge'][$i],$gruppe,str_replace(',','.',$tmp['verkaufspreis4netto'][$i]),$tmp['verkaufspreis4waehrung'][$i],isset($tmp['verkaufspreis4artikelnummerbeikunde'])?$tmp['verkaufspreis4artikelnummerbeikunde'][$i]:'');
                }else{
                  $this->app->erp->AddVerkaufspreis($artikelid,$tmp['verkaufspreis4menge'][$i],
                      $_kundenid,str_replace(',','.',$tmp['verkaufspreis4netto'][$i]),$tmp['verkaufspreis4waehrung'][$i],isset($tmp['verkaufspreis4artikelnummerbeikunde'])?$tmp['verkaufspreis4artikelnummerbeikunde'][$i]:'',$gruppe);
                }
              }
            }
            if($tmp['variante_von'][$i]!="")
            {
              // schaue ob              
              $tmpartikelid = $this->app->DB->Select("SELECT id FROM artikel WHERE nummer='".$tmp['variante_von'][$i]."' AND nummer!='' LIMIT 1");
              if($tmpartikelid > 0)
              {
                $this->app->DB->Update("UPDATE artikel SET variante_von='".$tmpartikelid."',variante=1 
                    WHERE id='".$artikelid."' AND id!='".$tmpartikelid."' LIMIT 1");
              } 
            }

            if(isset($this->teilprojekt) && isset($this->projekt))
            {
              $sort = 1+(int)$this->app->DB->Select("SELECT max(sort) FROM projekt_artikel WHERE teilprojekt = '".$this->teilprojekt."'");
              $menge = 1;
              if(!empty($tmp['menge'][$i]))$menge = str_replace(',','.',$tmp['menge'][$i]);
              if($menge < 0)$menge = 1;
              $this->app->DB->Insert("INSERT INTO projekt_artikel (projekt, teilprojekt,artikel, sort,geplant) VALUES ('".$this->projekt."','".$this->teilprojekt."','$artikelid','$sort','$menge')");
              $projektartikel = $this->app->DB->GetInsertID();
              $vk = $this->app->erp->GetVerkaufspreis($artikelid, $menge);
              $ek = $this->app->erp->GetEinkaufspreis($artikelid, $menge, $lieferantenid);
              if(isset($tmp['vk_geplant']) && isset($tmp['vk_geplant'][$i]))$vk = (double)str_replace(',','.',$tmp['vk_geplant'][$i]);
              if(isset($tmp['ek_geplant']) && isset($tmp['ek_geplant'][$i]))$ek = (double)str_replace(',','.',$tmp['ek_geplant'][$i]);
              if($vk)$this->app->DB->Update("UPDATE projekt_artikel SET vk_geplant = '$vk' WHERE id = '$projektartikel' LIMIT 1");
              if($vk)$this->app->DB->Update("UPDATE projekt_artikel SET ek_geplant = '$ek' WHERE id = '$projektartikel' LIMIT 1");
            }
            
            if($tmp['einheit'][$i] != "" )
            {
              if($artikelid)$this->app->DB->Update("UPDATE artikel set einheit = '".$this->app->DB->real_escape_string($tmp['einheit'][$i])."' where id = '$artikelid' LIMIT 1");
            }
            
            for($freifeldind = 1; $freifeldind <=  6; $freifeldind++)
            {
              if($tmp['freifeld'.$freifeldind][$i] != "" )
              {
                if($artikelid)$this->app->DB->Update("UPDATE artikel set ".'freifeld'.$freifeldind." = '".$this->app->DB->real_escape_string($tmp['freifeld'.$freifeldind][$i])."' where id = '$artikelid' LIMIT 1");
              }        
            }

            
            if($tmp['stuecklisteexplodiert'][$i]!="")
            {
              if($artikelid)
              {
                $this->app->DB->Update("UPDATE artikel set juststueckliste = '".((int)$tmp['stuecklisteexplodiert'][$i])."' where id = '$artikelid' LIMIT 1");
              }
            }

            if($tmp['stuecklistevonartikel'][$i]!="" && $artikelid)
            {
              $tmpartikelid = $this->app->DB->Select("SELECT id FROM artikel WHERE nummer='".$this->app->DB->real_escape_string($tmp['stuecklistevonartikel'][$i])."' AND nummer!='' LIMIT 1"); 
              if($tmpartikelid > 0)
              {
                $this->app->DB->Update("UPDATE artikel set stueckliste = '1' WHERE id = '$tmpartikelid' LIMIT 1");
                $this->app->DB->Update("UPDATE artikel set typ='produktion' WHERE id = '$tmpartikelid' AND typ = '' LIMIT 1");

                $stuecklistecheck = $this->app->DB->Select("SELECT id FROM stueckliste where stuecklistevonartikel = '$tmpartikelid' and artikel = '$artikelid' LIMIT 1");
                if(!$stuecklistecheck)
                {
                  $sort = 1 + (int)$this->app->DB->Select("SELECT max(sort) FROM stueckliste where stuecklistevonartikel = '$tmpartikelid' LIMIT 1");
                  if(!$this->app->erp->IstStuecklistenZirkel($artikelid, $tmpartikelid))$this->app->DB->Insert("INSERT INTO stueckliste (artikel, stuecklistevonartikel,menge,layer,place,sort,firma) values ('$artikelid','$tmpartikelid','1','$sort','Top','DP','1')");
                  $stuecklistecheck = $this->app->DB->GetInsertID();
                }

                if($stuecklistecheck)
                {
                  if(isset($tmp['stuecklistemenge'][$i]) && $tmp['stuecklistemenge'][$i] != "")
                  {
                    $menge = round((double)str_replace(',','.',$tmp['stuecklistemenge'][$i]),4);
                    if($menge <= 0)$menge = 1;            
                    $this->app->DB->Update("UPDATE stueckliste SET menge = '$menge' where stuecklistevonartikel = '$tmpartikelid' and artikel = '$artikelid' LIMIT 1");
                  }
                  if($tmp['stuecklisteart'][$i] != "")
                  {
                    $art = $this->app->DB->real_escape_string($tmp['stuecklisteart'][$i]);
                    $this->app->DB->Update("UPDATE stueckliste SET art = '$art' where stuecklistevonartikel = '$tmpartikelid' and artikel = '$artikelid' LIMIT 1");
                  }
 
                  if($tmp['stuecklistelayer'][$i] != "")
                  {
                    $layer = $this->app->DB->real_escape_string($tmp['stuecklistelayer'][$i]);
                    $this->app->DB->Update("UPDATE stueckliste SET layer = '$layer' where stuecklistevonartikel = '$tmpartikelid' and artikel = '$artikelid' LIMIT 1");
                  }
                  if($tmp['stuecklisteplace'][$i] != "")
                  {
                    $place = $this->app->DB->real_escape_string($tmp['stuecklisteplace'][$i]);
                    $this->app->DB->Update("UPDATE stueckliste SET place = '$place' where stuecklistevonartikel = '$tmpartikelid' and artikel = '$artikelid' LIMIT 1");
                  }                  
                }
              }
            }


            if($tmp['aktiv'][$i]=="1")
            {
              $this->app->DB->Update("UPDATE artikel SET inaktiv=0 WHERE id='".$artikelid."' LIMIT 1");
            } 
            if($tmp['aktiv'][$i]=="0")
            {
              $this->app->DB->Update("UPDATE artikel SET inaktiv=1 WHERE id='".$artikelid."' LIMIT 1");
            } 
            // prozentzeichen entfernen
            $tmp['umsatzsteuer'][$i] = str_replace('%','',$tmp['umsatzsteuer'][$i]);
            /*
               if($tmp[umsatzsteuer][$i]=="" || $tmp[umsatzsteuer][$i]=="19.00" || $this->app->erp->Firmendaten("steuersatz_normal")==$tmp[umsatzsteuer][$i] 
               || $tmp[umsatzsteuer][$i]=="19%" || $tmp[umsatzsteuer][$i]=="19.00%" || $tmp[umsatzsteuer][$i]=="19" || $tmp[umsatzsteuer][$i]=="normal")
               {
               } 
             */           
            // standard standardsteuersatz 
            $this->app->DB->Update("UPDATE artikel SET umsatzsteuer='normal' WHERE id='".$artikelid."' LIMIT 1");

            if($tmp['umsatzsteuer'][$i]=="7.00" || $tmp['umsatzsteuer'][$i]=="7%" || $tmp['umsatzsteuer'][$i]=="7.00%" || $tmp['umsatzsteuer'][$i]=="7" 
                || $this->app->erp->Firmendaten("steuersatz_ermaessigt")==$tmp['umsatzsteuer'][$i]
                || $tmp['umsatzsteuer'][$i]=="ermaessigt")
            {
              $this->app->DB->Update("UPDATE artikel SET umsatzsteuer='ermaessigt' WHERE id='".$artikelid."' LIMIT 1");
            } 

            // Artikelkategorie
            if($tmp['artikelkategorie'][$i]!="")
            {
              $tmp['typ'][$i] = $tmp['artikelkategorie'][$i];
              if(is_numeric($tmp['typ'][$i]))
              {
                $this->app->DB->Update("UPDATE artikel SET typ='".$tmp['typ'][$i]."_kat' WHERE id='".$artikelid."' LIMIT 1");
              } else {
                $this->app->DB->Update("UPDATE artikel SET typ='".$this->app->DB->real_escape_string($tmp['typ'][$i])."' WHERE id='".$artikelid."' LIMIT 1");
              }
            }
            for($lpk = 1; $lpk <= 5; $lpk++)
            {
              if($tmp['lager_platz'.($lpk>1?$lpk:'')][$i]!=""){
                $lager_id = $this->app->DB->Select("SELECT lager FROM lager_platz WHERE kurzbezeichnung='".$this->app->DB->real_escape_string($tmp['lager_platz'.($lpk>1?$lpk:'')][$i])."' AND kurzbezeichnung!=''");
                if($lager_id <=0)
                {
                  $lager_id = $this->app->DB->Select("SELECT id FROM lager WHERE geloescht!='1' LIMIT 1");
                }
                $felder['lagerartikel']=1;
                $tmp['lagerartikel'][$i]=1;
                $this->app->DB->Update("UPDATE artikel SET lagerartikel='1' WHERE id='$artikelid' LIMIT 1");
                $regal = $this->app->erp->CreateLagerplatz($lager_id,$tmp['lager_platz'.($lpk>1?$lpk:'')][$i]);
                $this->app->DB->Update("UPDATE artikel set lager_platz = '$regal' WHERE id = '$artikelid'");
                if($tmp['lager_menge_addieren'.($lpk>1?$lpk:'')][$i] > 0)
                  $this->app->erp->LagerEinlagernDifferenz($artikelid,$tmp['lager_menge_addieren'.($lpk>1?$lpk:'')][$i],$regal,"","Importzentrale",1);

                //chargen importieren
                if($tmp['lager_mhd'.($lpk>1?$lpk:'')][$i] > 0 && $tmp['lager_charge'.($lpk>1?$lpk:'')][$i] > 0)
                  $this->app->erp->AddMindesthaltbarkeitsdatumLagerOhneBewegung($artikelid,$tmp['lager_menge_addieren'.($lpk>1?$lpk:'')][$i],$regal,date('Y-m-d',strtotime($tmp['lager_mhd'.($lpk>1?$lpk:'')][$i])),$tmp['lager_charge'.($lpk>1?$lpk:'')][$i]);
                else if ($tmp['lager_mhd'.($lpk>1?$lpk:'')][$i] > 0)
                  $this->app->erp->AddMindesthaltbarkeitsdatumLagerOhneBewegung($artikelid,$tmp['lager_menge_addieren'.($lpk>1?$lpk:'')][$i],$regal,date('Y-m-d',strtotime($tmp['lager_mhd'.($lpk>1?$lpk:'')][$i])),"");
                else if($tmp['lager_charge'.($lpk>1?$lpk:'')][$i] > 0)
                  $this->app->erp->AddMindesthaltbarkeitsdatumLagerOhneBewegung($artikelid,$tmp['lager_menge_addieren'.($lpk>1?$lpk:'')][$i],$regal,"",$tmp['lager_charge'.($lpk>1?$lpk:'')][$i]);



                if($tmp['lager_menge_total'.($lpk>1?$lpk:'')][$i] >= 0 && $regal > 0)
                {
                  $tmp_anzahl_lager = $this->app->DB->Select("SELECT SUM(lpi.menge) FROM lager_platz_inhalt lpi LEFT JOIN lager_platz lp ON lp.id=lpi.lager_platz
                    WHERE lpi.artikel='$artikelid' AND lp.id='$regal'");
                  if($tmp_anzahl_lager > 0)
                    $this->app->erp->LagerAuslagernRegal($artikelid,$regal,$tmp_anzahl_lager,$projekt,"Importzentrale");
                  $this->app->erp->LagerEinlagernDifferenz($artikelid,$tmp['lager_menge_total'.($lpk>1?$lpk:'')][$i],$regal,"","Importzentrale",1);
                }
              }
            }
            
            
            
            for($pi = 1; $pi <= 2; $pi++)
            {
              if(!empty($tmp['provision'.$pi][$i]))
              {
                if(strpos($tmp['provision'.$pi][$i],'%') != false)$tmp['provision'.$pi][$i] = (float)(str_replace(array('%',','),array('','.'),$tmp['provision'.$pi][$i]));
                if(!empty($tmp['provisiongruppe'.$pi][$i]))
                {
                  if(is_numeric($tmp['provisiongruppe'.$pi][$i]))
                  {
                    $gruppenid = (int)$tmp['provisiongruppe'.$pi][$i];
                  }else{
                    $gruppenid = $this->app->DB->Select("SELECT id FROM gruppen WHERE name like '".$this->app->DB->real_escape_string($tmp['provisiongruppe'.$pi][$i])."' LIMIT 1");
                    if(!$gruppenid)$gruppenid = $this->app->DB->Select("SELECT id FROM gruppen WHERE kennziffer like '".$this->app->DB->real_escape_string($tmp['provisiongruppe'.$pi][$i])."' LIMIT 1");
                  }
                  if($gruppenid)
                  {
                    $checkprovision = $this->app->DB->Select("SELECT id FROM provision_regeln WHERE artikel = '$artikelid' AND gruppe = '$gruppenid' LIMIT 1");
                    if(!$this->app->DB->error())
                    {
                      if($checkprovision)
                      {
                        $this->app->DB->Update("UPDATE provision_regeln SET provision = '".(float)str_replace(',','.',$tmp['provision'.$pi][$i])."' WHERE id = '$checkprovision' LIMIT 1");
                        $this->app->DB->Update("UPDATE provision_regeln SET bis = '0000-00-00' WHERE id = '$checkprovision' LIMIT 1");
                      }else{
                        $this->app->DB->Insert("INSERT INTO provision_regeln (artikel, gruppe, provision, typ) VALUES ('$artikelid','$gruppenid','".(float)str_replace(',','.',$tmp['provision'.$pi][$i])."','')");
                        $checkprovision = $this->app->DB->GetInsertID();
                      }
                    }
                    if(!empty($tmp['provisiontyp'.$pi][$i]))
                    {
                      $this->app->DB->Update("UPDATE provision_regeln SET typ = '".strtolower(trim($this->app->DB->real_escape_string($tmp['provisiontyp'.$pi][$i])))."' WHERE id = '$checkprovision' LIMIT 1");
                    }
                  }
                }elseif(empty($tmp['provisiongruppe'.$pi])){
                  if(empty($tmp['provisionadresse'.$pi][$i]) && empty($tmp['provisionmitarbeiternummer'.$pi][$i]))
                  {
                    $checkprovision = $this->app->DB->Select("SELECT id FROM provisionenartikel_provision WHERE adresse = 0 AND artikel = '$artikelid' LIMIT 1");
                    if($checkprovision)
                    {
                      $this->app->DB->Update("UPDATE provisionenartikel_provision SET provision = '".(float)str_replace(',','.',$tmp['provision'.$pi][$i])."' WHERE id = '$checkprovision' LIMIT 1");
                      $this->app->DB->Update("UPDATE provisionenartikel_provision SET gueltigbis = '0000-00-00' WHERE id = '$checkprovision' LIMIT 1");
                    }else{
                      $this->app->DB->Insert("INSERT INTO provisionenartikel_provision (artikel, adresse, provision) VALUES ('$artikelid','0','".(float)str_replace(',','.',$tmp['provision'.$pi][$i])."')");
                      $checkprovision = $this->app->DB->GetInsertID();
                    }
                    
                    if(!empty($tmp['provisiontyp'.$pi][$i]))
                    {
                      $this->app->DB->Update("UPDATE provisionenartikel_provision SET provisiontyp = '".strtolower(trim($this->app->DB->real_escape_string($tmp['provisiontyp'.$pi][$i])))."' WHERE id = '$checkprovision' LIMIT 1");
                    }
                  }elseif(!empty($tmp['provisionadresse'.$pi][$i])){
                    $checkprovision = $this->app->DB->Select("SELECT id FROM provisionenartikel_provision WHERE adresse = '".(int)$tmp['provisionadresse'.$pi][$i]."' AND artikel = '$artikelid' LIMIT 1");
                    if($checkprovision)
                    {
                      $this->app->DB->Update("UPDATE provisionenartikel_provision SET provision = '".(float)str_replace(',','.',$tmp['provision'.$pi][$i])."' WHERE id = '$checkprovision' LIMIT 1");
                      $this->app->DB->Update("UPDATE provisionenartikel_provision SET gueltigbis = '0000-00-00' WHERE id = '$checkprovision' LIMIT 1");
                    }else{
                      $this->app->DB->Insert("INSERT INTO provisionenartikel_provision (artikel, adresse, provision) VALUES ('$artikelid','".(int)$tmp['provisionadresse'.$pi][$i]."','".(float)str_replace(',','.',$tmp['provision'.$pi][$i])."')");
                      $checkprovision = $this->app->DB->GetInsertID();
                    }
                    
                    if(!empty($tmp['provisiontyp'.$pi][$i]))
                    {
                      $this->app->DB->Update("UPDATE provisionenartikel_provision SET provisiontyp = '".strtolower(trim($this->app->DB->real_escape_string($tmp['provisiontyp'.$pi][$i])))."' WHERE id = '$checkprovision' LIMIT 1");
                    }
                  }elseif(!empty($tmp['provisionmitarbeiternummer'.$pi][$i]))
                  {
                    $provisionadresse = (int)$this->app->DB->Select("SELECT id FROM adresse WHERE mitarbeiternummer = '".$this->app->DB->real_escape_string($tmp['provisionmitarbeiternummer'.$pi][$i])."' LIMIT 1");
                    if($provisionadresse)
                    {
                      $checkprovision = $this->app->DB->Select("SELECT id FROM provisionenartikel_provision WHERE adresse = '".$provisionadresse."' AND artikel = '$artikelid' LIMIT 1");
                      if($checkprovision)
                      {
                        $this->app->DB->Update("UPDATE provisionenartikel_provision SET provision = '".(float)str_replace(',','.',$tmp['provision'.$pi][$i])."' WHERE id = '$checkprovision' LIMIT 1");
                        $this->app->DB->Update("UPDATE provisionenartikel_provision SET gueltigbis = '0000-00-00' WHERE id = '$checkprovision' LIMIT 1");
                      }else{
                        $this->app->DB->Insert("INSERT INTO provisionenartikel_provision (artikel, adresse, provision) VALUES ('$artikelid','".$provisionadresse."','".(float)str_replace(',','.',$tmp['provision'.$pi][$i])."')");
                        $checkprovision = $this->app->DB->GetInsertID();
                      }
                      if(!empty($tmp['provisiontyp'.$pi][$i]))
                      {
                        $this->app->DB->Update("UPDATE provisionenartikel_provision SET provisiontyp = '".strtolower(trim($this->app->DB->real_escape_string($tmp['provisiontyp'.$pi][$i])))."' WHERE id = '$checkprovision' LIMIT 1");
                      }
                    }
                  }
                }
              }
            }
            if($tmp['shop'][$i]!="")
            {
              $this->app->DB->Update("UPDATE artikel SET shop = '".(int)$tmp['shop'][$i]."' WHERE id = '$artikelid' LIMIT 1");
            }
            if($tmp['fremdnummer'][$i]!="")
            {
              $shop = $this->app->DB->Select("SELECT shop FROM artikel WHERE id = '$artikelid' LIMIT 1");
              if(!$shop && $this->app->DB->Select("SELECT count(id) FROM shopexport WHERE aktiv = 1") == 1)
              {
                $shop = $this->app->DB->Select("SELECT id FROM shopexport WHERE aktiv = 1 LIMIT 1");
              }
              if($shop)
              {
                $check = $this->app->DB->Select("SELECT id FROM artikelnummer_fremdnummern WHERE artikel = '$artikelid' AND nummer = '".$this->app->DB->real_escape_string($tmp['fremdnummer'][$i])."' and shopid = '$shop' LIMIT 1");
                if(!$check)$this->app->DB->Insert("INSERT INTO artikelnummer_fremdnummern (artikel, aktiv, nummer, shopid, zeitstempel, bearbeiter) VALUES ('$artikelid','1','".$this->app->DB->real_escape_string($tmp['fremdnummer'][$i])."','$shop',now(),'".$this->app->DB->real_escape_string($this->app->User->GetName())."')");
              }
            }
          } else if ($tmp['cmd'][$i]=="update") { // && $tmp['checked'][$i]=="1") {
            // wenn er vorhanden ist nur ein Update braucht
            if($artikelid > 0)
            {                
              //foreach($fields as $key=>$value)
              foreach($fieldset as $key=>$val)
              {
                $valu = $val['field'];

                $bedingung = "";
                $value = "";
                if(isset($val['bedingung']))$bedingung = $val['bedingung'];
                if(trim(strtolower($bedingung)) == 'unique')
                {


                }
                if(isset($val['nr']))
                {
                  $value = trim($tmp[$valu][$i]);
                  if(isset($val['inv']))
                  {
                    if($value != "1")
                    {
                      $value = 1;
                    }else{
                      $value = 0;
                    }
                  }
                } elseif(isset($val['vorlage']))
                {
                  $value = $val['vorlage'];
                }
                if(isset($val['bedingung']))$value = $this->ImportvorlageBedingung($value, $val['bedingung']);
                $tmp[$valu][$i] = $value;
                $value = $valu;
              }

              foreach($fieldset as $key=>$val)
              {
                $value = $val['field'];
                switch($value)
                {
                  case "name_de":
                  case "name_en":
                  case "uebersicht_de":
                  case "uebersicht_en":
                  case "kurztext_en":
                  case "kurztext_de":
                  case "anabregs_text":
                  case "anabregs_text_en":
                  case "lagerartikel":
                  case "ean":
                  case "chargenverwaltung":
                  case "herkunftsland":
                  case "zolltarifnummer":
                  case "ursprungsregion":
                  case "produktion":
                  case "gewicht":
                  case "mindestlager":
                  case "mindestbestellung":
                  case "gewicht":
                  case "hersteller":
                  case "internerkommentar":
                  case "herstellerlink":
                  case "herstellernummer":
                  case "allelieferanten":
                  case "geraet":
                  case "serviceartikel":
                  case "steuer_erloese_inland_normal":
                  case "steuer_erloese_inland_ermaessigt":
                  case "steuer_aufwendung_inland_nichtsteuerbar":
                  case "steuer_erloese_inland_innergemeinschaftlich":
                  case "steuer_erloese_inland_eunormal":
                  case "steuer_erloese_inland_euermaessigt":
                  case "steuer_erloese_inland_export":
                  case "steuer_aufwendung_inland_normal":
                  case "steuer_aufwendung_inland_ermaessigt":
                  case "steuer_aufwendung_inland_nichtsteuerbar":
                  case "steuer_aufwendung_inland_innergemeinschaftlich":
                  case "steuer_aufwendung_inland_eunormal":
                  case "steuer_aufwendung_inland_euermaessigt":
                  case "steuer_aufwendung_inland_import":
                  case "seriennummern":
                  case "freifeld1":
                  case "freifeld2":
                  case "freifeld3":
                  case "freifeld4":
                  case "freifeld5":
                  case "freifeld6":
                  case "autolagerlampe":
                  case "restmenge":
                  case "shop":
                  case "shop2":
                  case "shop3":
                  case "pseudopreis":
                    $this->app->DB->Update("UPDATE artikel SET ".$value."='".$this->app->DB->real_escape_string($tmp[$value][$i])."' WHERE id='".$artikelid."' LIMIT 1");
                    break;
                  case "fremdnummer":
                    $shop = $this->app->DB->Select("SELECT shop FROM artikel WHERE id = '$artikelid' LIMIT 1");
                    if(!$shop && $this->app->DB->Select("SELECT count(id) FROM shopexport WHERE aktiv = 1") == 1)
                    {
                      $shop = $this->app->DB->Select("SELECT id FROM shopexport WHERE aktiv = 1 LIMIT 1");
                    }
                    if($shop)
                    {
                      $check = $this->app->DB->Select("SELECT id FROM artikelnummer_fremdnummern WHERE artikel = '$artikelid' AND nummer = '".$this->app->DB->real_escape_string($tmp[$value][$i])."' and shopid = '$shop' LIMIT 1");
                      if(!$check)$this->app->DB->Insert("INSERT INTO artikelnummer_fremdnummern (artikel, aktiv, nummer, shopid, zeitstempel, bearbeiter) VALUES ('$artikelid','1','".$this->app->DB->real_escape_string($tmp[$value][$i])."','$shop',now(),'".$this->app->DB->real_escape_string($this->app->User->GetName())."')");
                    }
                  break;
                  case "matrixproduktvon":
                  case "vkmeldungunterdruecken":
                    if($tmp[$value][$i] == 1 || $tmp[$value][$i] == 0)$this->app->DB->Update("UPDATE artikel SET ".$value."='".$this->app->DB->real_escape_string($tmp[$value][$i])."' WHERE id='".$artikelid."' LIMIT 1");
                  break;
                  case "beschreibung_de":
                  case "artikelbeschreibung_de":
                    $this->app->DB->Update("UPDATE artikel SET anabregs_text='".$this->app->DB->real_escape_string($tmp[$value][$i])."' WHERE id='".$artikelid."' LIMIT 1");
                    break;
                  case "beschreibung_en":
                  case "artikelbeschreibung_en":
                    $this->app->DB->Update("UPDATE artikel SET anabregs_text_en='".$this->app->DB->real_escape_string($tmp[$value][$i])."' WHERE id='".$artikelid."' LIMIT 1");
                    break;
                  case "projekt":
                    if(!is_int($tmp['projekt'][$i]))
                    {              
                      $tmp['projekt'][$i] = $this->app->DB->Select("SELECT id FROM projekt WHERE abkuerzung='".$this->app->DB->real_escape_string($tmp['projekt'][$i])."' AND abkuerzung!='' LIMIT 1");
                    }
                    $this->app->DB->Update("UPDATE artikel SET projekt='".$tmp['projekt'][$i]."' WHERE id='".$artikelid."' LIMIT 1");
                  case "artikelkategorie":
                  case "typ":

                    if($tmp['artikelkategorie'][$i]!="")
                    {
                      $tmp['typ'][$i] = $tmp['artikelkategorie'][$i];
                    }
                    if(is_numeric($tmp['typ'][$i]))
                    {

                      $this->app->DB->Update("UPDATE artikel SET typ='".$tmp['typ'][$i]."_kat' WHERE id='".$artikelid."' LIMIT 1");
                    } else {
                      $this->app->DB->Update("UPDATE artikel SET typ='".$this->app->DB->real_escape_string($tmp['typ'][$i])."' WHERE id='".$artikelid."' LIMIT 1");
                    }

                    break;
                  case "artikelkategorie_name":
                    if(!empty($tmp['artikelkategorie_name'][$i])){
                      $check = $this->app->DB->Select("SELECT id FROM artikelkategorien WHERE bezeichnung like '".$this->app->DB->real_escape_string($tmp['artikelkategorie_name'][$i])."'  order by geloescht LIMIT 1");
                      if(!$check)
                      {
                        $this->app->DB->Insert("INSERT INTO artikelkategorien (bezeichnung) values ('".$this->app->DB->real_escape_string($tmp['artikelkategorie_name'][$i])."')");
                        $check = $this->app->DB->GetInsertID();
                      }else $this->app->DB->Update("UPDATE artikelkategorien set geloescht = 0 WHERE id = '$check' LIMIT 1");
                      if($check)$this->app->DB->Update("UPDATE artikel SET typ='".$check."_kat' WHERE id='".$artikelid."' LIMIT 1");
                    }
                    break;
                  case "artikelunterkategorie_name":  
                    if(!empty($tmp['artikelunterkategorie_name'][$i]) && (!empty($tmp['artikelkategorie_name'][$i]) || !empty($tmp['artikelkategorie'][$i]))){
                      if(!empty($tmp['artikelkategorie'][$i]))
                      {
                        $check = $this->app->DB->Select("SELECT id FROM artikelkategorien WHERE id = '".(int)$tmp['artikelkategorie'][$i]."'  order by geloescht LIMIT 1");
                      }else{
                        $check = $this->app->DB->Select("SELECT id FROM artikelkategorien WHERE bezeichnung like '".$this->app->DB->real_escape_string($tmp['artikelkategorie_name'][$i])."'  order by geloescht LIMIT 1");
                        if(!$check)
                        {
                          $this->app->DB->Insert("INSERT INTO artikelkategorien (bezeichnung) values ('".$this->app->DB->real_escape_string($tmp['artikelkategorie_name'][$i])."')");
                          $check = $this->app->DB->GetInsertID();
                        }else $this->app->DB->Update("UPDATE artikelkategorien set geloescht = 0 WHERE id = '$check' LIMIT 1");
                      }
                      if($check)
                      {
                        $felder['typ'] = $check.'_kat';
                        $this->app->DB->Update("UPDATE artikel SET typ='".$check."_kat' WHERE id='".$artikelid."' LIMIT 1");
                        $check2 = $this->app->DB->Select("SELECT id FROM artikelkategorien WHERE bezeichnung like '".$this->app->DB->real_escape_string($tmp['artikelunterkategorie_name'][$i])."'  order by geloescht, parent = '$check' DESC  LIMIT 1");
                        if(!$check2)
                        {
                          $this->app->DB->Insert("INSERT INTO artikelkategorien (bezeichnung,parent) values ('".$this->app->DB->real_escape_string($tmp['artikelunterkategorie_name'][$i])."', '$check')");
                          $check2 = $this->app->DB->GetInsertID();
                        }else $this->app->DB->Update("UPDATE artikelkategorien set geloescht = 0 WHERE id = '$check2' LIMIT 1");
                        if($check2)
                        {
                          $check3 = $this->app->DB->Select("SELECT id FROM artikelbaum_artikel WHERE kategorie = '$check2' AND artikel = '$artikelid' LIMIT 1");
                          if(!mysqli_error($this->app->DB->connection) && !$check3)
                          {
                            $this->app->DB->Insert("INSERT INTO artikelbaum_artikel (kategorie, artikel) VALUES ('$check2','$artikelid')");
                          }
                        }
                      }
                    }
                    break;
                  case "stuecklistevonartikel":
                    if($tmp['stuecklistevonartikel'][$i]!="" && $artikelid)
                    {

                      $tmpartikelid = $this->app->DB->Select("SELECT id FROM artikel WHERE nummer='".$tmp['stuecklistevonartikel'][$i]."' AND nummer!='' LIMIT 1"); 

                      if($tmpartikelid > 0)
                      {
                        $this->app->DB->Update("UPDATE artikel set stueckliste = '1' WHERE id = '$tmpartikelid' LIMIT 1");
                        $this->app->DB->Update("UPDATE artikel typ='produktion' WHERE id = '$tmpartikelid' AND typ = '' LIMIT 1");

                        $stuecklistecheck = $this->app->DB->Select("SELECT id FROM stueckliste where stuecklistevonartikel = '$tmpartikelid' and artikel = '$artikelid' LIMIT 1");
                        if(!$stuecklistecheck)
                        {
                          $sort = 1 + (int)$this->app->DB->Select("SELECT max(sort) FROM stueckliste where stuecklistevonartikel = '$tmpartikelid' LIMIT 1");
                          if(!$this->app->erp->IstStuecklistenZirkel($artikelid, $tmpartikelid))$this->app->DB->Insert("INSERT INTO stueckliste (artikel, stuecklistevonartikel,menge,layer,place,sort,firma) values ('$artikelid','$tmpartikelid','1','Top','DP','$sort','1')");
                          $stuecklistecheck = $this->app->DB->GetInsertID();
                        }

                        if($stuecklistecheck)
                        {
                          if(isset($tmp['stuecklistemenge'][$i]) && $tmp['stuecklistemenge'][$i] != "")
                          {
                            $menge = round((double)str_replace(',','.',$tmp['stuecklistemenge'][$i]),4);
                            if($menge <= 0)$menge = 1;            
                            $this->app->DB->Update("UPDATE stueckliste set menge = '$menge'  where stuecklistevonartikel = '$tmpartikelid' and artikel = '$artikelid' LIMIT 1");
                          }
                          if($tmp['stuecklisteart'][$i] != "")
                          {
                            $art = $this->app->DB->real_escape_string($tmp['stuecklisteart'][$i]);
                            $this->app->DB->Update("UPDATE stueckliste SET art = '$art'  where stuecklistevonartikel = '$tmpartikelid' and artikel = '$artikelid' LIMIT 1");
                          }
 
                          if($tmp['stuecklistelayer'][$i] != "")
                          {
                            $layer = $this->app->DB->real_escape_string($tmp['stuecklistelayer'][$i]);
                            $this->app->DB->Update("UPDATE stueckliste SET layer = '$layer'  where stuecklistevonartikel = '$tmpartikelid' and artikel = '$artikelid' LIMIT 1");
                          }
                          if($tmp['stuecklisteplace'][$i] != "")
                          {
                            $place = $this->app->DB->real_escape_string($tmp['stuecklisteplace'][$i]);
                            $this->app->DB->Update("UPDATE stueckliste set place = '$place' where stuecklistevonartikel = '$tmpartikelid' and artikel = '$artikelid' LIMIT 1");
                          }                  
                        }
                      }
                    }

                    break;
                  case "einheit":
                    if($tmp['einheit'][$i] != "")
                    {
                      if($artikelid)$this->app->DB->Update("UPDATE artikel SET einheit='".$this->app->DB->real_escape_string($tmp['einheit'][$i])."' WHERE id='".$artikelid."' LIMIT 1");
                    }
                    break;
                  case "umsatzsteuer":
                    if($tmp[$value][$i]=="" || $tmp[$value][$i]=="19.00" || $tmp[$value][$i]=="normal" ||
                        $tmp[$value][$i]=="19%" || $tmp[$value][$i]=="19.00%" || $tmp[$value][$i]=="19")
                    {
                      $this->app->DB->Update("UPDATE artikel SET umsatzsteuer='normal' WHERE id='".$artikelid."' LIMIT 1");
                    } 
                    if($tmp[$value][$i]=="7.00" || $tmp[$value][$i]=="7%" || $tmp[$value][$i]=="7.00%" || $tmp[$value][$i]=="7" || $tmp[$value][$i]=="ermaessigt")
                    {
                      $this->app->DB->Update("UPDATE artikel SET umsatzsteuer='ermaessigt' WHERE id='".$artikelid."' LIMIT 1");
                    } 
                    break;
                  case "aktiv":
                    if($tmp[$value][$i]=="0")
                      $this->app->DB->Update("UPDATE artikel SET inaktiv=1 WHERE id='".$artikelid."' LIMIT 1");
                    else
                      $this->app->DB->Update("UPDATE artikel SET inaktiv=0 WHERE id='".$artikelid."' LIMIT 1");
                    break;
                  case "variante_von":
                    if(trim($tmp[$value][$i])!="")
                    {
                      // schaue ob              
                      $tmpartikelid = $this->app->DB->Select("SELECT id FROM artikel WHERE nummer='".trim($tmp[$value][$i])."' AND nummer!='' LIMIT 1");
                      if($tmpartikelid > 0)
                      {
                        $this->app->DB->Update("UPDATE artikel SET variante_von='".$tmpartikelid."',variante=1 
                            WHERE id='".$artikelid."' AND id!='".$tmpartikelid."' LIMIT 1");
                      } 
                    }
                    break;
                  case  "lieferanteinkaufvpepreis":
                    if($tmp['lieferanteinkaufvpemenge'][$i] > 0 && $tmp['lieferanteinkaufmenge'][$i]<=0 && $tmp['lieferanteinkaufvpepreis'][$i]  > 0)
                    {
                      $tmp['lieferanteinkaufnetto'][$i] = $tmp['lieferanteinkaufvpepreis'][$i] / $tmp['lieferanteinkaufvpemenge'][$i]*1.00;

                      if($tmp['lieferanteinkaufmenge'][$i]<=0)
                        $tmp['lieferanteinkaufmenge'][$i] = 1;

                      if($artikelid && $lieferantid)
                      {
                        $aktlieferantid = $this->app->DB->Select("SELECT adresse FROM artikel WHERE id = '$artikelid' LIMIT 1");
                        if(!$aktlieferantid)$this->app->DB->Update("UPDATE artikel SET adresse = '$lieferantid' WHERE id = '$artikelid' LIMIT 1");

                      }
                      $lieferantartikelbezeichnung = "";
                      if($tmp['lieferantartikelbezeichnung'][$i])
                      {
                        $lieferantartikelbezeichnung = $this->app->DB->real_escape_string($tmp['lieferantartikelbezeichnung'][$i]);
                        if($tmp['lieferantartikelbezeichnung'][$i])$lieferantartikelbezeichnung .= " ".$this->app->DB->real_escape_string($tmp['lieferantartikelbezeichnung'][$i]);
                      }

                      $this->app->erp->AddEinkaufspreis($artikelid,$tmp['lieferanteinkaufmenge'][$i],
                          $lieferantid,$nr,$lieferantartikelbezeichnung,
                          str_replace(',','.',$tmp['lieferanteinkaufnetto'][$i]),$tmp['lieferanteinkaufwaehrung'][$i],$tmp['lieferanteinkaufvpemenge'][$i]);
                    }
                    break;
                  case  "lieferanteinkaufvpepreis2":
                    if($tmp['lieferanteinkaufvpemenge2'][$i] > 0 && $tmp['lieferanteinkaufmenge2'][$i]<=0 && $tmp['lieferanteinkaufvpepreis2'][$i]  > 0)
                    {
                      $tmp['lieferanteinkaufnetto2'][$i] = $tmp['lieferanteinkaufvpepreis2'][$i] / $tmp['lieferanteinkaufvpemenge2'][$i]*1.00;

                      if($tmp['lieferanteinkaufmenge2'][$i]<=0)
                        $tmp['lieferanteinkaufmenge2'][$i] = 1;

                      if($artikelid && $lieferantid)
                      {
                        $aktlieferantid = $this->app->DB->Select("SELECT adresse FROM artikel WHERE id = '$artikelid' LIMIT 1");
                        if(!$aktlieferantid)$this->app->DB->Update("UPDATE artikel SET adresse = '$lieferantid' WHERE id = '$artikelid' LIMIT 1");

                      }
                      $lieferantartikelbezeichnung = "";
                      if($tmp['lieferantartikelbezeichnung2'][$i])
                      {
                        $lieferantartikelbezeichnung = $this->app->DB->real_escape_string($tmp['lieferantartikelbezeichnung2'][$i]);
                        if($tmp['lieferantartikelbezeichnung2'][$i])$lieferantartikelbezeichnung .= " ".$this->app->DB->real_escape_string($tmp['lieferantartikelbezeichnung2'][$i]);
                      }

                      $this->app->erp->AddEinkaufspreis($artikelid,$tmp['lieferanteinkaufmenge2'][$i],
                          $lieferantid,$nr,$lieferantartikelbezeichnung,
                          str_replace(',','.',$tmp['lieferanteinkaufnetto2'][$i]),$tmp['lieferanteinkaufwaehrung2'][$i],$tmp['lieferanteinkaufvpemenge2'][$i]);
                    }
                    break;

                  case  "lieferanteinkaufvpepreis3":
                    if($tmp['lieferanteinkaufvpemenge3'][$i] > 0 && $tmp['lieferanteinkaufmenge3'][$i]<=0 && $tmp['lieferanteinkaufvpepreis3'][$i]  > 0)
                    {
                      $tmp['lieferanteinkaufnetto3'][$i] = $tmp['lieferanteinkaufvpepreis3'][$i] / $tmp['lieferanteinkaufvpemenge3'][$i]*1.00;

                      if($tmp['lieferanteinkaufmenge3'][$i]<=0)
                        $tmp['lieferanteinkaufmenge3'][$i] = 1;

                      if($artikelid && $lieferantid)
                      {
                        $aktlieferantid = $this->app->DB->Select("SELECT adresse FROM artikel WHERE id = '$artikelid' LIMIT 1");
                        if(!$aktlieferantid)$this->app->DB->Update("UPDATE artikel SET adresse = '$lieferantid' WHERE id = '$artikelid' LIMIT 1");

                      }
                      $lieferantartikelbezeichnung = "";
                      if($tmp['lieferantartikelbezeichnung3'][$i])
                      {
                        $lieferantartikelbezeichnung = $this->app->DB->real_escape_string($tmp['lieferantartikelbezeichnung3'][$i]);
                        if($tmp['lieferantartikelbezeichnung3'][$i])$lieferantartikelbezeichnung .= " ".$this->app->DB->real_escape_string($tmp['lieferantartikelbezeichnung3'][$i]);
                      }

                      $this->app->erp->AddEinkaufspreis($artikelid,$tmp['lieferanteinkaufmenge3'][$i],
                          $lieferantid,$nr,$lieferantartikelbezeichnung,
                          str_replace(',','.',$tmp['lieferanteinkaufnetto3'][$i]),$tmp['lieferanteinkaufwaehrung3'][$i],$tmp['lieferanteinkaufvpemenge3'][$i]);
                    }
                    break;



                  case  "lieferanteinkaufnetto":
                    $alterek = $this->app->DB->Select("SELECT preis FROM einkaufspreise WHERE ab_menge='".$tmp['lieferanteinkaufmenge'][$i]."' 
                        AND (gueltig_bis='0000-00-00' OR gueltig_bis >=NOW()) AND adresse='".$lieferantid."' AND artikel='".$artikelid."' LIMIT 1");
                    if($alterek != str_replace(',','.',$tmp['lieferanteinkaufnetto'][$i]))
                    {
                      $ekpreisaenderungen++;
                      $this->app->DB->Update("UPDATE einkaufspreise SET gueltig_bis=DATE_SUB(NOW(),INTERVAL 1 DAY) 
                          WHERE adresse='".$lieferantid."' AND artikel='".$artikelid."' 
                          AND (gueltig_bis='0000-00-00' OR gueltig_bis >=NOW())
                          AND ab_menge='".$tmp['lieferanteinkaufmenge'][$i]."' LIMIT 1");

                      if($tmp['lieferantbestellnummer'][$i]!="") $nr = $tmp['lieferantbestellnummer'][$i];
                      else if($tmp['herstellernummer'][$i]!="") $nr = $tmp['herstellernummer'][$i];
                      else $nr = $tmp['name_de'][$i];


                      if($tmp['lieferanteinkaufvpemenge'][$i] > 0 && $tmp['lieferanteinkaufmenge'][$i]<=0 && $tmp['lieferanteinkaufvpepreis'][$i]  > 0)
                      {
                        $tmp['lieferanteinkaufnetto'][$i] = $tmp['lieferanteinkaufvpepreis'][$i] / $tmp['lieferanteinkaufvpemenge'][$i]*1.00;
                      }

                      if($tmp['lieferanteinkaufmenge'][$i]<=0)
                        $tmp['lieferanteinkaufmenge'][$i] = 1;
                      if($artikelid && $lieferantid)
                      {
                        $aktlieferantid = $this->app->DB->Select("SELECT adresse FROM artikel WHERE id = '$artikelid' LIMIT 1");
                        if(!$aktlieferantid)$this->app->DB->Update("UPDATE artikel SET adresse = '$lieferantid' WHERE id = '$artikelid' LIMIT 1");

                      }
                      $lieferantartikelbezeichnung = "";
                      if($tmp['lieferantartikelbezeichnung'][$i])
                      {
                        $lieferantartikelbezeichnung = $this->app->DB->real_escape_string($tmp['lieferantartikelbezeichnung'][$i]);
                        if($tmp['lieferantartikelbezeichnung'][$i])$lieferantartikelbezeichnung .= " ".$this->app->DB->real_escape_string($tmp['lieferantartikelbezeichnung'][$i]);
                      }

                      $this->app->erp->AddEinkaufspreis($artikelid,$tmp['lieferanteinkaufmenge'][$i],
                          $lieferantid,$nr,$lieferantartikelbezeichnung,
                          str_replace(',','.',$tmp['lieferanteinkaufnetto'][$i]),$tmp['lieferanteinkaufwaehrung'][$i],$tmp['lieferanteinkaufvpemenge'][$i]);
                    } 
                    break;
                  case  "lieferanteinkaufnetto2":
                    $alterek = $this->app->DB->Select("SELECT preis FROM einkaufspreise WHERE ab_menge='".$tmp['lieferanteinkaufmenge2'][$i]."' 
                        AND (gueltig_bis='0000-00-00' OR gueltig_bis >=NOW()) AND adresse='".$lieferantid."' AND artikel='".$artikelid."' LIMIT 1");
                    if($alterek != str_replace(',','.',$tmp['lieferanteinkaufnetto2'][$i]))
                    {
                      $ekpreisaenderungen++;
                      $this->app->DB->Update("UPDATE einkaufspreise SET gueltig_bis=DATE_SUB(NOW(),INTERVAL 1 DAY) 
                          WHERE adresse='".$lieferantid."' AND artikel='".$artikelid."' 
                          AND (gueltig_bis='0000-00-00' OR gueltig_bis >=NOW())
                          AND ab_menge='".$tmp['lieferanteinkaufmenge2'][$i]."' LIMIT 1");

                      if($tmp['lieferantbestellnummer2'][$i]!="") $nr = $tmp['lieferantbestellnummer2'][$i];
                      else if($tmp['herstellernummer'][$i]!="") $nr = $tmp['herstellernummer'][$i];
                      else $nr = $tmp['name_de'][$i];

                      if($tmp['lieferanteinkaufvpemenge2'][$i] > 0 && $tmp['lieferanteinkaufmenge2'][$i]<=0 && $tmp['lieferanteinkaufvpepreis2'][$i]  > 0)
                      {
                        $tmp['lieferanteinkaufnetto2'][$i] = $tmp['lieferanteinkaufvpepreis2'][$i] / $tmp['lieferanteinkaufvpemenge2'][$i]*1.00;
                      }

                      if($tmp['lieferanteinkaufmenge2'][$i]<=0)
                        $tmp['lieferanteinkaufmenge2'][$i] = 1;
                      if($artikelid && $lieferantid)
                      {
                        $aktlieferantid = $this->app->DB->Select("SELECT adresse FROM artikel WHERE id = '$artikelid' LIMIT 1");
                        if(!$aktlieferantid)$this->app->DB->Update("UPDATE artikel SET adresse = '$lieferantid' WHERE id = '$artikelid' LIMIT 1");

                      }
                      $lieferantartikelbezeichnung = "";
                      if($tmp['lieferantartikelbezeichnung2'][$i])
                      {
                        $lieferantartikelbezeichnung = $this->app->DB->real_escape_string($tmp['lieferantartikelbezeichnung2'][$i]);
                        if($tmp['lieferantartikelbezeichnung2'][$i])$lieferantartikelbezeichnung .= " ".$this->app->DB->real_escape_string($tmp['lieferantartikelbezeichnung2'][$i]);
                      }

                      $this->app->erp->AddEinkaufspreis($artikelid,$tmp['lieferanteinkaufmenge2'][$i],
                          $lieferantid,$nr,$lieferantartikelbezeichnung,
                          str_replace(',','.',$tmp['lieferanteinkaufnetto2'][$i]),$tmp['lieferanteinkaufwaehrung2'][$i],$tmp['lieferanteinkaufvpemenge2'][$i]);
                    } 
                    break;
                  case  "lieferanteinkaufnetto3":
                    $alterek = $this->app->DB->Select("SELECT preis FROM einkaufspreise WHERE ab_menge='".$tmp['lieferanteinkaufmenge3'][$i]."' 
                        AND (gueltig_bis='0000-00-00' OR gueltig_bis >=NOW()) AND adresse='".$lieferantid."' LIMIT 1");
                    if($alterek != str_replace(',','.',$tmp['lieferanteinkaufnetto3'][$i]))
                    {
                      $ekpreisaenderungen++;
                      $this->app->DB->Update("UPDATE einkaufspreise SET gueltig_bis=DATE_SUB(NOW(),INTERVAL 1 DAY) 
                          WHERE adresse='".$lieferantid."' AND artikel='".$artikelid."' 
                          AND (gueltig_bis='0000-00-00' OR gueltig_bis >=NOW())
                          AND ab_menge='".$tmp['lieferanteinkaufmenge3'][$i]."' LIMIT 1");

                      if($tmp['lieferantbestellnummer3'][$i]!="") $nr = $tmp['lieferantbestellnummer3'][$i];
                      else if($tmp['herstellernummer'][$i]!="") $nr = $tmp['herstellernummer'][$i];
                      else $nr = $tmp['name_de'][$i];

                      if($tmp['lieferanteinkaufvpemenge3'][$i] > 0 && $tmp['lieferanteinkaufmenge3'][$i]<=0 && $tmp['lieferanteinkaufvpepreis3'][$i]  > 0)
                      {
                        $tmp['lieferanteinkaufnetto3'][$i] = $tmp['lieferanteinkaufvpepreis3'][$i] / $tmp['lieferanteinkaufvpemenge3'][$i]*1.00;
                      }


                      if($tmp['lieferanteinkaufmenge3'][$i]<=0)
                        $tmp['lieferanteinkaufmenge3'][$i] = 1;
                      if($artikelid && $lieferantid)
                      {
                        $aktlieferantid = $this->app->DB->Select("SELECT adresse FROM artikel WHERE id = '$artikelid' LIMIT 1");
                        if(!$aktlieferantid)$this->app->DB->Update("UPDATE artikel SET adresse = '$lieferantid' WHERE id = '$artikelid' LIMIT 1");

                      }
                      $lieferantartikelbezeichnung = "";
                      if($tmp['lieferantartikelbezeichnung3'][$i])
                      {
                        $lieferantartikelbezeichnung = $this->app->DB->real_escape_string($tmp['lieferantartikelbezeichnung3'][$i]);
                        if($tmp['lieferantartikelbezeichnung3'][$i])$lieferantartikelbezeichnung .= " ".$this->app->DB->real_escape_string($tmp['lieferantartikelbezeichnung3'][$i]);
                      }

                      $this->app->erp->AddEinkaufspreis($artikelid,$tmp['lieferanteinkaufmenge3'][$i],
                          $lieferantid,$nr,$lieferantartikelbezeichnung,
                          str_replace(',','.',$tmp['lieferanteinkaufnetto3'][$i]),$tmp['lieferanteinkaufwaehrung3'][$i],$tmp['lieferanteinkaufvpemenge3'][$i]);
                    } 
                    break;
                  case  "verkaufspreis1netto":
                    $gruppe = "";
                    $_kundenid = 0;
                    if(isset($tmp['verkaufspreis1kundennummer']) && $tmp['verkaufspreis1kundennummer'][$i])$_kundenid = $this->app->DB->Select("SELECT id FROM adresse WHERE geloescht = 0 AND kundennummer = '".$this->app->DB->real_escape_string($tmp['verkaufspreis1kundennummer'][$i])."' and kundennummer != '' LIMIT 1");
                    if(isset($tmp['verkaufspreis1gruppe'][$i]))$gruppe = $this->app->DB->Select("SELECT id FROM gruppen where kennziffer = '".$tmp['verkaufspreis1gruppe'][$i]."' LIMIT 1");

                    $altervk = $this->app->DB->Select("SELECT preis FROM verkaufspreise WHERE ab_menge='".$tmp['verkaufspreis1menge'][$i]."' 
                        AND (gueltig_bis='0000-00-00' OR gueltig_bis >=NOW() ) AND adresse <='$_kundenid' ".($gruppe?" AND gruppe = '".$gruppe."'":" AND (is_null(gruppe) or gruppe = '') ")." LIMIT 1");

                    if($altervk != str_replace(',','.',$tmp['verkaufspreis1netto'][$i]) && str_replace(',','.',$tmp['verkaufspreis1netto'][$i]))
                    {
                      $vkpreisaenderungen++;
                      $this->app->DB->Update("UPDATE verkaufspreise SET gueltig_bis=DATE_SUB(NOW(),INTERVAL 1 DAY) 
                          WHERE artikel='".$artikelid."' AND adresse='$_kundenid' ".($gruppe?" AND gruppe = '".$gruppe."'":" AND (is_null(gruppe) or gruppe = '') ")."
                          AND ab_menge='".$tmp['verkaufspreis1menge'][$i]."' LIMIT 1");
                      if($gruppe)
                      {
                        $this->app->erp->AddVerkaufspreisGruppe($artikelid,$tmp['verkaufspreis1menge'][$i],$gruppe,str_replace(',','.',$tmp['verkaufspreis1netto'][$i]),$tmp['verkaufspreis1waehrung'][$i],isset($tmp['verkaufspreis1artikelnummerbeikunde'])?$tmp['verkaufspreis1artikelnummerbeikunde'][$i]:'');
                      }else{
                        $this->app->erp->AddVerkaufspreis($artikelid,$tmp['verkaufspreis1menge'][$i],
                            $_kundenid,str_replace(',','.',$tmp['verkaufspreis1netto'][$i]),$tmp['verkaufspreis1waehrung'][$i],isset($tmp['verkaufspreis1artikelnummerbeikunde'])?$tmp['verkaufspreis1artikelnummerbeikunde'][$i]:'',$gruppe);
                      }
                    } 
                    break;
                  case  "verkaufspreis2netto":


                    $gruppe = "";
                    $_kundenid = 0;
                    if(isset($tmp['verkaufspreis2kundennummer']) && $tmp['verkaufspreis2kundennummer'][$i])$_kundenid = $this->app->DB->Select("SELECT id FROM adresse WHERE geloescht = 0 AND kundennummer = '".$this->app->DB->real_escape_string($tmp['verkaufspreis2kundennummer'][$i])."' and kundennummer != '' LIMIT 1");
                    if(isset($tmp['verkaufspreis2gruppe'][$i]))
                    {
                      $gruppe = $this->app->DB->Select("SELECT id FROM gruppen where kennziffer = '".$tmp['verkaufspreis2gruppe'][$i]."' LIMIT 1");
                    }

                    $altervk = $this->app->DB->Select("SELECT preis FROM verkaufspreise WHERE ab_menge='".$tmp['verkaufspreis2menge'][$i]."' 
                        AND (gueltig_bis='0000-00-00' OR gueltig_bis >=NOW() ) AND adresse <='$_kundenid' ".($gruppe?" AND gruppe = '".$gruppe."'":" AND (is_null(gruppe) or gruppe = '') ")." LIMIT 1");

                    if($altervk != str_replace(',','.',$tmp['verkaufspreis2netto'][$i]) && str_replace(',','.',$tmp['verkaufspreis2netto'][$i]))
                    {
                      $vkpreisaenderungen++;
                      $this->app->DB->Update("UPDATE verkaufspreise SET gueltig_bis=DATE_SUB(NOW(),INTERVAL 1 DAY) 
                          WHERE artikel='".$artikelid."' AND adresse='$_kundenid' ".($gruppe?" AND gruppe = '".$gruppe."'":" AND (is_null(gruppe) or gruppe = '') ")."
                          AND ab_menge='".$tmp['verkaufspreis2menge'][$i]."' LIMIT 1");
                      if($tmp['verkaufspreis2netto'][$i])
                      {
                        if($gruppe)
                        {
                          $this->app->erp->AddVerkaufspreisGruppe($artikelid,$tmp['verkaufspreis2menge'][$i],$gruppe,str_replace(',','.',$tmp['verkaufspreis2netto'][$i]),$tmp['verkaufspreis2waehrung'][$i],isset($tmp['verkaufspreis2artikelnummerbeikunde'])?$tmp['verkaufspreis2artikelnummerbeikunde'][$i]:'');
                        }else{
                          $this->app->erp->AddVerkaufspreis($artikelid,$tmp['verkaufspreis2menge'][$i],
                              $_kundenid,str_replace(',','.',$tmp['verkaufspreis2netto'][$i]),$tmp['verkaufspreis2waehrung'][$i],isset($tmp['verkaufspreis2artikelnummerbeikunde'])?$tmp['verkaufspreis2artikelnummerbeikunde'][$i]:'',$gruppe);
                        }                          
                      }

                    }
                    break;
                  case  "verkaufspreis3netto":
                    $gruppe = "";
                    $_kundenid = 0;
                    if(isset($tmp['verkaufspreis3kundennummer']) && $tmp['verkaufspreis3kundennummer'][$i])$_kundenid = $this->app->DB->Select("SELECT id FROM adresse WHERE geloescht = 0 AND kundennummer = '".$this->app->DB->real_escape_string($tmp['verkaufspreis3kundennummer'][$i])."' and kundennummer != '' LIMIT 1");
                    if(isset($tmp['verkaufspreis3gruppe'][$i]))$gruppe = $this->app->DB->Select("SELECT id FROM gruppen where kennziffer = '".$tmp['verkaufspreis3gruppe'][$i]."' LIMIT 1");

                    $altervk = $this->app->DB->Select("SELECT preis FROM verkaufspreise WHERE ab_menge='".$tmp['verkaufspreis3menge'][$i]."' 
                        AND (gueltig_bis='0000-00-00' OR gueltig_bis >=NOW() ) AND adresse <='$_kundenid' ".($gruppe?" AND gruppe = '".$gruppe."'":" AND (is_null(gruppe) or gruppe = '') ")." LIMIT 1");
                    if($altervk != str_replace(',','.',$tmp['verkaufspreis3netto'][$i]) && str_replace(',','.',$tmp['verkaufspreis3netto'][$i]))
                    {
                      $vkpreisaenderungen++;
                      $this->app->DB->Update("UPDATE verkaufspreise SET gueltig_bis=DATE_SUB(NOW(),INTERVAL 1 DAY) 
                          WHERE artikel='".$artikelid."' AND adresse='$_kundenid' ".($gruppe?" AND gruppe = '".$gruppe."'":" AND (is_null(gruppe) or gruppe = '') ")."
                          AND ab_menge='".$tmp['verkaufspreis3menge'][$i]."' LIMIT 1");

                      if($tmp['verkaufspreis3netto'][$i])
                      {
                        if($gruppe)
                        {
                          $this->app->erp->AddVerkaufspreisGruppe($artikelid,$tmp['verkaufspreis3menge'][$i],$gruppe,str_replace(',','.',$tmp['verkaufspreis3netto'][$i]),$tmp['verkaufspreis3waehrung'][$i],isset($tmp['verkaufspreis3artikelnummerbeikunde'])?$tmp['verkaufspreis3artikelnummerbeikunde'][$i]:'');
                        }else{
                          $this->app->erp->AddVerkaufspreis($artikelid,$tmp['verkaufspreis3menge'][$i],
                              $_kundenid,str_replace(',','.',$tmp['verkaufspreis3netto'][$i]),$tmp['verkaufspreis3waehrung'][$i],isset($tmp['verkaufspreis3artikelnummerbeikunde'])?$tmp['verkaufspreis3artikelnummerbeikunde'][$i]:'',$gruppe);
                        }
                      }
                    } 
                    break;
                  case  "verkaufspreis4netto":
                    $gruppe = "";
                    $_kundenid = 0;
                    if(isset($tmp['verkaufspreis4kundennummer']) && $tmp['verkaufspreis4kundennummer'][$i])$_kundenid = $this->app->DB->Select("SELECT id FROM adresse WHERE geloescht = 0 AND kundennummer = '".$this->app->DB->real_escape_string($tmp['verkaufspreis4kundennummer'][$i])."' and kundennummer != '' LIMIT 1");
                    
                    if(isset($tmp['verkaufspreis4gruppe'][$i]))$gruppe = $this->app->DB->Select("SELECT id FROM gruppen where kennziffer = '".$tmp['verkaufspreis4gruppe'][$i]."' LIMIT 1");

                    $altervk = $this->app->DB->Select("SELECT preis FROM verkaufspreise WHERE ab_menge='".$tmp['verkaufspreis4menge'][$i]."' 
                        AND (gueltig_bis='0000-00-00' OR gueltig_bis >=NOW() ) AND adresse ='$_kundenid' ".($gruppe?" AND gruppe = '".$gruppe."'":" AND (is_null(gruppe) or gruppe = '') ")." LIMIT 1");
                    if($altervk != str_replace(',','.',$tmp['verkaufspreis4netto'][$i]) && str_replace(',','.',$tmp['verkaufspreis4netto'][$i]))
                    {
                      $vkpreisaenderungen++;
                      $this->app->DB->Update("UPDATE verkaufspreise SET gueltig_bis=DATE_SUB(NOW(),INTERVAL 1 DAY) 
                          WHERE artikel='".$artikelid."' AND adresse='$_kundenid' ".($gruppe?" AND gruppe = '".$gruppe."'":" AND (is_null(gruppe) or gruppe = '') ")."
                          AND ab_menge='".$tmp['verkaufspreis4menge'][$i]."' LIMIT 1");

                      if($tmp['verkaufspreis4netto'][$i])
                      {
                        if($gruppe)
                        {
                          $this->app->erp->AddVerkaufspreisGruppe($artikelid,$tmp['verkaufspreis4menge'][$i],$gruppe,str_replace(',','.',$tmp['verkaufspreis4netto'][$i]),$tmp['verkaufspreis4waehrung'][$i],isset($tmp['verkaufspreis4artikelnummerbeikunde'])?$tmp['verkaufspreis4artikelnummerbeikunde'][$i]:'');
                        }else{
                          $this->app->erp->AddVerkaufspreis($artikelid,$tmp['verkaufspreis4menge'][$i],
                              $_kundenid,str_replace(',','.',$tmp['verkaufspreis4netto'][$i]),$tmp['verkaufspreis4waehrung'][$i],isset($tmp['verkaufspreis4artikelnummerbeikunde'])?$tmp['verkaufspreis4artikelnummerbeikunde'][$i]:'',$gruppe);
                        }
                      }
                    } 
                    break;
                  case "lager_platz":
                  case "lager_platz2":
                  case "lager_platz3":
                  case "lager_platz4":
                  case "lager_platz5":
                    for($lpk = 1; $lpk <= 5; $lpk++)
                    {
                      if($tmp['lager_platz'.($lpk>1?$lpk:'')][$i]!=""){
                        $lager_id = $this->app->DB->Select("SELECT lager FROM lager_platz WHERE 
                            kurzbezeichnung='".$tmp['lager_platz'.($lpk>1?$lpk:'')][$i]."' AND kurzbezeichnung!='' AND geloescht!='1' LIMIT 1");

                        if($lager_id <=0)
                        {
                          $lager_id = $this->app->DB->Select("SELECT id FROM lager WHERE geloescht!='1' LIMIT 1");
                        }
                        $felder['lagerartikel']=1;
                        $tmp['lagerartikel'][$i]=1;
                        $this->app->DB->Update("UPDATE artikel SET lagerartikel='1' WHERE id='$artikelid' LIMIT 1");
                        $regal = $this->app->erp->CreateLagerplatz($lager_id,$tmp['lager_platz'.($lpk>1?$lpk:'')][$i]);
                        $this->app->DB->Update("UPDATE artikel SET lager_platz='$regal' WHERE id='$artikelid' LIMIT 1");
                        if($tmp['lager_menge_addieren'.($lpk>1?$lpk:'')][$i] > 0)
                          $this->app->erp->LagerEinlagernDifferenz($artikelid,$tmp['lager_menge_addieren'.($lpk>1?$lpk:'')][$i],$regal,"","Importzentrale",1);
                        //chargen importieren
                        if($tmp['lager_mhd'.($lpk>1?$lpk:'')][$i] > 0 && $tmp['lager_charge'.($lpk>1?$lpk:'')][$i] > 0)
                          $this->app->erp->AddMindesthaltbarkeitsdatumLagerOhneBewegung($artikelid,$tmp['lager_menge_addieren'.($lpk>1?$lpk:'')][$i],$regal,date('Y-m-d',strtotime($tmp['lager_mhd'.($lpk>1?$lpk:'')][$i])),$tmp['lager_charge'.($lpk>1?$lpk:'')][$i]);
                        else if ($tmp['lager_mhd'.($lpk>1?$lpk:'')][$i] > 0)
                          $this->app->erp->AddMindesthaltbarkeitsdatumLagerOhneBewegung($artikelid,$tmp['lager_menge_addieren'.($lpk>1?$lpk:'')][$i],$regal,date('Y-m-d',strtotime($tmp['lager_mhd'.($lpk>1?$lpk:'')][$i])),"");
                        else if($tmp['lager_charge'.($lpk>1?$lpk:'')][$i] > 0)
                          $this->app->erp->AddMindesthaltbarkeitsdatumLagerOhneBewegung($artikelid,$tmp['lager_menge_addieren'.($lpk>1?$lpk:'')][$i],$regal,"",$tmp['lager_charge'.($lpk>1?$lpk:'')][$i]);


                        if($tmp['lager_menge_total'.($lpk>1?$lpk:'')][$i] >= 0 && $regal > 0)
                        {
                          $tmp_anzahl_lager = $this->app->DB->Select("SELECT SUM(lpi.menge) FROM lager_platz_inhalt lpi LEFT JOIN lager_platz lp ON lp.id=lpi.lager_platz
                            WHERE lpi.artikel='$artikelid' AND lp.id='$regal'");
                          if($tmp_anzahl_lager > 0)
                            $this->app->erp->LagerAuslagernRegal($artikelid,$regal,$tmp_anzahl_lager,$projekt,"Importzentrale");
                          // komplett leeren
                          $this->app->erp->LagerEinlagernDifferenz($artikelid,$tmp['lager_menge_total'.($lpk>1?$lpk:'')][$i],$regal,"","Importzentrale",1);
                        }
                      }
                    }
                    break; 
                  case "provision1":
                  case "provision2":
                    switch($value)
                    {
                      case "provision1":
                        $pi = 1;
                      break;
                      case "provision2":
                        $pi = 2;
                      break;
                    }

                    if(!empty($tmp['provision'.$pi][$i]))
                    {
                      if(strpos($tmp['provision'.$pi][$i],'%') != false)$tmp['provision'.$pi][$i] = (float)(str_replace(array('%',','),array('','.'),$tmp['provision'.$pi][$i]));
                      if(!empty($tmp['provisiongruppe'.$pi][$i]))
                      {
                        if(is_numeric($tmp['provisiongruppe'.$pi][$i]))
                        {
                          $gruppenid = (int)$tmp['provisiongruppe'.$pi][$i];
                        }else{
                          $gruppenid = $this->app->DB->Select("SELECT id FROM gruppen WHERE name like '".$this->app->DB->real_escape_string($tmp['provisiongruppe'.$pi][$i])."' LIMIT 1");
                          if(!$gruppenid)$gruppenid = $this->app->DB->Select("SELECT id FROM gruppen WHERE kennziffer like '".$this->app->DB->real_escape_string($tmp['provisiongruppe'.$pi][$i])."' LIMIT 1");
                        }
                        if($gruppenid)
                        {
                          $checkprovision = $this->app->DB->Select("SELECT id FROM provision_regeln WHERE artikel = '$artikelid' AND gruppe = '$gruppenid' LIMIT 1");
                          if(!$this->app->DB->error())
                          {
                            if($checkprovision)
                            {
                              $this->app->DB->Update("UPDATE provision_regeln SET provision = '".(float)str_replace(',','.',$tmp['provision'.$pi][$i])."' WHERE id = '$checkprovision' LIMIT 1");
                              $this->app->DB->Update("UPDATE provision_regeln SET bis = '0000-00-00' WHERE id = '$checkprovision' LIMIT 1");
                            }else{
                              $this->app->DB->Insert("INSERT INTO provision_regeln (artikel, gruppe, provision, typ) VALUES ('$artikelid','$gruppenid','".(float)str_replace(',','.',$tmp['provision'.$pi][$i])."','')");
                              $checkprovision = $this->app->DB->GetInsertID();
                            }
                            if(!empty($tmp['provisiontyp'.$pi][$i]))
                            {
                              $this->app->DB->Update("UPDATE provision_regeln SET typ = '".strtolower(trim($this->app->DB->real_escape_string($tmp['provisiontyp'.$pi][$i])))."' WHERE id = '$checkprovision' LIMIT 1");
                            }
                          }
                        }
                      }elseif(empty($tmp['provisiongruppe'.$pi])){
                        if(empty($tmp['provisionadresse'.$pi][$i]) && empty($tmp['provisionmitarbeiternummer'.$pi][$i]))
                        {
                          $checkprovision = $this->app->DB->Select("SELECT id FROM provisionenartikel_provision WHERE adresse = 0 AND artikel = '$artikelid' LIMIT 1");
                          if($checkprovision)
                          {
                            $this->app->DB->Update("UPDATE provisionenartikel_provision SET provision = '".(float)str_replace(',','.',$tmp['provision'.$pi][$i])."' WHERE id = '$checkprovision' LIMIT 1");
                            $this->app->DB->Update("UPDATE provisionenartikel_provision SET gueltigbis = '0000-00-00' WHERE id = '$checkprovision' LIMIT 1");
                          }else{
                            $this->app->DB->Insert("INSERT INTO provisionenartikel_provision (artikel, adresse, provision) VALUES ('$artikelid','0','".(float)str_replace(',','.',$tmp['provision'.$pi][$i])."')");
                            $checkprovision = $this->app->DB->GetInsertID();
                          }
                    
                          if(!empty($tmp['provisiontyp'.$pi][$i]))
                          {
                            $this->app->DB->Update("UPDATE provisionenartikel_provision SET provisiontyp = '".strtolower(trim($this->app->DB->real_escape_string($tmp['provisiontyp'.$pi][$i])))."' WHERE id = '$checkprovision' LIMIT 1");
                          }
                        }elseif(!empty($tmp['provisionadresse'.$pi][$i])){
                          $checkprovision = $this->app->DB->Select("SELECT id FROM provisionenartikel_provision WHERE adresse = '".(int)$tmp['provisionadresse'.$pi][$i]."' AND artikel = '$artikelid' LIMIT 1");
                          if($checkprovision)
                          {
                            $this->app->DB->Update("UPDATE provisionenartikel_provision SET provision = '".(float)str_replace(',','.',$tmp['provision'.$pi][$i])."' WHERE id = '$checkprovision' LIMIT 1");
                            $this->app->DB->Update("UPDATE provisionenartikel_provision SET gueltigbis = '0000-00-00' WHERE id = '$checkprovision' LIMIT 1");
                          }else{
                            $this->app->DB->Insert("INSERT INTO provisionenartikel_provision (artikel, adresse, provision) VALUES ('$artikelid','".(int)$tmp['provisionadresse'.$pi][$i]."','".(float)str_replace(',','.',$tmp['provision'.$pi][$i])."')");
                            $checkprovision = $this->app->DB->GetInsertID();
                          }
                          if(!empty($tmp['provisiontyp'.$pi][$i]))
                          {
                            $this->app->DB->Update("UPDATE provisionenartikel_provision SET provisiontyp = '".strtolower(trim($this->app->DB->real_escape_string($tmp['provisiontyp'.$pi][$i])))."' WHERE id = '$checkprovision' LIMIT 1");
                          }
                        }elseif(!empty($tmp['provisionmitarbeiternummer'.$pi][$i]))
                        {
                          $provisionadresse = (int)$this->app->DB->Select("SELECT id FROM adresse WHERE mitarbeiternummer = '".$this->app->DB->real_escape_string($tmp['provisionmitarbeiternummer'.$pi][$i])."' LIMIT 1");
                          if($provisionadresse)
                          {
                            $checkprovision = $this->app->DB->Select("SELECT id FROM provisionenartikel_provision WHERE adresse = '".$provisionadresse."' AND artikel = '$artikelid' LIMIT 1");
                            if($checkprovision)
                            {
                              $this->app->DB->Update("UPDATE provisionenartikel_provision SET provision = '".(float)str_replace(',','.',$tmp['provision'.$pi][$i])."' WHERE id = '$checkprovision' LIMIT 1");
                              $this->app->DB->Update("UPDATE provisionenartikel_provision SET gueltigbis = '0000-00-00' WHERE id = '$checkprovision' LIMIT 1");
                            }else{
                              $this->app->DB->Insert("INSERT INTO provisionenartikel_provision (artikel, adresse, provision) VALUES ('$artikelid','".$provisionadresse."','".(float)str_replace(',','.',$tmp['provision'.$pi][$i])."')");
                              $checkprovision = $this->app->DB->GetInsertID();
                            }
                            if(!empty($tmp['provisiontyp'.$pi][$i]))
                            {
                              $this->app->DB->Update("UPDATE provisionenartikel_provision SET provisiontyp = '".strtolower(trim($this->app->DB->real_escape_string($tmp['provisiontyp'.$pi][$i])))."' WHERE id = '$checkprovision' LIMIT 1");
                            }
                          }
                        }
                      }
                    }
                  break;
                }
              }
              if(isset($this->teilprojekt) && isset($this->projekt))
              {
                $sort = 1+(int)$this->app->DB->Select("SELECT max(sort) FROM projekt_artikel WHERE teilprojekt = '".$this->teilprojekt."'");
                $menge = 1;
                if(!empty($felder['menge']))$menge = $felder['menge'];
                if($menge < 1)$menge = 1;
                $this->app->DB->Insert("INSERT INTO projekt_artikel (projekt, teilprojekt,artikel, sort,geplant) VALUES ('".$this->projekt."','".$this->teilprojekt."','$artikelid','$sort','$menge')");
                $projektartikel = $this->app->DB->GetInsertID();
                $vk = $this->app->erp->GetVerkaufspreis($artikelid,$menge);
                $ek = $this->app->erp->GetEinkaufspreis($artikelid, $menge, $this->app->DB->Select("SELECT adresse FROM artikel WHERE id = '$artikelid' LIMIT 1"));
                if(isset($felder['vk_geplant']))$vk = (double)str_replace(',','.',$felder['vk_geplant']);
                if(isset($felder['ek_geplant']))$vk = (double)str_replace(',','.',$felder['ek_geplant']);
                if($vk)$this->app->DB->Update("UPDATE projekt_artikel SET vk_geplant = '$vk' WHERE id = '$projektartikel' LIMIT 1");
                if($vk)$this->app->DB->Update("UPDATE projekt_artikel SET ek_geplant = '$ek' WHERE id = '$projektartikel' LIMIT 1");
              }
            }
          }     
          break;
            case "zeiterfassung":
            case "wiedervorlagen":
            case "notizen":
          if($tmp['cmd'][$i]=="create")
          {
            if($tmp['nummer'][$i]!="")
            {
              foreach($fieldset as $k => $v)
              {
                $bedingung = "";
                $value = "";
                $fieldname = "";
                if(isset($fieldset[$k]['bedingung']))$bedingung = $fieldset[$k]['bedingung'];
                if(trim(strtolower($bedingung)) == 'unique')
                {


                }
                if(isset($v['nr']))
                {
                  $value = trim($tmp[$v['field']][$i]);
                  if(isset($v['inv']))
                  {
                    if($value != "1")
                    {
                      $value = 1;
                    }else{
                      $value = 0;
                    }
                  }
                } elseif(isset($v['vorlage']))
                {
                  $value = $v['vorlage'];
                }
                if(isset($v['bedingung']))$value = $this->ImportvorlageBedingung($value, $v['bedingung']);
                $fieldname = $v['field'];
                $felder[$fieldname] = $value;
              }
            }

            $adresse = $this->app->DB->Select("SELECT id FROM adresse WHERE kundennummer='".$tmp['kundennummer'][$i]."' LIMIT 1");
            $mitarbeiteradresse = $this->app->DB->Select("SELECT id FROM adresse WHERE mitarbeiternummer='".$tmp['mitarbeiternummer'][$i]."' LIMIT 1");
            if($ziel=="zeiterfassung")
            {
              $vonZeit = $tmp['datum_von'][$i]." ".$tmp['zeit_von'][$i].":00";
              $bisZeit = $tmp['datum_bis'][$i]." ".$tmp['zeit_bis'][$i].":00";
              $ort = "";
              $projekt = "";
              $art = "";
              $kunde = $adresse;
              if($tmp['taetigkeit'][$i]=="")$tmp['taetigkeit'][$i]="Zeiterfassung";
              $this->app->erp->AddArbeitszeit($this->app->User->GetID(), $vonZeit, $bisZeit, $tmp['taetigkeit'][$i], $tmp['details'][$i],$ort, $projekt, 0,$art,$kunde);
            } else if ($ziel=="wiedervorlagen")
            {
              $betreff = $tmp['betreff'][$i];
              $text = $tmp['text'][$i];
              $datum_faellig = date('Y-m-d',strtotime($tmp['datum_faellig'][$i]));
              if($tmp['uhrzeit_faellig'][$i]=="")
                $uhrzeit_faellig = "00:00:00";
              else if(strlen($tmp['uhrzeit_faellig'][$i])<=5)
                $uhrzeit_faellig = $tmp['uhrzeit_faellig'][$i].":00";
              else $uhrzeit_faellig = $tmp['uhrzeit_faellig'][$i];
              
              if($tmp['abgeschlossen'][$i]!="1") $abgeschlossen=0; else $abgeschlossen=1;
              if($tmp['prio'][$i]!="1") $prio=0; else $prio=1;
           
              $this->app->DB->Insert("INSERT INTO wiedervorlage (id,adresse,adresse_mitarbeiter,bearbeiter,bezeichnung,beschreibung,datum_erinnerung,zeit_erinnerung,datum_angelegt,abgeschlossen,prio)
                VALUES ('',$adresse,$mitarbeiteradresse,".$this->app->User->GetAdresse().",'$betreff','$text','$datum_faellig','$uhrzeit_faellig',NOW(),$abgeschlossen,$prio)");

            } else if ($ziel=="notizen")
            {
              $betreff = $tmp['betreff'][$i];
              $text = $tmp['text'][$i];
              $datum = date('Y-m-d',strtotime($tmp['datum'][$i]));
              if($tmp['uhrzeit'][$i]=="")
                $uhrzeit = "00:00:00";
              else if(strlen($tmp['uhrzeit'][$i])<=5)
                $uhrzeit = $tmp['uhrzeit'][$i].":00";
              else $uhrzeit = $tmp['uhrzeit'][$i];

              if($mitarbeiteradresse>0)
                $bearbeiter = $this->app->DB->Select("SELECT CONCAT(mitarbeiternummer,' ',name) FROM adresse WHERE id='$mitarbeiteradresse' LIMIT 1");
              else $bearbeiter="Import";
              
              $this->app->DB->Insert("INSERT INTO dokumente (id,adresse_to,adresse_from,typ,betreff,content,datum,uhrzeit,bearbeiter)
                VALUES ('',$adresse,$mitarbeiteradresse,'notiz','$betreff','$text','$datum','$uhrzeit','$bearbeiter')");
            }
          }
          break;
            case "adresse":

          // wenn import per datei
          if($stueckliste_csv !="")
            $tmp['checked'][$i]=1;

          if(!is_int($tmp['projekt'][$i]) && $tmp['projekt'][$i]!="")
          {
            $tmp['projekt'][$i] = $this->app->DB->Select("SELECT id FROM projekt WHERE abkuerzung='".$this->app->DB->real_escape_string($tmp['projekt'][$i])."' AND abkuerzung!='' LIMIT 1");
            $felder['projekt'] = $tmp['projekt'][$i];
          }

          // automatisch create und update erkennen
          if($tmp['kundennummer'][$i]=="" && $tmp['lieferantennummer'][$i]=="" && $tmp['name'][$i]=="" && $tmp['firma'][$i]=="")
          {
            $tmp['cmd'][$i]="none";
            $tmp['checked'][$i]=0;
          }
          else if($tmp['kundennummer'][$i]=="" && ($tmp['name'][$i]!="" || $tmp['firma'][$i]!="") && $tmp['lieferantennummer'][$i]=="")
          {
            $tmp['cmd'][$i]="create";
          }
          else if($tmp['lieferantennummer'][$i]!="" || $tmp['kundennummer'][$i]!="")
          {
            $checkkunde = $this->app->DB->Select("SELECT id FROM adresse WHERE kundennummer='".$this->app->DB->real_escape_string($tmp['kundennummer'][$i])."' AND kundennummer!='' LIMIT 1");
            if($checkkunde <= 0)
              $tmp['cmd'][$i]="create";
            else 
              $tmp['cmd'][$i]="update";

            if($checkkunde <= 0)
            {
              $checklieferant = $this->app->DB->Select("SELECT id FROM adresse WHERE lieferantennummer='".$this->app->DB->real_escape_string($tmp['lieferantennummer'][$i])."' AND lieferantennummer!='' LIMIT 1");
              if($checklieferant <= 0)
                $tmp['cmd'][$i]="create";
              else 
                $tmp['cmd'][$i]="update";
            }
          }

          // automatisch create und update erkennen
          if($tmp['cmd'][$i]=="create")
          {
            $adresse=0;


            foreach($fieldset as $k => $v)
            {
              $bedingung = "";
              $value = "";
              $fieldname = "";
              if(isset($v['bedingung']))$bedingung = $v['bedingung'];
              if(trim(strtolower($bedingung)) == 'unique')
              {

              }
              if(isset($v['nr']))
              {
                $value = trim($tmp[$v['field']][$i]);
                if(isset($v['inv']))
                {
                  if($value != "1")
                  {
                    $value = 1;
                  }else{
                    $value = 0;
                  }
                }
              } elseif(isset($v['vorlage']))
              {
                $value = $v['vorlage'];
              }
              if(isset($v['bedingung']))$value = $this->ImportvorlageBedingung($value, $v['bedingung']);
              $fieldname = $v['field'];
              $felder[$fieldname] = $value;

            }


            if(($tmp['kundennummer'][$i]!="" && $tmp['kundennummer'][$i]!="NEW" && $tmp['kundennummer'][$i]!="NEU") || ($tmp['lieferantennummer'][$i]!="" && $tmp['lieferantennummer'][$i]!="NEW" && $tmp['lieferantennummer'][$i]!="NEU"))
            {
              $adresse = $this->app->DB->Select("SELECT id FROM adresse WHERE kundennummer='".$this->app->DB->real_escape_string($tmp['kundennummer'][$i])."' AND kundennummer!='' LIMIT 1");
              if($adresse <=0)
                $adresse = $this->app->DB->Select("SELECT id FROM adresse WHERE lieferantennummer='".$this->app->DB->real_escape_string($tmp['lieferantennummer'][$i])."' AND lieferantennummer!='' LIMIT 1");
            }
            $felder['strasse'] = $felder['strasse']." ".$felder['hausnummer'];
            if($felder['strasse_hausnummer']!="") $felder['strasse'] = $felder['strasse_hausnummer'];

            $felder['email'] = str_replace(" ","",$felder['email']);

            $felder['sprache'] = strtolower($felder['sprache']);
            $felder['typ'] = $this->TypErkennung($felder['typ']);
            if($felder['land']=="") $felder['land']="DE";

            $felder['zahlungsweise']  = strtolower($felder['zahlungsweise']);
            $felder['versandart']  = strtolower($felder['versandart']);
            $felder['ust_befreit']  = $this->UstBefreitErkennung($felder['ust_befreit']);

            if($felder['geburtstag']!="")
            {
              if(strpos($felder['geburtstag'],'.')!==false) {
                $felder['geburtstag'] = $this->app->String->Convert($felder['geburtstag'],"%1.%2.%3","%3-%2-%1");
              }
            }

            if($felder['mandatsreferenzdatum']!="")
            {
              if(strpos($felder['mandatsreferenzdatum'],'.')!==false) {
                $felder['mandatsreferenzdatum'] = $this->app->String->Convert($felder['mandatsreferenzdatum'],"%1.%2.%3","%3-%2-%1");
              }
            }

            if($felder['liefersperredatum']!="")
            {
              if(strpos($felder['liefersperredatum'],'.')!==false) {
                $felder['liefersperredatum'] = $this->app->String->Convert($felder['liefersperredatum'],"%1.%2.%3","%3-%2-%1");
              }
            }
            
            if(isset($felder['liefersperre']))
            {
              if($felder['liefersperre'] === "1" || strtolower($felder['liefersperre']) === 'x'|| substr(strtolower($felder['liefersperre']),0,1) === 'j')
              {
                $felder['liefersperre'] = 1;
              }elseif($felder['liefersperre'] === "0" || strtolower($felder['liefersperre']) === ''|| substr(strtolower($felder['liefersperre']),0,1) === 'n')
              {
                $felder['liefersperre'] = 0;
              }
            }


            if($felder['plz_ort']!="")
            {
              $felder['plz'] = strstr($felder['plz_ort'], ' ', true); 
              $felder['ort'] = strstr($felder['plz_ort'], ' '); 
            }

            if($felder['name']!="" || $felder['firma']!="")
            { 
              if($felder['firma']!="")
              {
                if($felder['vorname']!="")
                  $felder['ansprechpartner']=$felder['vorname']." ".$felder['name'];
                else
                  $felder['ansprechpartner']=$felder['name'];

                $felder['name']=$felder['firma'];
                $felder['typ']='firma';
              } else {
                if($felder['vorname']!="" && $felder['nachname']=="")
                  $felder['name']=$felder['vorname']." ".$felder['name'];
              }

              $felder['typ'] = $this->TypErkennung($felder['typ']);
              
              if($felder['rechnung_firma']!="")
              {
                if($felder['rechnung_vorname']!="")
                  $felder['rechnung_ansprechpartner']=$felder['rechnung_vorname']." ".$felder['rechnung_name'];
                else
                  $felder['rechnung_ansprechpartner']=$felder['rechnung_name'];

                $felder['rechnung_name']=$felder['rechnung_firma'];
                $felder['rechnung_typ']='firma';
              } else {
                if($felder['rechnung_vorname']!="" && $felder['rechnung_nachname']=="")
                  $felder['rechnung_name']=$felder['rechnung_vorname']." ".$felder['rechnung_name'];
              }
 
              if($felder['rechnung_typ']!="")
                $felder['rechnung_typ'] = $this->TypErkennung($felder['rechnung_typ']);



              $als_ansprechpartner_speichern = false;
              //pruefe ob datensatz ein ansprechpartner werden soll
              if($felder['lieferantennummer']!=str_replace("ANSPRECHPARTNER","",$felder['lieferantennummer'])) 
              {
                // Dieser Datensatz wird als ansprechpartner verwendet
                $als_ansprechpartner_speichern = true;
                $ermittle_adresse = str_replace("ANSPRECHPARTNER","",$felder['lieferantennummer']);
                $ermittle_adresse = rtrim(ltrim($ermittle_adresse," :"));
                $adresse = $this->app->DB->Select("SELECT id FROM adresse WHERE lieferantennummer='$ermittle_adresse' AND lieferantennummer!='' LIMIT 1");

                if($tmp['strasse_hausnummer'][$i]!="") $tmp['strasse'][$i] = $felder['strasse_hausnummer'];
                $tmp['typ'][$i] = $this->TypErkennung($felder['typ']);
                
                switch($tmp['typ'][$i])
                {
                  case 'herr':
                    $tmp['typ'][$i] = 'Herr';
                  break;
                  case 'frau':
                    $tmp['typ'][$i] = 'Frau';
                  break;
                  case 'firma':
                    $tmp['typ'][$i] = 'Firma / Filiale / Niederlassung';
                  break;                  
                }
                
                $tmp['name'][$i] = $felder['name'];

                $data_fields = array('typ','name','abteilung','unterabteilung','adresszusatz','titel','strasse','ort','plz',
                    'land','telefon','telefax','email','mobil','anschreiben');
                foreach($data_fields as $tmp_key=>$data_field_key)
                {
                  $data_ansprechpartner[$data_field_key] = $tmp[$data_field_key][$i];
                }
                $this->app->erp->ImportCreateAnsprechpartner($adresse,$data_ansprechpartner);
              }
              else if($felder['kundennummer']!=str_replace("ANSPRECHPARTNER","",$felder['kundennummer'])) 
              {
                // Dieser Datensatz wird als ansprechpartner verwendet
                $als_ansprechpartner_speichern = true;
                $ermittle_adresse = str_replace("ANSPRECHPARTNER","",$felder['kundennummer']);
                $ermittle_adresse = rtrim(ltrim($ermittle_adresse," :"));
                $adresse = $this->app->DB->Select("SELECT id FROM adresse WHERE kundennummer='$ermittle_adresse' AND kundennummer!='' LIMIT 1");

                if($tmp['strasse_hausnummer'][$i]!="") $tmp['strasse'][$i] = $felder['strasse_hausnummer'];
                $tmp['typ'][$i] = $this->TypErkennung($felder['typ']);
                
                switch($tmp['typ'][$i])
                {
                  case 'herr':
                    $tmp['typ'][$i] = 'Herr';
                  break;
                  case 'frau':
                    $tmp['typ'][$i] = 'Frau';
                  break;
                  case 'firma':
                    $tmp['typ'][$i] = 'Firma / Filiale / Niederlassung';
                  break;                  
                }
                
                $tmp['name'][$i] = $felder['name'];

                $data_fields = array('typ','name','abteilung','unterabteilung','adresszusatz','titel','strasse','ort','plz',
                    'land','telefon','telefax','email','mobil','anschreiben');
                    
                
                    
                foreach($data_fields as $tmp_key=>$data_field_key)
                {
                  $data_ansprechpartner[$data_field_key] = $tmp[$data_field_key][$i];
                }
                $this->app->erp->ImportCreateAnsprechpartner($adresse,$data_ansprechpartner);
              } 
              else {
                $loeschen_lfr_new=false;
                if(strtoupper($felder['lieferantennummer'])=="NEW" || strtoupper($felder['lieferantennummer'])=="NEU")
                  $loeschen_lfr_new=true;

                $loeschen_kd_new=false;
                if(strtoupper($felder['kundennummer'])=="NEW" || strtoupper($felder['kundennummer'])=="NEU" )
                  $loeschen_kd_new=true;

                $loeschen_mi_new=false;
                if(strtoupper($felder['mitarbeiternummer'])=="NEW" || strtoupper($felder['mitarbeiternummer'])=="NEU" )
                  $loeschen_mi_new=true;


                if($loeschen_lfr_new) $felder['lieferantennummer']="";
                if($loeschen_kd_new) $felder['kundennummer']="";
                if($loeschen_mi_new) $felder['mitarbeiternummer']="";
                foreach($felder as $kk => $vv)$__felder[$kk] = $this->app->DB->real_escape_string($vv);
                $adresse =$this->app->erp->ImportCreateAdresse($__felder, false);
                unset($__felder);
                $this->app->erp->ImportvorlageLog($id,$zeitstempel,"adresse",$adresse,$ersterdatensatz);
                $ersterdatensatz=0;

                if($felder['lieferantennummer']!="" || $loeschen_lfr_new)
                {
                  $this->app->erp->AddRolleZuAdresse($adresse, "Lieferant", "von","Projekt",$tmp['projekt'][$i]);
                }
                if($felder['kundennummer']!="" || $loeschen_kd_new)
                {
                  $this->app->erp->AddRolleZuAdresse($adresse, "Kunde", "von","Projekt",$tmp['projekt'][$i]);
                }
                if($felder['mitarbeiternummer']!="" || $loeschen_mi_new)
                {
                  $this->app->erp->AddRolleZuAdresse($adresse, "Mitarbeiter", "von","Projekt",$tmp['projekt'][$i]);
                }
              }
              
              if($adresse)
              {
                for($gk = 1; $gk <= 5; $gk++)
                {
                  $key = "gruppe".$gk;
                  if(trim($tmp[$key][$i]) != '')
                  {
                    $gr = $this->app->DB->Select("SELECT id FROM gruppen WHERE kennziffer = '".$this->app->DB->real_escape_string(trim($tmp[$key][$i]))."' LIMIT 1");
                    if(!$gr)$gr = $this->app->DB->Select("SELECT id FROM gruppen WHERE name = '".$this->app->DB->real_escape_string(trim($tmp[$key][$i]))."' LIMIT 1");
                    if($gr)
                    {
                      $check = $this->app->DB->Select("SELECT id FROM adresse_rolle WHERE adresse = '$adresse' AND objekt like 'Gruppe' AND parameter = '$gr' AND (bis = '0000-00-00' OR isnull(bis) OR bis >= curdate()) LIMIT 1");
                      if(!$check)
                      {
                        $projekt = $tmp['projekt'][$i];
                        if(!$projekt)$projekt = $this->app->DB->Select("SELECT projekt FROM adresse WHERE id = '$adresse' LIMIT 1");
                        $this->app->DB->Insert("INSERT INTO adresse_rolle (adresse, projekt, subjekt, praedikat, objekt, parameter, von, bis) VALUES ('$adresse','$projekt','Mitglied','von','Gruppe','$gr',curdate(),'0000-00-00')");
                      }
                    }
                  }                
                }
              }
              
              // Ansprechpartner automatisch anlegen

              if($felder['ansprechpartner1name']!="" && !$als_ansprechpartner_speichern)
              {
                unset($data);
                $data['name']=$felder['ansprechpartner1name'];
                $data['typ']=$this->TypErkennung($felder['ansprechpartner1typ']);
                $data['strasse']=$felder['ansprechpartner1strasse'];
                $data['sprache']=$felder['ansprechpartner1sprache'];
                $data['bereich']=$felder['ansprechpartner1bereich'];
                $data['abteilung']=$felder['ansprechpartner1abteilung'];
                $data['unterabteilung']=$felder['ansprechpartner1unterabteilung'];
                $data['land']=$felder['ansprechpartner1land'];
                $data['ort']=$felder['ansprechpartner1ort'];
                $data['plz']=$felder['ansprechpartner1plz'];
                $data['telefon']=$felder['ansprechpartner1telefon'];
                $data['telefax']=$felder['ansprechpartner1telefax'];
                $data['mobil']=$felder['ansprechpartner1mobil'];
                $data['email']=$felder['ansprechpartner1email'];
                $data['sonstiges']=$felder['ansprechpartner1sonstiges'];
                $data['adresszusatz']=$felder['ansprechpartner1adresszusatz'];
                $data['ansprechpartner_land']=$felder['ansprechpartner1ansprechpartner_land'];
                $data['anschreiben']=$felder['ansprechpartner1anschreiben'];
                $data['titel']=$felder['ansprechpartner1titel'];
                $this->app->erp->CreateAnsprechpartner($adresse,$data);
              }


              if($felder['ansprechpartner2name']!="" && !$als_ansprechpartner_speichern )
              {
                unset($data);
                $data['name']=$felder['ansprechpartner2name'];
                $data['typ']=$this->TypErkennung($felder['ansprechpartner2typ']);
                $data['strasse']=$felder['ansprechpartner2strasse'];
                $data['sprache']=$felder['ansprechpartner2sprache'];
                $data['bereich']=$felder['ansprechpartner2bereich'];
                $data['abteilung']=$felder['ansprechpartner2abteilung'];
                $data['unterabteilung']=$felder['ansprechpartner2unterabteilung'];
                $data['land']=$felder['ansprechpartner2land'];
                $data['ort']=$felder['ansprechpartner2ort'];
                $data['plz']=$felder['ansprechpartner2plz'];
                $data['telefon']=$felder['ansprechpartner2telefon'];
                $data['telefax']=$felder['ansprechpartner2telefax'];
                $data['mobil']=$felder['ansprechpartner2mobil'];
                $data['email']=$felder['ansprechpartner2email'];
                $data['sonstiges']=$felder['ansprechpartner2sonstiges'];
                $data['adresszusatz']=$felder['ansprechpartner2adresszusatz'];
                $data['ansprechpartner_land']=$felder['ansprechpartner2ansprechpartner_land'];
                $data['anschreiben']=$felder['ansprechpartner2anschreiben'];
                $data['titel']=$felder['ansprechpartner2titel'];
                $this->app->erp->CreateAnsprechpartner($adresse,$data);
              }

              if($felder['ansprechpartner3name']!="" && !$als_ansprechpartner_speichern )
              {
                unset($data);
                $data['name']=$felder['ansprechpartner3name'];
                $data['typ']=$this->TypErkennung($felder['ansprechpartner3typ']);
                $data['strasse']=$felder['ansprechpartner3strasse'];
                $data['sprache']=$felder['ansprechpartner3sprache'];
                $data['bereich']=$felder['ansprechpartner3bereich'];
                $data['abteilung']=$felder['ansprechpartner3abteilung'];
                $data['unterabteilung']=$felder['ansprechpartner3unterabteilung'];
                $data['land']=$felder['ansprechpartner3land'];
                $data['ort']=$felder['ansprechpartner3ort'];
                $data['plz']=$felder['ansprechpartner3plz'];
                $data['telefon']=$felder['ansprechpartner3telefon'];
                $data['telefax']=$felder['ansprechpartner3telefax'];
                $data['mobil']=$felder['ansprechpartner3mobil'];
                $data['email']=$felder['ansprechpartner3email'];
                $data['sonstiges']=$felder['ansprechpartner3sonstiges'];
                $data['adresszusatz']=$felder['ansprechpartner3adresszusatz'];
                $data['ansprechpartner_land']=$felder['ansprechpartner3ansprechpartner_land'];
                $data['anschreiben']=$felder['ansprechpartner3anschreiben'];
                $data['titel']=$felder['ansprechpartner3titel'];
                $this->app->erp->CreateAnsprechpartner($adresse,$data);
              }

              if($felder['lieferadresse1name']!="")
              {
                unset($data);
                $data['name']=$felder['lieferadresse1name'];
                $data['typ']=$this->TypErkennung($felder['lieferadresse1typ']);
                $data['strasse']=$felder['lieferadresse1strasse'];
                $data['abteilung']=$felder['lieferadresse1abteilung'];
                $data['unterabteilung']=$felder['lieferadresse1unterabteilung'];
                $data['land']=$felder['lieferadresse1land'];
                $data['ort']=$felder['lieferadresse1ort'];
                $data['plz']=$felder['lieferadresse1plz'];
                $data['telefon']=$felder['lieferadresse1telefon'];
                $data['telefax']=$felder['lieferadresse1telefax'];
                $data['email']=$felder['lieferadresse1email'];
                $data['sonstiges']=$felder['lieferadresse1sonstiges'];
                $data['adresszusatz']=$felder['lieferadresse1adresszusatz'];
                $data['ansprechpartner']=$felder['lieferadresse1ansprechpartner'];
                $data['standardlieferadresse']=$felder['lieferadresse1standardlieferadresse'];
                $this->app->erp->CreateLieferadresse($adresse,$data);
              }

              if($felder['lieferadresse2name']!="")
              {
                unset($data);
                $data['name']=$felder['lieferadresse2name'];
                $data['typ']=$this->TypErkennung($felder['lieferadresse2typ']);
                $data['strasse']=$felder['lieferadresse2strasse'];
                $data['abteilung']=$felder['lieferadresse2abteilung'];
                $data['unterabteilung']=$felder['lieferadresse2unterabteilung'];
                $data['land']=$felder['lieferadresse2land'];
                $data['ort']=$felder['lieferadresse2ort'];
                $data['plz']=$felder['lieferadresse2plz'];
                $data['telefon']=$felder['lieferadresse2telefon'];
                $data['telefax']=$felder['lieferadresse2telefax'];
                $data['email']=$felder['lieferadresse2email'];
                $data['sonstiges']=$felder['lieferadresse2sonstiges'];
                $data['adresszusatz']=$felder['lieferadresse2adresszusatz'];
                $data['ansprechpartner']=$felder['lieferadresse2ansprechpartner'];
                $data['standardlieferadresse']=$felder['lieferadresse2standardlieferadresse'];
                $this->app->erp->CreateLieferadresse($adresse,$data);
              }

              if($felder['lieferadresse3name']!="")
              {
                unset($data);
                $data['name']=$felder['lieferadresse3name'];
                $data['typ']=$this->TypErkennung($felder['lieferadresse3typ']);
                $data['strasse']=$felder['lieferadresse3strasse'];
                $data['abteilung']=$felder['lieferadresse3abteilung'];
                $data['unterabteilung']=$felder['lieferadresse3unterabteilung'];
                $data['land']=$felder['lieferadresse3land'];
                $data['ort']=$felder['lieferadresse3ort'];
                $data['plz']=$felder['lieferadresse3plz'];
                $data['telefon']=$felder['lieferadresse3telefon'];
                $data['telefax']=$felder['lieferadresse3telefax'];
                $data['email']=$felder['lieferadresse3email'];
                $data['sonstiges']=$felder['lieferadresse3sonstiges'];
                $data['adresszusatz']=$felder['lieferadresse3adresszusatz'];
                $data['ansprechpartner']=$felder['lieferadresse3ansprechpartner'];
                $data['standardlieferadresse']=$felder['lieferadresse3standardlieferadresse'];
                $this->app->erp->CreateLieferadresse($adresse,$data);
              }

              //rolle verpassen
            }


          }
          else if($tmp['cmd'][$i]=="update")// && $tmp['checked'][$i]=="1")
          {

            $adresse=0;

            if($tmp['kundennummer'][$i]!="" || $tmp['lieferantennummer'][$i]!="")
            {
              $adresse = $this->app->DB->Select("SELECT id FROM adresse WHERE kundennummer='".$tmp['kundennummer'][$i]."' AND kundennummer!='' LIMIT 1");
              if($adresse <=0)
                $adresse = $this->app->DB->Select("SELECT id FROM adresse WHERE lieferantennummer='".$tmp['lieferantennummer'][$i]."' AND lieferantennummer!='' LIMIT 1");
            }
            if($adresse > 0)
            {
              $fields_tmp = "";

              foreach($fieldset as $k => $v)
              {
                $bedingung = "";
                $value = "";
                $fieldname = "";
                if(isset($fieldset[$k]['bedingung']))$bedingung = $fieldset[$k]['bedingung'];
                if(trim(strtolower($bedingung)) == 'unique')
                {

                }
                if(isset($fieldset[$k]['nr']))
                {
                  $value = trim($data[$fieldset[$k]['nr'] - 1]);
                  if(isset($fieldset[$k]['inv']))
                  {
                    if($value != "1")
                    {
                      $value = 1;
                    }else{
                      $value = 0;
                    }
                  }
                } elseif(isset($fieldset[$k]['vorlage']))
                {
                  $value = $fieldset[$k]['vorlage'];
                }
                if(isset($fieldset[$k]['bedingung']))$value = $this->ImportvorlageBedingung($value, $fieldset[$k]['bedingung']);
                $fieldname = $fieldset[$k]['field'];
                $felder[$fieldname] = $value;

                $key = $fieldname;
                $value = $fieldname;

                $felder[$key]=$tmp[$value][$i];
                if($key=="typ" || $key=="zahlungsweise" || $key=="versandart") $tmp[$value][$i] = strtolower($tmp[$value][$i]);

                if($key=="typ" || $key=="rechnung_typ")
                {
                  $tmp[$value][$i] = $this->TypErkennung($tmp[$value][$i]);
                }

                if($key=="ust_befreit")
                {
                  $tmp[$value][$i] = $this->UstBefreitErkennung($tmp[$value][$i]);
                }

                if($key=="land") {
                  if($tmp[$value][$i]=="Deutschland" || $tmp[$value][$i]=="Germany" || $tmp[$value][$i]=="")
                    $tmp[$value][$i] = "DE";
                }

                if($key=="rechnung_vorname")
                {
                  if($tmp['rechnung_vorname'][$i]!="") $tmp['rechnung_name'][$i] = $tmp['rechnung_vorname'][$i]." ".$tmp['rechnung_name'][$i];
                }

                if($key=="name")
                {
                  if($tmp['vorname'][$i]!="" && $tmp['firma'][$i]=="") $tmp['name'][$i] = $tmp['vorname'][$i]." ".$tmp['name'][$i];

                  if($tmp['firma'][$i]!='') {
                    if($tmp['name'][$i]!="") {                                                                                                                                                                                         
                      if($tmp['vorname'][$i]!="")
                        $this->app->DB->Update("UPDATE adresse SET ansprechpartner='".$tmp['vorname'][$i]." ".$tmp['name'][$i]."' WHERE id='$adresse' LIMIT 1");                                 
                      else
                        $this->app->DB->Update("UPDATE adresse SET ansprechpartner='".$tmp['name'][$i]."' WHERE id='$adresse' LIMIT 1");                                 
                    }      
                    $this->app->DB->Update("UPDATE adresse SET name='".$tmp['firma'][$i]."' WHERE id='$adresse' LIMIT 1");                                 
                  }
                }
                if($key=="firma")
                {
                  $this->app->DB->Update("UPDATE adresse SET typ='firma', name='".$tmp['firma'][$i]."',ansprechpartner='".$tmp['name'][$i]."' WHERE id='$adresse' LIMIT 1");
                  if($tmp['vorname'][$i]!="") {
                    $this->app->DB->Update("UPDATE adresse SET typ='firma', ansprechpartner='".$tmp['vorname'][$i]." ".$tmp['name'][$i]."' WHERE id='$adresse' LIMIT 1");
                  }
                }

                switch($key)
                {
                  case "gruppe1":
                  case "gruppe2":
                  case "gruppe3":
                  case "gruppe4":
                  case "gruppe5":
                    if(trim($tmp[$key][$i]) != '')
                    {
                      $gr = $this->app->DB->Select("SELECT id FROM gruppen WHERE kennziffer = '".$this->app->DB->real_escape_string(trim($tmp[$key][$i]))."' LIMIT 1");
                      if(!$gr)$gr = $this->app->DB->Select("SELECT id FROM gruppen WHERE name = '".$this->app->DB->real_escape_string(trim($tmp[$key][$i]))."' LIMIT 1");
                      if($gr)
                      {
                        $check = $this->app->DB->Select("SELECT id FROM adresse_rolle WHERE adresse = '$adresse' AND objekt like 'Gruppe' AND parameter = '$gr' AND (bis = '0000-00-00' OR isnull(bis) OR bis >= curdate()) LIMIT 1");
                        if(!$check)
                        {
                          $projekt = $tmp['projekt'][$i];
                          if(!$projekt)$projekt = $this->app->DB->Select("SELECT projekt FROM adresse WHERE id = '$adresse' LIMIT 1");
                          $this->app->DB->Insert("INSERT INTO adresse_rolle (adresse, projekt, subjekt, praedikat, objekt, parameter, von, bis) VALUES ('$adresse','$projekt','Mitglied','von','Gruppe','$gr',curdate(),'0000-00-00')");
                        }
                      }
                      
                    }
                  break;
                }
                
                if($key=="liefersperre")
                {
                  if(isset($tmp['liefersperre'][$i]))
                  {
                    if($tmp['liefersperre'][$i] === "1" || strtolower($tmp['liefersperre'][$i]) === 'x'|| substr(strtolower($tmp['liefersperre'][$i]),0,1) === 'j')
                    {
                      $tmp['liefersperre'][$i] = 1;
                      $this->app->DB->Update("UPDATE adresse SET liefersperre='1' WHERE id='$adresse' LIMIT 1");
                    }elseif($tmp['liefersperre'][$i] === "0" || strtolower($tmp['liefersperre'][$i]) === ''|| substr(strtolower($tmp['liefersperre'][$i]),0,1) === 'n')
                    {
                      $tmp['liefersperre'][$i] = 0;
                      $this->app->DB->Update("UPDATE adresse SET liefersperre='0' WHERE id='$adresse' LIMIT 1");
                    }
                  }
                }
                
                
                if($key=="plz_ort")
                {
                  $tmp['plz'][$i] = strstr($felder['plz_ort'], ' ', true); 
                  $tmp['ort'][$i] = strstr($felder['plz_ort'], ' '); 
                  $this->app->DB->Update("UPDATE adresse SET plz='".$tmp['plz'][$i]."', ort='".$tmp['ort'][$i]."' WHERE id='$adresse' LIMIT 1");
                }
           
                if($key=="strasse" || $key=="hausnummer")
                {
                  if($tmp['hausnummer'][$i]!="")
                    $tmp['strasse'][$i] = $tmp['strasse'][$i]." ".$tmp['hausnummer'][$i];
                }

                if($key=="strasse_hausnummer")
                {
                  $this->app->DB->Update("UPDATE adresse SET strasse='".$this->app->DB->real_escape_string($tmp['strasse_hausnummer'][$i])."' WHERE id='$adresse' LIMIT 1");
                }

                if($key=="geburtstag")
                {
                  if(strpos($tmp[$value][$i],'.')!==false) {
                    $tmp[$value][$i] = $this->app->String->Convert($tmp[$value][$i],"%1.%2.%3","%3-%2-%1");
                  }
                }

                if($key=="mandatsreferenzdatum")
                {
                  if(strpos($tmp[$value][$i],'.')!==false) {
                    $tmp[$value][$i] = $this->app->String->Convert($tmp[$value][$i],"%1.%2.%3","%3-%2-%1");
                  }
                }

                if($key=="liefersperredatum")
                {
                  if(strpos($tmp[$value][$i],'.')!==false) {
                    $tmp[$value][$i] = $this->app->String->Convert($tmp[$value][$i],"%1.%2.%3","%3-%2-%1");
                  }
                }

                $fields_tmp = " ".$v['field']."='".$this->app->DB->real_escape_string($tmp[$value][$i])."' ";
                $this->app->DB->Update("UPDATE adresse SET $fields_tmp WHERE id='$adresse' LIMIT 1");
              }

            }
          }
          break;
        }
      }
      if($return)return $number_of_rows;
      if($ziel=="zeiterfassung" || $ziel=="wiedervorlage" || $ziel=="notizen")
      {
        $msg=$this->app->erp->base64_url_encode("<div class=\"info\">Import durchgef&uuml;hrt.</div>");
        header("Location: index.php?module=importvorlage&action=import&id=$id&msg=$msg");
        exit;
      } else {    
        $msg=$this->app->erp->base64_url_encode("<div class=\"info\">Import durchgef&uuml;hrt.</div>");
        header("Location: index.php?module=importvorlage&action=import&id=$id&msg=$msg");
        exit;
      }
    }

  function ImportvorlageBedingung($value, $bedingung)
  {
    if(strpos($bedingung,'?') !== false && strpos($bedingung,':') !== false)
    {
      $beda = explode('?',$bedingung,2);
      $beda[1] = trim(trim($beda[1]),'"');
      $beda[1] = str_replace('%value%',$value,$beda[1]);

      $beda2 = explode(':',$beda[1],2);
      if(isset($beda2[1]))
      {
        $beda[1] = $beda2[0];
        $beda2[1] = trim(trim($beda2[1]),'"');
        $beda2[1] = str_replace('%value%',$value,$beda2[1]);
        if(strpos($beda[0],'>=') !== false)
        {
          $beda3 = explode('>=',$beda[0],2);
          $beda3[1] = trim(trim($beda3[1]),'"');          
          if(trim(trim($value),'"') >= trim(trim($beda3[1]),'"'))
          {
            return $beda[1];
          }else{
            return $beda2[1];
          }

        }elseif(strpos($beda[0],'<=') !== false)
        {
          $beda3 = explode('<=',$beda[0],2);
          $beda3[1] = trim(trim($beda3[1]),'"');          
          if(trim(trim($value),'"') <= trim(trim($beda3[1]),'"'))
          {
            return $beda[1];
          }else{
            return $beda2[1];
          }        
        }elseif(strpos($beda[0],'>') !== false)
        {
          $beda3 = explode('>',$beda[0],2);
          $beda3[1] = trim(trim($beda3[1]),'"');          
          if(trim(trim($value),'"') > trim(trim($beda3[1]),'"'))
          {
            return $beda[1];
          }else{
            return $beda2[1];
          }

        }elseif(strpos($beda[0],'<') !== false)
        {
          $beda3 = explode('<',$beda[0],2);
          $beda3[1] = trim(trim($beda3[1]),'"');          
          if(trim(trim($value),'"') < trim(trim($beda3[1]),'"'))
          {
            return $beda[1];
          }else{
            return $beda2[1];
          }
        }elseif(strpos($beda[0],'!=') !== false)
        {
          $beda3 = explode('!=',$beda[0],2);
          $beda3[1] = trim(trim($beda3[1]),'"');          
          if(trim(trim($value),'"') != trim(trim($beda3[1]),'"'))
          {
            return $beda[1];
          }else{
            return $beda2[1];
          }
        }elseif(strpos($beda[0],'==') !== false)
        {
          $beda3 = explode('==',$beda[0],2);
          $beda3[1] = trim(trim($beda3[1]),'"');          
          if(trim(trim($value),'"') == trim(trim($beda3[1]),'"'))
          {
            return $beda[1];
          }else{
            return $beda2[1];
          }
        }elseif(strpos($beda[0],'=') !== false)
        {
          $beda3 = explode('=',$beda[0],2);
          $beda3[1] = trim(trim($beda3[1]),'"');          
          if(trim(trim($value),'"') == trim(trim($beda3[1]),'"'))
          {
            return $beda[1];
          }else{
            return $beda2[1];
          }
        }
      }
    }
    return $value;
  }


  function ImportPrepareHeader($ziel,$fieldset)
  {
    $number_of_fields =count($fieldset);

    switch($ziel)
    {
      case "einkauf":
      case "artikel":
        $this->app->Tpl->Add('ERGEBNIS','<tr><td width="100"><b>Auswahl</b></td><td width="100"><b>Aktion</b></td><td><b>Artikel</b></td>');
        break;
      case "adresse":
        $this->app->Tpl->Add('ERGEBNIS','<tr><td width="100"><b>Auswahl</b></td><td width="100"><b>Aktion</b></td><td><b>Adresse</b></td>');
        break;

      case "zeiterfassung":
      case "wiedervorlagen":
      case "notizen":
        $this->app->Tpl->Add('ERGEBNIS','<tr><td width="100"><b>Auswahl</b></td>
            <td width="100"><b>Aktion</b></td><td><b>Kunde</b></td>');
        break;
      default:
        $this->app->Tpl->Add('ERGEBNIS','<tr><td width="100"><b>Auswahl</b></td>
            <td width="100"><b>Aktion</b></td><td><b></b></td>');          
      break;
    }

    for($j=0;$j<$number_of_fields;$j++)
    {
      if(isset($fieldset[$j]) && isset($fieldset[$j]['field']))$this->app->Tpl->Add('ERGEBNIS','<td><b>'.$fieldset[$j]['field'].'</b></td>');
    }

    $this->app->Tpl->Add('ERGEBNIS','</tr>');
  }

  function ImportPrepareRow($rowcounter,$ziel,$data,$fieldset)
  {
    $number_of_fields =count($fieldset);
    //Standard
    $fields['waehrung'] = 'EUR';

    for($j=0;$j<$number_of_fields;$j++)
    {
      $value = "";
      $bedingung = false;
      if(isset($fieldset[$j]['bedingung']))$bedingung = $fieldset[$j]['bedingung'];
      if(isset($fieldset[$j]['nr']))
      {
        $value = trim($data[$fieldset[$j]['nr'] - 1]);
        if(isset($fieldset[$j]['inv']))
        {
          if($value != "1")
          {
            $value = 1;
          }else{
            $value = 0;
          }
        }
      } elseif(isset($fieldset[$j]['vorlage']))
      {
        $value = $fieldset[$j]['vorlage'];
      }
      if(isset($fieldset[$j]['bedingung']))$value = $this->ImportvorlageBedingung($value, $fieldset[$j]['bedingung']);
      $fieldname = $fieldset[$j]['field'];

      switch($fieldname)
      {
        case "herstellernummer":
          $fields['herstellernummer'] = $value;
          $fields['herstellernummer'] = $this->app->DB->Select("SELECT herstellernummer 
              FROM artikel WHERE herstellernummer='".$this->app->DB->real_escape_string($fields['herstellernummer'])."' LIMIT 1");
          //                                                    if($fields[herstellernummer]<=0) $fields[herstellernummer]="";
          break;
        case "nummer":
          $fields['nummer'] = trim($value);
          $fields['nummer'] = $this->app->DB->Select("SELECT nummer FROM artikel WHERE nummer='".$this->app->DB->real_escape_string($fields['nummer'])."' LIMIT 1");

          foreach($fieldset as $k => $v)
          {
            $bedingung = "";
            if(isset($fieldset[$k]['bedingung']))$bedingung = $fieldset[$k]['bedingung'];
            if(trim(strtolower($bedingung)) == 'unique')
            {

              if($v['field'] && isset($fields[$v['field']])  && $fields[$v['field']])
              {
                $adressid = $this->app->DB->Select("SELECT id FROM artikel WHERE ".$v['field']."='".$this->app->DB->real_escape_string($fields[$v['field']])."' LIMIT 1");
                if($adressid)
                {
                  if(isset($fields['nummer']) && (strtoupper($value) == 'NEW' || strtoupper($value) == 'NEU'))
                  {
                    $fields['nummer'] = $this->app->DB->Select("SELECT nummer FROM artikel WHERE id = '".$adressid."' LIMIT 1");
                  }
                }
              }
            }
          }
          break;
        case "lieferantennummer":
          $fields['lieferantennummer'] = $value;
          $fields['lieferantennummer'] = $this->app->DB->Select("SELECT lieferantennummer FROM adresse WHERE lieferantennummer='".$this->app->DB->real_escape_string($fields['lieferantennummer'])."' LIMIT 1");

          foreach($fieldset as $k => $v)
          {
            $bedingung = "";
            if(isset($fieldset[$k]['bedingung']))$bedingung = $fieldset[$k]['bedingung'];
            if(trim(strtolower($bedingung)) == 'unique')
            {

              if($v['field'] && isset($fields[$v['field']])  && $fields[$v['field']])
              {
                $adressid = $this->app->DB->Select("SELECT id FROM adresse WHERE ".$v['field']."='".$this->app->DB->real_escape_string($fields[$v['field']])."' LIMIT 1");
                if($adressid)
                {
                  if(isset($fields['lieferantennummer']) && (strtoupper($value) == 'NEW' || strtoupper($value) == 'NEU'))
                  {
                    $fields['lieferantennummer'] = $this->app->DB->Select("SELECT lieferantennummer FROM adresse WHERE id = '".$adressid."' LIMIT 1");
                  }
                }
              }
            }
          }

          $lieferantid = $this->app->DB->Select("SELECT id FROM adresse WHERE lieferantennummer='".$this->app->DB->real_escape_string($fields['lieferantennummer'])."' LIMIT 1");
          break;
        case "kundennummer":
          $fields['kundennummer'] = $value;
          $fields['kundennummer'] = $this->app->DB->Select("SELECT kundennummer FROM adresse WHERE kundennummer='".$this->app->DB->real_escape_string($fields['kundennummer'])."' LIMIT 1");
          foreach($fieldset as $k => $v)
          {
            $bedingung = "";
            if(isset($fieldset[$k]['bedingung']))$bedingung = $fieldset[$k]['bedingung'];
            if(trim(strtolower($bedingung)) == 'unique')
            {

              if($v['field'] && isset($fields[$v['field']])  && $fields[$v['field']])
              {
                $adressid = $this->app->DB->Select("SELECT id FROM adresse WHERE ".$v['field']."='".$this->app->DB->real_escape_string($fields[$v['field']])."' LIMIT 1");
                if($adressid)
                {
                  if(isset($fields['kundennummer']) && (strtoupper($value) == 'NEW' || strtoupper($value) == 'NEU'))
                  {
                    $fields['kundennummer'] = $this->app->DB->Select("SELECT kundennummer FROM adresse WHERE id = '".$adressid."' LIMIT 1");
                  }
                }
              }
            }
          }
          break;
        case "ab_menge":
          $fields['ab_menge'] = $value;
          break;
        case "ean":
          $fields['ab_menge'] = $value;
          break;
        case "waehrung":
          $fields['waehrung'] = $value;
          break;
        case "ekpreis":
          $value = str_replace('EUR','',$value);
          $value = str_replace(' ','',$value);
          if(preg_match('#^(?<integer>.*)(?<separator>[\.,])(?<decimals>[0-9]+)$#', $value, $matches))
          {
            /* clean integer and append decimals with your own separator */
            $number = ((int) preg_replace('#[^0-9]+#', '', $matches['integer']) . ',' . $matches['decimals']);
          }
          else
          {
            $number = (int) preg_replace('#[^0-9]+#', '', $input);
          }
          // $formatter = new NumberFormatter('de_DE', NumberFormatter::CURRENCY);

          // prüfe von rechts letztes zeichen das keine 0 ist

          // let's print the international format for the en_US locale
          $value = $number;
          $fields['ekpreis'] = $value;
          break;
        case "datum_von":
          $value = $this->app->String->Convert($value,"%1.%2.%3","%3-%2-%1");
          $fields['datum_von'] = $value;
          break;
        case "datum_bis":
          $value = $this->app->String->Convert($value,"%1.%2.%3","%3-%2-%1");
          $fields['datum_bis'] = $value;
          break;
        case "kennung":
          $fields['kennung'] = $value;
          break;
        case "zeit_bis":
          $fields['zeit_bis'] = $value;
          break;
        case "zeit_von":
          $fields['zeit_von'] = $value;
          break;
        default:
          $fields[$fieldname] = $value; 
      }

      $output .= '<td><input type="text" size="15" name="row['.$fieldname.']['.$rowcounter.']" value="'.$value.'" readonly></td>';
    }

    switch($ziel)
    {
      case "einkauf":
        $checked = "checked";
        if($fields['lieferantennummer']=="")
        {
          $action_anzeige = "Keine (Lieferant fehlt)";
          $action="none";
          $checked="";
        }
        else if($fields['lieferantennummer']!="" && $fields['nummer']!="")
        {
          $nummer = trim($fields['nummer']);
          $action_anzeige = "Update (Artikelnr. gefunden)";
          $action="update";
        }
        else if($fields['lieferantennummer']!="" && $fields['herstellernummer']!="")
        {
          $nummer = $this->app->DB->Select("SELECT nummer FROM artikel WHERE herstellernummer='".$this->app->DB->real_escape_string($fields['herstellernummer'])."' LIMIT 1");
          $action_anzeige = "Update (Herstellernr. gefunden)";
          $action="update";
        } 
        else if($fields['lieferantennummer']!="" && $fields['bestellnummer']!="")
        {
          $artikelid = $this->app->DB->Select("SELECT artikel FROM einkaufspreise WHERE bestellnummer='".$this->app->DB->real_escape_string($fields['bestellnummer'])."'
              AND adresse='".$lieferantid."' LIMIT 1");
          $nummer = $this->app->DB->Select("SELECT nummer FROM artikel WHERE id='".$artikelid."' LIMIT 1");
          $action_anzeige = "Update (Bestellnr. gefunden)";
          $action="update";
        } 


        else {
          $action_anzeige = "Keine (Artikel- oder Herstellernr. fehlt)";
          $action="none";
          $checked="";
        }
        break;
      case "adresse":
        if($fields['kundennummer']=="" && $fields['lieferantennummer']=="" && $fields['name']=="" && $fields['firma']=="" )
        {
          $action_anzeige = "Keine (Kd.- und Lieferanten-Nr. name und firma fehlt)";
          $action="none";
          $checked="";
        }
        else if($fields['kundennummer']=="" && ($fields['name']!="" || $fields['firma']!="") && $fields['lieferantennummer']=="")
        {
          $action_anzeige = "Neu (Adresse neu anlegen)";
          $action="create";
          $checked="checked";
        }
        else if($fields['lieferantennummer']!="" || $fields['kundennummer']!="")
        {
          $checkkunde = $this->app->DB->Select("SELECT id FROM adresse WHERE kundennummer='".$this->app->DB->real_escape_string($fields['kundennummer'])."' AND kundennummer!='' LIMIT 1");
          if($checkkunde <= 0)
          {
            $action_anzeige = "Neu (Adresse neu anlegen)";
            $action="create";
            $checked="checked";
          } else {
            $action_anzeige = "Update (Kundennummer gefunden)";
            $action="update";
            $checked="checked";
          }

          if($checkkunde <= 0) {
            $checklieferant = $this->app->DB->Select("SELECT id FROM adresse WHERE lieferantennummer='".$this->app->DB->real_escape_string($fields['lieferantennummer'])."' AND lieferantennummer!='' LIMIT 1");
            if($checklieferant <= 0)
            {
              $action_anzeige = "Neu (Adresse neu anlegen)";
              $action="create";
              $checked="checked";
            } else {
              $action_anzeige = "Update (Lieferantennummer gefunden)";
              $action="update";
              $checked="checked";
            }
          }
        }

        break;

      case "artikel":
        if($fields['nummer']=="" && $fields['name_de']=="")
        {
          $action_anzeige = "Keine (Artikel Nr. und name_de fehlt)";
          $action="none";
          $checked="";
        }
        else if($fields['nummer']=="" && $fields['name_de']!="")
        {
          $action_anzeige = "Neu (Artikel neu anlegen)";
          $action="create";
          $checked="checked";
        }
        else if($fields['nummer']!="")
        {
          $action_anzeige = "Update (Artikel update)";
          $action="update";
          $checked="checked";
        }
        break;
      case "zeiterfassung":
      case "wiedervorlagen":
      case "notizen":
        $checked = "checked";
        if($fields['kundennummer']!="")
          $nummer = $this->app->DB->Select("SELECT kundennummer FROM adresse WHERE kundennummer='".$fields['kundennummer']."' LIMIT 1");
        else $nummer="";
        if($nummer=="")
        {
          $action_anzeige = "Keine (Kundennummer fehlt)";
          $action="none";
          $checked="";
        } else {
          $action="create";
        }
        break;
    }

    $this->app->Tpl->Add('ERGEBNIS','<tr><td width="100"><input type="hidden" name="row[cmd]['.$rowcounter.']" value="'.$action.'">
        </td><td nowrap>'.$action_anzeige.'</td>
        <td>'.$nummer.'<input type="hidden" name="'.$row['nummer'][$rowcounter].'" value="'.$nummer.'"></td>'.$output);
    $this->app->Tpl->Add('ERGEBNIS','</tr>');
  }

  function UstBefreitErkennung($ust_befreit)
  {
    $ust_befreit = strtolower($ust_befreit);
    switch($ust_befreit)
    {
      case "inland": $result=0; break;
      case "eu-lieferung": $result=1; break;
      case "export": $result=2; break;
      case "steuerfrei_inland": $result=3; break;
      default: $result=0;
    }
    return $result;
  }

  function TypErkennung($typ)
  {
    $typ = strtolower($typ);
    switch($typ)
    {
      case "mr": $typ="herr"; break;
      case "mr.": $typ="herr"; break;
      case "ms": $typ="frau"; break;
      case "ms.": $typ="frau"; break;
      case "mrs": $typ="frau"; break;
      case "mrs.": $typ="frau"; break;
      case "company": $typ="firma"; break;
    }
    return $typ;
  }
}
?>
