<?php
/*
**** COPYRIGHT & LICENSE NOTICE *** DO NOT REMOVE ****
* 
* WaWision (c) embedded projects GmbH, Holzbachstrasse 4, D-86154 Augsburg, * Germany 2015 
*
* This file is licensed under the Embedded Projects General Public License *Version 3.1. 
*
* You should have received a copy of this license from your vendor and/or *along with this file; If not, please visit www.wawision.de/Lizenzhinweis 
* to obtain the text of the corresponding license version.  
*
**** END OF COPYRIGHT & LICENSE NOTICE *** DO NOT REMOVE ****
*/
?>
<?php
include ("_gen/shopexport.php");

class Onlineshops extends GenShopexport {
  var $app;

  function __construct(&$app) {
    //parent::GenShopexport($app);
    $this->app=&$app;

    $this->app->ActionHandlerInit($this);

    $this->app->ActionHandler("create","ShopexportCreate");
    $this->app->ActionHandler("edit","ShopexportEdit");
    $this->app->ActionHandler("list","ShopexportList");
    $this->app->ActionHandler("delete","ShopexportDelete");
    $this->app->ActionHandler("zahlweisedelete","ShopexportZahlweisedelete");
    $this->app->ActionHandler("versandartdelete","ShopexportVersandartdelete");
    $this->app->ActionHandler("freifelddelete","ShopexportFreifelddelete");
    $this->app->ActionHandler("subshopdelete","ShopexportSubshopdelete");
    $this->app->ActionHandler("zahlweiseget","ShopexportZahlweiseget");
    $this->app->ActionHandler("zahlweisesave","ShopexportZahlweisesave");
    $this->app->ActionHandler("zahlweiseeditsave","ShopexportZahlweiseeditsave");
    $this->app->ActionHandler("freifeldersave","ShopexportFreifeldsave");
    $this->app->ActionHandler("subshopsave","ShopexportSubshopsave");

    $this->app->ActionHandler("versandartget","ShopexportVersandartget");
    $this->app->ActionHandler("freifeldget","ShopexportFreifeldget");
    $this->app->ActionHandler("subshopget","ShopexportSubshopget");
    $this->app->ActionHandler("versandartsave","ShopexportVersandartsave");
    $this->app->ActionHandler("versandarteditsave","ShopexportVersandarteditsave");
    $this->app->ActionHandler("freifeldereditsave","ShopexportFreifeldereditsave");
    $this->app->ActionHandler("subshopeditsave","ShopexportSubshopeditsave");


    $this->app->Tpl->Set('KURZUEBERSCHRIFT',"Shopexport");
    $this->app->ActionHandlerListen($app);
  }

  function ShopexportZahlweisesave()
  {
    $id = (int)$this->app->Secure->GetGET('id');

    $shop = (int)$this->app->Secure->GetPOST('shop');
    $zahlweise_shop = $this->app->Secure->GetPOST('zahlweise_shop');
    $zahlweise_wawision = $this->app->Secure->GetPOST('zahlweise_wawision');
    $vorabbezahltmarkieren = $this->app->Secure->GetPOST('vorabbezahltmarkieren');
    $autoversand = $this->app->Secure->GetPOST('autoversand');

    if($vorabbezahltmarkieren!="1") $vorabbezahltmarkieren=0;
    if($autoversand!="1") $autoversand=0;

    $aktiv = 1;

    if ($shop) {
      $this->app->DB->Insert("INSERT INTO shopexport_zahlweisen (id,shop,zahlweise_shop,zahlweise_wawision,vorabbezahltmarkieren,aktiv,autoversand) VALUES
          ('','$shop','$zahlweise_shop','$zahlweise_wawision','$vorabbezahltmarkieren','$aktiv','$autoversand')");
    }

    echo json_encode(array(
          'status' => 1,
          'statusText' => 'Gespeichert.'
          ));
    exit;

  }


  function ShopexportSubshopsave()
  {
    $id = (int)$this->app->Secure->GetPOST('id');
    $shop = (int)$this->app->Secure->GetPOST('shop');
    $subshopkennung = $this->app->Secure->GetPOST('subshopkennung');
    $projekt = $this->app->Secure->GetPOST('projekt');
    $aktiv = 1;

    $projekt = $this->app->DB->Select("SELECT id FROM projekt WHERE abkuerzung='$projekt' AND abkuerzung!='' LIMIT 1");

    if ($shop && $subshopkennung && $projekt) {
      $this->app->DB->Insert("INSERT INTO shopexport_subshop (id,shop,subshopkennung,projekt,aktiv) VALUES
          ('','$shop','$subshopkennung','$projekt','$aktiv')");

      echo json_encode(array(
            'status' => 1,
            'statusText' => 'Gespeichert.'
            ));        
    }else{
      echo json_encode(array(
            'status' => 0,
            'statusText' => 'Bitte alle Felder eingeben'
            ));

    }


    exit;
  }

  function ShopexportFreifeldsave()
  {
    $id = (int)$this->app->Secure->GetPOST('id');
    $shop = (int)$this->app->Secure->GetPOST('shop');
    $freifeld_shop = $this->app->Secure->GetPOST('freifeld_shop');
    $freifeld_wawi = $this->app->Secure->GetPOST('freifeld_wawi');
    $aktiv = 1;

    if ($shop && $freifeld_shop) {
      $this->app->DB->Insert("INSERT INTO shopexport_freifelder (id,shop,freifeld_shop,freifeld_wawi,aktiv) VALUES
          ('','$shop','$freifeld_shop','$freifeld_wawi','$aktiv')");

      echo json_encode(array(
            'status' => 1,
            'statusText' => 'Gespeichert.'
            ));        
    }else{
      echo json_encode(array(
            'status' => 0,
            'statusText' => 'Bitte Freifeld eingeben'
            ));

    }


    exit;
  }

  function ShopexportZahlweiseeditsave()
  {
    $id = (int)$this->app->Secure->GetPOST('id');
    $zahlweise_shop = $this->app->Secure->GetPOST('zahlweise_shop');
    $zahlweise_wawision = $this->app->Secure->GetPOST('zahlweise_wawision');
    $vorabbezahltmarkieren = $this->app->Secure->GetPOST('vorabbezahltmarkieren');
    $autoversand = $this->app->Secure->GetPOST('autoversand');
    $aktiv = $this->app->Secure->GetPOST('aktiv');


    if($vorabbezahltmarkieren!="1") $vorabbezahltmarkieren=0;
    if($autoversand!="1") $autoversand=0;
    if($aktiv!="1") $aktiv=0;

    if ($id) {
      $this->app->DB->Update("UPDATE shopexport_zahlweisen SET zahlweise_shop='$zahlweise_shop',zahlweise_wawision='$zahlweise_wawision',vorabbezahltmarkieren='$vorabbezahltmarkieren',autoversand='$autoversand',aktiv='$aktiv' WHERE id = '$id'");
    }

    echo json_encode(array(
          'status' => 1,
          'statusText' => 'Gespeichert.'
          ));
    exit;

  }


  function ShopexportZahlweiseget() {
    $id = $this->app->Secure->GetPOST('id');
    $row = $this->app->DB->SelectArr('
        SELECT
        id,
        zahlweise_shop,
        zahlweise_wawision,
        vorabbezahltmarkieren,
        autoversand,
        aktiv
        FROM
        shopexport_zahlweisen
        WHERE
        id = "' . $id . '"
        ');
    if ($row) {
      $row = reset($row);
    }
    echo json_encode($row);
    exit;
  }

  function ShopexportZahlweisedelete()
  {
    $id = (int)$this->app->Secure->GetGET("id");
    $sid = $this->app->DB->Select("SELECT shop FROM shopexport_zahlweisen WHERE id='$id' LIMIT 1");                      

    if($id > 0)
    {
      $this->app->DB->Delete("DELETE FROM shopexport_zahlweisen WHERE id='$id' LIMIT 1");
      $msg = $this->app->erp->base64_url_encode("<div class=\"info\">Der Eintrag wurde entfernt!</div>  ");
      header("Location: index.php?module=onlineshops&action=edit&id=$sid&msg=$msg#tabs-2"); 
      exit;
    }
  }


  function ShopexportVersandartsave()
  {
    $id = (int)$this->app->Secure->GetGET('id');
    $shop = (int)$this->app->Secure->GetPOST('shop');
    $versandart_shop = $this->app->Secure->GetPOST('versandart_shop');
    $versandart_wawision = $this->app->Secure->GetPOST('versandart_wawision');
    $land = $this->app->Secure->GetPOST('land');
    $autoversand = $this->app->Secure->GetPOST('autoversand');

    if($autoversand!="1") $autoversand=0;

    $aktiv = 1;

    if ($shop) {
      $this->app->DB->Update("INSERT INTO shopexport_versandarten (id,shop,versandart_shop,versandart_wawision,aktiv,autoversand,land) VALUES
          ('','$shop','$versandart_shop','$versandart_wawision','$aktiv','$autoversand','$land')");
    }

    echo json_encode(array(
          'status' => 1,
          'statusText' => 'Gespeichert.'
          ));
    exit;

  }


  function ShopexportVersandarteditsave()
  {
    $id = (int)$this->app->Secure->GetPOST('id');
    $versandart_shop = $this->app->Secure->GetPOST('versandart_shop');
    $versandart_wawision = $this->app->Secure->GetPOST('versandart_wawision');
    $autoversand = $this->app->Secure->GetPOST('autoversand');
    $land = $this->app->Secure->GetPOST('land');
    $aktiv = $this->app->Secure->GetPOST('aktiv');


    if ($provision > $this->maxProvision) {
      echo json_encode(array(
            'status' => 0,
            'statusText' => 'Maximal ' . $this->maxProvision . '% möglich.'
            ));
      exit;
    }

    if($vorabbezahltmarkieren!="1") $vorabbezahltmarkieren=0;
    if($aktiv!="1") $aktiv=0;

    if ($id) {
      $this->app->DB->Update("UPDATE shopexport_versandarten SET versandart_shop='$versandart_shop',versandart_wawision='$versandart_wawision',autoversand='$autoversand',land='$land',
          aktiv='$aktiv' WHERE id = '$id'");
    }

    echo json_encode(array(
          'status' => 1,
          'statusText' => 'Gespeichert.'
          ));
    exit;

  }

  function ShopexportSubshopeditsave()
  {
    $id = (int)$this->app->Secure->GetPOST('id');
    $subshopkennung = $this->app->Secure->GetPOST('subshopkennung');
    $projekt = $this->app->Secure->GetPOST('projekt');
    $aktiv = $this->app->Secure->GetPOST('aktiv');
    $sprache = $this->app->Secure->GetPOST('sprache');

    if($aktiv!="1") $aktiv=0;

    $projekt = $this->app->DB->Select("SELECT id FROM projekt WHERE abkuerzung='$projekt' AND abkuerzung!='' LIMIT 1");

    if ($id && $projekt > 0) {
      $this->app->DB->Update("UPDATE shopexport_subshop SET subshopkennung='$subshopkennung',projekt='$projekt',sprache = '$sprache',
          aktiv='$aktiv' WHERE id = '$id'");
      echo json_encode(array(
            'status' => 1,
            'statusText' => 'Gespeichert.'
            ));
    } else {
      echo json_encode(array(
            'status' => 0,
            'statusText' => 'Projekt nicht vorhanden'
            ));
    }

    exit;

  }


  function ShopexportFreifeldereditsave()
  {
    $id = (int)$this->app->Secure->GetPOST('id');
    $freifeld_shop = $this->app->Secure->GetPOST('freifeld_shop');
    $freifeld_wawi = $this->app->Secure->GetPOST('freifeld_wawi');
    $aktiv = $this->app->Secure->GetPOST('aktiv');

    if($aktiv!="1") $aktiv=0;

    if ($id) {
      $this->app->DB->Update("UPDATE shopexport_freifelder SET freifeld_wawi='$freifeld_wawi',freifeld_shop='$freifeld_shop',
          aktiv='$aktiv' WHERE id = '$id'");
    }

    echo json_encode(array(
          'status' => 1,
          'statusText' => 'Gespeichert.'
          ));
    exit;

  }

  function ShopexportVersandartget() {
    $id = $this->app->Secure->GetPOST('id');
    $row = $this->app->DB->SelectArr('
        SELECT
        id,
        versandart_shop,
        versandart_wawision,
        autoversand,
        land,
        aktiv
        FROM
        shopexport_versandarten
        WHERE
        id = "' . $id . '"
        ');
    if ($row) {
      $row = reset($row);
    }
    echo json_encode($row);
    exit;
  }


  function ShopexportSubshopget()
  {
    $id = $this->app->Secure->GetPOST('id');
    $row = $this->app->DB->SelectArr('
        SELECT
        s.id,
        s.subshopkennung,
        p.abkuerzung as projekt,
        s.sprache,
        s.aktiv
        FROM
        shopexport_subshop s LEFT JOIN projekt p ON p.id=s.projekt
        WHERE
        s.id = "' . $id . '"
        ');
    if ($row) {
      $row = reset($row);
    }
    echo json_encode($row);
    exit;
  }


  function ShopexportFreifeldget()
  {
    $id = $this->app->Secure->GetPOST('id');
    $row = $this->app->DB->SelectArr('
        SELECT
        id,
        freifeld_shop,
        freifeld_wawi,
        aktiv
        FROM
        shopexport_freifelder
        WHERE
        id = "' . $id . '"
        ');
    if ($row) {
      $row = reset($row);
    }
    echo json_encode($row);
    exit;
  }


  function ShopexportVersandartdelete()
  {
    $id = (int)$this->app->Secure->GetGET("id");
    $sid = $this->app->DB->Select("SELECT shop FROM shopexport_versandarten WHERE id='$id' LIMIT 1");                      
    if($id > 0)
    {
      $this->app->DB->Delete("DELETE FROM shopexport_versandarten WHERE id='$id' LIMIT 1");

      $msg = $this->app->erp->base64_url_encode("<div class=\"info\">Der Eintrag wurde entfernt!</div>  ");
      header("Location: index.php?module=onlineshops&action=edit&id=$sid&msg=$msg#tabs-3"); 
      exit;
    }
  }


  function ShopexportSubshopdelete()
  {
    $id = (int)$this->app->Secure->GetGET("id");
    $sid = $this->app->DB->Select("SELECT shop FROM shopexport_subshop WHERE id='$id' LIMIT 1");                      
    if($id > 0)
    {
      $this->app->DB->Delete("DELETE FROM shopexport_subshop WHERE id='$id' LIMIT 1");

      $msg = $this->app->erp->base64_url_encode("<div class=\"info\">Der Eintrag wurde entfernt!</div>  ");
      header("Location: index.php?module=onlineshops&action=edit&id=$sid&msg=$msg#tabs-5"); 
      exit;
    }
  }

  function ShopexportFreifelddelete()
  {
    $id = (int)$this->app->Secure->GetGET("id");
    $sid = $this->app->DB->Select("SELECT shop FROM shopexport_freifelder WHERE id='$id' LIMIT 1");                      
    if($id > 0)
    {
      $this->app->DB->Delete("DELETE FROM shopexport_freifelder WHERE id='$id' LIMIT 1");

      $msg = $this->app->erp->base64_url_encode("<div class=\"info\">Der Eintrag wurde entfernt!</div>  ");
      header("Location: index.php?module=onlineshops&action=edit&id=$sid&msg=$msg#tabs-4"); 
      exit;
    }
  }

  function ShopexportCreate()
  {
    $this->ShopexportMenu();
    parent::ShopexportCreate();
  }

  function ShopexportList()
  {
    $this->ShopexportMenu();
    parent::ShopexportList();
  }

  function ShopexportMenu()
  {
    $id = $this->app->Secure->GetGET("id");
    $this->app->erp->MenuEintrag("index.php?module=onlineshops&action=create","Neu");
    if($this->app->Secure->GetGET("action")=="list")
    {
      $this->app->erp->MenuEintrag("index.php?module=onlineshops&action=list","&Uuml;bersicht");  
    }

    if($id > 0)
    {
      $name = $this->app->DB->Select("SELECT bezeichnung FROM shopexport WHERE id='$id' LIMIT 1");
      $this->app->Tpl->Add('KURZUEBERSCHRIFT2',$name);
      $this->app->erp->MenuEintrag("index.php?module=onlineshops&action=edit&id=$id","Einstellungen");
      $this->app->erp->MenuEintrag("index.php?module=shopexport&action=export&id=$id","Export");
      $this->app->erp->MenuEintrag("index.php?module=shopexport&action=artikeluebertragung&id=$id","Artikel &Uuml;bertragung");
    }


    $typ = $this->app->DB->Select("SELECT typ FROM shopexport WHERE id='$id' LIMIT 1");
    if($typ=="wawision")
    {
      $this->app->erp->MenuEintrag("index.php?module=shopexport&action=navigationtab&id=$id","Navigation");
      $this->app->erp->MenuEintrag("index.php?module=shopexport&action=artikelgruppen&id=$id","Artikelgruppen");
      $this->app->erp->MenuEintrag("index.php?module=shopexport&action=dateien&id=$id","Dateien");
      $this->app->erp->MenuEintrag("index.php?module=shopexport&action=live&id=$id","Live-Status");
      $this->app->erp->MenuEintrag("index.php?module=inhalt&action=listshop&id=$id","Inhalte / E-Mailvorlagen");
    }

    if($this->app->Secure->GetGET("action")=="list")
      $this->app->erp->MenuEintrag("index.php?module=einstellungen&action=list","Zur&uuml;ck zur &Uuml;bersicht");
    else
      $this->app->erp->MenuEintrag("index.php?module=onlineshops&action=list","Zur&uuml;ck zur &Uuml;bersicht");
  }

  function ShopexportDelete() 
  {
    $id = $this->app->Secure->GetGET('id');
    if(is_numeric($id)) {
      $this->app->DB->Delete("DELETE FROM shopexport WHERE id='$id' LIMIT 1");
    }
    header('Location: ./index.php?module=onlineshops&action=list');
    exit;
  }


  function ShopexportEdit()
  {
    $id = (int)$this->app->Secure->GetGET('id');
    $this->app->YUI->TableSearch('TAB2',"shopexport_zahlweisen");
    $this->app->YUI->TableSearch('TAB3',"shopexport_versandarten");
    $this->app->YUI->TableSearch('TAB4',"shopexport_freifelder");
    $this->app->YUI->TableSearch('TAB5',"shopexport_subshop");
    $this->app->YUI->AutoComplete('b_projekt',"projektname",1);
    
    $this->app->Tpl->Add('FREIFELDEROPTIONEN','<option value=""></option>');
    for($i = 1; $i <= 20; $i++)
    {
      $freifeldname = $this->app->erp->Firmendaten('freifeld'.$i);
      if(!$freifeldname)$freifeldname = 'Freifeld '.$i;
      $this->app->Tpl->Add('FREIFELDEROPTIONEN','<option value="freifeld'.$i.'">'.$freifeldname.'</option>');  
    }



    $this->app->Tpl->Set('FORMULAR','<div id="editZahlweisen" style="display:none;" title="Bearbeiten">
        <input type="hidden" id="b_id">
        <table>
        <tr>
        <td>Zahlweise Shop:</td>
        <td><input type="text" id="b_zahlweise_shop"></td>
        </tr>

        <tr>
        <td>Zahlweise WaWision:</td>
        <td><input type="text" id="b_zahlweise_wawision"></td>
        </tr>
        <tr>
        <td>Vorab als bezahlt markieren:</td>
        <td><input type="checkbox" value="1" id="b_vorabbezahltmarkieren"></td>
        </tr>
        <tr>
        <td>Autoversand aktiv:</td>
        <td><input type="checkbox" checked="checked" value="1" id="b_autoversand"></td>
        </tr>
        <tr>
        <td>Aktiv:</td>
        <td><input type="checkbox" value="1" id="b_aktiv"></td>
        </tr>
        </table>
        </div>');

    $this->app->Tpl->Add('FORMULAR','<div id="editVersandarten" style="display:none;" title="Bearbeiten">
        <input type="hidden" id="b_id2">
        <table>
        <tr>
        <td>Versandart Shop:</td>
        <td><input type="text" id="b_versandart_shop"></td>
        </tr>

        <tr>
        <td>Versandart WaWision:</td>
        <td><input type="text" id="b_versandart_wawision"></td>
        </tr>
        <tr>
        <td>Land (mit Komma getrennt 2-sellig ISO):</td>
        <td><input type="text" id="b_land"></td>
        </tr>
        <tr>
        <td>Autoversand aktiv:</td>
        <td><input type="checkbox" checked="checked" value="1" id="b_autoversand2"></td>
        </tr>
        <tr>
            <td>Aktiv:</td>
                           <td><input type="checkbox" value="1" id="b_aktiv2"></td>
                                                     </tr>
                                                     </table>
                                                     </div>');
    $this->app->Tpl->Add('FORMULAR','<div id="editFreifelder" style="display:none;" title="Bearbeiten">
        <input type="hidden" id="b_id3">
        <table>
        <tr>
        <td>Freifeld WaWision:</td>
        <td><select id="b_freifeld_wawi">
        [FREIFELDEROPTIONEN]
        </select></td>
        </tr>

        <tr>
        <td>Bezeichnung in Shop:</td>
        <td><input type="text" id="b_freifeld_shop"></td>
        </tr>
        <tr>
        <td>Aktiv:</td>
        <td><input type="checkbox" value="1" id="b_aktiv3"></td>
        </tr>
        </table>
        </div>');


      $this->app->Tpl->Add('FORMULAR','<div id="editSubshop" style="display:none;" title="Bearbeiten">
        <input type="hidden" id="b_id4">
        <table>
        <tr>
        <td>Subshop Kennung:</td>
        <td><input type="text" id="b_subshopkennung"></td>
        </tr>

        <tr>
        <td>Projekt WaWision:</td>
        <td><input type="text" id="b_projekt"></td>
        </tr>
        <tr>
        <td>Sprache:</td>
        <td><select id="b_sprache"><option value=""></option><option value="deutsch">Deutsch</option><option value="englisch">Englisch</option></select></td>
        </tr>
        <tr>
            <td>Aktiv:</td>
                           <td><input type="checkbox" value="1" id="b_aktiv4"></td>
                                                     </tr>
                                                     </table>
                                                     </div>');

    $this->app->Tpl->Set('NEUTAB2','
        <fieldset>
        <legend>Anlegen</legend>
        <form action="" onsubmit="return zahlweiseSave(this);">
        <input type="hidden" name="shop" id="shop" value="'.$id.'">
        <table width="" cellspacing="0" cellpadding="0">
        <tr>
        <td>Zahlweise Shop:&nbsp;</td>
        <td><input type="text" name="zahlweise_shop" id="zahlweise_shop"></td>
        <td>&nbsp;</td>
        <td>Zahlweise WaWision:&nbsp;</td>
        <td><input type="text" name="zahlweise_wawision" id="zahlweise_wawision"></td>
        <td>&nbsp;</td>
        <td>Vorab als bezahlt markieren:&nbsp;</td>
        <td><input type="checkbox" value="1" name="vorabbezahltmarkieren" id="vorabbezahltmarkieren"></td>
        <td>&nbsp;</td>
        <td>Autoversand aktiv:&nbsp;</td>
        <td><input type="checkbox" value="1" checked="checked" name="autoversand" id="autoversand">&nbsp;<i>(Haken muss Standardmässig aktiviert sein)</i></td>
        <td>&nbsp;</td>
        <td><input type="submit" name="" value="Speichern"></td>
        </tr>
        </table>
        </form>
        </fieldset>');


    $this->app->Tpl->Set('NEUTAB3','
        <fieldset>
        <legend>Anlegen</legend>
        <form action="" onsubmit="return versandartSave(this);">
        <input type="hidden" name="shop" id="shop" value="'.$id.'">
        <table width="" cellspacing="0" cellpadding="0">
        <tr>
        <td width="105">Versandart Shop:&nbsp;</td>
        <td width="180"><input type="text" name="versandart_shop" id="versandart_shop"></td>
        <td>&nbsp;</td>
        <td width="130">Versandart WaWision:&nbsp;</td>
        <td width="180"><input type="text" name="versandart_wawision" id="versandart_wawision"></td>
        <td>&nbsp;</td>
        <td width="230">Land (2-stellig ISO mit Komma getrennt):&nbsp;</td>
        <td width="60"><input type="text" name="land" id="land" size="3"></td>
        <td>&nbsp;</td>
        <td width="110">Autoversand aktiv:&nbsp;</td>
        <td width="300"><input type="checkbox" value="1" checked="checked" name="autoversand" id="autoversand">&nbsp;<i>(Haken muss Standardmässig aktiviert sein)</i></td>
        <td>&nbsp;</td>
        <td><input type="submit" name="" value="Speichern"></td>
        </tr>
        </table>
        </form>
        </fieldset>');

    $this->app->Tpl->Set('NEUTAB4','
        <fieldset>
        <legend>Anlegen</legend>
        <form action="" onsubmit="return freifelderSave(this);">
        <input type="hidden" name="shop" id="shop" value="'.$id.'">
        <table width="" cellspacing="0" cellpadding="0">
        <tr>
        <td>Freifeld WaWision:&nbsp;</td>
        <td><select name="freifeld_wawi" id="freifeld_wawi">[FREIFELDEROPTIONEN]</select></td>
        <td>&nbsp;</td>
        <td>Bezeichnung in Shop:&nbsp;</td>
        <td><input type="text" name="freifeld_shop" id="freifeld_shop"></td>
        <td>&nbsp;</td>
        <td><input type="submit" name="" value="Speichern"></td>
        </tr>
        </table>
        </form>
        </fieldset>');




    $this->app->Tpl->Set('NEUTAB5','
        <fieldset>
        <legend>Anlegen</legend>
        <form action="" onsubmit="return subshopSave(this);">
        <input type="hidden" name="shop" id="shop" value="'.$id.'">
        <table width="" cellspacing="0" cellpadding="0">
        <tr>
        <td>Subshop Kennung:&nbsp;</td>
        <td><input type="text" name="subshopkennung" id="subshopkennung"></td>
        <td>&nbsp;</td>
        <td>Sprache:&nbsp;</td>
        <td><select name="sprache" id="sprache"><option value=""></option><option value="deutsch">Deutsch</option><option value="englisch">Englisch</option></select></td>
        <td>&nbsp;</td>
        <td>Projekt WaWision:&nbsp;</td>
        <td><input type="text" name="projekt" id="projekt"></td>
        <td>&nbsp;</td>
        <td><input type="submit" name="" value="Speichern"></td>
        </tr>
        </table>
        </form>
        </fieldset>');



    $this->ShopexportMenu();
    parent::ShopexportEdit();
  }





}
?>
