<?php
/*
**** COPYRIGHT & LICENSE NOTICE *** DO NOT REMOVE ****
* 
* WaWision (c) embedded projects GmbH, Holzbachstrasse 4, D-86154 Augsburg, * Germany 2015 
*
* This file is licensed under the Embedded Projects General Public License *Version 3.1. 
*
* You should have received a copy of this license from your vendor and/or *along with this file; If not, please visit www.wawision.de/Lizenzhinweis 
* to obtain the text of the corresponding license version.  
*
**** END OF COPYRIGHT & LICENSE NOTICE *** DO NOT REMOVE ****
*/
?>
<?php
include ("_gen/projekt.php");

class Projekt extends GenProjekt {
  var $app;
  var $ebene=0;
  var $voraengerbaum;
  var $projektwaehrung="";
  
  static function TableSearch(&$app, $name, $erlaubtevars)
  {
    switch($name)
    {
      case "projekt_mitarbeiterstundengeplant":
        $allowed['projekt'] = array('dashboard');
        $heading = array('Mitarbeiternummer','Mitarbeiter','Bezeichnung','Stunden','Stundenlohn','');
        $width = array('20%','25%','20%','15%','14%','1%');
        $findcols = array( 'a.mitarbeiternummer','a.name','tgz.bezeichnung','tgz.stunden','tgz.stundensatz', 'a.id');
        $searchsql = array('a.mitarbeiternummer','a.name','tgz.bezeichnung','tgz.stunden','tgz.stundensatz', 'a.id');
        
        $defaultorder = 1; //Optional wenn andere Reihenfolge gewuenscht

        $defaultorderdesc = 1;

        $teilprojekt = (int)$app->User->GetParameter("teilprojekt_geplante_zeiten_teilprojekt");
        $id = (int)$app->Secure->GetGET('id');
        $sql = "SELECT SQL_CALC_FOUND_ROWS a.id,a.mitarbeiternummer, a.name as name,
            concat('<input onchange=\"changestundensatzname(',a.id,',$teilprojekt)\" type=\"text\" value=\"',ifnull(tgz.bezeichnung,ifnull((SELECT zk.beschreibung FROM zeiterfassung_kosten zk WHERE zk.adresse = a.id AND (zk.gueltig_ab = '0000-00-00' OR zk.gueltig_ab <= curdate()) ORDER by zk.gueltig_ab DESC LIMIT 1 ),'')),'\" name=\"stundensatzname_',a.id,'\" id=\"stundensatzname_',a.id,'\" />') , 
            concat('<input onchange=\"changestundensatzname(',a.id,',$teilprojekt)\" type=\"text\" value=\"',ifnull(tgz.stunden,0),'\" name=\"stunden_',a.id,'\" id=\"stunden_',a.id,'\" />') , 
            concat('<input onchange=\"changestundensatzname(',a.id,',$teilprojekt)\" type=\"text\" value=\"',ifnull(tgz.stundensatz,ifnull((SELECT zk.stundensatz FROM zeiterfassung_kosten zk WHERE zk.adresse = a.id AND (zk.gueltig_ab = '0000-00-00' OR zk.gueltig_ab <= curdate()) ORDER by zk.gueltig_ab DESC LIMIT 1 ),0)),'\" name=\"stundensatz_',a.id,'\" id=\"stundensatz_',a.id,'\" />')
            , a.id as menu
            FROM adresse a 
            INNER JOIN adresse_rolle a2 ON a2.adresse=a.id 
            INNER JOIN projekt p ON p.id=a2.projekt OR p.id = a.projekt
            LEFT JOIN teilprojekt_geplante_zeiten tgz ON a.id = tgz.adresse AND tgz.teilprojekt = '$teilprojekt'";
        $groupby = " group by a.id";
        $where = " (a2.projekt='$id' AND (a2.bis='0000-00-00' OR a2.bis >= date(NOW())) AND a2.objekt like 'Projekt' AND a.geloescht != 1 AND mitarbeiternummer != '') OR not isnull(tgz.id) ";
        
        $count = "SELECT count(distinct a.id) FROM adresse a 
                                           
                                           INNER JOIN adresse_rolle a2 ON a2.adresse=a.id 
                                           INNER JOIN projekt p ON p.id=a2.projekt OR p.id = a.projekt
                                           LEFT JOIN teilprojekt_geplante_zeiten tgz ON a.id = tgz.adresse AND tgz.teilprojekt = '$teilprojekt'
                                           WHERE $where";
            
      break;
    }
    
    $erg = false;

    foreach($erlaubtevars as $k => $v)
    {
      if(isset($$v))$erg[$v] = $$v;
    }
    return $erg; 
  }
  
  function __construct(&$app, $intern = false) {
    $this->app=&$app;
    if($intern)return;
    $this->app->ActionHandlerInit($this);

    $this->app->ActionHandler("create","ProjektCreate");
    $this->app->ActionHandler("edit","ProjektEdit");
    $this->app->ActionHandler("list","ProjektList");
    $this->app->ActionHandler("pdf","ProjektPDF");
    $this->app->ActionHandler("delete","ProjektDelete");
    $this->app->ActionHandler("dateien","ProjektDateien");
    $this->app->ActionHandler("uebersicht","ProjektUebersicht");
    $this->app->ActionHandler("zeit","ProjektZeit");
    $this->app->ActionHandler("material","ProjektMaterial");
    $this->app->ActionHandler("arbeitsnachweise","ProjektArbeitsnachweise");
    $this->app->ActionHandler("arbeitsnachweispdf","ProjektArbeitsnachweisPDF");
    $this->app->ActionHandler("arbeitspaket","ProjektArbeitspaket");
    $this->app->ActionHandler("arbeitspaketeditpopup","ProjektArbeitspaketEditPopup");
    $this->app->ActionHandler("arbeitspaketdelete","ProjektArbeitspaketDelete");
    $this->app->ActionHandler("arbeitspaketdisable","ProjektArbeitspaketDisable");
    $this->app->ActionHandler("arbeitspaketcopy","ProjektArbeitspaketCopy");
    $this->app->ActionHandler("nextnumber","ProjektNextnumber");
    $this->app->ActionHandler("delnumber","ProjektDelnumber");
    $this->app->ActionHandler("getnextnumber","ProjektGetNextNumber");
    $this->app->ActionHandler("neueaufgabe","ProjektNeueAufgabe");
    $this->app->ActionHandler("artikeledit","ProjektArtikelEdit");
    
    $this->app->ActionHandler("minidetailarbeitspaket","ProjektMiniDetailArbeitspaket");
    
    $this->app->ActionHandler("plan","ProjektPlan");

    $this->app->ActionHandler("kostenstellen","ProjektKostenstellen");
    $this->app->ActionHandler("schaltung","ProjektSchaltung");
    
    $this->app->ActionHandler("mitgliederdelete","ProjektMitgliederDelete");
    $this->app->ActionHandler("copy","ProjektCopy");


    $this->app->ActionHandlerListen($app);
  }
  
  function getStueckliste(&$ret, $artikel, $menge, $lvl = 0)
  {
    if($lvl > 6)return;
    $parent = -1;
    if(!empty($ret))$parent = count($ret)-1;
    $stueckliste = $this->app->DB->SelectArr("SELECT id, menge, artikel,stuecklistevonartikel FROM  stueckliste WHERE stuecklistevonartikel = '$artikel'");
    if($stueckliste)
    {
      foreach($stueckliste as $art)
      {
        $art['menge'] = $art['menge'] * $menge;
        $art['parent'] = -1;
        if(is_array($ret))$art['parent'] = $parent;
        
        $ret[] = $art;
        $res = $this->getStueckliste($ret, $art['artikel'], $art['menge'] , $lvl+1);
        if($res)
        {
          foreach($res as $a)
          {
            $a['parent'] = $art['parent']+1;
            $ret[] = $a;
          }
          unset($res);
        }
      }
    }
  }

  function UpdateProjektartikelCache($id, $nurwe = false)
  {
    $artikel = $this->app->DB->Select("SELECT artikel FROM projekt_artikel WHERE id = '$id' LIMIT 1");
    if(!$artikel)
    {
      return false;
    }
    if(!$nurwe)
    {
      $belege = array('PR'=>'produktion','AN'=>'angebot','AB'=>'auftrag','LS'=>'lieferschein','GS'=>'gutschrift','RE'=>'rechnung','PF'=>'preisanfrage'); //WE Wareneingang
      foreach($belege as $cache => $beleg)
      {
        $count = $this->app->DB->Select("SELECT sum(bp.menge) as co FROM $beleg"."_position bp INNER JOIN $beleg b ON bp.$beleg = b.id WHERE bp.teilprojekt > 0 AND bp.artikel = '$artikel' AND b.status!='storniert' AND b.status!='abgelehnt' AND b.status != 'angelegt' AND b.belegnr != ''");
        $this->app->DB->Update("UPDATE projekt_artikel SET cache_".$cache." = '$count' WHERE id = '$id' LIMIT 1");
      }
      $beleg = 'lieferschein';
      $cache = 'WA';
      $count = $this->app->DB->Select("SELECT sum(bp.geliefert) as co FROM $beleg"."_position bp INNER JOIN $beleg b ON bp.$beleg = b.id WHERE bp.teilprojekt > 0 AND bp.artikel = '$artikel' AND b.status!='storniert' AND b.status!='abgelehnt' AND b.status != 'angelegt' AND b.belegnr != ''");
      $this->app->DB->Update("UPDATE projekt_artikel SET cache_".$cache." = '$count',lastcheck = now() WHERE id = '$id' LIMIT 1");
    }
    
    $count = $this->app->DB->SelectArr("SELECT sum(geliefert) as cogeliefert, sum(menge) as comenge FROM bestellung_position WHERE teilprojekt > 0 AND artikel = '$artikel' ");
    if($count)
    {
      $count = reset($count);
      $menge = $count['comenge'];
      $geliefert = $count['cogeliefert'];
      $this->app->DB->Update("UPDATE projekt_artikel SET cache_WE = '$geliefert', cache_BE = '$menge' WHERE id = '$id' LIMIT 1");
    }
  }


  function ProjektNeueAufgabe()
  {
    $id = (int)$this->app->Secure->GetGET('id');

    $aufgabe = $this->app->erp->CreateAufgabe(0,"");
    $this->app->DB->Update("UPDATE aufgabe SET projekt='$id' WHERE id='$aufgabe'");
    header("Location: index.php?module=aufgaben&action=edit&id=$aufgabe");
    exit;
  }

  function ProjektArtikelEdit()
  {
    $id = (int)$this->app->Secure->GetGET('id');
    $artikelid = $this->app->DB->Select("SELECT artikel FROM projekt_artikel WHERE id='$id' LIMIT 1");
    header("Location: index.php?module=artikel&action=edit&id=$artikelid");
    exit;
  }
  
  function ProjektCopy()
  {
    $id = (int)$this->app->Secure->GetGET('id');
    if($id && $this->app->erp->UserProjektRecht($id))
    {
      $newid = $this->app->erp->CopyProjekt($id);
      if($newid)
      {
        $msg = $this->app->erp->base64_url_encode("<div class=\"info\">Das Projekt wurde erfolgreich kopiert.</div>"); 
        header('Location: index.php?module=projekt&action=list&msg='.$msg);
        exit;        
      }
      $msg = $this->app->erp->base64_url_encode("<div class=\"error\">Fehler beim Kopieren des Projekts.</div>"); 
    }else{
      $msg = $this->app->erp->base64_url_encode("<div class=\"error\">Fehlende Projektrechte: Das Projekt wurde nicht kopiert.</div>"); 
    }
    header('Location: index.php?module=projekt&action=list&msg='.$msg);
    exit;
  }
  
  function ProjektMitgliederDelete()
  {
    $id = (int)$this->app->Secure->GetGET('id');
    $projekt = (int)$this->app->DB->Select("SELECT projekt FROM adresse_rolle WHERE id = '$id' LIMIT 1");
    $adresse = (int)$this->app->DB->Select("SELECT adresse FROM adresse_rolle WHERE id = '$id' LIMIT 1");
    if($projekt && $adresse && $this->app->erp->UserProjektRecht($projekt))
    {
      $this->app->DB->Update("UPDATE adresse_rolle SET bis = DATE_SUB(curdate(),INTERVAL 1 DAY) WHERE objekt like 'Projekt' AND id = '$id' LIMIT 1");
    }
    header('Location: index.php?module=projekt&action=mitglieder&id='.$projekt);
    exit;
  }

  function ProjektMitglieder()
  {
    $id = (int)$this->app->Secure->GetGET('id');
    $this->app->Tpl->Set('ID',$id);
    
    if($this->app->Secure->GetGET('cmd') == 'adresse')
    {
      $adresse = $this->app->DB->Select("SELECT adresse FROM adresse_rolle WHERE id = '$id' LIMIT 1");
      header('Location: index.php?module=adresse&action=edit&id='.$adresse);
      exit;
    }
    
    if($this->app->Secure->GetPOST('hinzufuegen'))
    {
      $adresse = explode(' ',$this->app->Secure->GetPOST('adresse'));
      $adresse = (int)$adresse[0];
      $rolle = $this->app->Secure->GetPOST('rolle');
      $rollen = array('Kunde','Mitarbeiter','Mitglied','Projektleiter','Lieferant','Externer Mitarbeiter');
      if($adresse && in_array($rolle, $rollen))
      {
        $check = $this->app->DB->Select("SELECT id FROM adresse_rolle WHERE adresse = '$adresse' AND projekt = '$id' AND objekt like 'Projekt' AND subjekt LIKE '$rolle' LIMIT 1");
        if($check)
        {
          $this->app->DB->Update("UPDATE adresse_rolle SET von = curdate() WHERE id = '$check' AND von > curdate() LIMIT 1");
          $this->app->DB->Update("UPDATE adresse_rolle SET bis = '0000-00-00' WHERE id = '$check' LIMIT 1");
        }else{
          $this->app->DB->Insert("INSERT INTO adresse_rolle (adresse, objekt, subjekt, projekt, praedikat, von, bis, parameter) VALUES ('$adresse','Projekt','$rolle','$id','von',now(),'0000-00-00','$id')");
        }
        $this->app->Tpl->Add('MESSAGE','<div class="info">Rolle '.$rolle.' angelegt</div>');
      }
    }
    
    $this->ProjektMenu();
    $this->app->YUI->AutoComplete('adresse','adresse');
    $this->app->YUI->TableSearch('TAB1',"projekt_mitglieder");

    $this->app->Tpl->Parse('PAGE',"projekt_mitglieder.tpl");
  }


  function ProjektDelnumber()
  {
    $id = $this->app->Secure->GetGET("id");
    $nummer = $this->app->Secure->GetGET("nummer");
    $cmd = $this->app->Secure->GetGET("cmd");
    $projekt = $this->app->DB->SelectArr("SELECT * from projekt where id = '$id' LIMIT 1");
    if($projekt)
    {
      $projekt = reset($projekt);
      if(isset($projekt['next_'.$cmd]))$this->app->DB->Update("UPDATE projekt set ".'next_'.$cmd."='' where id = '$id'");

    }
    header('location: index.php?module=projekt&action=edit&id='.$id.'#tabs-4');
    exit;
  }


  function ProjektNextnumber()
  {
    $id = $this->app->Secure->GetGET("id");
    $nummer = $this->app->Secure->GetGET("nummer");
    $cmd = $this->app->Secure->GetGET("cmd");
    $projekt = $this->app->DB->SelectArr("SELECT * from projekt where id = '$id' LIMIT 1");
    if($projekt)
    {
      $projekt = reset($projekt);
      if(isset($projekt['next_'.$cmd]))$this->app->DB->Update("UPDATE projekt set ".'next_'.$cmd."='".mysqli_real_escape_string($this->app->DB->connection,$nummer)."' where id = '$id'");

    }
    header('location: index.php?module=projekt&action=edit&id='.$id.'#tabs-4');
    exit;
  }

  function ProjektGetNextNumber()
  {
    $id = $this->app->Secure->GetGET("id");
    $projekt = $this->app->DB->SelectArr("SELECT * from projekt where id = '$id' LIMIT 1");
    if($projekt)
    {
      echo json_encode($projekt[0]);
    }
    exit;
  }

  function ProjektArbeitsnachweisPDF()
  {
    $date = $this->app->Secure->GetGET("date");

    $Brief = new ArbeitsnachweisPDF($this->app);
    $Brief->GetArbeitsnachweis($date);
    $Brief->displayDocument();
    exit;

  }

  function ProjektPlan()
  {
    $id = $this->app->Secure->GetGET("id");


    $this->ProjektMenu();

    $startarbeitspaket = 0;

    $baumtiefe = $this->ProjektPlanRekrusiv($id,$startarbeitspaket);

    $arbeitspakete = $this->ProjektPlanArbeitspaketeinReihenfolge($id,$baumtiefe);

    asort($arbeitspakete);

    $beschreibung = $this->app->DB->Select("SELECT beschreibung FROM projekt WHERE id='".$id."'");	

    $this->app->Tpl->Add('TAB1',"<h1>&Uuml;bersicht</h1><br><style>.border {border: 1px solid black;}</style>");

    $this->app->Tpl->Add('TAB1',"<table width=700><tr><td>".nl2br($beschreibung)."</td></tr></table><br>");

    $this->app->Tpl->Add('TAB1',"<h1>Umfang</h1><br>");
    $this->app->Tpl->Add('TAB1',"<table border=0 class=border cellspacing=0 cellpadding=3 width=\"65%\">");

    $pos = 1;

    foreach($arbeitspakete as $key=>$value)
    {
      $aufgabe = $this->app->DB->Select("SELECT aufgabe FROM arbeitspaket WHERE id='".$key."'");	
      $vorgaenger = $this->app->DB->Select("SELECT vorgaenger FROM arbeitspaket WHERE id='".$key."'");	
      $art = $this->app->DB->Select("SELECT art FROM arbeitspaket WHERE id='".$key."'");	

      if($art=="meilenstein")	
        $this->app->Tpl->Add('TAB1',"<tr><td width=20 class=border>$pos</td><td width=300 class=border><b>".$aufgabe."</b></td>");
      else
        $this->app->Tpl->Add('TAB1',"<tr><td width=20 class=border>$pos</td><td width=300 class=border>".$aufgabe."</td>");

      $painted=false;
      for($j=0;$j<$baumtiefe;$j++)
      {
        if($vorgaenger==$this->voraengerbaum[$j] && $painted==false){
          $this->app->Tpl->Add('TAB1',"<td width=20 class=border><b>X</b></td>");
          $painted=true;
        }
        else
          $this->app->Tpl->Add('TAB1',"<td width=20 class=border>&nbsp;</td>");

      }
      $this->app->Tpl->Add('TAB1',"</tr>");
      $pos++;
    }
    $this->app->Tpl->Add('TAB1',"</table><br><br>");


    $this->app->Tpl->Add('TAB1',"<h1>Details</h1><br>");

    $pos = 1;
    foreach($arbeitspakete as $key=>$value)
    {
      $aufgabe = $this->app->DB->Select("SELECT aufgabe FROM arbeitspaket WHERE id='".$key."'");	
      $vorgaenger = $this->app->DB->Select("SELECT vorgaenger FROM arbeitspaket WHERE id='".$key."'");	
      $art = $this->app->DB->Select("SELECT UPPER(art) FROM arbeitspaket WHERE id='".$key."'");	
      $beschreibung = $this->app->DB->Select("SELECT beschreibung FROM arbeitspaket WHERE id='".$key."'");	
      $vorgaenger_aufgabe = $this->app->DB->Select("SELECT aufgabe FROM arbeitspaket WHERE id='".$vorgaenger."'");	
      $abgabe_bis = $this->app->DB->Select("SELECT DATE_FORMAT(abgabedatum,'%d.%m.%Y') FROM arbeitspaket WHERE id='".$key."'");	
      $startdatum = $this->app->DB->Select("SELECT DATE_FORMAT(startdatum,'%d.%m.%Y') FROM arbeitspaket WHERE id='".$key."'");	

      if($abgabe_bis!="00.00.0000" && $abgabe_bis!="")
        $abgabe_bis = "<br>Abgabe bis $abgabe_bis";



      $zeit_geplant = $this->app->DB->Select("SELECT zeit_geplant FROM arbeitspaket WHERE id='".$key."'");	
      $kosten_geplant = $this->app->DB->Select("SELECT kosten_geplant FROM arbeitspaket WHERE id='".$key."'");	

      $gesamt_zeit = $gesamt_zeit + $zeit_geplant;
      $gesamt_kosten = $gesamt_kosten + $kosten_geplant;

      if($zeit_geplant=="0.00") $zeit_geplant="-"; else $zeit_geplant=$zeit_geplant." h";
      if($kosten_geplant=="0.00") $kosten_geplant="-"; else $kosten_geplant = $kosten_geplant." ".$this->projektwaehrung;


      if($art=="MEILENSTEIN")
      {
        $kostentabelle = "Meilenstein (keine Kosten)";
      } else {

        $kostentabelle = "<table border=0 width=200>
          <tr><td>Stunden:</td><td>$zeit_geplant</td></tr>
          <tr><td>oder Fixkosten:</td><td>$kosten_geplant</td></tr>
          </table>";

      }
      $this->app->Tpl->Add('TAB1',"<br><h2>".$pos.". $aufgabe ($art)</h2><br>
          <table border=0 cellpadding=5 width=700 class=border>
          <tr><td><b>Beschreibung:</b></td><td><b>Aufwand:</b></td></tr>
          <tr valign=top><td width=420>".nl2br($beschreibung)."</td><td>
          $kostentabelle

          $abgabe_bis
          </td></tr></table>");
      $pos++;
    }	


    //Material
    $this->app->Tpl->Add('TAB1',"<h1>Material</h1>");

    $material = $this->app->DB->SelectArr("SELECT * FROM arbeitspaket 
        WHERE projekt='$id' AND art='material'");
    for($m=0;$m < count($material);$m++)
    {
      $aufgabe = $material[$m]['aufgabe'];
      $beschreibung = $material[$m]['beschreibung'];
      $kosten_geplant = $material[$m]['kosten_geplant'];
      $this->app->Tpl->Add('TAB1',"
          <table border=0 cellpadding=5 width=700 class=border>
          <tr><td><b>Material:</b>$aufgabe</td><td><b>Kosten:</b></td></tr>
          <tr valign=top><td width=420>".nl2br($beschreibung)."</td><td>
          <table border=0 width=200>
          <tr><td>Komplett:</td><td>$kosten_geplant ".$this->projektwaehrung."</td></tr>
          </table>
          </td></tr></table><br>");

      $gesamt_kosten = $gesamt_kosten + $kosten_geplant;
    }


    $stundensatz = "65";	

    $gesamt = $gesamt_kosten + $gesamt_zeit*$stundensatz;

    $this->app->Tpl->Add('TAB1',"<h1>Kosten</h1>

        <table border=0 cellpadding=5 width=700 class=border>
        <tr><td>Gesamt:</td></tr>
        <tr valign=top><td>
        <table border=0 width=100%>
        <tr><td width=430>Stunden:</td><td>$gesamt_zeit h (&#225; $stundensatz ".$this->projektwaehrung.")</td></tr>
        <tr><td>externe Kosten:</td><td>$gesamt_kosten ".$this->projektwaehrung."</td></tr>
        <tr><td>Gesamt:</td><td><b>$gesamt ".$this->projektwaehrung."</b>&nbsp;(zzgl. gesetzl. MwSt.)</td></tr>
        </table>
        </td></tr></table>
        ");

    $this->app->Tpl->Set('TABTEXT',"Projektplan");
    $this->app->Tpl->Parse('PAGE',"tabview.tpl");

  }



  function ProjektPlanArbeitspaketeinReihenfolge($id,$baumtiefe)
  {
    $arbeitspakete = $this->app->DB->SelectArr("SELECT * FROM arbeitspaket WHERE projekt='$id' AND art!='material'");

    $reihenfolge = array();

    for($i=0;$i<count($arbeitspakete);$i++)
    {
      for($j=0;$j<$baumtiefe;$j++)
      {
        if($arbeitspakete[$i]['vorgaenger']==$this->voraengerbaum[$j]){
          $reihenfolge[$arbeitspakete[$i]['id']]=$j;
          $j=$baumtiefe;
        }
      }
    }
    return $reihenfolge;
  }


  function ProjektPlanRekrusiv($projekt,$id)
  {
    $arbeitspakete = $this->app->DB->SelectArr("SELECT * FROM arbeitspaket 
        WHERE projekt='$projekt' AND vorgaenger='".$id."' AND art!='material'");

    if(count($arbeitspakete) <= 0) return 0;

    for($i=0;$i<count($arbeitspakete);$i++)
    {
      $this->voraengerbaum[]=$arbeitspakete[$i]['vorgaenger'];
      $anzahl++;
      $anzahl = $anzahl + $this->ProjektPlanRekrusiv($projekt,$arbeitspakete[$i]['id']);
    }
    return $anzahl;
  }



  function ProjektPDF()
  {
    $id = $this->app->Secure->GetGET("id");

    //    $belegnr = $this->app->DB->Select("SELECT belegnr FROM angebot WHERE id='$id' LIMIT 1");

    //    if(is_numeric($belegnr) && $belegnr!=0)
    {
      $Brief = new ProjektPDF($this->app);
      $Brief->GetProjekt($id);
      $Brief->displayDocument();
    } //else
    //     $this->app->Tpl->Set(MESSAGE,"<div class=\"error\">Noch nicht freigegebene Angeboten k&ouml;nnen nicht als PDF betrachtet werden.!</div>");

    $this->ProjektList();
  }



  function ProjektDelete()
  {
    $ref = $_SERVER['HTTP_REFERER'];
    $id = $this->app->Secure->GetGET('id');
    if(is_numeric($id)) {
      $this->app->DB->Delete("DELETE FROM projekt WHERE id='$id' LIMIT 1");
      $this->app->DB->Delete("DELETE FROM geschaeftsbrief_vorlagen WHERE projekt='$id'");
    }
    header("Location: $ref");
    exit;
  }

  function getProjektArtikel($id)
  {
    $arbeitspakete = null;
    $this->getProjektBaum($arbeitspakete, 0, $id, '', null, true);
    $artikel = null;
    $ind = $this->getProjektArtikelBaum($artikel, 0, $id, 0);
    $i = 0;
    foreach($arbeitspakete as $paket)
    {
      $i++;
      if($i < count($arbeitspakete))
      {
        $tmp = null;
        $ind = $this->getProjektArtikelBaum($tmp, 0, $id, $paket['id'],'',$ind);
        if($tmp)
        {
          foreach($tmp as $v)$artikel[] = $v;
          unset($tmp);
        }
      }
    }
    return $artikel;
  }
  
  function getProjektArtikelBaum(&$artikel, $parent, $projekt, $teilprojekt, $nr = '', $i = 0)
  {
    $res = $this->app->DB->SelectArr("SELECT pa.*, a.nummer, a.name_de FROM projekt_artikel pa LEFT JOIN artikel a ON pa.artikel = a.id WHERE pa.parent = '$parent' AND pa.projekt = '$projekt' AND pa.teilprojekt = '$teilprojekt' ORDER by pa.sort, a.name_de");
    if($res)
    {
      foreach($res as $k => $v)
      {
        $i++;
        $v['nr_alt'] = $v['nr'];
        if($nr != '')
        {
          $v['nr'] = $nr.'.'.$i;
        }else{
          $v['nr'] = $i;
        }
        $artikel[] = $v;
        $this->getProjektArtikelBaum($artikel, $v['id'], $projekt, $teilprojekt, $v['nr']);
      }
    }
    return $i;
  }
  
  function getProjektBaum(&$projekte, $vorgaenger, $projekt, $nr = '', $liste = null, $onlynummertitel = false)
  {
    if(is_null($liste))
    {
      for($i = 0; $i <= 22; $i++)$liste[] = 0;
    }
    $zeit_summiert = $liste[0];
    $gebucht_summiert = $liste[1];
    $kosten_summiert = $liste[2];
    $abgerechnet_summiert = $liste[3];
    $offen_summiert = $liste[4];
    $gesamt_zeit_ek_geplant = $liste[5];
    $gesamt_zeit_ek_gebucht = $liste[6];
    $gesamt_zeit_ek_offen = $liste[7];
    $gesamt_zeit_vk_geplant = $liste[8];
    $gesamt_zeit_vk_gebucht = $liste[9];
    $gesamt_zeit_vk_offen = $liste[10];
    $gesamt_artikel_ek_geplant = $liste[11];
    $gesamt_artikel_ek_gebucht = $liste[12];
    $gesamt_artikel_ek_offen = $liste[13];
    $gesamt_artikel_vk_geplant = $liste[14];
    $gesamt_artikel_vk_gebucht = $liste[15];
    $gesamt_artikel_vk_offen = $liste[16];
    $gesamt_rohertrag_zeit = $liste[17];
    $gesamt_rohertrag_artikel = $liste[18];
    $gesamt_rohertrag_gesamt = $liste[19];
    $gesamt_rohertrag_zeit_geplant = $liste[20];
    $gesamt_rohertrag_artikel_geplant = $liste[21];
    $gesamt_rohertrag_gesamt_geplant = $liste[22];
    
    $res = $this->app->DB->SelectArr("SELECT * FROM arbeitspaket WHERE geloescht != 1 AND vorgaenger = '$vorgaenger' AND projekt = '$projekt' ORDER by sort, aufgabe");
    if($res)
    {
      $i = 0;
      foreach($res as $k => $v)
      {
        $i++;
        if($nr != '')
        {
          $v['nr'] = $nr.'.'.$i;
        }else{
          $v['nr'] = $i;
        }

        if(!$onlynummertitel)
        {
          if($v['adresse'])
          {
            $v['verantwortlicher'] = $this->app->DB->Select("SELECT name FROM adresse WHERE id = '".$v['adresse']."' LIMIT 1");
          }else{
            $v['verantwortlicher'] = '';
          }
          $zeit_summiert += $v['zeit_geplant'];
          if($v['artikel_geplant']){
            
            $v['nummer'] = $this->app->DB->Select("SELECT nummer FROM artikel WHERE id = '".$v['artikel_geplant']."' LIMIT 1");
            /*$v['BE'] = $this->app->DB->Select("SELECT sum(bp.menge) FROM bestellung b INNER JOIN bestellung_position bp ON b.id = bp.bestellung WHERE bp.artikel = '".$v['artikel_geplant']."' ");
            $v['PR'] = $this->app->DB->Select("SELECT sum(bp.menge) FROM produktion b INNER JOIN produktion_position bp ON b.id = bp.produktion WHERE bp.artikel = '".$v['artikel_geplant']."' ");
            $v['AN'] = $this->app->DB->Select("SELECT sum(bp.menge) FROM angebot b INNER JOIN angebot_position bp ON b.id = bp.angebot WHERE bp.artikel = '".$v['artikel_geplant']."' ");
            $v['AB'] = $this->app->DB->Select("SELECT sum(bp.menge) FROM auftrag b INNER JOIN auftrag_position bp ON b.id = bp.auftrag WHERE bp.artikel = '".$v['artikel_geplant']."' ");
            $v['LS'] = $this->app->DB->Select("SELECT sum(bp.menge) FROM lieferschein b INNER JOIN lieferschein_position bp ON b.id = bp.lieferschein WHERE bp.artikel = '".$v['artikel_geplant']."' ");
            $v['RE'] = $this->app->DB->Select("SELECT sum(bp.menge) FROM rechnung b INNER JOIN rechnung_position bp ON b.id = bp.rechnung WHERE bp.artikel = '".$v['artikel_geplant']."' ");
            $v['GS'] = $this->app->DB->Select("SELECT sum(bp.menge) FROM gutschrift b INNER JOIN gutschrift_position bp ON b.id = bp.gutschrift WHERE bp.artikel = '".$v['artikel_geplant']."' ");*/
            if(!$v['BE'])$v['BE'] = '-';
            if(!$v['PR'])$v['PR'] = '-';
            if(!$v['AN'])$v['AN'] = '-';
            if(!$v['AB'])$v['AB'] = '-';
            if(!$v['LS'])$v['LS'] = '-';
            if(!$v['RE'])$v['RE'] = '-';
            if(!$v['GS'])$v['GS'] = '-';
          }else{
            $v['nummer'] = '-';
            $v['BE'] = '-';
            $v['PR'] = '-';
            $v['AN'] = '-';
            $v['AB'] = '-';
            $v['LS'] = '-';
            $v['RE'] = '-';
            $v['GS'] = '-';
          }
          $v['status'] = strtoupper($v['status']);
          $v['zeit_gebucht'] = ((int)$this->app->DB->Select("SELECT sum( TIME_TO_SEC( TIMEDIFF( bis, von ) )) FROM `zeiterfassung` WHERE arbeitspaket = '".$v['id']."'  "))/3600;
          $v['zeit_abgerechnet'] = ((int)$this->app->DB->Select("SELECT sum( TIME_TO_SEC( TIMEDIFF( bis, von ) )) FROM `zeiterfassung` WHERE arbeitspaket = '".$v['id']."' AND abgerechnet = 1"))/3600;
          //$v['zeit_abgerechnet'] = ((int)$this->app->DB->Select("SELECT sum( TIME_TO_SEC( TIMEDIFF( bis, von ) )) FROM `zeiterfassung` WHERE arbeitspaket = '".$v['id']."' AND abgerechnet = 1"))/3600;
          //$v['zeit_offen'] = ((int)$this->app->DB->Select("SELECT sum( TIME_TO_SEC( TIMEDIFF( bis, von ) )) FROM `zeiterfassung` WHERE arbeitspaket = '".$v['id']."' AND status <> 'abgeschlossen' "))/3600;
          $v['zeit_offen'] = $v['zeit_geplant'] - ((int)$this->app->DB->Select("SELECT sum( TIME_TO_SEC( TIMEDIFF( bis, von ) )) FROM `zeiterfassung` WHERE arbeitspaket = '".$v['id']."'"))/3600;;
          $gebucht_summiert += $v['zeit_gebucht'];
          $abgerechnet_summiert += $v['zeit_abgerechnet'];
          $offen_summiert += $v['zeit_offen'];
          
          $v['zeit_ek_geplant'] = $v['ek_geplant']*($v['kalkulationbasis'] == 'pauschale'?1:$v['zeit_geplant']);
          $v['zeit_ek_gebucht'] = 0;//$v['ek_geplant']*($v['kalkulationbasis'] == 'pauschale'?1:$v['zeit_gebucht']);
          
          if($v['zeit_gebucht'])
          {
            $stundenmitstundensatz = (float)$this->app->DB->Select("SELECT sum( TIME_TO_SEC( TIMEDIFF( bis, von ) ) / 3600) FROM `zeiterfassung` WHERE arbeitspaket = '".$v['id']."' AND stundensatz > 0");
            $zeitmitstundensatz = (float)$this->app->DB->Select("SELECT sum( TIME_TO_SEC( TIMEDIFF( bis, von ) ) / 3600 * stundensatz ) FROM `zeiterfassung` WHERE arbeitspaket = '".$v['id']."' AND stundensatz > 0");
            if($v['kalkulationbasis'] == 'pauschale')
            {
              $v['zeit_ek_gebucht'] = $zeitmitstundensatz+(($v['zeit_gebucht']-$stundenmitstundensatz) / ($v['zeit_geplant']?$v['zeit_geplant']:1))*$v['ek_geplant'];
            }else{
              $v['zeit_ek_gebucht'] = $zeitmitstundensatz+($v['zeit_gebucht']-$stundenmitstundensatz)*$v['ek_geplant']; 
            }
            
          }
          $v['zeit_ek_offen'] = $v['ek_geplant']*($v['kalkulationbasis'] == 'pauschale'?($v['zeit_ek_gebucht'] > 0?0:1):$v['zeit_offen']);
          $v['zeit_vk_geplant'] = $v['vk_geplant']*($v['vkkalkulationbasis'] == 'pauschale'?1:$v['zeit_geplant']);
          $v['zeit_vk_gebucht'] = 0;//$v['vk_geplant']*($v['vkkalkulationbasis'] == 'pauschale'?1:$v['zeit_gebucht']);
          $v['zeit_vk_offen'] = $v['vk_geplant']*($v['vkkalkulationbasis'] == 'pauschale'?($v['zeit_vk_gebucht'] > 0?0:1):$v['zeit_offen']);

          
          $v['rohertrag_zeit'] = $v['zeit_vk_geplant'] - $v['zeit_ek_gebucht'];
          $v['rohertrag_zeit_geplant'] = $v['zeit_vk_geplant'] - $v['zeit_ek_geplant'];
          
          
          $artikelliste = $this->app->DB->SelectArr("SELECT * FROM projekt_artikel WHERE projekt = '$projekt' AND teilprojekt = '".$v['id']."' AND artikel > 0");
          $v['artikel_vk_geplant'] = 0;
          $v['artikel_vk_gebucht'] = 0;
          
          $v['artikel_ek_geplant'] = 0;
          $v['artikel_ek_gebucht'] = 0;
          
          if($artikelliste)
          {
            foreach($artikelliste as $art)
            {
              if($art['kalkulationbasis'] == 'prostueck')
              {
                if($art['showinmonitoring'])$v['artikel_vk_geplant'] += $art['vk_geplant'] * $art['geplant'];
                if($art['showinmonitoring'])$v['artikel_ek_geplant'] += $art['ek_geplant'] * $art['geplant'];
                $vk_geplant = $v['vk_geplant'];
                $ek_geplant = $v['ek_geplant'];
              }else{
                $vk_geplant = 0;
                $ek_geplant = 0;
                if($art['showinmonitoring'])$v['artikel_vk_geplant'] += $art['vk_geplant'];
                if($art['showinmonitoring'])$v['artikel_ek_geplant'] += $art['ek_geplant'];
                if($art['geplant'] > 0)
                {
                  $vk_geplant = $art['vk_geplant'] / $art['geplant'];
                  $ek_geplant = $art['ek_geplant'] / $art['geplant'];
                }
              }
              if($vk_geplant)
              {
                $v['artikel_vk_gebucht'] += (float)$this->app->DB->Select("SELECT sum(rp.menge) FROM rechnung r INNER JOIN rechnung_position rp ON r.id = rp.rechnung AND rp.artikel = '".$art['artikel']."' AND r.status != 'storniert' AND r.status != 'angelegt' AND rp.teilprojekt = '".$v['id']."'");
                $v['artikel_vk_gebucht'] -= (float)$this->app->DB->Select("SELECT sum(rp.menge) FROM gutschrift r INNER JOIN gutschrift_position rp ON r.id = rp.gutschrift AND rp.artikel = '".$art['artikel']."' AND r.status != 'storniert' AND r.status != 'angelegt' AND rp.teilprojekt  = '".$v['id']."'");
              }
              if($ek_geplant)
              {
                $v['artikel_ek_gebucht'] += (float)$this->app->DB->Select("SELECT sum(rp.menge) FROM bestellung r INNER JOIN bestellung_position rp ON r.id = rp.bestellung AND rp.artikel = '".$art['artikel']."' AND r.status != 'storniert' AND r.status != 'angelegt' AND rp.teilprojekt = '".$v['id']."'");
              }
            }            
          }
          
          $v['artikel_ek_offen'] = $v['artikel_ek_geplant']-$v['artikel_ek_gebucht'];
          $v['artikel_vk_offen'] = $v['artikel_vk_geplant']-$v['artikel_vk_gebucht'];
          $v['rohertrag_artikel'] = $v['artikel_vk_gebucht'] - $v['artikel_ek_gebucht'];
          $v['rohertrag_gesamt'] = $v['rohertrag_zeit']+$v['rohertrag_artikel'];
          $v['rohertrag_artikel_geplant'] = $v['artikel_vk_geplant'] - $v['artikel_ek_geplant'];
          $v['rohertrag_gesamt_geplant'] = $v['rohertrag_zeit_geplant']+$v['rohertrag_artikel_geplant'];
          
          $v['prognose_artikel'] = $v['artikel_vk_geplant']-$v['artikel_ek_geplant'];
          $v['prognose_zeit'] = $v['zeit_vk_geplant'] - $v['zeit_ek_gebucht'];
          $v['prognose_zeit_geplant'] = $v['zeit_vk_geplant'] - $v['zeit_ek_geplant'];
          $v['prognose_gesamt'] = $v['prognose_artikel'] + $v['prognose_zeit_geplant'];
          $gesamt_artikel_ek_gebucht += $v['artikel_ek_gebucht'];
          $gesamt_artikel_ek_offen += $v['artikel_ek_offen'];
          $gesamt_artikel_ek_geplant += $v['artikel_ek_geplant'];
          $gesamt_artikel_vk_gebucht += $v['artikel_vk_gebucht'];
          $gesamt_artikel_vk_offen += $v['artikel_vk_offen'];
          $gesamt_artikel_vk_geplant += $v['artikel_vk_geplant'];          
          
          $gesamt_zeit_ek_gebucht += $v['zeit_ek_gebucht'];
          $gesamt_zeit_ek_offen += $v['zeit_ek_offen'];
          $gesamt_zeit_ek_geplant += $v['zeit_ek_geplant'];
          $gesamt_zeit_vk_gebucht += $v['zeit_vk_gebucht'];
          $gesamt_zeit_vk_offen += $v['zeit_vk_offen'];
          $gesamt_zeit_vk_geplant += $v['zeit_vk_geplant'];
          
          $gesamt_rohertrag_artikel += $v['rohertrag_artikel'];
          $gesamt_rohertrag_zeit += $v['rohertrag_zeit'];
          $gesamt_rohertrag_gesamt += $v['rohertrag_gesamt'];
          
          $gesamt_rohertrag_artikel_geplant += $v['rohertrag_artikel_geplant'];
          $gesamt_rohertrag_zeit_geplant += $v['rohertrag_zeit_geplant'];
          $gesamt_rohertrag_gesamt_geplant += $v['rohertrag_gesamt_geplant'];
          
          $v['prognose_artikel'] = number_format($v['prognose_artikel'],2,'.','');
          $v['prognose_zeit'] = number_format($v['prognose_zeit'],2,'.','');
          $v['prognose_zeit_geplant'] = number_format($v['prognose_zeit_geplant'],2,'.','');
          $v['prognose_gesamt'] = number_format($v['prognose_gesamt'],2,'.','');
          
          $v['rohertrag_zeit'] = number_format($v['rohertrag_zeit'],2,'.','');
          $v['rohertrag_artikel'] = number_format($v['rohertrag_artikel'],2,'.','');
          $v['rohertrag_gesamt'] = number_format($v['rohertrag_gesamt'],2,'.','');

          $v['rohertrag_zeit_geplant'] = number_format($v['rohertrag_zeit_geplant'],2,'.','');
          $v['rohertrag_artikel_geplant'] = number_format($v['rohertrag_artikel_geplant'],2,'.','');
          $v['rohertrag_gesamt_geplant'] = number_format($v['rohertrag_gesamt_geplant'],2,'.','');
          
          $v['zeit_ek_geplant'] = number_format($v['zeit_ek_geplant'],2,'.','');
          $v['zeit_ek_gebucht'] = number_format($v['zeit_ek_gebucht'],2,'.','');
          $v['zeit_ek_offen'] = number_format($v['zeit_ek_offen'],2,'.','');
          $v['zeit_vk_geplant'] = number_format($v['zeit_vk_geplant'],2,'.','');
          $v['zeit_vk_gebucht'] = number_format($v['zeit_vk_gebucht'],2,'.','');
          $v['zeit_vk_offen'] = number_format($v['zeit_vk_offen'],2,'.','');
          
          $v['artikel_vk_geplant'] = number_format($v['artikel_vk_geplant'],2,'.','');
          $v['artikel_vk_gebucht'] = number_format($v['artikel_vk_gebucht'],2,'.','');
          $v['artikel_vk_offen'] = number_format($v['artikel_vk_offen'],2,'.','');
          $v['artikel_ek_geplant'] = number_format($v['artikel_ek_geplant'],2,'.','');
          $v['artikel_ek_gebucht'] = number_format($v['artikel_ek_gebucht'],2,'.','');
          $v['artikel_ek_offen'] = number_format($v['artikel_ek_offen'],2,'.','');
          
          $v['zeit_gebucht'] = number_format($v['zeit_gebucht'],2,'.','');
          $v['zeit_abgerechnet'] = number_format($v['zeit_abgerechnet'],2,'.','');
          $v['gebucht_summiert'] = $v['zeit_gebucht'];//number_format($gebucht_summiert,2,'.','');
          $v['abgerechnet_summiert'] = number_format($abgerechnet_summiert,2,'.','');
          $v['zeit_offen'] = number_format($v['zeit_offen'],2,'.','');
          $v['zeit_summiert'] = number_format($v['zeit_geplant'],2,'.','') ;  //number_format($zeit_summiert,2,'.','');
          $kosten_summiert += (float)$v['kosten_geplant'];
          $v['kosten_geplant']  = number_format($v['kosten_geplant'],2,',','.');
          
        }
        $projekteindex = empty($projekte)?0:count($projekte);

        // checken ob es so besser ist
        //foreach($v as $v_key=>$v_value)
        //  if(trim(strip_tags($v[$v_key]))=="0.00") $v[$v_key]="";
        $v['editierbar'] = true;
        
        if($v['zeit_geplant'] > 0 && $this->app->DB->Select("SELECT id FROM `teilprojekt_geplante_zeiten` WHERE teilprojekt = '".$v['id']."' AND stundensatz > 0 AND stunden > 0 LIMIT 1"))
        {
          $v['editierbar'] = false;  
        }
        
        $projekte[] = $v;
        $oldgebucht_summiert = $gebucht_summiert;
        $oldzeit_summiert = $zeit_summiert;
        
        $anzahlteilprojekte = count($projekte);
        $liste = $this->getProjektBaum($projekte, $v['id'], $projekt, $v['nr'], 
        array($zeit_summiert,$gebucht_summiert, $kosten_summiert, $abgerechnet_summiert,$offen_summiert
        ,$gesamt_zeit_ek_geplant,$gesamt_zeit_ek_gebucht,$gesamt_zeit_ek_offen
        ,$gesamt_zeit_vk_geplant,$gesamt_zeit_vk_gebucht,$gesamt_zeit_vk_offen
        ,$gesamt_artikel_ek_geplant,$gesamt_artikel_ek_gebucht,$gesamt_artikel_ek_offen
        ,$gesamt_artikel_vk_geplant,$gesamt_artikel_vk_gebucht,$gesamt_artikel_vk_offen
        ,$gesamt_rohertrag_zeit,$gesamt_rohertrag_artikel,$gesamt_rohertrag_gesamt
        ,$gesamt_rohertrag_zeit_geplant,$gesamt_rohertrag_artikel_geplant,$gesamt_rohertrag_gesamt_geplant
        ), $onlynummertitel);
        
        if(count($projekte) == $anzahlteilprojekte)
        {
          //$projekte[count($projekte)-1]['editierbar'] = true;
        }
        
        

        $zeit_summiert = $liste[0];
        $gebucht_summiert = $liste[1];
        $kosten_summiert = $liste[2];
        $abgerechnet_summiert = $liste[3];
        $offen_summiert = $liste[4];
        $gesamt_zeit_ek_geplant = $liste[5];
        $gesamt_zeit_ek_gebucht = $liste[6];
        $gesamt_zeit_ek_offen = $liste[7];
        $gesamt_zeit_vk_geplant = $liste[8];
        $gesamt_zeit_vk_gebucht = $liste[9];
        $gesamt_zeit_vk_offen = $liste[10];
        $gesamt_artikel_ek_geplant = $liste[11];
        $gesamt_artikel_ek_gebucht = $liste[12];
        $gesamt_artikel_ek_offen = $liste[13];
        $gesamt_artikel_vk_geplant = $liste[14];
        $gesamt_artikel_vk_gebucht = $liste[15];
        $gesamt_artikel_vk_offen = $liste[16];
        $gesamt_rohertrag_zeit = $liste[17];
        $gesamt_rohertrag_artikel = $liste[18];
        $gesamt_rohertrag_gesamt = $liste[19];
        $gesamt_rohertrag_zeit_geplant = $liste[20];
        $gesamt_rohertrag_artikel_geplant = $liste[21];
        $gesamt_rohertrag_gesamt_geplant = $liste[22];
        $projekte[$projekteindex]['gebucht_summiert'] += $gebucht_summiert - $oldgebucht_summiert;
        $projekte[$projekteindex]['gebucht_summiert'] = number_format($projekte[$projekteindex]['gebucht_summiert'],2,',','.');
        $projekte[$projekteindex]['zeit_summiert'] += $zeit_summiert - $oldzeit_summiert;
        $projekte[$projekteindex]['zeit_summiert'] = number_format($projekte[$projekteindex]['zeit_summiert'],2,',','.');
      }
    }
    if($vorgaenger == 0)
    {
      if(isset($v))unset($v);
      $v['nr'] = '';
      $v['aufgabe'] = '<b>Summe Gesamt</b>';
      $v['nummer'] = '-';
      $v['BE'] = '-';
      $v['PR'] = '-';
      $v['AN'] = '-';
      $v['AB'] = '-';
      $v['LS'] = '-';
      $v['RE'] = '-';
      $v['GS'] = '-';
      $v['zeit_summiert'] = '<b>'.number_format($zeit_summiert,2).'</b>';
      $v['zeit_geplant'] = $v['zeit_summiert'];
      $v['gebucht_summiert'] = '<b>'.number_format($gebucht_summiert,2).'</b>';
      $v['zeit_gebucht'] = '<b>'.number_format($gebucht_summiert,2).'</b>';
      $v['zeit_offen'] = '<b>'.number_format($offen_summiert,2).'</b>';
      $v['zeit_abgerechnet'] = '<b>'.number_format($abgerechnet_summiert,2).'</b>';
      $v['kosten_geplant'] = '<b>'.number_format($kosten_summiert,2,',','.').'</b>';
      $v['rohertrag_zeit'] = '<b'.($gesamt_rohertrag_zeit < 0?' style="color:red;"':'').'>'.number_format($gesamt_rohertrag_zeit,2,'.','').'</b>';
      $v['rohertrag_artikel'] = '<b'.($gesamt_rohertrag_artikel < 0?' style="color:red;"':'').'>'.number_format($gesamt_rohertrag_artikel,2,'.','').'</b>';
      $v['rohertrag_gesamt'] = '<b'.($gesamt_rohertrag_gesamt < 0?' style="color:red;"':'').'>'.number_format($gesamt_rohertrag_gesamt,2,'.','').'</b>';

      $v['rohertrag_zeit_geplant'] = '<b'.($gesamt_rohertrag_zeit_geplant < 0?' style="color:red;"':'').'>'.number_format($gesamt_rohertrag_zeit_geplant,2,'.','').'</b>';
      $v['rohertrag_artikel_geplant'] = '<b'.($gesamt_rohertrag_artikel_geplant < 0?' style="color:red;"':'').'>'.number_format($gesamt_rohertrag_artikel_geplant,2,'.','').'</b>';
      $v['rohertrag_gesamt_geplant'] = '<b'.($gesamt_rohertrag_gesamt_geplant < 0?' style="color:red;"':'').'>'.number_format($gesamt_rohertrag_gesamt_geplant,2,'.','').'</b>';
      $prognose_artikel = $gesamt_artikel_vk_geplant - $gesamt_artikel_ek_geplant;
      $prognose_zeit = $gesamt_zeit_vk_geplant - $gesamt_zeit_ek_gebucht;
      $prognose_zeit_geplant = $gesamt_zeit_vk_geplant - $gesamt_zeit_ek_geplant;
      $prognose_gesamt = $prognose_artikel + $prognose_zeit_geplant;
      $v['zeit_ek_geplant'] = '<b>'.number_format($gesamt_zeit_ek_geplant,2,'.','').'</b>';
      $v['zeit_ek_gebucht'] = '<b>'.number_format($gesamt_zeit_ek_gebucht,2,'.','').'</b>';
      $v['zeit_ek_offen'] = '<b'.($gesamt_zeit_ek_offen < 0?' style="color:red;"':'').'>'.number_format($gesamt_zeit_ek_offen,2,'.','').'</b>';
      $v['zeit_vk_geplant'] = '<b>'.number_format($gesamt_zeit_vk_geplant,2,'.','').'</b>';
      $v['zeit_vk_gebucht'] = '<b>'.number_format($gesamt_zeit_vk_gebucht,2,'.','').'</b>';
      $v['zeit_vk_offen'] = '<b'.($gesamt_zeit_vk_offen < 0?' style="color:red;"':'').'>'.number_format($gesamt_zeit_vk_offen,2,'.','').'</b>';
      
      $v['artikel_ek_geplant'] = '<b>'.number_format($gesamt_artikel_ek_geplant,2,'.','').'</b>';
      $v['artikel_ek_gebucht'] = '<b>'.number_format($gesamt_artikel_ek_gebucht,2,'.','').'</b>';
      $v['artikel_ek_offen'] = '<b'.($gesamt_artikel_ek_offen < 0?' style="color:red;"':'').'>'.number_format($gesamt_artikel_ek_offen,2,'.','').'</b>';
      $v['artikel_vk_geplant'] = '<b>'.number_format($gesamt_artikel_vk_geplant,2,'.','').'</b>';
      $v['artikel_vk_gebucht'] = '<b>'.number_format($gesamt_artikel_vk_gebucht,2,'.','').'</b>';
      $v['artikel_vk_offen'] = '<b'.($gesamt_artikel_vk_offen < 0?' style="color:red;"':'').'>'.number_format($gesamt_artikel_vk_offen,2,'.','').'</b>';
      $v['prognose_artikel'] = '<b'.($prognose_artikel < 0?' style="color:red;"':'').'>'.number_format($prognose_artikel,2,'.','').'</b>';
      $v['prognose_zeit'] = '<b'.($prognose_zeit < 0?' style="color:red;"':'').'>'.number_format($prognose_zeit,2,'.','').'</b>';
      $v['prognose_zeit_geplant'] = '<b'.($prognose_zeit_geplant < 0?' style="color:red;"':'').'>'.number_format($prognose_zeit_geplant,2,'.','').'</b>';
      $v['prognose_gesamt'] = '<b'.($prognose_gesamt < 0?' style="color:red;"':'').'>'.number_format($prognose_gesamt,2,'.','').'</b>';

      $projekte[] = $v;
    }

    $result =  array($zeit_summiert,$gebucht_summiert,$kosten_summiert,$abgerechnet_summiert,$offen_summiert,$gesamt_zeit_ek_geplant,$gesamt_zeit_ek_gebucht,$gesamt_zeit_ek_offen
        ,$gesamt_zeit_vk_geplant,$gesamt_zeit_vk_gebucht,$gesamt_zeit_vk_offen
        ,$gesamt_artikel_ek_geplant,$gesamt_artikel_ek_gebucht,$gesamt_artikel_ek_offen
        ,$gesamt_artikel_vk_geplant,$gesamt_artikel_vk_gebucht,$gesamt_artikel_vk_offen
        ,$gesamt_rohertrag_zeit,$gesamt_rohertrag_artikel,$gesamt_rohertrag_gesamt
        ,$gesamt_rohertrag_zeit_geplant,$gesamt_rohertrag_artikel_geplant,$gesamt_rohertrag_gesamt_geplant
        );

    return $result;
  }

  function ProjektArbeitspaketMonitor($id)
  {
    $arbeitspaket = $this->app->DB->SelectArr("SELECT * FROM arbeitspaket WHERE id = '$id' LIMIT 1");
    $check = 0;
    $budget = 0;
    $termin = 0;
    
    if($arbeitspaket)
    {
      $arbeitspaket = reset($arbeitspaket);
      if($arbeitspaket['status'] != 'abgeschlossen' && $arbeitspaket['status'] != 'abgerechnet')
      {
        if(empty($arbeitspaket['abgabedatum']) || $arbeitspaket['abgabedatum'] == '0000-00-00' || $this->app->DB->Select("select '".$arbeitspaket['abgabedatum']."' >= date(now())"))
        {
          $termin = 1;
        }else{
          $termin = 2;
        }
        if(round(((int)$this->app->DB->Select("SELECT sum( TIME_TO_SEC( TIMEDIFF( bis, von ) )) FROM `zeiterfassung` WHERE arbeitspaket = '".$id."' "))/3600,2) > $arbeitspaket['zeit_geplant'])
        {
          $check = 2;
        }else{
          $check = 1;
        }
        $bestellungsumme = $this->app->DB->Select("SELECT sum(bp.preis*bp.menge) FROM bestellung_position bp INNER JOIN projekt_artikel pa ON pa.artikel = bp.artikel AND pa.teilprojekt = '$id'");
        if($bestellungsumme > $arbeitspaket['kosten_geplant'])
        {
          $budget = 2;
        }else{
          $budget = 1;
        }
      }
      return '<img src="./themes/new/images/'.($check==0?'grey':($check==1?'checkgo':'checkstop')).'.png" title="'.($check==0?'Teilprojekt abgeschlossen / abgerechnet':($check==1?'Gebuchte Zeit noch in geplanter Zeit':'Gebuchte Zeit nicht in geplanter Zeit')).'"><img src="./themes/new/images/'.($termin==0?'grey':($termin==1?'termingo':'terminstop')).'.png" title="'.($termin==0?'Teilprojekt abgeschlossen / abgerechnet':($termin==1?'Keine Termine &uuml;berschritten':'Termine wurden &uuml;berschritten')).'"><img src="./themes/new/images/'.($budget==0?'grey':($budget==1?'kreditlimitgo':'kreditlimitstop')).'.png" title="'.($budget==0?'Teilprojekt abgeschlossen / abgerechnet':($budget==1?'Material im Budget':'Budget wurde &uuml;berschritten')).'">';
    }else{
      return '';
    }
    
  }
 
  function ProjektUebersicht()
  {
    $id = (int)$this->app->Secure->GetGET('id');
    $this->ProjektMenu();


    $speichern = $this->app->Secure->GetPOST('speichern');
    if($speichern!="")
    {
      $kunde = $this->app->Secure->GetPOST("kunde");
      $verantwortlicher = $this->app->Secure->GetPOST("verantwortlicher");
      $kundennummer = strstr($kunde,' ',true);
      $mitarbeiternummer = strstr($verantwortlicher,' ',true);
      $kundeid = $this->app->DB->Select("SELECT id FROM adresse WHERE kundennummer!='' AND kundennummer='$kundennummer' AND geloescht!=1 LIMIT 1");
      $verantwortlicherid = $this->app->DB->Select("SELECT id FROM adresse WHERE mitarbeiternummer!='' AND mitarbeiternummer='$mitarbeiternummer' AND geloescht!=1 LIMIT 1");

      $allowed = "/[^a-zA-Z0-9._-]/";
      $this->app->Secure->POST["abkuerzung"] = preg_replace($allowed,"",$this->app->Secure->POST["abkuerzung"]);
      $this->app->Secure->POST["abkuerzung"]=substr(strtoupper($this->app->Secure->POST["abkuerzung"]),0,20);

      $error = false;

      // pruefe ob es die Abzuerung schon gibt
      $checkprojekt = $this->app->DB->Select("SELECT COUNT(id) FROM projekt WHERE abkuerzung='".$this->app->Secure->POST["abkuerzung"]."' AND abkuerzung!='' AND id!='$id' "); 
      if($checkprojekt > 0)
      {
        $checkprojekt++;
        $this->app->Secure->POST["abkuerzung"]=$this->app->Secure->POST["abkuerzung"]."-".$checkprojekt; 

        $msg = $this->app->erp->base64_url_encode("<div class=\"warning\">Die Kennung gibt es bereits. Es wurde automatisch eine Folgenummer angelegt.</div>"); 
        $error = true;
      }    

      if($this->app->Secure->POST["abkuerzung"]=="")
      {
        $kennung = $this->app->DB->Select("SELECT COUNT(id) FROM projekt WHERE abkuerzung LIKE 'PROJEKT%' ") + 1;
        $this->app->Secure->POST["abkuerzung"]="PROJEKT-".$kennung;
        $msg = $this->app->erp->base64_url_encode("<div class=\"warning\">Die Kennung ist ein Pflichtfeld. Es wurde eine automatische Kennung vergeben.</div>"); 
        $error = true;
      }

      $this->app->FormHandler->FormUpdateDatabase("projekt",$id);
      $this->app->DB->Update("UPDATE projekt SET kunde='$kundeid', verantwortlicher='$verantwortlicherid' WHERE id='$id' LIMIT 1");

      if($error===false)
      {
        $msg = $this->app->erp->base64_url_encode("<div class=\"info\">Projekt wurde gespeichert.</div>");
      }

      if($msg!="")
      {
        header("Location: index.php?module=projekt&action=uebersicht&id=$id&msg=$msg");
        exit;
      }
      

    }

    $this->app->FormHandler->FormGetVars("projekt",$id);
    $data = $this->app->DB->SelectArr("SELECT CONCAT(a.kundennummer,' ',a.name) as kunde, CONCAT(a2.mitarbeiternummer,' ',a2.name) as mitarbeiter, status FROM projekt p
      LEFT JOIN adresse a ON a.id=p.kunde LEFT JOIN adresse a2 ON a2.id=p.verantwortlicher WHERE p.id='$id' LIMIT 1");
    if(isset($data[0]))
    {  
      $this->app->Tpl->Set('KUNDE',$data[0]['kunde']);
      $this->app->Tpl->Set('VERANTWORTLICHER',$data[0]['mitarbeiter']);    
      switch($data[0]['status']){
        case 'gestartet':
        case 'geplant':
        case 'abgeschlossen':
          $this->app->Tpl->Set("STATUS".strtoupper($data[0]['status']),' selected="selected" ');
        break;
      }
    }
    $this->app->YUI->AutoComplete("abkuerzung","projektname",1);
    $this->app->YUI->AutoComplete("kunde","kunde");
    $this->app->YUI->AutoComplete("verantwortlicher","mitarbeiter");
    $this->app->YUI->CkEditor("beschreibung","belege");
    $this->app->YUI->CkEditor("sonstiges","internal");
    $this->app->Tpl->Parse('PAGE','projekt_uebersicht.tpl');
  }
 
  
  function ProjektMiniDetailArbeitspaket()
  {
    $this->ProjektMiniDetailTeilprojekt();
  }

  function ProjektMiniDetailTeilprojekt()
  {


    $this->app->Tpl->Output("projekt_minidetail_teilprojekt.tpl");
    exit;


    $id = $this->app->Secure->GetGET("id");
    $projekt = $this->app->DB->Select("SELECT projekt FROM arbeitspaket WHERE id='$id'");
    $beschreibung = $this->app->DB->Select("SELECT beschreibung FROM arbeitspaket WHERE id='$id'");
    $vorgaenger = $this->app->DB->Select("SELECT vorgaenger FROM arbeitspaket WHERE id='$id'");
    $vorgaenger_aufgabe = $this->app->DB->Select("SELECT aufgabe FROM arbeitspaket WHERE id='$vorgaenger'");

    $this->app->Tpl->Set('VORGAENGER',$vorgaenger_aufgabe);
    $this->app->Tpl->Set('BESCHREIBUNG',nl2br($beschreibung));
    $this->app->Tpl->Set('PROJEKT',$projekt);
    $this->app->Tpl->Set('ID',$id);

    $table = new EasyTable($this->app);
    $table->Query("
        SELECT 
        CONCAT('<input type=\"checkbox\" checked name=\"z_id[]\" value=\"',z.id,'\">') as '',
        DATE_FORMAT(z.bis, GET_FORMAT(DATE,'EUR')) AS Datum, 
        DATE_FORMAT(z.von,'%H:%i') as von, DATE_FORMAT(z.bis,'%H:%i') as bis,
        FORMAT(TIME_TO_SEC(TIMEDIFF(z.bis, z.von))/3600,2) AS Dauer,
        a.name as Mitarbeiter,
        IF(LENGTH(z.aufgabe) > 40, CONCAT('<a title=\"',z.aufgabe,'\" style=\"font-weight:normal\">',LEFT(z.aufgabe, 37), '...</a>'), 
          CONCAT('<a title=\"',z.aufgabe,'\" style=\"font-weight:normal\">',z.aufgabe,'</a>')) as Taetigkeit, 
        CONCAT(v.nummer,' ',v.beschreibung) as verrechnungsart,

        if(z.arbeitsnachweis > 0,CONCAT('<a href=\"index.php?module=arbeitsnachweis&action=edit&id=',z.arbeitsnachweis,'\" target=\"_blank\">gebucht</a>'),'-')  as arbeitsnachweis,

        CONCAT('<a href=\"#\" onclick=\"if(!confirm(\'Wirklich stornieren?\')) return false; else window.location.href=\'index.php?module=zeiterfassung&action=list&do=stornieren&lid=', z.id, '&back=projekt&back_id=$projekt\'\"><img src=\"./themes/new/images/delete.gif\"></a>&nbsp;<a href=\"index.php?module=zeiterfassung&action=create&id=', z.id, '&back=projekt&back_id=$projekt\" ><img src=\"./themes/new/images/edit.png\"></a>')
        FROM zeiterfassung z 
        LEFT JOIN adresse a ON a.id=z.adresse 
        LEFT JOIN adresse b ON b.id=z.adresse_abrechnung
        LEFT JOIN projekt p ON p.id=z.projekt 
        LEFT JOIN arbeitspaket ap ON z.arbeitspaket=ap.id
        LEFT JOIN verrechnungsart v ON v.nummer=z.verrechnungsart
        WHERE z.arbeitspaket='$id' AND (z.arbeitsnachweis IS NULL OR z.arbeitsnachweis=0) AND ist_abgerechnet!=1 AND abgerechnet!=1 ORDER by z.von
        ");
    $table->DisplayNew('OFFENEZEIT', "Menü","Action");

    $table->Query("
        SELECT 
        DATE_FORMAT(z.bis, GET_FORMAT(DATE,'EUR')) AS Datum, 
        DATE_FORMAT(z.von,'%H:%i') as von, DATE_FORMAT(z.bis,'%H:%i') as bis,
        FORMAT(TIME_TO_SEC(TIMEDIFF(z.bis, z.von))/3600,2) AS Dauer,
        a.name as Mitarbeiter,
        IF(LENGTH(z.aufgabe) > 40, CONCAT('<a title=\"',z.aufgabe,'\" style=\"font-weight:normal\">',LEFT(z.aufgabe, 37), '...</a>'), 
          CONCAT('<a title=\"',z.aufgabe,'\" style=\"font-weight:normal\">',z.aufgabe,'</a>')) as Taetigkeit, 
        CONCAT(v.nummer,' ',v.beschreibung) as verrechnungsart,

        if(z.arbeitsnachweis > 0,CONCAT('<a href=\"index.php?module=arbeitsnachweis&action=edit&id=',z.arbeitsnachweis,'\" target=\"_blank\">gebucht</a>'),'-')  as arbeitsnachweis,

        CONCAT('<a href=\"#\" onclick=\"if(!confirm(\'Wirklich stornieren?\')) return false; else window.location.href=\'index.php?module=zeiterfassung&action=list&do=stornieren&lid=', z.id, '&back=projekt&back_id=$projekt\'\"><img src=\"./themes/new/images/delete.gif\"></a>&nbsp;<a href=\"index.php?module=zeiterfassung&action=create&id=', z.id, '&back=projekt&back_id=$projekt\" ><img src=\"./themes/new/images/edit.png\"></a>')
        FROM zeiterfassung z 
        LEFT JOIN adresse a ON a.id=z.adresse 
        LEFT JOIN adresse b ON b.id=z.adresse_abrechnung
        LEFT JOIN projekt p ON p.id=z.projekt 
        LEFT JOIN arbeitspaket ap ON z.arbeitspaket=ap.id
        LEFT JOIN verrechnungsart v ON v.nummer=z.verrechnungsart
        WHERE z.arbeitspaket='$id' AND (z.arbeitsnachweis >0 OR z.ist_abgerechnet=1 OR z.abgerechnet=1) ORDER by z.von
        ");
    $table->DisplayNew('GEBUCHTEZEIT', "Menü","Action");



    $this->app->Tpl->Set('ID',$id);
    $this->app->Tpl->Output("projekt_minidetail_teilprojekt.tpl");
    exit;
  }

  function ProjektDateien()
  {
    $id = $this->app->Secure->GetGET("id");
    $this->ProjektMenu();
    $this->app->Tpl->Add('UEBERSCHRIFT'," (Dateien)");
    $this->app->YUI->DateiUpload('PAGE',"Projekt",$id);
  }


  function ProjektZeit()
  {
    $id = $this->app->Secure->GetGET("id");
    $sid = $this->app->Secure->GetGET("sid");
    $this->ProjektMenu();
    $this->app->YUI->TableSearch('TAB1',"projektzeiterfassung");

    $this->app->Tpl->Add('TAB1',"<br><table width=\"100%\"><tr><td align=\"center\">
        <input type=\"submit\" value=\"Auftrag erzeugen\" name=\"auftragsubmit\">
        <input type=\"submit\" value=\"Status: Archiv / Freigabe\" name=\"auftragsubmit\">
        <!--			<input type=\"submit\" value=\"Rechnung erzeugen\" name=\"rechnungsubmit\">-->
        </td></tr></table><br></form>");

    $this->app->Tpl->Parse('PAGE',"zeiterfassunguebersicht.tpl");


    /*

    //    $auftragsubmit = $this->app->Secure->GetPOST("auftragsubmit");
    $lieferscheinsubmit = $this->app->Secure->GetPOST("lieferscheinsubmit");
    $z_id = $this->app->Secure->GetPOST("z_id");
    if($lieferscheinsubmit !="") {
    //				print_r($z_id);
    $adresse = $this->app->DB->Select("SELECT kunde FROM projekt WHERE id='$id' LIMIT 1");

    //			$lieferschein = $this-app->erp->CreateLieferschein($adresse);
    for($i=0;$i<count($z_id);$i++)
    {
    $single_z_id = $z_id[$i];
    //$dauer = $this->app->DB->Select("SELECT TIME_TO_SEC(TIMEDIFF(z.bis, z.von))/3600 AS Dauer FROM zeiterfassung z WHERE z.id='".$single_z_id."'");
    //echo $dauer."<br>";
    $this->app->DB->Select("UPDATE zeiterfassung SET ist_abgerechnet='1', abgerechnet='1' WHERE id='".$single_z_id."'");
    }

    }
    //   $rechnungsubmit = $this->app->Secure->GetPOST("rechnungsubmit");

    $this->app->Tpl->Set(TABTEXT,"Zeiterfassung");

    $tmp = $this->app->DB->SelectArr("SELECT * FROM arbeitspaket WHERE projekt='$id'");

    $options="<option>Alle</option>";

    if($sid=="ohne")	
    $options.="<option value=\"ohne\">Ohne</option>";
    else
    $options.="<option value=\"ohne\">Ohne</option>";

    for($i=0;$i<count($tmp);$i++)
    {

    if($sid==$tmp[$i][id])$checked="selected"; else $checked="";
    $options .="<option value=\"".$tmp[$i][id]."\" $checked>".$tmp[$i][aufgabe]."</option>";

    }

    $this->app->Tpl->Add(INHALT,"
    <script>
    $(function(){
    // bind change event to select
    $('#dynamic_select').bind('change', function () {
    var url = $(this).val(); // get selected value
    if (url) { // require a URL
    window.location = 'index.php?module=projekt&action=zeit&id=$id&sid='+url; // redirect
    }
    return false;
    });
    });
    </script>

    <table width=\"100%\"><tr><td align=\"center\">Auswahl Unterprojekt/Arbeitspaket: <select id=\"dynamic_select\">$options</select></td></tr></table><br>
    <form action=\"\" method=\"post\">[EASYTABLE]");


    if($sid >0)
    $subwhere = " AND ap.id='$sid'";

    $table = new EasyTable($this->app);

    $table->Query("SELECT 
    if(z.abgerechnet,'&nbsp;&nbsp;-',CONCAT('<input type=\"checkbox\" value=\"',z.id,'\" name=\"z_id[]\" checked>')) as 'übernehmen', 
    DATE_FORMAT(z.bis, GET_FORMAT(DATE,'EUR')) AS Datum, 
    a.name as mitarbeiter,
    DATE_FORMAT(z.von,'%H:%i') as start, DATE_FORMAT(z.bis,'%H:%i') as ende,
    TIMEDIFF(z.bis, z.von) AS Dauer,
    ap.aufgabe as 'unterprojekt/Aufgabe', 
    z.aufgabe as Taetigkeit, 
    if(abgerechnet,'ja','nein') as abgrechnet,
      CONCAT('<a href=\"index.php?module=zeiterfassung&action=create&id=',z.id,'&back=projekt&back_id=$id&back_sid=$sid\"><img src=\"themes/new/images/edit.png\"></a>&nbsp;
          <a href=\"#\" onclick=\"if(!confirm(\'Wirklich stornieren?\')) return false; else window.location.href=\'index.php?module=zeiterfassung&action=list&do=stornieren&back=projekt&back_id=$id&back_sid=$sid&lid=',z.id,'\'\"><img src=\"themes/new/images/delete.gif\"></a>&nbsp;') as Menü
        FROM zeiterfassung z LEFT JOIN adresse a ON a.id=z.adresse LEFT JOIN arbeitspaket ap ON z.arbeitspaket=ap.id
        WHERE z.projekt=$id $subwhere
        ORDER BY 7,Datum, bis DESC
        ");
    $table->DisplayNew(EASYTABLE, "Menü","noAction");

    $summe = $this->app->DB->Select("SELECT
        SEC_TO_TIME(SUM(TIME_TO_SEC(TIMEDIFF(z.bis, z.von))))
        FROM zeiterfassung z LEFT JOIN adresse a ON a.id=z.adresse LEFT JOIN arbeitspaket ap ON z.arbeitspaket=ap.id
        WHERE z.projekt=$id $subwhere");

    //$this->app->Tpl->Add(INHALT,"<br>Summe offen: $summe Summe gesamt: $summegesamt<br>");
    //$this->app->Tpl->Add(INHALT,"Summe offen: $summeeur ".$this->projektwaehrung);
    //$this->app->Tpl->Add(INHALT,"Summe offen: $summeeur ".$this->projektwaehrung);
    $this->app->Tpl->Add(EXTEND,"Summe: $summe");

    $this->app->Tpl->Add(INHALT,"<br><table width=\"100%\"><tr><td align=\"center\">
        <!--<input type=\"submit\" value=\"Auftrag erzeugen\" name=\"auftragsubmit\">-->
        <input type=\"submit\" value=\"Arbeitszeiten freigeben\" name=\"lieferscheinsubmit\">
        <!--			<input type=\"submit\" value=\"Rechnung erzeugen\" name=\"rechnungsubmit\">-->
        </td></tr></table><br></form>");

    $this->app->Tpl->Parse(TAB1,"projekt_zeiterfassung.tpl");

    $this->app->Tpl->Parse(PAGE,"tabview.tpl");
    */
  }


  function ProjektMaterial()
  {
    $id = $this->app->Secure->GetGET("id");
    $this->app->Tpl->Set('TABTEXT',"Materialeinsatz");
    $this->app->Tpl->Set('SUBSUBHEADING',"Positionen aus Bestellungen");
    $table = new EasyTable($this->app);
    $table->Query("SELECT  bp.bezeichnunglieferant as artikel, a.name as lieferant,b.belegnr as bestellung, bp.menge, bp.preis,menge*preis as gesamt, if(bp.abgerechnet,'ja','nein') as rechung FROM bestellung_position bp 
        LEFT JOIN bestellung b ON bp.bestellung=b.id LEFT JOIN adresse a ON b.adresse=a.id WHERE bp.projekt='$id' ORDER By bp.bestellung");

    $table->DisplayNew('MATERIAL', "abgerechnet","noAction");

    $summe = $this->app->DB->Select("SELECT  SUM(menge*preis) FROM bestellung_position WHERE projekt='$id' AND abgerechnet!='1' ORDER By bestellung");
    $summevk= $this->ProjektOffenesMaterial($id);
    $summegesamt = $summe;

    $this->app->Tpl->Add('MATERIAL',"<br>Summe offen: $summe ");
    $this->app->Tpl->Add('MATERIAL',"<br>Summe offen: $summevk ");
    $this->app->Tpl->Parse('TAB1',"rahmen70.tpl");


    $this->app->Tpl->Set('SUBSUBHEADING',"Positionen aus Lieferungen");
    $table = new EasyTable($this->app);
    $table->Query("SELECT  bp.menge, bp.bezeichnung as artikel, bp.seriennummer, b.belegnr as lieferschein, if(bp.abgerechnet,'ja','nein') as rechnung FROM lieferschein_position bp 
        LEFT JOIN lieferschein b ON bp.lieferschein=b.id LEFT JOIN adresse a ON b.adresse=a.id WHERE b.projekt='$id' ORDER By bp.lieferschein");

    $table->DisplayNew('MATERIAL', "abgerechnet","noAction");

    $summe = $this->app->DB->Select("SELECT  SUM(menge*preis) FROM bestellung_position WHERE projekt='$id' AND abgerechnet!='1' ORDER By bestellung");
    $summegesamt = $summe;

    //$this->app->Tpl->Add(INHALT,"<br>Summe offen: $summe Summe gesamt: $summegesamt<br>");



    $this->app->Tpl->Set('SUBSUBHEADING',"Material im Lager");
    $table = new EasyTable($this->app);
    $table->Query("SELECT  DISTINCT a.name_de as artikel, a.nummer, lp.kurzbezeichnung as regal, lpi.menge, a.hersteller FROM lager_platz_inhalt lpi
        LEFT JOIN artikel a ON a.id=lpi.artikel LEFT JOIN lager_platz lp ON lpi.lager_platz=lp.id WHERE a.projekt='$id' GROUP BY a.id");

    $table->DisplayNew('MATERIAL', "abgerechnet","noAction");

    $summe = $this->app->DB->Select("SELECT  SUM(menge*preis) FROM bestellung_position WHERE projekt='$id' AND abgerechnet!='1' ORDER By bestellung");
    $summegesamt = $summe;

    //$this->app->Tpl->Add(INHALT,"<br>Summe offen: $summe Summe gesamt: $summegesamt<br>");
  }

  function ProjektOffenesMaterial($id)
  {
    $summe = $this->app->DB->Select("SELECT  SUM(menge*preis) FROM bestellung_position WHERE projekt='$id' AND abgerechnet!='1' ORDER By bestellung");
    $summevk= $summe*((100 + $this->app->erp->GetStandardMarge())/100);
    $summegesamt = $summe;
    return $summevk;
  }

  function ProjektOffeneZeit($id)
  {
    $summe = $this->app->DB->Select("SELECT FORMAT(SUM(TIMEDIFF(z.bis, z.von))/10000,2) FROM zeiterfassung z LEFT JOIN arbeitspaket ap ON z.arbeitspaket = ap.id AND ap.projekt = '$id' WHERE (z.art='' OR z.art='Arbeit') AND (z.projekt='$id' OR not isnull(ap.id)) AND z.abgerechnet!='1'");
    $summeeur = $summe*$this->app->erp->GetStandardStundensatz();

    return $summeeur;
  }


  function ProjektSchaltung()
  {
    $id = $this->app->Secure->GetGET("id");
    $this->ProjektMenu();
    $this->app->Tpl->Add('UEBERSCHRIFT'," (Schaltung)");
    $this->app->Tpl->Set('PAGE',"
        <br>Neues Teilprojekt anlegen: <br>
        Name:<input type=text value=\"KUBUS 3B\"><br>Budget: <input type=text><br>Liefertermin: <input type=text value=>
        <br><br>
        <br><br>
        <table border=1><tr><td>Teilprojekt</td><td>Aktion</td></tr>
        <tr><td>Prototyp 1 KUBUS 3B</td><td><a>BOM</a>&nbsp;<a>Lagerbestand</a>&nbsp;<a>Bestellung</a>&nbsp;<a>Datenblaetter</a>&nbsp;<a>Schaltplan u. Layout</a>&nbsp;<a>Projekt Charter</a></td>
        <tr><td>SNOM Stick</td><td><a>BOM</a>&nbsp;<a>Lagerbestand</a>&nbsp;<a>Bestellung</a>&nbsp;<a>Datenblaetter</a>&nbsp;<a>Schaltplan u. Layout</a>&nbsp;<a>Projekt Charter</a></td>
        </table>
        <br><br>
        Prototyp 1 (inkl. eagle, stuecklisten, fertigungsauftrag fuer prototype, prueflisten, lagerbestand, bestellungsauftrag usw..)<br>Budget<br>Kostenstellen (ende mit 1)");
  }


  function ProjektKostenstellen()
  {
    $id = $this->app->Secure->GetGET("id");
    $this->ProjektMenu();
    $this->app->Tpl->Add('UEBERSCHRIFT'," (Kostenstellen)");


    $summezeit = $this->ProjektOffeneZeit($id);
    $summevk = $this->ProjektOffenesMaterial($id);

    $kosten = $summezeit + $summevk;
/*
    $this->app->Tpl->Set('KOSTEN',money_format('€ %!n',$kosten));
    $this->app->Tpl->Set('SUMMEZEIT',money_format('€ %!n',$summezeit));
    $this->app->Tpl->Set('SUMMEVK',money_format('€ %!n',$summevk));
*/
    $this->ProjektMaterial();


    $this->app->Tpl->Parse('PAGE',"projekt_kostenstellen.tpl");

  }



  function ProjektCreate()
  {
    $this->app->erp->MenuEintrag("index.php?module=projekt&action=list","Zur&uuml;ck zur &Uuml;bersicht");
    //parent::ProjektCreate();

    $schritt2 = $this->app->Secure->GetPOST("schritt2");
    $schritt3 = $this->app->Secure->GetGET("schritt3");

    $felder = array('name','kunde','verantwortlicher','abkuerzung','beschreibung','projekt','status');

    if($schritt3=="") $schritt3 = $this->app->Secure->GetPOST("schritt3");
    $auswahl = $this->app->Secure->GetPOST("auswahl");

    if($schritt2!="")
    {
      if($auswahl=="neu") $schritt3 = "weiter";
      else if ($auswahl=="kopie") {
        $this->app->YUI->TableSearch('TAB1',"projekt_kopie");
        $this->app->Tpl->Parse("PAGE","projekt_create_step2.tpl");
      }
    } 

    if($this->app->Secure->GetPOST('speichern') && $this->app->Secure->GetPOST('prkopieren'))
    {
      $id = $this->app->Secure->GetGET("id");
      $toid = $this->app->Secure->GetPOST("toid");
      $data = null;
      foreach($_POST as $key => $value)
      {
        $keya = explode('_',$key);
        if(isset($keya[1]))
        {
          switch($keya[0])
          {
            case 'arbeitspaket':
              $data['arbeitspaket'][] = (int)$keya[1];
            break;
            case 'artikel':
              $data['artikel'][] = (int)$keya[1];
            break;
            case 'adressrollen':
              $data['adressrollen'][] = (int)$keya[1];
            break;
          }
        }
      }
      $newid = $this->app->erp->CopyProjektDaten($id, $toid, $data);

      $msg = $this->app->erp->base64_url_encode("<div class=\"info\">Das Projekt wurde erfolgreich kopiert.</div>"); 
      header('Location: index.php?module=projekt&action=uebersicht&id='.$toid.'&msg='.$msg);
      exit;        
    }
    
    
    if ( $schritt3!="")
    {
      // auswahl projekt
      $this->app->YUI->AutoComplete("kunde","adresse");
      $this->app->YUI->AutoComplete("verantwortlicher","adresse");

      $this->app->YUI->CkEditor("beschreibung","belege");

      $id = $this->app->Secure->GetGET("id");
      if($id > 0)
      {
        foreach($felder as $field)
        {
          $value = $this->app->DB->Select("SELECT $field FROM projekt WHERE id='$id' LIMIT 1");
          if($field=="abkuerzung") 
          {
            if(strpos($value,'.') !== false)
            {
              $numericind = strlen($value);
              $fortlaufennach = '';
              for($i = $numericind -1; $i > 0 ; $i--)
              {
                if(!is_numeric($value{$i}))
                {
                  break;
                }else{
                  $fortlaufennach = $value{$i}.$fortlaufennach;
                }
              }
               
              $fortlaufendvor = '';
              if($i > 0)$fortlaufendvor = substr($value, 0, $i + 1);
              if($fortlaufennach == '')$fortlaufennach = 1;
              $fortlaufennachlen = strlen($fortlaufennach);
              
              while($this->app->DB->Select("SELECT id FROM projekt WHERE abkuerzung = '".$this->app->DB->real_escape_string($fortlaufendvor.$fortlaufennach)."' LIMIT 1"))
              {
                $fortlaufennach++;
                if(strlen($fortlaufennach) < $fortlaufennachlen)$fortlaufennach = str_repeat('0',$fortlaufennachlen-strlen($fortlaufennach)).$fortlaufennach;
              }
              $value = $fortlaufendvor.$fortlaufennach;
 
              
            }else
              $value=$value."-1";
          }
          if($field=="kunde") $value=$this->app->DB->Select("SELECT CONCAT(id,' ',name) FROM adresse WHERE id='$value' LIMIT 1");
          if($field=="verantwortlicher") $value=$this->app->DB->Select("SELECT CONCAT(id,' ',name) FROM adresse WHERE id='$value' LIMIT 1");
         
          $this->app->Tpl->Set(strtoupper($field),$value);
        }
        $typ = $this->app->Secure->GetPOST('typ');
        if($typ == 'manuell' || $typ == 'kundennummer' || $typ == 'fortlaufend')
        {
          $this->app->Tpl->Set(strtoupper($typ),' checked="checked" ');
        }else{
          $this->app->Tpl->Set('MANUELL',' checked="checked" ');
        }
      } else {
        foreach($felder as $field)
        {
          $value = $this->app->Secure->GetPOST($field);
          $this->app->Tpl->Set(strtoupper($field),$value);
          $$field = $value;
        }
        $typ = $this->app->Secure->GetPOST('typ');
        if($typ == 'manuell' || $typ == 'kundennummer' || $typ == 'fortlaufend')
        {
          $this->app->Tpl->Set(strtoupper($typ),' checked="checked" ');
          switch($typ)
          {
            case 'manuell':
              //nichts weiter zu tun
            break;
            case 'kundennummer':
              if($kunde)
              {
                $kundennummer = $this->app->DB->Select("SELECT kundennummer FROM adresse WHERE id = '$kunde' LIMIT 1");
                if($kundennummer == '')
                {
                  $error[]="Keine Kundennummer gefunden.";
                }else{
                  $abkuerzungen = $this->app->DB->SelectArr("SELECT abkuerzung FROM projekt WHERE abkuerzung like '".$this->app->DB->real_escape_string($kundennummer).".%'");
                  if($abkuerzungen)
                  {
                    $j = 1;
                    $laenge = 1;
                    foreach($abkuerzungen as $abk)
                    {
                      $abkuerzungalt = substr($abk['abkuerzung'],strlen($kundennummer)+1);
                      if(strlen($abkuerzungalt) > $laenge)$laenge = strlen($abkuerzungalt);
                      $abkuerzungalt = 1+(int)$abkuerzungalt;
                      if($j < $abkuerzungalt)$j = $abkuerzungalt;
                    }
                    $abkuerzung = $kundennummer.'.'.(strlen($j) < $laenge?str_repeat('0', $laenge-strlen($j)):'').$j;
                  }else{
                    $abkuerzung = $kundennummer.'.1';
                  }
                }
              }else{
                $error[]="Kein Kunde ausgew&auml;lt.";
              }
            break;
            case 'fortlaufend':
              $fortlaufend = $this->app->erp->Firmendaten('next_projektnummer');
              if($fortlaufend == '')$fortlaufend = '1000';
              $numericind = strlen($fortlaufend);
              $fortlaufennach = '';
              for($i = $numericind -1; $i > 0 ; $i--)
              {
                if(!is_numeric($fortlaufend{$i}))
                {
                  break;
                }else{
                  $fortlaufennach = $fortlaufend{$i}.$fortlaufennach;
                }
              }
               
              $fortlaufendvor = '';
              if($i > 0)$fortlaufendvor = substr($fortlaufend, 0, $i + 1);
              if($fortlaufennach == '')$fortlaufennach = 1;
              $fortlaufennachlen = strlen($fortlaufennach);
              
              while($this->app->DB->Select("SELECT id FROM projekt WHERE abkuerzung = '".$this->app->DB->real_escape_string($fortlaufendvor.$fortlaufennach)."' LIMIT 1"))
              {
                $fortlaufennach++;
                if(strlen($fortlaufennach) < $fortlaufennachlen)$fortlaufennach = str_repeat('0',$fortlaufennachlen-strlen($fortlaufennach)).$fortlaufennach;
              }
              $abkuerzung = $fortlaufendvor.$fortlaufennach;
              $fortlaufennach++;
              if(strlen($fortlaufennach) < $fortlaufennachlen)$fortlaufennach = str_repeat('0',$fortlaufennachlen-strlen($fortlaufennach)).$fortlaufennach;              
              $this->app->erp->FirmendatenSet('next_projektnummer',$fortlaufendvor.$fortlaufennach);
            break;
            
          }
          
          
        }else{
          $this->app->Tpl->Set('MANUELL',' checked="checked" ');
        }
      }
      // pruefe ob es abkuerzung schon gibt

      if($this->app->Secure->GetPOST("save")=="1")
      {
        $checkabkuerzung = $this->app->DB->Select("SELECT id FROM projekt WHERE abkuerzung='$abkuerzung' LIMIT 1");
    
        if($checkabkuerzung > 0 && $this->app->Secure->GetPOST("typ")=="manuell")
          $error[]="Abkürzung schon vorhanden. Bitte eine andere wählen.";

        if($this->app->Secure->GetPOST("name")=="")
          $error[]="Bitte geben Sie eine Bezeichung an.";

        if($this->app->Secure->GetPOST("abkuerzung")=="" && $this->app->Secure->GetPOST("typ")=="manuell")
          $error[]="Bitte geben Sie eine Kennung an.";
 
  

        if(count($error)<=0 && $this->app->Secure->GetPOST("save")=="1") $finish=1;
      } 
     
      for($i=0;$i<count($error);$i++)
        $this->app->Tpl->Add("MESSAGE","<div class=\"error\">".$error[$i]."</div>");

      if($finish!="1")
      {
        $stati = array('geplant','gestartet','abgeschlossen');
        $status = $this->app->Secure->GetPOST('status');
        if(!$status)$status = 'gestartet';
        foreach($stati as $stat)
        {
          $this->app->Tpl->Add('STATUSSEL','<option'.($status == $stat?' selected="selected" ':'').'>'.$stat.'</option>');
        }
        
        $this->app->Tpl->Parse("PAGE","projekt_create_step3.tpl");
      }
    } 


    // startseite
    if($schritt2=="" && $schritt3=="")
    {
      $this->app->Tpl->Parse("PAGE","projekt_create_step1.tpl");
    }


    if($finish)
    {
      foreach($felder as $field)
      {
        $data[$field]=$this->app->Secure->GetPOST($field);
        if($field == 'verantwortlicher')
        {
          $va = explode(' ', $data[$field]);
          $data[$field] = $va[0];
        }
      }
       
      if($abkuerzung=="") 
        $abkuerzung = $data['abkuerzung'];

      $allowed = "/[^a-zA-Z0-9._-]/";      
      $abkuerzung = preg_replace($allowed,"",$abkuerzung);
      $abkuerzung =  substr(strtoupper($abkuerzung),0,20);

      if($abkuerzung)$data['abkuerzung'] = $abkuerzung;

      // kopieren oder anlegen
      $id = $this->app->Secure->GetGET('id');
      if($id > 0)
      {
        $check = $this->app->erp->CopyProjekt($id);
        if($check > 0)
        {
          $this->app->DB->Update("UPDATE projekt SET name='".$data['name']."',abkuerzung='".$data['abkuerzung']."',kunde='".$data['kunde']."',verantwortlicher='".$data['verantwortlicher']."',
            beschreibung='".$data['beschreibung']."', status='".$data['status']."' WHERE id='$check' LIMIT 1");
          if(!$this->app->erp->UserProjektRecht($check))$this->app->DB->Insert("INSERT INTO adresse_rolle (id, adresse, subjekt, praedikat, objekt, parameter,von,projekt)
          VALUES ('','".$this->app->User->GetAdresse()."','Mitglied','von','Projekt','$check',NOW(),'$check')");
        }

        $this->app->Tpl->Set('TOID',$check);
      } else {
        if($data['waehrung']=="") $data['waehrung'] = $this->app->erp->Firmendaten("waehrung");
        if($data['steuersatz_normal']=="") $data['steuersatz_normal'] = $this->app->erp->Firmendaten("steuersatz_normal");
        if($data['steuersatz_ermaessigt']=="") $data['steuersatz_ermaessigt'] = $this->app->erp->Firmendaten("steuersatz_ermaessigt");

        

        //anlegen
        $this->app->DB->Insert("INSERT INTO projekt (id,name,abkuerzung,kunde,verantwortlicher,beschreibung,status,waehrung,steuersatz_normal,steuersatz_ermaessigt) VALUES ('','".$data['name']."','".$data['abkuerzung']."','".$data['kunde']."','".$data['verantwortlicher']."','".$data['beschreibung']."','".(empty($data['status'])?'gestartet':$data['status'])."','".$data['waehrung']."','".$data['steuersatz_normal']."','".$data['steuersatz_ermaessigt']."')");
        $check = $this->app->DB->GetInsertID();
        if(!$this->app->erp->UserProjektRecht($check))$this->app->DB->Insert("INSERT INTO adresse_rolle (id, adresse, subjekt, praedikat, objekt, parameter,von,projekt)
        VALUES ('','".$this->app->User->GetAdresse()."','Mitglied','von','Projekt','$check',NOW(),'$check')");
      }

      if($check > 0)
      {
        $msg = $this->app->erp->base64_url_encode("<div class=\"info\">Das Projekt wurde erfolgreich angelegt.</div>"); 
        header("Location: index.php?module=projekt&action=uebersicht&id=$check&msg=$msg");
      } else {
        $msg = $this->app->erp->base64_url_encode("<div class=\"error\">Es gab einen Fehler. Das Projekt konnte nicht angelegt werden.</div>  "); 
        header("Location: index.php?module=projekt&action=list&msg=$msg");
      }
      exit;
    } 


  }

  function ProjektList()
  {

    //$this->app->Tpl->Add(TABS,"<li><h2 class=\"allgemein\">Allgemein</h2></li>");
    $this->app->erp->MenuEintrag("index.php?module=projekt&action=list","&Uuml;bersicht");
    $this->app->erp->MenuEintrag("index.php?module=projekt&action=create","Neues Projekt anlegen");
    //$this->app->Tpl->Add(TABS,"<li><a  href=\"index.php\">Zur&uuml;ck zur &Uuml;bersicht</a></li>");

    //    $this->app->Tpl->Set(UEBERSCHRIFT,"Projekte");
    //    $this->app->Tpl->Set(KURZUEBERSCHRIFT,"Projekte");

    $this->app->YUI->TableSearch('TAB1',"projekttabelle");
    $this->app->Tpl->Parse('PAGE',"projektuebersicht.tpl");
    /*

       $this->app->Tpl->Add(TABS,"<li><h2 class=\"allgemein\">Allgemein</h2></li>");
       $this->app->Tpl->Add(TABS,"<li><a  href=\"index.php?module=projekt&action=create\">Neues Projekt anlegen</a></li>");
       $this->app->Tpl->Add(TABS,"<li><a  href=\"index.php?module=projekt&action=search\">Projekt suchen</a></li>");
       $this->app->Tpl->Add(TABS,"<li><a  href=\"index.php?module=projekt&action=list\">Zur&uuml;ck zur &Uuml;bersicht</a></li>");
       $this->app->Tpl->Add(TABS,"<li><br><br></li>");
       parent::ProjektList();
     */
  }


  function ProjektMenu($id="")
  {
    if($id=="")
      $id = $this->app->Secure->GetGET("id");

    //$nummer = $this->app->Secure->GetPOST("nummer");

    $data = $this->app->DB->SelectArr("SELECT p.abkuerzung as abk,p.name as projekt_name, a.kundennummer, a.name as kunde 
      FROM projekt p LEFT JOIN adresse a ON a.id=p.kunde WHERE p.id='$id' LIMIT 1");

    $data = reset($data);
    $this->app->Tpl->Add('KURZUEBERSCHRIFT2',$data['abk']." ".$data['projekt_name']." ".$data['kundennummer']." ".$data['kunde']);

    $this->app->erp->MenuEintrag("index.php?module=projekt&action=uebersicht&id=$id","&Uuml;bersicht");
    if($this->app->erp->Version()!="stock")
      $this->app->erp->MenuEintrag("index.php?module=projekt&action=dateien&id=$id","Dateien");
//    if($this->app->erp->Version()!="stock")
//      $this->app->erp->MenuEintrag("index.php?module=projekt&action=arbeitspaket&id=$id","Teilprojekte / Arbeitspakete");
    //    $this->app->Tpl->Add(TABS,"<li><a href=\"index.php?module=projekt&action=edit&id=$id\">Adressen</a></li>");
    //$this->app->Tpl->Add(TABS,"<li><a href=\"index.php?module=projekt&action=schaltung&id=$id\">Schaltungen</a></li>");
    //$this->app->Tpl->Add(TABS,"<li><a href=\"index.php?module=projekt&action=edit&id=$id\">Kosten</a></li>");
    //$this->app->Tpl->Add(TABS,"<li><a href=\"index.php?module=projekt&action=edit&id=$id\">Wareneingang</a></li>");
    //    $this->app->erp->MenuEintrag("index.php?module=projekt&action=zeit&id=$id","Zeiterfassung");
    //    $this->app->erp->MenuEintrag("index.php?module=projekt&action=arbeitsnachweise&id=$id","Arbeitsnachweise");
    //$this->app->erp->MenuEintrag("index.php?module=projekt&action=kostenstellen&id=$id","Kostenstellen");
//    if($this->app->erp->Version()!="stock")
//      $this->app->erp->MenuEintrag("index.php?module=projekt&action=kostenstellen&id=$id","Kostenstellen");
    //$this->app->Tpl->Add(TABS,"<a href=\"index.php?module=projekt&action=kosten&id=$id\">idGesamtkalkulation</a>&nbsp;");
    // $this->app->erp->MenuEintrag("index.php?module=projekt&action=pdf&id=$id","PDF");
//    if($this->app->erp->Version()!="stock")
//      $this->app->erp->MenuEintrag("index.php?module=projekt&action=plan&id=$id","Projektplan");



    $this->app->erp->MenuEintrag("index.php?module=projekt&action=edit&id=$id","Einstellungen");

    $this->app->erp->MenuEintrag("index.php?module=projekt&action=list","Zur&uuml;ck zur &Uuml;bersicht");

    //$this->app->erp->MenuEintrag("index.php?module=projekt&action=statistik&id=$id","Statistik");

  }

  function ProjektArbeitsnachweise()
  {

    $this->ProjektMenu();

    $this->app->YUI->TableSearch('TAB1',"arbeitsnachweiseprojekt");
    $this->app->Tpl->Set('TABTEXT',"Arbeitsnachweise");
    $this->app->Tpl->Parse('PAGE',"tabview.tpl");
  }

  function ArbeitspaketReadDetails($index,&$ref)
  {

  }

  function ProjektArbeitspaket()
  {
    $this->ProjektMenu();

    $id = (int)$this->app->Secure->GetGET("id");
    $pakete = $this->app->DB->SelectArr("SELECT * FROM arbeitspaket WHERE projekt = '$id' ORDER by vorgaenger, sort, id");
    if($pakete)
    {
      $oldvorgaenger = -1;
      foreach($pakete as $paket)
      {
        if($paket['sort'] == 0)
        {
          $newsort = 1+(int)$this->app->DB->Select("SELECT max(sort) FROM arbeitspaket WHERE projekt = '$id' AND vorgaenger = '".$paket['vorgaenger']."'");
          $this->app->DB->Update("UPDATE arbeitspaket SET sort = '$newsort' WHERE id = '".$paket['id']."' LIMIT 1");
        }
      }      
    }
   
    $abgerechnet = $this->app->Secure->GetPOST("abgerechnet");

    $this->app->Tpl->Parse('MANUELLCHECKBOX',"checkbox.tpl");

    $this->app->Tpl->Add('OFFENE',
        "<center>
        <input type=\"submit\" value=\"markierte Teilprojekte mit Zeitangabe in Rechnung oder Auftrag &uuml;berf&uuml;hren\" name=\"inklzeit\">
        <input type=\"submit\" value=\"markierte Teilprojekte ohne Zeitangabe in Rechnung oder Auftrag &uuml;berf&uuml;hren\">
        <br>
        <br>
        <input type=\"submit\" value=\"als abgerechnet markieren\" name=\"abgerechnetmarkiert\">
        <input type=\"submit\" value=\"als offen markieren\" name=\"offenmarkiert\">
        </center>");

    if($abgerechnet!="")
    {
      $zid = $this->app->Secure->GetPOST("z_id");
      for($i=0;$i<count($zid);$i++)
      {
        $zid_i = (int)$zid[$i];
        $this->app->DB->Update("UPDATE zeiterfassung SET ist_abgerechnet=1, abgerechnet=1 WHERE id='$zid_i' LIMIT 1");
      }
    }

    // neues arbeitspaket
    $widget = new WidgetArbeitspaket($this->app,'TAB2');
    $widget->form->SpecialActionAfterExecute("none",
        "index.php?module=projekt&action=arbeitspaket&id=$id#tabs-1");
    $this->app->Tpl->Set('TMPSCRIPT',"<script type=\"text/javascript\">$(document).ready(function(){ $('#tabs').tabs('select', 1); });</script>");

    $widget->Create();


    // easy table mit arbeitspaketen YUI als template 
    $this->app->YUI->TableSearch('TAB1',"projektzeiterfassung");

    $tmp = $this->app->DB->Select("SELECT SUM(zeit_geplant) FROM arbeitspaket WHERE projekt='$id'");

    //$this->app->Tpl->Add('TAB1',"<div class=\"info\">Kontigent Projekt (mit abgeschlossenen) geplant: $tmp</div>");

    $this->app->Tpl->Parse('PAGE',"arbeitspaketeuebersicht.tpl");
  }

  function ProjektArbeitspaketEditPopup()
  {
    //$frame = $this->app->Secure->GetGET("frame");
    $id = $this->app->Secure->GetGET("id");
    $sid = $this->app->Secure->GetGET("sid");
    $this->app->Tpl->Set('OPENDISABLE',"<!--");
    $this->app->Tpl->Set('CLOSEDISABLE',"-->");


    $sid = $this->app->DB->Select("SELECT projekt FROM arbeitspaket WHERE id='$id' LIMIT 1");
    //    $this->ProjektMenu($sid);

    if($this->app->Conf->WFdbType=="postgre") {
      if(is_numeric($sid)) {
        $abk= $this->app->DB->Select("SELECT abkuerzung FROM projekt WHERE id='$sid' LIMIT 1");
        $name= $this->app->DB->Select("SELECT name FROM projekt WHERE id='$sid' LIMIT 1");
      }
    }else {
      $abk= $this->app->DB->Select("SELECT abkuerzung FROM projekt WHERE id='$sid' LIMIT 1");
      $name= $this->app->DB->Select("SELECT name FROM projekt WHERE id='$sid' LIMIT 1");
    }


    $this->app->Tpl->Add('KURZUEBERSCHRIFT',"Projekt $abk");
    $this->app->Tpl->Add('KURZUEBERSCHRIFT2',$name);



    $this->app->erp->MenuEintrag("index.php?module=projekt&action=arbeitspaket&id=$sid","Zur&uuml;ck zur &Uuml;bersicht");
    $this->app->Tpl->Set('ABBRECHEN',"<input type=\"button\" value=\"Abbrechen\" onclick=\"window.location.href='index.php?module=projekt&action=arbeitspaket&id=$sid';\">");

    $widget = new WidgetArbeitspaket($this->app,'TAB1');
    $widget->form->SpecialActionAfterExecute("close_refresh",
        "index.php?module=projekt&action=arbeitspaket&id=$sid#tabs-1");
    $widget->Edit();


    $this->app->Tpl->Add('TAB2',"Sie bearbeiten gerade ein Arbeitspaket. Erst nach dem Speichern k&ouml;nnen neue Arbeitspakete angelegt werden.");

    $this->app->Tpl->Parse('PAGE',"arbeitspaketeuebersicht.tpl");
  }


  function ProjektArbeitspaketDisable()
  {
    //   $this->ArtikelMenu();
    $id = $this->app->Secure->GetGET("id");

    $sid = $this->app->DB->Select("SELECT projekt FROM arbeitspaket WHERE id='$id' LIMIT 1");
    $this->app->DB->Update("UPDATE arbeitspaket SET abgenommen=1,abgenommen_von='".$this->app->User->GetID()."' WHERE id='$id' LIMIT 1");
    header("Location: index.php?module=projekt&action=arbeitspaket&id=".$sid);
    exit;

  }
  
  function DeleteArbeitspaket($id)
  {
    $id = (int)$id;
    if(!$this->app->erp->RechteVorhanden('projekt','arbeitspaketdelete'))return false;
    $id = $this->app->DB->Select("SELECT id FROM arbeitspaket WHERE id = '$id' LIMIT 1");
    $sid = $this->app->DB->Select("SELECT projekt FROM arbeitspaket WHERE id='$id' LIMIT 1");
    if(!$id || !$sid)return false;
    $vorgaenger = (int)$this->app->DB->Select("SELECT vorgaenger FROM arbeitspaket WHERE id='$id' LIMIT 1");
    if($vorgaenger)$this->app->DB->Update("UPDATE arbeitspaket SET vorgaenger = '$vorgaenger' WHERE projekt = '$sid' AND vorgaenger = '$id'");
    $this->app->DB->Delete("DELETE FROM arbeitspaket WHERE id='$id' LIMIT 1");
    return true;
  }

  function ProjektArbeitspaketDelete()
  {
    //    $this->ArtikelMenu();
    $id = $this->app->Secure->GetGET("id");
    $sid = $this->app->DB->Select("SELECT projekt FROM arbeitspaket WHERE id='$id' LIMIT 1");
    $this->DeleteArbeitspaket($id);
    header("Location: index.php?module=projekt&action=arbeitspaket&id=".$sid);
    exit;
  }


  function ProjektArbeitspaketCopy()
  {
    $id = $this->app->Secure->GetGET("id");

    $id = $this->app->DB->MysqlCopyRow("arbeitspaket","id",$id);
    $this->app->DB->Update("UPDATE arbeitspaket SET geloescht='0', abgenommen='0', abgenommen_von='0', abgenommen_bemerkung='' WHERE id='$id' LIMIT 1");

    //$this->app->DB->Update("UPDATE einkaufspreise SET geloescht='1' WHERE id='$id' LIMIT 1");
    $sid = $this->app->DB->Select("SELECT projekt FROM arbeitspaket WHERE id='$id' LIMIT 1");
    header("Location: index.php?module=projekt&action=arbeitspaket&id=".$sid);
    exit;


  }


  function ProjektKalender()
  {
    $this->ProjektMenu();
    
    if($this->app->Secure->GetPOST('submitForm') == 1)
    {
      $id = (int)$this->app->Secure->GetGET("id");
      $eventid = $this->app->Secure->GetPOST("eventid");
      $titel = $this->app->Secure->GetPOST("titel");
      $datum = $this->app->Secure->GetPOST("datum");
      $datum_bis = $this->app->Secure->GetPOST("datum_bis");
      $allday = $this->app->Secure->GetPOST("allday");
      $public = $this->app->Secure->GetPOST("public");
      $erinnerung = $this->app->Secure->GetPOST("erinnerung");
      $von = $this->app->Secure->GetPOST("von");
      $bis = $this->app->Secure->GetPOST("bis");
      $beschreibung = $this->app->Secure->GetPOST("beschreibung");
      $ort = $this->app->Secure->GetPOST("ort");
      $adresse = $this->app->Secure->GetPOST("adresse");
      $adresseintern = $this->app->Secure->GetPOST("adresseintern");
      $projekt = $this->app->Secure->GetPOST("projekt");

      $personen = $this->app->Secure->GetPOST("personen");
      $color = $this->app->Secure->GetPOST("color");
      $mode = $this->app->Secure->GetPOST('mode');
      $von_datum =  $this->app->String->Convert("$datum $von", "%1.%2.%3 %4:%5", "%3-%2-%1 %4:%5");
      $bis_datum =  $this->app->String->Convert("$datum_bis $bis", "%1.%2.%3 %4:%5", "%3-%2-%1 %4:%5");

      if($allday=='1') {
        $von_datum = $this->app->String->Convert("$datum 00:00", "%1.%2.%3 %4:%5", "%3-%2-%1 %4:%5");
        $bis_datum = $this->app->String->Convert("$datum_bis 00:00", "%1.%2.%3 %4:%5", "%3-%2-%1 %4:%5");
        //$bis_datum = $datum_bis;
      }

      $adresse = trim($adresse);
      $rest = explode(" ",$adresse);
      $rest = $rest[0];
      $adresse =  $this->app->DB->Select("SELECT id FROM adresse WHERE id='$rest' AND geloescht=0 LIMIT 1");

      $adresseintern = trim($adresseintern);
      $rest = explode(" ",$adresseintern);
      $rest = $rest[0];
      $adresseintern =  $this->app->DB->Select("SELECT id FROM adresse WHERE id='$rest' AND geloescht=0 LIMIT 1");

      $projekt = trim($projekt);
      $projekt =  $this->app->DB->Select("SELECT id FROM projekt WHERE abkuerzung='$projekt' AND abkuerzung!='' LIMIT 1");
      if($mode=="new") {
        $this->app->DB->Insert("INSERT INTO kalender_event (ort,bezeichnung,beschreibung, von, bis, allDay, color, public,adresse,adresseintern,angelegtvon,erinnerung,projekt,typ)
            VALUES ('$ort','$titel', '$beschreibung','$von_datum', '$bis_datum', '$allday', '$color', '$public','$adresse','$adresseintern','".$this->app->User->GetAdresse()."','$erinnerung','$projekt','meilenstein')");
        $event = $this->app->DB->GetInsertID();
      }elseif($mode == "edit")
      {
        
        $check = $this->app->DB->Select("SELECT id FROM kalender_event WHERE  id='$eventid' AND projekt = '$id' AND typ = 'meilenstein' LIMIT 1");
        if($check)
        {
          $this->app->DB->Update("UPDATE kalender_event SET ort='$ort',bezeichnung='$titel', beschreibung='$beschreibung',von='$von_datum', bis='$bis_datum',
              allDay='$allday', color='$color', public='$public',adresse='$adresse',adresseintern='$adresseintern',erinnerung='$erinnerung' WHERE id='$eventid' LIMIT 1");
          $this->app->DB->Delete("DELETE FROM kalender_user WHERE event='$eventid'");
          $event = $eventid;
        }else{
          $mode = "";
        }
      }
      if(!in_array($this->app->User->GetID(),$personen))
      {
        $personen[]=$this->app->User->GetID();
      }

      // Schreibe Personen
      if(is_numeric($event) && is_array($personen) && count($personen) && $mode!="delete" && $mode != "") {
        for($p=0;$p<count($personen);$p++)
          $this->app->DB->Insert("INSERT INTO kalender_user (event, userid) VALUES ('$event', '{$personen[$p]}')");
      }
    }
    
    $cmd = $this->app->Secure->GetGET('cmd');
    if($cmd == 'getkalender')
    {
      $id = $this->app->Secure->GetGET('id');
      $data['write'] = 0;
      if(strpos($id, 'task'))
      {
        $id = (int)str_replace('task','',$id);
        $kalenderevent = $this->app->DB->SelectArr("SELECT id, ort, bezeichnung AS titel, beschreibung, von, bis, allDay, color, public,erinnerung,adresse,adresseintern,projekt, typ FROM kalender_event WHERE id='$id' LIMIT 1");
        if($kalenderevent)
        {
          $data = reset($kalenderevent);
          $data['write'] = 0;
          $data['projekt'] = $this->app->DB->Select("SELECT abkuerzung FROM projekt WHERE id = '".$data['projekt']."' LIMIT 1");
          if($data['typ'] == 'meilenstein')$data['write'] = 1;
          $personen = $this->app->DB->SelectArr("SELECT DISTINCT ku.userid, a.name FROM kalender_user AS ku
              LEFT JOIN user AS u ON u.id=ku.userid 
              LEFT JOIN adresse a ON a.id=u.adresse
              WHERE ku.event='$id' ORDER BY u.username ");
          $data['personen'] = $personen;
        }
      }
      echo json_encode($data);
      exit;
      
    }
    $user = $this->app->User->GetID();
    $users = $this->app->DB->SelectArr("SELECT u.id, a.name as description FROM user u LEFT JOIN adresse a ON a.id=u.adresse WHERE u.activ='1' AND u.kalender_ausblenden!=1 ORDER BY u.username");
    for($i=0; $i<count($users);$i++){
      $user_out .= "<option value=\"{$users[$i]['id']}\" $select>{$users[$i]['description']}</option>";
    }
    $this->app->Tpl->Set('PERSONEN', $user_out);


    $this->app->Tpl->Set('LINKADRESSE',"<a href=\"#\" onclick=\"splitstring = document.getElementById('adresse').value; felder = splitstring.split(' ', 3); if( felder[0] > 0) window.location.href='index.php?module=adresse&action=brief&id=' + felder[0];\" style=\"font-weight:normal;text-decoration:underline; position:absolute;margin-top:5px;margin-left:5px;\"><img src=\"themes/new/images/forward.png\"></a>");
    $id = (int)$this->app->Secure->GetGET("id");
    $this->app->Tpl->Set('PROJEKTNAME', $this->app->DB->Select("SELECT abkuerzung FROM projekt WHERE id = '$id' LIMIT 1"));
    //$this->app->Tpl->Set('COLORS', $this->ColorPicker());
    $this->app->YUI->ColorPicker("color");
    $this->app->YUI->AutoComplete("adresse","adresse");
    $this->app->YUI->AutoComplete("adresseintern","adresse");
    $this->app->YUI->AutoComplete("projekt","projektname",1);
    $this->app->YUI->DatePicker("datum");
    $this->app->YUI->DatePicker("datum_bis");
    $this->app->Tpl->Parse('TAB1',"projekt_dashboard_zeitplanung.tpl");
    $this->app->Tpl->Parse('PAGE',"tabview.tpl");
  }

  function ProjektTagebuch()
  {
    $this->ProjektMenu();

    $this->app->Tpl->Parse('PAGE',"projekt_tagebuch.tpl");
  }



  function ProjektEdit()
  {
    $this->ProjektMenu();
    $id = $this->app->Secure->GetGET("id");


    $this->app->Tpl->Set('TMPSCRIPT',"");


    $allowed = "/[^a-zA-Z0-9._-]/";      
    $this->app->Secure->POST["abkuerzung"] = preg_replace($allowed,"",$this->app->Secure->POST["abkuerzung"]); 
    $this->app->Secure->POST["abkuerzung"]=substr(strtoupper($this->app->Secure->POST["abkuerzung"]),0,20);


    $abkuerzung = $this->app->DB->Select("SELECT abkuerzung FROM projekt WHERE id='$id' LIMIT 1");
    if($abkuerzung=="")
    {
      $tmp_abkuerzung = $this->app->DB->Select("SELECT MAX(abkuerzung) FROM projekt");
      $tmp_abkuerzung = $this->app->erp->CalcNextNummer($tmp_abkuerzung);
      $this->app->DB->Update("UPDATE projekt SET abkuerzung='$tmp_abkuerzung' WHERE id='$id' LIMIT 1");
    } 


    parent::ProjektEdit();

    if($this->app->Secure->GetPOST("speichern")!="")
    {
      if($this->app->Secure->GetGET("msg")=="")
      {
        $msg = $msg.$this->app->Tpl->Get('MESSAGE');
        $msg = base64_encode($msg);
      } else {
        $msg = base64_encode($msg);
      }

      header("Location: index.php?module=projekt&action=edit&id=$id&msg=$msg");
      exit;
    }


  }


}
?>
