<?php
/*
**** COPYRIGHT & LICENSE NOTICE *** DO NOT REMOVE ****
* 
* WaWision (c) embedded projects GmbH, Holzbachstrasse 4, D-86154 Augsburg, * Germany 2015 
*
* This file is licensed under the Embedded Projects General Public License *Version 3.1. 
*
* You should have received a copy of this license from your vendor and/or *along with this file; If not, please visit www.wawision.de/Lizenzhinweis 
* to obtain the text of the corresponding license version.  
*
**** END OF COPYRIGHT & LICENSE NOTICE *** DO NOT REMOVE ****
*/
?>
<?php
include ("_gen/prozessstarter.php");

class Prozessstarter extends GenProzessstarter {
  var $app;
  
  function __construct(&$app) {
    //parent::GenProzessstarter($app);
    $this->app=&$app;

    $this->app->ActionHandlerInit($this);

    $this->app->ActionHandler("create","ProzessstarterCreate");
    $this->app->ActionHandler("edit","ProzessstarterEdit");
    $this->app->ActionHandler("list","ProzessstarterList");
    $this->app->ActionHandler("delete","ProzessstarterDelete");

    $this->app->ActionHandlerListen($app);

  }

  function ProzessstarterDelete()
  {
    $id = (int)$this->app->Secure->GetGET('id');
    if($id)$this->app->DB->Delete("DELETE FROM prozessstarter WHERE id = '$id' LIMIT 1");
    header('Location: index.php?module=prozessstarter&action=list');
    exit;
  }

  function ProzessstarterCreate()
  {
    $this->ProzessstarterMenu();
    parent::ProzessstarterCreate();
  }

  function ProzessstarterList()
  {
    $this->ProzessstarterMenu();
    $letzteraufruf = $this->app->erp->GetKonfiguration("prozessstarter_letzteraufruf");
    $diff = time() - strtotime($letzteraufruf);
    if($diff > 65) // mit sicherheitsabstand :-)
    {
      $this->app->Tpl->Set('MESSAGE','<div class="error">Es sieht so aus, als ob der Prozessstarter Cronjob nicht regelm&auml;&szlig;ig ausgef&uuml;hrt wird! Bitte aktivieren Sie diesen (<a href="http://helpdesk.wawision.de/doku.php?id=entwickler:grundinstallation#einrichten_des_heartbeat-cronjobs_optional" target="_blank">Link zu Helpdesk</a>)!</div>');
    }
    if($this->app->DB->Select("SELECT id FROM prozessstarter WHERE aktiv = 1 AND parameter = 'autoversand' LIMIT 1"))
    {
      $this->app->Tpl->Add('MESSAGE','<div class="warning">Der Prozess Autoversand kann eine hohe Serverlast verursachen. Es ist ratsam die Art auf Uhrzeit oder die Periode auf eine hohe Zahl zu stellen.</div>');
      
    }

    parent::ProzessstarterList();
  }

  function ProzessstarterMenu()
  {
    $id = $this->app->Secure->GetGET("id");
    $this->app->Tpl->Set('KURZUEBERSCHRIFT',"Prozessstarter");
    $this->app->erp->MenuEintrag("index.php?module=prozessstarter&action=list","&Uuml;bersicht");
    $this->app->erp->MenuEintrag("index.php?module=prozessstarter&action=create","Neu");
    if($this->app->Secure->GetGET("action")=="list")
    $this->app->erp->MenuEintrag("index.php?module=einstellungen&action=list","Zur&uuml;ck zur &Uuml;bersicht");
    else
    $this->app->erp->MenuEintrag("index.php?module=prozessstarter&action=list","Zur&uuml;ck zur &Uuml;bersicht");
  }


  function ProzessstarterEdit()
  {
    $this->ProzessstarterMenu();

    parent::ProzessstarterEdit();
  }





}

?>
