<?php
/*
**** COPYRIGHT & LICENSE NOTICE *** DO NOT REMOVE ****
* 
* WaWision (c) embedded projects GmbH, Holzbachstrasse 4, D-86154 Augsburg, * Germany 2015 
*
* This file is licensed under the Embedded Projects General Public License *Version 3.1. 
*
* You should have received a copy of this license from your vendor and/or *along with this file; If not, please visit www.wawision.de/Lizenzhinweis 
* to obtain the text of the corresponding license version.  
*
**** END OF COPYRIGHT & LICENSE NOTICE *** DO NOT REMOVE ****
*/
?>
<?php
class Steuersaetze {
  var $app;

  static function TableSearch(&$app, $name, $erlaubtevars)
  {
    // in dieses switch alle lokalen Tabellen (diese Live Tabellen mit Suche etc.) für dieses Modul
    switch($name)
    {
      case "steuersaetze_list":
      $allowed['steuersaetze'] = array('list');

      $heading = array('Steuersatz', 'Bezeichnung', 'Aktiv', 'Men&uuml;');
      $width = array('25%', '40%', '25%','10%');

      $findcols = array('s.satz', 's.bezeichnung', 's.aktiv','s.id');
      $searchsql = array('s.id', 's.satz', 's.bezeichnung', 's.aktiv');

      $defaultorder = 1;
      $defaultorderdesc = 0;

      $menu = '<table cellpadding="0" cellspacing="0">';
        $menu .= '<tr>';
          $menu .= '<td nowrap>';
            $menu .= '<a href="javascript:;" onclick="SteuersaetzeEdit(%value%);">';
              $menu .= '<img src="themes/' . $app->Conf->WFconf['defaulttheme'] . '/images/edit.png" border="0">';
            $menu .= '</a>&nbsp;';
            $menu .= '<a href="javascript:;" onclick="SteuersaetzeDelete(%value%);">';
              $menu .= '<img src="themes/' . $app->Conf->WFconf['defaulttheme'] . '/images/delete.gif" border="0">';
            $menu .= '</a>';
          $menu .= '</td>';
        $menu .= '</tr>';
      $menu .= '</table>';

      $where = " s.id > 0 ";

      $sql = "SELECT SQL_CALC_FOUND_ROWS s.id, s.satz, s.bezeichnung, if(s.aktiv=1,'ja','nein'), s.id FROM steuersaetze s";

      $count = "SELECT count(s.id) FROM steuersaetze s WHERE $where";
      break;

    }

    $erg = false;

    foreach($erlaubtevars as $k => $v)
    {
      if(isset($$v))$erg[$v] = $$v;
    }
    return $erg;
  }

  function __construct($app, $intern = false) {
    $this->app=&$app;
    if($intern)return;
    $this->app->ActionHandlerInit($this);

    // ab hier alle Action Handler definieren die das Modul hat
    $this->app->ActionHandler("list", "SteuersaetzeList");
    $this->app->ActionHandler("edit", "SteuersaetzeEdit");
    $this->app->ActionHandler("save", "SteuersaetzeSave");
    $this->app->ActionHandler("delete", "SteuersaetzeDelete");
    
    $this->app->ActionHandlerListen($app);

  }

  function SteuersaetzeMenu()
  {
    $this->app->erp->MenuEintrag("index.php?module=steuersaetze&action=list","Zur&uuml;ck zur &Uuml;bersicht");
  }

  function SteuersaetzeList()
  {
    $this->app->erp->MenuEintrag("index.php?module=steuersaetze&action=list","&Uuml;bersicht");

    $speichern = $this->app->Secure->GetPOST("Speichern");
    
    if($speichern != ""){
      $bearbeiter = $this->app->DB->real_escape_string($this->app->User->GetName());

      $satz_neu = $this->app->Secure->GetPOST("satz_neu");
      $satz_neu = (float)str_replace(',','.',$satz_neu);
      $bezeichnung_neu = $this->app->Secure->GetPOST("bezeichnung_neu");
      $aktiv_neu = $this->app->Secure->GetPOST("aktiv_neu");
      if($aktiv_neu != "1"){
        $aktiv_neu = 0;
      }

      $error = "";

      if($satz_neu == 0){
        $error .= "<li>Bitte Steuersatz eingeben</li>";
      }
      if(trim($bezeichnung_neu) == ""){
        $error .= "<li>Bitte Bezeichnung eingeben</li>";
      }              

      if($error == ""){
        $this->app->DB->Insert("INSERT INTO steuersaetze (satz, bezeichnung, aktiv, bearbeiter) VALUES ('$satz_neu', '$bezeichnung_neu', '$aktiv_neu','$bearbeiter')");
      }else{
        $this->app->Tpl->Add("MESSAGE", "<div class=\"error\"><ul>".$error."</ul></div>");
      }
      
    }  




    $this->app->YUI->TableSearch('TAB1','steuersaetze_list', "show","","",basename(__FILE__), __CLASS__);
    $this->app->Tpl->Parse("PAGE","steuersaetze_list.tpl");
  }

  function SteuersaetzeEdit()
  {
    if($this->app->Secure->GetGET('cmd')=='get'){
      //$this->app->erp->MenuEintrag("index.php?module=zeiterfassung_kosten&action=edit&id=".$adresse,"Details");
      $id = (int)$this->app->Secure->GetPOST('id');
            
      if($id > 0){
        $data = $this->app->DB->SelectArr("SELECT id, satz, bezeichnung, aktiv FROM steuersaetze WHERE id = \"$id\" LIMIT 1");
      }
      
      if($data){
        $data = reset($data);
      }
      echo json_encode($data);
      exit;
    }   


    $this->app->Tpl->Parse('PAGE', "steuersaetze_list.tpl");
    
  }

  function SteuersaetzeSave()
  {
    $id = (int)$this->app->Secure->GetPOST('id');
    $satz = $this->app->Secure->GetPOST('satz');
    $bezeichnung = $this->app->Secure->GetPOST('bezeichnung');
    $aktiv = $this->app->Secure->GetPOST('aktiv');
    $bearbeiter = $this->app->DB->real_escape_string($this->app->User->GetName());
    $satz = (float)str_replace(',','.',$satz);

    $id = $this->app->DB->Select("Select id FROM steuersaetze WHERE id = '$id' LIMIT 1");
    
    if($id &&  trim($bezeichnung) != "" && $satz != 0){
      $this->app->DB->Update("UPDATE steuersaetze SET satz = '$satz', bezeichnung = '$bezeichnung', aktiv = '$aktiv', bearbeiter = '$bearbeiter' WHERE id = '$id' LIMIT 1");
      echo json_encode(array('status'=>1));
      exit;            
    }
    if($satz <= 0)$fehler = 'Bitte einen positiven Steuersatz eingeben';
    
    echo json_encode(array('status'=>0,'statusText'=>$fehler));
    exit;  
  }

  function SteuersaetzeDelete()
  {
    $id = (int) $this->app->Secure->GetPOST('id');
    $this->app->DB->Delete("DELETE FROM steuersaetze WHERE id = '$id' LIMIT 1");
    
    echo json_encode(array('status'=>1));
    exit;    
  }



/*
  function LaenderDelete()
  {
    $ref = $_SERVER['HTTP_REFERER'];
    $id = $this->app->Secure->GetGET("id");
    $this->app->DB->DELETE("DELETE FROM laender WHERE id = '$id' LIMIT 1");

    //$this->VorlageList();
    header("Location: $ref");
    exit;
  }

  function LaenderCreate(){
    //		$this->app->Tpl->Add(KURZUEBERSCHRIFT,"Benutzer");
    $this->app->erp->MenuEintrag("index.php?module=steuersaetze&action=list","Zur&uuml;ck zur &Uuml;bersicht");

    $input = $this->GetInput();
    $submit = $this->app->Secure->GetPOST('submitland');

    if($submit!='') {

      $error = '';

      if($input['iso']=='' || strlen(trim($input['iso'])) > 2) $error .= 'Geben Sie bitte einen zweistelligen ISO-Code ein.<br>';
      if($input['bezeichnung_de']=='') $error .= 'Geben Sie bitte eine deutsche L&auml;nderbezeichnung ein.<br>';
      if($input['bezeichnung_en']=='') $error .= 'Geben Sie bitte eine englische L&auml;nderbezeichnung ein.<br>';

      if($this->app->DB->Select("SELECT '1' FROM laender WHERE iso='{$input['iso']}' LIMIT 1")=='1')
        $error .= "Es existiert bereits ein ISO-Code mit diesem Namen.<br />";

      if($error!=''){
        $this->app->Tpl->Set('MESSAGE', "<div class=\"error\">$error</div>");
      }else {
        $this->app->DB->Insert("INSERT INTO laender (iso, bezeichnung_de, bezeichnung_en, eu) VALUES ('{$input['iso']}', '{$input['bezeichnung_de']}', '{$input['bezeichnung_en']}', '{$input['eu']}')");
        $newid = $this->app->DB->GetInsertID();
        $msg = $this->app->erp->base64_url_encode("<div class=\"success\">Der L&auml;ndereintrag wurde erfolgreich angelegt.</div>");
        header("Location: index.php?module=laender&action=edit&id=$newid&msg=$msg");
        exit;
      }
    }

    $this->SetInput($input);

    $this->app->Tpl->Parse('PAGE', "laender_edit.tpl");
  }


  function GetInput(){
    $input = array();
    $input['iso'] = $this->app->Secure->GetPOST('iso');
    $input['bezeichnung_de'] = $this->app->Secure->GetPOST('bezeichnung_de');
    $input['bezeichnung_en'] = $this->app->Secure->GetPOST('bezeichnung_en');
    $input['eu'] = (int)$this->app->Secure->GetPOST('eu');
    return $input;

  }

  function SetInput($input){
    $this->app->Tpl->Set('ISO', $input['iso']);
    $this->app->Tpl->Set('BEZEICHNUNG_DE', $input['bezeichnung_de']);
    $this->app->Tpl->Set('BEZEICHNUNG_EN', $input['bezeichnung_en']);
    if($input['eu']==1){
      $this->app->Tpl->Set('EU', "checked");
    }


  }
  */

}
