<?php
/*
**** COPYRIGHT & LICENSE NOTICE *** DO NOT REMOVE ****
* 
* WaWision (c) embedded projects GmbH, Holzbachstrasse 4, D-86154 Augsburg, * Germany 2015 
*
* This file is licensed under the Embedded Projects General Public License *Version 3.1. 
*
* You should have received a copy of this license from your vendor and/or *along with this file; If not, please visit www.wawision.de/Lizenzhinweis 
* to obtain the text of the corresponding license version.  
*
**** END OF COPYRIGHT & LICENSE NOTICE *** DO NOT REMOVE ****
*/
?>
<?php

class Versandarten {
  var $app;

  static function TableSearch(&$app, $name, $erlaubtevars)
  {
    // in dieses switch alle lokalen Tabellen (diese Live Tabellen mit Suche etc.) für dieses Modul
    switch($name)
    {
      case "versandarten_list":
      $allowed['versandarten'] = array('list');

      $heading = array('Bezeichnung', 'Typ','Modul', 'Projekt', 'Men&uuml;');
      $width = array('39%', '20%', '20%','20%','5%');

      $findcols = array('v.bezeichnung', 'v.type','v.modul', 'v.projekt','v.id');
      $searchsql = array('v.bezeichnung', 'v.type','v.modul', 'v.projekt');

      $defaultorder = 1;
      $defaultorderdesc = 0;

      $menu = "<table cellpadding=0 cellspacing=0><tr><td nowrap><a href=\"index.php?module=versandarten&action=edit&id=%value%\"><img src=\"themes/{$app->Conf->WFconf['defaulttheme']}/images/edit.png\" border=\"0\"></a>&nbsp;<a href=\"index.php?module=versandarten&action=copy&id=%value%\"><img src=\"themes/{$app->Conf->WFconf['defaulttheme']}/images/copy.png\" border=\"0\"></a>&nbsp;<a href=\"#\" onclick=DeleteDialog(\"index.php?module=versandarten&action=delete&id=%value%\")><img src=\"themes/{$app->Conf->WFconf['defaulttheme']}/images/delete.gif\" border=\"0\"></a></td></tr></table>";

      $where = " v.id > 0 ";

      $sql = "SELECT SQL_CALC_FOUND_ROWS v.id, if(v.aktiv, v.bezeichnung, CONCAT('<s>',v.bezeichnung,'</s>')), 
        if(v.aktiv, v.type, CONCAT('<s>',v.type,'</s>')), 
        if(v.aktiv, v.modul, CONCAT('<s>',v.modul,'</s>')), 
        if(v.projekt, (SELECT abkuerzung FROM projekt WHERE id = v.projekt), ''), v.id FROM versandarten v";

      $count = "SELECT count(v.id) FROM versandarten v WHERE $where";
      break;

    }

    $erg = false;

    foreach($erlaubtevars as $k => $v)
    {
      if(isset($$v))$erg[$v] = $$v;
    }
    return $erg;
  }

  function __construct($app, $intern = false) {
    $this->app=&$app;
    if($intern)return;
    $this->app->ActionHandlerInit($this);

    // ab hier alle Action Handler definieren die das Modul hat
    $this->app->ActionHandler("create", "VersandartenCreate");
    $this->app->ActionHandler("edit", "VersandartenEdit");
    $this->app->ActionHandler("list", "VersandartenList");
    $this->app->ActionHandler("delete", "VersandartenDelete");
    $this->app->ActionHandler("copy", "VersandartenCopy");

    $this->app->ActionHandlerListen($app);

  }

  function VersandartenCopy()
  {
    $id = (int)$this->app->Secure->GetGET('id');
    $id = $this->app->DB->Select("SELECT id FROM versandarten WHERE id = '$id' LIMIT 1");
    if(!$id)
    {
      header('Location: index.php?module=versandarten&action=list');
      exit;
    }
    $newid = $this->app->DB->MysqlCopyRow('versandarten', 'id', $id);
    if($newid)$this->app->DB->Update("UPDATE versandarten set aktiv = 0 WHERE id = '$newid' LIMIT 1");
    header('Location: index.php?module=versandarten&action=edit&id='.$newid);
    exit;  
  }
  function VersandartenMenu()
  {
    
  }

  function VersandartenList()
  {
    $this->app->erp->MenuEintrag("index.php?module=versandarten&action=create","Neue Versandart anlegen");
    $this->app->erp->MenuEintrag("index.php?module=versandarten&action=list","&Uuml;bersicht");
    $this->app->erp->MenuEintrag("index.php?module=einstellungen&action=list","Zur&uuml;ck zur &Uuml;bersicht");

   

    $this->app->YUI->TableSearch('TAB1','versandarten_list', "show","","",basename(__FILE__), __CLASS__);
    $this->app->Tpl->Parse("PAGE","versandarten_list.tpl");
  }
  
  function VersandartenSelModul($value)
  {
    $ret = '<option value=""></option>';
    $pfad = dirname(__FILE__).'/../lib/versandarten';
    if(is_dir($pfad))
    {
      $handle = opendir($pfad);
      if($handle)
      {
        while($file = readdir($handle))
        {
          if($file{0} != '.' && substr($file,-4) == '.php' && is_file($pfad.'/'.$file))
          {
            $modul = str_replace('.php','',$file);
            $ret .= '<option value="'.$modul.'"'.($value == $modul?' selected="selected" ':'').'>'.ucfirst($modul).'</option>';
          }
        }
        closedir($handle);
      }
    }
    return $ret;
  }

  function VersandartenEdit()
  {
    $id = (int)$this->app->Secure->GetGET('id');
    $speichern = $this->app->Secure->GetPOST('speichern');
    $daten = $this->app->DB->SelectArr("SELECT * FROM versandarten WHERE id = '$id' LIMIT 1");
    if($daten)$daten = reset($daten);

    $this->app->erp->MenuEintrag("index.php?module=versandarten&action=edit&id=$id","Details");
    $this->app->erp->MenuEintrag("index.php?module=versandarten&action=list","Zur&uuml;ck zur &Uuml;bersicht");

    $input = array();

    $input = $this->GetInput();

    $error = "";
    if(is_numeric($id) && $speichern != ""){

      if($id)
      {
      $error = "";
      if(trim($input['bezeichnung']) == "") $error = "Bitte alle Pflichtfelder ausfüllen!";
      if(trim($input['typ']) == "") $error = "Bitte alle Pflichtfelder ausfüllen!";

      if($error != ""){
        $this->app->Tpl->Set('MESSAGE', "<div class\"error\">$error</div>");
      }else{
        if($error == ""){
      
          $projektid = $this->app->DB->Select("SELECT id FROM projekt WHERE abkuerzung = '{$input['projekt']}' LIMIT 1");

          $this->app->DB->Update("UPDATE versandarten SET bezeichnung='{$input['bezeichnung']}', type ='{$input['typ']}', projekt=\"$projektid\", aktiv='{$input['aktiv']}', modul='{$input['selmodul']}',export_drucker = '{$input['export_drucker']}', paketmarke_drucker = '{$input['paketmarke_drucker']}', ausprojekt = '{$input['ausprojekt']}', versandmail = '{$input['versandmail']}',geschaeftsbrief_vorlage = '{$input['geschaeftsbrief_vorlage']}' WHERE id = '$id' LIMIT 1");
          if($input['aktiv'] == 1){
            $this->app->Tpl->Set('AKTIV', "checked");
          }
          $this->app->Tpl->Set('MESSAGE', "<div class=\"success\">Die Daten wurden erfolgreich gespeichert!</div>");
        }
      }
      }else{
        $error = '';

        if(trim($input['bezeichnung']) == "") 
        {
          $error = "Bitte alle Pflichtfelder ausfüllen!";
          $this->app->Tpl->Set('MSGBEZEICHNUNG',' <span style="color:red">Pflichtfeld!</span>');
        }
        if(trim($input['typ']) == "") 
        {
          $error = "Bitte alle Pflichtfelder ausfüllen!";
          $this->app->Tpl->Set('MSGTYP',' <span style="color:red">Pflichtfeld!</span>');
        }

        if($error!=''){
          $this->app->Tpl->Set('MESSAGE', "<div class=\"error\">$error</div>");
        }else {

          if(trim($input['projekt']) == ""){
            $projektid = 0;
          }else{
            $projektid = $this->app->DB->Select("SELECT id FROM projekt WHERE abkuerzung = '{$input['projekt']}' LIMIT 1");
          }  

          $this->app->DB->Insert("INSERT INTO versandarten (bezeichnung, type, projekt, aktiv, modul,export_drucker,paketmarke_drucker,ausprojekt,versandmail, geschaeftsbrief_vorlage) VALUES ('{$input['bezeichnung']}', '{$input['typ']}', \"$projektid\", '{$input['aktiv']}','{$input['selmodul']}','{$input['export_drucker']}','{$input['paketmarke_drucker']}','{$input['ausprojekt']}','{$input['versandmail']}','{$input['geschaeftsbrief_vorlage']}')");
         

          $newid = $this->app->DB->GetInsertID();
          $msg = $this->app->erp->base64_url_encode("<div class=\"success\">Die Daten wurden erfolgreich gespeichert!</div>");
          header("Location: index.php?module=versandarten&action=edit&id=$newid&msg=$msg");
          exit;
        }
        
      }      
    }
    $ausprojekt = 0;
    $daten = $this->app->DB->SelectArr("SELECT * FROM versandarten WHERE id = '$id' LIMIT 1");
    if($daten)$daten = reset($daten);
    if($daten)
    {
      $pfad = dirname(__FILE__).'/../lib/versandarten/'.$daten['modul'].'.php';
      if($daten['modul'] && is_file($pfad))
      {
        include_once($pfad);
        $classname = 'Versandart_'.$daten['modul'];
        if(class_exists($classname))
        {
          $obj = new $classname($this->app, $daten['id']);
        }
      }
      $bezeichnung = $daten['bezeichnung'];
      $typ = $daten['type'];
      $projekt = $daten['projekt'];
      $aktiv = $daten['aktiv'];
      $ausprojekt = $daten['ausprojekt'];
      $projektname = $this->app->DB->Select("SELECT abkuerzung FROM projekt WHERE id = '$projekt'");
      if(isset($obj) && method_exists($obj, 'Einstellungen'))$obj->Einstellungen('JSON');
    }

    $drucker_export = $this->app->erp->GetDrucker();
    $this->app->Tpl->Set('EXPORT_DRUCKER','<option value="0"></option>');
    if($drucker_export)
    {
      foreach($drucker_export as  $k => $v)
      {
        $this->app->Tpl->Add('EXPORT_DRUCKER','<option value="'.$k.'"'.($k == (isset($daten['export_drucker'])?$daten['export_drucker']:'')?' selected="selected" ':'').'>'.$v.'</option>');
      }
    }

    $drucker_paketmarke = $this->app->erp->GetDrucker();
    $this->app->Tpl->Set('PAKETMARKE_DRUCKER','<option value="0"></option>');
    if($drucker_paketmarke)
    {
      foreach($drucker_paketmarke as  $k => $v)
      {
        $this->app->Tpl->Add('PAKETMARKE_DRUCKER','<option value="'.$k.'"'.($k == (isset($daten['paketmarke_drucker'])?$daten['paketmarke_drucker']:'')?' selected="selected" ':'').'>'.$v.'</option>');
      }
    }
    $this->app->YUI->HideFormular('versandmail', array('0'=>'versandbetreff','1'=>'dummy'));
    $this->app->Tpl->Add('SELVERSANDMAIL','<option value="0">Standardverhalten</option>');
    $this->app->Tpl->Add('SELVERSANDMAIL','<option value="-1"'.(isset($daten['versandmail']) && $daten['versandmail'] == -1?' selected="selected"':'').'>Keine Versandmail</option>');
    $this->app->Tpl->Add('SELVERSANDMAIL','<option value="1"'.(isset($daten['versandmail']) && $daten['versandmail'] == 1?' selected="selected"':'').'>Eigene Textvorlage</option>');
    
    $geschaeftsbrief_vorlagen = $this->app->DB->SelectArr("SELECT gv.id, gv.subjekt, p.abkuerzung FROM geschaeftsbrief_vorlagen gv LEFT JOIN projekt p ON gv.projekt = p.id ORDER by gv.subjekt");
    if($geschaeftsbrief_vorlagen)
    {
      foreach($geschaeftsbrief_vorlagen as $k => $v)
      {
        $this->app->Tpl->Add('SELGESCHAEFTSBRIEF_VORLAGE','<option value="'.$v['id'].'"'.($v['id'] == (isset($daten['geschaeftsbrief_vorlage'])?$daten['geschaeftsbrief_vorlage']:'')?' selected="selected" ':'').'>'.$v['subjekt'].($v['abkuerzung']?' - '.$v['abkuerzung']:'').'</option>');
      }
    }
    
    $this->app->Tpl->Set('SELMODUL',$this->VersandartenSelModul($error == ''?isset($daten['modul'])?$daten['modul']:'':$input['selmodul']));

    $this->app->Tpl->Set('BEZEICHNUNG', $error == ''?$bezeichnung:$input['bezeichnung']);
    $this->app->Tpl->Set('TYP', $error == ''?$typ:$input['typ']);
    $this->app->Tpl->Set('PROJEKT', $error == ''?$projektname:$input['projekt']);
    if(($error == '' && $aktiv == 1) || ($error != '' && $input['aktiv'])){
      $this->app->Tpl->Set('AKTIV', "checked");
    }
    if(($error == '' && $ausprojekt == 1) ||  ($error != '' && $input['ausprojekt'])){
      $this->app->Tpl->Set('AUSPROJEKT', "checked");
    }
    $this->app->YUI->AutoComplete("projekt", "projektname", 1);
    $this->app->Tpl->Parse('PAGE', "versandarten_edit.tpl");



    
  }

  function VersandartenDelete()
  {
    $ref = $_SERVER['HTTP_REFERER'];
    $id = $this->app->Secure->GetGET("id");
    $this->app->DB->DELETE("DELETE FROM versandarten WHERE id = '$id' LIMIT 1");


    //$this->VorlageList();
    //header("Location: $ref");

    $msg = $this->app->erp->base64_url_encode("<div class=\"success\">Die Versandart wurde gelöscht!</div>");
    header("Location: index.php?module=versandarten&action=list&msg=$msg");

    exit;
  }

  function VersandartenCreate(){
    $this->VersandartenEdit();
    return;
    //    $this->app->Tpl->Add(KURZUEBERSCHRIFT,"Benutzer");
    $this->app->erp->MenuEintrag("index.php?module=versandarten&action=list","Zur&uuml;ck zur &Uuml;bersicht");

    $input = $this->GetInput();
    $speichern = $this->app->Secure->GetPOST('speichern');

    if($speichern != '') {

      $error = '';

      if(trim($input['bezeichnung']) == "") $error = "Bitte alle Pflichtfelder ausfüllen!";
      if(trim($input['typ']) == "") $error = "Bitte alle Pflichtfelder ausfüllen!";

      if($error!=''){
        $this->app->Tpl->Set('MESSAGE', "<div class=\"error\">$error</div>");
      }else {

        if(trim($input['projekt']) == ""){
          $projektid = 0;
        }else{
          $projektid = $this->app->DB->Select("SELECT id FROM projekt WHERE abkuerzung = '{$input['projekt']}' LIMIT 1");
        }  

        $this->app->DB->Insert("INSERT INTO versandarten (bezeichnung, type, projekt, aktiv) VALUES ('{$input['bezeichnung']}', '{$input['typ']}', \"$projektid\", '{$input['aktiv']}')");
       

        $newid = $this->app->DB->GetInsertID();
        $msg = $this->app->erp->base64_url_encode("<div class=\"success\">Die Daten wurden erfolgreich gespeichert!</div>");
        header("Location: index.php?module=versandarten&action=edit&id=$newid&msg=$msg");
        exit;
      }
    }

    $this->SetInput($input);
    $this->app->YUI->AutoComplete("projekt", "projektname",1);
    $this->app->Tpl->Parse('PAGE', "versandarten_edit.tpl");
  }


  function GetInput(){
    $input = array();
    $input['bezeichnung'] = $this->app->Secure->GetPOST('bezeichnung');
    $input['typ'] = $this->app->Secure->GetPOST('typ');
    $input['projekt'] = $this->app->Secure->GetPOST('projekt');
    $input['selmodul'] = $this->app->Secure->GetPOST('selmodul');
    $input['aktiv'] = (int)$this->app->Secure->GetPOST('aktiv');
    $input['ausprojekt'] = (int)$this->app->Secure->GetPOST('ausprojekt');
    $input['export_drucker'] = (int)$this->app->Secure->GetPOST('export_drucker');
    $input['paketmarke_drucker'] = (int)$this->app->Secure->GetPOST('paketmarke_drucker');
    $input['geschaeftsbrief_vorlage'] = (int)$this->app->Secure->GetPOST('geschaeftsbrief_vorlage');
    $input['versandmail'] = (int)$this->app->Secure->GetPOST('versandmail');
    return $input;

  }

  function SetInput($input){
    $this->app->Tpl->Set('BEZEICHNUNG', $input['bezeichnung']);
    $this->app->Tpl->Set('TYP', $input['typ']);
    $this->app->Tpl->Set('PROJEKT', $input['projekt']);
    if($input['aktiv']==1){
      $this->app->Tpl->Set('AKTIV', "checked");
    }
    if($input['ausprojekt']==1){
      $this->app->Tpl->Set('AUSPROJEKT', "checked");
    }


  }

}
