<?php
/*
**** COPYRIGHT & LICENSE NOTICE *** DO NOT REMOVE ****
* 
* WaWision (c) embedded projects GmbH, Holzbachstrasse 4, D-86154 Augsburg, * Germany 2015 
*
* This file is licensed under the Embedded Projects General Public License *Version 3.1. 
*
* You should have received a copy of this license from your vendor and/or *along with this file; If not, please visit www.wawision.de/Lizenzhinweis 
* to obtain the text of the corresponding license version.  
*
**** END OF COPYRIGHT & LICENSE NOTICE *** DO NOT REMOVE ****
*/
?>
<?php
class Api {
  var $app;
  var $api_id;
  function __construct(&$app, $intern = false) {
    $this->app=&$app;
    $this->api_id = 0;
    if($intern)return;
    $this->app->ActionHandlerInit($this);

    // eine alte Funktion
    $this->app->ActionHandler("shopimages","ApiShopimages");
    $this->app->ActionHandler("AdresseCreate","ApiAdresseCreate");
    $this->app->ActionHandler("AdresseEdit","ApiAdresseEdit");
    $this->app->ActionHandler("AdresseGet","ApiAdresseGet");

    $this->app->ActionHandler("AuftragCreate","ApiAuftragCreate");
    $this->app->ActionHandler("AuftragEdit","ApiAuftragEdit");
    $this->app->ActionHandler("AuftragGet","ApiAuftragGet");

    $this->app->ActionHandler("ArtikelCreate","ApiArtikelCreate");
    $this->app->ActionHandler("ArtikelEdit","ApiArtikelEdit");
    $this->app->ActionHandler("ArtikelGet","ApiArtikelGet");

    $this->app->ActionHandler("BenutzerCreate","ApiBenutzerCreate");
    $this->app->ActionHandler("BenutzerEdit","ApiBenutzerEdit");
    $this->app->ActionHandler("BenutzerGet","ApiBenutzerGet");

    $this->app->ActionHandler("SessionStart","ApiSessionStart");
    $this->app->ActionHandler("SessionClose","ApiSessionClose");

    $this->app->ActionHandler("AdresseKontaktCreate","ApiAdresseKontaktCreate");
    $this->app->ActionHandler("AdresseKontaktEdit","ApiAdresseKontaktEdit");
    $this->app->ActionHandler("AdresseKontaktGet","ApiAdresseKontaktGet");
    $this->app->ActionHandler("AdresseKontaktList","ApiAdresseKontaktList");
    
    $this->app->ActionHandler("AdresseListeGet","ApiAdresseListeGet");

    $this->app->ActionHandler("GruppeCreate","ApiGruppeCreate");
    $this->app->ActionHandler("GruppeEdit","ApiGruppeEdit");
    $this->app->ActionHandler("GruppeGet","ApiGruppeGet");
    
    $this->app->ActionHandler("GruppenList","ApiGruppenList");

    $this->app->ActionHandler("PreiseEdit","ApiPreiseEdit");

    $this->app->ActionHandler("ExportVorlageGet","ApiExportVorlageGet");
    $this->app->ActionHandler("AdresseAccountsGet","ApiAdresseAccountsGet");
    $this->app->ActionHandler("ArtikelkontingenteGet","ApiArtikelkontingenteGet");
    
    $this->app->ActionHandler("MappingGet","ApiMappingGet");
    $this->app->ActionHandler("MappingSet","ApiMappingSet");

    $this->app->ActionHandler("BelegeList","ApiBelegeList");
    $this->app->ActionHandler("ArtikelkategorienList","ApiArtikelkategorienList");
    
    $this->app->ActionHandler("AccountList", "ApiAccountList");
    $this->app->ActionHandler("AdresseGruppenList", "ApiAdresseGruppenList");
    $this->app->ActionHandler("AccountLogin", "ApiAccountLogin");
    
    $this->app->ActionHandler("DateiList", "ApiDateiList");
    $this->app->ActionHandler("DateiVorschau", "ApiDateiVorschau");
    $this->app->ActionHandler("DateiDownload", "ApiDateiDownload");
    $this->app->ActionHandler("DateiHeader", "ApiDateiHeader");
    
    
    
    $action = $this->app->Secure->GetGET("action"); 


    //$this->app->DefaultActionHandler("list");
    $this->CheckHash();

    $this->app->ActionHandlerListen($app);
  }
  
  function ApiArtikelkategorienList()
  {
    $xml = $this->XMLPost();
    $api_id = isset($this->api_id)?$this->api_id:0;
    $exakt = 0;
    if(isset($xml['ID']))$xml['id'] = $xml['ID'];
    if(isset($xml['ID_EXT']))$xml['id_ext'] = $xml['ID_EXT'];
    if(isset($xml['BEZEICHNUNG']))$xml['bezeichnung'] = $xml['BEZEICHNUNG'];
    if(isset($xml['EXAKT']))$xml['exakt'] = $xml['EXAKT'];
    
    $where = '';
    if($xml['id'])$where .= " AND ak.id = '".(int)$xml['id']."' ";
    if($xml['id_ext'])$where .= " AND am.id_ext = '".$this->app->DB->real_escape_string($xml['id_ext'])."' ";
    if($xml['bezeichnung'])
    {
      if($xml['exakt'] && $xml['exakt'] == 1)
      {
        $where .= " AND ak.bezeichnung like '".$this->app->DB->real_escape_string(base64_decode($xml['bezeichnung']))."' ";
      }else{
        $where .= " AND ak.bezeichnung like '%".$this->app->DB->real_escape_string(base64_decode($xml['bezeichnung']))."%' ";
      }
    }
    
    $kategorien = $this->app->DB->SelectArr("SELECT ak.*, am.id_ext FROM artikelkategorien ak LEFT JOIN api_mapping am ON am.id_int = ak.id AND am.tabelle = 'artikelkategorien' WHERE geloescht <> 1 $where ORDER BY parent, bezeichnung");    
    if($kategorien)
    {
      $out = '<artikelkategorien>';
      foreach($kategorien as $kategorie)
      {
        $out .= '<kategorie>';
        foreach($kategorie as $k => $v)$out .= '<'.$k.'>'.htmlspecialchars($v).'</'.$k.'>';
        $out .= '</kategorie>';
      }
      $out .= '</artikelkategorien>';
      $this->XMLResponse(1, $out);
      exit;
    }else{
      $this->XMLResponse(8);
      exit;
    }
  }
  
  function ApiDateiHeader()
  {
    $id = (int)$this->app->Secure->GetGET('id');
    if($id)
    {
      $datei = $this->app->DB->SelectArr("SELECT dv.id, ds.parameter FROM datei_version dv INNER JOIN datei_stichwoerter ds ON ds.datei = dv.datei WHERE dv.datei = '$id' ORDER BY  dv.datei DESC, dv.version DESC LIMIT 1");    
      if($datei)
      {
        $version = $this->app->DB->Select("SELECT MAX(version) FROM datei_version WHERE datei='$id'");
        $newid = $this->app->DB->Select("SELECT id FROM datei_version WHERE datei='$id' AND version='$version' LIMIT 1");

        if($versionid>0)
          $newid = $versionid;

        $name = $this->app->DB->Select("SELECT dateiname FROM datei_version WHERE id='$newid' LIMIT 1");
        if(isset($this->app->Conf->WFuserdata))
        {
          $path = $this->app->Conf->WFuserdata.'/dms/'.$this->app->Conf->WFdbname."/".$newid;
        }else
        $path = dirname(__FILE__)."/../../userdata/dms/".$this->app->Conf->WFdbname."/".$newid;
        //$name=basename($path);

        //filenames in IE containing dots will screw up the
        //filename unless we add this

        if (strstr($_SERVER['HTTP_USER_AGENT'], "MSIE"))
          $name = preg_replace('/\./', '%2e', $name, substr_count($name, '.') - 1);

        $contenttype= $this->app->erp->content_type($name);
        //required, or it might try to send the serving     //document instead of the file
        $res = "Content-Type: $contenttype\n";
        $res .= "Content-Length: " .(string)(filesize($path))."\n" ;
        $name = $this->app->erp->Dateinamen($name);
        $res .= 'Content-Disposition: attachment; filename="'.$name.'"';
        echo $res;
        exit;
      }
    }
    exit;    
  }
  
  function ApiDateiDownload()
  {
    $id = (int)$this->app->Secure->GetGET('id');
    if($id)
    {
      $datei = $this->app->DB->SelectArr("SELECT dv.id, ds.parameter FROM datei_version dv INNER JOIN datei_stichwoerter ds ON ds.datei = dv.datei WHERE dv.datei = '$id' ORDER BY  dv.datei DESC, dv.version DESC LIMIT 1");
      if($datei)$this->app->erp->SendDatei($id);
      exit;
      
    }
    exit;
  }
  
  function ApiDateiVorschau()
  {
    //$xml = $this->XMLPost();
    $datei = $this->app->Secure->GetGET('id');
    $id = (int)$datei;
    if($id)
    {
      $datei = $this->app->DB->SelectArr("SELECT dv.id, ds.parameter FROM datei_version dv INNER JOIN datei_stichwoerter ds ON ds.datei = dv.datei WHERE dv.datei = '$id'  ORDER BY  dv.datei DESC, dv.version DESC LIMIT 1");
      if(!$datei)
      {
        if ($this->app->erp->Firmendaten('iconset_dunkel')) {
          $str = file_get_contents(dirname(__FILE__) . '/../themes/new/images/keinbild_dunkel.png');
        } else {
          $str = file_get_contents(dirname(__FILE__) . '/../themes/new/images/keinbild_hell.png');
        }
        header('Content-type: image/png');
        echo $str;
        exit;
      }
      if($datei[0]['parameter'])
      {
        if($cmd == 'projekt')
        {
          if(!$this->app->erp->UserProjektRecht($datei[0]['parameter']))
          {
            if ($this->app->erp->Firmendaten('iconset_dunkel')) {
              $str = file_get_contents(dirname(__FILE__) . '/../themes/new/images/keinbild_dunkel.png');
            } else {
              $str = file_get_contents(dirname(__FILE__) . '/../themes/new/images/keinbild_hell.png');
            }
            header('Content-type: image/png');
            echo $str;
            exit;
          }
        }else{
          $projekt = $this->app->DB->Select("SELECT projekt FROM $cmd WHERE id = '".$datei[0]['parameter']."' LIMIT 1");
          if(!$this->app->erp->UserProjektRecht($projekt))
          {
            if ($this->app->erp->Firmendaten('iconset_dunkel')) {
              $str = file_get_contents(dirname(__FILE__) . '/../themes/new/images/keinbild_dunkel.png');
            } else {
              $str = file_get_contents(dirname(__FILE__) . '/../themes/new/images/keinbild_hell.png');
            }
            header('Content-type: image/png');
            echo $str;
            exit;
          }
        }
      }
      //Rechte prüfen
      
      $userdata = isset($this->app->Conf->WFuserdata)?$this->app->Conf->WFuserdata:str_replace("index.php", "", $_SERVER['SCRIPT_FILENAME'])."../userdata";
      $path = $userdata."/dms/".$this->app->Conf->WFdbname;
      $cachefolder = $path.'/cache';
      if(!file_exists($cachefolder.'/'.$datei[0]['id'].'_100_100'))
      {
        if(file_exists($path.'/'.$datei[0]['id']))
        {
          $type = mime_content_type($path.'/'.$datei[0]['id']);
          switch($type)
          {
            case 'image/jpg':
            case 'image/jpeg':
              $img = new image($this->app);
              $str = $img->scaledPicByFileId($datei[0]['id'], 100, 100);
              header('Content-type: image/jpg');
              echo $str;
              exit;
            break;
            case 'image/png':
              $img = new image($this->app);
              $str = $img->scaledPicByFileId($datei[0]['id'], 100, 100);
              header('Content-type: image/png');
              echo $str;
              exit;
            break;
            case 'image/gif':
              $img = new image($this->app);
              $str = $img->scaledPicByFileId($datei[0]['id'], 100, 100);
              header('Content-type: image/gif');
              echo $str;
              exit;
            break;
            case 'application/pdf':
              $str = file_get_contents(dirname(__FILE__) . '/../themes/new/images/pdf.png');
              header('Content-type: image/png');
              echo $str;
              exit;
            break;
          }
        }
      }
      
      if(file_exists($cachefolder.'/'.$datei[0]['id'].'_100_100'))
      {
        $type = mime_content_type($path.'/'.$datei[0]['id']);
        if(strpos($type,'image') !== false)
        {
          header('Content-type: '.$type);
          $str = file_get_contents($cachefolder.'/'.$datei[0]['id'].'_100_100');
          echo $str;
          exit;
        }
      }else{
        if ($this->app->erp->Firmendaten('iconset_dunkel')) {
          $str = file_get_contents(dirname(__FILE__) . '/../themes/new/images/keinbild_dunkel.png');
        } else {
          $str = file_get_contents(dirname(__FILE__) . '/../themes/new/images/keinbild_hell.png');
        }
        header('Content-type: image/png');
        echo $str;
        exit;
      }
    }else{
      if ($this->app->erp->Firmendaten('iconset_dunkel')) {
        $str = file_get_contents(dirname(__FILE__) . '/../themes/new/images/keinbild_dunkel.png');
      } else {
        $str = file_get_contents(dirname(__FILE__) . '/../themes/new/images/keinbild_hell.png');
      }
      header('Content-type: image/png');
      echo $str;
    }
    exit;
    
    
  }
  
  function ApiDateiList()
  {
    $xml = $this->XMLPost();
    $parameter = $xml['parameter'];
    $objekt = $xml['objekt'];
    $dateiliste = $this->app->DB->SelectArr( "SELECT d.titel, s.subjekt, v.version, v.ersteller, v.bemerkung, v.datum, d.id FROM 
    datei d LEFT JOIN datei_stichwoerter s ON d.id=s.datei LEFT JOIN datei_version v ON v.datei=d.id WHERE s.objekt LIKE '$objekt' AND s.parameter='$parameter' AND d.geloescht=0");

    if($dateiliste)
    {
      $xml = $this->CreateXmlObj();        
      foreach($dateiliste as $k => $datei)
      {
        $_datei = $xml->AddChild('Datei','');
        foreach($datei as $k => $row)$_datei->AddChild($k ,$row);
      }
      $out = str_replace(array('<?xml version="1.0" standalone="yes"?>','<?xml version="1.0" encoding="UTF-8"?>',"<response>",'</response>'),array('','','',''),$xml->asXML());
      $this->XMLResponse(1, $out);        
      exit; 
    }
    $this->XMLResponse(8);
    exit;
  }
  
  function ApiAccountLogin()
  {
    $xml = $this->XMLPost();
    $user = $xml['user'];
    $md5passwort = !empty($xml['md5passwort'])?$xml['md5passwort']:md5($xml['passwort']);
    
    $art = $xml['art'];
    if(!empty($user) && !empty($md5passwort) && !empty($art))
    {
      $acc = $this->app->DB->SelectArr("SELECT adr.*, aa.benutzername FROM adresse_accounts aa INNER JOIN adresse adr ON aa.adresse = adr.id WHERE adr.geloescht <> 1 AND aa.art = '".$this->app->DB->real_escape_string($art)."' AND aa.aktiv = 1 AND (aa.gueltig_bis = '0000-00-00' OR aa.gueltig_bis >= curdate() or isnull(aa.gueltig_bis)) AND (aa.gueltig_ab = '0000-00-00' OR isnull(gueltig_ab) OR gueltig_ab <= curdate()) AND aa.benutzername = '".$this->app->DB->real_escape_string($user)."' AND md5(aa.passwort) = '".$this->app->DB->real_escape_string($md5passwort)."' AND aa.art = '".$this->app->DB->real_escape_string($art)."' LIMIT 1");
      if($acc)
      {
        $xml = $this->CreateXmlObj();        
        $xml->AddChild('name', $acc[0]['name']);
        $xml->AddChild('adresse', $acc[0]['id']);
        $xml->AddChild('benutzername', $acc[0]['benutzername']);
        $out = str_replace(array('<?xml version="1.0" standalone="yes"?>','<?xml version="1.0" encoding="UTF-8"?>',"<response>",'</response>'),array('','','',''),$xml->asXML());
        $this->XMLResponse(1, $out);        
        exit; 
      }
    }
    $this->XMLResponse(8);
    exit;
  }
  
  function ApiBelegeList()
  {
    $xml = $this->XMLPost();
    $api_id = isset($this->api_id)?$this->api_id:0;
    $adresse = false;
    $belega = null;
    $belegtypen = array('auftrag','rechnung','angebot','lieferschein','gutschrift');
    $join = '';
    $extraselect = '';
    $groupbyartikel = false;
    if(isset($xml['groupbyartikel']) && $xml['groupbyartikel'])$groupbyartikel = true;
    $groupbyposition = false;
    if(isset($xml['groupbyposition']) && $xml['groupbyposition'])$groupbyposition = true;
    $groupbyadresse = false;
    if(isset($xml['groupbyadresse']) && $xml['groupbyadresse'])$groupbyadresse = true;
    if(isset($xml['beleg']))
    {
      if(is_array($xml['beleg']))
      {
        foreach($xml['beleg'] as $_beleg)
        {
          if(in_array($_beleg, $belegtypen))$belega[] = $_beleg;
        }
      }
      if(in_array($xml['beleg'], $belegtypen))$belega[] = $xml['beleg'];
    }
    
    if(!$belega)
    {
      $this->XMLResponse(8);
      exit;
    }
    
    $order = '';
    if(isset($xml['order'])){
      if(!isset($xml['order'][0]))
      {
        $xml['order'][0] = $xml['order'];
      }
      foreach($xml['order'] as $key => $sort)
      {
        $field = '';
        if(isset($sort['field']))
        {
          switch(strtolower($sort['field']))
          {
            case 'artikelkategorie':
              $field = 'ak.bezeichnung';
              if($groupbyartikel)$field = 't.artikelkategoriebezeichnung';
              $join = " INNER JOIN artikelkategorien ak ON concat(ak.id,'_kat') = a.typ ";
              $extraselect = ' ,ak.bezeichnung as artikelkategoriebezeichnung ';
            break;
            case 'status':
            case 'belegnr':
            case 'datum':
              if(!$groupbyartikel)$field = 'r.'.strtolower($sort['field']);
            break;
            case 'nummer':
              if(!$groupbyartikel)$field = 'rp.'.strtolower($sort['field']);
              if($groupbyartikel)$field = 't.'.strtolower($sort['field']);
            break;
            case 'menge':
              if(!$groupbyartikel)$field = 'rp.'.strtolower($sort['field']);
              if($groupbyartikel)$field = 'menge';
            break;
            case 'preis':
            case 'bezeichnung':
              if(!$groupbyartikel)$field = 'rp.'.strtolower($sort['field']);
            break;
            case 'name':
            case 'plz':
            case 'ort':
            case 'telefon':
            case 'land':
            case 'telefax':
            case 'strasse':
              if($groupbyadresse && $groupbyartikel)$field = 't.'.strtolower($sort['field']);
              if(!$groupbyartikel)$field = 'r.'.strtolower($sort['field']);
            break;
            case 'name_de':
            case 'name_en':
            case 'anabregs_text':
            case 'anabregs_text_en':
              if($groupbyartikel)$field = 't.'.strtolower($sort['field']);
            break;
            case 'betrag':
            case 'letztes_datum':
              if($groupbyartikel)$field = strtolower($sort['field']);
            break;
          }
          if(!empty($field)) 
          {  
            if(isset($sort['desc']) && $sort['desc'] == 1)
            {
              $field .= " DESC";
            }
            if($order != '')$order .= ',';
            $order .= $field;
          }
        }
      }
    }
    if($order != '')$order = $order.',';
    if(isset($xml['adresse']))
    {
      $adresse = (int)$xml['adresse'];
    }elseif(isset($xml['id_ext']))
    {
      $adresse = $this->app->DB->Select("SELECT id_int FROM api_mapping WHERE api = '".$api_id."' AND tabelle = 'adresse' AND id_ext = '".$this->app->DB->real_escape_string($xml['id_ext'])."' LIMIT 1");
    }
    if(true)
    {
      $filterkategoriename = false;
      if(isset($xml['status']))
      {
        $subwhere[] = " r.status like '".$this->app->DB->real_escape_string($xml['status'])."' ";
      }
      if(isset($xml['kategorie']))
      {
        $subwhere[] = " a.typ = '".((int)$xml['kategorie'])."_kat' ";
      }
      if(isset($xml['kategoriename']))
      {
        $field = 'ak.bezeichnung';
        $join = " INNER JOIN artikelkategorien ak ON concat(ak.id,'_kat') = a.typ ";
        $extraselect = ' ,ak.bezeichnung as artikelkategoriebezeichnung ';
        $subwhere[] = " ak.bezeichnung like '".$this->app->DB->real_escape_string(base64_decode((String)$xml['kategoriename']))."' ";
        $filterkategoriename = true;
      }
      if(isset($xml['datum_von']))
      {
        $subwhere[] = "r.datum >= '".$this->app->DB->real_escape_string($xml['datum_von'])."' ";
      }
      if(isset($xml['datum_bis']))
      {
        $subwhere[] = "r.datum <= '".$this->app->DB->real_escape_string($xml['datum_bis'])."' ";
      }
      
      if(isset($xml['vertrieb']))
      {
        $subwhere[] = " r.vertriebid = '".(int)$xml['vertrieb']."' ";
      }
      $limit = '';
      $offset = 0;
      $_limit = 999999999;
      if(isset($xml['limit']))
      {
        if((int)$xml['limit'] > 0)$_limit = (int)$xml['limit'];
        if(isset($xml['offset']) && (int)$xml['offset'] > 0)
        {
          $offset = (int)$xml['offset'];
          //$limit = ' LIMIT '.(int)$xml['offset'].', '.(int)$xml['limit'];
        }else{
          //$limit = ' LIMIT '.(int)$xml['limit'];
        }        
      }
      
      $searchmode = ' OR ';
      foreach($xml as $key => $filter)
      {
        $filterescaped = '';
        if(!is_array($filter))$filterescaped = $this->app->DB->real_escape_string($filter);
        
        switch(strtoupper($key))
        {
          case 'SEARCHMODE':
            if(strtoupper($filter) == 'AND')$searchmode = ' AND ';
            if(strtoupper($filter) == 'OR')$searchmode = ' OR ';
          break;
          case 'EXAKT':
            $exakt = true;
          break;
          case 'SEARCH':
          
            if(is_array($filter))
            {
              
              if(!isset($filter[0]))$filter[0] = $filter;
              
              foreach($filter as $_filter)
              {
                if(isset($_filter['SUCHE']))$_filter['suche'] = $_filter['SUCHE'];
                if(isset($_filter['FIELD']))$_filter['field'] = $_filter['FIELD'];
                if(isset($_filter['EXAKT']))$_filter['exakt'] = $_filter['EXAKT'];
                if(isset($_filter['suche']) && isset($_filter['field']))
                {
                  if(isset($_filter['exakt']) && $_filter['exakt'] == 1)
                  {
                    $like = " LIKE '".$this->app->DB->real_escape_string(base64_decode($_filter['suche']))."' ";
                  }else{
                    $like = " LIKE '%".$this->app->DB->real_escape_string(base64_decode($_filter['suche']))."%' ";
                  }
                  switch(strtolower($_filter['field']))
                  {
                    case 'datum':
                      if(strpos('.',$like) !== false)
                      {
                        if(isset($_filter['exakt']) && $_filter['exakt'] == 1)
                        {
                          $like = " LIKE '".$this->app->DB->real_escape_string($this->app->String->Convert(base64_decode($_filter['suche']),"%1.%2.%3","%3-%2-%1"))."' ";
                        }else{
                          $like = " LIKE '%".$this->app->DB->real_escape_string($this->app->String->Convert(base64_decode($_filter['suche']),"%1.%2.%3","%3-%2-%1"))."%' ";
                        }
                        $swhere[] = ' r.datum '.$like;
                      }
                    break;
                    case 'belegnr':
                      $swhere[] = ' r.belegnr '.$like;
                    break;
                    case 'nummer':
                      $swhere[] = ' a.'.strtolower($_filter['field']).' '.$like;
                    break;
                    case 'bezeichnung':
                      if($groupbyartikel)
                      {
                        if(strtolower($_filter['field']) == 'nummer')
                        {
                          
                        }else{
                          $swhere[] = ' a.name_de '.$like;
                        }
                      }else{
                        $swhere[] = ' rp.'.strtolower($_filter['field']).' '.$like;
                      }
                    break;
                    case 'name_de':
                      $swhere[] = ' a.name_de '.$like;
                    break;
                    case 'kategorieid':
                      if(isset($_filter['exakt']) && $_filter['exakt'] == 1)
                      {
                        $like = " LIKE '".$this->app->DB->real_escape_string(base64_decode($_filter['suche']))."_kat' ";
                      }else{
                        $like = " LIKE '%".$this->app->DB->real_escape_string(base64_decode($_filter['suche']))."%_kat' ";
                      }
                      $swhere[] = ' a.typ '.$like;
                    break;
                    case 'kategoriename':
                      if(!$_filterkategoriename)
                      {
                        $join = " INNER JOIN artikelkategorien ak ON concat(ak.id,'_kat') = a.typ ";
                        $extraselect = ' ,ak.bezeichnung as artikelkategoriebezeichnung ';
                        $swhere[] = ' ak.bezeichnung '.$like;
                        $_filterkategoriename = true;
                      }
                    break;
                    case 'name':
                    case 'plz':
                    case 'ort':
                    case 'strasse':
                    case 'kundennummer':
                    
                      if($groupbyadresse)$swhere[] = ' adr.'.strtolower($_filter['field']).' '.$like;
                      if(!$groupbyadresse)$swhere[] = ' r.'.strtolower($_filter['field']).' '.$like;
                    break;
                    break;
                  }
                }
              }
            }
          break;
        }
      }
      
      if(!empty($swhere))$subwhere[] = " (".implode( ' '.$searchmode.' ', $swhere).') ';
      
      $where = "";
      if($subwhere)$where = " AND ".implode(" AND ", $subwhere);
      unset($belege);
      $torder = trim($order,',');
      if(!$torder)$torder = ' 1 ';
      if($groupbyartikel)
      {
        if($groupbyadresse)
        {
          $sql = "SELECT t.adresse, t.name,t.strasse, t.plz, t.land, t.ort, t.kundennummer , t.aid, t.nummer, t.name_de, t.name_en, 
          t.anabregs_text, t.anabregs_text_en, t.artikelkategorie  ,t.artikelkategoriebezeichnung , sum(t.menge) as menge, 
          sum(t.betrag) as betrag, max(t.letztes_datum) as letztes_datum FROM( ";
          
          foreach($belega as $beleg)
          {
            
            $sqlb[] = " (SELECT  adr.id as adresse, adr.name,adr.strasse, adr.plz, adr.land, adr.ort, adr.kundennummer , a.id as aid, a.nummer, a.name_de, a.name_en, a.anabregs_text, a.anabregs_text_en, a.typ as artikelkategorie  ,ak.bezeichnung as artikelkategoriebezeichnung , sum(rp.menge) as menge, ".($belege == 'gutschrift'?'-':'')."sum(rp.menge * (rp.preis*((100-rp.rabatt)/100) )) as betrag, max(r.datum) as letztes_datum  FROM $beleg r INNER JOIN ".$beleg."_position rp ON r.id = rp.".$beleg." INNER JOIN artikel a ON rp.artikel = a.id INNER JOIN adresse adr ON r.adresse = adr.id  LEFT JOIN artikelkategorien ak ON concat(ak.id,'_kat') = a.typ WHERE ".($adresse?("r.adresse = '".$adresse."'"):"1")." $where GROUP BY adr.id, a.id ) "; 
            
          }
          
          $sql .= implode(" UNION ALL ",$sqlb).") t WHERE t.aid > 0 AND t.adresse > 0 GROUP BY t.aid, t.adresse ORDER BY $torder  $limit";
          //$this->app->erp->LogFile(addslashes($sql));
          $_belege = $this->app->DB->SelectArr($sql);
          //$this->app->erp->LogFile(addslashes($this->app->DB->error()));
          
        }else{
          
          $sql = "SELECT   t.aid, t.nummer, t.name_de, t.name_en, t.anabregs_text, t.anabregs_text_en, t.artikelkategorie  ,t.artikelkategoriebezeichnung  , t.menge,sum(t.betrag) as betrag,  max(t.letztes_datum) as letztes_datum FROM( ";
          
          foreach($belega as $beleg)
          {
            
            $sqlb[] = " (SELECT  r.id as bid,r.datum,rp.sort, a.id as aid, a.nummer, a.name_de, a.name_en, a.anabregs_text, a.anabregs_text_en, a.typ  as artikelkategorie ,ak.bezeichnung as artikelkategoriebezeichnung , sum(rp.menge) as menge, ".($belege == 'gutschrift'?'-':'')."sum(rp.menge * (rp.preis*((100-rp.rabatt)/100) )) as betrag, max(r.datum) as letztes_datum  FROM $beleg r INNER JOIN ".$beleg."_position rp ON r.id = rp.".$beleg." INNER JOIN adresse adr ON r.adresse = adr.id INNER JOIN artikel a ON rp.artikel = a.id  LEFT JOIN artikelkategorien ak ON concat(ak.id,'_kat') = a.typ  WHERE ".($adresse?("r.adresse = '".$adresse."'"):"1")." $where GROUP BY a.id, adr.id) "; 
            
          }
          
          $sql .= implode(" UNION ALL ",$sqlb).") t WHERE t.aid > 0 GROUP BY t.aid ORDER BY $torder  $limit";
          //$this->app->erp->LogFile(addslashes($sql));
          
          $_belege = $this->app->DB->SelectArr($sql);
          //$this->app->erp->LogFile(addslashes($this->app->DB->error()));
        }
        if($_belege)
        {
          foreach($_belege as $k => $position)
          {
            //$position['preis'] = $position['menge'] * $position['preis'] * (1-$position['rabatt']/100);
            $belege[] = $position;
            unset($_belege[$k]);
          }
        }
      }else{
        foreach($belega as $beleg)
        {
          $sql = "SELECT '$beleg' as beleg ,r.adresse, r.name,r.plz,r.ort,r.strasse,r.land,r.ansprechpartner,r.datum,r.status as rstatus,r.belegnr,r.id as belegid, rp.*, a.typ as artikelkategorie $extraselect FROM $beleg r LEFT JOIN ".$beleg."_position rp ON r.id = rp.".$beleg." LEFT JOIN artikel a ON rp.artikel = a.id $join WHERE ".($adresse?("r.adresse = '".$adresse."'"):"1")." $where ORDER BY $order r.datum, rp.sort  $limit ";
          $_belege = $this->app->DB->SelectArr($sql);
          //$this->app->erp->LogFile(addslashes($this->app->DB->error()));
          //$this->app->erp->LogFile(addslashes($sql));
          if($_belege)
          {
            foreach($_belege as $k => $position)
            {
              $position['status'] = $position['rstatus'];
              unset($position['rstatus']);
              $position['preis'] = $position['menge'] * $position['preis'] * (1-$position['rabatt']/100);
              $belege[] = $position;
              unset($_belege[$k]);
            }
          }
        }
      }
      
      
      /*
      foreach($belega as $beleg)
      {
        if($groupbyartikel)
        {
          if($groupbyadresse)
          {
            $_belege = $this->app->DB->SelectArr("SELECT '$beleg' as beleg, adr.id as adresse, adr.name,adr.strasse, adr.plz, adr.land, adr.ort, adr.kundennummer , a.id, a.nummer, a.name_de, a.name_en, a.anabregs_text, a.anabregs_text_en, a.typ as artikelkategorie  ,ak.bezeichnung as artikelkategoriebezeichnung , sum(rp.menge) as menge, sum(rp.menge * (rp.preis*((100-rp.rabatt)/100) )) as betrag, max(r.datum) as letztes_datum  FROM $beleg r INNER JOIN ".$beleg."_position rp ON r.id = rp.".$beleg." INNER JOIN artikel a ON rp.artikel = a.id INNER JOIN adresse adr ON r.adresse = adr.id  INNER JOIN artikelkategorien ak ON concat(ak.id,'_kat') = a.typ  WHERE ".($adresse?("r.adresse = '".$adresse."'"):"1")." $where GROUP BY a.id, adr.id ORDER BY $order r.datum, rp.sort  $limit ");
            
          }else{
            $_belege = $this->app->DB->SelectArr("SELECT '$beleg' as beleg ,  a.id, a.nummer, a.name_de, a.name_en, a.anabregs_text, a.anabregs_text_en, a.typ as artikelkategorie  ,ak.bezeichnung as artikelkategoriebezeichnung , sum(rp.menge) as menge, sum(rp.menge * (rp.preis*((100-rp.rabatt)/100) )) as betrag, max(r.datum) as letztes_datum  FROM $beleg r INNER JOIN ".$beleg."_position rp ON r.id = rp.".$beleg." INNER JOIN artikel a ON rp.artikel = a.id  INNER JOIN artikelkategorien ak ON concat(ak.id,'_kat') = a.typ  WHERE ".($adresse?("r.adresse = '".$adresse."'"):"1")." $where GROUP BY a.id ORDER BY $order r.datum, rp.sort  $limit ");
          }
          if($_belege)
          {
            foreach($_belege as $k => $position)
            {
              //$position['preis'] = $position['menge'] * $position['preis'] * (1-$position['rabatt']/100);
              $belege[] = $position;
              unset($_belege[$k]);
            }
          }
        }
      }*/
      
$xmlstr = <<<XML
<?xml version="1.0" standalone="yes"?>
<belege_list1>
</belege_list1>
XML;
      $_xmlobj = new SimpleXMLElement($xmlstr);
      if($groupbyartikel)
      {
        $xmlobj = $_xmlobj->AddChild('artikel_list','');
      }else{
        $xmlobj = $_xmlobj->AddChild('beleg_list','');
      }
      //$out = '<beleg_list>';
      $i = 0;
      $j = 0;
      if($belege)
      {
        if($groupbyartikel)
        {
          foreach($belege as $position)
          {
            if($i >= $offset && $i < $_limit + $offset)
            {
              $j++;
              $belegobj = $xmlobj->AddChild('artikel');
              $_belegobj = $belegobj->AddChild('id','');
              $_belegobj->value = $position['aid'];
              $_nummer = $belegobj->AddChild('nummer','');
              $_nummer->value = $position['nummer'];
              $_name_de = $belegobj->AddChild('name_de','');
              $_name_de->value = $position['name_de'];
              $_menge = $belegobj->AddChild('menge','');
              $_menge->value = round($position['menge'],4);
              $_betrag = $belegobj->AddChild('betrag','');
              $_betrag->value = $position['betrag'];
              $_artikelkategorie = $belegobj->AddChild('artikelkategorie','');
              $_artikelkategorie->value = $position['artikelkategorie'];
              $_letztes_datum = $belegobj->AddChild('letztes_datum','');
              $_letztes_datum->value = $position['letztes_datum'];
              $_artikelkategoriebezeichnung = $belegobj->AddChild('artikelkategoriebezeichnung','');
              $_artikelkategoriebezeichnung->value = $position['artikelkategoriebezeichnung'];
              if($groupbyadresse)
              {
                $_adresse = $belegobj->AddChild('adresse','');
                $_adresse->value = $position['adresse'];
                $_kundennummer = $belegobj->AddChild('kundennummer','');
                $_kundennummer->value = $position['kundennummer'];
                $_name = $belegobj->AddChild('name','');
                $_name->value = $position['name'];
                $_ort = $belegobj->AddChild('ort','');
                $_ort->value = $position['ort'];
                $_plz = $belegobj->AddChild('plz','');
                $_plz->value = $position['plz'];
                $_strasse = $belegobj->AddChild('strasse','');
                $_strasse->value = $position['strasse'];
                $_land = $belegobj->AddChild('land','');
                $_land->value = $position['land'];
              }            
            }
            $i++;
          }          
          
        }else{
          $old = 0;
          foreach($belege as $position)
          {
            
            if($i >= $offset && $i < $_limit + $offset)
            {
              $j++;
              if($groupbyposition || $old != $position['belegid'].$position['beleg'])
              {
                $belegobj = $xmlobj->AddChild($position['beleg']);
                //if($old != 0)$out .= '</'.$position['beleg'].'>';
                $old = $position['belegid'].$position['beleg'];
                
                //$out .= '<'.$position['beleg'].'>';
                
                $_belegobj = $belegobj->AddChild('belegid','');
                $_belegobj->value = $position['belegid'];
                $_plz = $belegobj->AddChild('plz','');
                $_plz->value = $position['plz'];
                $_ort = $belegobj->AddChild('ort','');
                $_ort->value = $position['ort'];
                $_strasse = $belegobj->AddChild('strasse','');
                $_strasse->value = $position['strasse'];
                $_land = $belegobj->AddChild('land','');
                $_land->value = $position['land'];
                $_ansprechpartner = $belegobj->AddChild('ansprechpartner','');
                $_ansprechpartner->value = $position['ansprechpartner'];
                $_datum = $belegobj->AddChild('datum','');
                $_datum->value = $position['datum'];
                $_belegnr = $belegobj->AddChild('belegnr','');
                $_belegnr->value = $position['belegnr'];
                $_status = $belegobj->AddChild('status','');
                $_status->value = $position['status'];
                $_adresse = $belegobj->AddChild('adresse','');
                $_adresse->value = $position['adresse'];
                $_name = $belegobj->AddChild('name','');
                $_name->value = $position['name'];
                //$out .= '<belegid>'.$position['belegid'].'</belegid>';
                //$out .= '<datum>'.$position['datum'].'</datum>';
                //$out .= '<belegnr>'.$position['belegnr'].'</belegnr>';
                //$out .= '<status>'.$position['status'].'</status>';
                //$out .= '<adresse>'.$position['adresse'].'</adresse>';
              }
              $_positionobj = $belegobj->AddChild('position','');
              //$out .= '<position>';
              foreach($position as $k => $v)
              {
                $objn = $k.'_obj';
                $$objn = $_positionobj->AddChild($k,'');
                $$objn->value = $v;
                //$out .= '<'.$k.'>'.htmlspecialchars($v).'</'.$k.'>';
              }
              //$out .= '</position>';
            }
            $i++;
          }
        }
        //$out .= '</'.$position['beleg'].'>';
      }
      //$out .= '</beleg_list><anz_gesamt>'.count($belege).'</anz_gesamt><anz_result>'.$j.'</anz_result>';
      $xmlobj->AddChild('anz_gesamt',count($belege));
      $xmlobj->AddChild('anz_result',$j);
      
      $out = str_replace(array('<?xml version="1.0" standalone="yes"?>',"<belege_list1>",'</belege_list1>'),array('','',''),$_xmlobj->asXML());
      unset($_xmlobj);
      $this->XMLResponse(1, $out);
      exit;
    }else{
      $this->XMLResponse(8);
      exit;
    }
  }
  
  function ApiGruppenList()
  {
    $gruppen = $this->app->DB->SelectArr("SELECT * FROM gruppen WHERE art like 'gruppe' ");
    if($gruppen)
    {
      $out = '<gruppen>';
      foreach($gruppen as $gruppe)
      {
        $out .= '<gruppe>';
        foreach($gruppe as $k => $v )
        {
          $out .= '<'.$k.'>'.$v.'</'.$k.'>'; 
        }
        $out .= '</gruppe>';
      }
      $out .= '</gruppen>';
      $this->XMLResponse(1, $out);
      exit;
    }else{
      $this->XMLResponse(8);
      exit;
    }
  }
  
  function ApiAdresseGruppenList()
  {
    $xml = $this->XMLPost();
    $api_id = isset($this->api_id)?$this->api_id:0;
    if(isset($xml['adresse']))
    {
      $adresse = (int)$xml['adresse'];
      
    }elseif(isset($xml['id_ext']))
    {
      $adresse = $this->app->DB->Select("SELECT id_int FROM api_mapping WHERE api = '".$api_id."' AND tabelle = 'adresse' AND id_ext = '".$this->app->DB->real_escape_string($xml['id_ext'])."' LIMIT 1");
    }
    if($adresse)
    {
      $gruppen = $this->app->DB->SelectArr("SELECT gr.id as gruppe, gr.name, am.id_int FROM adresse_rolle ar LEFT JOIN gruppen gr ON gr.id = ar.parameter LEFT JOIN api_mapping am ON am.id_int = gr.id AND am.tabelle = 'gruppen' WHERE  ar.adresse = '$adresse' AND ar.subjekt like 'Mitglied' AND objekt like 'Gruppe'");
      if($gruppen)
      {
        $out = '<gruppen>';
        foreach($gruppen as $gruppe)
        {
          $out .= '<gruppe>';
          foreach($gruppe as $k => $v )
          {
            $out .= '<'.$k.'>'.$v.'</'.$k.'>'; 
          }
          $out .= '</gruppe>';
        }        
        $out .= '</gruppen>';
        $this->XMLResponse(1, $out);
        exit;
      }else{
        $this->XMLResponse(8);
        exit;
      }      
    }
    $this->XMLResponse(8);
    exit;
  }
  

  function ApiAccountList()
  {
    $api_id = isset($this->api_id)?$this->api_id:0;
    if($api_id)
    {
      $url = $this->app->DB->Select("SELECT remotedomain FROM api_account WHERE id = '$api_id' LIMIT 1");
      $accounts = $this->app->DB->SelectArr("SELECT ac.adresse, ac.art, ac.benutzername,ac.passwort, ac.webid, am.id_ext, a.name, a.email FROM adresse_accounts ac INNER JOIN adresse a ON ac.adresse = a.id LEFT JOIN api_mapping am ON am.id_int = ac.adresse AND am.api = '$api_id' AND am.tabelle = 'adresse' WHERE ac.aktiv = 1 AND ac.url = '".$this->app->DB->real_escape_string($url)."' AND (ac.gueltig_bis <= now() or isnull(ac.gueltig_bis))");
      if($error = $this->app->DB->error())
      {
        $this->XMLResponse(1,'<sqlerror>'.$error.'</sqlerror>');
      }
      if($accounts)
      {
        $out = '<list>';
        foreach($accounts as $account)
        {
          $out .= '<account>';
          foreach($account as $key => $value)
          {
            $out .= '<'.$key.'>'.(is_null($value)?'':$value).'</'.$key.'>';
          }
          $out .= '</account>';
        }
        $out .= '</list>';
        $this->XMLResponse(1,$out);
        exit;
      }else{
        $this->XMLResponse(8);
        exit;
      }
    }else{
      $this->XMLResponse(3);
      exit;
    }
  }
  
  function ApiMappingGet()
  {
    $xml = $this->XMLPost();
    $api_id = isset($this->api_id)?$this->api_id:0;
    if(is_array($xml))
    {
      $list = false;
      if(isset($xml['list']))
      {
        $list = $xml['list'];
      }elseif($xml['LIST'])
      {
        $list = $xml['LIST'];
      }      
      if(!$list)
      {
        $table = isset($xml['table'])?$xml['table']:(isset($xml['TABLE'])?$xml['TABLE']:'');
        $id_int = isset($xml['id_int'])?$xml['id_int']:(isset($xml['ID_INT'])?$xml['ID_INT']:'');
        $id_ext = isset($xml['id_ext'])?$xml['id_ext']:(isset($xml['ID_EXT'])?$xml['ID_EXT']:'');
        if($table && (!empty($id_int) || !empty($id_ext)))
        {
          if(!empty($id_int))
          {
            $ergebnis = $this->app->DB->SelectArr("SELECT * FROM api_mapping WHERE tabelle = '".$this->app->DB->real_escape_string($xml['table'])."' AND id_int = '".$this->app->DB->real_escape_string($id_int)."' AND api = '".$api_id."' LIMIT 1");
          }else{
            $ergebnis = $this->app->DB->SelectArr("SELECT * FROM api_mapping WHERE tabelle = '".$this->app->DB->real_escape_string($xml['table'])."' AND id_ext = '".$this->app->DB->real_escape_string($id_ext)."' AND api = '".$api_id."' LIMIT 1");
          }
          if(empty($ergebnis))
          {
            $this->XMLResponse(8);
            exit;
          }else{
            $this->XMLResponse(1,'<id_int>'.$ergebnis[0]['id_int'].'</id_int><id_ext>'.$ergebnis[0]['id_ext'].'</id_ext><table>'.$ergebnis[0]['tabelle'].'</table>');
            exit;
          }
        }else{
          $this->XMLResponse(4);
          exit;
        }
      }else{
        $out = '<list>';
        foreach($list as $k => $v)
        {
          $table = isset($v['table'])?$v['table']:(isset($v['TABLE'])?$v['TABLE']:'');
          $id_int = isset($v['id_int'])?$v['id_int']:(isset($v['ID_INT'])?$v['ID_INT']:'');
          $id_ext = isset($v['id_ext'])?$v['id_ext']:(isset($v['ID_EXT'])?$v['ID_EXT']:'');
          if($table && (!empty($id_int) || !empty($id_ext)))
          {
            if(!empty($id_int))
            {
              $ergebnis = $this->app->DB->SelectArr("SELECT * FROM api_mapping WHERE table = '".$this->app->DB->real_escape_string($xml['table'])."' AND id_int = '".$this->app->DB->real_escape_string($id_int)."' AND api = '".$api_id."' LIMIT 1");
            }else{
              $ergebnis = $this->app->DB->SelectArr("SELECT * FROM api_mapping WHERE table = '".$this->app->DB->real_escape_string($xml['table'])."' AND id_ext = '".$this->app->DB->real_escape_string($id_ext)."' AND api = '".$api_id."' LIMIT 1");
            }
            if(!empty($ergebnis))
            {
              $out .= '<id_int>'.$ergebnis[0]['id_int'].'</id_int><id_ext>'.$ergebnis[0]['id_ext'].'</id_ext><table>'.$ergebnis[0]['tabelle'].'</table>';
            }
          }
        }
        $out = '</list>';
        $this->XMLResponse(1,$out);
        exit;
      }
    }
  }
  
  function ApiMappingSet()
  {
    $xml = $this->XMLPost();
    $api_id = isset($this->api_id)?$this->api_id:0;
    if(is_array($xml))
    {
      $list = false;
      if(isset($xml['list']))
      {
        $list = $xml['list'];
      }elseif($xml['LIST'])
      {
        $list = $xml['LIST'];
      }      
      if(!$list)
      {
        $table = isset($xml['table'])?$xml['table']:(isset($xml['TABLE'])?$xml['TABLE']:'');
        $id_int = isset($xml['id_int'])?$xml['id_int']:(isset($xml['ID_INT'])?$xml['ID_INT']:'');
        $id_ext = isset($xml['id_ext'])?$xml['id_ext']:(isset($xml['ID_EXT'])?$xml['ID_EXT']:'');
        if($table && (!empty($id_int) && !empty($id_ext)))
        {
          $ergebnis = $this->app->DB->SelectArr("SELECT * FROM api_mapping WHERE tabelle = '".$this->app->DB->real_escape_string($table)."' AND id_int = '".$this->app->DB->real_escape_string($id_int)."' AND api = '".$api_id."' LIMIT 1");
          if(empty($ergebnis))
          {
            $this->app->DB->Insert("INSERT INTO api_mapping (tabelle, id_int, id_ext, api) VALUES ('".$this->app->DB->real_escape_string($table)."','".$this->app->DB->real_escape_string($id_int)."','".$this->app->DB->real_escape_string($id_ext)."','".$api_id."')");
            if($insertid = $this->app->DB->GetInsertID())
            {
              $this->XMLResponse(1,'<id_int>'.$id_int.'</id_int><id_ext>'.$id_ext.'</id_ext><table>'.$table.'</table><id>'.$insertid.'</id><sql>'."INSERT INTO api_mapping (table, id_int, id_ext, api) VALUES ('".$this->app->DB->real_escape_string($table)."','".$this->app->DB->real_escape_string($id_int)."','".$this->app->DB->real_escape_string($id_ext)."','".$api_id."')".'</sql>');
              exit;
            }else{
              $this->XMLResponse(0);
              exit;
            }
            exit;
          }else{
            $this->app->DB->Update("UPDATE api_mapping SET id_ext = '".$this->app->DB->real_escape_string($id_ext)."' WHERE id = '".$ergebnis[0]['id']."' LIMIT 1");
            $this->XMLResponse(1,'<id_int>'.$id_int.'</id_int><id_ext>'.$id_ext.'</id_ext><table>'.$table.'</table>');
            exit;
          }
        }else{
          $this->XMLResponse(4);
          exit;
        }
      }else{
        $out = '<list>';
        foreach($list as $k => $v)
        {
          $table = isset($v['table'])?$v['table']:(isset($v['TABLE'])?$v['TABLE']:'');
          $id_int = isset($v['id_int'])?$v['id_int']:(isset($v['ID_INT'])?$v['ID_INT']:'');
          $id_ext = isset($v['id_ext'])?$v['id_ext']:(isset($v['ID_EXT'])?$v['ID_EXT']:'');
          if($table && (!empty($id_int) && !empty($id_ext)))
          {
            if(!empty($id_int))
            {
              $ergebnis = $this->app->DB->SelectArr("SELECT * FROM api_mapping WHERE tabelle = '".$this->app->DB->real_escape_string($xml['table'])."' AND id_int = '".$this->app->DB->real_escape_string($id_int)."' AND api = '".$api_id."' LIMIT 1");
            }
            if(!empty($ergebnis))
            {
              $this->app->DB->Update("UPDATE api_mapping SET id_ext = '".$this->app->DB->real_escape_string($id_ext)."' WHERE id = '".$ergebnis[0]['id']."' LIMIT 1");
              $out .= '<id_int>'.$id_int.'</id_int><id_ext>'.$id_ext.'</id_ext><table>'.$table.'</table>';
            }else{
              $this->app->DB->Insert("INSERT INTO api_mapping (table, id_int, id_ext, api) VALUES ('".$this->app->DB->real_escape_string($table)."','".$this->app->DB->real_escape_string($id_int)."','".$this->app->DB->real_escape_string($id_ext)."','".$api_id."')");
              $out .= '<id_int>'.$id_int.'</id_int><id_ext>'.$id_ext.'</id_ext><table>'.$table.'</table>';
            }
          }
        }
        $out = '</list>';
        $this->XMLResponse(1,$out);
        exit;
      }
    }
  }
  
  // allgemeine funktionen
  function CheckHash()
  {
    $hash = $this->app->Secure->GetGET("hash");
    $api_id = (int)$this->app->Secure->GetGET("api_id");

    if($api_id)
    {
      $this->api_id = $api_id;
      $initKey = $this->app->DB->Select("SELECT initkey FROM api_account WHERE id = '$api_id' LIMIT 1");
      $remoteDomain = $this->app->DB->Select("SELECT remotedomain FROM api_account WHERE id = '$api_id' LIMIT 1");
    }else{
      $initKey = $this->app->erp->Firmendaten("api_initkey");
      $remoteDomain = $this->app->erp->Firmendaten("api_remotedomain");
    }
    $keys = array($remoteDomain=>$initKey);
    $hash_false = true;

    foreach($keys as $domain=>$key)
    {
      if(($hash==$this->generateHash($domain,$key)) && $key!="")
      {
        $hash_false = false;    
        break;
      }
    }   
    if($hash_false)
    {
      $this->XMLResponse(2);
      exit;
    }

  }

  function generateHash($domain,$key)
  {
    $date = gmdate('dmY');
    $hash = "";

    for($i = 0; $i <= 200; $i++) 
      $hash = sha1($hash . $key . $domain . $date);

    return $hash;
  }
  
  function getBelege()
  {
    return array('auftrag','rechnung','gutschrift','angebot','lieferschein','bestellung','produktion');
  }
  
  function getTabellen()
  {
    return array('adresse','adresse_rolle','gruppen','adresse_kontakte','artikel','verkaufspreise','einkaufspreise','stueckliste');
  }
  
  function GetPDF($typ, $id)
  {
    $id = (int)$id;
    if(!$id)return;
    if(!in_array($typ, $this->getBelege()))return;
    $elemente = $this->app->DB->SelectArr("SELECT * FROM $typ WHERE id = '$id' LIMIT 1");
    if(!$elemente)return;

    if(!defined('FPDF_FONTPATH'))define('FPDF_FONTPATH','lib/pdf/font/');

    if(file_exists(dirname(__FILE__).'/../../conf/user_defined.php'))include_once(dirname(__FILE__).'/../../conf/user_defined.php');
    
    if(defined('USEFPDF2') && USEFPDF2)
    {
      if(file_exists(dirname(__FILE__).'/../lib/pdf/fpdf_2.php'))
      {
        require_once(dirname(__FILE__).'/../lib/pdf/fpdf_2.php');  
      }else {
        require_once(dirname(__FILE__).'/../lib/pdf/fpdf.php');  
      }
    } else {
      require_once(dirname(__FILE__).'/../lib/pdf/fpdf.php');  
    }
    
    require_once(dirname(__FILE__).'/../lib/pdf/fpdf_final.php');

    require_once(dirname(__FILE__)."/../lib/dokumente/class.superfpdf.php");
    require_once(dirname(__FILE__)."/../lib/dokumente/class.etikett.php");
    if(file_exists(dirname(__FILE__)."/../lib/dokumente/class.briefpapier_custom.php"))
    {
      require_once(dirname(__FILE__)."/../lib/dokumente/class.briefpapier_custom.php");
    }else{
      require_once(dirname(__FILE__)."/../lib/dokumente/class.briefpapier.php");
    }
    require_once(dirname(__FILE__)."/../lib/dokumente/class.dokumentenvorlage.php");
    if(file_exists("lib/dokumente/class.layoutvorlagen.php"))require_once("lib/dokumente/class.layoutvorlagen.php");
    require_once(dirname(__FILE__)."/../lib/dokumente/class.sepamandat.php");
    require_once(dirname(__FILE__)."/../lib/dokumente/class.dokuarbeitszeit.php");
    require_once(dirname(__FILE__)."/../../phpwf/plugins/class.string.php");
    if(!isset($this->app->String))$this->app->String = new WawiString();
    $classname = ucfirst($typ).'PDF';
    $classnamecustom = $classname.'Custom';
    if(!class_exists($classname) && !class_exists($classnamecustom))
    {
      if(file_exists(dirname(__FILE__).'/../lib/dokumente/class.'.$typ.'_custom.php'))
      {
        include_once(dirname(__FILE__).'/../lib/dokumente/class.'.$typ.'_custom.php');
      }elseif(file_exists(dirname(__FILE__).'/../lib/dokumente/class.'.$typ.'.php'))
      {
        include_once(dirname(__FILE__).'/../lib/dokumente/class.'.$typ.'.php');
      }
    }
    if(isset($Brief))unset($Brief);
    if(class_exists($classnamecustom))
    {
      $Brief = new $classnamecustom($this->app,$elemente[0]['projekt']);
    }elseif(class_exists($classname)){
      $Brief = new $classname($this->app,$elemente[0]['projekt']);
    }
    if(isset($Brief))
    {
      $funktionsname = 'Get'.ucfirst($typ);
      if(method_exists($Brief, $funktionsname))
      {
        $Brief->$funktionsname($elemente[0]['id']);
        $Brief->renderDocument();
        $output = $Brief->output('','S');
        return $output;
      }
    }   
  }


  function ApiDataToXML($typ, $id, &$xml = null, $parameter = null)
  {
    $n = null;
    $typ = strtolower($typ);
    if(is_null($xml))
    {
      $xml = $this->CreateXmlObj();
    }

    if(isset($parameter['briefpapier']) && $parameter['briefpapier'] == 1)
    {
      $briefpapier = '';
      $briefpapier2 = '';
      $logo = '';
      $briefpapier_typ = $this->app->erp->Firmendaten('hintergrund');
      
      if($briefpapier_typ=="logo")
      {
        $logo = $this->app->erp->Firmendaten('logo');
      }
      else if($briefpapier_typ=="briefpapier")
      {
        $briefpapier = $this->app->erp->Firmendaten('briefpapier');

        $briefpapier2vorhanden = $this->app->erp->Firmendaten('briefpapier2vorhanden');
        if($briefpapier2vorhanden > 0)
        {
          $briefpapier2 = $this->app->erp->Firmendaten('briefpapier2');
        }
      }
      if($briefpapier && !isset($xml->xml->briefpapier))$this->AddToXMLObj($xml, 'briefpapier','', $briefpapier, $n, $erg);
      if($briefpapier2 && !isset($xml->xml->briefpapier2))$this->AddToXMLObj($xml, 'briefpapier2','', $briefpapier2, $n, $erg);
      if($logo && !isset($xml->xml->logo))$this->AddToXMLObj($xml, 'logo','', $logo, $n, $erg);
      if($briefpapier_typ && !isset($xml->xml->briefpapier_typ))$this->AddToXMLObj($xml, 'briefpapier_typ','', $briefpapier_typ, $n, $erg);
    }
    $typen = $this->getTabellen();
    $belege = $this->getBelege();
    if(in_array($typ, $typen))
    {
      $elemente = $this->app->DB->SelectArr("SELECT t.*, m.id_ext FROM $typ t LEFT JOIN api_mapping m ON m.api = '".$this->api_id."' AND m.tabelle = '$typ' AND m.id_int = t.id WHERE t.id = '".($id)."' LIMIT 1");
      if($elemente)
      {
        $this->AddToXMLObj($xml, $typ,$typ.'_list', $elemente, $n, $erg);
      }
    }elseif(in_array($typ, $belege))
    {
      $typposition = $typ.'_position';
      $elemente = $this->app->DB->SelectArr("SELECT t.*, m.id_ext FROM $typ t LEFT JOIN api_mapping m ON m.api = '".$this->api_id."' AND m.tabelle = '$typ' AND m.id_int = t.id WHERE t.id = '".($id)."' LIMIT 1");
      if($elemente)
      {
        
        if(isset($parameter['pdf']) && $parameter['pdf'] == 1)
        {
          $file = $this->GetPDF($typ, $id);
          if(!empty($file))$elemente[0]['pdf'] = base64_encode($file);
        }
        if(isset($parameter['gln_freifeld']))
        {
          $elemente[0]['gln_empfaenger'] = $this->app->DB->Select("SELECT freifeld".(int)$parameter['gln_freifeld']." FROM adresse WHERE id = '".$elemente[0]['adresse']."' LIMIT 1");
        }
        if($typ == 'lieferschein')
        {
          $auftragsdaten = $this->app->DB->SelectArr("SELECT * FROM auftrag WHERE id = '".$elemente[0]['auftragid']."' LIMIT 1");
          if($auftragsdaten)
          {
            $elemente[0]['rechnung_name'] = $auftragsdaten[0]['name'];
            $elemente[0]['rechnung_anrede'] = $auftragsdaten[0]['anrede'];
            $elemente[0]['rechnung_strasse'] = $auftragsdaten[0]['strasse'];
            $elemente[0]['rechnung_adresszusatz'] = $auftragsdaten[0]['adresszusatz'];
            $elemente[0]['rechnung_ansprechpartner'] = $auftragsdaten[0]['ansprechpartner'];
            $elemente[0]['rechnung_abteilung'] = $auftragsdaten[0]['abteilung'];
            $elemente[0]['rechnung_unterabteilung'] = $auftragsdaten[0]['unterabteilung'];
            $elemente[0]['rechnung_plz'] = $auftragsdaten[0]['plz'];
            $elemente[0]['rechnung_ort'] = $auftragsdaten[0]['ort'];
            $elemente[0]['rechnung_land'] = $auftragsdaten[0]['land'];
          }          
        }
        if($typ == 'rechnung')
        {
          $auftragsdaten = $this->app->DB->SelectArr("SELECT * FROM auftrag WHERE id = '".$elemente[0]['auftragid']."' LIMIT 1");
          if($auftragsdaten)
          {
            $elemente[0]['liefername'] = $auftragsdaten[0]['abweichendelieferadresse'] == 1? $auftragsdaten[0]['liefername']:$auftragsdaten[0]['name'];
            $elemente[0]['lieferstrasse'] = $auftragsdaten[0]['abweichendelieferadresse'] == 1? $auftragsdaten[0]['liefername']:$auftragsdaten[0]['strasse'];
            $elemente[0]['lieferadresszusatz'] = $auftragsdaten[0]['abweichendelieferadresse'] == 1? $auftragsdaten[0]['lieferadresszusatz']:$auftragsdaten[0]['adresszusatz'];
            $elemente[0]['lieferansprechpartner'] = $auftragsdaten[0]['abweichendelieferadresse'] == 1? $auftragsdaten[0]['lieferansprechpartner']:$auftragsdaten[0]['ansprechpartner'];
            $elemente[0]['lieferabteilung'] = $auftragsdaten[0]['abweichendelieferadresse'] == 1? $auftragsdaten[0]['lieferabteilung']:$auftragsdaten[0]['abteilung'];
            $elemente[0]['lieferunterabteilung'] = $auftragsdaten[0]['abweichendelieferadresse'] == 1? $auftragsdaten[0]['lieferunterabteilung']:$auftragsdaten[0]['unterabteilung'];
            $elemente[0]['lieferplz'] = $auftragsdaten[0]['abweichendelieferadresse'] == 1? $auftragsdaten[0]['lieferplz']:$auftragsdaten[0]['plz'];
            $elemente[0]['lieferort'] = $auftragsdaten[0]['abweichendelieferadresse'] == 1? $auftragsdaten[0]['lieferort']:$auftragsdaten[0]['ort'];
            $elemente[0]['lieferland'] = $auftragsdaten[0]['abweichendelieferadresse'] == 1? $auftragsdaten[0]['lieferland']:$auftragsdaten[0]['land'];
          }
        }
        $lieferid = 0;
        if($typ != 'auftrag')
        {
          $lieferid = $this->app->DB->Select("SELECT lieferid FROM auftrag WHERE id = '".$elemente[0]['auftragid']."' LIMIT 1");
        }else{
          $lieferid = $auftragsdaten[0]['lieferid'];
        }
        if($lieferid)
        {
          $gln_lieferadresse = $this->app->DB->Select("SELECT gln FROM lieferadressen WHERE id = '$lieferid' LIMIT 1");
          if($gln_lieferadresse)$elemente[0]['gln_lieferadresse'] = $gln_lieferadresse;
        }
        
        $rabatt = 0;
        $gebuehr = 0;
        $summe = 0;
        $summeR = 0;
        $summeV = 0;
        $elemente_positionen = $this->app->DB->SelectArr("SELECT t.*, m.id_ext, art.ean, art.gewicht,art.herstellernummer, art.altersfreigabe FROM $typposition t LEFT JOIN artikel art ON t.artikel = art.id LEFT JOIN api_mapping m ON m.tabelle = '$typposition' AND m.id_int = t.id WHERE t.$typ = '".($elemente[0]['id'])."' ");
        if($elemente_positionen)
        {
          if(isset($elemente_positionen[0]['preis']))
          {
            foreach($elemente_positionen as $value)
            {
              
              if($value['umsatzsteuer'] != "ermaessigt") $value['umsatzsteuer'] = "normal";
              $netto_gesamt = $value['menge']*($value['preis']-($value['preis']/100*$value['rabatt']));
              $summe = $summe + $netto_gesamt;

              if($value['umsatzsteuer']=="" || $value['umsatzsteuer']=="normal")
              {
                $summeV = $summeV + (($netto_gesamt/100)*$this->app->erp->GetSteuersatzNormal(false,$id,"rechnung"));
                $totalV = $totalV + $netto_gesamt;
              }
              else {
                $summeR = $summeR + (($netto_gesamt/100)*$this->app->erp->GetSteuersatzErmaessigt(false,$id,"rechnung"));
                $totalR = $totalR + $netto_gesamt;
              }
              
              if($value['preis'] < -0.0001)
              {
                $rabatt -= $netto_gesamt;
              }else{
                $gebuehr_artikel = $this->app->DB->Select("SELECT gebuehr FROM artikel WHERE id = '".$value['artikel']."' LIMIT 1");
                if($gebuehr_artikel)$gebuehr += $netto_gesamt;
              }
            }
            if($rabatt)
            {
              $elemente[0]['rabatt'] = round($rabatt,2);
            }else $elemente[0]['rabatt'] = 0;
            if($gebuehr)
            {
              $elemente[0]['gebuehr'] = round($gebuehr,2);
            }else $elemente[0]['gebuehr'] = 0;
            if($this->app->erp->RechnungMitUmsatzeuer($id))
            {
              $elemente[0]['ust'] = round($summeR+$summeV,2);
              $elemente[0]['ust_ermaessigt'] = round($summeR,2);
              $elemente[0]['ust_normal'] = round($summeV,2);
              
            }else $elemente[0]['ust'] = 0;
          }
        }
        $this->AddToXMLObj($xml, $typ,$typ.'_list', $elemente, $n, $erg);
        if($elemente_positionen)
        {
          $this->AddToXMLObj($xml, $typposition,$typposition.'_list', $elemente_positionen, $erg, $erg2);
        }
      }
    }
  }
  
  function ParseXML($dateiname, $api = 0, $uebertragung = 0)
  {
    $api = (int)$api;
    $uebertragung = (int)$uebertragung;
    if(!$api && !$uebertragung)return false;
    if(!$api)$api = $this->app->DB->Select("SELECT api FROM uebertragungen_account WHERE id = '$uebertragung' LIMIT 1");
    //if(!$api)return false;
    $this->api_id = $api;
    $xml = $this->LoadFromXML($dateiname);
    if(!$xml)return false;
    if(isset($xml->xml))
    {
      if(count($xml->xml) > 0)
      {
        foreach($xml as $key0 => $value0)
        {
          if($key0 == 'status')
          {
            $status = &$value0;
            break;
          }
        }
        $ok = true;
        if(isset($status))
        {
          if(isset($status->messageCode) && $status->messageCode != 1)$ok = false;
        }
        
        foreach($xml as $key0 => $value0)
        {        
          if($key0 == 'xml')
          {
            $xml_inhalt = &$value0;
            break;
          }
        }
        
        $typen = $this->getTabellen();
        foreach($typen as $v)$typen_list[] = $v.'_list';
        $belege = $this->getBelege();
        foreach($belege as $v)$belege_list[] = $v.'_list';
        if(isset($xml_inhalt))
        {
          foreach($xml_inhalt as $key => $value)
          {
            if(in_array($key,$belege) || in_array($key,$typen))
            {
              $this->ParseTeilXML($key, $value, $uebertragung);
            }
            if(in_array($key,$belege_list) || in_array($key,$typen_list))
            {
              foreach($value as $key2 => $value2)
              {
                if(in_array($key2,$belege) || in_array($key2,$typen))
                {
                  $this->ParseTeilXML($key2, $value2, $uebertragung);
                }
              }
            }
          }
        }
      }
      return true;
    }else return false;
  }
  
  function AddMapping($tabelle, $id_int, $id_ext, $api = 0)
  {
    if(!$api)$api = $this->api_id;
    $api = (int)$api;
    if(!$api)return false;
    $checkmapping = $this->app->DB->SelectArr("SELECT id, id_ext FROM api_mapping WHERE api = '$api' AND tabelle = '$tabelle' AND id_int = '$id_int' LIMIT 1");
    if($checkmapping)
    {
      if($checkmapping[0]['id_ext'] == '')
      {
        $this->app->DB->Update("UPDATE api_mapping SET id_ext = '".$this->app->DB->real_escape_string($id_ext)."' WHERE id = '".$checkmapping[0]['id']."' LIMIT 1");
        return true;
      }
    }else{
      $this->app->DB->Insert("INSERT INTO api_mapping (id_int, tabelle, id_ext, api) VALUES ('$id_int','$tabelle','".$this->app->DB->real_escape_string($id_ext)."','$api')");
      return true;
    }
    return false;
  }
  
  function UpdateMappingXML($typ, &$xml)
  {
    $typen = $this->getTabellen();
    $belege = $this->getBelege();
    $is_beleg = in_array($typ, $belege);
    $is_typ = false;
    if(!$is_beleg)$is_typ = in_array($typ, $typen);
    if($is_typ || $is_beleg)
    {
      if(isset($xml->id_ext))
      {
        $id_ext = (String)$xml->id_ext;
        if($id_ext != '')
        {
          $id = 0;
          if(isset($xml->id))$id = (int)$xml->id;
          if($id > 0)
          {
            $this->AddMapping($typ, $id, $id_ext);
          }
        }
      }
      if($is_beleg)
      {
        if(is_array($xml) || is_object($xml))
        {
          if(count($xml) > 0)
          {
            foreach($xml as $key => $value)
            {
              if($key == $typ.'_position_list')
              {
                if(is_array($value) || is_object($value))
                {
                  if(count($value) > 0)
                  {
                    foreach($value as $key2 => $value2)
                    {
                      if($key2 == $typ.'_position')
                      {
                        if(isset($value2->id_ext))
                        {
                          $id_ext2 = (String)$value2->id_ext;
                          if($id_ext2 != '')
                          {
                            $id2 = 0;
                            if(isset($value2->id))$id2 = (int)$value2->id;
                            if($id2 > 0)
                            {
                              $this->AddMapping($typ.'_position', $id2, $id_ext2);
                            }
                          }
                        }
                      }
                    }
                  }
                }
              }elseif($key == $typ.'_position')
              {
                if(isset($value->id_ext))
                {
                  $id_ext2 = (String)$value->id_ext;
                  if($id_ext2 != '')
                  {
                    $id2 = 0;
                    if(isset($value->id))$id2 = (int)$value->id;
                    if($id2 > 0)
                    {
                      $this->AddMapping($typ.'_position', $id2, $id_ext2);
                    }
                  }
                }
              }
            }
          }          
        }
      }
      return true;
    }
    return false;
  }
  
  function GetIDFromFeld($typ, &$xml)
  {
    if(!$typ)return false;
    if(is_object($xml) || is_array($xml))
    {
      if(count($xml) > 0)
      {
        $id = 0;
        if(isset($xml->id))$id = (int)$xml->id;
        if($id)return $id;
        $id_ext = '';
        if(isset($xml->id_ext))$id_ext = (String)$xml->id_ext;
        if($id_ext != '')
        {
          $id = (int)$this->app->DB->Select("SELECT id_int FROM api_mapping WHERE api = '".$this->api_id."' AND api != '0' AND tabelle = '$typ' AND id_ext = '".$this->app->DB->real_escape_string($id_ext)."' AND id_int > 0 LIMIT 1");
          if($id)return $id;
        }
        $projekt = $this->app->DB->Select("SELECT projekt FROM api_account WHERE id = '".$this->api_id."' AND api != '0' LIMIT 1");
        $eigenernummernkreis = false;
        if($projekt)$eigenernummernkreis = $this->app->DB->Select("SELCT eigenernummernkreis FROM projekt WHERE id = '$projekt' LIMIT 1");
        switch($typ)
        {
          case 'artikel':
            //nummer
            if(isset($xml->nummer))
            {
              $nummer = (String)$xml->nummer;
              if($nummer != '')
              {
                if($eigenernummernkreis)
                {
                  $id = $this->app->DB->Select("SELECT id FROM artikel WHERE nummer <> 'DEL' AND nummer = '".$this->app->DB->real_escape_string($nummer)."' AND projekt = '$projekt' LIMIT 1");
                }else{
                  $id = $this->app->DB->Select("SELECT id FROM artikel WHERE nummer <> 'DEL' AND nummer = '".$this->app->DB->real_escape_string($nummer)."' LIMIT 1");
                }
                if($id)return $id;
              }
            }
            
            //ean
            if(isset($xml->ean))
            {
              $ean = (String)$xml->ean;
              if($ean != '')
              {
                if($eigenernummernkreis)
                {
                  $id = $this->app->DB->Select("SELECT id FROM artikel WHERE nummer <> 'DEL' AND ean = '".$this->app->DB->real_escape_string($ean)."' AND projekt = '$projekt' LIMIT 1");
                }else{
                  $id = $this->app->DB->Select("SELECT id FROM artikel WHERE nummer <> 'DEL' AND ean = '".$this->app->DB->real_escape_string($ean)."' LIMIT 1");
                }
                if($id)return $id;
              }
            }
            //herstellernummer
            if(isset($xml->herstellernummer))
            {
              $herstellernummer = (String)$xml->herstellernummer;
              if($herstellernummer != '')
              {
                if($eigenernummernkreis)
                {
                  $id = $this->app->DB->Select("SELECT id FROM artikel WHERE nummer <> 'DEL' AND herstellernummer = '".$this->app->DB->real_escape_string($herstellernummer)."' AND projekt = '$projekt' LIMIT 1");
                }else{
                  $id = $this->app->DB->Select("SELECT id FROM artikel WHERE nummer <> 'DEL' AND herstellernummer = '".$this->app->DB->real_escape_string($herstellernummer)."' LIMIT 1");
                }
                if($id)return $id;
              }
            }         
          break;
          case 'lieferschein':
          case 'rechnung':
          case 'auftrag':
          case 'gutschrift':
          case 'angebot':
            if(isset($xml->belegnr) && (String)$xml->belegnr != '')$id = $this->app->DB->Select("SELECT id FROM $typ WHERE belegnr = '".$this->app->DB->real_escape_string((String)$xml->belegnr)."' LIMIT 1");
            if($id)return $id;
          break;
          case 'lieferschein_position':
          case 'rechnung_position':
          case 'auftrag_position':
          case 'gutschrift_position':
          case 'angebot_position':
            $_ptyp = str_replace('_position','',$typ);
            if(isset($xml->$_ptyp) && isset($xml->sort))
            {
              $id = $this->app->DB->Select("SELECT id FROM $typ WHERE $_ptyp = '".(int)$xml->$_ptyp."' AND sort = '".(int)$xml->sort."' AND $_ptyp != '0' AND sort != '0' LIMIT 1");
              if($id)return $id;
            }
          break;          
          case 'adresse':
            if(isset($xml->kundennummer))
            {
              $kundennummer = (String)$xml->kundennummer;
              if($kundennummer != '')
              {
                if($eigenernummernkreis)
                {
                  $id = $this->app->DB->Select("SELECT id FROM adresse WHERE geloescht <> '1' AND kundennummer = '".$this->app->DB->real_escape_string($kundennummer)."' AND projekt = '$projekt' LIMIT 1");
                }else{
                  $id = $this->app->DB->Select("SELECT id FROM adresse WHERE geloescht <> '1' AND kundennummer = '".$this->app->DB->real_escape_string($kundennummer)."' LIMIT 1");
                }
                if($id)return $id;
              }
            } 
            if(isset($xml->lieferantennummer))
            {
              $lieferantennummer = (String)$xml->lieferantennummer;
              if($lieferantennummer != '')
              {
                if($eigenernummernkreis)
                {
                  $id = $this->app->DB->Select("SELECT id FROM adresse WHERE geloescht <> '1' AND lieferantennummer = '".$this->app->DB->real_escape_string($lieferantennummer)."' AND projekt = '$projekt' LIMIT 1");
                }else{
                  $id = $this->app->DB->Select("SELECT id FROM adresse WHERE geloescht <> '1' AND lieferantennummer = '".$this->app->DB->real_escape_string($lieferantennummer)."' LIMIT 1");
                }
                if($id)return $id;
              }
            } 
          break;
        }
      }
    }
    return false;
  }
  
  
  function ParseTeilXML($typ, &$xml, $uebertragungen_account)
  {
    $typen = $this->getTabellen();
    $belege = $this->getBelege();
    $is_beleg = in_array($typ, $belege);
    $is_typ = false;
    if(!$is_beleg)$is_typ = in_array($typ, $typen);
    if($is_typ || $is_beleg)
    {
      $this->UpdateMappingXML($typ, $xml);
      if($is_beleg)
      {
        $id = $this->GetIDFromFeld($typ, $xml);
        if($id)
        {         
          switch($typ)
          {
            case 'lieferschein':
              if(isset($xml->tracking))
              {
                $tracking = (String)$xml->tracking;
                if($tracking != '')
                {
                  //Tracking speichern                  
                  $adresse = $this->app->DB->Select("SELECT adresse FROM lieferschein WHERE id='$id' LIMIT 1");
                  $projekt = $this->app->DB->Select("SELECT projekt FROM lieferschein WHERE id='$id' LIMIT 1");
                  $versand = '';
                  if(isset($xml->versandart))$versand = (String)$xml->versandart;
                  if(!$versand)$versand = $this->app->DB->Select("SELECT versandart FROM lieferschein WHERE id='$id' LIMIT 1");
                  $kg = $this->app->erp->VersandartMindestgewicht($id);
        
                  //$tracking = $this->app->erp->TrackingNummerAnpassen($projekt,$tracking);
                  //echo "\r\nTracking: ".$tracking."\r\n";
                  $tracking = $this->app->DB->real_escape_string($tracking);
                  
                  if($versand == 'versandunternehmen')$versand = $this->app->erp->Firmendaten("versandart");
                  $versand = strtolower($versand);
                  
                  $versandid = false;
                  if(!$this->app->DB->Select("SELECT id FROM versand WHERE tracking = '$tracking' AND lieferschein = '$id' LIMIT 1"))
                  {
                    $this->app->DB->Insert("INSERT INTO versand (id,versandunternehmen, tracking,
                      versendet_am,abgeschlossen,lieferschein,
                      freigegeben,firma,adresse,projekt,gewicht,paketmarkegedruckt,anzahlpakete)
                        VALUES ('','$versand','$tracking',NOW(),1,'$id',1,'".$this->app->User->GetFirma()."','$adresse','$projekt','$kg','1','1') ");
                    $versandid = $this->app->DB->GetInsertID();
                  }
                  
                  $auftragid = $this->app->DB->Select("SELECT auftragid FROM lieferschein WHERE id = '$id' LIMIT 1");
                  
                  if($versandid)
                  {
                    if(!empty($this->app->remote)) $this->app->erp->VersandAbschluss($versandid);
                    $tracking_link = null;
                    $sprache = null;
                    if(isset($xml->tracking_sprache) && (String)$xml->tracking_sprache)$sprache = (String)$xml->tracking_sprache;
                    if(isset($xml->tracking_link) && (String)$xml->tracking_link)$tracking_link = (String)$xml->tracking_link;
                    $sprache = strtolower(trim($sprache));
                    if($sprache == 'english')$sprache = 'englisch';
                    if($this->app->DB->Select("SELECT trackingmail FROM uebertragungen_account WHERE id = '$uebertragungen_account' LIMIT 1"))$this->app->erp->Versandmail($versandid, $tracking_link, $sprache, $tracking, true);
                    //Rechnungsmail
                    $rechnungid = $this->app->DB->Select("SELECT id FROM rechnung where auftragid = '$auftragid' and status <> 'storniert' LIMIT 1");
                    if($this->app->DB->Select("SELECT rechnungmail FROM uebertragungen_account WHERE id = '$uebertragungen_account' LIMIT 1"))
                    {
                      if($rechnungid)$this->app->erp->Rechnungsmail($rechnungid);
                    }
                    $this->app->DB->Insert("INSERT INTO uebertragungen_log (uebertragungen_account, typ, parameter1,parameter2, wert) VALUES ('$uebertragungen_account','lieferschein','$id','tracking','$tracking')");
                  }
                  
                  unset($kg);
                  unset($adresse);
                  unset($projekt);
                  unset($tracking);
                  unset($versand);
                  $lieferschein_positionen = null;
                  if(isset($xml->lieferschein_position_list))
                  {
                    if(isset($xml->lieferschein_position_list->lieferschein_position))
                    {
                      $lieferschein_positionen = &$xml->lieferschein_position_list->lieferschein_position;
                    }
                    
                  }elseif(isset($xml->lieferschein_position)){
                    $lieferschein_positionen = &$xml->lieferschein_position;
                  }
                  if($lieferschein_positionen)
                  {
                    foreach($lieferschein_positionen as $position)
                    {
                      if(isset($position->sort) &&  !isset($position->lieferschein))$position->lieferschein = $id;
                      $id_pos = $this->GetIDFromFeld('lieferschein_position', $position);
                      if($id_pos)
                      {
                        $check = $this->app->DB->SelectArr("SELECT * FROM lieferschein_position WHERE id = '$id_pos' AND lieferschein = '$id' LIMIT 1");
                        if($check)
                        {
                          $check = reset($check);                    
                          if(isset($position->geliefert))
                          {
                            $geliefert = round((float)$position->geliefert,4);
                            if($check['menge'] >= $geliefert)$this->app->DB->Update("UPDATE lieferschein_position SET geliefert = '$geliefert' WHERE id = '$id_pos' LIMIT 1");
                          }
                        }
                      }
                    }
                  }else $this->app->DB->Update("UPDATE lieferschein_position SET geliefert = menge WHERE lieferschein = '$id'");
                  $this->app->DB->Update("UPDATE lieferschein SET status = 'versendet' WHERE id = '$id' LIMIT 1");
                }
              }

            break;
          }
          
          
        /*
        if(is_array($xml) || is_object($xml))
        {
          if(count($xml) > 0)
          {
            foreach($xml as $key => $value)
            {
              if($key == $typ.'_position_list')
              {
                if(is_array($value) || is_object($value))
                {
                  if(count($value) > 0)
                  {
                    foreach($value as $key2 => $value2)
                    {
                      if($key2 == $typ.'_position')
                      {
                        if(isset($value2->id_ext))
                        {
                          $id_ext2 = (String)$value2->id_ext;
                          if($id_ext2 != '')
                          {
                            $id2 = 0;
                            if(isset($value2->id))$id2 = (int)$value2->id;
                            if($id2 > 0)
                            {
                              $this->AddMapping($typ.'_position', $id2, $id_ext2);
                            }
                          }
                        }
                      }
                    }
                  }
                }
              }elseif($key == $typ.'_position')
              {
                if(isset($value->id_ext))
                {
                  $id_ext2 = (String)$value->id_ext;
                  if($id_ext2 != '')
                  {
                    $id2 = 0;
                    if(isset($value->id))$id2 = (int)$value->id;
                    if($id2 > 0)
                    {
                      $this->AddMapping($typ.'_position', $id2, $id_ext2);
                    }
                  }
                }
              }
            }
          }          
        }*/
          
        }else{
          //Beleg nicht gefunden
          //echo "$typ nicht gefunden\r\n";
          switch($typ)
          {
            case 'lieferschein':
              if(isset($xml->tracking))
              {
                if(isset($xml->belegnr))$this->app->DB->Insert("INSERT INTO uebertragungen_log (uebertragungen_account, typ, parameter1,parameter2, wert) VALUES ('$uebertragungen_account','lieferschein','".(String)$xml->belegnr."','tracking_fehler','Lieferschein ".(String)$xml->belegnr." nicht gefunden')");
              }
            break;
          }
        }
        

      }elseif($is_typ)
      {
        $id = $this->GetIDFromFeld($typ, $xml);
        if($id)
        {
          switch($typ)
          {
            case 'artikel':
              if(isset($xml->lagerzahl))
              {
                $lagerzahl = (String)$xml->lagerzahl;
                $lager_platz_id = false;
                $lagerplatz = false;
                if(isset($xml->lager_platz))
                {
                  
                  $lagerplatz = (String)$xml->lager_platz;
                  
                  $lagerplatz = $this->app->DB->Select("SELECT id FROM lager_platz WHERE kurzbezeichnung = '".$this->app->DB->real_escape_string($lagerplatz)."' LIMIT 1");
                  
                  $lager_platz_id = $lagerplatz;
                  
                }else{
                  $lagerplatz = $this->app->DB->Select("SELECT lager FROM uebertragungen_account WHERE id = '".$uebertragungen_account."' LIMIT 1");
                  $lager_platz_id = $lagerplatz;
                }
                if($lagerzahl != '')
                {
                  $lagerzahl = (int)$lagerzahl;
                  if($lager_platz_id)
                  {
                    $vorhanden = (int)$this->app->DB->Select("SELECT sum(menge) FROM lager_platz_inhalt WHERE lager_platz = '$lager_platz_id' AND artikel = '$id'");
                  }else
                  {
                    $vorhanden = (int)$this->app->erp->ArtikelAnzahlLager($id);
                  }
                  $projekt = (int)$this->app->DB->Select("SELECT projekt FROM artikel WHERE id = '$id' LIMIT 1");
                  if($lagerzahl > $vorhanden)
                  {

                    if(!$lagerplatz)$lagerplatz = $this->app->DB->Select("SELECT lager_platz FROM artikel WHERE id = '$id' LIMIT 1");
                    if(!$lagerplatz)$lagerplatz = $this->app->DB->Select("SELECT lp.id FROM lager_platz_inhalt lpi INNER JOIN lager_platz lp ON lpi.lager_platz = lp.id WHERE lpi.artikel = '$id' AND lp.sperrlager = 0 AND lp.poslager = 0 ORDER by lpi.menge DESC LIMIT 1");
                    if(!$lagerplatz)$lagerplatz = $this->app->DB->Select("SELECT lp.id FROM lager_platz lp WHERE lp.sperrlager = 0 AND lp.poslager = 0 ORDER by lp.id ASC LIMIT 1");
                    if($lagerplatz)
                    {
                      $this->app->erp->LagerEinlagern($id,$lagerzahl - $vorhanden,$lagerplatz,$projekt,'API Korrektur',true);
                      $this->app->DB->Insert("INSERT INTO uebertragungen_log (uebertragungen_account, typ, parameter1,parameter2, wert) VALUES ('$uebertragungen_account','artikel','$id','lagerzahl','$lagerzahl')");
                    }
                  }elseif($lagerzahl < $vorhanden)
                  {
                    $auslagern = $vorhanden - $lagerzahl;
                    if(!$lagerplatz)$lagerplatz = $this->app->DB->Select("SELECT lager_platz FROM artikel WHERE id = '$id' LIMIT 1");
                    if($lagerplatz)
                    {
                      $bestand = $this->app->erp->ArtikelImLagerPlatz($id, $lagerplatz);
                      if($bestand >= $auslagern)
                      {
                        $this->app->erp->LagerAuslagernRegal($id, $lagerplatz, $auslagern, $projekt,'API Korrektur',true );
                        $auslagern = 0;
                      }elseif($bestand > 0)
                      {
                        $this->app->erp->LagerAuslagernRegal($id, $lagerplatz, $bestand, $projekt,'API Korrektur',true );
                        $auslagern -= $bestand;
                      }
                    }
                    if($auslagern > 0 && !$lager_platz_id)
                    {
                      $lagerplaetze = $this->app->DB->SelectArr("SELECT lp.id FROM lager_platz_inhalt lpi INNER JOIN lager_platz lp ON lpi.lager_platz = lp.id WHERE lpi.artikel = '$id' AND lp.sperrlager = 0 AND lp.poslager = 0 ORDER by lpi.menge DESC");
                      if($lagerplaetze)
                      {
                        foreach($lagerplaetze as $lagerplatz)
                        {
                          $bestand = $this->app->erp->ArtikelImLagerPlatz($id, $lagerplatz['id']);
                          if($bestand >= $auslagern)
                          {
                            $this->app->erp->LagerAuslagernRegal($id, $lagerplatz['id'], $auslagern, $projekt,'API Korrektur',true );
                            $auslagern = 0;
                          }elseif($bestand > 0)
                          {
                            $this->app->erp->LagerAuslagernRegal($id, $lagerplatz['id'], $bestand, $projekt,'API Korrektur',true );
                            $auslagern -= $bestand;
                          }
                          if($auslagern <= 0)break;
                        }
                      }
                    }
                    if($auslagern != $vorhanden - $lagerzahl)
                    {
                      $this->app->DB->Insert("INSERT INTO uebertragungen_log (uebertragungen_account, typ, parameter1,parameter2, wert) VALUES ('$uebertragungen_account','artikel','$id','lagerzahl','$lagerzahl')");
                    }
                  }
                }
                //MHD
                if(isset($xml->mhd))
                {
                  if(!$lagerplatz)$lagerplatz = $this->app->DB->Select("SELECT lager_platz FROM artikel WHERE id = '$id' LIMIT 1");
                  if(!$lagerplatz)$lagerplatz = $this->app->DB->Select("SELECT lp.id FROM lager_platz_inhalt lpi INNER JOIN lager_platz lp ON lpi.lager_platz = lp.id WHERE lpi.artikel = '$id' AND lp.sperrlager = 0 AND lp.poslager = 0 ORDER by lpi.menge DESC LIMIT 1");
                  if(!$lagerplatz)$lagerplatz = $this->app->DB->Select("SELECT lp.id FROM lager_platz lp WHERE lp.sperrlager = 0 AND lp.poslager = 0 ORDER by lp.id ASC LIMIT 1");
                  
                  if($lager_platz_id)
                  {
                    $wawimhd = $this->app->DB->SelectArr("SELECT * FROM lager_mindesthaltbarkeitsdatum WHERE artikel = '$id' AND lager_platz = '$lager_platz_id' order by mhddatum, menge desc");
                    $chargenmhd = $this->app->DB->SelectArr("SELECT * FROM lager_charge WHERE artikel = '$id' AND lager_platz = '$lager_platz_id' order by charge, menge desc");
                  }else{
                    $wawimhd = $this->app->DB->SelectArr("SELECT * FROM lager_mindesthaltbarkeitsdatum WHERE artikel = '$id' order by mhddatum");
                    $chargenmhd = $this->app->DB->SelectArr("SELECT * FROM lager_charge WHERE artikel = '$id' order by charge, menge desc");
                    if($wawimhd)
                    {
                      $mhdohnelager = $this->app->DB->SelectArr("SELECT mhddatum, sum(menge) as smenge FROM lager_mindesthaltbarkeitsdatum WHERE artikel = '$id' group by mhddatum order by mhddatum ");
                    }
                    if($chargenmhd)
                    {
                      $chargenohnelager = $this->app->DB->SelectArr("SELECT charge, sum(menge) as smenge FROM lager_charge WHERE artikel = '$id' group by charge order by charge ");
                    }
                  }
                  
                  $mhd = $xml->mhd;
                  $mhddatum = json_decode(json_encode($mhd->datum),true);
                  $mhdanzahl = null;
                  $mhdcharge = null;
                  if(isset($mhd->anzahl))$mhdanzahl = json_decode(json_encode($mhd->anzahl),true);
                  if(isset($mhd->charge))
                  {
                    $mhdcharge = json_decode(json_encode($mhd->charge),true);
                  }
                  
                  foreach($mhddatum as $kmhd => $m)
                  {
                    $charge = '';
                    $anzahl = 1;
                    if(isset($mhd->charge))$charge = (String)$mhdcharge[$kmhd];
                    if(isset($mhd->anzahl))$anzahl = (int)$mhdanzahl[$kmhd];
                    $datum = date('Y-m-d',strtotime( (String)$m));
                    $chargenlager = null;
                    $found = false;
                    $foundcharge = false;
                    if($wawimhd)
                    {
                      if($lager_platz_id)
                      {
                        foreach($wawimhd as $k => $v)
                        {
                          if($v['mhddatum'] == $datum)
                          {
                            $found = true;
                            $wawimhd[$k]['gefunden'] = true;
                            if($v['menge'] != $anzahl)
                            {
                              $this->app->DB->Update("UPDATE lager_mindesthaltbarkeitsdatum SET menge = '$anzahl' WHERE id = '".$v['id']."' LIMIT 1");
                              break;
                            }
                          }
                        }
                        if($chargenmhd && $charge)
                        {
                          foreach($chargenmhd as $k => $v)
                          {
                            if($v['charge'] == $charge)
                            {
                              $foundcharge = true;
                              $chargenmhd[$k]['gefunden'] = true;
                              if($v['menge'] != $anzahl)
                              {
                                $this->app->DB->Update("UPDATE lager_charge SET menge = '$anzahl' WHERE id = '".$v['id']."' LIMIT 1");
                                break;
                              }
                            }
                          }
                        }
                        if(!$found)
                        {
                          $this->app->DB->Insert("INSERT INTO lager_mindesthaltbarkeitsdatum (artikel, datum, mhddatum, menge, lager_platz, charge) values ('$id',now(),'$datum','$anzahl','$lager_platz_id','".$this->app->DB->real_escape_string($charge)."')");
                        }
                        if(!$foundcharge && $charge)
                        {
                          $this->app->DB->Insert("INSERT INTO lager_charge (artikel, datum, menge, lager_platz, charge) values ('$id',now(),'$anzahl','$lager_platz_id','".$this->app->DB->real_escape_string($charge)."')");
                        }
                      }else{
                        if($mhdohnelager)
                        {
                          foreach($mhdohnelager as $k => $v)
                          {
                            if($v['mhddatum'] == $datum)
                            {
                              $mhdohnelager[$k]['gefunden'] = true;
                              $found = true;
                              if($v['smenge'] < $anzahl)
                              {
                                foreach($wawimhd as $k2 => $v2)
                                {
                                  if($v2['mhddatum'] == $datum)
                                  {
                                    $this->app->DB->Update("UPDATE lager_mindesthaltbarkeitsdatum SET menge = $anzahl WHERE id = '".$v2['id']."' LIMIT 1");
                                    if($charge)
                                    {
                                      $hinzuf = $anzahl - $v['smenge'];
                                      if(!isset($chargenlager[$v2['lager_platz'].'-'.$charge]))$chargenlager[$v2['lager_platz'].'-'.$charge] = 0;
                                      $chargenlager[$v2['lager_platz'].'-'.$charge] += $hinzuf;
                                    }
                                    break;
                                  }
                                }
                              }elseif($v['smenge'] > $anzahl)
                              {
                                $abzuziehen = $v['smenge'] - $anzahl;
                                foreach($wawimhd as $k2 => $v2)
                                {
                                  if($v2['menge'] > 0)
                                  {
                                    if($abzuziehen > 0)
                                    {
                                      if($abzuziehen >= $v2['menge'])
                                      {
                                        $abzuziehen -= $v2['menge'];
                                        $this->app->DB->Delete("DELETE FROM lager_mindesthaltbarkeitsdatum WHERE id = '".$v2['id']."' LIMIT 1");
                                        if(!isset($chargenlager[$v2['lager_platz'].'-'.$charge]))$chargenlager[$v2['lager_platz'].'-'.$charge] = 0;
                                        $chargenlager[$v2['lager_platz'].'-'.$charge] -= $v2['menge'];
                                      }else{
                                        $this->app->DB->Update("UPDATE lager_mindesthaltbarkeitsdatum SET menge = menge - $abzuziehen WHERE id = '".$v2['id']."' LIMIT 1");
                                        if(!isset($chargenlager[$v2['lager_platz'].'-'.$charge]))$chargenlager[$v2['lager_platz'].'-'.$charge] = 0;
                                        $chargenlager[$v2['lager_platz'].'-'.$charge] -= $abzuziehen;
                                        $abzuziehen = 0;
                                        break;
                                      }
                                    }
                                  }
                                }
                              }
                            }
                          }
                          if(!$found)
                          {
                            $this->app->DB->Insert("INSERT INTO lager_mindesthaltbarkeitsdatum (artikel, datum, mhddatum, menge, lager_platz, charge) values ('$id',now(),'$datum','$anzahl','$lager_platz_id','".$this->app->DB->real_escape_string($charge)."')");
                            if(!isset($chargenlager[$lager_platz_id.'-'.$charge]))$chargenlager[$lager_platz_id.'-'.$charge] = 0;
                            $chargenlager[$lager_platz_id.'-'.$charge] += $anzahl;
                          }
                        }
                      }
                    }else{
                      $this->app->DB->Insert("INSERT INTO lager_mindesthaltbarkeitsdatum (artikel, datum, mhddatum, menge, lager_platz, charge) values ('$id',now(),'$datum','$anzahl','$lagerplatz','".$this->app->DB->real_escape_string($charge)."')");
                      if(!isset($chargenlager[$lagerplatz.'-'.$charge]))$chargenlager[$lagerplatz.'-'.$charge] = 0;
                      $chargenlager[$lagerplatz.'-'.$charge] += $anzahl;
                    }
                    if(isset($chargenlager))
                    {
                      foreach($chargenlager as $kl => $vls)
                      {
                        $vla = explode('-', $vls, 2);
                        $vl = $vla[0];
                        $charge = '';
                        if(isset($vla[1]))$charge = $vla[1];
                        if($charge)
                        {
                          if($vl < 0)
                          {
                            if($chargenmhd)
                            {
                              $abzuziehen = -$vl;
                              foreach($chargenmhd as $vch)
                              {
                                if($vch['lager_platz'] == $kl && $charge == $vch['charge'])
                                {
                                  if($vch['menge'] > $abzuziehen)
                                  {
                                    $this->app->DB->Update("UPDATE lager_charge SET menge = menge - $abzuziehen WHERE id = '".$vch['id']."' LIMIT 1");
                                    $abzuziehen = 0;
                                    break;
                                  }elseif($vch['menge'] == $abzuziehen)
                                  {
                                    $this->app->DB->Delete("DELETE FROM lager_charge id = '".$vch['id']."' LIMIT 1");
                                    break;                                  
                                  }elseif($abzuziehen > 0)
                                  {
                                    $this->app->DB->Delete("DELETE FROM lager_charge id = '".$vch['id']."' LIMIT 1");
                                    $abzuziehen -= $vch['menge'];
                                  }
                                }
                              }
                            }
                          }elseif($vl > 0)
                          {
                            $hinzuf = $vl;
                            if($chargenmhd)
                            {
                              foreach($chargenmhd as $vch)
                              {
                                if($vch['lager_platz'] == $kl && $charge == $vch['charge'])
                                {
                                  $this->app->DB->Update("UPDATE lager_charge SET menge = menge + $vl WHERE id = '".$vch['id']."' LIMIT 1");
                                  $hinzuf = 0;
                                  break;
                                }                                
                              }
                            }
                            if($hinzuf)
                            {
                              $this->app->DB->Insert("INSERT INTO lager_charge (artikel, lager_platz, menge, charge) values ('$id','$kl','$hinzuf','$charge')");
                            }
                          }
                        }
                      }
                    }
                  }
                  if(isset($wawimhd))
                  {
                    if($lager_platz_id)
                    {
                      foreach($wawimhd as $k => $v)
                      {
                        if(!isset($v['gefunden']))
                        {
                          $this->app->DB->Delete("DELETE FROM lager_mindesthaltbarkeitsdatum WHERE id = '".$v['id']."' LIMIT 1");
                        }
                      }
                      if($charge)
                      {
                        $checkcharge = $this->app->DB->SelectArr("SELECT charge, sum(menge) as smenge FROM lager_charge WHERE artikel = '$id' GROUP BY charge");
                        if($checkcharge)
                        {
                          foreach($checkcharge as $vc)
                          {
                            $checkmindest = $this->app->DB->Select("SELECT sum(menge) as smenge FROM lager_mindesthaltbarkeitsdatum WHERE artikel = '$id' AND lager_platz = '$lager_platz_id' AND charge = '".$vc['charge']."' ");
                            if(!$checkmindest)$this->app->DB->Delete("DELETE FROM lager_charge WHERE artikel= '$id' AND charge = '".$vc['charge']."' AND lager_platz = '$lager_platz_id'");
                          }
                        }
                      }                      
                    }else{
                      if($mhdohnelager)
                      {
                        foreach($mhdohnelager as $k => $v)
                        {
                          if(!isset($v['gefunden']))
                          {
                            $this->app->DB->Delete("DELETE FROM lager_mindesthaltbarkeitsdatum WHERE artikel = '$id' AND mhddatum = '".$v['mhddatum']."'");
                          }
                        }
                        if($charge)
                        {
                          $checkcharge = $this->app->DB->SelectArr("SELECT charge,lager_platz sum(menge) as smenge FROM lager_charge WHERE artikel = '$id' GROUP BY charge, lager_platz");
                          if($checkcharge)
                          {
                            foreach($checkcharge as $vc)
                            {
                              $checkmindest = $this->app->DB->Select("SELECT sum(menge) as smenge FROM lager_mindesthaltbarkeitsdatum WHERE artikel = '$id' AND lager_platz = '".$vc['lager_platz']."' AND charge = '".$vc['charge']."' ");
                              if(!$checkmindest)$this->app->DB->Delete("DELETE FROM lager_charge WHERE artikel= '$id' AND charge = '".$vc['charge']."' AND lager_platz = '".$vc['lager_platz']."'");
                            }
                          }
                        }
                      }
                    }
                  }
                }
              }
            break;
          }
          
          //echo "$typ $id \r\n";
        }else{
          switch($typ)
          {
            case 'artikel':
              $parameter1 = '';
              $meldung = 'Artikel ';
              if(isset($xml->lagerzahl))
              {
                if(isset($xml->nummer))
                {
                  if($parameter1 == '')
                  {
                    $parameter1 = (String)$xml->nummer;
                    $meldung .= "mit Artikelnummer ".$parameter1." nicht gefunden";
                  }
                }
            
                if(isset($xml->ean))
                {
                  if($parameter1 == '')
                  {
                    $parameter1 = (String)$xml->ean;
                    $meldung .= "mit EAN ".$parameter1." nicht gefunden";
                  }
                }
                if(isset($xml->herstellernummer))
                {
                  if($parameter1 == '')
                  {
                    $parameter1 = (String)$xml->herstellernummer;
                    $meldung .= "mit Herstellernumemr ".$parameter1." nicht gefunden";
                  }
                }
                if($parameter1)
                {
                  $this->app->DB->Insert("INSERT INTO uebertragungen_log (uebertragungen_account, typ, parameter1,parameter2, wert) VALUES ('$uebertragungen_account','artikel','".$this->app->DB->real_escape_string($parameter1)."','lagerzahl_fehler','".$this->app->DB->real_escape_string($meldung)."')");
                }
              }
            break;
          }
        }
      }
    }
  }
  
  function LoadFromXML($dateiname)
  {
    if(is_file($dateiname))
    {
      $content = file_get_contents($dateiname);
      return simplexml_load_string($content);
    }
    return false;
  }
  
  function EntferneSteuerzeichen($string)
  {
    $len = strlen($string);
    $out = '';
    for($i = 0; $i < $len; $i++)
    {
      $ord = ord($string{$i});
      if($ord != 127 && ($ord > 31 || $ord == 13 || $ord == 10 || $ord == 9))$out .= $string{$i};
    }
    return $out;
  }
  
  function SaveXML(&$xml, $dateiname, $action = '')
  {
    if(!$dateiname)return false;
    if(!$xml)return false;
    
    $content = $this->XMLResponse(1,$xml, true, true, $action);
    if($content)
    {
      if(strpos($dateiname,'/') === false)
      {
        $dateiname = rtrim($this->app->Config->WFuserdata,'/').'/'.$dateiname;
      }
      
      $erg = file_put_contents($dateiname, $this->EntferneSteuerzeichen($content));
      if($erg !== false)return true;
    }
    return false;
  }
  
  function CreateXmlObj()
  {
$xmlstr = <<<XML
<?xml version="1.0" encoding="UTF-8"?>
<response>
</response>
XML;
    return new SimpleXMLElement($xmlstr);
  }

  function AddToXMLObj(&$xml_obj, $elementname, $parentelementname, $data, &$toelment = null, &$erg = null)
  {
    if(is_null($toelment))
    {
      if(!isset($xml_obj->xml))
      {
        $xml_obj->AddChild('xml','');
      }
      if(is_array($data))
      {
        if($parentelementname)
        {
          if(isset($xml_obj->xml->$parentelementname))
          {
            $parent = $xml_obj->xml->$parentelementname;
          }else{
            $parent = $xml_obj->xml->AddChild($parentelementname,'');
          }
          foreach($data as $k => $c)
          {
            $child = $parent->AddChild($elementname, '');
            if(is_array($c))
            {
              foreach($c as $key => $value)
              {
                $child->$key = $value;
              }
            }
          }
          $erg = $child;
        }else{
          if(isset($data[0]))
          {
            foreach($data as $k => $c)
            {
              $child = $xml_obj->xml->AddChild($elementname, '');
              if(is_array($c))
              {
                foreach($c as $key => $value)
                {
                  $child->$key = $value;
                }
              }
            }
            $erg = $child;
          }else{
            $child = $xml_obj->xml->AddChild($elementname, '');
            foreach($data as $key => $value)
            {
              $child->$key = $value;
            }
            $erg = $child;
          }
        }
      }else{
        
        $child = $xml_obj->xml->AddChild($elementname, $data);
        $erg = $child;
      }
    }else{
      if(is_array($data))
      {
        if($parentelementname)
        {
          if(isset($toelment->$parentelementname))
          {
            $parent = $toelment->$parentelementname;
          }else{
            $parent = $toelment->AddChild($parentelementname,'');
          }
          foreach($data as $k => $c)
          {
            $child = $parent->AddChild($elementname, '');
            if(is_array($c))
            {
              foreach($c as $key => $value)
              {
                $child->$key = $value;
              }
            }
            $erg = $child;
          }
        }else{
          if(isset($data[0]))
          {
            foreach($data as $k => $c)
            {
              $child = $toelment->AddChild($elementname, '');
              if(is_array($c))
              {
                foreach($c as $key => $value)
                {
                  $child->$key = $value;
                }
              }
              $erg = $child;
            }
          }else{
            $toelment->$elementname = $data;
            $erg = $toelment->$elementname;
          }
        }
      }else{
        $child = $toelment->AddChild($elementname, $data);
        $erg = $child;
      }
    }
  }
  
  function XMLResponse($messagecode,$xml_inside="", $xml_obj = false, $return = false, $action = '')
  {
    if(!$action)
    {
      if(isset($this->app->Secure))$action = $this->app->Secure->GetGET("action");
    }
    if($xml_obj)
    {
      if(!isset($xml_inside->status))$status = $xml_inside->AddChild('status','');
      if(!isset($xml_inside->status->action))$xml_inside->status->AddChild('action',$action);
      if(!isset($xml_inside->status->message))$xml_inside->status->AddChild('message',utf8_encode($this->MessageCode($messagecode)));
      if(!isset($xml_inside->status->messageCode))$xml_inside->status->AddChild('messageCode',$messagecode);
      if($return)return $xml_inside->asXML();
      header('Content-Type: application/xml; charset=utf-8');
      echo $xml_inside->asXML();
      exit;
    }

    // if further xml is given
    $append = "";
    if($xml_inside!="")
    {
      //$md5sum = md5($xml_inside);

      //$append = '<md5sum>'.$md5sum.'</md5sum>';
      $append .='<xml>'.$xml_inside.'</xml>';
    }

    header('Content-Type: application/xml; charset=utf-8');
    echo "<?xml version=\"1.0\" encoding=\"UTF-8\"?>
      <response>
      <status>
      <action>$action</action>
      <message>".utf8_encode($this->MessageCode($messagecode))."</message>
      <messageCode>".$messagecode."</messageCode>
      </status>
      ".$append."
      </response>";
    exit;
  }

  function XMLCleanUTF8( &$arr ) {
    foreach ( $arr as $idx => $_ ) {
      if( is_array( $_ ) ) $this->XMLCleanUTF8( $arr[$idx] );
      else {
        if( is_string( $_ ) ) {
          $arr[$idx] = $this->app->erp->ConvertForDBUTF8($_);
        }
      }
    }
  }


  function XMLClean( &$arr ) {
    foreach ( $arr as $idx => $_ ) {
      if( is_array( $_ ) ) $this->XMLClean( $arr[$idx] );
      else {
        if( is_string( $_ ) ) {
          if(mb_detect_encoding($_, 'UTF-8, ISO-8859-1') === 'UTF-8')
            $arr[$idx] = $this->app->erp->ConvertForDB($_);
          else
            $arr[$idx] = $this->app->erp->ConvertForDBUTF8($_);
        }
      }
    }
  }

  function XMLPostPlain()
  {
    $xml = $this->app->Secure->POST["xml"];


    /*
    //$xml = $this->app->Secure->GetPOST("xml");
    $xml = mysqli_real_escape_string($this->app->DB->connection,$this->app->Secure->POST["xml"]);
    $xml = str_replace('<?xml version=\"1.0\" encoding=\"UTF-8\"?>','<?xml version="1.0" encoding="UTF-8"?>',$xml);
    $xml = str_replace('>\n','>',$xml);
    $xml = str_replace('\"','"',$xml);
    $xml = str_replace('&#13;','',$xml);
    //$xml = str_replace('&','&amp;',$xml);
     */

    $deXml = simplexml_load_string($xml);
    return $deXml;
  }

  function XMLPost()
  {
    $api_id = isset($this->api_id)?$this->api_id:0;
    $xml = $this->app->Secure->POST["xml"];
    /*
    //$xml = $this->app->Secure->GetPOST("xml");
    $xml = mysqli_real_escape_string($this->app->DB->connection,$this->app->Secure->POST["xml"]);
    $xml = str_replace('<?xml version=\"1.0\" encoding=\"UTF-8\"?>','<?xml version="1.0" encoding="UTF-8"?>',$xml);
    $xml = str_replace('>\n','>',$xml);
    $xml = str_replace('\"','"',$xml);
    $xml = str_replace('&#13;','',$xml);
    //$xml = str_replace('&','&amp;',$xml);
     */
     
    $deXml = simplexml_load_string($xml);
    $this->app->erp->DumpVar($deXml);
    $deJson = json_encode($deXml);
    $xml_array = json_decode($deJson,TRUE);
    if($api_id)
    {
      $api_cleanutf8 = $this->app->DB->Select("SELECT cleanutf8 FROM api_account WHERE id = '$api_id' LIMIT 1");
    }else{
      $api_cleanutf8 = $this->app->erp->Firmendaten("api_cleanutf8");
    }


    $tmp = $xml_array['xml'];
     
    if($this->app->Secure->GetGET("action")=="AuftragEdit" || $this->app->Secure->GetGET("action")=="AuftragCreate")
    {
      if($api_cleanutf8=="1")
        $this->XMLCleanUTF8($tmp);
      else
        $this->XMLClean($tmp);
    }
    else if($this->app->Secure->GetGET("action")=="AdresseEdit" || $this->app->Secure->GetGET("action")=="AdresseCreate")
    {
      if($api_cleanutf8=="1")
        $this->XMLCleanUTF8($tmp);
      else
        $this->XMLClean($tmp);
    }
    else if($this->app->Secure->GetGET("action")=="ArtikelEdit" || $this->app->Secure->GetGET("action")=="ArtikelCreate")
    {
      if($api_cleanutf8=="1")
        $this->XMLCleanUTF8($tmp);
      else
        $this->XMLClean($tmp);
    }
    else if($this->app->Secure->GetGET("action")=="GruppeEdit" || $this->app->Secure->GetGET("action")=="GruppeCreate")
    {
      if($api_cleanutf8=="1")
        $this->XMLCleanUTF8($tmp);
      else
        $this->XMLClean($tmp);
    }
    else
      $this->XMLClean($tmp);

    $this->app->erp->DumpVar($tmp);
    return $tmp;
  }

  function MessageCode($messagecode)
  {
    switch($messagecode)
    {
      case 1: $message = "OK"; break;
      case 2: $message = "Wrong Hash"; break;
      case 3: $message = "Wrong number of GET parameters"; break;
      case 4: $message = "Wrong XML data structure for method"; break;
      case 5: $message = "Invalid key (id)"; break;
      case 6: $message = "Wrong md5sum"; break;
      case 7: $message = "Username exists already"; break;
      case 8: $message = "Data not found"; break;
      default: $message = "Unkown message code"; 
    }   
    return $message;
  }     

  function ApiAdresseCreate($internal=false)
  {
    $xmldata = $this->XMLPost();
    // anlegen der adresse
     $this->app->erp->LogFile("NAME: ".$xmldata['name'],$xmldata);
    $this->app->erp->DumpVar($xmldata);
    if($xmldata['name']!="" && !is_array($xmldata['name']))
    {
      //adresse anlegen
      $xmldata['strasse'] = $xmldata['strasse']." ".$xmldata['hausnummer'];
      if($xmldata['strasse_hausnummer']!="" && !is_array($xmldata['strasse_hausnummer'])) $xmldata['strasse'] = $xmldata['strasse_hausnummer'];

      $xmldata['email'] = str_replace(" ","",$xmldata['email']);

      switch($xmldata['typ'])
      {
        case "mr": $xmldata['typ']="herr"; break;
        case "mr.": $xmldata['typ']="herr"; break;
        case "ms": $xmldata['typ']="frau"; break;
        case "mrs": $xmldata['typ']="frau"; break;
        case "mrs.": $xmldata['typ']="frau"; break;
      }

      if($xmldata['firma']!="" && !is_array($xmldata['firma']))
      {
        if($xmldata['vorname']!="" && !is_array($xmldata['vorname']))
          $xmldata['ansprechpartner']=$xmldata['vorname']." ".$xmldata['name'];
        else
          $xmldata['ansprechpartner']=$xmldata['name'];  
        $xmldata['name']=$xmldata['firma'];
        $xmldata['typ']='firma';
      } else
      {
       if($xmldata['vorname']!="" && !is_array($xmldata['vorname']))
         $xmldata['name']=$xmldata['vorname']." ".$xmldata['name'];
      }
        
    }

    $id = $this->app->erp->CreateAdresse($xmldata['name']);

    //kundennummer=1 bedeutet gleiche Rolle Kunde anlegen
    if($xmldata['projekt']!="" && !is_array($xmldata['projekt']))
      $xmldata['projekt'] = $this->app->DB->Select("SELECT id FROM projekt WHERE abkuerzung='".$xmldata['projekt']."' LIMIT 1");
    else        
      $xmldata['projekt'] = $this->app->erp->GetStandardProjekt();

    $tmp_data_adresse = $this->app->DB->SelectArr("SELECT * FROM adresse WHERE id='$id' LIMIT 1");
    $tmp_data_adresse = reset($tmp_data_adresse);

    if(strtoupper($xmldata['kundennummer'])=="NEW" || strtoupper($xmldata['kundennummer'])=="NEU")
    {
      $xmldata['kundennummer'] = $this->app->erp->GetNextKundennummer($xmldata['projekt'],$tmp_data_adresse);
      $this->app->erp->ObjektProtokoll("adresse",$id,"adresse_next_kundennummer","Kundennummer ".$xmldata['kundennummer']." erhalten");
    }

    if(strtoupper($xmldata['lieferantennummer'])=="NEW" || strtoupper($xmldata['lieferantennummer'])=="NEU")
    {
      $xmldata['lieferantennummer'] = $this->app->erp->GetNextLieferantennummer($xmldata['projekt'],$tmp_data_adresse);
      $this->app->erp->ObjektProtokoll("adresse",$id,"adresse_next_lieferantennummer","Lieferantennummer ".$xmldata['lieferantennummer']." erhalten");
    }

    if($xmldata['porto_preis']!="" && $xmldata['porto_artikelid']!="" && !is_array($xmldata['porto_preis']))
      $this->app->erp->AddVerkaufspreis($xmldata['porto_artikelid'],1,$id,$xmldata['porto_preis']);


    foreach($xmldata as $key=>$value)
    {
      if(is_array($value))$value="";            
      if($key=="sonstiges") $value = strip_tags(html_entity_decode($value));
      if($key=="rabattinformation") $value = html_entity_decode($value);

      if($key!="id")
        $this->app->DB->Update("UPDATE adresse SET $key='$value' WHERE id='$id' LIMIT 1");
    }

    // Wenn Kundennummer vorhanden sofort Lieferant anlegen
    if($xmldata['kundennummer']!="" && !is_array($xmldata['kundennummer']))
      $this->app->erp->AddRolleZuAdresse($id, "Kunde", "von", "Projekt", $xmldata['projekt'] );

    if($xmldata['lieferantennummer']!="" && !is_array($xmldata['lieferantennummer']))
      $this->app->erp->AddRolleZuAdresse($id, "Lieferant", "von", "Projekt", $xmldata['projekt'] );

    if($xmldata['verband']!="" && !is_array($xmldata['verband']))
      $this->app->erp->AddRolleZuAdresse($id, "Kunde", "von", "Gruppe", $xmldata['verband']);

    if($xmldata['liefername']!="" && !is_array($xmldata['liefername']))
    {
      $xmldata['liefername'] = $xmldata['liefervorname']." ".$xmldata['liefername'];
      $xmldata['lieferstrasse'] = $xmldata['lieferstrasse']." ".$xmldata['lieferhausnummer'];

      if($xmldata['lieferfirma']!="" && !is_array($xmldata['lieferfirma']))
      {
        $xmldata['lieferadresszusatz']=$xmldata['liefervorname']." ".$xmldata['liefername'];
        $xmldata['liefername']=$xmldata['lieferfirma'];                $xmldata['liefertyp']='firma';
      }
      $this->app->DB->Insert("INSERT INTO lieferadressen                   
                  (id,name,abteilung,unterabteilung,land,strasse,ort,plz,telefon,telefax,email,ansprechpartner,adresse,typ,adresszusatz,standardlieferadresse)
                  VALUES ('','{$xmldata['liefername']}','{$xmldata['lieferabteilung']}','{$xmldata['lieferunterabteilung']}',                    
                  '{$xmldata['lieferland']}','{$xmldata['lieferstrasse']}','{$xmldata['lieferort']}',
                    '{$xmldata['lieferplz']}','{$xmldata['liefertelefon']}','{$xmldata['liefertelefax']}','{$xmldata['lieferemail']}',
                    '{$xmldata['lieferansprechpartner']}','$id','{$xmldata['liefertyp']}','{$xmldata['lieferadresszusatz']}',1)");
    }


    if($xmldata['lieferantennummer']=="")
    {
      if($internal) return $xmldata['kundennummer'];
      $this->XMLResponse(1,"<id>$id</id><kundennummer>".$xmldata['kundennummer']."</kundennummer>");
    } else {
      if($internal) return $xmldata['lieferantennummer'];
      $this->XMLResponse(1,"<id>$id</id><lieferantennummer>".$xmldata['lieferantennummer']."</lieferantennummer>");
    }
    exit;
  }

  function ApiAdresseEdit($intern = false)
  {
    $xmldata = $this->XMLPost();
    if(isset($xmldata['adresse']))
    {
      if(is_array($xmldata['adresse']) && isset($xmldata['adresse'][0]))
      {
      }else{
        $xmldata['adresse'][0] = $xmldata['adresse'];
      }
      foreach($xmldata['adresse'] as $_key => $_xmldata)
      {
        $id = 0;
        $kundennummer = '';
        $projekt = 0;
        if(isset($_xmldata['id']))$id = (int)$_xmldata['id'];
        if(isset($_xmldata['kundennummer']))$kundennummer = $this->app->DB->real_escape_string($_xmldata['kundennummer']);
        if(isset($_xmldata['projekt']))$projekt = (int)$_xmldata['projekt'];
        if($kundennummer!="")
        {
          if($projekt > 0)
          {
            $projekt = $this->app->DB->Select("SELECT id FROM projekt WHERE abkuerzung='$projekt' LIMIT 1");
            $id = $this->app->DB->Select("SELECT id FROM adresse WHERE kundennummer='$kundennummer' AND projekt='$projekt' LIMIT 1");
          } else {
            $id = $this->app->DB->Select("SELECT id FROM adresse WHERE kundennummer='$kundennummer' LIMIT 1");
          }
        }
        if($id)
        {

          if($_xmldata['porto_preis']!="" && $_xmldata['porto_artikelid']!="" && !is_array($_xmldata['porto_preis']))
            $this->app->erp->AddVerkaufspreis($_xmldata['porto_artikelid'],1,$id,$_xmldata['porto_preis']);

          if($_xmldata['projekt']!="" && !is_array($_xmldata['projekt']) && !is_numeric($_xmldata['projekt']))
            $_xmldata['projekt'] = $this->app->DB->Select("SELECT id FROM projekt WHERE abkuerzung='".$_xmldata['projekt']."' LIMIT 1");

          if($_xmldata['kundennummer']!="" && !is_array($_xmldata['kundennummer']))
            $this->app->erp->AddRolleZuAdresse($id, "Kunde", "von", "Projekt", $_xmldata['projekt'] );

          if($_xmldata['lieferantennummer']!="" && !is_array($_xmldata['lieferantennummer']))
            $this->app->erp->AddRolleZuAdresse($id, "Lieferant", "von", "Projekt", $_xmldata['projekt'] );

          if($_xmldata['verband']!="" && !is_array($_xmldata['verband']))
          {
            if($this->app->erp->GetVerband($id)!=$_xmldata['verband'])
            {
              // alle verbaende loeschen
              $this->app->DB->Update("UPDATE adresse_rolle ad LEFT JOIN gruppen g 
                  ON g.id=ad.parameter SET ad.bis=DATE_SUB(NOW(),INTERVAL 1 DAY) WHERE ad.objekt='Gruppe' AND g.art='verband'
                  AND ad.adresse='$id'"); 
            }
            $this->app->erp->AddRolleZuAdresse($id, "Kunde", "von", "Gruppe", $_xmldata['verband']);
          }
          else 
          {
            // alle verbaende loeschen
            $this->app->DB->Update("UPDATE adresse_rolle ad LEFT JOIN gruppen g 
                ON g.id=ad.parameter SET ad.bis=DATE_SUB(NOW(),INTERVAL 1 DAY) WHERE ad.objekt='Gruppe' AND g.art='verband'
                AND ad.adresse='$id'"); 
          }   

          foreach($_xmldata as $key=>$value)
          {
            if(is_array($value))$value="";            
            if($key=="sonstiges") $value = strip_tags(html_entity_decode($value));
            if($key=="rabattinformation") $value = html_entity_decode($value);
            if($key!="id")
              $this->app->DB->Update("UPDATE adresse SET $key='$value' WHERE id='$id' LIMIT 1");
          }
        }
      }
      if($intern)return $id;
      $this->XMLResponse(1);
      exit;
    }
    $id = $this->app->Secure->GetGET("id");
    $kundennummer = $this->app->Secure->GetGET("kundennummer");
    $projekt = $this->app->Secure->GetGET("projekt");

    if($kundennummer!="")
    {
      if($projekt!="")
      {
        $projekt = $this->app->DB->Select("SELECT id FROM projekt WHERE abkuerzung='$projekt' LIMIT 1");
        $id = $this->app->DB->Select("SELECT id FROM adresse WHERE kundennummer='$kundennummer' AND projekt='$projekt' LIMIT 1");
      } else {
        $id = $this->app->DB->Select("SELECT id FROM adresse WHERE kundennummer='$kundennummer' LIMIT 1");
      }
    }

    // Key gibt es nicht
    if($id <= 0)
    {
      
      if($intern)return false;
      $this->XMLResponse(5);
    }
    


    if($xmldata['porto_preis']!="" && $xmldata['porto_artikelid']!="" && !is_array($xmldata['porto_preis']))
      $this->app->erp->AddVerkaufspreis($xmldata['porto_artikelid'],1,$id,$xmldata['porto_preis']);

    if($xmldata['projekt']!="" && !is_array($xmldata['projekt']))
      $xmldata['projekt'] = $this->app->DB->Select("SELECT id FROM projekt WHERE abkuerzung='".$xmldata['projekt']."' LIMIT 1");

    if($xmldata['kundennummer']!="" && !is_array($xmldata['kundennummer']))
      $this->app->erp->AddRolleZuAdresse($id, "Kunde", "von", "Projekt", $xmldata['projekt'] );

    if($xmldata['lieferantennummer']!="" && !is_array($xmldata['lieferantennummer']))
      $this->app->erp->AddRolleZuAdresse($id, "Lieferant", "von", "Projekt", $xmldata['projekt'] );

    if($xmldata['verband']!="" && !is_array($xmldata['verband']))
    {
      if($this->app->erp->GetVerband($id)!=$xmldata['verband'])
      {
        // alle verbaende loeschen
        $this->app->DB->Update("UPDATE adresse_rolle ad LEFT JOIN gruppen g 
            ON g.id=ad.parameter SET ad.bis=DATE_SUB(NOW(),INTERVAL 1 DAY) WHERE ad.objekt='Gruppe' AND g.art='verband'
            AND ad.adresse='$id'"); 
      }
      $this->app->erp->AddRolleZuAdresse($id, "Kunde", "von", "Gruppe", $xmldata['verband']);
    }
    else 
    {
      // alle verbaende loeschen
      $this->app->DB->Update("UPDATE adresse_rolle ad LEFT JOIN gruppen g 
          ON g.id=ad.parameter SET ad.bis=DATE_SUB(NOW(),INTERVAL 1 DAY) WHERE ad.objekt='Gruppe' AND g.art='verband'
          AND ad.adresse='$id'"); 
    }   

    foreach($xmldata as $key=>$value)
    {
      if(is_array($value))$value="";            
      if($key=="sonstiges") $value = strip_tags(html_entity_decode($value));
      if($key=="rabattinformation") $value = html_entity_decode($value);
      if($key!="id")
        $this->app->DB->Update("UPDATE adresse SET $key='$value' WHERE id='$id' LIMIT 1");
    }

    $this->XMLResponse(1);
    exit;
  }

  function ApiAdresseGet($intern = false)
  {
    $id = $this->app->Secure->GetGET("id");
    $kundennummer = $this->app->Secure->GetGET("kundennummer");
    $projekt = $this->app->Secure->GetGET("projekt");

    if($kundennummer!="")
    {
      if($projekt!="")
      {
        $projekt = $this->app->DB->Select("SELECT id FROM projekt WHERE abkuerzung='$projekt' LIMIT 1");
        $id = $this->app->DB->Select("SELECT id FROM adresse WHERE kundennummer='$kundennummer' AND projekt='$projekt' LIMIT 1");
      } else {
        $id = $this->app->DB->Select("SELECT id FROM adresse WHERE kundennummer='$kundennummer' LIMIT 1");
      }
    }

    //check
    $id = $this->app->DB->Select("SELECT id FROM adresse WHERE id='$id' LIMIT 1");

    if($id > 0)
    {
      if($intern)return $this->app->erp->XMLAdresse($id);
      $this->XMLResponse(1,$this->app->erp->XMLAdresse($id));
    }
    else
    {
      if($intern)return false;
      $this->XMLResponse(5);
    }
    exit;
  }


  function ApiAuftragCreate($intern = false)
  {
    $xmldata = $this->XMLPost();
    // wenn gleich eine neue Adresse mitangelegt werden soll
    if(strtoupper($xmldata['kundennummer'])=="NEW" || strtoupper($xmldata['kundennummer'])=="NEU")
    {
      $xmldata['kundennummer'] = $this->ApiAdresseCreate(true);
    }

    // anlegen der adresse
    $adresse = $this->app->DB->Select("SELECT id FROM adresse WHERE kundennummer='".$xmldata['kundennummer']."' LIMIT 1");

    if($adresse <= 0)
    {
      if($intern)return false;
      $this->XMLResponse(5);
    }
      

    $id = $this->app->erp->CreateAuftrag($adresse);

    $xmldata['belegnr'] = $this->app->erp->GetNextNummer("auftrag",$xmldata['projekt'],$id);
    if($xmldata['shopextid']=="" || $xmldata['shopextid']==0)
      $xmldata['shopextid'] = 1;

    if($xmldata['projekt']=="")
      $xmldata['projekt'] = $this->app->DB->Select("SELECT abkuerzung FROM projekt WHERE id='".$this->app->erp->Firmendaten("projekt")."' LIMIT 1"); 

    $this->app->DB->Update("UPDATE auftrag SET belegnr='".$xmldata['belegnr']."' WHERE id='".$id."' LIMIT 1");

    $this->ApiAuftragEdit(true,$id);
    if($intern)return $id;
    $this->XMLResponse(1,"<id>$id</id><belegnr>".$xmldata['belegnr']."</belegnr>");

    exit;
  }

  function ApiAuftragEdit($intern=false,$id="")
  {
    if($id=="") 
      $id = $this->app->Secure->GetGET("id");

    $xmldata = $this->XMLPost();

    //  id pruefen
    $id = $this->app->DB->Select("SELECT id FROM auftrag WHERE id='".$id."' LIMIT 1");

    if($id <= 0)
    {
      if($intern)return false;
      $this->XMLResponse(5);
      exit;
    }

    // anlegen der adresse
    $adresse = $this->app->DB->Select("SELECT adresse FROM auftrag WHERE id='".$id."' LIMIT 1");

    if($adresse <= 0)
    {
      if($intern)return false;
      $this->XMLResponse(5);
      exit;
    }

    if($xmldata['status']!="angelegt" && $xmldata['status']!="freigegeben" && $xmldata['status']!="abgeschlossen" && $xmldata['status']!="storniert")
      $xmldata['status']="angelegt";

    //if($xmldata['status']=="freigegeben")
    //  $xmldata['status']="angelegt";

     //kundennummer=1 bedeutet gleiche Rolle Kunde anlegen
    if($xmldata['projekt']!="" && !is_array($xmldata['projekt']))
      $xmldata['projekt'] = $this->app->DB->Select("SELECT id FROM projekt WHERE abkuerzung='".$xmldata['projekt']."' LIMIT 1");

    if($xmldata['projekt'] <=0)
      $xmldata['projekt'] = $this->app->erp->ImportGetStandardProjekt();

    // schaue ob kundennummer angebene ist und mache Load
    if($xmldata['kundennummer']!="" && strtoupper($xmldata['kundennummer'])!="NEW" && strtoupper($xmldata['kundennummer'])!="NEU" && !is_array($xmldata['kundennummer']))
    {
      $adresse = $this->app->DB->Select("SELECT id FROM adresse WHERE kundennummer='".$xmldata['kundennummer']."' LIMIT 1");
      $this->app->erp->LoadAuftragStandardwerte($id,$adresse);
    }
    else {
      if($xmldata['land']=="") $xmldata['land']="DE";
    }
 

    $this->app->DB->Delete("DELETE FROM auftrag_position WHERE auftrag='$id'");

    if($xmldata['status']=="")
      $xmldata['status'] = "freigegeben";

    // updat alle felde die angeben wurden sind
    foreach($xmldata as $key=>$value)
    {
      if(is_array($value))$value="";            
      if($key!="id")
        $this->app->DB->Update("UPDATE auftrag SET $key='$value' WHERE id='$id' LIMIT 1");
    }

    if(isset($xmldata['artikelliste']['position']['menge']))
    {
      $tmp = $xmldata['artikelliste']['position'];
      unset($xmldata['artikelliste']['position']);
      $xmldata['artikelliste']['position'][0] = $tmp;
    }elseif(!isset($xmldata['artikelliste']['position'][0]))
    {
      $tmp = $xmldata['artikelliste']['position'];
      unset($xmldata['artikelliste']['position']);
      $xmldata['artikelliste']['position'][0] = $tmp;
    }
    // alle positionen der reihe nach
    
    for($i=0;$i<count($xmldata['artikelliste']['position']);$i++)
    {
      $projektid = $this->app->DB->Select("SELECT id FROM projekt WHERE abkuerzung='".$xmldata['artikelliste']['position'][$i]['projekt']."' LIMIT 1");
      if($projektid > 0)
      {
        $positionid = $this->app->DB->Select("SELECT id FROM artikel WHERE nummer='".$xmldata['artikelliste']['position'][$i]['nummer']."' AND projekt='".$projektid."' LIMIT 1");
      } else {
        $positionid = $this->app->DB->Select("SELECT id FROM artikel WHERE nummer='".$xmldata['artikelliste']['position'][$i]['nummer']."' LIMIT 1");
      }

      $xmldata['artikelliste']['position'][$i]['menge'] = str_replace(',','.',$xmldata['artikelliste']['position'][$i]['menge']);

      if($xmldata['artikelliste']['position'][$i]['waehrung']=="" || is_array($xmldata['artikelliste']['position'][$i]['waehrung']))
        $xmldata['artikelliste']['position'][$i]['waehrung']="EUR";

      if($positionid <= 0)
      {
        //TODO den Artikel gibt es in der datenbank nicht!
        $felder['name_de'] = $xmldata['artikelliste']['position'][$i]['bezeichnung'];
        $felder['anabregs_text'] = $xmldata['artikelliste']['position'][$i]['beschreibung'];
        $felder['nummer'] = $xmldata['artikelliste']['position'][$i]['nummer'];
        $felder['lagerartikel'] = 1;
        if($projektid > 0)
          $felder['projekt'] = $projektid;
        else
          $felder['projekt'] = $this->app->erp->GetStandardProjekt();

        $positionid = $this->app->erp->AddArtikel($felder);
      } else {
        $xmldata['artikelliste']['position'][$i]['artikel'] = $positionid;
        // wenn key == nummer alles laden und kopieren wenn felder leer
        if($xmldata['artikelliste']['position'][$i]['bezeichnung']=="")
          $xmldata['artikelliste']['position'][$i]['bezeichnung'] = $this->app->DB->SelectArr("SELECT name_de FROM artikel WHERE id='".$positionid."' LIMIT 1");

        if($xmldata['artikelliste']['position'][$i]['beschreibung']=="")
          $xmldata['artikelliste']['position'][$i]['beschreibung'] = $this->app->DB->SelectArr("SELECT anabregs_text FROM artikel WHERE id='".$positionid."' LIMIT 1");

        if($xmldata['artikelliste']['position'][$i]['preis']=="")
          $xmldata['artikelliste']['position'][$i]['preis'] = $this->app->erp->GetVerkaufspreis($positionid,$xmldata['artikelliste']['position'][$i]['menge'],
              $adresse,$xmldata['artikelliste']['position'][$i]['waehrung']);
      }

      $this->app->DB->Insert("INSERT INTO auftrag_position (id,auftrag,sort,artikel) VALUES ('','".$id."','".($i+1)."','".$positionid."')");
      $positionid= $this->app->DB->GetInsertID();

      // anpassen der felder
      foreach($xmldata['artikelliste']['position'][$i] as $key=>$value)
      {
        if(is_array($value))$value="";          
        if($key!="id")
          $this->app->DB->Update("UPDATE auftrag_position SET $key='$value' WHERE id='$positionid' LIMIT 1");
      }
    }

    $this->app->erp->AuftragNeuberechnen($id);

    $xmldata['belegnr'] = $this->app->DB->Select("SELECT belegnr FROM auftrag WHERE id='".$id."' LIMIT 1");

    if($intern) return $id;
    $this->XMLResponse(1,"<id>$id</id><belegnr>".$xmldata['belegnr']."</belegnr>");
    exit;
  }



  function ApiAuftragGet()
  {
    $id = $this->app->Secure->GetGET("id");
    $belegnr = $this->app->Secure->GetGET("belegnr");
    $projekt= $this->app->Secure->GetGET("projekt");

    if($belegnr!="")
    {
      if($projekt!="")
      {
        $projekt = $this->app->DB->Select("SELECT id FROM projekt WHERE abkuerzung='$projekt' LIMIT 1");
        $id = $this->app->DB->Select("SELECT id FROM auftrag WHERE belegnr='$belegnr' AND projekt='$projekt' LIMIT 1");
      } else {
        $id = $this->app->DB->Select("SELECT id FROM auftrag WHERE belegnr='$belegnr' LIMIT 1");
      }
    }

    //check
    $id = $this->app->DB->Select("SELECT id FROM auftrag WHERE id='$id' LIMIT 1");

    if($id > 0)
      $this->XMLResponse(1,$this->app->erp->XMLAuftrag($id));
    else
      $this->XMLResponse(5);

    exit;
  }


  function ApiArtikelCreate()
  {
    $xmldata = $this->XMLPost();
    // anlegen der adresse
    $felder = array();

    if($xmldata['name_de']!="" && !is_array($xmldata['name_de']))
      $id = $this->app->erp->AddArtikel($felder);
    else $this->XMLResponse(5);

    //kundennummer=1 bedeutet gleiche Rolle Kunde anlegen
    if($xmldata['projekt']!="" && !is_array($xmldata['projekt']))
      $xmldata['projekt'] = $this->app->DB->Select("SELECT id FROM projekt WHERE abkuerzung='".$xmldata['projekt']."' LIMIT 1");
    else        
      $xmldata['projekt'] = $this->app->erp->GetStandardProjekt();

    if(strtoupper($xmldata['nummer'])=="NEW" || strtoupper($xmldata['nummer'])=="NEU")
      $xmldata['nummer'] = $this->app->erp->GetNextArtikelnummer($xmldata['typ'],1,$xmldata['projekt']);

    if($xmldata['lager_platz']!="" && !is_array($xmldata['lager_platz']))
    {
      $lagerid = $this->app->DB->Select("SELECT MIN(id) FROM lager WHERE geloescht!='1'");
      if($lagerid<=0)
      {
        $this->app->DB->Insert("INSERT INTO lager (id,bezeichnung,firma) VALUES ('','Hauptlager',1)");
        $lagerid = $this->app->DB->GetInsertID();
      }
      $xmldata['lager_platz'] = $this->app->erp->CreateLagerplatz($lagerid,$xmldata['lager_platz'],$firma="1");

      if($xmldata['lager_menge'] > 0)
      {
        $menge = $this->app->DB->Select("SELECT SUM(menge) FROM lager_platz_inhalt WHERE artikel='$id' AND lager_platz='".$xmldata['lager_platz']."'");
        if($menge != $xmldata['lager_menge'])
        {
          $this->app->DB->Delete("DELETE FROM lager_platz_inhalt WHERE artikel='$id' AND lager_platz='".$xmldata['lager_platz']."'");
          $this->app->erp->LagerEinlagern($id,$xmldata['lager_menge'],$xmldata['lager_platz'],$xmldata['projekt'],"XML Importtool Anpassung");
        }
      }
      $xmldata['lagerartikel']=1;
    }

    if($xmldata['aktiv']=="1") $xmldata['inaktiv']=0;
    if($xmldata['aktiv']=="0"|| (array_key_exists('aktiv', $xmldata) && $xmldata['aktiv']=="")) $xmldata['inaktiv']=1;

    if($xmldata['inaktiv']=="1") {
        $xmldata['intern_gesperrtgrund']="Artikel inaktiv";
        $xmldata['intern_gesperrt']="1";
    }

    if($xmldata['variante_von_nummer']!="" && !is_array($xmldata['variante_von_nummer'])) {
      // pruefen ob es einen echte id ist
      $xmldata['variante_von'] = $this->app->DB->Select("SELECT id FROM artikel WHERE nummer='".$xmldata['variante_von_nummer']."' AND nummer!='' LIMIT 1");
      if($xmldata['variante_von'] > 0)
        $xmldata['variante']=1;
    } 

    if(!empty($xmldata['typ_ext']))$typ_ext = (int)$xmldata['typ_ext'];
    if(isset($typ_ext) && $typ_ext)$typ_ext = $this->app->DB->Select("SELECT id FROM artikelkategorien WHERE id = '$typ_ext' LIMIT 1");
    if(isset($typ_ext) && $typ_ext)
    {
      $xmldata['typ'] = $typ_ext.'_kat';
      unset($xmldata['typ_ext']);
    }elseif(isset($xmldata['typ']) && strpos($xmldata['typ'],'_kat') && !empty($xmldata['artikelkategorie']))
    {
      $kategorie = $this->app->DB->Select("SELECT id FROM artikelkategorien WHERE bezeichnung = '".$this->app->DB->real_escape_string($xmldata['artikelkategorie'])."' LIMIT 1");
      if($kategorie)
      {
        $xmldata['typ'] = $kategorie.'_kat';
        unset($xmldata['artikelkategorie']);
      }
    }
    

    foreach($xmldata as $key=>$value)
    {
      if(is_array($value))$value="";            
      if(is_array($value))$value="";
      if($key=="beschreibung_de") $value = html_entity_decode($value);
      if($key=="beschreibung_en") $value = html_entity_decode($value);
      if($key=="uebersicht_de") $value = html_entity_decode($value);
      if($key=="uebersicht_en") $value = html_entity_decode($value);
      if($key=="links_de") $value = html_entity_decode($value);
      if($key=="links_en") $value = html_entity_decode($value);
      if($key=="startseite_de") $value = html_entity_decode($value);
      if($key=="startseite_en") $value = html_entity_decode($value);
      if($key=="katalogtext_de") $value = html_entity_decode($value);
      if($key=="katalogtext_de") $value = html_entity_decode($value);
      if($key=="internerkommentar") $value = strip_tags(html_entity_decode($value));


      if($key!="id")
        $this->app->DB->Update("UPDATE artikel SET $key='$value' WHERE id='$id' LIMIT 1");
    }
    // alle positionen der reihe nach


    if($xmldata['stueckliste_artikel']['artikel']['menge']  > 0)
    {
      $tmp = $xmldata['stueckliste_artikel']['artikel'];
      $xmldata['stueckliste_artikel']['artikel']="";
      $xmldata['stueckliste_artikel']['artikel'][0] = $tmp;
    }

    for($i=0;$i<count($xmldata['stueckliste_artikel']['artikel']);$i++)
    {
      //$projektid = $this->app->DB->Select("SELECT id FROM projekt WHERE abkuerzung='".$xmldata['artikelliste']['position'][$i]['projekt']."' LIMIT 1");
      $artikel = $id;
      $menge = $xmldata['stueckliste_artikel']['artikel'][$i]['menge'];
      $xmldata['stueckliste_artikel']['artikel'][$i]['projekt'] = $this->app->DB->Select("SELECT id FROM projekt WHERE abkuerzung='".$xmldata['stueckliste_artikel']['artikel'][$i]['projekt']."' LIMIT 1");

      if($xmldata['stueckliste_artikel']['artikel'][$i]['projekt']!="" && !is_array($xmldata['stueckliste_artikel']['artikel'][$i]['projekt']))
        $stuecklisteartikel = $this->app->DB->Select("SELECT id FROM adresse WHERE nummer='".$xmldata['stueckliste_artikel']['artikel'][$i]['nummer']."' AND projekt='".$xmldata['stueckliste_artikel']['artikel'][$i]['projekt']."' LIMIT 1");
      else
        $stuecklisteartikel = $this->app->DB->Select("SELECT id FROM artikel WHERE nummer='".$xmldata['stueckliste_artikel']['artikel'][$i]['nummer']."' LIMIT 1");

      $this->app->DB->Insert("INSERT INTO stueckliste (id,sort,artikel,stuecklistevonartikel,menge) VALUES ('','".($i+1)."','$stuecklisteartikel','$artikel','$menge')");       
    }

    // eiinkaufspreise

    if($xmldata['einkaufspreise']['staffelpreis']['ab_menge']  > 0 || $xmldata['einkaufspreise']['staffelpreis']['preis']  > 0)
    {
      $tmp = $xmldata['einkaufspreise']['staffelpreis'];
      $xmldata['einkaufspreise']['staffelpreis']="";
      $xmldata['einkaufspreise']['staffelpreis'][0] = $tmp;
    }


    for($i=0;$i<count($xmldata['einkaufspreise']['staffelpreis']);$i++)
    {
      //$projektid = $this->app->DB->Select("SELECT id FROM projekt WHERE abkuerzung='".$xmldata['artikelliste']['position'][$i]['projekt']."' LIMIT 1");
      $artikel = $id;
      $abmenge = $xmldata['einkaufspreise']['staffelpreis'][$i]['ab_menge'];
      $xmldata['einkaufspreise']['staffelpreis'][$i]['projekt'] = $this->app->DB->Select("SELECT id FROM projekt WHERE abkuerzung='".$xmldata['einkaufspreise']['staffelpreis'][$i]['projekt']."' LIMIT 1");

      if($xmldata['einkaufspreise']['staffelpreis'][$i]['projekt']!="" && !is_array($xmldata['einkaufspreise']['staffelpreis'][$i]['projekt']))
      {
        $adresse = $this->app->DB->Select("SELECT id FROM adresse WHERE lieferantennummer='".$xmldata['einkaufspreise']['staffelpreis'][$i]['lieferantennummer']."' 
          AND lieferantennummer!='' AND projekt='".$xmldata['einkaufspreise']['staffelpreis'][$i]['projekt']."' LIMIT 1");

        $this->app->erp->LogFile("Fall 1 $adresse");
      }
      else
      {
        if($xmldata['einkaufspreise']['staffelpreis'][$i]['lieferantennummer']!="" && !is_array($xmldata['einkaufspreise']['staffelpreis'][$i]['lieferantennummer']))
          $adresse = $this->app->DB->Select("SELECT id FROM adresse WHERE lieferantennummer='".$xmldata['einkaufspreise']['staffelpreis'][$i]['lieferantennummer']."' 
            AND lieferantennummer!='' LIMIT 1");

        $this->app->erp->LogFile("Fall 2 ".$xmldata['einkaufspreise']['staffelpreis'][$i]['lieferantennummer']." Adresse $adresse");
      }

      if($adresse <=0)
      {
        if($xmldata['einkaufspreise']['staffelpreis'][$i]['lieferantname']!="" && !is_array($xmldata['einkaufspreise']['staffelpreis'][$i]['lieferantname']))
          $adresse = $this->app->DB->Select("SELECT id FROM adresse WHERE name='".$xmldata['einkaufspreise']['staffelpreis'][$i]['lieferantname']."' AND name!='' LIMIT 1");

        $this->app->erp->LogFile("Fall 3 $adresse");
      }

      if($adresse <=0)
      {
        if($xmldata['einkaufspreise']['staffelpreis'][$i]['lieferantname']=="")
          $xmldata['einkaufspreise']['staffelpreis'][$i]['lieferantname']="Lieferant";
        
        $adresse = $this->app->erp->CreateAdresse($xmldata['einkaufspreise']['staffelpreis'][$i]['lieferantname'],$firma="1");

        //wenn lieferanennummer vorhanden dann diese verwenden
        if($xmldata['einkaufspreise']['staffelpreis'][$i]['lieferantennummer']!="" && !is_array($xmldata['einkaufspreise']['staffelpreis'][$i]['lieferantennummer']))
          $this->app->DB->Update("UPDATE adresse SET lieferantennummer='".$xmldata['einkaufspreise']['staffelpreis'][$i]['lieferantennummer']."' WHERE id='$adresse' LIMIT 1");

        $this->app->erp->AddRolleZuAdresse($adresse, "Lieferant", "von", "Projekt", $xmldata['projekt'] );
        $this->app->erp->LogFile("Fall 4 $adresse");
      }


      $bestellnummer = $xmldata['einkaufspreise']['staffelpreis'][$i]['bestellnummer'];
      $bezeichnunglieferant = $xmldata['einkaufspreise']['staffelpreis'][$i]['bezeichnunglieferant'];
      if(is_array($bestellnummer))$bestellnummer="";

      if($bezeichnunglieferant=="")
        $bezeichnunglieferant = $this->app->DB->Select("SELECT name_de FROM artikel WHERE id='$artikel' LIMIT 1");
      if(is_array($bezeichnunglieferant) || $bezeichnunglieferant=="" )$bezeichnunglieferant=$xmldata['name_de'];

      $preis = str_replace(',','.',$xmldata['einkaufspreise']['staffelpreis'][$i]['preis']);
      $waehrung = $xmldata['einkaufspreise']['staffelpreis'][$i]['waehrung'];
      if(is_array($waehrung) || $waehrung=="")$waehrung="EUR";

      $this->app->erp->AddEinkaufspreis($artikel,$abmenge,$adresse,$bestellnummer,$bezeichnunglieferant,$preis,$waehrung);
    }


    if($xmldata['verkaufspreise']['staffelpreis']['ab_menge']  > 0)
    {
      $tmp = $xmldata['verkaufspreise']['staffelpreis'];
      $xmldata['verkaufspreise']['staffelpreis']="";
      $xmldata['verkaufspreise']['staffelpreis'][0] = $tmp;
    }

    // alle positionen der reihe nach
    for($i=0;$i<count($xmldata['verkaufspreise']['staffelpreis']);$i++)
    {
      $artikel = $id;
      $abmenge = $xmldata['verkaufspreise']['staffelpreis'][$i]['ab_menge'];
      $xmldata['verkaufspreise']['staffelpreis'][$i]['projekt'] = $this->app->DB->Select("SELECT id FROM projekt WHERE abkuerzung='".$xmldata['verkaufspreise']['staffelpreis'][$i]['projekt']."' LIMIT 1");

      if($xmldata['verkaufspreise']['staffelpreis'][$i]['projekt']!="" && !is_array($xmldata['verkaufspreise']['staffelpreis'][$i]['projekt']))
        $adresse = $this->app->DB->Select("SELECT id FROM adresse WHERE kundennummer='".$xmldata['verkaufspreise']['staffelpreis'][$i]['kundennummer']."' AND projekt='".$xmldata['verkaufspreise']['staffelpreis'][$i]['projekt']."' LIMIT 1");
      else
        $adresse = $this->app->DB->Select("SELECT id FROM adresse WHERE kundennummer='".$xmldata['verkaufspreise']['staffelpreis'][$i]['kundennummer']."' LIMIT 1");

      if($xmldata['verkaufspreise']['staffelpreis'][$i]['kundennummer']=="")
        $adresse = 0;
      else {
        // kunde gibt es nicht
        if($adresse <=0)
          continue;
      }

      if($xmldata['verkaufspreise']['staffelpreis'][$i]['gruppe']>0)
        $gruppe = $this->app->DB->Select("SELECT id FROM gruppen WHERE id='".$xmldata['verkaufspreise']['staffelpreis'][$i]['gruppe']."' LIMIT 1");
      else $gruppe = 0;

      $preis = str_replace(',','.',$xmldata['verkaufspreise']['staffelpreis'][$i]['preis']);
      $waehrung = $xmldata['verkaufspreise']['staffelpreis'][$i]['waehrung'];
      if(is_array($waehrung) || is_array($waehrung)) $waehrung = "EUR";


      //$projektid = $this->app->DB->Select("SELECT id FROM projekt WHERE abkuerzung='".$xmldata['artikelliste']['position'][$i]['projekt']."' LIMIT 1");
      if($gruppe > 0)
        $this->app->erp->AddVerkaufspreisGruppe($artikel,$abmenge,$gruppe,$preis,$waehrung);
      else
        $this->app->erp->AddVerkaufspreis($artikel,$abmenge,$adresse,$preis,$waehrung);
    }

    if($internal) return $xmldata['nummer'];

    $this->XMLResponse(1,"<id>$id</id><nummer>".$xmldata['nummer']."</nummer>");
    exit;
  }


  function ApiArtikelEdit()
  {
    $id = $this->app->Secure->GetGET("id");
    $nummer = $this->app->Secure->GetGET("nummer");
    $projekt = $this->app->Secure->GetGET("projekt");
    $xmldata = $this->XMLPost();
    
    if(!empty($xmldata['id_ext']))$id_ext = (int)$xmldata['id_ext'];
    if(!empty($xmldata['typ_ext']))$typ_ext = (int)$xmldata['typ_ext'];
    if(isset($id_ext) && $id_ext)$id_ext = $this->app->DB->Select("SELECT id FROM artikel WHERE geloescht != 1 AND id = '$id_ext' LIMIT 1");
    if(isset($typ_ext) && $typ_ext)$typ_ext = $this->app->DB->Select("SELECT id FROM artikelkategorien WHERE id = '$typ_ext' LIMIT 1");
    if(isset($typ_ext) && $typ_ext)
    {
      $xmldata['typ'] = $typ_ext.'_kat';
      unset($xmldata['typ_ext']);
    }elseif(isset($xmldata['typ']) && strpos($xmldata['typ'],'_kat') && !empty($xmldata['artikelkategorie']))
    {
      $kategorie = $this->app->DB->Select("SELECT id FROM artikelkategorien WHERE bezeichnung = '".$this->app->DB->real_escape_string($xmldata['artikelkategorie'])."' LIMIT 1");
      if($kategorie)
      {
        $xmldata['typ'] = $kategorie.'_kat';
        unset($xmldata['artikelkategorie']);
      }
    }
    if(isset($id_ext) && $id_ext)
    {
      $id = $id_ext;
    }else{
      if($nummer!="")
      {
        if($projekt!="")
        {
          $projekt = $this->app->DB->Select("SELECT id FROM projekt WHERE abkuerzung='$projekt' LIMIT 1");
          $id = $this->app->DB->Select("SELECT id FROM artikel WHERE nummer='$nummer' AND projekt='$projekt' LIMIT 1");
        } else {
          $id = $this->app->DB->Select("SELECT id FROM artikel WHERE nummer='$nummer' LIMIT 1");
        }
      }
    }

    // Key gibt es nicht
    if($id <= 0)
      $this->XMLResponse(5);

    //kundennummer=1 bedeutet gleiche Rolle Kunde anlegen
    if($xmldata['projekt']!="" && !is_array($xmldata['projekt']))
      $xmldata['projekt'] = $this->app->DB->Select("SELECT id FROM projekt WHERE abkuerzung='".$xmldata['projekt']."' LIMIT 1");


    // TODO wenn juststueckliste ist es nie ein lager artikel
    if($xmldata['juststueckliste']=="1")
    {
      $xmldata['lagerartikel']=0;
      $xmldata['lager_platz']="";
      $xmldata['lager_menge'] = 0;
    }
    

    if($xmldata['lager_platz']!="" && !is_array($xmldata['lager_platz']))
    {
      $lagerid = $this->app->DB->Select("SELECT MIN(id) FROM lager WHERE geloescht!='1'");
      if($lagerid<=0)
      {
        $this->app->DB->Insert("INSERT INTO lager (id,bezeichnung,firma) VALUES ('','Hauptlager',1)");
        $lagerid = $this->app->DB->GetInsertID();
      }

      $xmldata['lager_platz'] = $this->app->erp->CreateLagerplatz($lagerid,$xmldata['lager_platz'],$firma="1");
      if($xmldata['lager_menge'] > 0)
      {
        $menge = $this->app->DB->Select("SELECT SUM(menge) FROM lager_platz_inhalt WHERE artikel='$id' AND lager_platz='".$xmldata['lager_platz']."'");
        if($menge != $xmldata['lager_menge'])
        {
          $this->app->DB->Delete("DELETE FROM lager_platz_inhalt WHERE artikel='$id' AND lager_platz='".$xmldata['lager_platz']."'");
          $this->app->erp->LagerEinlagern($id,$xmldata['lager_menge'],$xmldata['lager_platz'],$xmldata['projekt'],"XML Importtool Anpassung");
        }
      }
      $xmldata['lagerartikel']=1;
    }

    if($xmldata['aktiv']=="1") $xmldata['inaktiv']=0;
    if($xmldata['aktiv']=="0"|| (array_key_exists('aktiv', $xmldata) && $xmldata['aktiv']=="")) $xmldata['inaktiv']=1;

    if($xmldata['inaktiv']=="1") {
        $xmldata['intern_gesperrtgrund']="Artikel inaktiv";
        $xmldata['intern_gesperrt']="1";
    }

    if($xmldata['variante_von_nummer']!="" && !is_array($xmldata['variante_von_nummer'])) {
      // pruefen ob es einen echte id ist
      $xmldata['variante_von'] = $this->app->DB->Select("SELECT id FROM artikel WHERE nummer='".$xmldata['variante_von_nummer']."' AND nummer!='' LIMIT 1");      
      if($xmldata['variante_von'] > 0)
        $xmldata['variante']=1;
    } 


    foreach($xmldata as $key=>$value)
    {
      if(is_array($value))$value="";            
      if($key=="beschreibung_de") $value = html_entity_decode($value);
      if($key=="beschreibung_en") $value = html_entity_decode($value);
      if($key=="uebersicht_de") $value = html_entity_decode($value);
      if($key=="uebersicht_en") $value = html_entity_decode($value);
      if($key=="links_de") $value = html_entity_decode($value);
      if($key=="links_en") $value = html_entity_decode($value);
      if($key=="startseite_de") $value = html_entity_decode($value);
      if($key=="startseite_en") $value = html_entity_decode($value);
      if($key=="katalogtext_de") $value = html_entity_decode($value);
      if($key=="katalogtext_de") $value = html_entity_decode($value);
      if($key=="internerkommentar") $value = strip_tags(html_entity_decode($value));

      if($key!="id")
        $this->app->DB->Update("UPDATE artikel SET $key='$value' WHERE id='$id' LIMIT 1");
    }

    if($xmldata['stueckliste_artikel']['artikel']['menge']  > 0)
    {
      $tmp = $xmldata['stueckliste_artikel']['artikel'];
      $xmldata['stueckliste_artikel']['artikel']="";
      $xmldata['stueckliste_artikel']['artikel'][0] = $tmp;
    }

    if(count($xmldata['stueckliste_artikel']['artikel']) > 0)
      $this->app->DB->Delete("DELETE FROM stueckliste WHERE stuecklistevonartikel='".$id."'");

    for($i=0;$i<count($xmldata['stueckliste_artikel']['artikel']);$i++)
    {
      //$projektid = $this->app->DB->Select("SELECT id FROM projekt WHERE abkuerzung='".$xmldata['artikelliste']['position'][$i]['projekt']."' LIMIT 1");
      $artikel = $id;
      $menge = $xmldata['stueckliste_artikel']['artikel'][$i]['menge'];
      $xmldata['stueckliste_artikel']['artikel'][$i]['projekt'] = $this->app->DB->Select("SELECT id FROM projekt WHERE abkuerzung='".$xmldata['stueckliste_artikel']['artikel'][$i]['projekt']."' LIMIT 1");

      if($xmldata['stueckliste_artikel']['artikel'][$i]['projekt']!="" && !is_array($xmldata['stueckliste_artikel']['artikel'][$i]['projekt']))
        $stuecklisteartikel = $this->app->DB->Select("SELECT id FROM adresse WHERE nummer='".$xmldata['stueckliste_artikel']['artikel'][$i]['nummer']."' AND projekt='".$xmldata['stueckliste_artikel']['artikel'][$i]['projekt']."' LIMIT 1");
      else
        $stuecklisteartikel = $this->app->DB->Select("SELECT id FROM artikel WHERE nummer='".$xmldata['stueckliste_artikel']['artikel'][$i]['nummer']."' LIMIT 1");

      $this->app->DB->Insert("INSERT INTO stueckliste (id,sort,artikel,stuecklistevonartikel,menge) VALUES ('','".($i+1)."','$stuecklisteartikel','$artikel','$menge')");       
    }

    if($xmldata['einkaufspreise']['staffelpreis']['ab_menge']  > 0 || $xmldata['einkaufspreise']['staffelpreis']['preis']  > 0)
    {
      $tmp = $xmldata['einkaufspreise']['staffelpreis'];
      $xmldata['einkaufspreise']['staffelpreis']="";
      $xmldata['einkaufspreise']['staffelpreis'][0] = $tmp;
    }

    $this->app->erp->SetzteSperreAPIArtikelPreise($id);
    for($i=0;$i<count($xmldata['einkaufspreise']['staffelpreis']);$i++)
    {
      //$projektid = $this->app->DB->Select("SELECT id FROM projekt WHERE abkuerzung='".$xmldata['artikelliste']['position'][$i]['projekt']."' LIMIT 1");
      $artikel = $id;
      // Markierung fuer SPerrung aller nicht uebegebenen Preise

      $abmenge = $xmldata['einkaufspreise']['staffelpreis'][$i]['ab_menge'];
      $xmldata['einkaufspreise']['staffelpreis'][$i]['projekt'] = $this->app->DB->Select("SELECT id FROM projekt WHERE abkuerzung='".$xmldata['einkaufspreise']['staffelpreis'][$i]['projekt']."' LIMIT 1");

      if($xmldata['einkaufspreise']['staffelpreis'][$i]['projekt']!="" && !is_array($xmldata['einkaufspreise']['staffelpreis'][$i]['projekt']))
        $adresse = $this->app->DB->Select("SELECT id FROM adresse WHERE lieferantennummer='".$xmldata['einkaufspreise']['staffelpreis'][$i]['lieferantennummer']."' 
          AND projekt='".$xmldata['einkaufspreise']['staffelpreis'][$i]['projekt']."' AND lieferantennummer!='' LIMIT 1");
      else
        $adresse = $this->app->DB->Select("SELECT id FROM adresse WHERE lieferantennummer='".$xmldata['einkaufspreise']['staffelpreis'][$i]['lieferantennummer']."' 
          AND lieferantennummer!='' LIMIT 1");

      if($adresse <=0)
      {
        $adresse = $this->app->DB->Select("SELECT id FROM adresse WHERE name='".$xmldata['einkaufspreise']['staffelpreis'][$i]['lieferantname']."' AND name!='' LIMIT 1");
      }

      if($adresse <=0)
      {
        if($xmldata['einkaufspreise']['staffelpreis'][$i]['lieferantname']=="")
          $xmldata['einkaufspreise']['staffelpreis'][$i]['lieferantname']="Lieferant";
        
        $adresse = $this->app->erp->CreateAdresse($xmldata['einkaufspreise']['staffelpreis'][$i]['lieferantname'],$firma="1");
        // wenn lieferantennummer vorhanden dann diese verwenden 
        if($xmldata['einkaufspreise']['staffelpreis'][$i]['lieferantennummer']!="" && !is_array($xmldata['einkaufspreise']['staffelpreis'][$i]['lieferantennummer']))
          $this->app->DB->Update("UPDATE adresse SET lieferantennummer='".$xmldata['einkaufspreise']['staffelpreis'][$i]['lieferantennummer']."' WHERE id='$adresse' LIMIT 1");

        $this->app->erp->AddRolleZuAdresse($adresse, "Lieferant", "von", "Projekt", $xmldata['projekt'] );
      }



      $bestellnummer = $xmldata['einkaufspreise']['staffelpreis'][$i]['bestellnummer'];
      $bezeichnunglieferant = $xmldata['einkaufspreise']['staffelpreis'][$i]['bezeichnunglieferant'];
      if(is_array($bestellnummer))$bestellnummer="";

      if($bezeichnunglieferant=="")
        $bezeichnunglieferant = $this->app->DB->Select("SELECT name_de FROM artikel WHERE id='$artikel' LIMIT 1");


      $preis = str_replace(',','.',$xmldata['einkaufspreise']['staffelpreis'][$i]['preis']);
      $waehrung = $xmldata['einkaufspreise']['staffelpreis'][$i]['waehrung'];
      if(is_array($waehrung) || $waehrung=="")
        $waehrung="EUR";

      $this->app->erp->AddEinkaufspreis($artikel,$abmenge,$adresse,$bestellnummer,$bezeichnunglieferant,$preis,$waehrung);
    }

    if($xmldata['verkaufspreise']['staffelpreis']['ab_menge']  > 0)
    {
      $tmp = $xmldata['verkaufspreise']['staffelpreis'];
      $xmldata['verkaufspreise']['staffelpreis']="";
      $xmldata['verkaufspreise']['staffelpreis'][0] = $tmp;
    }

    // alle positionen der reihe nach
    for($i=0;$i<count($xmldata['verkaufspreise']['staffelpreis']);$i++)
    {
      $artikel = $id;
      $abmenge = $xmldata['verkaufspreise']['staffelpreis'][$i]['ab_menge'];
      $xmldata['verkaufspreise']['staffelpreis'][$i]['projekt'] = $this->app->DB->Select("SELECT id FROM projekt WHERE abkuerzung='".$xmldata['verkaufspreise']['staffelpreis'][$i]['projekt']."' LIMIT 1");

      if($xmldata['verkaufspreise']['staffelpreis'][$i]['projekt']!="" && !is_array($xmldata['verkaufspreise']['staffelpreis'][$i]['projekt']))
        $adresse = $this->app->DB->Select("SELECT id FROM adresse WHERE kundennummer='".$xmldata['verkaufspreise']['staffelpreis'][$i]['kundennummer']."' AND projekt='".$xmldata['verkaufspreise']['staffelpreis'][$i]['projekt']."' LIMIT 1");
      else
        $adresse = $this->app->DB->Select("SELECT id FROM adresse WHERE kundennummer='".$xmldata['verkaufspreise']['staffelpreis'][$i]['kundennummer']."' LIMIT 1");

      $preis = str_replace(',','.',$xmldata['verkaufspreise']['staffelpreis'][$i]['preis']);
      $waehrung = $xmldata['verkaufspreise']['staffelpreis'][$i]['waehrung'];
      if(is_array($waehrung) || $waehrung=="") $waehrung = "EUR";
      $kundenartikelnummer = $xmldata['verkaufspreise']['staffelpreis'][$i]['kundenartikelnummer'];

      if($xmldata['verkaufspreise']['staffelpreis'][$i]['geloescht']=="1") $geloescht = 1;
      else $geloescht = 0;

      if($xmldata['verkaufspreise']['staffelpreis'][$i]['kundennummer']=="")
        $adresse = 0;
      else {
        // kunde gibt es nicht
        if($adresse <=0)
          continue;
      }

      // pruefe ob es diesen Preis schon gibt? wenn nicht lege einen neuen an ...       
      // $projektid = $this->app->DB->Select("SELECT id FROM projekt WHERE abkuerzung='".$xmldata['artikelliste']['position'][$i]['projekt']."' LIMIT 1");

      if($xmldata['verkaufspreise']['staffelpreis'][$i]['gruppe']>0)
        $gruppe = $this->app->DB->Select("SELECT id FROM gruppen WHERE id='".$xmldata['verkaufspreise']['staffelpreis'][$i]['gruppe']."' LIMIT 1");
      else $gruppe = 0;

      if($gruppe > 0)
        $this->app->erp->AddVerkaufspreisGruppe($artikel,$abmenge,$gruppe,$preis,$waehrung);
      else
        $this->app->erp->AddVerkaufspreis($artikel,$abmenge,$adresse,$preis,$waehrung);

      //deaktiviere alle alten preise von dem Artikel
    }
    $this->app->erp->EntferneSperreAPIArtikelPreise($id);

    $this->XMLResponse(1);
    exit;
  }


  function ApiArtikelGet()
  {
    $id = $this->app->Secure->GetGET("id");
    $nummer = $this->app->Secure->GetGET("nummer");
    $projekt = $this->app->Secure->GetGET("projekt");

    $xmldata = $this->XMLPost();

    if($nummer=="") $nummer = $xmldata["nummer"];
    if($id=="") $id = $xmldata["id"];
    if($projekt=="") $projekt = $xmldata["projekt"];

    if($nummer!="")
    {
      if($projekt!="")
      {
        $projekt = $this->app->DB->Select("SELECT id FROM projekt WHERE abkuerzung='$projekt' LIMIT 1");
        $id = $this->app->DB->Select("SELECT id FROM artikel WHERE nummer='$nummer' AND projekt='$projekt' LIMIT 1");
      } else {
        $id = $this->app->DB->Select("SELECT id FROM artikel WHERE nummer='$nummer' LIMIT 1");
      }
    }

    //check
    $id = $this->app->DB->Select("SELECT id FROM artikel WHERE id='$id' LIMIT 1");


    if($id > 0)
      $this->XMLResponse(1,$this->app->erp->XMLArtikel($id));
    else
      $this->XMLResponse(5);
    exit;
  }


  function ApiBenutzerCreate()
  {
    $xmldata = $this->XMLPost();
    // pruefe ob es adresse gibt
    $adressecheck = $this->app->DB->Select("SELECT id FROM adresse WHERE id='".$xmldata["adresse"]."' LIMIT 1");
    if($adressecheck <=0)
      $this->XMLResponse(5);

    // pruefe ob es username gibt       
    $usercheck = $this->app->DB->Select("SELECT id FROM user WHERE username='".$xmldata["username"]."' LIMIT 1");
    if($usercheck > 0)
      $this->XMLResponse(5);

    $felder = $xmldata; 

    if($felder['type']!="admin")
    {   
      $rechtevorlage = $felder['type'];
      $felder['vorlage']=$rechtevorlage;
      $felder['type']="standard";
    }

    $id = $this->app->erp->CreateBenutzer($felder);
    foreach($xmldata as $key=>$value)
    {
      if(is_array($value))$value="";            

      if($key=="sonstiges") $value = strip_tags(html_entity_decode($value));
      if($key!="id")
        $this->app->DB->Update("UPDATE `user` SET $key='$value' WHERE id='$id' LIMIT 1");
    }
    if(empty($xmldata['passwordunenescaped']) && empty($xmldata['passwordsha512']))$this->app->DB->Update("UPDATE `user` SET salt = '', passwordsha512 = '' WHERE id = '$id' LIMIT 1");

    $this->app->erp->AbgleichBenutzerVorlagen();
    $this->XMLResponse(1,"<id>$id</id>");
    exit;
  }



  function ApiBenutzerEdit()
  {
    $id = (int)$this->app->Secure->GetGET("id");


    $usercheck = $this->app->DB->Select("SELECT id FROM `user` WHERE id='".$id."' LIMIT 1");
    // User gibt es nicht
    if($usercheck <= 0)
      $this->XMLResponse(5);

    $xmldata = $this->XMLPost();
    $usernamecheck = $this->app->DB->Select("SELECT id FROM `user` WHERE username='".$xmldata["username"]."' AND id!='".$id."' LIMIT 1");
    // Username hat schon jemand anders
    if($usernamecheck > 0)
      $this->XMLResponse(6);

    if($xmldata['type']!="admin")
    {   
      $rechtevorlage = $xmldata['type'];
      $xmldata['vorlage']=$rechtevorlage;
      $xmldata['type']="standard";
    }

    foreach($xmldata as $key=>$value)
    {
      if(is_array($value))$value="";            
      if($key=="sonstiges") $value = strip_tags(html_entity_decode($value));
      if($key!="id")
        $this->app->DB->Update("UPDATE `user` SET $key='$value' WHERE id='$id' LIMIT 1");
    }
    
    if(empty($xmldata['passwordunenescaped']) && empty($xmldata['passwordsha512']) && !empty($xmldata['passwordmd5']))$this->app->DB->Update("UPDATE `user` SET salt = '', passwordsha512 = '' WHERE id = '$id' LIMIT 1");

    $this->app->erp->AbgleichBenutzerVorlagen();
    $this->XMLResponse(1);
    exit;
  }

  function ApiBenutzerGet()
  {
    $id = $this->app->Secure->GetGET("id");

    //checl
    $id = $this->app->DB->Select("SELECT id FROM user WHERE id='$id' LIMIT 1");

    if($id > 0)
      $this->XMLResponse(1,$this->app->erp->XMLBenutzer($id));
    else
      $this->XMLResponse(5);

    exit;
  }

  function ApiPreiseEdit()
  {
    $xmldata = $this->XMLPostPlain();

    foreach ($xmldata->xml->artikel as $artikel){
      $id = $this->app->DB->Select("SELECT id FROM artikel WHERE id='$artikel->id' LIMIT 1");   
      if($id<=0) continue;
      $this->app->erp->SetzteSperreAPIArtikelPreise($id);

      foreach ($artikel->verkaufspreise as $vk) {
        foreach ($vk->staffelpreis as $staffelpreis) {

          if($staffelpreis->kundennummer!="")
            $staffelpreis->adresse = $this->app->DB->Select("SELECT id FROM adresse WHERE kundennummer='".$staffelpreis->kundennummer."' LIMIT 1");
          if($staffelpreis->gruppe > 0)
            $this->app->erp->AddVerkaufspreisGruppe($id,$staffelpreis->ab_menge,$staffelpreis->gruppe,$staffelpreis->preis);
          else if($staffelpreis->adresse > 0)
            $this->app->erp->AddVerkaufspreis($id,$staffelpreis->ab_menge,$staffelpreis->adresse,$staffelpreis->preis);
          else if($staffelpreis->kundennummer=="" && $staffelpreis->adresse <= 0)
            $this->app->erp->AddVerkaufspreis($id,$staffelpreis->ab_menge,0,$staffelpreis->preis);
        }
      }

      // test
      foreach ($artikel->einkaufspreise as $ek) {
        foreach ($ek->staffelpreis as $staffelpreis) {

	  $lieferantadresse = $this->app->DB->Select("SELECT id FROM adresse WHERE lieferantennummer='".$staffelpreis->lieferantennummer."' AND lieferantennummer!='' LIMIT 1");
	  if($lieferantadresse > 0)
	  {
      	    $this->app->erp->AddEinkaufspreis($id,$staffelpreis->ab_menge,$lieferantadresse,$staffelpreis->bestellnummer,$staffelpreis->bezeichnunglieferant,
		$staffelpreis->preis,$staffelpreis->waehrung);
	  }
        }
      }

      $this->app->erp->EntferneSperreAPIArtikelPreise($id);
    }

    $this->XMLResponse(1);
    exit;
  }


  function ApiSessionStart()
  {

    $xmldata = $this->XMLPost();

    $sessionid = $xmldata['sessionID'];
    $userID = $xmldata['userID'];
    $validSession = $xmldata['isValidSession'];

    if($validSession=="1")
      $this->app->DB->Insert("INSERT INTO useronline (user_id,login,sessionid,time) VALUES ('$userID','1','$sessionid',NOW())");        

    $this->XMLResponse(1);
    // Eintrag anlegen in useronline
    // class.acl.php erweitern, wenn diese merkt das externer login war dann session freischalten ...
    exit;
  }


  function ApiSessionClose()
  {
    $xmldata = $this->XMLPost();

    $sessionid = $xmldata['sessionID'];

    $this->app->DB->Delete("DELETE FROM useronline WHERE sessionid='$sessionid' LIMIT 1");

    $this->XMLResponse(1);
    // loeschen aktiver login
    exit;
  }


  function ApiAdresseKontaktCreate()
  {
    $id = $this->app->Secure->GetGET("id");
    $kundennummer = $this->app->Secure->GetGET("kundennummer");
    $projekt = $this->app->Secure->GetGET("projekt");


    $xmldata = $this->XMLPost();
    if($id=="" && $kundennummer=="")
    {
      if($xmldata["kundennummer"]!="" && !is_array($xmldata["kundennummer"]))
        $kundennummer = $xmldata["kundennummer"];
      else
        $id = $xmldata["adresse"];
    }   

    if($kundennummer!="")
    {
      if($projekt!="")
      {
        $projekt = $this->app->DB->Select("SELECT id FROM projekt WHERE abkuerzung='$projekt' LIMIT 1");
        $id = $this->app->DB->Select("SELECT id FROM adresse WHERE kundennummer='$kundennummer' AND projekt='$projekt' LIMIT 1");
      } else {
        $id = $this->app->DB->Select("SELECT id FROM adresse WHERE kundennummer='$kundennummer' LIMIT 1");
      }
    }

    // Key gibt es nicht
    $id = $this->app->DB->Select("SELECT id FROM adresse WHERE id='$id' LIMIT 1");
    if($id <= 0)
      $this->XMLResponse(5);

    $bezeichnung = $xmldata["bezeichnung"];
    $kontakt = $xmldata["kontakt"];
    $this->app->DB->Insert("INSERT INTO adresse_kontakte (id,adresse,bezeichnung,kontakt) VALUES ('','$id','$bezeichnung','$kontakt')");

    $id = $this->app->DB->GetInsertID();

    $this->XMLResponse(1,"<id>$id</id>");
    exit;
  }


  function ApiAdresseKontaktEdit()
  {
    $id = $this->app->Secure->GetGET("id");

    $id = $this->app->DB->Select("SELECT id FROM adresse_kontakte WHERE id='$id' LIMIT 1");
    // Key gibt es nicht
    if($id <= 0)
      $this->XMLResponse(5);

    $xmldata = $this->XMLPost();

    foreach($xmldata as $key=>$value)
    {
      if(is_array($value))$value="";            
      if($key!="id")
        $this->app->DB->Update("UPDATE adresse_kontakte SET $key='$value' WHERE id='$id' LIMIT 1");
    }

    $this->XMLResponse(1);
    exit;
  }     

  function ApiAdresseKontaktList()
  {
    $id = (int)$this->app->Secure->GetGET("id");
    if(!$this->app->DB->Select("SELECT id FROM adresse WHERE id = '$id' AND geloescht <> 1 LIMIT 1"))
    {
      $this->XMLResponse(5);
      exit;
    }
    $kontakte = $this->app->DB->SelectArr("SELECT * FROM adresse_kontakte WHERE adresse = '$id' ORDER BY bezeichnung");
    if($kontakte)
    {
      $xmlstr = <<<XML
<?xml version="1.0" standalone="yes"?>
<kontakte2>
</kontakte2>
XML;
      $_xmlobj = new SimpleXMLElement($xmlstr);
      $xmlobj = $_xmlobj->AddChild('kontakte','');
      $xmlobj->AddChild('anz_gesamt',count($kontakte));
      $xmlobj->AddChild('anz_result',count($kontakte));
      //$sxe->addAttribute('type', 'documentary');
      
      foreach($kontakte as $kontakt)
      {
        $kobj = $xmlobj->AddChild('kontakt','');
        foreach($kontakt as $k => $v)
        {
          $valobj = $kobj->AddChild($k, (String)$v);
        }
      }
      
      $xml = str_replace(array('<?xml version="1.0" standalone="yes"?>',"<kontakte2>",'</kontakte2>'),array('','',''),$_xmlobj->asXML());
      $this->XMLResponse(1,$xml);
    }else{
      $this->XMLResponse(8);
    }
    exit;
  }

  function ApiAdresseKontaktGet()
  {
    $id = $this->app->Secure->GetGET("id");

    //checl
    $id = $this->app->DB->Select("SELECT id FROM adresse_kontakte WHERE id='$id' LIMIT 1");

    if($id > 0)
      $this->XMLResponse(1,$this->app->erp->XMLAdresseKontakt($id));
    else
      $this->XMLResponse(5);

    exit;
  }
  
  function ApiAdresseListeGet()
  {
    $xmldata = $this->XMLPost();
    $exakt = false;
    $filterspalten = array('name','plz','ort','kundennummer','land','strasse','abteilung','unterabteilung','id');
    $limit = '';
    $_limit = 999999999;
    $offset = 0;
    if(isset($xmldata['limit']))
    {
      $_limit = $xmldata['limit'];
      if(isset($xmldata['offset']))
      {
        $offset = $xmldata['offset'];
        //$limit = ' LIMIT '.(int)$xmldata['offset'].', '.(int)$xmldata['limit'];
      }else{
        //$limit = ' LIMIT '.(int)$xmldata['limit'];
      }        
    }
    
    if(!empty($xmldata['gruppen']))
    {
      if(isset($xmldata['gruppen']['kennziffer']))
      {
        if(!is_array($xmldata['gruppen']['kennziffer']))
        {
          $gruppen[0] = $xmldata['gruppen']['kennziffer'];
        }else{
          foreach($xmldata['gruppen']['kennziffer'] as $k => $gruppe)
          {
            $gruppen[] = $gruppe;
          }
        }
      }
    }
    
    $sumjoin = '';
    $sumwhere = '';
    $sumspalten = '';
    $re = false;
    $gu = false;
    $be = false;
    $ab = false;
    $an = false;
    $filterkategorie = false;
    
    $bvertrieb = 0;
    if($xmldata && is_array($xmldata))
    {
      foreach($xmldata as $key => $filter)
      {
        $filterescaped = '';
        if(!is_array($filter))$filterescaped = $this->app->DB->real_escape_string($filter);
        switch(strtoupper($key))
        {
          case 'VERTRIEB':
            $bvertrieb = (int)$filter;
          break;
          case 'KATEGORIE':
            $filterkategorie = (int)$filter;
          break;
        }
      }
    }
    
    if(isset($xmldata['summierung']))
    {
      if(isset($xmldata['summierung']['beleg']))
      {
        if(!is_array($xmldata['summierung']['beleg']) || !isset($xmldata['summierung']['beleg'][0]))
        {
          $belegea[0] = $xmldata['summierung']['beleg'];
        }else{
          $belegea = $xmldata['summierung']['beleg'];
        }
        foreach($belegea as $beleg)
        {
          switch($beleg)
          {
            case 'rechnung':
              if(!$re)
              {
                $re = true;
                $sumspalten .= ', (SELECT sum(re.umsatz_netto) FROM rechnung re  WHERE re.adresse = adr.id '.($bvertrieb?" AND re.vertriebid = '".$bvertrieb."' ":'');
                $sumjoin .= ' LEFT JOIN rechnung re ON re.adresse = adr.id ';
                $skat = '';
                if($filterkategorie)$skat = ' , (SELECT rear.id FROM rechnung re2 INNER JOIN rechnung_position rep2 ON re2.id = rep2.rechnung  INNER JOIN artikel rear ON rep2.artikel = rear.id WHERE re2.adresse = adr.id AND rear.typ = \''.$filterkategorie.'_kat\' ';
                //if($sumwhere != '')$sumwhere .= ' AND ';
                if(isset($xmldata['status']))
                {
                  $sumspalten .= " AND re.status like '".$this->app->DB->real_escape_string($xmldata['status'])."' ";
                  $skat .= " AND re2.status like '".$this->app->DB->real_escape_string($xmldata['status'])."' ";
                  //$sumwhere .= " (isnull(re.id) OR (re.status like '".$this->app->DB->real_escape_string($xmldata['status'])."' ";
                }else{
                  $sumspalten .= " AND re.status != 'storniert' AND re.status <> 'angelegt' ";
                  $skat .= " AND re2.status != 'storniert' AND re2.status <> 'angelegt' ";
                  //$sumwhere .= " (isnull(re.id) OR (re.status != 'storniert' AND re.status <> 'angelegt' ";
                }
                if(isset($xmldata['datumvon']))
                {
                  $sumspalten .= " AND re.datum >= '".$this->app->DB->real_escape_string($xmldata['datumvon'])."' ";
                  $skat .= " AND re2.datum >= '".$this->app->DB->real_escape_string($xmldata['datumvon'])."' ";
                  //$sumwhere .= " AND re.datum >= '".$this->app->DB->real_escape_string($xmldata['datumvon'])."' ";
                }
                if(isset($xmldata['datumbis']))
                {
                  $sumspalten .= " AND re.datum <= '".$this->app->DB->real_escape_string($xmldata['datumbis'])."' ";
                  $skat .= " AND re2.datum <= '".$this->app->DB->real_escape_string($xmldata['datumbis'])."' ";
                  //$sumwhere .= " AND re.datum <= '".$this->app->DB->real_escape_string($xmldata['datumbis'])."' ";
                }
                //$sumwhere .= "))";
                
                $sumspalten .= ') as rechnung_umsatz_netto';
                if($filterkategorie)$skat .= ' LIMIT 1) as re_iskat ';
                if($filterkategorie)$sumspalten .= $skat;
              }
            break;
            case 'gutschrift':
              if(!$gu)
              {
                $gu = true;
                $sumspalten .= ', (SELECT sum(gu.umsatz_netto) FROM gutschrift gu WHERE gu.adresse = adr.id '.($bvertrieb?" AND gu.vertriebid = '".$bvertrieb."' ":'');
                //$sumspalten .= ', sum(gu.soll) as gutschrift_soll';
                $sumjoin .= ' LEFT JOIN gutschrift gu ON gu.adresse = adr.id ';
                $skat = '';
                if($filterkategorie)$skat = ' , (SELECT guar.id FROM gutschrift gu2 INNER JOIN gutschrift_position gup2 ON gu2.id = gup2.gutschrift  INNER JOIN artikel guar ON gup2.artikel = guar.id WHERE gu2.adresse = adr.id  AND guar.typ = \''.$filterkategorie.'_kat\' ';
                //if($sumwhere != '')$sumwhere .= ' AND ';
                if(isset($xmldata['status']))
                {
                  $sumspalten .= " AND gu.status like '".$this->app->DB->real_escape_string($xmldata['status'])."' ";
                  $skat .= " AND gu2.status like '".$this->app->DB->real_escape_string($xmldata['status'])."' ";
                  //$sumwhere .= " (isnull(gu.id) OR (gu.status like '".$this->app->DB->real_escape_string($xmldata['status'])."' ";
                }else{
                  $sumspalten .= " AND gu.status != 'storniert' AND gu.status <> 'angelegt' ";
                  $skat .= " AND gu2.status != 'storniert' AND gu2.status <> 'angelegt' ";
                  //$sumwhere .= " (isnull(gu.id) OR (gu.status != 'storniert' AND gu.status <> 'angelegt'  ";
                }
                if(isset($xmldata['datumvon']))
                {
                  $sumspalten .= " AND gu.datum >= '".$this->app->DB->real_escape_string($xmldata['datumvon'])."' ";
                  $skat .= " AND gu2.datum >= '".$this->app->DB->real_escape_string($xmldata['datumvon'])."' ";
                  //$sumwhere .= " AND gu.datum >= '".$this->app->DB->real_escape_string($xmldata['datumvon'])."' ";
                }
                if(isset($xmldata['datumbis']))
                {
                  $sumspalten .= " AND gu.datum <= '".$this->app->DB->real_escape_string($xmldata['datumbis'])."' ";
                  $skat .= " AND gu2.datum <= '".$this->app->DB->real_escape_string($xmldata['datumbis'])."' ";
                  //$sumwhere .= " AND gu.datum <= '".$this->app->DB->real_escape_string($xmldata['datumbis'])."' ";
                }
                //$sumwhere .= "))";
                $sumspalten .= ') as gutschrift_umsatz_netto';
                if($filterkategorie)$skat .= ' LIMIT 1) as gu_iskat ';
                if($filterkategorie)$sumspalten .= $skat;
              }
            break;
            case 'bestellung':
              if(!$be)
              {
                $be = true;
                //$sumspalten .= ', sum(be.gesamtsumme) as bestellung_gesamtsumme';
                $sumspalten .= ', (SELECT sum(be.gesamtsumme) FROM bestellung be WHERE be.adresse = adr.id ';
                $sumjoin .= ' LEFT JOIN bestellung be ON be.adresse = adr.id ';
                $skat = '';
                if($filterkategorie)$skat = ' , (SELECT bear.id FROM bestellung be2 INNER JOIN bestellung_position bep2 ON be2.id = bep2.bestellung  INNER JOIN artikel bear ON bep2.artikel = bear.id WHERE be2.adresse = adr.id  AND bear.typ = \''.$filterkategorie.'_kat\' ';
                //if($sumwhere != '')$sumwhere .= ' AND ';
                if(isset($xmldata['status']))
                {
                  $sumspalten .= " AND be.status like '".$this->app->DB->real_escape_string($xmldata['status'])."' ";
                  $skat .= " AND be2.status like '".$this->app->DB->real_escape_string($xmldata['status'])."' ";
                  //$sumwhere .= " (isnull(be.id) OR (be.status like '".$this->app->DB->real_escape_string($xmldata['status'])."' ";
                }else{
                  $sumspalten .= " AND be.status != 'storniert' AND be.status <> 'angelegt' ";
                  $skat .= " AND be2.status != 'storniert' AND be2.status <> 'angelegt' ";
                  //$sumwhere .= " (isnull(be.id) OR (be.status != 'storniert' AND be.status <> 'angelegt' ";
                }
                if(isset($xmldata['datumvon']))
                {
                  $sumspalten .= " AND be.datum >= '".$this->app->DB->real_escape_string($xmldata['datumvon'])."' ";
                  $skat .= " AND be2.datum >= '".$this->app->DB->real_escape_string($xmldata['datumvon'])."' ";
                  //$sumwhere .= " AND be.datum >= '".$this->app->DB->real_escape_string($xmldata['datumvon'])."' ";
                }
                if(isset($xmldata['datumbis']))
                {
                  $sumspalten .= " AND be.datum <= '".$this->app->DB->real_escape_string($xmldata['datumbis'])."' ";
                  $skat .= " AND be2.datum <= '".$this->app->DB->real_escape_string($xmldata['datumbis'])."' ";
                  //$sumwhere .= " AND be.datum <= '".$this->app->DB->real_escape_string($xmldata['datumbis'])."' ";
                }
                //$sumwhere .= "))";
                $sumspalten .= ') as bestellung_gesamtsumme ';
                if($filterkategorie)$skat .= ' LIMIT 1) as be_iskat ';
                if($filterkategorie)$sumspalten .= $skat;
              }
            break;
            case 'auftrag':
              if(!$ab)
              {
                $ab = true;
                $sumspalten .= ', (SELECT sum(ab.umsatz_netto) FROM auftrag ab WHERE ab.adresse = adr.id '.($bvertrieb?" AND re.vertriebid = '".$bvertrieb."' ":'');
                //$sumspalten .= ', sum(ab.gesamtsumme) as auftrag_gesamtsumme';
                $sumjoin .= ' LEFT JOIN auftrag ab ON ab.adresse = adr.id ';
                $skat = '';
                if($filterkategorie)$skat = ' , (SELECT abar.id FROM auftrag ab2 INNER JOIN auftrag_position abp2 ON ab2.id = abp2.auftrag INNER JOIN artikel abar ON abp2.artikel = abar.id WHERE ab2.adresse = adr.id  AND abar.typ = \''.$filterkategorie.'_kat\' ';
                //if($sumwhere != '')$sumwhere .= ' AND ';
                if(isset($xmldata['status']))
                {
                  $sumspalten .= " AND ab.status like '".$this->app->DB->real_escape_string($xmldata['status'])."' ";
                  $skat .= " AND ab2.status like '".$this->app->DB->real_escape_string($xmldata['status'])."' ";
                  //$sumwhere .= " (isnull(ab.id) OR (ab.status like '".$this->app->DB->real_escape_string($xmldata['status'])."' ";
                }else{
                  $sumspalten .= " AND ab.status != 'storniert' AND ab.status <> 'angelegt' ";
                  $skat .= " AND ab2.status != 'storniert' AND ab2.status <> 'angelegt' ";
                  //$sumwhere .= " (isnull(ab.id) OR (ab.status != 'storniert' AND ab.status <> 'angelegt' ";
                }
                if(isset($xmldata['datumvon']))
                {
                  $sumspalten .= " AND ab.datum <= '".$this->app->DB->real_escape_string($xmldata['datumvon'])."' ";
                  $skat .= " AND ab2.datum >= '".$this->app->DB->real_escape_string($xmldata['datumvon'])."' ";
                  //$sumwhere .= " AND ab.datum >= '".$this->app->DB->real_escape_string($xmldata['datumvon'])."' ";
                }
                if(isset($xmldata['datumbis']))
                {
                  $sumspalten .= " AND ab.datum <= '".$this->app->DB->real_escape_string($xmldata['datumbis'])."' ";
                  $skat .= " AND ab2.datum <= '".$this->app->DB->real_escape_string($xmldata['datumbis'])."' ";
                  //$sumwhere .= " AND ab.datum <= '".$this->app->DB->real_escape_string($xmldata['datumbis'])."' ";
                }
                //$sumwhere .= "))";
                $sumspalten .= ') as auftrag_umsatz_netto ';
                if($filterkategorie)$skat .= ' LIMIT 1) as ab_iskat ';
                if($filterkategorie)$sumspalten .= $skat;
              }
            break;
            case 'angebot':
              if(!$an)
              {
                $an = true;
                $sumspalten .= ', (SELECT sum(an.umsatz_netto) FROM angebot an WHERE an.adresse = adr.id '.($bvertrieb?" AND an.vertriebid = '".$bvertrieb."' ":'');
                //$sumspalten .= ', sum(an.gesamtsumme) as angebot_gesamtsumme';
                $sumjoin .= ' LEFT JOIN angebot an ON an.adresse = adr.id ';
                $skat = '';
                if($filterkategorie)$skat = ' , (SELECT anar.id FROM angebot an2 INNER JOIN angebot_position an2 ON an2.id = anp2.auftrag INNER JOIN artikel anar ON anp2.artikel = anar.id WHERE an2.adresse = adr.id  AND anar.typ = \''.$filterkategorie.'_kat\' ';
                //if($sumwhere != '')$sumwhere .= ' AND ';
                if(isset($xmldata['status']))
                {
                  //$sumwhere .= " (isnull(an.id) OR (an.status like '".$this->app->DB->real_escape_string($xmldata['status'])."' ";
                  $sumspalten .= " AND an.status like '".$this->app->DB->real_escape_string($xmldata['status'])."' ";
                  $skat .= " AND an2.status like '".$this->app->DB->real_escape_string($xmldata['status'])."' ";
                }else{
                  //$sumwhere .= " (isnull(an.id) OR (an.status != 'storniert' AND an.status <> 'angelegt' ";
                  $sumspalten .= " AND an.status != 'storniert' AND an.status <> 'angelegt' ";
                  $skat .= " AND an2.status != 'storniert' AND an2.status <> 'angelegt' ";
                }
                if(isset($xmldata['datumvon']))
                {
                  $sumspalten .= " AND an.datum >= '".$this->app->DB->real_escape_string($xmldata['datumvon'])."' ";
                  $skat .= " AND an2.datum >= '".$this->app->DB->real_escape_string($xmldata['datumvon'])."' ";
                  //$sumwhere .= " AND an.datum >= '".$this->app->DB->real_escape_string($xmldata['datumvon'])."' ";
                }
                if(isset($xmldata['datumbis']))
                {
                  $sumspalten .= " AND an.datum <= '".$this->app->DB->real_escape_string($xmldata['datumbis'])."' ";
                  $skat .= " AND an2.datum <= '".$this->app->DB->real_escape_string($xmldata['datumbis'])."' ";
                  //$sumwhere .= " AND an.datum <= '".$this->app->DB->real_escape_string($xmldata['datumbis'])."' ";
                }
                //$sumwhere .= "))";
                $sumspalten .= ') as angebot_umsatz_netto ';
                if($filterkategorie)$skat .= ' LIMIT 1) as an_iskat ';
                if($filterkategorie)$sumspalten .= $skat;
              }
            break;
          }
        }
        /*
        if($sumwhere != '')
        {
          
          if($re)
          {
            $sumwherea[] = " not isnull(re.id) ";
          }
          if($gu)
          {
            $sumwherea[] = " not isnull(gu.id) ";
          }
          if($ab)
          {
            $sumwherea[] = " not isnull(ab.id) ";
          }
          if($an)
          {
            $sumwherea[] = " not isnull(an.id) ";
          }
          if($be)
          {
            $sumwherea[] = " not isnull(be.id) ";
          }          
          
          $sumwhere .= " AND ( ".implode(" OR ",$sumwherea)." ) ";
        }*/
      }
    }
 
    //if($sumwhere != '')$sumwhere = ' AND ('.$sumwhere.') ';
    $sumwhere = '';
    $sumjoin = '';
    $searchmode = ' AND ';
    if($xmldata && is_array($xmldata))
    {
      foreach($xmldata as $key => $filter)
      {
        $filterescaped = '';
        if(!is_array($filter))$filterescaped = $this->app->DB->real_escape_string($filter);
        switch(strtoupper($key))
        {
          case 'EXAKT':
            $exakt = true;
          break;
          case 'SEARCHMODE':
            if(strtoupper($filter) == 'AND')$searchmode = ' AND ';
            if(strtoupper($filter) == 'OR')$searchmode = ' OR ';
          break;
          case 'SEARCH':
            
            if(is_array($filter))
            {
              if(isset($filter[0]))
              {
                foreach($filter as $k => $_filter)
                {
                  if(isset($_filter['SUCHE']))$_filter['suche'] = $_filter['SUCHE'];
                  if(isset($_filter['FIELD']))$_filter['field'] = $_filter['FIELD'];
                  if(isset($_filter['EXAKT']))$_filter['exakt'] = $_filter['EXAKT'];
                  if(isset($_filter['suche']) && isset($_filter['field']) && in_array(strtolower($_filter['field']),$filterspalten))
                  {
                    if(isset($_filter['exakt']) && $_filter['exakt'] == 1)
                    {
                      if(strtolower($_filter['field']) == 'id')
                      {
                        $swhere[] = " adr.".$_filter['field']." LIKE '".$this->app->DB->real_escape_string((int)($_filter['suche']))."' ";
                      }else
                      $swhere[] = " adr.".$_filter['field']." LIKE '".$this->app->DB->real_escape_string(base64_decode($_filter['suche']))."' ";
                    }else{
                      if(strtolower($_filter['field']) == 'id')
                      {
                        $swhere[] = " adr.".$_filter['field']." LIKE '%".$this->app->DB->real_escape_string((int)($_filter['suche']))."%' ";
                      }
                        else
                      $swhere[] = " adr.".$_filter['field']." LIKE '%".$this->app->DB->real_escape_string(base64_decode($_filter['suche']))."%' ";
                    }
                  }
                }
              }else{
                if(isset($filter['SUCHE']))$filter['suche'] = $filter['SUCHE'];
                if(isset($filter['FIELD']))$filter['field'] = $filter['FIELD'];
                if(isset($filter['EXAKT']))$filter['exakt'] = $filter['EXAKT'];
                if(isset($filter['suche']) && isset($filter['field']) && in_array(strtolower($filter['field']),$filterspalten))
                {
                  if(strtolower($filter['field']) == 'id')
                  {
                    if(isset($filter['exakt']) && $filter['exakt'] == 1)
                    {
                      $swhere[] = " adr.".$filter['field']." LIKE '".$this->app->DB->real_escape_string((int)($filter['suche']))."' ";
                    }else{
                      $swhere[] = " adr.".$filter['field']." LIKE '%".$this->app->DB->real_escape_string((int)($filter['suche']))."%' ";
                    }
                    
                  }else{
                    if(isset($filter['exakt']) && $filter['exakt'] == 1)
                    {
                      $swhere[] = " adr.".$filter['field']." LIKE '".$this->app->DB->real_escape_string(base64_decode($filter['suche']))."' ";
                    }else{
                      $swhere[] = " adr.".$filter['field']." LIKE '%".$this->app->DB->real_escape_string(base64_decode($filter['suche']))."%' ";
                    }
                  }
                }
              }
            }else{
              $suchbegriff = $this->app->DB->real_escape_string(base64_decode($filterescaped));
            }
          
            //$subwhere[] = " (adr.name like '%$filterescaped%' OR adr.plz like '%$filterescaped%'  OR adr.ort like '%$filterescaped%' OR adr.kundennummer like '%$filterescaped%') ";
            
          break;
          case 'SUCHSPALTE':
            //if($filterescaped)$customsearch[] = $filterescaped;
          break;
          case 'VERTRIEB':
            $subwhere[] = " adr.vertrieb = '".(int)$filter."' ";
          break;
          case 'EXT':
            $filter_ext = $filter;
          break;
          case 'ID':
            if(is_array($filter) && isset($filter[0]))
            {
              foreach($filter as $k => $_filter)
              {
                $subwhere[] = " adr.id = '".(int)$_filter."' ";
              }
            }else
            $subwhere[] = " adr.id = '".(int)$filter."' ";
          break;
        }
      }
    }
    
    
    if(isset($suchbegriff) || !empty($swhere))
    {
      if(empty($swhere))
      {
        foreach($filterspalten as $f)
        {
          $swhere[] = " adr.".$f." like '".($exakt?'':"%").($suchbegriff).($exakt?'':"%")."' ";
        }
        $subwhere[] = ' ('.implode(' '.$searchmode.' ', $swhere).') ';
      }else{
        /*foreach($customsearch as $f)
        {
          if(in_array($f, $filterspalten))$swhere[] = " adr.".$f." like '".($exakt?'':"%").($suchbegriff).($exakt?'':"%")."' ";
        }*/
        if(!empty($swhere))$subwhere[] = " (".implode(' '.$searchmode.' ', $swhere).') ';
      }
    }
    $where = '1';
    if(!empty($subwhere))$where = implode(' '.$searchmode.' ',$subwhere);
    
    
    $order = '';
    if(isset($xmldata['order'])){
      if(!isset($xml['order'][0]))
      {
        $xmldata['order'][0] = $xmldata['order'];
      }
      foreach($xmldata['order'] as $key => $sort)
      {
        $field = '';
        if(isset($sort['field']))
        {
          switch(strtolower($sort['field']))
          {
            case 'gruppenname':
            case 'kennziffer':
              if($gruppen)$field = 'gr.name';
            break;
            
            case 'name':
            case 'plz':
            case 'ort':
            case 'telefon':
            case 'telefax':
            case 'ansprechpartner':
            case 'typ':
            case 'strasse':
            case 'land':
            case 'email':
            case 'kundennummer':
            case 'lieferantennummer':
              $field = 'adr.'.strtolower($sort['field']);
            break;
          }
          if(!empty($field)) 
          {  
            if(isset($sort['desc']) && $sort['desc'] == 1)
            {
              $field .= " DESC";
            }
            if($order != '')$order .= ',';
            $order .= $field;
          }
        }
      }
    }
    if($order != '')$order = $order.',';
    
    if(isset($gruppen))
    {
      $where .= " AND (gr.kennziffer = '".implode("' OR gr.kennziffer = '",$gruppen). "') AND (ar.bis = '0000-00-00' OR ar.bis >= date(now())) ";
      if(isset($filter_ext))
      {
        if(strtolower($filter_ext) == 'ja')
        {
          $where .= " AND not isnull(am.id) ";
        }elseif(strtolower($filter_ext) == 'nein')
        {
          $where .= " AND isnull(am.id) ";
        }
        $sql = "SELECT adr.*, gr.kennziffer, gr.name as gruppenname,am.id_ext $sumspalten FROM adresse adr LEFT JOIN api_mapping am ON am.id_int = adr.id AND am.tabelle = 'adresse' INNER JOIN adresse_rolle ar ON adr.id = ar.adresse AND ar.objekt like 'gruppe' INNER JOIN gruppen gr ON gr.id = ar.parameter $sumjoin WHERE $where $sumwhere ORDER BY $order adr.name, adr.id $limit";
        $adressen = $this->app->DB->Query($sql);
        
      }else{
        $sql = "SELECT adr.*, gr.kennziffer, gr.name as gruppenname $sumspalten FROM adresse adr INNER JOIN adresse_rolle ar ON adr.id = ar.adresse AND ar.objekt like  'gruppe' INNER JOIN gruppen gr ON gr.id = ar.parameter $sumjoin WHERE $where $sumwhere ORDER BY $order adr.name, adr.id $limit";
        $adressen = $this->app->DB->Query($sql);
        
      }
    }
    else{
      if(isset($filter_ext))
      {
        if(strtolower($filter_ext) == 'ja' || $filter_ext === '1' || $filter_ext === 1)
        {
          $where .= " AND not isnull(am.id) ";
        }elseif(strtolower($filter_ext) == 'nein' || $filter_ext === '0' || $filter_ext === 0)
        {
          $where .= " AND isnull(am.id) ";
        }
        $sql = "SELECT adr.*,am.id_ext $sumspalten FROM adresse adr LEFT JOIN api_mapping am ON am.id_int = adr.id AND am.tabelle = 'adresse' $sumjoin WHERE $where $sumwhere ORDER BY $order adr.name, adr.id $limit";
        $adressen = $this->app->DB->Query($sql);
        
      }else{
        $sql = "SELECT adr.* $sumspalten FROM adresse adr $sumjoin WHERE $where  $sumwhere ORDER BY $order adr.name, adr.id $limit";
        $adressen = $this->app->DB->Query($sql);
        
      }
    }
    //$this->app->erp->LogFile(addslashes($sql));
    if($adressen)
    {
      
$xmlstr = <<<XML
<?xml version="1.0" standalone="yes"?>
<adressen2>
</adressen2>
XML;
      $_xmlobj = new SimpleXMLElement($xmlstr);
      $xmlobj = $_xmlobj->AddChild('adressen','');
      //$sxe->addAttribute('type', 'documentary');
      
      
      
      $xml = '';
      $anz_gesamt = 0;
      $anz_result = 0;
      $i = 0;
      $gesamt_umsatz = 0;
      $anzeige_umsatz = 0;
      while($adresse = $this->app->DB->Fetch_Array($adressen))
      {
        
        $do = true;
        if($re && $gu)
        {
          
          if(isset($xmldata['umsatzvon']))
          {
            if((float)$adresse['rechnung_umsatz_netto'] - (float)$adresse['gutschrift_umsatz_netto'] < (float)$xmldata['umsatzvon'])$do = false;
          }
          if(isset($xmldata['umsatzbis']))
          {
            if((float)$adresse['rechnung_umsatz_netto'] - (float)$adresse['gutschrift_umsatz_netto'] > (float)$xmldata['umsatzbis'])$do = false;
          }
        }elseif($re)
        {
          if(isset($xmldata['umsatzvon']))
          {
            if((float)$adresse['rechnung_umsatz_netto'] < (float)$xmldata['umsatzvon'])$do = false;
          }
          if(isset($xmldata['umsatzbis']))
          {
            if((float)$adresse['rechnung_umsatz_netto'] > (float)$xmldata['umsatzbis'])$do = false;
          }
        }
        if($filterkategorie && $do)
        {
          $do2 = false;
          if($re && $adresse['re_iskat'])$do2 = true;
          if($gu && $adresse['gu_iskat'])$do2 = true;
          if($be && $adresse['be_iskat'])$do2 = true;
          if($ab && $adresse['ab_iskat'])$do2 = true;
          if($an && $adresse['an_iskat'])$do2 = true;
          if(!$do2)$do = false;
        }
        if($do && $re && $gu)
        {
          $gesamt_umsatz += (float)$adresse['rechnung_umsatz_netto'] - (float)$adresse['gutschrift_umsatz_netto'];
        }
        if($do && $i >= $offset && $i < $offset+$_limit)
        {
          $anzeige_umsatz += (float)$adresse['rechnung_umsatz_netto'] - (float)$adresse['gutschrift_umsatz_netto'];
          $adrobj = $xmlobj->AddChild('adresse','');
          //$xml .= '<adresse>';
          $RowKeys = array_keys($adresse);
          $RowValues = array_values($adresse);
          for($k = 1; $k < count($RowKeys);$k+=2)
          {
            if($RowKeys[$k] != 're_iskat' && $RowKeys[$k] != 'gu_iskat' && $RowKeys[$k] != 'be_iskat' && $RowKeys[$k] != 'ab_iskat' && $RowKeys[$k] != 'an_iskat')
            {
              if($RowKeys[$k] == 'rechnung_umsatz_netto' || $RowKeys[$k] == 'gutschrift_umsatz_netto' || $RowKeys[$k] == 'bestellung_umsatz_netto' || $RowKeys[$k] == 'auftrag_umsatz_netto' || $RowKeys[$k] == 'angebot_umsatz_netto')
                $RowValues[$k] = number_format((float)$this->app->erp->GetPlainText($RowValues[$k]),2,'.','');
              $valobj = $adrobj->AddChild($RowKeys[$k],'');              
              if((String)$this->app->erp->GetPlainText($RowValues[$k]) != '')$valobj->value = (String)$this->app->erp->GetPlainText($RowValues[$k]);
            }
            //$xml .= '<'.$RowKeys[$k].'>'.(String)$this->app->erp->GetPlainText($RowValues[$k]).'</'.$RowKeys[$k].'>';
          }
          //$xml .= '</adresse>';
          $anz_result++;
        }
        if($do)$i++;
      }
      $xmlobj->AddChild('anz_gesamt',$i);
      $xmlobj->AddChild('anz_result',$anz_result);
      if($re && $gu)
      {
        $xmlobj->AddChild('anzeige_umsatz',number_format($anzeige_umsatz,2,'.',''));
        $xmlobj->AddChild('gesamt_umsatz',number_format($gesamt_umsatz,2,'.',''));        
      }
      $xml = str_replace(array('<?xml version="1.0" standalone="yes"?>',"<adressen2>",'</adressen2>'),array('','',''),$_xmlobj->asXML());
      unset($_xmlobj);

    }else{
      $xml = '<anz_result>0</anz_result><anz_gesamt>0</anz_gesamt>';
      if($this->app->DB->error())
      {
        $xml .= '<sqlerror>' .$this->app->erp->GetPlainText($this->app->DB->error()).'</sqlerror>';
      }else{
        
      }
    }
    //$xml .= $xmldata;
    $this->XMLResponse(1,$xml);
    exit;
  }
  

  function ApiGruppeCreate()
  {
    $id = $this->app->Secure->GetGET("id");

    $xmldata = $this->XMLPost();

    $this->app->DB->Insert("INSERT INTO gruppen (id) VALUES ('')");

    $id = $this->app->DB->GetInsertID();

    $this->ApiGruppeEdit($id,true);

    $this->XMLResponse(1,"<id>$id</id>");
    exit;
  }


  function ApiGruppeEdit($id="",$internal=false)
  {
    if($id <=0)
      $id = $this->app->Secure->GetGET("id");

    $id = $this->app->DB->Select("SELECT id FROM gruppen WHERE id='$id' LIMIT 1");
    // Key gibt es nicht
    if($id <= 0)
      $this->XMLResponse(5);

    $xmldata = $this->XMLPost();

    if($xmldata['porto_preis']!="" && $xmldata['porto_artikelid']!="" && !is_array($xmldata['porto_preis']))
    {
      $this->app->erp->AddVerkaufspreisGruppe($xmldata['porto_artikelid'],1,$id,$xmldata['porto_preis']);
    }

    foreach($xmldata as $key=>$value)
    {
      if(is_array($value))$value="";            
      if($key=="internebemerkung") $value = html_entity_decode($value);
      if($key!="id")
        $this->app->DB->Update("UPDATE gruppen SET $key='$value' WHERE id='$id' LIMIT 1");
    }

    if($internal)
      return $id;
    else {
      $this->XMLResponse(1);
      exit;
    }
  }     


  function ApiGruppeGet()
  {
    $id = $this->app->Secure->GetGET("id");

    //checl
    $id = $this->app->DB->Select("SELECT id FROM gruppen WHERE id='$id' LIMIT 1");

    if($id > 0)
      $this->XMLResponse(1,$this->app->erp->XMLGruppe($id));
    else
      $this->XMLResponse(5);
    exit;
  }


  // alte funktion
  function ApiShopimages()
  {
    $artikel = $this->app->Secure->GetGET("artikel");
    $number = $this->app->Secure->GetGET("number");
    $datei = $this->app->DB->SelectArr("SELECT datei FROM  datei_stichwoerter WHERE subjekt='Shopbild' AND objekt='Artikel' AND parameter='$artikel'");
    if($number <= 0) $number = 1;

    $datei = $datei[$number-1][datei];

    $mimetype = mime_content_type($this->app->erp->GetDateiPfad($datei));
    // Wir werden eine PDF Datei ausgeben
    header('Content-type: '.$mimetype);
    echo $this->app->erp->GetDatei($datei);
    exit;       
  }



  function ApiExportVorlageGet()
  {
    $id = $this->app->Secure->GetGET("id");
    $projekt = $this->app->Secure->GetGET("projekt");
    $von = $this->app->Secure->GetGET("von");
    $bis = $this->app->Secure->GetGET("bis");

    if($id!="")
    {
      if($projekt!="")
      {
        $projekt = $this->app->DB->Select("SELECT id FROM projekt WHERE abkuerzung='$projekt' LIMIT 1");
      } 
    }

    //check
    $id = $this->app->DB->Select("SELECT id FROM exportvorlage WHERE id='$id' AND apifreigabe=1 LIMIT 1");

    $filter['projekt']=$projekt;
    $filter['von']=$von;
    $filter['bis']=$bis;

    if($id > 0)
      $this->XMLResponse(1,$this->app->erp->XMLExportVorlage($id,$filter));
    else
      $this->XMLResponse(5);
    exit;
  }


  function ApiAdresseAccountsGet()
  {
    $id = $this->app->Secure->GetGET("id");
    $projekt = $this->app->Secure->GetGET("projekt");
    $art = $this->app->Secure->GetGET("art");

    //check
    $id = $this->app->DB->Select("SELECT id FROM exportvorlage WHERE id='$id' AND apifreigabe=1 LIMIT 1");

    $filter['art']=$art;
    $filter['id']=$id;
    $filter['projekt']=$projekt;

    if($id > 0 || $art!="")
      $this->XMLResponse(1,$this->app->erp->XMLAdresseAccounts($filter));
    else
      $this->XMLResponse(5);
    exit;
  }

  function ApiArtikelkontingenteGet()
  {
    $id = $this->app->Secure->GetGET("id");
    $projekt = $this->app->Secure->GetGET("projekt");
    $nummer = $this->app->Secure->GetGET("nummer");
    $von = $this->app->Secure->GetGET("von");
    $bis = $this->app->Secure->GetGET("bis");

    $filter['nummer']=$nummer;
    $filter['id']=$id;
    $filter['projekt']=$projekt;
    $filter['von']=$von;
    $filter['bis']=$bis;

    if($filter['nummer']!="" || $filter['id']!="")
      $this->XMLResponse(1,$this->app->erp->XMLArtikelkontingente($filter));
    else
      $this->XMLResponse(5);
    exit;
  }



}

?>
